/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var dayjs = require('dayjs');
var customParseFormat = require('../../../_chunks/dep-9931ceef.js');
var _common_js_timePicker_const = require('./const.js');
require('../../../_chunks/dep-27dd8cc6.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var dayjs__default = /*#__PURE__*/_interopDefaultLegacy(dayjs);

dayjs__default["default"].extend(customParseFormat.advancedFormat);
dayjs__default["default"].extend(customParseFormat.customParseFormat);
function validateInputValue(value, format) {
  return dayjs__default["default"](value, format).format(format) === value;
}
function formatInputValue(value, format) {
  return dayjs__default["default"](value, format).format(format);
}
function closestLookup(availableArr, calcVal, step) {
  if (step <= 1) return calcVal;
  return availableArr.sort(function (a, b) {
    return Math.abs(calcVal + 1 - a) - Math.abs(calcVal + 1 - b);
  })[0];
}
function getPickerCols(format) {
  var renderCol = [];
  var meridiem = _common_js_timePicker_const.EPickerCols.meridiem,
    hour = _common_js_timePicker_const.EPickerCols.hour,
    minute = _common_js_timePicker_const.EPickerCols.minute,
    second = _common_js_timePicker_const.EPickerCols.second,
    milliSecond = _common_js_timePicker_const.EPickerCols.milliSecond;
  var match = format.match(_common_js_timePicker_const.TIME_FORMAT);
  match.forEach(function (m) {
    switch (m) {
      case "H":
      case "HH":
      case "h":
      case "hh":
        renderCol.push(hour);
        break;
      case "a":
      case "A":
        renderCol.push(meridiem);
        break;
      case "m":
      case "mm":
        renderCol.push(minute);
        break;
      case "s":
      case "ss":
        renderCol.push(second);
        break;
      case "SSS":
        renderCol.push(milliSecond);
        break;
    }
  });
  return renderCol;
}

exports.closestLookup = closestLookup;
exports.formatInputValue = formatInputValue;
exports.getPickerCols = getPickerCols;
exports.validateInputValue = validateInputValue;
//# sourceMappingURL=utils.js.map
