/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var _common_js_log_log = require('../log/log.js');
var pick = require('../../../_chunks/dep-71fa6788.js');
var isBoolean = require('../../../_chunks/dep-5b9bb086.js');
var omit = require('../../../_chunks/dep-6dc0a916.js');
var isUndefined = require('../../../_chunks/dep-62de1188.js');
require('../../../_chunks/dep-362bc4d7.js');
require('../../../_chunks/dep-fcf0662d.js');
require('@babel/runtime/helpers/typeof');
require('../../../_chunks/dep-d3015b4c.js');
require('../../../_chunks/dep-a4308f57.js');
require('../../../_chunks/dep-e4278c54.js');
require('../../../_chunks/dep-a4747856.js');
require('../../../_chunks/dep-3d8ab37d.js');
require('../../../_chunks/dep-ecccff93.js');
require('../../../_chunks/dep-a4cecac4.js');
require('../../../_chunks/dep-ab142eaf.js');
require('../../../_chunks/dep-201f7798.js');
require('../../../_chunks/dep-73fb598e.js');
require('../../../_chunks/dep-75cd6d52.js');
require('../../../_chunks/dep-b1a02818.js');
require('../../../_chunks/dep-234b7c02.js');
require('../../../_chunks/dep-2e32c1f2.js');
require('../../../_chunks/dep-6ad3de7c.js');
require('../../../_chunks/dep-5db8defc.js');
require('../../../_chunks/dep-a9e7deb2.js');
require('../../../_chunks/dep-bebcd284.js');
require('../../../_chunks/dep-b3120c1b.js');
require('../../../_chunks/dep-dbd838d6.js');
require('../../../_chunks/dep-f33eb57d.js');
require('../../../_chunks/dep-87c765cc.js');
require('../../../_chunks/dep-8b1e056e.js');
require('../../../_chunks/dep-6e4c473c.js');
require('../../../_chunks/dep-63b02f7b.js');
require('../../../_chunks/dep-3eec664c.js');
require('../../../_chunks/dep-eeb2e214.js');
require('../../../_chunks/dep-b5c96567.js');
require('../../../_chunks/dep-5b117689.js');
require('../../../_chunks/dep-68ba2357.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function getExposedProps(node) {
  var props = pick.pick(node, ["value", "label", "data", "actived", "expanded", "checked", "indeterminate", "loading"]);
  return props;
}
function createNodeModel(node) {
  var props = getExposedProps(node);
  var model = _objectSpread(_objectSpread({}, props), {}, {
    getLevel: function getLevel() {
      return node.getLevel();
    },
    getIndex: function getIndex() {
      return node.getIndex();
    },
    isFirst: function isFirst() {
      return node.isFirst();
    },
    isLast: function isLast() {
      return node.isLast();
    },
    isLeaf: function isLeaf() {
      return node.isLeaf();
    },
    insertBefore: function insertBefore(newData) {
      return node.insertBefore(newData);
    },
    insertAfter: function insertAfter(newData) {
      return node.insertAfter(newData);
    },
    appendData: function appendData(data) {
      return node.append(data);
    },
    getPath: function getPath() {
      var nodes = node.getPath();
      return nodes.map(function (item) {
        return item.getModel();
      });
    },
    getParent: function getParent() {
      var _node$parent;
      return (_node$parent = node.parent) === null || _node$parent === void 0 ? void 0 : _node$parent.getModel();
    },
    getParents: function getParents() {
      var nodes = node.getParents();
      return nodes.map(function (item) {
        return item.getModel();
      });
    },
    getRoot: function getRoot() {
      var root = node.getRoot();
      return root === null || root === void 0 ? void 0 : root.getModel();
    },
    getSiblings: function getSiblings() {
      var nodes = node.getSiblings();
      return nodes.map(function (item) {
        return item.getModel();
      });
    },
    getChildren: function getChildren(deep) {
      var childrenModel = false;
      var children = node.children;
      if (Array.isArray(children)) {
        if (children.length > 0) {
          if (deep) {
            var nodes = node.walk();
            nodes.shift();
            childrenModel = nodes.map(function (item) {
              return item.getModel();
            });
          } else {
            childrenModel = children.map(function (item) {
              return item.getModel();
            });
          }
        } else {
          childrenModel = false;
        }
      } else if (isBoolean.isBoolean(children)) {
        childrenModel = children;
      }
      return childrenModel;
    },
    remove: function remove(value) {
      if (!value) {
        node.remove();
        return;
      }
      var tree = node.tree;
      var targetNode = tree.getNode(value);
      if (!targetNode) {
        _common_js_log_log["default"].warnOnce("Tree", "`".concat(value, "` is not exist"));
        return;
      }
      var parents = targetNode.getParents();
      var parentValues = parents.map(function (pnode) {
        return pnode.value;
      });
      if (parentValues.indexOf(node.value) < 0) {
        _common_js_log_log["default"].warnOnce("Tree", "`".concat(value, "` is not a childNode of current node"));
        return;
      }
      targetNode.remove();
    },
    setData: function setData(data) {
      var _data = omit.omit(data, ["children", "value", "label"]);
      var keys = node.tree.config.keys;
      var dataValue = data[(keys === null || keys === void 0 ? void 0 : keys.value) || "value"];
      var dataLabel = data[(keys === null || keys === void 0 ? void 0 : keys.label) || "label"];
      if (!isUndefined.isUndefined(dataValue)) _data.value = dataValue;
      if (!isUndefined.isUndefined(dataLabel)) _data.label = dataLabel;
      Object.assign(node.data, _data);
      Object.assign(node, _data);
    }
  });
  return model;
}
function updateNodeModel(model, node) {
  var props = getExposedProps(node);
  Object.assign(model, props);
}

exports.createNodeModel = createNodeModel;
exports.updateNodeModel = updateNodeModel;
//# sourceMappingURL=tree-node-model.js.map
