/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var Vue = require('vue');
var utils_dom = require('../utils/dom.js');
var affix_props = require('./props.js');
var configProvider_configReceiver = require('../config-provider/config-receiver.js');
var utils_mixins = require('../utils/mixins.js');
var isFunction = require('../_chunks/dep-ecccff93.js');
require('raf');
require('../utils/easing.js');
require('../_chunks/dep-738b4f21.js');
require('../_chunks/dep-a4308f57.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-fcf0662d.js');
require('../_chunks/dep-e4278c54.js');
require('../_chunks/dep-07fb8c0e.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-a4a18104.js');
require('../_chunks/dep-27dd8cc6.js');
require('dayjs');
require('../_chunks/dep-87c765cc.js');
require('../_chunks/dep-75cd6d52.js');
require('../_chunks/dep-b1a02818.js');
require('../_chunks/dep-3d8ab37d.js');
require('../_chunks/dep-a4cecac4.js');
require('../_chunks/dep-ab142eaf.js');
require('../_chunks/dep-6ad3de7c.js');
require('../_chunks/dep-8b1e056e.js');
require('../_chunks/dep-5db8defc.js');
require('../_chunks/dep-6e4c473c.js');
require('../_chunks/dep-234b7c02.js');
require('../_chunks/dep-a4747856.js');
require('../_chunks/dep-932dd69e.js');
require('../_chunks/dep-9f4caea4.js');
require('../_chunks/dep-dbd838d6.js');
require('../_chunks/dep-b3120c1b.js');
require('../_chunks/dep-68ba2357.js');
require('../_chunks/dep-173eb46c.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);
var Vue__default = /*#__PURE__*/_interopDefaultLegacy(Vue);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var classMixins = configProvider_configReceiver.getClassPrefixMixins("affix");
var _Affix = utils_mixins["default"](Vue__default["default"], classMixins).extend({
  name: "TAffix",
  props: _objectSpread({}, affix_props["default"]),
  watch: {
    offsetTop: function offsetTop() {
      this.handleScroll();
    },
    offsetBottom: function offsetBottom() {
      this.handleScroll();
    },
    zIndex: function zIndex() {
      this.handleScroll();
    }
  },
  methods: {
    handleScroll: function handleScroll() {
      var _this = this;
      var scrollContainer = this.scrollContainer,
        offsetTop = this.offsetTop,
        offsetBottom = this.offsetBottom;
      var _this$$refs = this.$refs,
        affixWrapRef = _this$$refs.affixWrapRef,
        affixRef = _this$$refs.affixRef;
      if (!this.ticking) {
        window.requestAnimationFrame(function () {
          var _affixWrapRef$getBoun;
          var _ref = (_affixWrapRef$getBoun = affixWrapRef === null || affixWrapRef === void 0 ? void 0 : affixWrapRef.getBoundingClientRect()) !== null && _affixWrapRef$getBoun !== void 0 ? _affixWrapRef$getBoun : {
              top: 0,
              width: 0,
              height: 0
            },
            wrapToTop = _ref.top,
            wrapWidth = _ref.width,
            wrapHeight = _ref.height;
          var containerTop = 0;
          if (scrollContainer instanceof HTMLElement) {
            var _scrollContainer$getB;
            containerTop = scrollContainer === null || scrollContainer === void 0 || (_scrollContainer$getB = scrollContainer.getBoundingClientRect) === null || _scrollContainer$getB === void 0 ? void 0 : _scrollContainer$getB.call(scrollContainer).top;
          }
          var fixedTop;
          var calcTop = wrapToTop - containerTop;
          var containerHeight = (scrollContainer === null || scrollContainer === void 0 ? void 0 : scrollContainer[scrollContainer instanceof Window ? "innerHeight" : "clientHeight"]) - wrapHeight;
          var calcBottom = containerTop + containerHeight - offsetBottom;
          if (offsetTop !== void 0 && calcTop <= offsetTop) {
            fixedTop = containerTop + offsetTop;
          } else if (offsetBottom !== void 0 && wrapToTop >= calcBottom) {
            fixedTop = calcBottom;
          } else {
            fixedTop = false;
          }
          if (affixRef) {
            var affixed = fixedTop !== false;
            var placeholderStatus = affixWrapRef.contains(_this.placeholderEL);
            if (affixed) {
              affixRef.className = _this.componentName;
              affixRef.style.top = "".concat(fixedTop, "px");
              affixRef.style.width = "".concat(wrapWidth, "px");
              affixRef.style.height = "".concat(wrapHeight, "px");
              if (_this.zIndex) {
                affixRef.style.zIndex = "".concat(_this.zIndex);
              }
              if (!placeholderStatus) {
                _this.placeholderEL.style.width = "".concat(wrapWidth, "px");
                _this.placeholderEL.style.height = "".concat(wrapHeight, "px");
                affixWrapRef.appendChild(_this.placeholderEL);
              }
            } else {
              affixRef.removeAttribute("class");
              affixRef.removeAttribute("style");
              placeholderStatus && _this.placeholderEL.remove();
            }
            _this.$emit("fixedChange", affixed, {
              top: fixedTop
            });
            if (isFunction.isFunction(_this.onFixedChange)) _this.onFixedChange(affixed, {
              top: Number(fixedTop)
            });
          }
          _this.ticking = false;
        });
        this.ticking = true;
      }
    }
  },
  mounted: function mounted() {
    var _this2 = this;
    this.placeholderEL = document.createElement("div");
    var timer = setTimeout(function () {
      _this2.scrollContainer = utils_dom.getScrollContainer(_this2.container);
      _this2.handleScroll();
      utils_dom.on(_this2.scrollContainer, "scroll", _this2.handleScroll);
      utils_dom.on(window, "resize", _this2.handleScroll);
      clearTimeout(timer);
    }, 0);
  },
  destroyed: function destroyed() {
    if (!this.scrollContainer) return;
    utils_dom.off(this.scrollContainer, "scroll", this.handleScroll);
    utils_dom.off(window, "resize", this.handleScroll);
  },
  render: function render() {
    var h = arguments[0];
    return h("div", {
      "ref": "affixWrapRef"
    }, [h("div", {
      "ref": "affixRef"
    }, [this.$slots["default"]])]);
  }
});

exports["default"] = _Affix;
//# sourceMappingURL=affix.js.map
