/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _typeof = require('@babel/runtime/helpers/typeof');
var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var VueCompositionAPI = require('@vue/composition-api');
var tdesignIconsVue = require('tdesign-icons-vue');
var utils_dom = require('../utils/dom.js');
var utils_renderTnode = require('../utils/render-tnode.js');
var hooks_useConfig = require('../hooks/useConfig.js');
var hooks_useGlobalIcon = require('../hooks/useGlobalIcon.js');
var backTop_props = require('./props.js');
require('vue');
require('raf');
require('../utils/easing.js');
require('../_chunks/dep-738b4f21.js');
require('../_chunks/dep-a4308f57.js');
require('../_chunks/dep-fcf0662d.js');
require('../_chunks/dep-e4278c54.js');
require('@babel/runtime/helpers/readOnlyError');
require('../_chunks/dep-7c854ec6.js');
require('../_chunks/dep-eceed11d.js');
require('../_chunks/dep-201f7798.js');
require('../_chunks/dep-d3015b4c.js');
require('../_chunks/dep-f8a85d6a.js');
require('../_chunks/dep-5b117689.js');
require('../_chunks/dep-6478392e.js');
require('../_chunks/dep-47bca35e.js');
require('../config-provider/useConfig.js');
require('../_chunks/dep-07fb8c0e.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-a4a18104.js');
require('../_chunks/dep-27dd8cc6.js');
require('dayjs');
require('../_chunks/dep-87c765cc.js');
require('../_chunks/dep-75cd6d52.js');
require('../_chunks/dep-b1a02818.js');
require('../_chunks/dep-3d8ab37d.js');
require('../_chunks/dep-ecccff93.js');
require('../_chunks/dep-a4cecac4.js');
require('../_chunks/dep-ab142eaf.js');
require('../_chunks/dep-6ad3de7c.js');
require('../_chunks/dep-8b1e056e.js');
require('../_chunks/dep-5db8defc.js');
require('../_chunks/dep-6e4c473c.js');
require('../_chunks/dep-234b7c02.js');
require('../_chunks/dep-a4747856.js');
require('../_chunks/dep-932dd69e.js');
require('../_chunks/dep-9f4caea4.js');
require('../_chunks/dep-dbd838d6.js');
require('../_chunks/dep-b3120c1b.js');
require('../_chunks/dep-68ba2357.js');
require('../_chunks/dep-173eb46c.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _typeof__default = /*#__PURE__*/_interopDefaultLegacy(_typeof);
var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var _BackTop = VueCompositionAPI.defineComponent({
  name: "TBackTop",
  props: _objectSpread({}, backTop_props["default"]),
  setup: function setup(props2) {
    var visible = VueCompositionAPI.ref(false);
    var containerRef = VueCompositionAPI.ref(null);
    var componentName = hooks_useConfig.usePrefixClass("back-top");
    var classPrefix = hooks_useConfig.usePrefixClass();
    var theme = props2.theme,
      shape = props2.shape,
      size = props2.size,
      target = props2.target,
      duration = props2.duration,
      offset = props2.offset,
      container = props2.container;
    var _useGlobalIcon = hooks_useGlobalIcon.useGlobalIcon({
        BacktopIcon: tdesignIconsVue.BacktopIcon
      }),
      BacktopIcon = _useGlobalIcon.BacktopIcon;
    var getContainer = function getContainer(container2) {
      if (typeof container2 === "string" && (typeof document === "undefined" ? "undefined" : _typeof__default["default"](document)) !== void 0) {
        if (container2 === "body") {
          return document;
        }
        return document.querySelector(container2);
      }
      if (typeof container2 === "function") {
        return container2();
      }
      return null;
    };
    var getBackTo = function getBackTo() {
      if (target === container) return 0;
      if (target === "body") return 0;
      if (!target) return 0;
      var targetNode = getContainer(target);
      if (!targetNode) return 0;
      var _targetNode$getBoundi = targetNode.getBoundingClientRect(),
        y = _targetNode$getBoundi.y;
      return y;
    };
    var handleClick = function handleClick(e) {
      var _props2$onClick;
      var y = getBackTo();
      utils_dom.scrollTo(y, {
        container: containerRef.value,
        duration: duration
      });
      (_props2$onClick = props2.onClick) === null || _props2$onClick === void 0 || _props2$onClick.call(props2, {
        e: e
      });
    };
    var cls = VueCompositionAPI.computed(function () {
      return _defineProperty__default["default"](_defineProperty__default["default"](_defineProperty__default["default"](_defineProperty__default["default"](_defineProperty__default["default"](_defineProperty__default["default"]({}, componentName.value, true), "".concat(componentName.value, "--theme-").concat(theme), true), "".concat(componentName.value, "--").concat(shape), true), "".concat(componentName.value, "--show"), visible.value), "".concat(classPrefix.value, "-size-s"), size === "small"), "".concat(classPrefix.value, "-size-m"), size === "medium");
    });
    var positionStyle = VueCompositionAPI.computed(function () {
      return {
        insetInlineEnd: offset[0],
        insetBlockEnd: offset[1]
      };
    });
    VueCompositionAPI.onMounted(function () {
      containerRef.value = getContainer(props2.container);
      var visibleHeight;
      if (typeof props2.visibleHeight === "string") {
        visibleHeight = Number(props2.visibleHeight.replace("px", ""));
      } else {
        visibleHeight = props2.visibleHeight;
      }
      if (visibleHeight === 0) {
        visible.value = true;
        return;
      }
      var scrollDOM;
      if (containerRef.value) {
        if (containerRef.value.scrollTop === void 0) {
          scrollDOM = document.documentElement;
        } else {
          scrollDOM = containerRef.value;
        }
        containerRef.value.onscroll = function () {
          var _scrollDOM = scrollDOM,
            scrollTop = _scrollDOM.scrollTop;
          if (scrollTop >= visibleHeight) {
            visible.value = true;
          }
          if (scrollTop < visibleHeight && visible.value) {
            visible.value = false;
          }
        };
      }
    });
    VueCompositionAPI.onBeforeUnmount(function () {
      containerRef.value.onscroll = null;
    });
    return {
      BacktopIcon: BacktopIcon,
      cls: cls,
      handleClick: handleClick,
      positionStyle: positionStyle,
      componentName: componentName
    };
  },
  render: function render() {
    var h = arguments[0];
    var BacktopIcon = this.BacktopIcon;
    var defaultContent = h("div", [h(BacktopIcon, {
      "class": "".concat(this.componentName, "__icon"),
      "attrs": {
        "size": "24"
      }
    }), h("span", {
      "class": "".concat(this.componentName, "__text")
    }, ["TOP"])]);
    return h("button", {
      "attrs": {
        "type": "button"
      },
      "class": this.cls,
      "style": this.positionStyle,
      "on": {
        "click": this.handleClick
      }
    }, [utils_renderTnode.renderContent(this, "content", "default", defaultContent)]);
  }
});

exports["default"] = _BackTop;
//# sourceMappingURL=back-top.js.map
