import dayjs from 'dayjs';
import { CalendarValue, CalendarCell, WeekDay, TdCalendarProps } from './type';
export * from './type';
export declare type CalendarProps = TdCalendarProps;
export interface CalendarData {
    realFirstDayOfWeek: number;
    curDate?: dayjs.Dayjs | null;
    curDateList?: dayjs.Dayjs[];
    curSelectedYear: number;
    curSelectedMonth: number;
    curSelectedMode: string;
    isShowWeekend: boolean;
    controlSize: string;
}
export interface CalendarRange {
    from: CalendarValue;
    to: CalendarValue;
}
export interface YearMonthOption {
    value: number;
    label: string;
    disabled?: boolean;
}
export interface CellColHeader {
    num: WeekDay;
    display: string;
}
export interface ModeOption {
    value: string;
    label: string;
}
export interface CellEventOption {
    cell: CalendarCell;
    e: MouseEvent;
}
export declare type CellClickEventCallback = (options: CellEventOption) => void;
export interface TextConfigType {
    showWeekend: string;
    hideWeekend: string;
    today: string;
    thisMonth: string;
}
