/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var VueCompositionAPI = require('@vue/composition-api');
var cascader_components_Panel = require('./components/Panel.js');
var selectInput_index = require('../select-input/index.js');
var commonComponents_fakeArrow = require('../common-components/fake-arrow.js');
var cascader_props = require('./props.js');
var cascader_hooks = require('./hooks.js');
var hooks_useConfig = require('../hooks/useConfig.js');
var cascader_core_effect = require('./core/effect.js');
var cascader_core_helper = require('./core/helper.js');
var cascader_core_className = require('./core/className.js');
var hooks_useFormDisabled = require('../hooks/useFormDisabled.js');
var utils_renderTnode = require('../utils/render-tnode.js');
var configProvider_useConfig = require('../config-provider/useConfig.js');
var omit = require('../_chunks/dep-6dc0a916.js');
require('./components/Item.js');
require('../_chunks/dep-ece3c062.js');
require('tdesign-icons-vue');
require('../checkbox/index.js');
require('../checkbox/group.js');
require('@babel/runtime/helpers/typeof');
require('@babel/runtime/helpers/toConsumableArray');
require('@babel/runtime/helpers/slicedToArray');
require('../utils/helper.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('../_chunks/dep-7c854ec6.js');
require('../_chunks/dep-eceed11d.js');
require('../_chunks/dep-201f7798.js');
require('../_chunks/dep-a4308f57.js');
require('../_chunks/dep-fcf0662d.js');
require('../_chunks/dep-d3015b4c.js');
require('../_chunks/dep-e4278c54.js');
require('../_chunks/dep-f8a85d6a.js');
require('../_chunks/dep-5b117689.js');
require('../_chunks/dep-6478392e.js');
require('../checkbox/checkbox.js');
require('../checkbox/props.js');
require('../checkbox/constants.js');
require('../checkbox/store.js');
require('@babel/runtime/helpers/classCallCheck');
require('@babel/runtime/helpers/createClass');
require('../checkbox/hooks/useKeyboardEvent.js');
require('../_common/js/common.js');
require('../hooks/useVModel.js');
require('../_chunks/dep-47bca35e.js');
require('../hooks/useElementLazyRender.js');
require('../_common/js/utils/observe.js');
require('../checkbox/checkbox-group-props.js');
require('../_chunks/dep-e83685df.js');
require('../_chunks/dep-d23147db.js');
require('../_chunks/dep-a4747856.js');
require('../_chunks/dep-3d8ab37d.js');
require('../_chunks/dep-ecccff93.js');
require('../_chunks/dep-a4cecac4.js');
require('../_chunks/dep-ab142eaf.js');
require('../_chunks/dep-502c56be.js');
require('../_chunks/dep-6e4c473c.js');
require('../_chunks/dep-9f4caea4.js');
require('../_chunks/dep-dbd838d6.js');
require('../_chunks/dep-b3120c1b.js');
require('../_chunks/dep-b1a02818.js');
require('../_chunks/dep-5db8defc.js');
require('../_chunks/dep-62de1188.js');
require('../hooks/slots.js');
require('../utils/withInstall.js');
require('vue');
require('../_chunks/dep-07fb8c0e.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-a4a18104.js');
require('../_chunks/dep-27dd8cc6.js');
require('dayjs');
require('../_chunks/dep-87c765cc.js');
require('../_chunks/dep-75cd6d52.js');
require('../_chunks/dep-6ad3de7c.js');
require('../_chunks/dep-8b1e056e.js');
require('../_chunks/dep-234b7c02.js');
require('../_chunks/dep-932dd69e.js');
require('../_chunks/dep-68ba2357.js');
require('../_chunks/dep-173eb46c.js');
require('@babel/runtime/helpers/readOnlyError');
require('../loading/index.js');
require('../loading/directive.js');
require('../loading/plugin.js');
require('../loading/loading.js');
require('../loading/icon/gradient.js');
require('../_common/js/loading/circle-adapter.js');
require('../_common/js/utils/setStyle.js');
require('../_common/js/utils/helper.js');
require('../_chunks/dep-867c284e.js');
require('../_chunks/dep-738b4f21.js');
require('../_chunks/dep-aa0a4aac.js');
require('../config-provider/config-receiver.js');
require('../utils/mixins.js');
require('../utils/dom.js');
require('raf');
require('../utils/easing.js');
require('../utils/transfer-dom.js');
require('../loading/props.js');
require('../config.js');
require('../_chunks/dep-013a3403.js');
require('../_chunks/dep-8cb0d589.js');
require('../_chunks/dep-de60f5aa.js');
require('../_chunks/dep-63b02f7b.js');
require('../_chunks/dep-bebcd284.js');
require('../_chunks/dep-3eec664c.js');
require('../_chunks/dep-eeb2e214.js');
require('../_chunks/dep-315a67f0.js');
require('../_chunks/dep-f84d1ea5.js');
require('../_chunks/dep-362bc4d7.js');
require('../_chunks/dep-2e32c1f2.js');
require('../_chunks/dep-f14aac54.js');
require('../hooks/useGlobalIcon.js');
require('../utils/ripple.js');
require('../hooks/tnode.js');
require('../hooks/render-tnode.js');
require('../_chunks/dep-a6490a32.js');
require('../select-input/select-input.js');
require('../popup/index.js');
require('../popup/popup.js');
require('@popperjs/core');
require('../popup/props.js');
require('../popup/container.js');
require('../utils/event.js');
require('../popup/utils.js');
require('../_chunks/dep-f3761329.js');
require('../_chunks/dep-848a5a32.js');
require('../utils/map-props.js');
require('../popup/plugin.js');
require('../_common/js/log/log.js');
require('../select-input/props.js');
require('../select-input/useSingle.js');
require('../input/index.js');
require('../input/input.js');
require('../input/props.js');
require('../input/input-group.js');
require('../hooks/useDefaultValue.js');
require('../_chunks/dep-71fa6788.js');
require('../_chunks/dep-73fb598e.js');
require('../_chunks/dep-a9e7deb2.js');
require('../select-input/useMultiple.js');
require('../tag-input/index.js');
require('../tag-input/tag-input.js');
require('../tag-input/props.js');
require('../tag-input/hooks/useTagScroll.js');
require('../tag-input/useTagList.js');
require('../tag/index.js');
require('../tag/tag.js');
require('tinycolor2');
require('../tag/props.js');
require('../tag/check-tag.js');
require('../tag/check-tag-props.js');
require('../tag/check-tag-group.js');
require('../tag/check-tag-group-props.js');
require('../tag-input/hooks/useHover.js');
require('../tag-input/hooks/useDragSorter.js');
require('../select-input/useOverlayInnerStyle.js');
require('../_common/js/tree/tree-store.js');
require('mitt');
require('../_common/js/tree/tree-node.js');
require('@babel/runtime/helpers/asyncToGenerator');
require('@babel/runtime/regenerator');
require('../_common/js/tree/tree-node-model.js');
require('../_chunks/dep-5b9bb086.js');
require('../_chunks/dep-db8e4c0d.js');
require('../_chunks/dep-8b3c7277.js');
require('../_chunks/dep-7f8c4040.js');
require('../_chunks/dep-a0ae49c9.js');
require('../_chunks/dep-f45125c9.js');
require('../_chunks/dep-f33eb57d.js');
require('../_chunks/dep-b5c96567.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var _Cascader = VueCompositionAPI.defineComponent({
  name: "TCascader",
  props: _objectSpread({}, cascader_props["default"]),
  setup: function setup(props2, _ref) {
    var emit = _ref.emit;
    var COMPONENT_NAME = hooks_useConfig.usePrefixClass("cascader");
    var classPrefix = hooks_useConfig.usePrefixClass();
    var _useCommonClassName = hooks_useConfig.useCommonClassName(),
      STATUS = _useCommonClassName.STATUS;
    var overlayClassName = hooks_useConfig.usePrefixClass("cascader__popup");
    var _useConfig = configProvider_useConfig.useConfig("cascader"),
      global = _useConfig.global;
    var _useCascaderContext = cascader_hooks.useCascaderContext(props2),
      innerValue = _useCascaderContext.innerValue,
      cascaderContext = _useCascaderContext.cascaderContext,
      isFilterable = _useCascaderContext.isFilterable,
      getCascaderItems = _useCascaderContext.getCascaderItems;
    var displayValue = VueCompositionAPI.computed(function () {
      return props2.multiple ? cascader_core_helper.getMultipleContent(cascaderContext.value) : cascader_core_helper.getSingleContent(cascaderContext.value);
    });
    var panels = VueCompositionAPI.computed(function () {
      return cascader_core_helper.getPanels(cascaderContext.value.treeNodes);
    });
    var inputPlaceholder = VueCompositionAPI.computed(function () {
      var _props2$placeholder;
      if (cascaderContext.value.visible && !props2.multiple) {
        var placeholder = cascader_core_helper.getSingleContent(cascaderContext.value);
        if (typeof placeholder === "number") placeholder = String(placeholder);
        return placeholder;
      }
      return (_props2$placeholder = props2.placeholder) !== null && _props2$placeholder !== void 0 ? _props2$placeholder : global.value.placeholder;
    });
    var _useFormDisabled = hooks_useFormDisabled.useFormDisabled(),
      formDisabled = _useFormDisabled.formDisabled;
    var isDisabled = VueCompositionAPI.computed(function () {
      return formDisabled.value || cascaderContext.value.disabled;
    });
    var valueDisplayParams = VueCompositionAPI.computed(function () {
      var arrayValue = innerValue.value instanceof Array ? innerValue.value : [innerValue.value];
      var displayValue2 = props2.multiple && props2.minCollapsedNum ? arrayValue.slice(0, props2.minCollapsedNum) : innerValue.value;
      var options = getCascaderItems(arrayValue);
      return {
        value: innerValue.value,
        selectedOptions: options,
        onClose: function onClose(index) {
          cascader_core_effect.handleRemoveTagEffect(cascaderContext.value, index, props2.onRemove);
        },
        displayValue: displayValue2
      };
    });
    var updateScrollTop = function updateScrollTop(content) {
      var cascaderMenuList = content.querySelectorAll(".".concat(COMPONENT_NAME.value, "__menu"));
      cascaderMenuList.forEach(function (menu) {
        var firstSelectedNode = (menu === null || menu === void 0 ? void 0 : menu.querySelector(".".concat(classPrefix.value, "-is-selected"))) || (menu === null || menu === void 0 ? void 0 : menu.querySelector(".".concat(classPrefix.value, "-is-expanded")));
        if (!firstSelectedNode || !menu) return;
        var _getComputedStyle = getComputedStyle(firstSelectedNode),
          paddingBottom = _getComputedStyle.paddingBottom;
        var _getComputedStyle2 = getComputedStyle(menu),
          marginBottom = _getComputedStyle2.marginBottom;
        var elementBottomHeight = parseInt(paddingBottom, 10) + parseInt(marginBottom, 10);
        var updateValue = firstSelectedNode.offsetTop - menu.offsetTop - (menu.clientHeight - firstSelectedNode.clientHeight) + elementBottomHeight;
        menu.scrollTop = updateValue;
      });
    };
    return {
      COMPONENT_NAME: COMPONENT_NAME,
      overlayClassName: overlayClassName,
      panels: panels,
      innerValue: innerValue,
      displayValue: displayValue,
      inputPlaceholder: inputPlaceholder,
      isFilterable: isFilterable,
      isDisabled: isDisabled,
      STATUS: STATUS,
      classPrefix: classPrefix,
      cascaderContext: cascaderContext,
      emit: emit,
      valueDisplayParams: valueDisplayParams,
      updateScrollTop: updateScrollTop
    };
  },
  render: function render() {
    var _this = this,
      _this$popupProps;
    var h = arguments[0];
    var valueDisplayParams = this.valueDisplayParams,
      COMPONENT_NAME = this.COMPONENT_NAME,
      overlayClassName = this.overlayClassName,
      panels = this.panels,
      displayValue = this.displayValue,
      inputPlaceholder = this.inputPlaceholder,
      isFilterable = this.isFilterable,
      isDisabled = this.isDisabled,
      STATUS = this.STATUS,
      classPrefix = this.classPrefix,
      cascaderContext = this.cascaderContext,
      emit = this.emit;
    var renderValueDisplay = function renderValueDisplay() {
      return utils_renderTnode.renderTNodeJSX(_this, "valueDisplay", {
        params: valueDisplayParams
      });
    };
    var renderSuffixIcon = function renderSuffixIcon() {
      var suffixIcon = utils_renderTnode.renderTNodeJSX(_this, "suffixIcon");
      if (suffixIcon) return suffixIcon;
      var visible2 = cascaderContext.visible;
      return h(commonComponents_fakeArrow["default"], {
        "attrs": {
          "overlayClassName": cascader_core_className.getFakeArrowIconClass(classPrefix, STATUS, cascaderContext),
          "isActive": visible2,
          "disabled": isDisabled
        }
      });
    };
    var setVisible = cascaderContext.setVisible,
      visible = cascaderContext.visible,
      inputVal = cascaderContext.inputVal,
      setInputVal = cascaderContext.setInputVal;
    var slots = this.$scopedSlots;
    return h(selectInput_index.SelectInput, {
      "class": COMPONENT_NAME,
      "props": _objectSpread({}, _objectSpread({
        value: displayValue,
        inputValue: visible ? inputVal : "",
        popupVisible: visible,
        keys: this.keys,
        allowInput: isFilterable,
        minCollapsedNum: this.minCollapsedNum,
        collapsedItems: this.collapsedItems,
        label: this.label,
        valueDisplay: renderValueDisplay,
        suffix: this.suffix,
        tag: this.tag,
        readonly: this.readonly,
        disabled: isDisabled,
        clearable: this.clearable,
        placeholder: inputPlaceholder,
        multiple: this.multiple,
        loading: this.loading,
        status: this.status,
        tips: this.tips,
        updateScrollTop: this.updateScrollTop,
        suffixIcon: function suffixIcon() {
          return renderSuffixIcon();
        },
        popupProps: _objectSpread(_objectSpread({}, this.popupProps), {}, {
          overlayInnerStyle: panels.length && !this.loading ? {
            width: "auto"
          } : "",
          overlayClassName: [overlayClassName, (_this$popupProps = this.popupProps) === null || _this$popupProps === void 0 ? void 0 : _this$popupProps.overlayClassName]
        }),
        inputProps: _objectSpread({
          size: this.size
        }, this.inputProps),
        tagInputProps: _objectSpread({
          size: this.size
        }, this.tagInputProps),
        tagProps: _objectSpread({}, this.tagProps),
        onInputChange: function onInputChange(value, ctx) {
          var _this$selectInputProp, _this$selectInputProp2;
          if (!_this.isFilterable) return;
          setInputVal("".concat(value));
          _this === null || _this === void 0 || (_this$selectInputProp = _this.selectInputProps) === null || _this$selectInputProp === void 0 || (_this$selectInputProp2 = _this$selectInputProp.onInputChange) === null || _this$selectInputProp2 === void 0 || _this$selectInputProp2.call(_this$selectInputProp, value, ctx);
        },
        onTagChange: function onTagChange(val, ctx) {
          var _this$selectInputProp3, _this$selectInputProp4;
          if (ctx.trigger === "enter") return;
          cascader_core_effect.handleRemoveTagEffect(cascaderContext, ctx.index, _this.onRemove);
          (_this$selectInputProp3 = _this.selectInputProps) === null || _this$selectInputProp3 === void 0 || (_this$selectInputProp4 = _this$selectInputProp3.onTagChange) === null || _this$selectInputProp4 === void 0 || _this$selectInputProp4.call(_this$selectInputProp3, val, ctx);
        },
        onPopupVisibleChange: function onPopupVisibleChange(val, context) {
          var _this$selectInputProp5, _this$selectInputProp6;
          if (_this.disabled) return;
          setVisible(val, context);
          (_this$selectInputProp5 = _this.selectInputProps) === null || _this$selectInputProp5 === void 0 || (_this$selectInputProp6 = _this$selectInputProp5.onPopupVisibleChange) === null || _this$selectInputProp6 === void 0 || _this$selectInputProp6.call(_this$selectInputProp5, val, context);
        },
        onBlur: function onBlur(val, context) {
          var _this$onBlur, _this$selectInputProp7, _this$selectInputProp8;
          var ctx = {
            value: cascaderContext.value,
            inputValue: context.inputValue || "",
            e: context.e
          };
          (_this$onBlur = _this.onBlur) === null || _this$onBlur === void 0 || _this$onBlur.call(_this, ctx);
          emit("blur", ctx);
          (_this$selectInputProp7 = _this.selectInputProps) === null || _this$selectInputProp7 === void 0 || (_this$selectInputProp8 = _this$selectInputProp7.onBlur) === null || _this$selectInputProp8 === void 0 || _this$selectInputProp8.call(_this$selectInputProp7, val, context);
        },
        onFocus: function onFocus(val, context) {
          var _this$onFocus, _this$selectInputProp9, _this$selectInputProp10;
          var ctx = {
            value: cascaderContext.value,
            e: context.e
          };
          (_this$onFocus = _this.onFocus) === null || _this$onFocus === void 0 || _this$onFocus.call(_this, ctx);
          emit("focus", ctx);
          (_this$selectInputProp9 = _this.selectInputProps) === null || _this$selectInputProp9 === void 0 || (_this$selectInputProp10 = _this$selectInputProp9.onFocus) === null || _this$selectInputProp10 === void 0 || _this$selectInputProp10.call(_this$selectInputProp9, val, context);
        },
        onClear: function onClear(context) {
          var _this$selectInputProp11, _this$selectInputProp12;
          cascader_core_effect.closeIconClickEffect(cascaderContext);
          (_this$selectInputProp11 = _this.selectInputProps) === null || _this$selectInputProp11 === void 0 || (_this$selectInputProp12 = _this$selectInputProp11.onClear) === null || _this$selectInputProp12 === void 0 || _this$selectInputProp12.call(_this$selectInputProp11, context);
        }
      }, omit.omit(this.selectInputProps, ["onTagChange", "onInputChange", "onPopupVisibleChange", "onBlur", "onFocus", "onClear"]))),
      "scopedSlots": {
        panel: function panel() {
          return h(cascader_components_Panel["default"], {
            "attrs": {
              "option": _this.option,
              "empty": _this.empty,
              "trigger": _this.trigger,
              "loading": _this.loading,
              "loadingText": _this.loadingText,
              "cascaderContext": cascaderContext
            },
            "scopedSlots": {
              option: slots.option,
              empty: slots.empty,
              loadingText: slots.loadingText
            }
          });
        },
        tips: slots.tips,
        tag: slots.tag,
        suffix: slots.suffix,
        label: slots.label,
        collapsedItems: slots.collapsedItems
      }
    });
  }
});

exports["default"] = _Cascader;
//# sourceMappingURL=cascader.js.map
