import { TdCascaderProps } from './type';
import './style';
export * from './type';
export declare type CascaderProps = TdCascaderProps;
export declare const Cascader: import("vue").ComponentOptions<import("vue").default, import("@vue/composition-api").ShallowUnwrapRef<{
    COMPONENT_NAME: import("@vue/composition-api").ComputedRef<string>;
    overlayClassName: import("@vue/composition-api").ComputedRef<string>;
    panels: import("@vue/composition-api").ComputedRef<import("./interface").TreeNode[][]>;
    innerValue: import("@vue/composition-api").Ref<import("./type").CascaderValue<import("..").TreeOptionData<string | number>>>;
    displayValue: import("@vue/composition-api").ComputedRef<string | string[]>;
    inputPlaceholder: import("@vue/composition-api").ComputedRef<string>;
    isFilterable: import("@vue/composition-api").ComputedRef<boolean>;
    isDisabled: import("@vue/composition-api").ComputedRef<boolean>;
    STATUS: import("@vue/composition-api").ComputedRef<{
        loading: string;
        loadMore: string;
        disabled: string;
        focused: string;
        success: string;
        error: string;
        warning: string;
        selected: string;
        active: string;
        checked: string;
        current: string;
        hidden: string;
        visible: string;
        expanded: string;
        indeterminate: string;
    }>;
    classPrefix: import("@vue/composition-api").ComputedRef<string>;
    cascaderContext: import("@vue/composition-api").ComputedRef<{
        setTreeNodes: (nodes: import("./interface").TreeNode[]) => void;
        setValue: (val: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>, source: import("./type").CascaderChangeSource, node?: import("..").TreeNodeModel<import("..").TreeOptionData<string | number>>) => void;
        setVisible: (visible: boolean, context: import("..").PopupVisibleChangeContext) => void;
        setInputVal: (val: string) => void;
        setExpend: (val: import("./interface").TreeNodeValue[]) => void;
        treeStore: any;
        inputVal: any;
        scopeVal: any;
        treeNodes: any[];
        expend: any[];
        value: any;
        size: import("..").SizeEnum;
        checkStrictly: boolean;
        lazy: boolean;
        multiple: boolean;
        filterable: boolean;
        clearable: boolean;
        checkProps: import("..").TdCheckboxProps;
        max: number;
        disabled: boolean;
        showAllLevels: boolean;
        minCollapsedNum: number;
        valueType: "full" | "single";
        visible: boolean;
        cascaderValue: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    }>;
    emit: (event: string, ...args: any[]) => void;
    valueDisplayParams: import("@vue/composition-api").ComputedRef<{
        value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
        selectedOptions: import("./interface").TreeOptionData<string | number>[];
        onClose: (index: number) => void;
        displayValue: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    }>;
    updateScrollTop: (content: HTMLDivElement) => void;
}> & import("@vue/composition-api").Data, {}, {}, {
    autofocus: BooleanConstructor;
    borderless: BooleanConstructor;
    checkProps: {
        type: import("vue").PropType<import("..").TdCheckboxProps>;
    };
    checkStrictly: BooleanConstructor;
    clearable: BooleanConstructor;
    collapsedItems: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: {
            value: import("..").TreeOptionData<string | number>[];
            collapsedSelectedItems: import("..").TreeOptionData<string | number>[];
            count: number;
            onClose: (context: {
                index: number;
                e?: MouseEvent;
            }) => void;
        }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    disabled: BooleanConstructor;
    empty: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    filter: {
        type: import("vue").PropType<(filterWords: string, node: import("..").TreeNodeModel<import("..").TreeOptionData<string | number>>) => boolean | Promise<boolean>>;
    };
    filterable: BooleanConstructor;
    inputProps: {
        type: import("vue").PropType<import("..").InputProps<import("..").InputValue>>;
    };
    keys: {
        type: import("vue").PropType<import("..").TreeKeysType>;
    };
    label: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    lazy: {
        type: BooleanConstructor;
        default: boolean;
    };
    load: {
        type: import("vue").PropType<(node: import("..").TreeNodeModel<import("..").TreeOptionData<string | number>>) => Promise<import("..").TreeOptionData<string | number>[]>>;
    };
    loading: BooleanConstructor;
    loadingText: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    max: {
        type: NumberConstructor;
        default: number;
    };
    minCollapsedNum: {
        type: NumberConstructor;
        default: number;
    };
    multiple: BooleanConstructor;
    option: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: {
            item: import("..").TreeOptionData<string | number>;
            index: number;
        }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    options: {
        type: import("vue").PropType<import("..").TreeOptionData<string | number>[]>;
        default: () => import("..").TreeOptionData<string | number>[];
    };
    placeholder: {
        type: StringConstructor;
        default: any;
    };
    popupProps: {
        type: import("vue").PropType<import("..").TdPopupProps>;
    };
    popupVisible: BooleanConstructor;
    readonly: BooleanConstructor;
    reserveKeyword: BooleanConstructor;
    selectInputProps: {
        type: import("vue").PropType<import("..").TdSelectInputProps>;
    };
    showAllLevels: {
        type: BooleanConstructor;
        default: boolean;
    };
    size: {
        type: import("vue").PropType<import("..").SizeEnum>;
        default: import("..").SizeEnum;
        validator(val: import("..").SizeEnum): boolean;
    };
    status: {
        type: import("vue").PropType<"error" | "default" | "success" | "warning">;
        default: "error" | "default" | "success" | "warning";
        validator(val: "error" | "default" | "success" | "warning"): boolean;
    };
    suffix: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    suffixIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    tagInputProps: {
        type: import("vue").PropType<import("..").TdTagInputProps>;
    };
    tagProps: {
        type: import("vue").PropType<import("..").TdTagProps>;
    };
    tips: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    trigger: {
        type: import("vue").PropType<"click" | "hover">;
        default: "click" | "hover";
        validator(val: "click" | "hover"): boolean;
    };
    value: {
        type: import("vue").PropType<import("./type").CascaderValue<import("..").TreeOptionData<string | number>>>;
        default: () => import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    };
    defaultValue: {
        type: import("vue").PropType<import("./type").CascaderValue<import("..").TreeOptionData<string | number>>>;
        default: () => import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    };
    valueDisplay: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement, props: {
            value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
            onClose: (index: number) => void;
            displayValue?: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
            selectedOptions: import("..").TreeOptionData<string | number>[];
        }) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    valueMode: {
        type: import("vue").PropType<"all" | "onlyLeaf" | "parentFirst">;
        default: "all" | "onlyLeaf" | "parentFirst";
        validator(val: "all" | "onlyLeaf" | "parentFirst"): boolean;
    };
    valueType: {
        type: import("vue").PropType<"full" | "single">;
        default: "full" | "single";
        validator(val: "full" | "single"): boolean;
    };
    onBlur: import("vue").PropType<(context: {
        value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    } & import("..").PopupVisibleChangeContext & {
        inputValue: string;
        tagInputValue?: import("..").TagInputValue;
    }) => void>;
    onChange: import("vue").PropType<(value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>, context: import("./type").CascaderChangeContext<import("..").TreeOptionData<string | number>>) => void>;
    onFocus: import("vue").PropType<(context: {
        value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
        e: FocusEvent;
    }) => void>;
    onPopupVisibleChange: import("vue").PropType<(visible: boolean, context: import("..").PopupVisibleChangeContext) => void>;
    onRemove: import("vue").PropType<(context: import("./type").RemoveContext<import("..").TreeOptionData<string | number>>) => void>;
}, import("@vue/composition-api").ExtractPropTypes<{
    autofocus: BooleanConstructor;
    borderless: BooleanConstructor;
    checkProps: {
        type: import("vue").PropType<import("..").TdCheckboxProps>;
    };
    checkStrictly: BooleanConstructor;
    clearable: BooleanConstructor;
    collapsedItems: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: {
            value: import("..").TreeOptionData<string | number>[];
            collapsedSelectedItems: import("..").TreeOptionData<string | number>[];
            count: number;
            onClose: (context: {
                index: number;
                e?: MouseEvent;
            }) => void;
        }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    disabled: BooleanConstructor;
    empty: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    filter: {
        type: import("vue").PropType<(filterWords: string, node: import("..").TreeNodeModel<import("..").TreeOptionData<string | number>>) => boolean | Promise<boolean>>;
    };
    filterable: BooleanConstructor;
    inputProps: {
        type: import("vue").PropType<import("..").InputProps<import("..").InputValue>>;
    };
    keys: {
        type: import("vue").PropType<import("..").TreeKeysType>;
    };
    label: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    lazy: {
        type: BooleanConstructor;
        default: boolean;
    };
    load: {
        type: import("vue").PropType<(node: import("..").TreeNodeModel<import("..").TreeOptionData<string | number>>) => Promise<import("..").TreeOptionData<string | number>[]>>;
    };
    loading: BooleanConstructor;
    loadingText: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    max: {
        type: NumberConstructor;
        default: number;
    };
    minCollapsedNum: {
        type: NumberConstructor;
        default: number;
    };
    multiple: BooleanConstructor;
    option: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: {
            item: import("..").TreeOptionData<string | number>;
            index: number;
        }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    options: {
        type: import("vue").PropType<import("..").TreeOptionData<string | number>[]>;
        default: () => import("..").TreeOptionData<string | number>[];
    };
    placeholder: {
        type: StringConstructor;
        default: any;
    };
    popupProps: {
        type: import("vue").PropType<import("..").TdPopupProps>;
    };
    popupVisible: BooleanConstructor;
    readonly: BooleanConstructor;
    reserveKeyword: BooleanConstructor;
    selectInputProps: {
        type: import("vue").PropType<import("..").TdSelectInputProps>;
    };
    showAllLevels: {
        type: BooleanConstructor;
        default: boolean;
    };
    size: {
        type: import("vue").PropType<import("..").SizeEnum>;
        default: import("..").SizeEnum;
        validator(val: import("..").SizeEnum): boolean;
    };
    status: {
        type: import("vue").PropType<"error" | "default" | "success" | "warning">;
        default: "error" | "default" | "success" | "warning";
        validator(val: "error" | "default" | "success" | "warning"): boolean;
    };
    suffix: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    suffixIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    tagInputProps: {
        type: import("vue").PropType<import("..").TdTagInputProps>;
    };
    tagProps: {
        type: import("vue").PropType<import("..").TdTagProps>;
    };
    tips: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    trigger: {
        type: import("vue").PropType<"click" | "hover">;
        default: "click" | "hover";
        validator(val: "click" | "hover"): boolean;
    };
    value: {
        type: import("vue").PropType<import("./type").CascaderValue<import("..").TreeOptionData<string | number>>>;
        default: () => import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    };
    defaultValue: {
        type: import("vue").PropType<import("./type").CascaderValue<import("..").TreeOptionData<string | number>>>;
        default: () => import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    };
    valueDisplay: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement, props: {
            value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
            onClose: (index: number) => void;
            displayValue?: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
            selectedOptions: import("..").TreeOptionData<string | number>[];
        }) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    valueMode: {
        type: import("vue").PropType<"all" | "onlyLeaf" | "parentFirst">;
        default: "all" | "onlyLeaf" | "parentFirst";
        validator(val: "all" | "onlyLeaf" | "parentFirst"): boolean;
    };
    valueType: {
        type: import("vue").PropType<"full" | "single">;
        default: "full" | "single";
        validator(val: "full" | "single"): boolean;
    };
    onBlur: import("vue").PropType<(context: {
        value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    } & import("..").PopupVisibleChangeContext & {
        inputValue: string;
        tagInputValue?: import("..").TagInputValue;
    }) => void>;
    onChange: import("vue").PropType<(value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>, context: import("./type").CascaderChangeContext<import("..").TreeOptionData<string | number>>) => void>;
    onFocus: import("vue").PropType<(context: {
        value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
        e: FocusEvent;
    }) => void>;
    onPopupVisibleChange: import("vue").PropType<(visible: boolean, context: import("..").PopupVisibleChangeContext) => void>;
    onRemove: import("vue").PropType<(context: import("./type").RemoveContext<import("..").TreeOptionData<string | number>>) => void>;
}>> & Omit<import("vue").VueConstructor<import("vue").default>, never> & (new (...args: any[]) => import("@vue/composition-api").ComponentRenderProxy<{
    max: number;
    value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    loading: boolean;
    autofocus: boolean;
    lazy: boolean;
    disabled: boolean;
    multiple: boolean;
    options: import("..").TreeOptionData<string | number>[];
    size: import("..").SizeEnum;
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    defaultValue: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    trigger: "click" | "hover";
    borderless: boolean;
    clearable: boolean;
    placeholder: string;
    minCollapsedNum: number;
    popupVisible: boolean;
    reserveKeyword: boolean;
    valueType: "full" | "single";
    filterable: boolean;
    checkStrictly: boolean;
    valueMode: "all" | "onlyLeaf" | "parentFirst";
    showAllLevels: boolean;
} & {
    filter?: (filterWords: string, node: import("..").TreeNodeModel<import("..").TreeOptionData<string | number>>) => boolean | Promise<boolean>;
    keys?: unknown;
    label?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    option?: (h: import("vue").CreateElement, props: {
        item: import("..").TreeOptionData<string | number>;
        index: number;
    }) => import("vue/types/vnode").ScopedSlotReturnValue;
    load?: (node: import("..").TreeNodeModel<import("..").TreeOptionData<string | number>>) => Promise<import("..").TreeOptionData<string | number>[]>;
    empty?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onChange?: (value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>, context: import("./type").CascaderChangeContext<import("..").TreeOptionData<string | number>>) => void;
    suffix?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    suffixIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onBlur?: (context: {
        value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    } & import("..").PopupVisibleChangeContext & {
        inputValue: string;
        tagInputValue?: import("..").TagInputValue;
    }) => void;
    onFocus?: (context: {
        value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
        e: FocusEvent;
    }) => void;
    collapsedItems?: (h: import("vue").CreateElement, props: {
        value: import("..").TreeOptionData<string | number>[];
        collapsedSelectedItems: import("..").TreeOptionData<string | number>[];
        count: number;
        onClose: (context: {
            index: number;
            e?: MouseEvent;
        }) => void;
    }) => import("vue/types/vnode").ScopedSlotReturnValue;
    inputProps?: unknown;
    tagProps?: unknown;
    valueDisplay?: string | ((h: import("vue").CreateElement, props: {
        value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
        onClose: (index: number) => void;
        displayValue?: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
        selectedOptions: import("..").TreeOptionData<string | number>[];
    }) => import("vue/types/vnode").ScopedSlotReturnValue);
    onRemove?: (context: import("./type").RemoveContext<import("..").TreeOptionData<string | number>>) => void;
    popupProps?: unknown;
    tagInputProps?: unknown;
    onPopupVisibleChange?: (visible: boolean, context: import("..").PopupVisibleChangeContext) => void;
    loadingText?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    selectInputProps?: unknown;
    checkProps?: unknown;
}, import("@vue/composition-api").ShallowUnwrapRef<{
    COMPONENT_NAME: import("@vue/composition-api").ComputedRef<string>;
    overlayClassName: import("@vue/composition-api").ComputedRef<string>;
    panels: import("@vue/composition-api").ComputedRef<import("./interface").TreeNode[][]>;
    innerValue: import("@vue/composition-api").Ref<import("./type").CascaderValue<import("..").TreeOptionData<string | number>>>;
    displayValue: import("@vue/composition-api").ComputedRef<string | string[]>;
    inputPlaceholder: import("@vue/composition-api").ComputedRef<string>;
    isFilterable: import("@vue/composition-api").ComputedRef<boolean>;
    isDisabled: import("@vue/composition-api").ComputedRef<boolean>;
    STATUS: import("@vue/composition-api").ComputedRef<{
        loading: string;
        loadMore: string;
        disabled: string;
        focused: string;
        success: string;
        error: string;
        warning: string;
        selected: string;
        active: string;
        checked: string;
        current: string;
        hidden: string;
        visible: string;
        expanded: string;
        indeterminate: string;
    }>;
    classPrefix: import("@vue/composition-api").ComputedRef<string>;
    cascaderContext: import("@vue/composition-api").ComputedRef<{
        setTreeNodes: (nodes: import("./interface").TreeNode[]) => void;
        setValue: (val: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>, source: import("./type").CascaderChangeSource, node?: import("..").TreeNodeModel<import("..").TreeOptionData<string | number>>) => void;
        setVisible: (visible: boolean, context: import("..").PopupVisibleChangeContext) => void;
        setInputVal: (val: string) => void;
        setExpend: (val: import("./interface").TreeNodeValue[]) => void;
        treeStore: any;
        inputVal: any;
        scopeVal: any;
        treeNodes: any[];
        expend: any[];
        value: any;
        size: import("..").SizeEnum;
        checkStrictly: boolean;
        lazy: boolean;
        multiple: boolean;
        filterable: boolean;
        clearable: boolean;
        checkProps: import("..").TdCheckboxProps;
        max: number;
        disabled: boolean;
        showAllLevels: boolean;
        minCollapsedNum: number;
        valueType: "full" | "single";
        visible: boolean;
        cascaderValue: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    }>;
    emit: (event: string, ...args: any[]) => void;
    valueDisplayParams: import("@vue/composition-api").ComputedRef<{
        value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
        selectedOptions: import("./interface").TreeOptionData<string | number>[];
        onClose: (index: number) => void;
        displayValue: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    }>;
    updateScrollTop: (content: HTMLDivElement) => void;
}>, import("@vue/composition-api").Data, {}, {}, {}, {}, {}, {
    max: number;
    value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    loading: boolean;
    autofocus: boolean;
    lazy: boolean;
    disabled: boolean;
    multiple: boolean;
    options: import("..").TreeOptionData<string | number>[];
    size: import("..").SizeEnum;
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    defaultValue: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    trigger: "click" | "hover";
    borderless: boolean;
    clearable: boolean;
    placeholder: string;
    minCollapsedNum: number;
    popupVisible: boolean;
    reserveKeyword: boolean;
    valueType: "full" | "single";
    filterable: boolean;
    checkStrictly: boolean;
    valueMode: "all" | "onlyLeaf" | "parentFirst";
    showAllLevels: boolean;
} & {
    filter?: (filterWords: string, node: import("..").TreeNodeModel<import("..").TreeOptionData<string | number>>) => boolean | Promise<boolean>;
    keys?: unknown;
    label?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    option?: (h: import("vue").CreateElement, props: {
        item: import("..").TreeOptionData<string | number>;
        index: number;
    }) => import("vue/types/vnode").ScopedSlotReturnValue;
    load?: (node: import("..").TreeNodeModel<import("..").TreeOptionData<string | number>>) => Promise<import("..").TreeOptionData<string | number>[]>;
    empty?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onChange?: (value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>, context: import("./type").CascaderChangeContext<import("..").TreeOptionData<string | number>>) => void;
    suffix?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    suffixIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onBlur?: (context: {
        value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    } & import("..").PopupVisibleChangeContext & {
        inputValue: string;
        tagInputValue?: import("..").TagInputValue;
    }) => void;
    onFocus?: (context: {
        value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
        e: FocusEvent;
    }) => void;
    collapsedItems?: (h: import("vue").CreateElement, props: {
        value: import("..").TreeOptionData<string | number>[];
        collapsedSelectedItems: import("..").TreeOptionData<string | number>[];
        count: number;
        onClose: (context: {
            index: number;
            e?: MouseEvent;
        }) => void;
    }) => import("vue/types/vnode").ScopedSlotReturnValue;
    inputProps?: unknown;
    tagProps?: unknown;
    valueDisplay?: string | ((h: import("vue").CreateElement, props: {
        value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
        onClose: (index: number) => void;
        displayValue?: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
        selectedOptions: import("..").TreeOptionData<string | number>[];
    }) => import("vue/types/vnode").ScopedSlotReturnValue);
    onRemove?: (context: import("./type").RemoveContext<import("..").TreeOptionData<string | number>>) => void;
    popupProps?: unknown;
    tagInputProps?: unknown;
    onPopupVisibleChange?: (visible: boolean, context: import("..").PopupVisibleChangeContext) => void;
    loadingText?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    selectInputProps?: unknown;
    checkProps?: unknown;
}, {
    max: number;
    value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    loading: boolean;
    autofocus: boolean;
    lazy: boolean;
    disabled: boolean;
    multiple: boolean;
    options: import("..").TreeOptionData<string | number>[];
    size: import("..").SizeEnum;
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    defaultValue: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    trigger: "click" | "hover";
    borderless: boolean;
    clearable: boolean;
    placeholder: string;
    minCollapsedNum: number;
    popupVisible: boolean;
    reserveKeyword: boolean;
    valueType: "full" | "single";
    filterable: boolean;
    checkStrictly: boolean;
    valueMode: "all" | "onlyLeaf" | "parentFirst";
    showAllLevels: boolean;
}, true>) & import("vue").PluginObject<import("vue").ComponentOptions<import("vue").default, import("@vue/composition-api").ShallowUnwrapRef<{
    COMPONENT_NAME: import("@vue/composition-api").ComputedRef<string>;
    overlayClassName: import("@vue/composition-api").ComputedRef<string>;
    panels: import("@vue/composition-api").ComputedRef<import("./interface").TreeNode[][]>;
    innerValue: import("@vue/composition-api").Ref<import("./type").CascaderValue<import("..").TreeOptionData<string | number>>>;
    displayValue: import("@vue/composition-api").ComputedRef<string | string[]>;
    inputPlaceholder: import("@vue/composition-api").ComputedRef<string>;
    isFilterable: import("@vue/composition-api").ComputedRef<boolean>;
    isDisabled: import("@vue/composition-api").ComputedRef<boolean>;
    STATUS: import("@vue/composition-api").ComputedRef<{
        loading: string;
        loadMore: string;
        disabled: string;
        focused: string;
        success: string;
        error: string;
        warning: string;
        selected: string;
        active: string;
        checked: string;
        current: string;
        hidden: string;
        visible: string;
        expanded: string;
        indeterminate: string;
    }>;
    classPrefix: import("@vue/composition-api").ComputedRef<string>;
    cascaderContext: import("@vue/composition-api").ComputedRef<{
        setTreeNodes: (nodes: import("./interface").TreeNode[]) => void;
        setValue: (val: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>, source: import("./type").CascaderChangeSource, node?: import("..").TreeNodeModel<import("..").TreeOptionData<string | number>>) => void;
        setVisible: (visible: boolean, context: import("..").PopupVisibleChangeContext) => void;
        setInputVal: (val: string) => void;
        setExpend: (val: import("./interface").TreeNodeValue[]) => void;
        treeStore: any;
        inputVal: any;
        scopeVal: any;
        treeNodes: any[];
        expend: any[];
        value: any;
        size: import("..").SizeEnum;
        checkStrictly: boolean;
        lazy: boolean;
        multiple: boolean;
        filterable: boolean;
        clearable: boolean;
        checkProps: import("..").TdCheckboxProps;
        max: number;
        disabled: boolean;
        showAllLevels: boolean;
        minCollapsedNum: number;
        valueType: "full" | "single";
        visible: boolean;
        cascaderValue: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    }>;
    emit: (event: string, ...args: any[]) => void;
    valueDisplayParams: import("@vue/composition-api").ComputedRef<{
        value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
        selectedOptions: import("./interface").TreeOptionData<string | number>[];
        onClose: (index: number) => void;
        displayValue: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    }>;
    updateScrollTop: (content: HTMLDivElement) => void;
}> & import("@vue/composition-api").Data, {}, {}, {
    autofocus: BooleanConstructor;
    borderless: BooleanConstructor;
    checkProps: {
        type: import("vue").PropType<import("..").TdCheckboxProps>;
    };
    checkStrictly: BooleanConstructor;
    clearable: BooleanConstructor;
    collapsedItems: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: {
            value: import("..").TreeOptionData<string | number>[];
            collapsedSelectedItems: import("..").TreeOptionData<string | number>[];
            count: number;
            onClose: (context: {
                index: number;
                e?: MouseEvent;
            }) => void;
        }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    disabled: BooleanConstructor;
    empty: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    filter: {
        type: import("vue").PropType<(filterWords: string, node: import("..").TreeNodeModel<import("..").TreeOptionData<string | number>>) => boolean | Promise<boolean>>;
    };
    filterable: BooleanConstructor;
    inputProps: {
        type: import("vue").PropType<import("..").InputProps<import("..").InputValue>>;
    };
    keys: {
        type: import("vue").PropType<import("..").TreeKeysType>;
    };
    label: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    lazy: {
        type: BooleanConstructor;
        default: boolean;
    };
    load: {
        type: import("vue").PropType<(node: import("..").TreeNodeModel<import("..").TreeOptionData<string | number>>) => Promise<import("..").TreeOptionData<string | number>[]>>;
    };
    loading: BooleanConstructor;
    loadingText: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    max: {
        type: NumberConstructor;
        default: number;
    };
    minCollapsedNum: {
        type: NumberConstructor;
        default: number;
    };
    multiple: BooleanConstructor;
    option: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: {
            item: import("..").TreeOptionData<string | number>;
            index: number;
        }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    options: {
        type: import("vue").PropType<import("..").TreeOptionData<string | number>[]>;
        default: () => import("..").TreeOptionData<string | number>[];
    };
    placeholder: {
        type: StringConstructor;
        default: any;
    };
    popupProps: {
        type: import("vue").PropType<import("..").TdPopupProps>;
    };
    popupVisible: BooleanConstructor;
    readonly: BooleanConstructor;
    reserveKeyword: BooleanConstructor;
    selectInputProps: {
        type: import("vue").PropType<import("..").TdSelectInputProps>;
    };
    showAllLevels: {
        type: BooleanConstructor;
        default: boolean;
    };
    size: {
        type: import("vue").PropType<import("..").SizeEnum>;
        default: import("..").SizeEnum;
        validator(val: import("..").SizeEnum): boolean;
    };
    status: {
        type: import("vue").PropType<"error" | "default" | "success" | "warning">;
        default: "error" | "default" | "success" | "warning";
        validator(val: "error" | "default" | "success" | "warning"): boolean;
    };
    suffix: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    suffixIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    tagInputProps: {
        type: import("vue").PropType<import("..").TdTagInputProps>;
    };
    tagProps: {
        type: import("vue").PropType<import("..").TdTagProps>;
    };
    tips: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    trigger: {
        type: import("vue").PropType<"click" | "hover">;
        default: "click" | "hover";
        validator(val: "click" | "hover"): boolean;
    };
    value: {
        type: import("vue").PropType<import("./type").CascaderValue<import("..").TreeOptionData<string | number>>>;
        default: () => import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    };
    defaultValue: {
        type: import("vue").PropType<import("./type").CascaderValue<import("..").TreeOptionData<string | number>>>;
        default: () => import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    };
    valueDisplay: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement, props: {
            value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
            onClose: (index: number) => void;
            displayValue?: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
            selectedOptions: import("..").TreeOptionData<string | number>[];
        }) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    valueMode: {
        type: import("vue").PropType<"all" | "onlyLeaf" | "parentFirst">;
        default: "all" | "onlyLeaf" | "parentFirst";
        validator(val: "all" | "onlyLeaf" | "parentFirst"): boolean;
    };
    valueType: {
        type: import("vue").PropType<"full" | "single">;
        default: "full" | "single";
        validator(val: "full" | "single"): boolean;
    };
    onBlur: import("vue").PropType<(context: {
        value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    } & import("..").PopupVisibleChangeContext & {
        inputValue: string;
        tagInputValue?: import("..").TagInputValue;
    }) => void>;
    onChange: import("vue").PropType<(value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>, context: import("./type").CascaderChangeContext<import("..").TreeOptionData<string | number>>) => void>;
    onFocus: import("vue").PropType<(context: {
        value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
        e: FocusEvent;
    }) => void>;
    onPopupVisibleChange: import("vue").PropType<(visible: boolean, context: import("..").PopupVisibleChangeContext) => void>;
    onRemove: import("vue").PropType<(context: import("./type").RemoveContext<import("..").TreeOptionData<string | number>>) => void>;
}, import("@vue/composition-api").ExtractPropTypes<{
    autofocus: BooleanConstructor;
    borderless: BooleanConstructor;
    checkProps: {
        type: import("vue").PropType<import("..").TdCheckboxProps>;
    };
    checkStrictly: BooleanConstructor;
    clearable: BooleanConstructor;
    collapsedItems: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: {
            value: import("..").TreeOptionData<string | number>[];
            collapsedSelectedItems: import("..").TreeOptionData<string | number>[];
            count: number;
            onClose: (context: {
                index: number;
                e?: MouseEvent;
            }) => void;
        }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    disabled: BooleanConstructor;
    empty: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    filter: {
        type: import("vue").PropType<(filterWords: string, node: import("..").TreeNodeModel<import("..").TreeOptionData<string | number>>) => boolean | Promise<boolean>>;
    };
    filterable: BooleanConstructor;
    inputProps: {
        type: import("vue").PropType<import("..").InputProps<import("..").InputValue>>;
    };
    keys: {
        type: import("vue").PropType<import("..").TreeKeysType>;
    };
    label: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    lazy: {
        type: BooleanConstructor;
        default: boolean;
    };
    load: {
        type: import("vue").PropType<(node: import("..").TreeNodeModel<import("..").TreeOptionData<string | number>>) => Promise<import("..").TreeOptionData<string | number>[]>>;
    };
    loading: BooleanConstructor;
    loadingText: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    max: {
        type: NumberConstructor;
        default: number;
    };
    minCollapsedNum: {
        type: NumberConstructor;
        default: number;
    };
    multiple: BooleanConstructor;
    option: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: {
            item: import("..").TreeOptionData<string | number>;
            index: number;
        }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    options: {
        type: import("vue").PropType<import("..").TreeOptionData<string | number>[]>;
        default: () => import("..").TreeOptionData<string | number>[];
    };
    placeholder: {
        type: StringConstructor;
        default: any;
    };
    popupProps: {
        type: import("vue").PropType<import("..").TdPopupProps>;
    };
    popupVisible: BooleanConstructor;
    readonly: BooleanConstructor;
    reserveKeyword: BooleanConstructor;
    selectInputProps: {
        type: import("vue").PropType<import("..").TdSelectInputProps>;
    };
    showAllLevels: {
        type: BooleanConstructor;
        default: boolean;
    };
    size: {
        type: import("vue").PropType<import("..").SizeEnum>;
        default: import("..").SizeEnum;
        validator(val: import("..").SizeEnum): boolean;
    };
    status: {
        type: import("vue").PropType<"error" | "default" | "success" | "warning">;
        default: "error" | "default" | "success" | "warning";
        validator(val: "error" | "default" | "success" | "warning"): boolean;
    };
    suffix: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    suffixIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    tagInputProps: {
        type: import("vue").PropType<import("..").TdTagInputProps>;
    };
    tagProps: {
        type: import("vue").PropType<import("..").TdTagProps>;
    };
    tips: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    trigger: {
        type: import("vue").PropType<"click" | "hover">;
        default: "click" | "hover";
        validator(val: "click" | "hover"): boolean;
    };
    value: {
        type: import("vue").PropType<import("./type").CascaderValue<import("..").TreeOptionData<string | number>>>;
        default: () => import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    };
    defaultValue: {
        type: import("vue").PropType<import("./type").CascaderValue<import("..").TreeOptionData<string | number>>>;
        default: () => import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    };
    valueDisplay: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement, props: {
            value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
            onClose: (index: number) => void;
            displayValue?: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
            selectedOptions: import("..").TreeOptionData<string | number>[];
        }) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    valueMode: {
        type: import("vue").PropType<"all" | "onlyLeaf" | "parentFirst">;
        default: "all" | "onlyLeaf" | "parentFirst";
        validator(val: "all" | "onlyLeaf" | "parentFirst"): boolean;
    };
    valueType: {
        type: import("vue").PropType<"full" | "single">;
        default: "full" | "single";
        validator(val: "full" | "single"): boolean;
    };
    onBlur: import("vue").PropType<(context: {
        value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    } & import("..").PopupVisibleChangeContext & {
        inputValue: string;
        tagInputValue?: import("..").TagInputValue;
    }) => void>;
    onChange: import("vue").PropType<(value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>, context: import("./type").CascaderChangeContext<import("..").TreeOptionData<string | number>>) => void>;
    onFocus: import("vue").PropType<(context: {
        value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
        e: FocusEvent;
    }) => void>;
    onPopupVisibleChange: import("vue").PropType<(visible: boolean, context: import("..").PopupVisibleChangeContext) => void>;
    onRemove: import("vue").PropType<(context: import("./type").RemoveContext<import("..").TreeOptionData<string | number>>) => void>;
}>> & Omit<import("vue").VueConstructor<import("vue").default>, never> & (new (...args: any[]) => import("@vue/composition-api").ComponentRenderProxy<{
    max: number;
    value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    loading: boolean;
    autofocus: boolean;
    lazy: boolean;
    disabled: boolean;
    multiple: boolean;
    options: import("..").TreeOptionData<string | number>[];
    size: import("..").SizeEnum;
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    defaultValue: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    trigger: "click" | "hover";
    borderless: boolean;
    clearable: boolean;
    placeholder: string;
    minCollapsedNum: number;
    popupVisible: boolean;
    reserveKeyword: boolean;
    valueType: "full" | "single";
    filterable: boolean;
    checkStrictly: boolean;
    valueMode: "all" | "onlyLeaf" | "parentFirst";
    showAllLevels: boolean;
} & {
    filter?: (filterWords: string, node: import("..").TreeNodeModel<import("..").TreeOptionData<string | number>>) => boolean | Promise<boolean>;
    keys?: unknown;
    label?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    option?: (h: import("vue").CreateElement, props: {
        item: import("..").TreeOptionData<string | number>;
        index: number;
    }) => import("vue/types/vnode").ScopedSlotReturnValue;
    load?: (node: import("..").TreeNodeModel<import("..").TreeOptionData<string | number>>) => Promise<import("..").TreeOptionData<string | number>[]>;
    empty?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onChange?: (value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>, context: import("./type").CascaderChangeContext<import("..").TreeOptionData<string | number>>) => void;
    suffix?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    suffixIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onBlur?: (context: {
        value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    } & import("..").PopupVisibleChangeContext & {
        inputValue: string;
        tagInputValue?: import("..").TagInputValue;
    }) => void;
    onFocus?: (context: {
        value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
        e: FocusEvent;
    }) => void;
    collapsedItems?: (h: import("vue").CreateElement, props: {
        value: import("..").TreeOptionData<string | number>[];
        collapsedSelectedItems: import("..").TreeOptionData<string | number>[];
        count: number;
        onClose: (context: {
            index: number;
            e?: MouseEvent;
        }) => void;
    }) => import("vue/types/vnode").ScopedSlotReturnValue;
    inputProps?: unknown;
    tagProps?: unknown;
    valueDisplay?: string | ((h: import("vue").CreateElement, props: {
        value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
        onClose: (index: number) => void;
        displayValue?: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
        selectedOptions: import("..").TreeOptionData<string | number>[];
    }) => import("vue/types/vnode").ScopedSlotReturnValue);
    onRemove?: (context: import("./type").RemoveContext<import("..").TreeOptionData<string | number>>) => void;
    popupProps?: unknown;
    tagInputProps?: unknown;
    onPopupVisibleChange?: (visible: boolean, context: import("..").PopupVisibleChangeContext) => void;
    loadingText?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    selectInputProps?: unknown;
    checkProps?: unknown;
}, import("@vue/composition-api").ShallowUnwrapRef<{
    COMPONENT_NAME: import("@vue/composition-api").ComputedRef<string>;
    overlayClassName: import("@vue/composition-api").ComputedRef<string>;
    panels: import("@vue/composition-api").ComputedRef<import("./interface").TreeNode[][]>;
    innerValue: import("@vue/composition-api").Ref<import("./type").CascaderValue<import("..").TreeOptionData<string | number>>>;
    displayValue: import("@vue/composition-api").ComputedRef<string | string[]>;
    inputPlaceholder: import("@vue/composition-api").ComputedRef<string>;
    isFilterable: import("@vue/composition-api").ComputedRef<boolean>;
    isDisabled: import("@vue/composition-api").ComputedRef<boolean>;
    STATUS: import("@vue/composition-api").ComputedRef<{
        loading: string;
        loadMore: string;
        disabled: string;
        focused: string;
        success: string;
        error: string;
        warning: string;
        selected: string;
        active: string;
        checked: string;
        current: string;
        hidden: string;
        visible: string;
        expanded: string;
        indeterminate: string;
    }>;
    classPrefix: import("@vue/composition-api").ComputedRef<string>;
    cascaderContext: import("@vue/composition-api").ComputedRef<{
        setTreeNodes: (nodes: import("./interface").TreeNode[]) => void;
        setValue: (val: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>, source: import("./type").CascaderChangeSource, node?: import("..").TreeNodeModel<import("..").TreeOptionData<string | number>>) => void;
        setVisible: (visible: boolean, context: import("..").PopupVisibleChangeContext) => void;
        setInputVal: (val: string) => void;
        setExpend: (val: import("./interface").TreeNodeValue[]) => void;
        treeStore: any;
        inputVal: any;
        scopeVal: any;
        treeNodes: any[];
        expend: any[];
        value: any;
        size: import("..").SizeEnum;
        checkStrictly: boolean;
        lazy: boolean;
        multiple: boolean;
        filterable: boolean;
        clearable: boolean;
        checkProps: import("..").TdCheckboxProps;
        max: number;
        disabled: boolean;
        showAllLevels: boolean;
        minCollapsedNum: number;
        valueType: "full" | "single";
        visible: boolean;
        cascaderValue: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    }>;
    emit: (event: string, ...args: any[]) => void;
    valueDisplayParams: import("@vue/composition-api").ComputedRef<{
        value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
        selectedOptions: import("./interface").TreeOptionData<string | number>[];
        onClose: (index: number) => void;
        displayValue: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    }>;
    updateScrollTop: (content: HTMLDivElement) => void;
}>, import("@vue/composition-api").Data, {}, {}, {}, {}, {}, {
    max: number;
    value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    loading: boolean;
    autofocus: boolean;
    lazy: boolean;
    disabled: boolean;
    multiple: boolean;
    options: import("..").TreeOptionData<string | number>[];
    size: import("..").SizeEnum;
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    defaultValue: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    trigger: "click" | "hover";
    borderless: boolean;
    clearable: boolean;
    placeholder: string;
    minCollapsedNum: number;
    popupVisible: boolean;
    reserveKeyword: boolean;
    valueType: "full" | "single";
    filterable: boolean;
    checkStrictly: boolean;
    valueMode: "all" | "onlyLeaf" | "parentFirst";
    showAllLevels: boolean;
} & {
    filter?: (filterWords: string, node: import("..").TreeNodeModel<import("..").TreeOptionData<string | number>>) => boolean | Promise<boolean>;
    keys?: unknown;
    label?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    option?: (h: import("vue").CreateElement, props: {
        item: import("..").TreeOptionData<string | number>;
        index: number;
    }) => import("vue/types/vnode").ScopedSlotReturnValue;
    load?: (node: import("..").TreeNodeModel<import("..").TreeOptionData<string | number>>) => Promise<import("..").TreeOptionData<string | number>[]>;
    empty?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onChange?: (value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>, context: import("./type").CascaderChangeContext<import("..").TreeOptionData<string | number>>) => void;
    suffix?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    suffixIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onBlur?: (context: {
        value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    } & import("..").PopupVisibleChangeContext & {
        inputValue: string;
        tagInputValue?: import("..").TagInputValue;
    }) => void;
    onFocus?: (context: {
        value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
        e: FocusEvent;
    }) => void;
    collapsedItems?: (h: import("vue").CreateElement, props: {
        value: import("..").TreeOptionData<string | number>[];
        collapsedSelectedItems: import("..").TreeOptionData<string | number>[];
        count: number;
        onClose: (context: {
            index: number;
            e?: MouseEvent;
        }) => void;
    }) => import("vue/types/vnode").ScopedSlotReturnValue;
    inputProps?: unknown;
    tagProps?: unknown;
    valueDisplay?: string | ((h: import("vue").CreateElement, props: {
        value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
        onClose: (index: number) => void;
        displayValue?: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
        selectedOptions: import("..").TreeOptionData<string | number>[];
    }) => import("vue/types/vnode").ScopedSlotReturnValue);
    onRemove?: (context: import("./type").RemoveContext<import("..").TreeOptionData<string | number>>) => void;
    popupProps?: unknown;
    tagInputProps?: unknown;
    onPopupVisibleChange?: (visible: boolean, context: import("..").PopupVisibleChangeContext) => void;
    loadingText?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    selectInputProps?: unknown;
    checkProps?: unknown;
}, {
    max: number;
    value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    loading: boolean;
    autofocus: boolean;
    lazy: boolean;
    disabled: boolean;
    multiple: boolean;
    options: import("..").TreeOptionData<string | number>[];
    size: import("..").SizeEnum;
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    defaultValue: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    trigger: "click" | "hover";
    borderless: boolean;
    clearable: boolean;
    placeholder: string;
    minCollapsedNum: number;
    popupVisible: boolean;
    reserveKeyword: boolean;
    valueType: "full" | "single";
    filterable: boolean;
    checkStrictly: boolean;
    valueMode: "all" | "onlyLeaf" | "parentFirst";
    showAllLevels: boolean;
}, true>)>;
export declare const CascaderPanel: import("vue").ComponentOptions<import("vue").default, import("@vue/composition-api").ShallowUnwrapRef<{
    cascaderContext: import("@vue/composition-api").ComputedRef<{
        setTreeNodes: (nodes: import("./interface").TreeNode[]) => void;
        setValue: (val: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>, source: import("./type").CascaderChangeSource, node?: import("..").TreeNodeModel<import("..").TreeOptionData<string | number>>) => void;
        setVisible: (visible: boolean, context: import("..").PopupVisibleChangeContext) => void;
        setInputVal: (val: string) => void;
        setExpend: (val: import("./interface").TreeNodeValue[]) => void;
        treeStore: any;
        inputVal: any;
        scopeVal: any;
        treeNodes: any[];
        expend: any[];
        value: any;
        size: import("..").SizeEnum;
        checkStrictly: boolean;
        lazy: boolean;
        multiple: boolean;
        filterable: boolean;
        clearable: boolean;
        checkProps: import("..").TdCheckboxProps;
        max: number;
        disabled: boolean;
        showAllLevels: boolean;
        minCollapsedNum: number;
        valueType: "full" | "single";
        visible: boolean;
        cascaderValue: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    }>;
    slots: Readonly<{
        [name: string]: (...args: any[]) => import("vue").VNode[];
    }>;
    onClick: (value: string, node: import("./interface").TreeNode) => void;
}> & import("@vue/composition-api").Data, {}, {}, {
    autofocus: BooleanConstructor;
    borderless: BooleanConstructor;
    checkProps: {
        type: import("vue").PropType<import("..").TdCheckboxProps>;
    };
    checkStrictly: BooleanConstructor;
    clearable: BooleanConstructor;
    collapsedItems: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: {
            value: import("..").TreeOptionData<string | number>[];
            collapsedSelectedItems: import("..").TreeOptionData<string | number>[];
            count: number;
            onClose: (context: {
                index: number;
                e?: MouseEvent;
            }) => void;
        }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    disabled: BooleanConstructor;
    empty: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    filter: {
        type: import("vue").PropType<(filterWords: string, node: import("..").TreeNodeModel<import("..").TreeOptionData<string | number>>) => boolean | Promise<boolean>>;
    };
    filterable: BooleanConstructor;
    inputProps: {
        type: import("vue").PropType<import("..").InputProps<import("..").InputValue>>;
    };
    keys: {
        type: import("vue").PropType<import("..").TreeKeysType>;
    };
    label: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    lazy: {
        type: BooleanConstructor;
        default: boolean;
    };
    load: {
        type: import("vue").PropType<(node: import("..").TreeNodeModel<import("..").TreeOptionData<string | number>>) => Promise<import("..").TreeOptionData<string | number>[]>>;
    };
    loading: BooleanConstructor;
    loadingText: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    max: {
        type: NumberConstructor;
        default: number;
    };
    minCollapsedNum: {
        type: NumberConstructor;
        default: number;
    };
    multiple: BooleanConstructor;
    option: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: {
            item: import("..").TreeOptionData<string | number>;
            index: number;
        }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    options: {
        type: import("vue").PropType<import("..").TreeOptionData<string | number>[]>;
        default: () => import("..").TreeOptionData<string | number>[];
    };
    placeholder: {
        type: StringConstructor;
        default: any;
    };
    popupProps: {
        type: import("vue").PropType<import("..").TdPopupProps>;
    };
    popupVisible: BooleanConstructor;
    readonly: BooleanConstructor;
    reserveKeyword: BooleanConstructor;
    selectInputProps: {
        type: import("vue").PropType<import("..").TdSelectInputProps>;
    };
    showAllLevels: {
        type: BooleanConstructor;
        default: boolean;
    };
    size: {
        type: import("vue").PropType<import("..").SizeEnum>;
        default: import("..").SizeEnum;
        validator(val: import("..").SizeEnum): boolean;
    };
    status: {
        type: import("vue").PropType<"error" | "default" | "success" | "warning">;
        default: "error" | "default" | "success" | "warning";
        validator(val: "error" | "default" | "success" | "warning"): boolean;
    };
    suffix: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    suffixIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    tagInputProps: {
        type: import("vue").PropType<import("..").TdTagInputProps>;
    };
    tagProps: {
        type: import("vue").PropType<import("..").TdTagProps>;
    };
    tips: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    trigger: {
        type: import("vue").PropType<"click" | "hover">;
        default: "click" | "hover";
        validator(val: "click" | "hover"): boolean;
    };
    value: {
        type: import("vue").PropType<import("./type").CascaderValue<import("..").TreeOptionData<string | number>>>;
        default: () => import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    };
    defaultValue: {
        type: import("vue").PropType<import("./type").CascaderValue<import("..").TreeOptionData<string | number>>>;
        default: () => import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    };
    valueDisplay: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement, props: {
            value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
            onClose: (index: number) => void;
            displayValue?: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
            selectedOptions: import("..").TreeOptionData<string | number>[];
        }) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    valueMode: {
        type: import("vue").PropType<"all" | "onlyLeaf" | "parentFirst">;
        default: "all" | "onlyLeaf" | "parentFirst";
        validator(val: "all" | "onlyLeaf" | "parentFirst"): boolean;
    };
    valueType: {
        type: import("vue").PropType<"full" | "single">;
        default: "full" | "single";
        validator(val: "full" | "single"): boolean;
    };
    onBlur: import("vue").PropType<(context: {
        value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    } & import("..").PopupVisibleChangeContext & {
        inputValue: string;
        tagInputValue?: import("..").TagInputValue;
    }) => void>;
    onChange: import("vue").PropType<(value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>, context: import("./type").CascaderChangeContext<import("..").TreeOptionData<string | number>>) => void>;
    onFocus: import("vue").PropType<(context: {
        value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
        e: FocusEvent;
    }) => void>;
    onPopupVisibleChange: import("vue").PropType<(visible: boolean, context: import("..").PopupVisibleChangeContext) => void>;
    onRemove: import("vue").PropType<(context: import("./type").RemoveContext<import("..").TreeOptionData<string | number>>) => void>;
}, import("@vue/composition-api").ExtractPropTypes<{
    autofocus: BooleanConstructor;
    borderless: BooleanConstructor;
    checkProps: {
        type: import("vue").PropType<import("..").TdCheckboxProps>;
    };
    checkStrictly: BooleanConstructor;
    clearable: BooleanConstructor;
    collapsedItems: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: {
            value: import("..").TreeOptionData<string | number>[];
            collapsedSelectedItems: import("..").TreeOptionData<string | number>[];
            count: number;
            onClose: (context: {
                index: number;
                e?: MouseEvent;
            }) => void;
        }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    disabled: BooleanConstructor;
    empty: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    filter: {
        type: import("vue").PropType<(filterWords: string, node: import("..").TreeNodeModel<import("..").TreeOptionData<string | number>>) => boolean | Promise<boolean>>;
    };
    filterable: BooleanConstructor;
    inputProps: {
        type: import("vue").PropType<import("..").InputProps<import("..").InputValue>>;
    };
    keys: {
        type: import("vue").PropType<import("..").TreeKeysType>;
    };
    label: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    lazy: {
        type: BooleanConstructor;
        default: boolean;
    };
    load: {
        type: import("vue").PropType<(node: import("..").TreeNodeModel<import("..").TreeOptionData<string | number>>) => Promise<import("..").TreeOptionData<string | number>[]>>;
    };
    loading: BooleanConstructor;
    loadingText: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    max: {
        type: NumberConstructor;
        default: number;
    };
    minCollapsedNum: {
        type: NumberConstructor;
        default: number;
    };
    multiple: BooleanConstructor;
    option: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: {
            item: import("..").TreeOptionData<string | number>;
            index: number;
        }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    options: {
        type: import("vue").PropType<import("..").TreeOptionData<string | number>[]>;
        default: () => import("..").TreeOptionData<string | number>[];
    };
    placeholder: {
        type: StringConstructor;
        default: any;
    };
    popupProps: {
        type: import("vue").PropType<import("..").TdPopupProps>;
    };
    popupVisible: BooleanConstructor;
    readonly: BooleanConstructor;
    reserveKeyword: BooleanConstructor;
    selectInputProps: {
        type: import("vue").PropType<import("..").TdSelectInputProps>;
    };
    showAllLevels: {
        type: BooleanConstructor;
        default: boolean;
    };
    size: {
        type: import("vue").PropType<import("..").SizeEnum>;
        default: import("..").SizeEnum;
        validator(val: import("..").SizeEnum): boolean;
    };
    status: {
        type: import("vue").PropType<"error" | "default" | "success" | "warning">;
        default: "error" | "default" | "success" | "warning";
        validator(val: "error" | "default" | "success" | "warning"): boolean;
    };
    suffix: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    suffixIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    tagInputProps: {
        type: import("vue").PropType<import("..").TdTagInputProps>;
    };
    tagProps: {
        type: import("vue").PropType<import("..").TdTagProps>;
    };
    tips: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    trigger: {
        type: import("vue").PropType<"click" | "hover">;
        default: "click" | "hover";
        validator(val: "click" | "hover"): boolean;
    };
    value: {
        type: import("vue").PropType<import("./type").CascaderValue<import("..").TreeOptionData<string | number>>>;
        default: () => import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    };
    defaultValue: {
        type: import("vue").PropType<import("./type").CascaderValue<import("..").TreeOptionData<string | number>>>;
        default: () => import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    };
    valueDisplay: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement, props: {
            value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
            onClose: (index: number) => void;
            displayValue?: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
            selectedOptions: import("..").TreeOptionData<string | number>[];
        }) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    valueMode: {
        type: import("vue").PropType<"all" | "onlyLeaf" | "parentFirst">;
        default: "all" | "onlyLeaf" | "parentFirst";
        validator(val: "all" | "onlyLeaf" | "parentFirst"): boolean;
    };
    valueType: {
        type: import("vue").PropType<"full" | "single">;
        default: "full" | "single";
        validator(val: "full" | "single"): boolean;
    };
    onBlur: import("vue").PropType<(context: {
        value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    } & import("..").PopupVisibleChangeContext & {
        inputValue: string;
        tagInputValue?: import("..").TagInputValue;
    }) => void>;
    onChange: import("vue").PropType<(value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>, context: import("./type").CascaderChangeContext<import("..").TreeOptionData<string | number>>) => void>;
    onFocus: import("vue").PropType<(context: {
        value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
        e: FocusEvent;
    }) => void>;
    onPopupVisibleChange: import("vue").PropType<(visible: boolean, context: import("..").PopupVisibleChangeContext) => void>;
    onRemove: import("vue").PropType<(context: import("./type").RemoveContext<import("..").TreeOptionData<string | number>>) => void>;
}>> & Omit<import("vue").VueConstructor<import("vue").default>, never> & (new (...args: any[]) => import("@vue/composition-api").ComponentRenderProxy<{
    max: number;
    value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    loading: boolean;
    autofocus: boolean;
    lazy: boolean;
    disabled: boolean;
    multiple: boolean;
    options: import("..").TreeOptionData<string | number>[];
    size: import("..").SizeEnum;
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    defaultValue: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    trigger: "click" | "hover";
    borderless: boolean;
    clearable: boolean;
    placeholder: string;
    minCollapsedNum: number;
    popupVisible: boolean;
    reserveKeyword: boolean;
    valueType: "full" | "single";
    filterable: boolean;
    checkStrictly: boolean;
    valueMode: "all" | "onlyLeaf" | "parentFirst";
    showAllLevels: boolean;
} & {
    filter?: (filterWords: string, node: import("..").TreeNodeModel<import("..").TreeOptionData<string | number>>) => boolean | Promise<boolean>;
    keys?: unknown;
    label?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    option?: (h: import("vue").CreateElement, props: {
        item: import("..").TreeOptionData<string | number>;
        index: number;
    }) => import("vue/types/vnode").ScopedSlotReturnValue;
    load?: (node: import("..").TreeNodeModel<import("..").TreeOptionData<string | number>>) => Promise<import("..").TreeOptionData<string | number>[]>;
    empty?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onChange?: (value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>, context: import("./type").CascaderChangeContext<import("..").TreeOptionData<string | number>>) => void;
    suffix?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    suffixIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onBlur?: (context: {
        value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    } & import("..").PopupVisibleChangeContext & {
        inputValue: string;
        tagInputValue?: import("..").TagInputValue;
    }) => void;
    onFocus?: (context: {
        value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
        e: FocusEvent;
    }) => void;
    collapsedItems?: (h: import("vue").CreateElement, props: {
        value: import("..").TreeOptionData<string | number>[];
        collapsedSelectedItems: import("..").TreeOptionData<string | number>[];
        count: number;
        onClose: (context: {
            index: number;
            e?: MouseEvent;
        }) => void;
    }) => import("vue/types/vnode").ScopedSlotReturnValue;
    inputProps?: unknown;
    tagProps?: unknown;
    valueDisplay?: string | ((h: import("vue").CreateElement, props: {
        value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
        onClose: (index: number) => void;
        displayValue?: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
        selectedOptions: import("..").TreeOptionData<string | number>[];
    }) => import("vue/types/vnode").ScopedSlotReturnValue);
    onRemove?: (context: import("./type").RemoveContext<import("..").TreeOptionData<string | number>>) => void;
    popupProps?: unknown;
    tagInputProps?: unknown;
    onPopupVisibleChange?: (visible: boolean, context: import("..").PopupVisibleChangeContext) => void;
    loadingText?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    selectInputProps?: unknown;
    checkProps?: unknown;
}, import("@vue/composition-api").ShallowUnwrapRef<{
    cascaderContext: import("@vue/composition-api").ComputedRef<{
        setTreeNodes: (nodes: import("./interface").TreeNode[]) => void;
        setValue: (val: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>, source: import("./type").CascaderChangeSource, node?: import("..").TreeNodeModel<import("..").TreeOptionData<string | number>>) => void;
        setVisible: (visible: boolean, context: import("..").PopupVisibleChangeContext) => void;
        setInputVal: (val: string) => void;
        setExpend: (val: import("./interface").TreeNodeValue[]) => void;
        treeStore: any;
        inputVal: any;
        scopeVal: any;
        treeNodes: any[];
        expend: any[];
        value: any;
        size: import("..").SizeEnum;
        checkStrictly: boolean;
        lazy: boolean;
        multiple: boolean;
        filterable: boolean;
        clearable: boolean;
        checkProps: import("..").TdCheckboxProps;
        max: number;
        disabled: boolean;
        showAllLevels: boolean;
        minCollapsedNum: number;
        valueType: "full" | "single";
        visible: boolean;
        cascaderValue: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    }>;
    slots: Readonly<{
        [name: string]: (...args: any[]) => import("vue").VNode[];
    }>;
    onClick: (value: string, node: import("./interface").TreeNode) => void;
}>, import("@vue/composition-api").Data, {}, {}, {}, {}, {}, {
    max: number;
    value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    loading: boolean;
    autofocus: boolean;
    lazy: boolean;
    disabled: boolean;
    multiple: boolean;
    options: import("..").TreeOptionData<string | number>[];
    size: import("..").SizeEnum;
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    defaultValue: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    trigger: "click" | "hover";
    borderless: boolean;
    clearable: boolean;
    placeholder: string;
    minCollapsedNum: number;
    popupVisible: boolean;
    reserveKeyword: boolean;
    valueType: "full" | "single";
    filterable: boolean;
    checkStrictly: boolean;
    valueMode: "all" | "onlyLeaf" | "parentFirst";
    showAllLevels: boolean;
} & {
    filter?: (filterWords: string, node: import("..").TreeNodeModel<import("..").TreeOptionData<string | number>>) => boolean | Promise<boolean>;
    keys?: unknown;
    label?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    option?: (h: import("vue").CreateElement, props: {
        item: import("..").TreeOptionData<string | number>;
        index: number;
    }) => import("vue/types/vnode").ScopedSlotReturnValue;
    load?: (node: import("..").TreeNodeModel<import("..").TreeOptionData<string | number>>) => Promise<import("..").TreeOptionData<string | number>[]>;
    empty?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onChange?: (value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>, context: import("./type").CascaderChangeContext<import("..").TreeOptionData<string | number>>) => void;
    suffix?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    suffixIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onBlur?: (context: {
        value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    } & import("..").PopupVisibleChangeContext & {
        inputValue: string;
        tagInputValue?: import("..").TagInputValue;
    }) => void;
    onFocus?: (context: {
        value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
        e: FocusEvent;
    }) => void;
    collapsedItems?: (h: import("vue").CreateElement, props: {
        value: import("..").TreeOptionData<string | number>[];
        collapsedSelectedItems: import("..").TreeOptionData<string | number>[];
        count: number;
        onClose: (context: {
            index: number;
            e?: MouseEvent;
        }) => void;
    }) => import("vue/types/vnode").ScopedSlotReturnValue;
    inputProps?: unknown;
    tagProps?: unknown;
    valueDisplay?: string | ((h: import("vue").CreateElement, props: {
        value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
        onClose: (index: number) => void;
        displayValue?: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
        selectedOptions: import("..").TreeOptionData<string | number>[];
    }) => import("vue/types/vnode").ScopedSlotReturnValue);
    onRemove?: (context: import("./type").RemoveContext<import("..").TreeOptionData<string | number>>) => void;
    popupProps?: unknown;
    tagInputProps?: unknown;
    onPopupVisibleChange?: (visible: boolean, context: import("..").PopupVisibleChangeContext) => void;
    loadingText?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    selectInputProps?: unknown;
    checkProps?: unknown;
}, {
    max: number;
    value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    loading: boolean;
    autofocus: boolean;
    lazy: boolean;
    disabled: boolean;
    multiple: boolean;
    options: import("..").TreeOptionData<string | number>[];
    size: import("..").SizeEnum;
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    defaultValue: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    trigger: "click" | "hover";
    borderless: boolean;
    clearable: boolean;
    placeholder: string;
    minCollapsedNum: number;
    popupVisible: boolean;
    reserveKeyword: boolean;
    valueType: "full" | "single";
    filterable: boolean;
    checkStrictly: boolean;
    valueMode: "all" | "onlyLeaf" | "parentFirst";
    showAllLevels: boolean;
}, true>) & import("vue").PluginObject<import("vue").ComponentOptions<import("vue").default, import("@vue/composition-api").ShallowUnwrapRef<{
    cascaderContext: import("@vue/composition-api").ComputedRef<{
        setTreeNodes: (nodes: import("./interface").TreeNode[]) => void;
        setValue: (val: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>, source: import("./type").CascaderChangeSource, node?: import("..").TreeNodeModel<import("..").TreeOptionData<string | number>>) => void;
        setVisible: (visible: boolean, context: import("..").PopupVisibleChangeContext) => void;
        setInputVal: (val: string) => void;
        setExpend: (val: import("./interface").TreeNodeValue[]) => void;
        treeStore: any;
        inputVal: any;
        scopeVal: any;
        treeNodes: any[];
        expend: any[];
        value: any;
        size: import("..").SizeEnum;
        checkStrictly: boolean;
        lazy: boolean;
        multiple: boolean;
        filterable: boolean;
        clearable: boolean;
        checkProps: import("..").TdCheckboxProps;
        max: number;
        disabled: boolean;
        showAllLevels: boolean;
        minCollapsedNum: number;
        valueType: "full" | "single";
        visible: boolean;
        cascaderValue: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    }>;
    slots: Readonly<{
        [name: string]: (...args: any[]) => import("vue").VNode[];
    }>;
    onClick: (value: string, node: import("./interface").TreeNode) => void;
}> & import("@vue/composition-api").Data, {}, {}, {
    autofocus: BooleanConstructor;
    borderless: BooleanConstructor;
    checkProps: {
        type: import("vue").PropType<import("..").TdCheckboxProps>;
    };
    checkStrictly: BooleanConstructor;
    clearable: BooleanConstructor;
    collapsedItems: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: {
            value: import("..").TreeOptionData<string | number>[];
            collapsedSelectedItems: import("..").TreeOptionData<string | number>[];
            count: number;
            onClose: (context: {
                index: number;
                e?: MouseEvent;
            }) => void;
        }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    disabled: BooleanConstructor;
    empty: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    filter: {
        type: import("vue").PropType<(filterWords: string, node: import("..").TreeNodeModel<import("..").TreeOptionData<string | number>>) => boolean | Promise<boolean>>;
    };
    filterable: BooleanConstructor;
    inputProps: {
        type: import("vue").PropType<import("..").InputProps<import("..").InputValue>>;
    };
    keys: {
        type: import("vue").PropType<import("..").TreeKeysType>;
    };
    label: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    lazy: {
        type: BooleanConstructor;
        default: boolean;
    };
    load: {
        type: import("vue").PropType<(node: import("..").TreeNodeModel<import("..").TreeOptionData<string | number>>) => Promise<import("..").TreeOptionData<string | number>[]>>;
    };
    loading: BooleanConstructor;
    loadingText: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    max: {
        type: NumberConstructor;
        default: number;
    };
    minCollapsedNum: {
        type: NumberConstructor;
        default: number;
    };
    multiple: BooleanConstructor;
    option: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: {
            item: import("..").TreeOptionData<string | number>;
            index: number;
        }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    options: {
        type: import("vue").PropType<import("..").TreeOptionData<string | number>[]>;
        default: () => import("..").TreeOptionData<string | number>[];
    };
    placeholder: {
        type: StringConstructor;
        default: any;
    };
    popupProps: {
        type: import("vue").PropType<import("..").TdPopupProps>;
    };
    popupVisible: BooleanConstructor;
    readonly: BooleanConstructor;
    reserveKeyword: BooleanConstructor;
    selectInputProps: {
        type: import("vue").PropType<import("..").TdSelectInputProps>;
    };
    showAllLevels: {
        type: BooleanConstructor;
        default: boolean;
    };
    size: {
        type: import("vue").PropType<import("..").SizeEnum>;
        default: import("..").SizeEnum;
        validator(val: import("..").SizeEnum): boolean;
    };
    status: {
        type: import("vue").PropType<"error" | "default" | "success" | "warning">;
        default: "error" | "default" | "success" | "warning";
        validator(val: "error" | "default" | "success" | "warning"): boolean;
    };
    suffix: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    suffixIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    tagInputProps: {
        type: import("vue").PropType<import("..").TdTagInputProps>;
    };
    tagProps: {
        type: import("vue").PropType<import("..").TdTagProps>;
    };
    tips: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    trigger: {
        type: import("vue").PropType<"click" | "hover">;
        default: "click" | "hover";
        validator(val: "click" | "hover"): boolean;
    };
    value: {
        type: import("vue").PropType<import("./type").CascaderValue<import("..").TreeOptionData<string | number>>>;
        default: () => import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    };
    defaultValue: {
        type: import("vue").PropType<import("./type").CascaderValue<import("..").TreeOptionData<string | number>>>;
        default: () => import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    };
    valueDisplay: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement, props: {
            value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
            onClose: (index: number) => void;
            displayValue?: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
            selectedOptions: import("..").TreeOptionData<string | number>[];
        }) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    valueMode: {
        type: import("vue").PropType<"all" | "onlyLeaf" | "parentFirst">;
        default: "all" | "onlyLeaf" | "parentFirst";
        validator(val: "all" | "onlyLeaf" | "parentFirst"): boolean;
    };
    valueType: {
        type: import("vue").PropType<"full" | "single">;
        default: "full" | "single";
        validator(val: "full" | "single"): boolean;
    };
    onBlur: import("vue").PropType<(context: {
        value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    } & import("..").PopupVisibleChangeContext & {
        inputValue: string;
        tagInputValue?: import("..").TagInputValue;
    }) => void>;
    onChange: import("vue").PropType<(value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>, context: import("./type").CascaderChangeContext<import("..").TreeOptionData<string | number>>) => void>;
    onFocus: import("vue").PropType<(context: {
        value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
        e: FocusEvent;
    }) => void>;
    onPopupVisibleChange: import("vue").PropType<(visible: boolean, context: import("..").PopupVisibleChangeContext) => void>;
    onRemove: import("vue").PropType<(context: import("./type").RemoveContext<import("..").TreeOptionData<string | number>>) => void>;
}, import("@vue/composition-api").ExtractPropTypes<{
    autofocus: BooleanConstructor;
    borderless: BooleanConstructor;
    checkProps: {
        type: import("vue").PropType<import("..").TdCheckboxProps>;
    };
    checkStrictly: BooleanConstructor;
    clearable: BooleanConstructor;
    collapsedItems: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: {
            value: import("..").TreeOptionData<string | number>[];
            collapsedSelectedItems: import("..").TreeOptionData<string | number>[];
            count: number;
            onClose: (context: {
                index: number;
                e?: MouseEvent;
            }) => void;
        }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    disabled: BooleanConstructor;
    empty: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    filter: {
        type: import("vue").PropType<(filterWords: string, node: import("..").TreeNodeModel<import("..").TreeOptionData<string | number>>) => boolean | Promise<boolean>>;
    };
    filterable: BooleanConstructor;
    inputProps: {
        type: import("vue").PropType<import("..").InputProps<import("..").InputValue>>;
    };
    keys: {
        type: import("vue").PropType<import("..").TreeKeysType>;
    };
    label: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    lazy: {
        type: BooleanConstructor;
        default: boolean;
    };
    load: {
        type: import("vue").PropType<(node: import("..").TreeNodeModel<import("..").TreeOptionData<string | number>>) => Promise<import("..").TreeOptionData<string | number>[]>>;
    };
    loading: BooleanConstructor;
    loadingText: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    max: {
        type: NumberConstructor;
        default: number;
    };
    minCollapsedNum: {
        type: NumberConstructor;
        default: number;
    };
    multiple: BooleanConstructor;
    option: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: {
            item: import("..").TreeOptionData<string | number>;
            index: number;
        }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    options: {
        type: import("vue").PropType<import("..").TreeOptionData<string | number>[]>;
        default: () => import("..").TreeOptionData<string | number>[];
    };
    placeholder: {
        type: StringConstructor;
        default: any;
    };
    popupProps: {
        type: import("vue").PropType<import("..").TdPopupProps>;
    };
    popupVisible: BooleanConstructor;
    readonly: BooleanConstructor;
    reserveKeyword: BooleanConstructor;
    selectInputProps: {
        type: import("vue").PropType<import("..").TdSelectInputProps>;
    };
    showAllLevels: {
        type: BooleanConstructor;
        default: boolean;
    };
    size: {
        type: import("vue").PropType<import("..").SizeEnum>;
        default: import("..").SizeEnum;
        validator(val: import("..").SizeEnum): boolean;
    };
    status: {
        type: import("vue").PropType<"error" | "default" | "success" | "warning">;
        default: "error" | "default" | "success" | "warning";
        validator(val: "error" | "default" | "success" | "warning"): boolean;
    };
    suffix: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    suffixIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    tagInputProps: {
        type: import("vue").PropType<import("..").TdTagInputProps>;
    };
    tagProps: {
        type: import("vue").PropType<import("..").TdTagProps>;
    };
    tips: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    trigger: {
        type: import("vue").PropType<"click" | "hover">;
        default: "click" | "hover";
        validator(val: "click" | "hover"): boolean;
    };
    value: {
        type: import("vue").PropType<import("./type").CascaderValue<import("..").TreeOptionData<string | number>>>;
        default: () => import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    };
    defaultValue: {
        type: import("vue").PropType<import("./type").CascaderValue<import("..").TreeOptionData<string | number>>>;
        default: () => import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    };
    valueDisplay: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement, props: {
            value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
            onClose: (index: number) => void;
            displayValue?: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
            selectedOptions: import("..").TreeOptionData<string | number>[];
        }) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    valueMode: {
        type: import("vue").PropType<"all" | "onlyLeaf" | "parentFirst">;
        default: "all" | "onlyLeaf" | "parentFirst";
        validator(val: "all" | "onlyLeaf" | "parentFirst"): boolean;
    };
    valueType: {
        type: import("vue").PropType<"full" | "single">;
        default: "full" | "single";
        validator(val: "full" | "single"): boolean;
    };
    onBlur: import("vue").PropType<(context: {
        value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    } & import("..").PopupVisibleChangeContext & {
        inputValue: string;
        tagInputValue?: import("..").TagInputValue;
    }) => void>;
    onChange: import("vue").PropType<(value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>, context: import("./type").CascaderChangeContext<import("..").TreeOptionData<string | number>>) => void>;
    onFocus: import("vue").PropType<(context: {
        value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
        e: FocusEvent;
    }) => void>;
    onPopupVisibleChange: import("vue").PropType<(visible: boolean, context: import("..").PopupVisibleChangeContext) => void>;
    onRemove: import("vue").PropType<(context: import("./type").RemoveContext<import("..").TreeOptionData<string | number>>) => void>;
}>> & Omit<import("vue").VueConstructor<import("vue").default>, never> & (new (...args: any[]) => import("@vue/composition-api").ComponentRenderProxy<{
    max: number;
    value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    loading: boolean;
    autofocus: boolean;
    lazy: boolean;
    disabled: boolean;
    multiple: boolean;
    options: import("..").TreeOptionData<string | number>[];
    size: import("..").SizeEnum;
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    defaultValue: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    trigger: "click" | "hover";
    borderless: boolean;
    clearable: boolean;
    placeholder: string;
    minCollapsedNum: number;
    popupVisible: boolean;
    reserveKeyword: boolean;
    valueType: "full" | "single";
    filterable: boolean;
    checkStrictly: boolean;
    valueMode: "all" | "onlyLeaf" | "parentFirst";
    showAllLevels: boolean;
} & {
    filter?: (filterWords: string, node: import("..").TreeNodeModel<import("..").TreeOptionData<string | number>>) => boolean | Promise<boolean>;
    keys?: unknown;
    label?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    option?: (h: import("vue").CreateElement, props: {
        item: import("..").TreeOptionData<string | number>;
        index: number;
    }) => import("vue/types/vnode").ScopedSlotReturnValue;
    load?: (node: import("..").TreeNodeModel<import("..").TreeOptionData<string | number>>) => Promise<import("..").TreeOptionData<string | number>[]>;
    empty?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onChange?: (value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>, context: import("./type").CascaderChangeContext<import("..").TreeOptionData<string | number>>) => void;
    suffix?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    suffixIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onBlur?: (context: {
        value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    } & import("..").PopupVisibleChangeContext & {
        inputValue: string;
        tagInputValue?: import("..").TagInputValue;
    }) => void;
    onFocus?: (context: {
        value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
        e: FocusEvent;
    }) => void;
    collapsedItems?: (h: import("vue").CreateElement, props: {
        value: import("..").TreeOptionData<string | number>[];
        collapsedSelectedItems: import("..").TreeOptionData<string | number>[];
        count: number;
        onClose: (context: {
            index: number;
            e?: MouseEvent;
        }) => void;
    }) => import("vue/types/vnode").ScopedSlotReturnValue;
    inputProps?: unknown;
    tagProps?: unknown;
    valueDisplay?: string | ((h: import("vue").CreateElement, props: {
        value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
        onClose: (index: number) => void;
        displayValue?: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
        selectedOptions: import("..").TreeOptionData<string | number>[];
    }) => import("vue/types/vnode").ScopedSlotReturnValue);
    onRemove?: (context: import("./type").RemoveContext<import("..").TreeOptionData<string | number>>) => void;
    popupProps?: unknown;
    tagInputProps?: unknown;
    onPopupVisibleChange?: (visible: boolean, context: import("..").PopupVisibleChangeContext) => void;
    loadingText?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    selectInputProps?: unknown;
    checkProps?: unknown;
}, import("@vue/composition-api").ShallowUnwrapRef<{
    cascaderContext: import("@vue/composition-api").ComputedRef<{
        setTreeNodes: (nodes: import("./interface").TreeNode[]) => void;
        setValue: (val: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>, source: import("./type").CascaderChangeSource, node?: import("..").TreeNodeModel<import("..").TreeOptionData<string | number>>) => void;
        setVisible: (visible: boolean, context: import("..").PopupVisibleChangeContext) => void;
        setInputVal: (val: string) => void;
        setExpend: (val: import("./interface").TreeNodeValue[]) => void;
        treeStore: any;
        inputVal: any;
        scopeVal: any;
        treeNodes: any[];
        expend: any[];
        value: any;
        size: import("..").SizeEnum;
        checkStrictly: boolean;
        lazy: boolean;
        multiple: boolean;
        filterable: boolean;
        clearable: boolean;
        checkProps: import("..").TdCheckboxProps;
        max: number;
        disabled: boolean;
        showAllLevels: boolean;
        minCollapsedNum: number;
        valueType: "full" | "single";
        visible: boolean;
        cascaderValue: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    }>;
    slots: Readonly<{
        [name: string]: (...args: any[]) => import("vue").VNode[];
    }>;
    onClick: (value: string, node: import("./interface").TreeNode) => void;
}>, import("@vue/composition-api").Data, {}, {}, {}, {}, {}, {
    max: number;
    value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    loading: boolean;
    autofocus: boolean;
    lazy: boolean;
    disabled: boolean;
    multiple: boolean;
    options: import("..").TreeOptionData<string | number>[];
    size: import("..").SizeEnum;
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    defaultValue: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    trigger: "click" | "hover";
    borderless: boolean;
    clearable: boolean;
    placeholder: string;
    minCollapsedNum: number;
    popupVisible: boolean;
    reserveKeyword: boolean;
    valueType: "full" | "single";
    filterable: boolean;
    checkStrictly: boolean;
    valueMode: "all" | "onlyLeaf" | "parentFirst";
    showAllLevels: boolean;
} & {
    filter?: (filterWords: string, node: import("..").TreeNodeModel<import("..").TreeOptionData<string | number>>) => boolean | Promise<boolean>;
    keys?: unknown;
    label?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    option?: (h: import("vue").CreateElement, props: {
        item: import("..").TreeOptionData<string | number>;
        index: number;
    }) => import("vue/types/vnode").ScopedSlotReturnValue;
    load?: (node: import("..").TreeNodeModel<import("..").TreeOptionData<string | number>>) => Promise<import("..").TreeOptionData<string | number>[]>;
    empty?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onChange?: (value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>, context: import("./type").CascaderChangeContext<import("..").TreeOptionData<string | number>>) => void;
    suffix?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    suffixIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onBlur?: (context: {
        value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    } & import("..").PopupVisibleChangeContext & {
        inputValue: string;
        tagInputValue?: import("..").TagInputValue;
    }) => void;
    onFocus?: (context: {
        value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
        e: FocusEvent;
    }) => void;
    collapsedItems?: (h: import("vue").CreateElement, props: {
        value: import("..").TreeOptionData<string | number>[];
        collapsedSelectedItems: import("..").TreeOptionData<string | number>[];
        count: number;
        onClose: (context: {
            index: number;
            e?: MouseEvent;
        }) => void;
    }) => import("vue/types/vnode").ScopedSlotReturnValue;
    inputProps?: unknown;
    tagProps?: unknown;
    valueDisplay?: string | ((h: import("vue").CreateElement, props: {
        value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
        onClose: (index: number) => void;
        displayValue?: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
        selectedOptions: import("..").TreeOptionData<string | number>[];
    }) => import("vue/types/vnode").ScopedSlotReturnValue);
    onRemove?: (context: import("./type").RemoveContext<import("..").TreeOptionData<string | number>>) => void;
    popupProps?: unknown;
    tagInputProps?: unknown;
    onPopupVisibleChange?: (visible: boolean, context: import("..").PopupVisibleChangeContext) => void;
    loadingText?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    selectInputProps?: unknown;
    checkProps?: unknown;
}, {
    max: number;
    value: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    loading: boolean;
    autofocus: boolean;
    lazy: boolean;
    disabled: boolean;
    multiple: boolean;
    options: import("..").TreeOptionData<string | number>[];
    size: import("..").SizeEnum;
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    defaultValue: import("./type").CascaderValue<import("..").TreeOptionData<string | number>>;
    trigger: "click" | "hover";
    borderless: boolean;
    clearable: boolean;
    placeholder: string;
    minCollapsedNum: number;
    popupVisible: boolean;
    reserveKeyword: boolean;
    valueType: "full" | "single";
    filterable: boolean;
    checkStrictly: boolean;
    valueMode: "all" | "onlyLeaf" | "parentFirst";
    showAllLevels: boolean;
}, true>)>;
export default Cascader;
