/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var VueCompositionAPI = require('@vue/composition-api');
var colorPicker_props = require('../props.js');
var _common_js_colorPicker_constants = require('../../_common/js/color-picker/constants.js');
var radio_index = require('../../radio/index.js');
var colorPicker_hooks = require('../hooks.js');
var configProvider_useConfig = require('../../config-provider/useConfig.js');
require('../../radio/radio.js');
require('../../_chunks/dep-ece3c062.js');
require('vue');
require('../../utils/helper.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/slicedToArray');
require('../../_chunks/dep-7c854ec6.js');
require('../../_chunks/dep-eceed11d.js');
require('../../_chunks/dep-201f7798.js');
require('../../_chunks/dep-a4308f57.js');
require('@babel/runtime/helpers/typeof');
require('../../_chunks/dep-fcf0662d.js');
require('../../_chunks/dep-d3015b4c.js');
require('../../_chunks/dep-e4278c54.js');
require('../../_chunks/dep-f8a85d6a.js');
require('../../_chunks/dep-5b117689.js');
require('../../_chunks/dep-6478392e.js');
require('../../utils/render-tnode.js');
require('@babel/runtime/helpers/readOnlyError');
require('../../_chunks/dep-47bca35e.js');
require('../../radio/props.js');
require('../../utils/event.js');
require('../../config-provider/config-receiver.js');
require('../../_chunks/dep-07fb8c0e.js');
require('../../_common/js/global-config/default-config.js');
require('../../_common/js/global-config/locale/zh_CN.js');
require('../../_chunks/dep-a4a18104.js');
require('../../_chunks/dep-27dd8cc6.js');
require('dayjs');
require('../../_chunks/dep-87c765cc.js');
require('../../_chunks/dep-75cd6d52.js');
require('../../_chunks/dep-b1a02818.js');
require('../../_chunks/dep-3d8ab37d.js');
require('../../_chunks/dep-ecccff93.js');
require('../../_chunks/dep-a4cecac4.js');
require('../../_chunks/dep-ab142eaf.js');
require('../../_chunks/dep-6ad3de7c.js');
require('../../_chunks/dep-8b1e056e.js');
require('../../_chunks/dep-5db8defc.js');
require('../../_chunks/dep-6e4c473c.js');
require('../../_chunks/dep-234b7c02.js');
require('../../_chunks/dep-a4747856.js');
require('../../_chunks/dep-932dd69e.js');
require('../../_chunks/dep-9f4caea4.js');
require('../../_chunks/dep-dbd838d6.js');
require('../../_chunks/dep-b3120c1b.js');
require('../../_chunks/dep-68ba2357.js');
require('../../_chunks/dep-173eb46c.js');
require('../../utils/mixins.js');
require('../../radio/group.js');
require('../../radio/radio-group-props.js');
require('../../radio/radio-button.js');
require('../../utils/dom.js');
require('raf');
require('../../utils/easing.js');
require('../../_chunks/dep-738b4f21.js');
require('../../_common/js/common.js');
require('../../_chunks/dep-aa0a4aac.js');
require('../../utils/map-props.js');
require('../../utils/withInstall.js');
require('../../hooks/useConfig.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var PanelHeader = VueCompositionAPI.defineComponent({
  name: "PanelHeader",
  components: {
    TRadioGroup: radio_index.RadioGroup,
    TRadioButton: radio_index.RadioButton
  },
  props: _objectSpread(_objectSpread({}, colorPicker_props["default"]), {}, {
    mode: {
      type: String,
      "default": "color"
    },
    togglePopup: {
      type: Function
    },
    handleModeChange: {
      type: Function,
      "default": function _default() {
        return function () {};
      }
    }
  }),
  setup: function setup(props2) {
    var _useConfig = configProvider_useConfig.useConfig("colorPicker"),
      globalConfig = _useConfig.globalConfig;
    var baseClassName = colorPicker_hooks.useBaseClassName();
    var modeValue = VueCompositionAPI.ref(props2.mode);
    VueCompositionAPI.watch(function () {
      return props2.mode;
    }, function (v) {
      modeValue.value = v;
    });
    return {
      globalConfig: globalConfig,
      baseClassName: baseClassName,
      modeValue: modeValue
    };
  },
  render: function render() {
    var _this$colorModes,
      _this = this;
    var h = arguments[0];
    if (((_this$colorModes = this.colorModes) === null || _this$colorModes === void 0 ? void 0 : _this$colorModes.length) === 1) {
      return null;
    }
    var baseClassName = this.baseClassName;
    return h("div", {
      "class": "".concat(baseClassName, "__head")
    }, [h("div", {
      "class": "".concat(baseClassName, "__mode")
    }, [h("t-radio-group", {
      "attrs": {
        "variant": "default-filled",
        "size": "small",
        "disabled": this.disabled
      },
      "on": {
        "change": this.handleModeChange
      },
      "model": {
        value: _this.modeValue,
        callback: function callback($$v) {
          _this.modeValue = $$v;
        }
      }
    }, [this.colorModes.map(function (key) {
      return h("t-radio-button", {
        "key": key,
        "attrs": {
          "value": key
        }
      }, [Reflect.get(_this.globalConfig, _common_js_colorPicker_constants.COLOR_MODES[key])]);
    })])])]);
  }
});

exports["default"] = PanelHeader;
//# sourceMappingURL=header.js.map
