/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _toConsumableArray = require('@babel/runtime/helpers/toConsumableArray');
var _slicedToArray = require('@babel/runtime/helpers/slicedToArray');
var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var VueCompositionAPI = require('@vue/composition-api');
var configProvider_useConfig = require('../../config-provider/useConfig.js');
var hooks_useCommonClassName = require('../../hooks/useCommonClassName.js');
var colorPicker_props = require('../props.js');
var _common_js_colorPicker_constants = require('../../_common/js/color-picker/constants.js');
var colorPicker_panel_header = require('./header.js');
var colorPicker_panel_linearGradient = require('./linear-gradient.js');
var colorPicker_panel_saturation = require('./saturation.js');
var colorPicker_panel_hue = require('./hue.js');
var colorPicker_panel_alpha = require('./alpha.js');
var colorPicker_panel_format_index = require('./format/index.js');
var colorPicker_panel_swatches = require('./swatches.js');
var colorPicker_hooks = require('../hooks.js');
var hooks_useVModel = require('../../hooks/useVModel.js');
var hooks_useDefaultValue = require('../../hooks/useDefaultValue.js');
var _common_js_colorPicker_color = require('../../_common/js/color-picker/color.js');
require('../../_chunks/dep-07fb8c0e.js');
require('../../_common/js/global-config/default-config.js');
require('../../_common/js/global-config/locale/zh_CN.js');
require('../../_chunks/dep-a4a18104.js');
require('@babel/runtime/helpers/typeof');
require('../../_chunks/dep-27dd8cc6.js');
require('dayjs');
require('../../_chunks/dep-87c765cc.js');
require('../../_chunks/dep-75cd6d52.js');
require('../../_chunks/dep-b1a02818.js');
require('../../_chunks/dep-3d8ab37d.js');
require('../../_chunks/dep-ecccff93.js');
require('../../_chunks/dep-a4308f57.js');
require('../../_chunks/dep-a4cecac4.js');
require('../../_chunks/dep-ab142eaf.js');
require('../../_chunks/dep-6ad3de7c.js');
require('../../_chunks/dep-e4278c54.js');
require('../../_chunks/dep-fcf0662d.js');
require('../../_chunks/dep-8b1e056e.js');
require('../../_chunks/dep-5db8defc.js');
require('../../_chunks/dep-6e4c473c.js');
require('../../_chunks/dep-234b7c02.js');
require('../../_chunks/dep-a4747856.js');
require('../../_chunks/dep-932dd69e.js');
require('../../_chunks/dep-9f4caea4.js');
require('../../_chunks/dep-dbd838d6.js');
require('../../_chunks/dep-b3120c1b.js');
require('../../_chunks/dep-68ba2357.js');
require('../../_chunks/dep-173eb46c.js');
require('../../radio/index.js');
require('../../radio/radio.js');
require('../../_chunks/dep-ece3c062.js');
require('vue');
require('../../utils/helper.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('../../_chunks/dep-7c854ec6.js');
require('../../_chunks/dep-eceed11d.js');
require('../../_chunks/dep-201f7798.js');
require('../../_chunks/dep-d3015b4c.js');
require('../../_chunks/dep-f8a85d6a.js');
require('../../_chunks/dep-5b117689.js');
require('../../_chunks/dep-6478392e.js');
require('../../utils/render-tnode.js');
require('@babel/runtime/helpers/readOnlyError');
require('../../_chunks/dep-47bca35e.js');
require('../../radio/props.js');
require('../../utils/event.js');
require('../../config-provider/config-receiver.js');
require('../../utils/mixins.js');
require('../../radio/group.js');
require('../../radio/radio-group-props.js');
require('../../radio/radio-button.js');
require('../../utils/dom.js');
require('raf');
require('../../utils/easing.js');
require('../../_chunks/dep-738b4f21.js');
require('../../_common/js/common.js');
require('../../_chunks/dep-aa0a4aac.js');
require('../../utils/map-props.js');
require('../../utils/withInstall.js');
require('../../input-number/index.js');
require('../../input-number/input-number.js');
require('tdesign-icons-vue');
require('../../button/index.js');
require('../../button/button.js');
require('../../loading/index.js');
require('../../loading/directive.js');
require('../../loading/plugin.js');
require('../../loading/loading.js');
require('../../loading/icon/gradient.js');
require('../../_common/js/loading/circle-adapter.js');
require('../../_common/js/utils/setStyle.js');
require('../../_common/js/utils/helper.js');
require('../../_chunks/dep-62de1188.js');
require('../../_chunks/dep-867c284e.js');
require('../../utils/transfer-dom.js');
require('../../loading/props.js');
require('../../config.js');
require('../../_chunks/dep-013a3403.js');
require('../../_chunks/dep-8cb0d589.js');
require('../../_chunks/dep-d23147db.js');
require('../../_chunks/dep-de60f5aa.js');
require('../../_chunks/dep-63b02f7b.js');
require('../../_chunks/dep-bebcd284.js');
require('../../_chunks/dep-3eec664c.js');
require('../../_chunks/dep-eeb2e214.js');
require('../../_chunks/dep-315a67f0.js');
require('../../_chunks/dep-f84d1ea5.js');
require('../../_chunks/dep-362bc4d7.js');
require('../../_chunks/dep-2e32c1f2.js');
require('../../_chunks/dep-f14aac54.js');
require('../../button/props.js');
require('../../utils/ripple.js');
require('../../input/index.js');
require('../../input/input.js');
require('../../input/props.js');
require('../../_common/js/log/log.js');
require('../../input/input-group.js');
require('../../input-number/props.js');
require('../../input-number/useInputNumber.js');
require('../../_common/js/input-number/number.js');
require('../../_common/js/input-number/large-number.js');
require('../../hooks/useFormDisabled.js');
require('../../hooks/useGlobalIcon.js');
require('./base-props.js');
require('../../_chunks/dep-f45125c9.js');
require('../../_chunks/dep-f33eb57d.js');
require('../../select/index.js');
require('../../select/select.js');
require('../../hooks/tnode.js');
require('../../hooks/render-tnode.js');
require('../../_chunks/dep-a6490a32.js');
require('../../select/props.js');
require('../../popup/index.js');
require('../../popup/popup.js');
require('@popperjs/core');
require('../../popup/props.js');
require('../../popup/container.js');
require('../../popup/utils.js');
require('../../_chunks/dep-f3761329.js');
require('../../_chunks/dep-848a5a32.js');
require('../../popup/plugin.js');
require('../../tag/index.js');
require('../../tag/tag.js');
require('tinycolor2');
require('../../tag/props.js');
require('../../tag/check-tag.js');
require('../../tag/check-tag-props.js');
require('../../hooks/useConfig.js');
require('../../tag/check-tag-group.js');
require('../../tag/check-tag-group-props.js');
require('../../select-input/index.js');
require('../../select-input/select-input.js');
require('../../select-input/props.js');
require('../../select-input/useSingle.js');
require('../../_chunks/dep-71fa6788.js');
require('../../_chunks/dep-73fb598e.js');
require('../../_chunks/dep-a9e7deb2.js');
require('../../select-input/useMultiple.js');
require('../../tag-input/index.js');
require('../../tag-input/tag-input.js');
require('../../tag-input/props.js');
require('../../tag-input/hooks/useTagScroll.js');
require('../../tag-input/useTagList.js');
require('../../tag-input/hooks/useHover.js');
require('../../tag-input/hooks/useDragSorter.js');
require('../../select-input/useOverlayInnerStyle.js');
require('../../common-components/fake-arrow.js');
require('../../select/option.js');
require('../../select/option-props.js');
require('../../checkbox/index.js');
require('../../checkbox/group.js');
require('../../checkbox/checkbox.js');
require('../../checkbox/props.js');
require('../../checkbox/constants.js');
require('../../checkbox/store.js');
require('@babel/runtime/helpers/classCallCheck');
require('@babel/runtime/helpers/createClass');
require('../../checkbox/hooks/useKeyboardEvent.js');
require('../../hooks/useElementLazyRender.js');
require('../../_common/js/utils/observe.js');
require('../../checkbox/checkbox-group-props.js');
require('../../_chunks/dep-e83685df.js');
require('../../_chunks/dep-502c56be.js');
require('../../hooks/slots.js');
require('../../hooks/useLazyLoad.js');
require('../../select/util.js');
require('../../select/select-panel.js');
require('../../select/optionGroup.js');
require('../../select/option-group-props.js');
require('../../hooks/useVirtualScroll.js');
require('../../select/hooks/useSelectOptions.js');
require('../../_chunks/dep-6dc0a916.js');
require('../../_chunks/dep-b5c96567.js');
require('../../_common/js/color-picker/draggable.js');
require('./slider.js');
require('./format/inputs.js');
require('./format/config.js');
require('../../_chunks/dep-13309278.js');
require('../../_common/js/color-picker/cmyk.js');
require('../../_common/js/color-picker/gradient.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _toConsumableArray__default = /*#__PURE__*/_interopDefaultLegacy(_toConsumableArray);
var _slicedToArray__default = /*#__PURE__*/_interopDefaultLegacy(_slicedToArray);
var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var ColorPanel = VueCompositionAPI.defineComponent({
  name: "ColorPanel",
  components: {
    PanelHeader: colorPicker_panel_header["default"],
    LinearGradient: colorPicker_panel_linearGradient["default"],
    SaturationPanel: colorPicker_panel_saturation["default"],
    HueSlider: colorPicker_panel_hue["default"],
    AlphaSlider: colorPicker_panel_alpha["default"],
    FormatPanel: colorPicker_panel_format_index["default"],
    SwatchesPanel: colorPicker_panel_swatches["default"]
  },
  props: _objectSpread(_objectSpread({}, colorPicker_props["default"]), {}, {
    togglePopup: {
      type: Function
    }
  }),
  setup: function setup(props2) {
    var _props2$colorModes;
    var baseClassName = colorPicker_hooks.useBaseClassName();
    var _useCommonClassName = hooks_useCommonClassName["default"](),
      statusClassNames = _useCommonClassName.statusClassNames;
    var _useConfig = configProvider_useConfig.useConfig("colorPicker"),
      t = _useConfig.t,
      global = _useConfig.global;
    var _toRefs = VueCompositionAPI.toRefs(props2),
      inputValue = _toRefs.value,
      recentColors = _toRefs.recentColors;
    var _useVModel = hooks_useVModel.useVModel(inputValue, props2.defaultValue, props2.onChange, "change"),
      _useVModel2 = _slicedToArray__default["default"](_useVModel, 2),
      innerValue = _useVModel2[0],
      setInnerValue = _useVModel2[1];
    var defaultEmptyColor = VueCompositionAPI.computed(function () {
      return isGradient.value ? _common_js_colorPicker_constants.DEFAULT_LINEAR_GRADIENT : _common_js_colorPicker_constants.DEFAULT_COLOR;
    });
    var mode = VueCompositionAPI.ref(((_props2$colorModes = props2.colorModes) === null || _props2$colorModes === void 0 ? void 0 : _props2$colorModes.length) === 1 ? props2.colorModes[0] : "monochrome");
    var isGradient = VueCompositionAPI.computed(function () {
      return mode.value === "linear-gradient";
    });
    var color = VueCompositionAPI.ref(new _common_js_colorPicker_color.Color(innerValue.value || defaultEmptyColor.value));
    var updateColor = function updateColor() {
      return color.value.update(innerValue.value || defaultEmptyColor.value);
    };
    var formatModel = VueCompositionAPI.ref(color.value.isGradient ? "CSS" : "RGB");
    var _useDefaultValue = hooks_useDefaultValue["default"](recentColors, props2.defaultRecentColors, props2.onRecentColorsChange, "recentColors", "recentColorsChange"),
      _useDefaultValue2 = _slicedToArray__default["default"](_useDefaultValue, 2),
      recentlyUsedColors = _useDefaultValue2[0],
      setRecentlyUsedColors = _useDefaultValue2[1];
    var formatValue = function formatValue() {
      if (mode.value === "linear-gradient") {
        return color.value.linearGradient;
      }
      return color.value.getFormatsColorMap()[props2.format] || color.value.css;
    };
    var addRecentlyUsedColor = function addRecentlyUsedColor() {
      if (recentlyUsedColors.value === null || recentlyUsedColors.value === false) {
        return;
      }
      var colors = recentlyUsedColors.value || [];
      var currentColor = color.value.isGradient ? color.value.linearGradient : color.value.rgba;
      var index = colors.indexOf(currentColor);
      if (index > -1) {
        colors.splice(index, 1);
      }
      colors.unshift(currentColor);
      if (colors.length > _common_js_colorPicker_constants.TD_COLOR_USED_COLORS_MAX_SIZE) {
        colors.length = _common_js_colorPicker_constants.TD_COLOR_USED_COLORS_MAX_SIZE;
      }
      handleRecentlyUsedColorsChange(colors);
    };
    var handleRecentlyUsedColorsChange = function handleRecentlyUsedColorsChange(colors) {
      recentlyUsedColors.value = colors;
      setRecentlyUsedColors(colors);
    };
    var emitColorChange = function emitColorChange(trigger) {
      setInnerValue(formatValue(), {
        color: _common_js_colorPicker_color.getColorObject(color.value),
        trigger: trigger || "palette-saturation-brightness"
      });
    };
    VueCompositionAPI.watch(function () {
      return [props2.defaultValue, props2.enableAlpha];
    }, updateColor);
    VueCompositionAPI.watch(function () {
      return innerValue.value;
    }, function (newColor) {
      if (newColor !== formatValue()) {
        updateColor();
        mode.value = color.value.isGradient ? "linear-gradient" : "monochrome";
      }
    });
    var handleModeChange = function handleModeChange(value) {
      mode.value = value;
      if (value === "linear-gradient") {
        color.value.update(color.value.gradientColors.length > 0 ? color.value.linearGradient : _common_js_colorPicker_constants.DEFAULT_LINEAR_GRADIENT);
      } else {
        color.value.update(color.value.rgba);
      }
      emitColorChange();
    };
    var handleFormatModeChange = function handleFormatModeChange(format) {
      return formatModel.value = format;
    };
    var handleSatAndValueChange = function handleSatAndValueChange(_ref) {
      var saturation = _ref.saturation,
        value = _ref.value;
      var _color$value = color.value,
        sat = _color$value.saturation,
        val = _color$value.value;
      var changeTrigger = "palette-saturation-brightness";
      if (value !== val && saturation !== sat) {
        color.value.saturation = saturation;
        color.value.value = value;
        changeTrigger = "palette-saturation-brightness";
      } else if (saturation !== sat) {
        color.value.saturation = saturation;
        changeTrigger = "palette-saturation";
      } else if (value !== val) {
        color.value.value = value;
        changeTrigger = "palette-brightness";
      } else {
        return;
      }
      emitColorChange(changeTrigger);
    };
    var handleHueChange = function handleHueChange(hue) {
      var _props2$onPaletteBarC;
      color.value.hue = hue;
      emitColorChange("palette-hue-bar");
      (_props2$onPaletteBarC = props2.onPaletteBarChange) === null || _props2$onPaletteBarC === void 0 || _props2$onPaletteBarC.call(props2, {
        color: _common_js_colorPicker_color.getColorObject(color.value)
      });
    };
    var handleAlphaChange = function handleAlphaChange(alpha) {
      color.value.alpha = alpha;
      emitColorChange("palette-alpha-bar");
    };
    var handleInputChange = function handleInputChange(input, alpha) {
      color.value.update(input);
      color.value.alpha = alpha;
      emitColorChange("input");
    };
    var handleGradientChange = function handleGradientChange(_ref2) {
      var key = _ref2.key,
        payload = _ref2.payload;
      var trigger = "palette-saturation-brightness";
      switch (key) {
        case "degree":
          color.value.gradientDegree = payload;
          trigger = "input";
          break;
        case "selectedId":
          color.value.gradientSelectedId = payload;
          break;
        case "colors":
          color.value.gradientColors = payload;
          break;
      }
      emitColorChange(trigger);
    };
    var handleSetColor = function handleSetColor(type, value) {
      var isGradientValue = _common_js_colorPicker_color.Color.isGradientColor(value);
      if (isGradientValue) {
        if (props2.colorModes.includes("linear-gradient")) {
          mode.value = "linear-gradient";
          color.value.update(value);
          color.value.updateCurrentGradientColor();
        } else {
          console.warn("\u8BE5\u6A21\u5F0F\u4E0D\u652F\u6301\u6E10\u53D8\u8272");
        }
      } else if (mode.value === "linear-gradient") {
        color.value.updateStates(value);
        color.value.updateCurrentGradientColor();
      } else {
        color.value.update(value);
      }
      emitColorChange();
    };
    var previewColorStyle = VueCompositionAPI.computed(function () {
      return mode.value === "linear-gradient" ? color.value.linearGradient : color.value.rgba;
    });
    return {
      baseClassName: baseClassName,
      statusClassNames: statusClassNames,
      t: t,
      global: global,
      color: color,
      mode: mode,
      isGradient: isGradient,
      formatModel: formatModel,
      recentlyUsedColors: recentlyUsedColors,
      previewColorStyle: previewColorStyle,
      addRecentlyUsedColor: addRecentlyUsedColor,
      handleModeChange: handleModeChange,
      handleSatAndValueChange: handleSatAndValueChange,
      handleHueChange: handleHueChange,
      handleAlphaChange: handleAlphaChange,
      handleGradientChange: handleGradientChange,
      handleSetColor: handleSetColor,
      handleFormatModeChange: handleFormatModeChange,
      handleInputChange: handleInputChange,
      handleRecentlyUsedColorsChange: handleRecentlyUsedColorsChange
    };
  },
  render: function render() {
    var _systemColors,
      _this = this;
    var h = arguments[0];
    var baseClassName = this.baseClassName,
      statusClassNames = this.statusClassNames,
      t = this.t,
      global = this.global,
      swatchColors = this.swatchColors,
      previewColorStyle = this.previewColorStyle,
      isGradient = this.isGradient;
    var showUsedColors = this.recentlyUsedColors !== null && this.recentlyUsedColors !== false;
    var systemColors = swatchColors;
    if (systemColors === void 0) {
      systemColors = _toConsumableArray__default["default"](_common_js_colorPicker_constants.DEFAULT_SYSTEM_SWATCH_COLORS);
    }
    var showSystemColors = ((_systemColors = systemColors) === null || _systemColors === void 0 ? void 0 : _systemColors.length) > 0;
    var renderSwatches = function renderSwatches() {
      if (!showSystemColors && !showUsedColors) {
        return null;
      }
      return h("div", {
        "class": "".concat(baseClassName, "__swatches-wrap")
      }, [showUsedColors ? h("swatches-panel", {
        "attrs": {
          "color": _this.color,
          "disabled": _this.disabled,
          "title": t(global.recentColorTitle),
          "editable": true,
          "colors": _this.recentlyUsedColors,
          "handleAddColor": _this.addRecentlyUsedColor,
          "handleSetColor": function handleSetColor(color) {
            _this.handleSetColor("used", color);
          },
          "handleChange": _this.handleRecentlyUsedColorsChange
        }
      }) : null, showSystemColors ? h("swatches-panel", {
        "attrs": {
          "color": _this.color,
          "disabled": _this.disabled,
          "title": t(global.swatchColorTitle),
          "colors": systemColors,
          "handleSetColor": function handleSetColor(color) {
            return _this.handleSetColor("system", color);
          }
        }
      }) : null]);
    };
    return h("div", {
      "class": ["".concat(baseClassName, "__panel"), this.disabled ? statusClassNames.disabled : false]
    }, [h("panel-header", {
      "props": _objectSpread({}, _objectSpread({}, this.$props)),
      "attrs": {
        "mode": this.mode,
        "handleModeChange": this.handleModeChange
      }
    }), h("div", {
      "class": ["".concat(baseClassName, "__body")]
    }, [isGradient ? h("linear-gradient", {
      "attrs": {
        "color": this.color,
        "disabled": this.disabled,
        "handleChange": this.handleGradientChange,
        "enableMultipleGradient": this.enableMultipleGradient
      }
    }) : null, h("saturation-panel", {
      "attrs": {
        "color": this.color,
        "disabled": this.disabled,
        "handleChange": this.handleSatAndValueChange
      }
    }), h("div", {
      "class": ["".concat(baseClassName, "__sliders-wrapper")]
    }, [h("div", {
      "class": ["".concat(baseClassName, "__sliders")]
    }, [h("hue-slider", {
      "attrs": {
        "color": this.color,
        "disabled": this.disabled,
        "handleChange": this.handleHueChange
      }
    }), this.enableAlpha ? h("alpha-slider", {
      "attrs": {
        "color": this.color,
        "disabled": this.disabled,
        "handleChange": this.handleAlphaChange
      }
    }) : null]), this.showPrimaryColorPreview ? h("div", {
      "class": ["".concat(baseClassName, "__sliders-preview"), "".concat(baseClassName, "--bg-alpha")]
    }, [h("span", {
      "class": "".concat(baseClassName, "__sliders-preview-inner"),
      "style": {
        background: previewColorStyle
      }
    })]) : null]), h("format-panel", {
      "props": _objectSpread({}, _objectSpread(_objectSpread({}, this.$props), {}, {
        format: this.formatModel
      })),
      "attrs": {
        "color": this.color,
        "handleFormatModeChange": this.handleFormatModeChange,
        "handleFormatInputChange": this.handleInputChange
      }
    }), renderSwatches()])]);
  }
});

exports["default"] = ColorPanel;
//# sourceMappingURL=index.js.map
