/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var VueCompositionAPI = require('@vue/composition-api');
var tdesignIconsVue = require('tdesign-icons-vue');
var select_index = require('../../select/index.js');
var colorPicker_hooks = require('../hooks.js');
var hooks_useConfig = require('../../hooks/useConfig.js');
var hooks_useGlobalIcon = require('../../hooks/useGlobalIcon.js');
var hooks_useCommonClassName = require('../../hooks/useCommonClassName.js');
var colorPicker_panel_baseProps = require('./base-props.js');
var button_index = require('../../button/index.js');
var configProvider_useConfig = require('../../config-provider/useConfig.js');
var cloneDeep = require('../../_chunks/dep-f45125c9.js');
var _common_js_colorPicker_color = require('../../_common/js/color-picker/color.js');
require('../../select/select.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/toConsumableArray');
require('@babel/runtime/helpers/typeof');
require('@babel/runtime/helpers/slicedToArray');
require('../../hooks/useDefaultValue.js');
require('../../hooks/useVModel.js');
require('../../_chunks/dep-47bca35e.js');
require('../../_chunks/dep-6478392e.js');
require('../../_chunks/dep-201f7798.js');
require('../../_chunks/dep-a4308f57.js');
require('../../_chunks/dep-fcf0662d.js');
require('../../_chunks/dep-d3015b4c.js');
require('../../_chunks/dep-e4278c54.js');
require('../../hooks/tnode.js');
require('../../hooks/render-tnode.js');
require('../../_chunks/dep-a4cecac4.js');
require('../../_chunks/dep-738b4f21.js');
require('../../_chunks/dep-7c854ec6.js');
require('../../_chunks/dep-eceed11d.js');
require('../../_chunks/dep-f8a85d6a.js');
require('../../_chunks/dep-5b117689.js');
require('../../_chunks/dep-ecccff93.js');
require('../../_chunks/dep-a6490a32.js');
require('../../_chunks/dep-3eec664c.js');
require('../../_chunks/dep-8b1e056e.js');
require('../../_chunks/dep-5db8defc.js');
require('../../_chunks/dep-6e4c473c.js');
require('../../_chunks/dep-3d8ab37d.js');
require('../../_chunks/dep-eeb2e214.js');
require('../../_chunks/dep-6ad3de7c.js');
require('../../select/props.js');
require('../../loading/index.js');
require('../../loading/directive.js');
require('../../loading/plugin.js');
require('vue');
require('../../loading/loading.js');
require('../../loading/icon/gradient.js');
require('../../_common/js/loading/circle-adapter.js');
require('../../_common/js/utils/setStyle.js');
require('../../_common/js/utils/helper.js');
require('../../_chunks/dep-62de1188.js');
require('../../_chunks/dep-867c284e.js');
require('../../_chunks/dep-aa0a4aac.js');
require('../../config-provider/config-receiver.js');
require('../../_chunks/dep-07fb8c0e.js');
require('../../_common/js/global-config/default-config.js');
require('../../_common/js/global-config/locale/zh_CN.js');
require('../../_chunks/dep-a4a18104.js');
require('../../_chunks/dep-27dd8cc6.js');
require('dayjs');
require('../../_chunks/dep-87c765cc.js');
require('../../_chunks/dep-75cd6d52.js');
require('../../_chunks/dep-b1a02818.js');
require('../../_chunks/dep-ab142eaf.js');
require('../../_chunks/dep-234b7c02.js');
require('../../_chunks/dep-a4747856.js');
require('../../_chunks/dep-932dd69e.js');
require('../../_chunks/dep-9f4caea4.js');
require('../../_chunks/dep-dbd838d6.js');
require('../../_chunks/dep-b3120c1b.js');
require('../../_chunks/dep-68ba2357.js');
require('../../_chunks/dep-173eb46c.js');
require('../../utils/mixins.js');
require('../../utils/dom.js');
require('raf');
require('../../utils/easing.js');
require('../../utils/render-tnode.js');
require('@babel/runtime/helpers/readOnlyError');
require('../../utils/transfer-dom.js');
require('../../loading/props.js');
require('../../config.js');
require('../../_chunks/dep-013a3403.js');
require('../../_chunks/dep-8cb0d589.js');
require('../../_chunks/dep-d23147db.js');
require('../../_chunks/dep-de60f5aa.js');
require('../../_chunks/dep-63b02f7b.js');
require('../../_chunks/dep-bebcd284.js');
require('../../_chunks/dep-315a67f0.js');
require('../../_chunks/dep-f84d1ea5.js');
require('../../_chunks/dep-362bc4d7.js');
require('../../_chunks/dep-2e32c1f2.js');
require('../../_chunks/dep-f14aac54.js');
require('../../utils/withInstall.js');
require('../../popup/index.js');
require('../../popup/popup.js');
require('@popperjs/core');
require('../../utils/helper.js');
require('../../popup/props.js');
require('../../popup/container.js');
require('../../utils/event.js');
require('../../popup/utils.js');
require('../../_chunks/dep-f3761329.js');
require('../../_chunks/dep-848a5a32.js');
require('../../utils/map-props.js');
require('../../popup/plugin.js');
require('../../_common/js/log/log.js');
require('../../input/index.js');
require('../../input/input.js');
require('../../_chunks/dep-ece3c062.js');
require('../../input/props.js');
require('../../input/input-group.js');
require('../../tag/index.js');
require('../../tag/tag.js');
require('tinycolor2');
require('../../tag/props.js');
require('../../tag/check-tag.js');
require('../../tag/check-tag-props.js');
require('../../_common/js/common.js');
require('../../tag/check-tag-group.js');
require('../../tag/check-tag-group-props.js');
require('../../select-input/index.js');
require('../../select-input/select-input.js');
require('../../select-input/props.js');
require('../../select-input/useSingle.js');
require('../../_chunks/dep-71fa6788.js');
require('../../_chunks/dep-73fb598e.js');
require('../../_chunks/dep-a9e7deb2.js');
require('../../select-input/useMultiple.js');
require('../../tag-input/index.js');
require('../../tag-input/tag-input.js');
require('../../tag-input/props.js');
require('../../tag-input/hooks/useTagScroll.js');
require('../../tag-input/useTagList.js');
require('../../tag-input/hooks/useHover.js');
require('../../tag-input/hooks/useDragSorter.js');
require('../../select-input/useOverlayInnerStyle.js');
require('../../common-components/fake-arrow.js');
require('../../select/option.js');
require('../../utils/ripple.js');
require('../../select/option-props.js');
require('../../checkbox/index.js');
require('../../checkbox/group.js');
require('../../checkbox/checkbox.js');
require('../../checkbox/props.js');
require('../../checkbox/constants.js');
require('../../checkbox/store.js');
require('@babel/runtime/helpers/classCallCheck');
require('@babel/runtime/helpers/createClass');
require('../../checkbox/hooks/useKeyboardEvent.js');
require('../../hooks/useFormDisabled.js');
require('../../hooks/useElementLazyRender.js');
require('../../_common/js/utils/observe.js');
require('../../checkbox/checkbox-group-props.js');
require('../../_chunks/dep-e83685df.js');
require('../../_chunks/dep-502c56be.js');
require('../../hooks/slots.js');
require('../../hooks/useLazyLoad.js');
require('../../select/util.js');
require('../../_chunks/dep-f33eb57d.js');
require('../../select/select-panel.js');
require('../../select/optionGroup.js');
require('../../select/option-group-props.js');
require('../../hooks/useVirtualScroll.js');
require('../../select/hooks/useSelectOptions.js');
require('../../_chunks/dep-6dc0a916.js');
require('../../_chunks/dep-b5c96567.js');
require('../../button/button.js');
require('../../button/props.js');
require('../../_common/js/color-picker/cmyk.js');
require('../../_common/js/color-picker/gradient.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var SwatchesPanel = VueCompositionAPI.defineComponent({
  name: "SwatchesPanel",
  components: {
    TSelect: select_index.Select,
    TOption: select_index.Option,
    TButton: button_index.Button
  },
  props: _objectSpread(_objectSpread({}, colorPicker_panel_baseProps["default"]), {}, {
    colors: {
      type: Array,
      "default": function _default() {
        return [];
      }
    },
    title: {
      type: String,
      "default": "\u7CFB\u7EDF\u8272\u5F69"
    },
    editable: {
      type: Boolean,
      "default": false
    },
    handleSetColor: {
      type: Function,
      "default": function _default() {
        return function () {};
      }
    },
    handleAddColor: {
      type: Function,
      "default": function _default() {
        return function () {};
      }
    }
  }),
  setup: function setup(props) {
    var baseClassName = colorPicker_hooks.useBaseClassName();
    var _useConfig = configProvider_useConfig.useConfig("colorPicker"),
      t = _useConfig.t,
      global = _useConfig.global;
    var _useConfig2 = configProvider_useConfig.useConfig("popconfirm"),
      confirmGlobal = _useConfig2.global;
    var classPrefix = hooks_useConfig.usePrefixClass();
    var _useGlobalIcon = hooks_useGlobalIcon.useGlobalIcon({
        DeleteIcon: tdesignIconsVue.DeleteIcon,
        AddIcon: tdesignIconsVue.AddIcon
      }),
      DeleteIcon = _useGlobalIcon.DeleteIcon,
      AddIcon = _useGlobalIcon.AddIcon;
    var _useCommonClassName = hooks_useCommonClassName["default"](),
      statusClassNames = _useCommonClassName.statusClassNames;
    var visiblePopConfirm = VueCompositionAPI.ref(false);
    var colorInstance = VueCompositionAPI.computed(function () {
      return cloneDeep.cloneDeep(props.color);
    });
    var setVisiblePopConfirm = function setVisiblePopConfirm(visible) {
      visiblePopConfirm.value = visible;
    };
    var handleClick = function handleClick(color) {
      props.handleSetColor(color);
    };
    var isEqualCurrentColor = function isEqualCurrentColor(color) {
      return _common_js_colorPicker_color.Color.compare(color, colorInstance.value.css);
    };
    var selectedColorIndex = VueCompositionAPI.computed(function () {
      return props.colors.findIndex(function (color) {
        return isEqualCurrentColor(color);
      });
    });
    var handleRemoveColor = function handleRemoveColor() {
      var _props$handleChange;
      var colors = props.colors;
      var selectedIndex = selectedColorIndex.value;
      if (selectedIndex === -1) return;
      colors.splice(selectedIndex, 1);
      (_props$handleChange = props.handleChange) === null || _props$handleChange === void 0 || _props$handleChange.call(props, colors);
      setVisiblePopConfirm(false);
    };
    return {
      t: t,
      global: global,
      confirmGlobal: confirmGlobal,
      classPrefix: classPrefix,
      DeleteIcon: DeleteIcon,
      AddIcon: AddIcon,
      baseClassName: baseClassName,
      statusClassNames: statusClassNames,
      selectedColorIndex: selectedColorIndex,
      visiblePopConfirm: visiblePopConfirm,
      setVisiblePopConfirm: setVisiblePopConfirm,
      handleClick: handleClick,
      isEqualCurrentColor: isEqualCurrentColor,
      handleRemoveColor: handleRemoveColor
    };
  },
  render: function render() {
    var _this = this;
    var h = arguments[0];
    var baseClassName = this.baseClassName,
      statusClassNames = this.statusClassNames,
      title = this.title,
      editable = this.editable,
      DeleteIcon = this.DeleteIcon,
      AddIcon = this.AddIcon;
    var swatchesClass = "".concat(baseClassName, "__swatches");
    var renderActions = function renderActions() {
      if (!editable) {
        return null;
      }
      return h("div", {
        "class": "".concat(swatchesClass, "--actions")
      }, [h("span", {
        "attrs": {
          "role": "button"
        },
        "class": "".concat(baseClassName, "__icon"),
        "on": {
          "click": function click() {
            return _this.handleAddColor();
          }
        }
      }, [h(AddIcon)]), _this.colors.length > 0 ? h("span", {
        "attrs": {
          "role": "button"
        },
        "class": "".concat(baseClassName, "__icon"),
        "on": {
          "click": function click() {
            return _this.handleRemoveColor();
          }
        }
      }, [h(DeleteIcon)]) : null]);
    };
    return h("div", {
      "class": swatchesClass
    }, [h("h3", {
      "class": "".concat(swatchesClass, "--title")
    }, [h("span", [title]), renderActions()]), h("ul", {
      "class": ["".concat(swatchesClass, "--items"), "narrow-scrollbar"]
    }, [this.colors.map(function (color) {
      return h("li", {
        "class": ["".concat(swatchesClass, "--item"), _this.isEqualCurrentColor(color) && editable ? statusClassNames.active : ""],
        "key": color,
        "on": {
          "click": function click() {
            if (_this.disabled) {
              return;
            }
            _this.handleClick(color);
          }
        }
      }, [h("div", {
        "class": ["".concat(swatchesClass, "--color"), "".concat(baseClassName, "--bg-alpha")]
      }, [h("span", {
        "class": "".concat(swatchesClass, "--inner"),
        "style": {
          background: color
        }
      })])]);
    })])]);
  }
});

exports["default"] = SwatchesPanel;
//# sourceMappingURL=swatches.js.map
