/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var Vue = require('vue');
var configProvider_context = require('../_chunks/dep-07fb8c0e.js');
var configProvider_props = require('./props.js');
var cloneDeep = require('../_chunks/dep-f45125c9.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-a4a18104.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-27dd8cc6.js');
require('dayjs');
require('../_chunks/dep-87c765cc.js');
require('../_chunks/dep-75cd6d52.js');
require('../_chunks/dep-b1a02818.js');
require('../_chunks/dep-3d8ab37d.js');
require('../_chunks/dep-ecccff93.js');
require('../_chunks/dep-a4308f57.js');
require('../_chunks/dep-a4cecac4.js');
require('../_chunks/dep-ab142eaf.js');
require('../_chunks/dep-6ad3de7c.js');
require('../_chunks/dep-e4278c54.js');
require('../_chunks/dep-fcf0662d.js');
require('../_chunks/dep-8b1e056e.js');
require('../_chunks/dep-5db8defc.js');
require('../_chunks/dep-6e4c473c.js');
require('../_chunks/dep-234b7c02.js');
require('../_chunks/dep-a4747856.js');
require('../_chunks/dep-932dd69e.js');
require('../_chunks/dep-9f4caea4.js');
require('../_chunks/dep-dbd838d6.js');
require('../_chunks/dep-b3120c1b.js');
require('../_chunks/dep-68ba2357.js');
require('../_chunks/dep-173eb46c.js');
require('../_chunks/dep-f33eb57d.js');
require('../_chunks/dep-63b02f7b.js');
require('../_chunks/dep-bebcd284.js');
require('../_chunks/dep-3eec664c.js');
require('../_chunks/dep-eeb2e214.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var Vue__default = /*#__PURE__*/_interopDefaultLegacy(Vue);

var globalConfigSymbol = "__TDESIGN__INSTANCE__GLOBAL__CONFIG__";
var ConfigProvider = Vue__default["default"].extend({
  name: "TConfigProvider",
  props: configProvider_props["default"],
  data: function data() {
    return {
      defaultData: cloneDeep.cloneDeep(configProvider_context.defaultGlobalConfig)
    };
  },
  provide: function provide() {
    return {
      globalConfig: this.mergedGlobalConfig
    };
  },
  computed: {
    mergedGlobalConfig: function mergedGlobalConfig() {
      var mergedGlobalConfig = configProvider_context.mergeWith(this.defaultData, this.globalConfig);
      Vue__default["default"].prototype[globalConfigSymbol] = mergedGlobalConfig;
      return mergedGlobalConfig;
    }
  },
  render: function render() {
    var _this$$slots$default;
    var h = arguments[0];
    if (((_this$$slots$default = this.$slots["default"]) === null || _this$$slots$default === void 0 ? void 0 : _this$$slots$default.length) === 1) {
      return this.$slots["default"][0];
    }
    return h("div", [this.$slots["default"]]);
  }
});

exports["default"] = ConfigProvider;
exports.globalConfigSymbol = globalConfigSymbol;
//# sourceMappingURL=config-provider.js.map
