import { TdDateRangePickerProps } from '../date-picker/type';
import { PropType } from 'vue';
declare const _default: {
    allowInput: BooleanConstructor;
    borderless: BooleanConstructor;
    clearable: BooleanConstructor;
    defaultTime: {
        type: PropType<string[]>;
        default: () => TdDateRangePickerProps['defaultTime'];
    };
    disableDate: {
        type: PropType<import("../date-picker/type").DisableRangeDate>;
    };
    disableTime: {
        type: PropType<(times: Date[], context: {
            partial: import("../date-picker/type").DateRangePickerPartial;
        }) => Partial<{
            hour: number[];
            minute: number[];
            second: number[];
        }>>;
    };
    disabled: BooleanConstructor;
    readonly: {
        type: BooleanConstructor;
        default: any;
    };
    enableTimePicker: BooleanConstructor;
    firstDayOfWeek: {
        type: NumberConstructor;
        validator(val: TdDateRangePickerProps['firstDayOfWeek']): boolean;
    };
    format: {
        type: StringConstructor;
        default: string;
    };
    label: {
        type: PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    mode: {
        type: PropType<"month" | "year" | "quarter" | "week" | "date">;
        default: "month" | "year" | "quarter" | "week" | "date";
        validator(val: TdDateRangePickerProps['mode']): boolean;
    };
    panelPreselection: {
        type: BooleanConstructor;
        default: boolean;
    };
    placeholder: {
        type: PropType<string | string[]>;
    };
    popupProps: {
        type: PropType<import("..").TdPopupProps>;
    };
    prefixIcon: {
        type: PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    presets: {
        type: PropType<import("../date-picker/type").PresetRange>;
    };
    presetsPlacement: {
        type: PropType<"left" | "top" | "bottom" | "right">;
        default: "left" | "top" | "bottom" | "right";
        validator(val: TdDateRangePickerProps['presetsPlacement']): boolean;
    };
    rangeInputProps: {
        type: PropType<import("..").TdRangeInputProps>;
    };
    separator: {
        type: StringConstructor;
        default: string;
    };
    size: {
        type: PropType<import("..").SizeEnum>;
        default: import("..").SizeEnum;
        validator(val: TdDateRangePickerProps['size']): boolean;
    };
    status: {
        type: PropType<"error" | "default" | "success" | "warning">;
        default: "error" | "default" | "success" | "warning";
        validator(val: TdDateRangePickerProps['status']): boolean;
    };
    suffixIcon: {
        type: PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    timePickerProps: {
        type: PropType<import("..").TdTimePickerProps>;
    };
    tips: {
        type: PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    value: {
        type: PropType<import("../date-picker/type").DateRangeValue>;
        default: () => TdDateRangePickerProps['value'];
    };
    defaultValue: {
        type: PropType<import("../date-picker/type").DateRangeValue>;
        default: () => TdDateRangePickerProps['defaultValue'];
    };
    valueType: {
        type: PropType<"YYYY-MM-DD" | "Date" | "time-stamp" | "YYYY" | "YYYY-MM" | "YYYY-MM-DD HH" | "YYYY-MM-DD HH:mm" | "YYYY-MM-DD HH:mm:ss" | "YYYY-MM-DD HH:mm:ss:SSS">;
        validator(val: TdDateRangePickerProps['valueType']): boolean;
    };
    cancelRangeSelectLimit: {
        type: BooleanConstructor;
        default: boolean;
    };
    onBlur: PropType<(context: {
        value: import("../date-picker/type").DateRangeValue;
        partial: import("../date-picker/type").DateRangePickerPartial;
        e: FocusEvent;
    }) => void>;
    onChange: PropType<(value: import("../date-picker/type").DateRangeValue, context: {
        dayjsValue?: import("dayjs").Dayjs[];
        trigger?: import("../date-picker/type").DatePickerTriggerSource;
    }) => void>;
    onConfirm: PropType<(context: {
        date: Date[];
        e: MouseEvent;
        partial: import("../date-picker/type").DateRangePickerPartial;
    }) => void>;
    onFocus: PropType<(context: {
        value: import("../date-picker/type").DateRangeValue;
        partial: import("../date-picker/type").DateRangePickerPartial;
        e: FocusEvent;
    }) => void>;
    onInput: PropType<(context: {
        input: string;
        value: import("../date-picker/type").DateRangeValue;
        partial: import("../date-picker/type").DateRangePickerPartial;
        e: InputEvent;
    }) => void>;
    onPick: PropType<(value: import("../date-picker/type").DateValue, context: import("../date-picker/type").PickContext) => void>;
    onPresetClick: PropType<(context: {
        preset: import("../date-picker/type").PresetDate;
        e: MouseEvent;
    }) => void>;
};
export default _default;
