/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _slicedToArray = require('@babel/runtime/helpers/slicedToArray');
var VueCompositionAPI = require('@vue/composition-api');
var hooks_useVModel = require('../../hooks/useVModel.js');
var _common_js_datePicker_format = require('../../_common/js/date-picker/format.js');
require('../../_chunks/dep-47bca35e.js');
require('../../_chunks/dep-6478392e.js');
require('../../_chunks/dep-201f7798.js');
require('../../_chunks/dep-a4308f57.js');
require('@babel/runtime/helpers/typeof');
require('../../_chunks/dep-fcf0662d.js');
require('../../_chunks/dep-d3015b4c.js');
require('../../_chunks/dep-e4278c54.js');
require('dayjs');
require('../../_chunks/dep-27dd8cc6.js');
require('../../_common/js/log/log.js');
require('../../_chunks/dep-738b4f21.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _slicedToArray__default = /*#__PURE__*/_interopDefaultLegacy(_slicedToArray);

var PARTIAL_MAP = {
  first: "start",
  second: "end"
};
function useRangeValue(props) {
  var _toRefs = VueCompositionAPI.toRefs(props),
    valueFromProps = _toRefs.value;
  var _useVModel = hooks_useVModel.useVModel(valueFromProps, props.defaultValue, props.onChange, "change"),
    _useVModel2 = _slicedToArray__default["default"](_useVModel, 2),
    value = _useVModel2[0],
    onChange = _useVModel2[1];
  var formatRef = VueCompositionAPI.computed(function () {
    return _common_js_datePicker_format.getDefaultFormat({
      mode: props.mode,
      format: props.format,
      enableTimePicker: props.enableTimePicker
    });
  });
  if (props.enableTimePicker) {
    if (!_common_js_datePicker_format.extractTimeFormat(formatRef.value.format)) console.error("format: ".concat(formatRef.value.format, " \u4E0D\u89C4\u8303\uFF0C\u5305\u542B\u65F6\u95F4\u9009\u62E9\u5FC5\u987B\u8981\u6709\u65F6\u95F4\u683C\u5F0F\u5316 HH:mm:ss"));
  }
  if (!Array.isArray(value.value)) {
    console.error("typeof value: ".concat(value.value, " must be Array!"));
  } else if (!_common_js_datePicker_format.isValidDate(value.value, formatRef.value.format)) {
    console.error("value: ".concat(value.value, " is invalid dateTime! Check whether the value is consistent with format: ").concat(formatRef.value.format));
  }
  var isFirstValueSelected = VueCompositionAPI.ref(false);
  var time = VueCompositionAPI.ref(_common_js_datePicker_format.initYearMonthTime({
    value: value.value,
    mode: props.mode,
    format: formatRef.value.format,
    timeFormat: formatRef.value.timeFormat
  }).time);
  var month = VueCompositionAPI.ref(_common_js_datePicker_format.initYearMonthTime({
    value: value.value,
    mode: props.mode,
    format: formatRef.value.format,
    enableTimePicker: props.enableTimePicker
  }).month);
  var year = VueCompositionAPI.ref(_common_js_datePicker_format.initYearMonthTime({
    value: value.value,
    mode: props.mode,
    format: formatRef.value.format
  }).year);
  var cacheValue = VueCompositionAPI.ref(_common_js_datePicker_format.formatDate(value.value, {
    format: formatRef.value.format
  }));
  VueCompositionAPI.watchEffect(function () {
    if (!value.value) {
      cacheValue.value = [];
      return;
    }
    if (!_common_js_datePicker_format.isValidDate(value.value, formatRef.value.format)) return;
    cacheValue.value = _common_js_datePicker_format.formatDate(value.value, {
      format: formatRef.value.format
    });
    time.value = _common_js_datePicker_format.formatTime(value.value, formatRef.value.format, formatRef.value.timeFormat, props.defaultTime);
  });
  return {
    year: year,
    month: month,
    value: value,
    time: time,
    isFirstValueSelected: isFirstValueSelected,
    cacheValue: cacheValue,
    onChange: onChange
  };
}

exports.PARTIAL_MAP = PARTIAL_MAP;
exports["default"] = useRangeValue;
//# sourceMappingURL=useRangeValue.js.map
