/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var _slicedToArray = require('@babel/runtime/helpers/slicedToArray');
var VueCompositionAPI = require('@vue/composition-api');
var hooks_useConfig = require('../../hooks/useConfig.js');
var datePicker_panel_PanelContent = require('./PanelContent.js');
var datePicker_panel_ExtraContent = require('./ExtraContent.js');
var _common_js_datePicker_format = require('../../_common/js/date-picker/format.js');
var datePicker_hooks_useTableData = require('../hooks/useTableData.js');
var datePicker_hooks_useDisableDate = require('../hooks/useDisableDate.js');
var datePicker_utils = require('../utils.js');
var configProvider_useConfig = require('../../config-provider/useConfig.js');
var isFunction = require('../../_chunks/dep-ecccff93.js');
require('../../_chunks/dep-07fb8c0e.js');
require('../../_common/js/global-config/default-config.js');
require('../../_common/js/global-config/locale/zh_CN.js');
require('../../_chunks/dep-a4a18104.js');
require('@babel/runtime/helpers/typeof');
require('../../_chunks/dep-27dd8cc6.js');
require('dayjs');
require('../../_chunks/dep-87c765cc.js');
require('../../_chunks/dep-75cd6d52.js');
require('../../_chunks/dep-b1a02818.js');
require('../../_chunks/dep-3d8ab37d.js');
require('../../_chunks/dep-a4308f57.js');
require('../../_chunks/dep-a4cecac4.js');
require('../../_chunks/dep-ab142eaf.js');
require('../../_chunks/dep-6ad3de7c.js');
require('../../_chunks/dep-e4278c54.js');
require('../../_chunks/dep-fcf0662d.js');
require('../../_chunks/dep-8b1e056e.js');
require('../../_chunks/dep-5db8defc.js');
require('../../_chunks/dep-6e4c473c.js');
require('../../_chunks/dep-234b7c02.js');
require('../../_chunks/dep-a4747856.js');
require('../../_chunks/dep-932dd69e.js');
require('../../_chunks/dep-9f4caea4.js');
require('../../_chunks/dep-dbd838d6.js');
require('../../_chunks/dep-b3120c1b.js');
require('../../_chunks/dep-68ba2357.js');
require('../../_chunks/dep-173eb46c.js');
require('../../_chunks/dep-ece3c062.js');
require('../base/Header.js');
require('@babel/runtime/helpers/toConsumableArray');
require('../../pagination/index.js');
require('../../pagination/pagination.js');
require('tdesign-icons-vue');
require('../../utils/mixins.js');
require('vue');
require('../../config-provider/config-receiver.js');
require('../../input-number/index.js');
require('../../input-number/input-number.js');
require('../../button/index.js');
require('../../button/button.js');
require('../../loading/index.js');
require('../../loading/directive.js');
require('../../loading/plugin.js');
require('../../loading/loading.js');
require('../../loading/icon/gradient.js');
require('../../_common/js/loading/circle-adapter.js');
require('../../_common/js/utils/setStyle.js');
require('../../_common/js/utils/helper.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('../../_chunks/dep-62de1188.js');
require('../../_chunks/dep-867c284e.js');
require('../../_chunks/dep-738b4f21.js');
require('../../_chunks/dep-aa0a4aac.js');
require('../../utils/dom.js');
require('raf');
require('../../utils/easing.js');
require('../../utils/render-tnode.js');
require('@babel/runtime/helpers/readOnlyError');
require('../../_chunks/dep-7c854ec6.js');
require('../../_chunks/dep-eceed11d.js');
require('../../_chunks/dep-201f7798.js');
require('../../_chunks/dep-d3015b4c.js');
require('../../_chunks/dep-f8a85d6a.js');
require('../../_chunks/dep-5b117689.js');
require('../../_chunks/dep-6478392e.js');
require('../../_chunks/dep-47bca35e.js');
require('../../utils/transfer-dom.js');
require('../../loading/props.js');
require('../../config.js');
require('../../_chunks/dep-013a3403.js');
require('../../_chunks/dep-8cb0d589.js');
require('../../_chunks/dep-d23147db.js');
require('../../_chunks/dep-de60f5aa.js');
require('../../_chunks/dep-63b02f7b.js');
require('../../_chunks/dep-bebcd284.js');
require('../../_chunks/dep-3eec664c.js');
require('../../_chunks/dep-eeb2e214.js');
require('../../_chunks/dep-315a67f0.js');
require('../../_chunks/dep-f84d1ea5.js');
require('../../_chunks/dep-362bc4d7.js');
require('../../_chunks/dep-2e32c1f2.js');
require('../../_chunks/dep-f14aac54.js');
require('../../utils/withInstall.js');
require('../../button/props.js');
require('../../utils/ripple.js');
require('../../input/index.js');
require('../../input/input.js');
require('../../utils/helper.js');
require('../../utils/event.js');
require('../../input/props.js');
require('../../_common/js/log/log.js');
require('../../input/input-group.js');
require('../../utils/map-props.js');
require('../../input-number/props.js');
require('../../input-number/useInputNumber.js');
require('../../hooks/useCommonClassName.js');
require('../../hooks/useVModel.js');
require('../../_common/js/input-number/number.js');
require('../../_common/js/input-number/large-number.js');
require('../../hooks/useFormDisabled.js');
require('../../hooks/useGlobalIcon.js');
require('../../select/index.js');
require('../../select/select.js');
require('../../hooks/useDefaultValue.js');
require('../../hooks/tnode.js');
require('../../hooks/render-tnode.js');
require('../../_chunks/dep-a6490a32.js');
require('../../select/props.js');
require('../../popup/index.js');
require('../../popup/popup.js');
require('@popperjs/core');
require('../../popup/props.js');
require('../../popup/container.js');
require('../../popup/utils.js');
require('../../_chunks/dep-f3761329.js');
require('../../_chunks/dep-848a5a32.js');
require('../../popup/plugin.js');
require('../../tag/index.js');
require('../../tag/tag.js');
require('tinycolor2');
require('../../tag/props.js');
require('../../tag/check-tag.js');
require('../../tag/check-tag-props.js');
require('../../_common/js/common.js');
require('../../tag/check-tag-group.js');
require('../../tag/check-tag-group-props.js');
require('../../select-input/index.js');
require('../../select-input/select-input.js');
require('../../select-input/props.js');
require('../../select-input/useSingle.js');
require('../../_chunks/dep-71fa6788.js');
require('../../_chunks/dep-73fb598e.js');
require('../../_chunks/dep-a9e7deb2.js');
require('../../select-input/useMultiple.js');
require('../../tag-input/index.js');
require('../../tag-input/tag-input.js');
require('../../tag-input/props.js');
require('../../tag-input/hooks/useTagScroll.js');
require('../../tag-input/useTagList.js');
require('../../tag-input/hooks/useHover.js');
require('../../tag-input/hooks/useDragSorter.js');
require('../../select-input/useOverlayInnerStyle.js');
require('../../common-components/fake-arrow.js');
require('../../select/option.js');
require('../../select/option-props.js');
require('../../checkbox/index.js');
require('../../checkbox/group.js');
require('../../checkbox/checkbox.js');
require('../../checkbox/props.js');
require('../../checkbox/constants.js');
require('../../checkbox/store.js');
require('@babel/runtime/helpers/classCallCheck');
require('@babel/runtime/helpers/createClass');
require('../../checkbox/hooks/useKeyboardEvent.js');
require('../../hooks/useElementLazyRender.js');
require('../../_common/js/utils/observe.js');
require('../../checkbox/checkbox-group-props.js');
require('../../_chunks/dep-e83685df.js');
require('../../_chunks/dep-502c56be.js');
require('../../hooks/slots.js');
require('../../hooks/useLazyLoad.js');
require('../../select/util.js');
require('../../_chunks/dep-f45125c9.js');
require('../../_chunks/dep-f33eb57d.js');
require('../../select/select-panel.js');
require('../../select/optionGroup.js');
require('../../select/option-group-props.js');
require('../../hooks/useVirtualScroll.js');
require('../../select/hooks/useSelectOptions.js');
require('../../_chunks/dep-6dc0a916.js');
require('../../_chunks/dep-b5c96567.js');
require('../../input-adornment/index.js');
require('../../input-adornment/input-adornment.js');
require('../../input-adornment/props.js');
require('../../pagination/props.js');
require('../../pagination/pagination-mini.js');
require('../../pagination/pagination-mini-props.js');
require('../base/Table.js');
require('../base/Cell.js');
require('../../_common/js/date-picker/utils.js');
require('@babel/runtime/helpers/objectDestructuringEmpty');
require('@babel/runtime/helpers/extends');
require('../../_chunks/dep-9931ceef.js');
require('../../_chunks/dep-5284fe1d.js');
require('../../time-picker/panel/time-picker-panel.js');
require('../../_common/js/time-picker/const.js');
require('../../time-picker/panel/props.js');
require('../../time-picker/props.js');
require('../../time-picker/panel/single-panel.js');
require('../../_common/js/time-picker/utils.js');
require('../base/Footer.js');
require('../../_chunks/dep-8b3c7277.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);
var _slicedToArray__default = /*#__PURE__*/_interopDefaultLegacy(_slicedToArray);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var TRangePanel = VueCompositionAPI.defineComponent({
  name: "TRangePanel",
  props: {
    hoverValue: Array,
    activeIndex: Number,
    isFirstValueSelected: Boolean,
    disableDate: [Object, Array, Function],
    disableTime: Function,
    mode: {
      type: String,
      "default": "date"
    },
    format: String,
    presetsPlacement: {
      type: String,
      "default": "bottom"
    },
    value: Array,
    timePickerProps: Object,
    presets: Object,
    enableTimePicker: Boolean,
    firstDayOfWeek: Number,
    panelPreselection: Boolean,
    hidePreselection: {
      type: Boolean,
      defaultValue: true
    },
    popupVisible: Boolean,
    year: Array,
    month: Array,
    time: Array,
    cancelRangeSelectLimit: Boolean,
    onClick: Function,
    onCellClick: Function,
    onCellMouseEnter: Function,
    onCellMouseLeave: Function,
    onJumperClick: Function,
    onConfirmClick: Function,
    onPresetClick: Function,
    onYearChange: Function,
    onMonthChange: Function,
    onTimePickerChange: Function
  },
  setup: function setup(props) {
    var COMPONENT_NAME = hooks_useConfig.usePrefixClass("date-range-picker__panel");
    var _useConfig = configProvider_useConfig.useConfig("datePicker"),
      global = _useConfig.global;
    var _getDefaultFormat = _common_js_datePicker_format.getDefaultFormat({
        mode: props.mode,
        format: props.format,
        enableTimePicker: props.enableTimePicker
      }),
      format = _getDefaultFormat.format;
    var hidePreselection = !props.panelPreselection && props.value.length === 2;
    var disableDateOptions = VueCompositionAPI.computed(function () {
      return datePicker_hooks_useDisableDate["default"]({
        format: format,
        mode: props.mode,
        disableDate: props.disableDate,
        start: props.isFirstValueSelected && props.activeIndex === 1 ? new Date(_common_js_datePicker_format.parseToDayjs(props.value[0], format, "start").toDate().setHours(0, 0, 0)) : void 0,
        end: props.isFirstValueSelected && props.activeIndex === 0 ? new Date(_common_js_datePicker_format.parseToDayjs(props.value[1], format).toDate().setHours(23, 59, 59)) : void 0
      });
    });
    var disableTime = function disableTime(h, m, s, context) {
      if (!isFunction.isFunction(props.disableTime)) {
        return {};
      }
      var _ref = props.value || [],
        _ref2 = _slicedToArray__default["default"](_ref, 2),
        startTime = _ref2[0],
        endTime = _ref2[1];
      if (context.partial) {
        return props.disableTime([datePicker_utils.parseToDateTime(startTime, format, [h, m, s]), datePicker_utils.parseToDateTime(endTime, format)], context);
      }
      return props.disableTime([datePicker_utils.parseToDateTime(startTime, format), datePicker_utils.parseToDateTime(endTime, format, [h, m, s])], context);
    };
    var startTableData = VueCompositionAPI.computed(function () {
      return datePicker_hooks_useTableData["default"](_objectSpread(_objectSpread({
        isRange: true,
        start: props.value[0] ? _common_js_datePicker_format.parseToDayjs(props.value[0], format).toDate() : void 0,
        end: props.value[1] ? _common_js_datePicker_format.parseToDayjs(props.value[1], format).toDate() : void 0,
        hoverStart: !hidePreselection && props.hoverValue[0] ? _common_js_datePicker_format.parseToDayjs(props.hoverValue[0], format).toDate() : void 0,
        hoverEnd: !hidePreselection && props.hoverValue[1] ? _common_js_datePicker_format.parseToDayjs(props.hoverValue[1], format).toDate() : void 0,
        year: props.year[0],
        month: props.month[0],
        mode: props.mode,
        firstDayOfWeek: props.firstDayOfWeek || global.value.firstDayOfWeek
      }, disableDateOptions.value), {}, {
        cancelRangeSelectLimit: props.cancelRangeSelectLimit
      }));
    });
    var endTableData = VueCompositionAPI.computed(function () {
      return datePicker_hooks_useTableData["default"](_objectSpread(_objectSpread({
        isRange: true,
        start: props.value[0] ? _common_js_datePicker_format.parseToDayjs(props.value[0], format).toDate() : void 0,
        end: props.value[1] ? _common_js_datePicker_format.parseToDayjs(props.value[1], format).toDate() : void 0,
        hoverStart: !hidePreselection && props.hoverValue[0] ? _common_js_datePicker_format.parseToDayjs(props.hoverValue[0], format).toDate() : void 0,
        hoverEnd: !hidePreselection && props.hoverValue[1] ? _common_js_datePicker_format.parseToDayjs(props.hoverValue[1], format).toDate() : void 0,
        year: props.year[1],
        month: props.month[1],
        mode: props.mode,
        firstDayOfWeek: props.firstDayOfWeek || global.value.firstDayOfWeek
      }, disableDateOptions.value), {}, {
        cancelRangeSelectLimit: props.cancelRangeSelectLimit
      }));
    });
    var panelContentProps = VueCompositionAPI.computed(function () {
      return {
        format: format,
        mode: props.mode,
        firstDayOfWeek: props.firstDayOfWeek || global.value.firstDayOfWeek,
        popupVisible: props.popupVisible,
        enableTimePicker: props.enableTimePicker,
        timePickerProps: _objectSpread({
          disableTime: disableTime
        }, props.timePickerProps),
        onMonthChange: props.onMonthChange,
        onYearChange: props.onYearChange,
        onJumperClick: props.onJumperClick,
        onCellClick: props.onCellClick,
        onCellMouseEnter: props.onCellMouseEnter,
        onCellMouseLeave: props.onCellMouseLeave,
        onTimePickerChange: props.onTimePickerChange
      };
    });
    return {
      COMPONENT_NAME: COMPONENT_NAME,
      startTableData: startTableData,
      endTableData: endTableData,
      panelContentProps: panelContentProps
    };
  },
  render: function render() {
    var _this = this;
    var h = arguments[0];
    var COMPONENT_NAME = this.COMPONENT_NAME,
      startTableData = this.startTableData,
      endTableData = this.endTableData,
      panelContentProps = this.panelContentProps;
    return h("div", {
      "class": [COMPONENT_NAME, _defineProperty__default["default"]({}, "".concat(COMPONENT_NAME, "--direction-row"), ["left", "right"].includes(this.presetsPlacement))],
      "on": {
        "click": function click(e) {
          var _this$onClick;
          return (_this$onClick = _this.onClick) === null || _this$onClick === void 0 ? void 0 : _this$onClick.call(_this, {
            e: e
          });
        }
      }
    }, [["top", "left"].includes(this.presetsPlacement) ? h(datePicker_panel_ExtraContent["default"], {
      "props": _objectSpread({}, {
        presets: this.presets,
        selectedValue: this.value[this.activeIndex],
        enableTimePicker: this.enableTimePicker,
        onPresetClick: this.onPresetClick,
        onConfirmClick: this.onConfirmClick,
        presetsPlacement: this.presetsPlacement
      })
    }) : null, h("div", {
      "class": "".concat(COMPONENT_NAME, "-content-wrapper")
    }, [!this.enableTimePicker ? [h(datePicker_panel_PanelContent["default"], {
      "key": "startPanel",
      "props": _objectSpread({}, _objectSpread({
        partial: "start",
        year: this.year[0],
        month: this.month[0],
        time: this.time[0],
        value: this.value,
        tableData: startTableData
      }, panelContentProps))
    }), h(datePicker_panel_PanelContent["default"], {
      "key": "endPanel",
      "props": _objectSpread({}, _objectSpread({
        partial: "end",
        year: this.year[1],
        month: this.month[1],
        time: this.time[1],
        value: this.value,
        tableData: endTableData
      }, panelContentProps))
    })] : h(datePicker_panel_PanelContent["default"], {
      "key": "start",
      "props": _objectSpread({}, _objectSpread({
        partial: this.activeIndex ? "end" : "start",
        year: this.activeIndex ? this.year[1] : this.year[0],
        month: this.activeIndex ? this.month[1] : this.month[0],
        time: this.activeIndex ? this.time[1] : this.time[0],
        value: this.value,
        tableData: this.activeIndex ? endTableData : startTableData
      }, panelContentProps))
    })]), ["bottom", "right"].includes(this.presetsPlacement) ? h(datePicker_panel_ExtraContent["default"], {
      "props": _objectSpread({}, {
        presets: this.presets,
        selectedValue: this.value[this.activeIndex],
        enableTimePicker: this.enableTimePicker,
        onPresetClick: this.onPresetClick,
        onConfirmClick: this.onConfirmClick,
        presetsPlacement: this.presetsPlacement
      })
    }) : null]);
  }
});

exports["default"] = TRangePanel;
//# sourceMappingURL=RangePanel.js.map
