/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var VueCompositionAPI = require('@vue/composition-api');
var hooks_tnode = require('../hooks/tnode.js');
var hooks_useConfig = require('../hooks/useConfig.js');
var descriptions_props = require('./props.js');
var descriptions_const_index = require('./const/index.js');
var descriptions_descriptionsBody = require('./descriptions-body.js');
var descriptions_utils_index = require('./utils/index.js');
var descriptions_interface = require('./interface.js');
var isArray = require('../_chunks/dep-fcf0662d.js');
var isNil = require('../_chunks/dep-8b3c7277.js');
var hooks_slots = require('../hooks/slots.js');
require('../hooks/render-tnode.js');
require('../_chunks/dep-a4cecac4.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-738b4f21.js');
require('../_chunks/dep-a4308f57.js');
require('../_chunks/dep-e4278c54.js');
require('../_chunks/dep-7c854ec6.js');
require('../_chunks/dep-eceed11d.js');
require('../_chunks/dep-201f7798.js');
require('../_chunks/dep-d3015b4c.js');
require('../_chunks/dep-f8a85d6a.js');
require('../_chunks/dep-5b117689.js');
require('../_chunks/dep-6478392e.js');
require('../_chunks/dep-47bca35e.js');
require('../_chunks/dep-ecccff93.js');
require('../_chunks/dep-a6490a32.js');
require('../_chunks/dep-3eec664c.js');
require('../_chunks/dep-8b1e056e.js');
require('../_chunks/dep-5db8defc.js');
require('../_chunks/dep-6e4c473c.js');
require('../_chunks/dep-3d8ab37d.js');
require('../_chunks/dep-eeb2e214.js');
require('../_chunks/dep-6ad3de7c.js');
require('../config-provider/useConfig.js');
require('../_chunks/dep-07fb8c0e.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-a4a18104.js');
require('../_chunks/dep-27dd8cc6.js');
require('dayjs');
require('../_chunks/dep-87c765cc.js');
require('../_chunks/dep-75cd6d52.js');
require('../_chunks/dep-b1a02818.js');
require('../_chunks/dep-ab142eaf.js');
require('../_chunks/dep-234b7c02.js');
require('../_chunks/dep-a4747856.js');
require('../_chunks/dep-932dd69e.js');
require('../_chunks/dep-9f4caea4.js');
require('../_chunks/dep-dbd838d6.js');
require('../_chunks/dep-b3120c1b.js');
require('../_chunks/dep-68ba2357.js');
require('../_chunks/dep-173eb46c.js');
require('../_chunks/dep-ece3c062.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var _Descriptions = VueCompositionAPI.defineComponent({
  name: "TDescriptions",
  props: descriptions_props["default"],
  setup: function setup(props2) {
    var COMPONENT_NAME = hooks_useConfig.usePrefixClass("descriptions");
    var getChildByName = hooks_slots.useChildComponentSlots();
    var itemsType = VueCompositionAPI.ref(descriptions_interface.ItemsType.props);
    var renderTNodeJSX = hooks_tnode.useTNodeJSX();
    var renderTitle = renderTNodeJSX("title");
    var getRows = function getRows() {
      var column = props2.column,
        layout = props2.layout;
      var items = [];
      if (isArray.isArray(props2.items)) {
        items = props2.items.map(function (item) {
          return {
            label: descriptions_utils_index.renderCustomNode(item.label),
            content: descriptions_utils_index.renderCustomNode(item.content),
            span: item.span || 1
          };
        });
        itemsType.value = descriptions_interface.ItemsType.props;
      } else {
        var slots = getChildByName("TDescriptionsItem");
        if (slots.length !== 0) {
          items = slots;
          itemsType.value = descriptions_interface.ItemsType.slots;
        }
      }
      if (layout === "vertical") {
        return [items];
      }
      var temp = [];
      var reset = column;
      var res = [];
      items.forEach(function (item, index) {
        var span = 1;
        if (descriptions_utils_index.itemTypeIsProps(itemsType.value)) {
          span = isNil.isNil(item.span) ? span : item.span;
        } else {
          var propsData = item.componentOptions.propsData || {};
          span = isNil.isNil(propsData === null || propsData === void 0 ? void 0 : propsData.span) ? span : propsData.span;
          propsData.span = span;
          Object.assign(item.componentOptions, _objectSpread(_objectSpread({}, item.componentOptions), {}, {
            propsData: propsData
          }));
        }
        if (reset >= span) {
          temp.push(item);
          reset -= span;
        } else {
          res.push(temp);
          temp = [item];
          reset = column - span;
        }
        if (index === items.length - 1) {
          if (descriptions_utils_index.itemTypeIsProps(itemsType.value)) {
            Object.assign(item, {
              span: item.span + reset
            });
          } else {
            var _propsData = item.componentOptions.propsData || {};
            _propsData.span += reset;
            Object.assign(item.componentOptions, _objectSpread(_objectSpread({}, item.componentOptions), {}, {
              propsData: _propsData
            }));
          }
          res.push(temp);
        }
      });
      return res;
    };
    VueCompositionAPI.provide(descriptions_const_index["default"], props2);
    return {
      renderTitle: renderTitle,
      getRows: getRows,
      itemsType: itemsType,
      COMPONENT_NAME: COMPONENT_NAME
    };
  },
  render: function render() {
    var _this = this;
    var h = arguments[0];
    var renderHeader = function renderHeader() {
      return _this.renderTitle ? h("div", {
        "class": "".concat(_this.COMPONENT_NAME, "__header")
      }, [_this.renderTitle]) : "";
    };
    return h("div", {
      "class": this.COMPONENT_NAME
    }, [renderHeader(), h(descriptions_descriptionsBody["default"], {
      "attrs": {
        "item-type": this.itemsType,
        "rows": this.getRows()
      }
    })]);
  }
});

exports["default"] = _Descriptions;
//# sourceMappingURL=descriptions.js.map
