import { TdDialogProps } from './type';
import './style';
export * from './type';
export declare type DialogProps = TdDialogProps;
export declare const Dialog: import("vue/types/vue").ExtendedVue<{
    useGlobalIcon(tdIcon: Record<string, any>): import("tdesign-icons-vue").GlobalIconConfig;
} & Record<never, any> & import("../config-provider/config-receiver").ConfigComponent & import("vue").default & {
    globalAttach(): import("..").AttachNode;
} & {
    getConfirmBtn(options: import("./actions").MixinsConfirmBtn): any;
    getCancelBtn(options: import("./actions").MixinsCancelBtn): any;
    getButtonByProps(button: string | import("..").TdButtonProps, params: {
        defaultButtonProps: import("..").TdButtonProps;
        className?: import("..").ClassName;
        confirmLoading?: boolean;
    }): JSX.Element;
    confirmBtnAction(e: MouseEvent): void;
    cancelBtnAction(e: MouseEvent): void;
    getDefaultConfirmBtnProps(options: import("./actions").MixinsConfirmBtn): import("..").TdButtonProps;
    getDefaultCancelBtnProps(options: import("./actions").MixinsCancelBtn): import("..").TdButtonProps;
} & {
    t<T>(pattern: T, placement?: import("../config-provider/config-receiver").Placement): string;
} & {
    global: import("..").DialogConfig;
    classPrefix: string;
    componentName: string;
    commonSizeClassName: Record<string, string>;
    commonStatusClassName: Record<string, string>;
}, {
    uid: number;
    scrollWidth: number;
    disX: number;
    disY: number;
    windowInnerWidth: number;
    windowInnerHeight: number;
    dialogW: number;
    dialogH: number;
    dLeft: number;
    dTop: number;
    styleEl: any;
    timer: any;
    animationEnd: boolean;
}, {
    clearStyleFunc(): void;
    destroySelfStyle(): void;
    destroySelf(): void;
    storeUid(flag: boolean): void;
    addKeyboardEvent(status: boolean): void;
    keyboardEvent(e: KeyboardEvent): void;
    keyboardEnterEvent(e: KeyboardEvent): void;
    overlayAction(e: MouseEvent): void;
    closeBtnAction(e: MouseEvent): void;
    cancelBtnAction(e: MouseEvent): void;
    confirmBtnAction(e: MouseEvent): void;
    beforeEnter(): void;
    afterEnter(): void;
    beforeLeave(): void;
    afterLeave(): void;
    emitCloseEvent(context: import("./type").DialogCloseContext): void;
    hasEventOn(name: string): boolean;
    getIcon(): any;
    mousedownHandler(targetEvent: MouseEvent): void;
    mouseMoverHandler(documentEvent: MouseEvent): void;
    mouseUpHandler(): void;
    initDragEvent(status: boolean): void;
    resizeAdjustPosition(): void;
    onStopDown(e: MouseEvent): void;
    renderDialog(): JSX.Element;
}, {
    isModal: boolean;
    isModeLess: boolean;
    isNormal: boolean;
    isFullScreen: boolean;
    maskClass: import("..").ClassName;
    dialogClass: import("..").ClassName;
    positionClass: import("..").ClassName;
    wrapClass: import("..").ClassName;
    ctxClass: import("..").ClassName;
    positionStyle: import("..").Styles;
    computedDialogStyle: import("..").Styles;
    computedAttach: import("..").AttachNode;
}, {
    instanceGlobal: any;
    attach: import("..").AttachNode;
    body: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    cancelBtn: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue) | import("..").TdButtonProps;
    closeBtn: string | boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    closeOnEscKeydown: any;
    closeOnOverlayClick: any;
    confirmBtn: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue) | import("..").TdButtonProps;
    confirmLoading: any;
    confirmOnEnter: boolean;
    default: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    destroyOnClose: boolean;
    dialogClassName: string;
    dialogStyle: import("..").Styles;
    draggable: boolean;
    footer: boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    header: string | boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    mode: "normal" | "modal" | "modeless" | "full-screen";
    placement: "center" | "top";
    preventScrollThrough: boolean;
    showInAttachedElement: boolean;
    showOverlay: boolean;
    theme: "default" | "success" | "warning" | "danger" | "info";
    top: string | number;
    visible: boolean;
    width: string | number;
    zIndex: number;
    onBeforeClose: () => void;
    onBeforeOpen: () => void;
    onCancel: (context: {
        e: MouseEvent;
    }) => void;
    onClose: (context: import("./type").DialogCloseContext) => void;
    onCloseBtnClick: (context: {
        e: MouseEvent;
    }) => void;
    onClosed: () => void;
    onConfirm: (context: {
        e: MouseEvent | KeyboardEvent;
    }) => void;
    onEscKeydown: (context: {
        e: KeyboardEvent;
    }) => void;
    onOpened: () => void;
    onOverlayClick: (context: {
        e: MouseEvent;
    }) => void;
}> & import("vue").PluginObject<import("vue/types/vue").ExtendedVue<{
    useGlobalIcon(tdIcon: Record<string, any>): import("tdesign-icons-vue").GlobalIconConfig;
} & Record<never, any> & import("../config-provider/config-receiver").ConfigComponent & import("vue").default & {
    globalAttach(): import("..").AttachNode;
} & {
    getConfirmBtn(options: import("./actions").MixinsConfirmBtn): any;
    getCancelBtn(options: import("./actions").MixinsCancelBtn): any;
    getButtonByProps(button: string | import("..").TdButtonProps, params: {
        defaultButtonProps: import("..").TdButtonProps;
        className?: import("..").ClassName;
        confirmLoading?: boolean;
    }): JSX.Element;
    confirmBtnAction(e: MouseEvent): void;
    cancelBtnAction(e: MouseEvent): void;
    getDefaultConfirmBtnProps(options: import("./actions").MixinsConfirmBtn): import("..").TdButtonProps;
    getDefaultCancelBtnProps(options: import("./actions").MixinsCancelBtn): import("..").TdButtonProps;
} & {
    t<T>(pattern: T, placement?: import("../config-provider/config-receiver").Placement): string;
} & {
    global: import("..").DialogConfig;
    classPrefix: string;
    componentName: string;
    commonSizeClassName: Record<string, string>;
    commonStatusClassName: Record<string, string>;
}, {
    uid: number;
    scrollWidth: number;
    disX: number;
    disY: number;
    windowInnerWidth: number;
    windowInnerHeight: number;
    dialogW: number;
    dialogH: number;
    dLeft: number;
    dTop: number;
    styleEl: any;
    timer: any;
    animationEnd: boolean;
}, {
    clearStyleFunc(): void;
    destroySelfStyle(): void;
    destroySelf(): void;
    storeUid(flag: boolean): void;
    addKeyboardEvent(status: boolean): void;
    keyboardEvent(e: KeyboardEvent): void;
    keyboardEnterEvent(e: KeyboardEvent): void;
    overlayAction(e: MouseEvent): void;
    closeBtnAction(e: MouseEvent): void;
    cancelBtnAction(e: MouseEvent): void;
    confirmBtnAction(e: MouseEvent): void;
    beforeEnter(): void;
    afterEnter(): void;
    beforeLeave(): void;
    afterLeave(): void;
    emitCloseEvent(context: import("./type").DialogCloseContext): void;
    hasEventOn(name: string): boolean;
    getIcon(): any;
    mousedownHandler(targetEvent: MouseEvent): void;
    mouseMoverHandler(documentEvent: MouseEvent): void;
    mouseUpHandler(): void;
    initDragEvent(status: boolean): void;
    resizeAdjustPosition(): void;
    onStopDown(e: MouseEvent): void;
    renderDialog(): JSX.Element;
}, {
    isModal: boolean;
    isModeLess: boolean;
    isNormal: boolean;
    isFullScreen: boolean;
    maskClass: import("..").ClassName;
    dialogClass: import("..").ClassName;
    positionClass: import("..").ClassName;
    wrapClass: import("..").ClassName;
    ctxClass: import("..").ClassName;
    positionStyle: import("..").Styles;
    computedDialogStyle: import("..").Styles;
    computedAttach: import("..").AttachNode;
}, {
    instanceGlobal: any;
    attach: import("..").AttachNode;
    body: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    cancelBtn: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue) | import("..").TdButtonProps;
    closeBtn: string | boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    closeOnEscKeydown: any;
    closeOnOverlayClick: any;
    confirmBtn: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue) | import("..").TdButtonProps;
    confirmLoading: any;
    confirmOnEnter: boolean;
    default: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    destroyOnClose: boolean;
    dialogClassName: string;
    dialogStyle: import("..").Styles;
    draggable: boolean;
    footer: boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    header: string | boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    mode: "normal" | "modal" | "modeless" | "full-screen";
    placement: "center" | "top";
    preventScrollThrough: boolean;
    showInAttachedElement: boolean;
    showOverlay: boolean;
    theme: "default" | "success" | "warning" | "danger" | "info";
    top: string | number;
    visible: boolean;
    width: string | number;
    zIndex: number;
    onBeforeClose: () => void;
    onBeforeOpen: () => void;
    onCancel: (context: {
        e: MouseEvent;
    }) => void;
    onClose: (context: import("./type").DialogCloseContext) => void;
    onCloseBtnClick: (context: {
        e: MouseEvent;
    }) => void;
    onClosed: () => void;
    onConfirm: (context: {
        e: MouseEvent | KeyboardEvent;
    }) => void;
    onEscKeydown: (context: {
        e: KeyboardEvent;
    }) => void;
    onOpened: () => void;
    onOverlayClick: (context: {
        e: MouseEvent;
    }) => void;
}>>;
export { default as DialogPlugin } from './plugin';
export default Dialog;
