/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var VueCompositionAPI = require('@vue/composition-api');
var dropdown_dropdownItemProps = require('./dropdown-item-props.js');
var hooks_tnode = require('../hooks/tnode.js');
var hooks_useConfig = require('../hooks/useConfig.js');
var utils_helper = require('../utils/helper.js');
var utils_ripple = require('../utils/ripple.js');
var configProvider_configReceiver = require('../config-provider/config-receiver.js');
require('../hooks/render-tnode.js');
require('../_chunks/dep-a4cecac4.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-738b4f21.js');
require('../_chunks/dep-a4308f57.js');
require('../_chunks/dep-fcf0662d.js');
require('../_chunks/dep-e4278c54.js');
require('../_chunks/dep-7c854ec6.js');
require('../_chunks/dep-eceed11d.js');
require('../_chunks/dep-201f7798.js');
require('../_chunks/dep-d3015b4c.js');
require('../_chunks/dep-f8a85d6a.js');
require('../_chunks/dep-5b117689.js');
require('../_chunks/dep-6478392e.js');
require('../_chunks/dep-47bca35e.js');
require('../_chunks/dep-ecccff93.js');
require('../_chunks/dep-a6490a32.js');
require('../_chunks/dep-3eec664c.js');
require('../_chunks/dep-8b1e056e.js');
require('../_chunks/dep-5db8defc.js');
require('../_chunks/dep-6e4c473c.js');
require('../_chunks/dep-3d8ab37d.js');
require('../_chunks/dep-eeb2e214.js');
require('../_chunks/dep-6ad3de7c.js');
require('../config-provider/useConfig.js');
require('../_chunks/dep-07fb8c0e.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-a4a18104.js');
require('../_chunks/dep-27dd8cc6.js');
require('dayjs');
require('../_chunks/dep-87c765cc.js');
require('../_chunks/dep-75cd6d52.js');
require('../_chunks/dep-b1a02818.js');
require('../_chunks/dep-ab142eaf.js');
require('../_chunks/dep-234b7c02.js');
require('../_chunks/dep-a4747856.js');
require('../_chunks/dep-932dd69e.js');
require('../_chunks/dep-9f4caea4.js');
require('../_chunks/dep-dbd838d6.js');
require('../_chunks/dep-b3120c1b.js');
require('../_chunks/dep-68ba2357.js');
require('../_chunks/dep-173eb46c.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/slicedToArray');
require('../_common/js/utils/setStyle.js');
require('../config.js');
require('vue');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var keepAnimationMixins = configProvider_configReceiver.getKeepAnimationMixins();
var _DropdownItem = VueCompositionAPI.defineComponent({
  name: "TDropdownItem",
  mixins: [keepAnimationMixins],
  directives: {
    ripple: utils_ripple["default"]
  },
  props: _objectSpread(_objectSpread({}, dropdown_dropdownItemProps["default"]), {}, {
    maxColumnWidth: {
      type: [String, Number],
      "default": 100
    },
    minColumnWidth: {
      type: [String, Number],
      "default": 10
    },
    isSubmenu: Boolean
  }),
  setup: function setup(props, _ref) {
    var emit = _ref.emit;
    var itemRef = VueCompositionAPI.ref();
    var dropdownItemClass = hooks_useConfig.usePrefixClass("dropdown__item");
    var handleItemClick = function handleItemClick(e) {
      var _props$onClick;
      (_props$onClick = props.onClick) === null || _props$onClick === void 0 || _props$onClick.call(props, props.value, {
        e: e
      });
      emit("click", props.value, {
        e: e
      });
    };
    return {
      itemRef: itemRef,
      dropdownItemClass: dropdownItemClass,
      handleItemClick: handleItemClick
    };
  },
  render: function render() {
    var h = arguments[0];
    var classes = [this.dropdownItemClass, "".concat(this.dropdownItemClass, "--theme-").concat(this.theme), _defineProperty__default["default"](_defineProperty__default["default"]({}, "".concat(this.dropdownItemClass, "--active"), this.active), "".concat(this.dropdownItemClass, "--disabled"), this.disabled)];
    var renderTNodeJSX = hooks_tnode.useTNodeJSX();
    var prefixIcon = renderTNodeJSX("prefixIcon");
    return h("li", {
      "class": classes,
      "on": {
        "click": this.handleItemClick
      },
      "style": {
        maxWidth: utils_helper.pxCompat(this.maxColumnWidth),
        minWidth: utils_helper.pxCompat(this.minColumnWidth)
      },
      "directives": [{
        name: "ripple",
        value: !this.isSubmenu && this.keepAnimation.ripple
      }],
      "ref": this.itemRef
    }, [this.prefixIcon ? h("div", {
      "class": "".concat(this.dropdownItemClass, "-icon")
    }, [prefixIcon]) : null, renderTNodeJSX("default")]);
  }
});

exports["default"] = _DropdownItem;
//# sourceMappingURL=dropdown-item.js.map
