/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var VueCompositionAPI = require('@vue/composition-api');
var tdesignIconsVue = require('tdesign-icons-vue');
var dropdown_dropdownItem = require('./dropdown-item.js');
var dropdown_props = require('./props.js');
var divider_index = require('../divider/index.js');
var hooks_useConfig = require('../hooks/useConfig.js');
var hooks_useGlobalIcon = require('../hooks/useGlobalIcon.js');
var isFunction = require('../_chunks/dep-ecccff93.js');
require('./dropdown-item-props.js');
require('../hooks/tnode.js');
require('../hooks/render-tnode.js');
require('../_chunks/dep-a4cecac4.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-738b4f21.js');
require('../_chunks/dep-a4308f57.js');
require('../_chunks/dep-fcf0662d.js');
require('../_chunks/dep-e4278c54.js');
require('../_chunks/dep-7c854ec6.js');
require('../_chunks/dep-eceed11d.js');
require('../_chunks/dep-201f7798.js');
require('../_chunks/dep-d3015b4c.js');
require('../_chunks/dep-f8a85d6a.js');
require('../_chunks/dep-5b117689.js');
require('../_chunks/dep-6478392e.js');
require('../_chunks/dep-47bca35e.js');
require('../_chunks/dep-a6490a32.js');
require('../_chunks/dep-3eec664c.js');
require('../_chunks/dep-8b1e056e.js');
require('../_chunks/dep-5db8defc.js');
require('../_chunks/dep-6e4c473c.js');
require('../_chunks/dep-3d8ab37d.js');
require('../_chunks/dep-eeb2e214.js');
require('../_chunks/dep-6ad3de7c.js');
require('../utils/helper.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/slicedToArray');
require('../utils/ripple.js');
require('../_common/js/utils/setStyle.js');
require('../config.js');
require('../config-provider/config-receiver.js');
require('vue');
require('../_chunks/dep-07fb8c0e.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-a4a18104.js');
require('../_chunks/dep-27dd8cc6.js');
require('dayjs');
require('../_chunks/dep-87c765cc.js');
require('../_chunks/dep-75cd6d52.js');
require('../_chunks/dep-b1a02818.js');
require('../_chunks/dep-ab142eaf.js');
require('../_chunks/dep-234b7c02.js');
require('../_chunks/dep-a4747856.js');
require('../_chunks/dep-932dd69e.js');
require('../_chunks/dep-9f4caea4.js');
require('../_chunks/dep-dbd838d6.js');
require('../_chunks/dep-b3120c1b.js');
require('../_chunks/dep-68ba2357.js');
require('../_chunks/dep-173eb46c.js');
require('../config-provider/useConfig.js');
require('../divider/divider.js');
require('../divider/props.js');
require('../utils/render-tnode.js');
require('@babel/runtime/helpers/readOnlyError');
require('../utils/mixins.js');
require('../utils/withInstall.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var _DropdownMenu = VueCompositionAPI.defineComponent({
  name: "TDropdownMenu",
  props: _objectSpread({}, dropdown_props["default"]),
  setup: function setup(props, _ref) {
    var emit = _ref.emit;
    var dropdownClass = hooks_useConfig.usePrefixClass("dropdown");
    var dropdownMenuClass = hooks_useConfig.usePrefixClass("dropdown__menu");
    var menuRef = VueCompositionAPI.ref();
    var isOverMaxHeight = VueCompositionAPI.ref(false);
    var scrollTopMap = VueCompositionAPI.reactive({});
    var handleItemClick = function handleItemClick(optionItem, options) {
      var _data$onClick, _props$onClick;
      if (optionItem.disabled || optionItem.children) return;
      var data = options.data,
        context = options.context;
      data === null || data === void 0 || (_data$onClick = data.onClick) === null || _data$onClick === void 0 || _data$onClick.call(data, data, context);
      (_props$onClick = props.onClick) === null || _props$onClick === void 0 || _props$onClick.call(props, data, context);
      emit("click", data, context);
    };
    var handleScroll = function handleScroll(e, deep) {
      var scrollTop = e.target.scrollTop;
      VueCompositionAPI.set(scrollTopMap, deep, scrollTop);
    };
    VueCompositionAPI.onMounted(function () {
      if (menuRef.value) {
        var _window;
        var menuHeight = parseInt((_window = window) === null || _window === void 0 ? void 0 : _window.getComputedStyle(menuRef.value).height, 10);
        if (menuHeight >= props.maxHeight) isOverMaxHeight.value = true;
      }
    });
    return {
      dropdownClass: dropdownClass,
      dropdownMenuClass: dropdownMenuClass,
      handleItemClick: handleItemClick,
      menuRef: menuRef,
      isOverMaxHeight: isOverMaxHeight,
      handleScroll: handleScroll,
      scrollTopMap: scrollTopMap
    };
  },
  methods: {
    renderOptionContent: function renderOptionContent(content) {
      if (isFunction.isFunction(content)) {
        return content(VueCompositionAPI.h);
      }
      return content;
    },
    renderOptions: function renderOptions(data, deep) {
      var _data$forEach,
        _this = this;
      var h = this.$createElement;
      var _useGlobalIcon = hooks_useGlobalIcon.useGlobalIcon({
          ChevronRightIcon: tdesignIconsVue.ChevronRightIcon
        }),
        ChevronRightIcon = _useGlobalIcon.ChevronRightIcon;
      var arr = [];
      var renderContent;
      (_data$forEach = data.forEach) === null || _data$forEach === void 0 || _data$forEach.call(data, function (menu, idx) {
        var optionItem = _objectSpread({}, menu);
        var onViewIdx = idx - Math.ceil(_this.scrollTopMap[deep] / 30);
        var renderIdx = onViewIdx >= 0 ? onViewIdx : idx;
        if (optionItem.children) {
          optionItem.children = _this.renderOptions(optionItem.children, deep + 1);
          renderContent = h("div", {
            "key": idx
          }, [h(dropdown_dropdownItem["default"], {
            "class": ["".concat(_this.dropdownClass, "__item"), "".concat(_this.dropdownClass, "__item--suffix"), optionItem["class"]],
            "props": _objectSpread({}, {
              value: optionItem.value,
              theme: optionItem.theme,
              active: optionItem.active,
              prefixIcon: optionItem.prefixIcon,
              disabled: optionItem.disabled,
              minColumnWidth: _this.minColumnWidth,
              maxColumnWidth: _this.maxColumnWidth,
              isSubmenu: true
            })
          }, [h("div", {
            "class": "".concat(_this.dropdownClass, "__item-content")
          }, [h("span", {
            "class": "".concat(_this.dropdownClass, "__item-text")
          }, [_this.renderOptionContent(optionItem.content)]), h(ChevronRightIcon, {
            "class": "".concat(_this.dropdownClass, "__item-direction"),
            "attrs": {
              "size": "16"
            }
          })]), h("div", {
            "class": ["".concat(_this.dropdownClass, "__submenu-wrapper"), _defineProperty__default["default"]({}, "".concat(_this.dropdownClass, "__submenu-wrapper--").concat(_this.direction), _this.direction)],
            "style": {
              position: "absolute",
              top: "".concat(renderIdx * 30, "px")
            }
          }, [h("div", {
            "class": ["".concat(_this.dropdownClass, "__submenu"), _defineProperty__default["default"]({}, "".concat(_this.dropdownClass, "__submenu--disabled"), optionItem.disabled)],
            "style": {
              position: "static",
              maxHeight: "".concat(_this.maxHeight, "px")
            },
            "on": {
              "scroll": function scroll(e) {
                return _this.handleScroll(e, deep + 1);
              }
            }
          }, [h("ul", [optionItem.children])])])]), optionItem.divider ? h(divider_index.Divider) : null]);
        } else {
          renderContent = h("div", {
            "key": idx
          }, [h(dropdown_dropdownItem["default"], {
            "class": ["".concat(_this.dropdownClass, "__item"), optionItem["class"]],
            "props": _objectSpread({}, {
              value: optionItem.value,
              theme: optionItem.theme,
              active: optionItem.active,
              prefixIcon: optionItem.prefixIcon,
              disabled: optionItem.disabled,
              minColumnWidth: _this.minColumnWidth,
              maxColumnWidth: _this.maxColumnWidth,
              onClick: function onClick(value, context) {
                return _this.handleItemClick({
                  disabled: optionItem.disabled,
                  children: optionItem.children
                }, {
                  data: optionItem,
                  context: context
                });
              }
            })
          }, [h("span", {
            "class": "".concat(_this.dropdownClass, "__item-text")
          }, [_this.renderOptionContent(optionItem.content)])]), optionItem.divider ? h(divider_index.Divider) : null]);
        }
        arr.push(renderContent);
      });
      return arr;
    }
  },
  render: function render() {
    var _this2 = this;
    var h = arguments[0];
    return h("div", {
      "class": [this.dropdownMenuClass, "".concat(this.dropdownMenuClass, "--").concat(this.direction), _defineProperty__default["default"]({}, "".concat(this.dropdownMenuClass, "--overflow"), this.isOverMaxHeight)],
      "style": {
        maxHeight: "".concat(this.maxHeight, "px")
      },
      "ref": "menuRef",
      "on": {
        "scroll": function scroll(e) {
          return _this2.handleScroll(e, 0);
        }
      }
    }, [this.renderOptions(this.options, 0)]);
  }
});

exports["default"] = _DropdownMenu;
//# sourceMappingURL=dropdown-menu.js.map
