/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var VueCompositionAPI = require('@vue/composition-api');
var popup_index = require('../popup/index.js');
var popup_utils = require('../popup/utils.js');
var dropdown_dropdownMenu = require('./dropdown-menu.js');
var dropdown_props = require('./props.js');
var hooks_useConfig = require('../hooks/useConfig.js');
var hooks_tnode = require('../hooks/tnode.js');
var dropdown_hooks_useDropdownOptions = require('./hooks/useDropdownOptions.js');
var omit = require('../_chunks/dep-6dc0a916.js');
require('../popup/popup.js');
require('@babel/runtime/helpers/typeof');
require('@popperjs/core');
require('../utils/dom.js');
require('vue');
require('raf');
require('../utils/easing.js');
require('../_chunks/dep-738b4f21.js');
require('../_chunks/dep-a4308f57.js');
require('../_chunks/dep-fcf0662d.js');
require('../_chunks/dep-e4278c54.js');
require('../utils/render-tnode.js');
require('@babel/runtime/helpers/readOnlyError');
require('../_chunks/dep-7c854ec6.js');
require('../_chunks/dep-eceed11d.js');
require('../_chunks/dep-201f7798.js');
require('../_chunks/dep-d3015b4c.js');
require('../_chunks/dep-f8a85d6a.js');
require('../_chunks/dep-5b117689.js');
require('../_chunks/dep-6478392e.js');
require('../_chunks/dep-47bca35e.js');
require('../utils/helper.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/slicedToArray');
require('../_common/js/utils/setStyle.js');
require('../popup/props.js');
require('../popup/container.js');
require('../_chunks/dep-ecccff93.js');
require('../_chunks/dep-a4cecac4.js');
require('../config-provider/config-receiver.js');
require('../_chunks/dep-07fb8c0e.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-a4a18104.js');
require('../_chunks/dep-27dd8cc6.js');
require('dayjs');
require('../_chunks/dep-87c765cc.js');
require('../_chunks/dep-75cd6d52.js');
require('../_chunks/dep-b1a02818.js');
require('../_chunks/dep-3d8ab37d.js');
require('../_chunks/dep-ab142eaf.js');
require('../_chunks/dep-6ad3de7c.js');
require('../_chunks/dep-8b1e056e.js');
require('../_chunks/dep-5db8defc.js');
require('../_chunks/dep-6e4c473c.js');
require('../_chunks/dep-234b7c02.js');
require('../_chunks/dep-a4747856.js');
require('../_chunks/dep-932dd69e.js');
require('../_chunks/dep-9f4caea4.js');
require('../_chunks/dep-dbd838d6.js');
require('../_chunks/dep-b3120c1b.js');
require('../_chunks/dep-68ba2357.js');
require('../_chunks/dep-173eb46c.js');
require('../utils/mixins.js');
require('../utils/event.js');
require('../_chunks/dep-f3761329.js');
require('../_chunks/dep-848a5a32.js');
require('../utils/map-props.js');
require('../utils/withInstall.js');
require('../popup/plugin.js');
require('../_common/js/log/log.js');
require('tdesign-icons-vue');
require('./dropdown-item.js');
require('./dropdown-item-props.js');
require('../utils/ripple.js');
require('../config.js');
require('../hooks/render-tnode.js');
require('../_chunks/dep-a6490a32.js');
require('../_chunks/dep-3eec664c.js');
require('../_chunks/dep-eeb2e214.js');
require('../config-provider/useConfig.js');
require('../divider/index.js');
require('../divider/divider.js');
require('../divider/props.js');
require('../hooks/useGlobalIcon.js');
require('../_chunks/dep-f84d1ea5.js');
require('../_chunks/dep-362bc4d7.js');
require('../_chunks/dep-f33eb57d.js');
require('../_chunks/dep-63b02f7b.js');
require('../_chunks/dep-bebcd284.js');
require('../_chunks/dep-b5c96567.js');
require('../_chunks/dep-a9e7deb2.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var _Dropdown = VueCompositionAPI.defineComponent({
  name: "TDropdown",
  props: _objectSpread({}, dropdown_props["default"]),
  setup: function setup(props2, _ref) {
    var emit = _ref.emit;
    var dropdownClass = hooks_useConfig.usePrefixClass("dropdown");
    var isPopupVisible = VueCompositionAPI.ref(false);
    var invisibleDelay = VueCompositionAPI.computed(function () {
      var _props2$popupProps;
      var popupInvisibleDelay = (_props2$popupProps = props2.popupProps) === null || _props2$popupProps === void 0 ? void 0 : _props2$popupProps.delay;
      if (!popupInvisibleDelay) return popup_utils.defaultVisibleDelay[1] + 10;
      return popupInvisibleDelay[1] ? popupInvisibleDelay[1] + 10 : popupInvisibleDelay[0] + 10;
    });
    var handleMenuClick = function handleMenuClick(data, context) {
      var _props2$onClick;
      if (props2.hideAfterItemClick) {
        setTimeout(function () {
          var _props2$popupProps2, _props2$popupProps2$o, _props2$popupProps3, _props2$popupProps3$o;
          isPopupVisible.value = false;
          (_props2$popupProps2 = props2.popupProps) === null || _props2$popupProps2 === void 0 || (_props2$popupProps2$o = _props2$popupProps2.onVisibleChange) === null || _props2$popupProps2$o === void 0 || _props2$popupProps2$o.call(_props2$popupProps2, false, context);
          (_props2$popupProps3 = props2.popupProps) === null || _props2$popupProps3 === void 0 || (_props2$popupProps3$o = _props2$popupProps3["on-visible-change"]) === null || _props2$popupProps3$o === void 0 || _props2$popupProps3$o.call(_props2$popupProps3, false, context);
        }, invisibleDelay.value);
      }
      props2 === null || props2 === void 0 || (_props2$onClick = props2.onClick) === null || _props2$onClick === void 0 || _props2$onClick.call(props2, data, context);
      emit("click", data, context);
    };
    var handleVisibleChange = function handleVisibleChange(visible, context) {
      var _props2$popupProps4, _props2$popupProps4$o, _props2$popupProps5, _props2$popupProps5$o;
      if (!visible) {
        setTimeout(function () {
          isPopupVisible.value = visible;
        }, invisibleDelay.value);
      } else {
        isPopupVisible.value = visible;
      }
      (_props2$popupProps4 = props2.popupProps) === null || _props2$popupProps4 === void 0 || (_props2$popupProps4$o = _props2$popupProps4.onVisibleChange) === null || _props2$popupProps4$o === void 0 || _props2$popupProps4$o.call(_props2$popupProps4, visible, context);
      (_props2$popupProps5 = props2.popupProps) === null || _props2$popupProps5 === void 0 || (_props2$popupProps5$o = _props2$popupProps5["on-visible-change"]) === null || _props2$popupProps5$o === void 0 || _props2$popupProps5$o.call(_props2$popupProps5, visible, context);
    };
    return {
      dropdownClass: dropdownClass,
      handleMenuClick: handleMenuClick,
      isPopupVisible: isPopupVisible,
      handleVisibleChange: handleVisibleChange
    };
  },
  render: function render() {
    var _this$popupProps, _renderTNodeJSX;
    var h = arguments[0];
    var popupParams = _objectSpread(_objectSpread({
      disabled: this.disabled,
      placement: this.placement,
      trigger: this.trigger
    }, omit.omit(this.popupProps, ["onVisibleChange", "on-visible-change"])), {}, {
      overlayInnerClassName: [this.dropdownClass, (_this$popupProps = this.popupProps) === null || _this$popupProps === void 0 ? void 0 : _this$popupProps.overlayInnerClassName]
    });
    var renderTNodeJSX = hooks_tnode.useTNodeJSX();
    var options = dropdown_hooks_useDropdownOptions["default"](this.$props, this.$slots);
    var trigger = (_renderTNodeJSX = renderTNodeJSX("default")) === null || _renderTNodeJSX === void 0 ? void 0 : _renderTNodeJSX[0];
    return h(popup_index.Popup, {
      "props": _objectSpread({}, _objectSpread({
        destroyOnClose: true,
        visible: this.isPopupVisible,
        onVisibleChange: this.handleVisibleChange,
        expandAnimation: true
      }, popupParams))
    }, [h(dropdown_dropdownMenu["default"], {
      "slot": "content",
      "props": _objectSpread({}, _objectSpread(_objectSpread({}, this.$props), {}, {
        options: options.value,
        onClick: this.handleMenuClick
      }))
    }), trigger]);
  }
});

exports["default"] = _Dropdown;
//# sourceMappingURL=dropdown.js.map
