/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var helper = require('../_chunks/dep-ece3c062.js');
var VueCompositionAPI = require('@vue/composition-api');
var configProvider_useConfig = require('../config-provider/useConfig.js');
var hooks_useConfig = require('../hooks/useConfig.js');
var empty_props = require('./props.js');
var image_index = require('../image/index.js');
var utils_renderTnode = require('../utils/render-tnode.js');
var empty_assets_MaintenanceSvg = require('./assets/MaintenanceSvg.js');
var empty_assets_NetworkErrorSvg = require('./assets/NetworkErrorSvg.js');
var empty_assets_EmptySvg = require('./assets/EmptySvg.js');
var empty_assets_FailSvg = require('./assets/FailSvg.js');
var empty_assets_SuccessSvg = require('./assets/SuccessSvg.js');
var isString = require('../_chunks/dep-738b4f21.js');
var isPlainObject = require('../_chunks/dep-68ba2357.js');
require('../_chunks/dep-07fb8c0e.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-a4a18104.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-27dd8cc6.js');
require('dayjs');
require('../_chunks/dep-87c765cc.js');
require('../_chunks/dep-75cd6d52.js');
require('../_chunks/dep-b1a02818.js');
require('../_chunks/dep-3d8ab37d.js');
require('../_chunks/dep-ecccff93.js');
require('../_chunks/dep-a4308f57.js');
require('../_chunks/dep-a4cecac4.js');
require('../_chunks/dep-ab142eaf.js');
require('../_chunks/dep-6ad3de7c.js');
require('../_chunks/dep-e4278c54.js');
require('../_chunks/dep-fcf0662d.js');
require('../_chunks/dep-8b1e056e.js');
require('../_chunks/dep-5db8defc.js');
require('../_chunks/dep-6e4c473c.js');
require('../_chunks/dep-234b7c02.js');
require('../_chunks/dep-a4747856.js');
require('../_chunks/dep-932dd69e.js');
require('../_chunks/dep-9f4caea4.js');
require('../_chunks/dep-dbd838d6.js');
require('../_chunks/dep-b3120c1b.js');
require('../_chunks/dep-173eb46c.js');
require('../image/image.js');
require('@babel/runtime/helpers/slicedToArray');
require('tdesign-icons-vue');
require('../_common/js/utils/observe.js');
require('../image/props.js');
require('../space/index.js');
require('../space/space.js');
require('@babel/runtime/helpers/defineProperty');
require('../space/props.js');
require('../_common/js/utils/helper.js');
require('@babel/runtime/helpers/toConsumableArray');
require('@babel/runtime/helpers/objectWithoutProperties');
require('../_chunks/dep-62de1188.js');
require('../_chunks/dep-867c284e.js');
require('../_chunks/dep-aa0a4aac.js');
require('@babel/runtime/helpers/readOnlyError');
require('vue');
require('../_chunks/dep-7c854ec6.js');
require('../_chunks/dep-eceed11d.js');
require('../_chunks/dep-201f7798.js');
require('../_chunks/dep-d3015b4c.js');
require('../_chunks/dep-f8a85d6a.js');
require('../_chunks/dep-5b117689.js');
require('../_chunks/dep-6478392e.js');
require('../_chunks/dep-47bca35e.js');
require('../utils/withInstall.js');
require('../_chunks/dep-6dc0a916.js');
require('../_chunks/dep-f33eb57d.js');
require('../_chunks/dep-63b02f7b.js');
require('../_chunks/dep-bebcd284.js');
require('../_chunks/dep-3eec664c.js');
require('../_chunks/dep-eeb2e214.js');
require('../_chunks/dep-362bc4d7.js');
require('../_chunks/dep-b5c96567.js');
require('../_chunks/dep-a9e7deb2.js');
require('../hooks/useImagePreviewUrl.js');
require('../_common/js/upload/utils.js');
require('../_common/js/log/log.js');
require('../utils/map-props.js');

var _Empty = VueCompositionAPI.defineComponent({
  name: "TEmpty",
  components: {
    TImage: image_index.Image
  },
  props: empty_props["default"],
  setup: function setup(props2, _ref) {
    var slots = _ref.slots;
    var _toRefs = VueCompositionAPI.toRefs(props2),
      size = _toRefs.size,
      propsImage = _toRefs.image,
      propsDescription = _toRefs.description,
      propsTitle = _toRefs.title,
      type = _toRefs.type;
    var _useConfig = configProvider_useConfig.useConfig("empty"),
      globalConfig = _useConfig.globalConfig;
    var componentName = configProvider_useConfig.usePrefixClass("empty");
    var showAction = VueCompositionAPI.computed(function () {
      return props2.action || slots.action;
    });
    var _useCommonClassName = hooks_useConfig.useCommonClassName(),
      SIZE = _useCommonClassName.SIZE;
    var defaultMaps = {
      maintenance: {
        image: globalConfig.value.image.maintenance || empty_assets_MaintenanceSvg["default"],
        title: globalConfig.value.titleText.maintenance
      },
      success: {
        image: globalConfig.value.image.success || empty_assets_SuccessSvg["default"],
        title: globalConfig.value.titleText.success
      },
      fail: {
        image: globalConfig.value.image.fail || empty_assets_FailSvg["default"],
        title: globalConfig.value.titleText.fail
      },
      "network-error": {
        image: globalConfig.value.image.networkError || empty_assets_NetworkErrorSvg["default"],
        title: globalConfig.value.titleText.networkError
      },
      empty: {
        image: globalConfig.value.image.empty || empty_assets_EmptySvg["default"],
        title: globalConfig.value.titleText.empty
      }
    };
    var emptyClasses = VueCompositionAPI.computed(function () {
      return [componentName.value, SIZE.value[size.value]];
    });
    var titleClasses = ["".concat(componentName.value, "__title")];
    var imageClasses = ["".concat(componentName.value, "__image")];
    var descriptionClasses = ["".concat(componentName.value, "__description")];
    var actionClass = ["".concat(componentName.value, "__action")];
    var typeImageProps = VueCompositionAPI.computed(function () {
      var _defaultMaps$type$val;
      return (_defaultMaps$type$val = defaultMaps[type.value]) !== null && _defaultMaps$type$val !== void 0 ? _defaultMaps$type$val : null;
    });
    var showImage = VueCompositionAPI.computed(function () {
      var _typeImageProps$value;
      return propsImage.value || slots.image || ((_typeImageProps$value = typeImageProps.value) === null || _typeImageProps$value === void 0 ? void 0 : _typeImageProps$value.image);
    });
    var showTitle = VueCompositionAPI.computed(function () {
      var _typeImageProps$value2;
      return propsTitle.value || slots.title || ((_typeImageProps$value2 = typeImageProps.value) === null || _typeImageProps$value2 === void 0 ? void 0 : _typeImageProps$value2.title);
    });
    var showDescription = VueCompositionAPI.computed(function () {
      return propsDescription.value || slots.description;
    });
    return {
      emptyClasses: emptyClasses,
      imageClasses: imageClasses,
      titleClasses: titleClasses,
      descriptionClasses: descriptionClasses,
      actionClass: actionClass,
      showImage: showImage,
      showTitle: showTitle,
      showDescription: showDescription,
      showAction: showAction
    };
  },
  methods: {
    renderTitle: function renderTitle() {
      var h = this.$createElement;
      if (!this.showTitle) {
        return null;
      }
      return h("div", {
        "class": this.titleClasses
      }, [this.showTitle]);
    },
    renderDescription: function renderDescription() {
      var h = this.$createElement;
      if (!this.showDescription) {
        return null;
      }
      return h("div", {
        "class": this.descriptionClasses
      }, [this.showDescription]);
    },
    getImageIns: function getImageIns() {
      var h = this.$createElement;
      var data = this.showImage;
      var result = null;
      if (isString.isString(data)) {
        result = h(image_index.Image, {
          "attrs": {
            "src": data
          }
        });
      } else if (data && Reflect.has(data, "render")) {
        result = h(data);
      } else if (isPlainObject.isPlainObject(data)) {
        result = h(image_index.Image, helper.helper([{}, data]));
      }
      return data ? result : null;
    }
  },
  render: function render() {
    var h = arguments[0];
    return h("div", {
      "class": this.emptyClasses
    }, [this.showImage ? h("div", {
      "class": this.imageClasses,
      "style": this.imageStyle
    }, [this.$slots.image ? utils_renderTnode.renderTNodeJSX(this, "image") : this.getImageIns()]) : null, this.renderTitle(), this.renderDescription(), this.showAction ? h("div", {
      "class": this.actionClass
    }, [utils_renderTnode.renderTNodeJSX(this, "action")]) : null]);
  }
});

exports["default"] = _Empty;
//# sourceMappingURL=empty.js.map
