/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _asyncToGenerator = require('@babel/runtime/helpers/asyncToGenerator');
var _slicedToArray = require('@babel/runtime/helpers/slicedToArray');
var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var _regeneratorRuntime = require('@babel/runtime/regenerator');
var form_props = require('./props.js');
var form_const = require('./const.js');
var utils_event = require('../utils/event.js');
var form_formItem = require('./form-item.js');
var configProvider_configReceiver = require('../config-provider/config-receiver.js');
var utils_mixins = require('../utils/mixins.js');
var _getAllKeys = require('../_chunks/dep-63b02f7b.js');
var isEmpty = require('../_chunks/dep-a6490a32.js');
require('../utils/helper.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('../_chunks/dep-7c854ec6.js');
require('../_chunks/dep-eceed11d.js');
require('../_chunks/dep-201f7798.js');
require('../_chunks/dep-a4308f57.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-fcf0662d.js');
require('../_chunks/dep-d3015b4c.js');
require('../_chunks/dep-e4278c54.js');
require('../_chunks/dep-f8a85d6a.js');
require('../_chunks/dep-5b117689.js');
require('../_chunks/dep-6478392e.js');
require('vue');
require('tdesign-icons-vue');
require('./form-model.js');
require('../_chunks/dep-27dd8cc6.js');
require('../_chunks/dep-aa0a4aac.js');
require('./form-item-props.js');
require('../_common/js/log/log.js');
require('../utils/render-tnode.js');
require('@babel/runtime/helpers/readOnlyError');
require('@vue/composition-api');
require('../_chunks/dep-47bca35e.js');
require('../_chunks/dep-8b3c7277.js');
require('../_chunks/dep-f84d1ea5.js');
require('../_chunks/dep-362bc4d7.js');
require('../_chunks/dep-a4747856.js');
require('../_chunks/dep-3d8ab37d.js');
require('../_chunks/dep-ecccff93.js');
require('../_chunks/dep-a4cecac4.js');
require('../_chunks/dep-ab142eaf.js');
require('../_chunks/dep-f45125c9.js');
require('../_chunks/dep-f33eb57d.js');
require('../_chunks/dep-87c765cc.js');
require('../_chunks/dep-75cd6d52.js');
require('../_chunks/dep-b1a02818.js');
require('../_chunks/dep-6ad3de7c.js');
require('../_chunks/dep-8b1e056e.js');
require('../_chunks/dep-5db8defc.js');
require('../_chunks/dep-6e4c473c.js');
require('../_chunks/dep-234b7c02.js');
require('../_chunks/dep-bebcd284.js');
require('../_chunks/dep-3eec664c.js');
require('../_chunks/dep-eeb2e214.js');
require('../_chunks/dep-07fb8c0e.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-a4a18104.js');
require('dayjs');
require('../_chunks/dep-932dd69e.js');
require('../_chunks/dep-9f4caea4.js');
require('../_chunks/dep-dbd838d6.js');
require('../_chunks/dep-b3120c1b.js');
require('../_chunks/dep-68ba2357.js');
require('../_chunks/dep-173eb46c.js');
require('../_chunks/dep-7a2463e1.js');
require('../_chunks/dep-73fb598e.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _asyncToGenerator__default = /*#__PURE__*/_interopDefaultLegacy(_asyncToGenerator);
var _slicedToArray__default = /*#__PURE__*/_interopDefaultLegacy(_slicedToArray);
var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);
var _regeneratorRuntime__default = /*#__PURE__*/_interopDefaultLegacy(_regeneratorRuntime);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var classPrefixMixins = configProvider_configReceiver.getClassPrefixMixins("form");
var _Form = utils_mixins["default"](classPrefixMixins).extend({
  name: "TForm",
  props: _objectSpread({}, form_props["default"]),
  provide: function provide() {
    return {
      form: this
    };
  },
  data: function data() {
    return {
      children: []
    };
  },
  computed: {
    formClass: function formClass() {
      return [this.componentName, _defineProperty__default["default"]({}, "".concat(this.componentName, "-inline"), this.layout === "inline")];
    },
    formDataKeys: function formDataKeys() {
      return _getAllKeys.keys(this.data);
    },
    controlledComponents: function controlledComponents() {
      var _this$formControlledC;
      var fields = form_const.FORM_CONTROL_COMPONENTS;
      if ((_this$formControlledC = this.formControlledComponents) !== null && _this$formControlledC !== void 0 && _this$formControlledC.length) {
        fields = fields.concat(this.formControlledComponents);
      }
      return fields;
    }
  },
  created: function created() {
    var _this = this;
    this.$on("form-item-created", function (formItem) {
      _this.children.push(formItem);
    });
    this.$on("form-item-destroyed", function (formItem) {
      var index = _this.children.findIndex(function (item) {
        return item === formItem;
      });
      _this.children.splice(index, 1);
    });
  },
  methods: {
    getFirstError: function getFirstError(r) {
      if (r === true) return;
      var _Object$keys = Object.keys(r),
        _Object$keys2 = _slicedToArray__default["default"](_Object$keys, 1),
        firstKey = _Object$keys2[0];
      if (this.scrollToFirstError) {
        this.scrollTo(".".concat(form_formItem.getFormItemClassName(this.componentName, firstKey)));
      }
      return r[firstKey][0].message;
    },
    scrollTo: function scrollTo(selector) {
      var dom = this.$el.querySelector(selector);
      var behavior = this.scrollToFirstError;
      dom && dom.scrollIntoView({
        behavior: behavior
      });
    },
    isFunction: function isFunction(val) {
      return typeof val === "function";
    },
    needValidate: function needValidate(name, fields) {
      if (!fields || !Array.isArray(fields)) return true;
      return fields.indexOf(name) !== -1;
    },
    formatValidateResult: function formatValidateResult(arr) {
      if (!arr || !arr.length) return true;
      var r = arr.reduce(function (r2, err) {
        return Object.assign(r2 || {}, err);
      });
      Object.keys(r).forEach(function (key) {
        if (r[key] === true) {
          delete r[key];
        } else {
          r[key] = r[key].filter(function (fr) {
            return fr.result === false;
          });
        }
      });
      return isEmpty.isEmpty(r) ? true : r;
    },
    validate: function validate() {
      var _arguments = arguments,
        _this2 = this;
      return _asyncToGenerator__default["default"](/*#__PURE__*/_regeneratorRuntime__default["default"].mark(function _callee() {
        var param, source, _ref2, fields, _ref2$trigger, trigger, list, arr, result;
        return _regeneratorRuntime__default["default"].wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              param = _arguments.length > 0 && _arguments[0] !== undefined ? _arguments[0] : {
                showErrorMessage: true
              };
              source = _arguments.length > 1 && _arguments[1] !== undefined ? _arguments[1] : "submit-function";
              _ref2 = param || {}, fields = _ref2.fields, _ref2$trigger = _ref2.trigger, trigger = _ref2$trigger === void 0 ? "all" : _ref2$trigger;
              list = _this2.children.filter(function (child) {
                return _this2.isFunction(child.validate) && _this2.needValidate(String(child.name), fields);
              }).map(function (child) {
                return child.validate(trigger, param.showErrorMessage, source);
              });
              _context.next = 6;
              return Promise.all(list);
            case 6:
              arr = _context.sent;
              result = _this2.formatValidateResult(arr);
              utils_event.emitEvent(_this2, "validate", {
                validateResult: result,
                firstError: _this2.getFirstError(result)
              });
              return _context.abrupt("return", result);
            case 10:
            case "end":
              return _context.stop();
          }
        }, _callee);
      }))();
    },
    validateOnly: function validateOnly(param) {
      var _this3 = this;
      return _asyncToGenerator__default["default"](/*#__PURE__*/_regeneratorRuntime__default["default"].mark(function _callee2() {
        var _ref3, fields, _ref3$trigger, trigger, list, arr, result;
        return _regeneratorRuntime__default["default"].wrap(function _callee2$(_context2) {
          while (1) switch (_context2.prev = _context2.next) {
            case 0:
              _ref3 = param || {}, fields = _ref3.fields, _ref3$trigger = _ref3.trigger, trigger = _ref3$trigger === void 0 ? "all" : _ref3$trigger;
              list = _this3.children.filter(function (child) {
                return _this3.isFunction(child.validate) && _this3.needValidate(String(child.name), fields);
              }).map(function (child) {
                return child.validateOnly(trigger);
              });
              _context2.next = 4;
              return Promise.all(list);
            case 4:
              arr = _context2.sent;
              result = _this3.formatValidateResult(arr);
              return _context2.abrupt("return", result);
            case 7:
            case "end":
              return _context2.stop();
          }
        }, _callee2);
      }))();
    },
    setValidateMessage: function setValidateMessage(validateMessage) {
      var _this4 = this;
      var keys2 = Object.keys(validateMessage || {});
      if (!keys2.length) return;
      var list = this.children.filter(function (child) {
        return _this4.isFunction(child.setValidateMessage) && keys2.includes(String(child.name));
      }).map(function (child) {
        return child.setValidateMessage(validateMessage[child.name]);
      });
      Promise.all(list);
    },
    submitHandler: function submitHandler(e) {
      var _this5 = this;
      if (this.preventSubmitDefault) {
        e === null || e === void 0 || e.preventDefault();
        e === null || e === void 0 || e.stopPropagation();
      }
      this.validate({
        showErrorMessage: true
      }, "submit-event").then(function (r) {
        utils_event.emitEvent(_this5, "submit", {
          validateResult: r,
          firstError: _this5.getFirstError(r),
          e: e
        });
      });
    },
    resetHandler: function resetHandler(e) {
      var _this6 = this;
      if (this.preventSubmitDefault) {
        e === null || e === void 0 || e.preventDefault();
        e === null || e === void 0 || e.stopPropagation();
      }
      this.children.filter(function (child) {
        return _this6.isFunction(child.resetField) && _this6.needValidate(String(child.name), _this6.formDataKeys);
      }).forEach(function (child) {
        return child.resetField(_this6.resetType || "initial");
      });
      utils_event.emitEvent(this, "reset", {
        e: e
      });
    },
    clearValidate: function clearValidate(fields) {
      var _this7 = this;
      this.children.forEach(function (child) {
        if (_this7.isFunction(child.resetHandler) && _this7.needValidate(String(child.name), fields)) {
          child.resetHandler();
        }
      });
    },
    reset: function reset() {
      var _this8 = this;
      var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      this.children.filter(function (child) {
        return _this8.isFunction(child.resetField) && _this8.needValidate(String(child.name), _this8.formDataKeys);
      }).forEach(function (child) {
        var resetType = params.type || _this8.resetType || "initial";
        if (!params.fields || params.fields && params.fields.includes(child.name)) {
          child.resetField(resetType);
        }
      });
      utils_event.emitEvent(this, "reset", {
        e: void 0
      });
    },
    submit: function submit(params) {
      var _this9 = this;
      this.validate({
        showErrorMessage: params === null || params === void 0 ? void 0 : params.showErrorMessage
      }, "submit-function").then(function (r) {
        utils_event.emitEvent(_this9, "submit", {
          validateResult: r,
          firstError: _this9.getFirstError(r)
        });
      });
    }
  },
  render: function render() {
    var h = arguments[0];
    var on = {
      submit: this.submitHandler,
      reset: this.resetHandler
    };
    return h("form", {
      "ref": "form",
      "class": this.formClass,
      "on": _objectSpread({}, on)
    }, [this.$slots["default"]]);
  }
});

exports["default"] = _Form;
//# sourceMappingURL=form.js.map
