/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var helper = require('../_chunks/dep-ece3c062.js');
var _slicedToArray = require('@babel/runtime/helpers/slicedToArray');
var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var VueCompositionAPI = require('@vue/composition-api');
var guide_utils_getScrollParent = require('./utils/getScrollParent.js');
var guide_utils_getRelativePosition = require('./utils/getRelativePosition.js');
var guide_utils_getTargetElm = require('./utils/getTargetElm.js');
var guide_utils_scrollToElm = require('./utils/scrollToElm.js');
var _common_js_utils_setStyle = require('../_common/js/utils/setStyle.js');
var utils_transferDom = require('../utils/transfer-dom.js');
var utils_dom = require('../utils/dom.js');
var hooks_useDefaultValue = require('../hooks/useDefaultValue.js');
var hooks_useConfig = require('../hooks/useConfig.js');
var button_index = require('../button/index.js');
var popup_index = require('../popup/index.js');
var guide_props = require('./props.js');
var utils_renderTnode = require('../utils/render-tnode.js');
var configProvider_useConfig = require('../config-provider/useConfig.js');
var isFunction = require('../_chunks/dep-ecccff93.js');
require('vue');
require('raf');
require('../utils/easing.js');
require('../_chunks/dep-738b4f21.js');
require('../_chunks/dep-a4308f57.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-fcf0662d.js');
require('../_chunks/dep-e4278c54.js');
require('../button/button.js');
require('../loading/index.js');
require('../loading/directive.js');
require('../loading/plugin.js');
require('../loading/loading.js');
require('../loading/icon/gradient.js');
require('../_common/js/loading/circle-adapter.js');
require('../_common/js/utils/helper.js');
require('@babel/runtime/helpers/toConsumableArray');
require('@babel/runtime/helpers/objectWithoutProperties');
require('../_chunks/dep-62de1188.js');
require('../_chunks/dep-867c284e.js');
require('../_chunks/dep-aa0a4aac.js');
require('../config-provider/config-receiver.js');
require('../_chunks/dep-07fb8c0e.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-a4a18104.js');
require('../_chunks/dep-27dd8cc6.js');
require('dayjs');
require('../_chunks/dep-87c765cc.js');
require('../_chunks/dep-75cd6d52.js');
require('../_chunks/dep-b1a02818.js');
require('../_chunks/dep-3d8ab37d.js');
require('../_chunks/dep-a4cecac4.js');
require('../_chunks/dep-ab142eaf.js');
require('../_chunks/dep-6ad3de7c.js');
require('../_chunks/dep-8b1e056e.js');
require('../_chunks/dep-5db8defc.js');
require('../_chunks/dep-6e4c473c.js');
require('../_chunks/dep-234b7c02.js');
require('../_chunks/dep-a4747856.js');
require('../_chunks/dep-932dd69e.js');
require('../_chunks/dep-9f4caea4.js');
require('../_chunks/dep-dbd838d6.js');
require('../_chunks/dep-b3120c1b.js');
require('../_chunks/dep-68ba2357.js');
require('../_chunks/dep-173eb46c.js');
require('../utils/mixins.js');
require('../loading/props.js');
require('@babel/runtime/helpers/readOnlyError');
require('../_chunks/dep-7c854ec6.js');
require('../_chunks/dep-eceed11d.js');
require('../_chunks/dep-201f7798.js');
require('../_chunks/dep-d3015b4c.js');
require('../_chunks/dep-f8a85d6a.js');
require('../_chunks/dep-5b117689.js');
require('../_chunks/dep-6478392e.js');
require('../_chunks/dep-47bca35e.js');
require('../config.js');
require('../_chunks/dep-013a3403.js');
require('../_chunks/dep-8cb0d589.js');
require('../_chunks/dep-d23147db.js');
require('../_chunks/dep-de60f5aa.js');
require('../_chunks/dep-63b02f7b.js');
require('../_chunks/dep-bebcd284.js');
require('../_chunks/dep-3eec664c.js');
require('../_chunks/dep-eeb2e214.js');
require('../_chunks/dep-315a67f0.js');
require('../_chunks/dep-f84d1ea5.js');
require('../_chunks/dep-362bc4d7.js');
require('../_chunks/dep-2e32c1f2.js');
require('../_chunks/dep-f14aac54.js');
require('../utils/withInstall.js');
require('../button/props.js');
require('../utils/ripple.js');
require('../popup/popup.js');
require('@popperjs/core');
require('../utils/helper.js');
require('../popup/props.js');
require('../popup/container.js');
require('../utils/event.js');
require('../popup/utils.js');
require('../_chunks/dep-f3761329.js');
require('../_chunks/dep-848a5a32.js');
require('../utils/map-props.js');
require('../popup/plugin.js');
require('../_common/js/log/log.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _slicedToArray__default = /*#__PURE__*/_interopDefaultLegacy(_slicedToArray);
var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var _Guide = VueCompositionAPI.defineComponent({
  name: "TGuide",
  directives: {
    TransferDom: utils_transferDom["default"]
  },
  props: _objectSpread({}, guide_props["default"]),
  setup: function setup(props2, context) {
    var COMPONENT_NAME = hooks_useConfig.usePrefixClass("guide");
    var LOCK_CLASS = hooks_useConfig.usePrefixClass("guide--lock");
    var _useConfig = configProvider_useConfig.useConfig("guide"),
      global = _useConfig.global;
    var _toRefs = VueCompositionAPI.toRefs(props2),
      current = _toRefs.current;
    var _useCommonClassName = hooks_useConfig.useCommonClassName(),
      classPrefix = _useCommonClassName.classPrefix;
    var _useDefaultValue = hooks_useDefaultValue["default"](current, props2.defaultCurrent, props2.onChange, "current", "change"),
      _useDefaultValue2 = _slicedToArray__default["default"](_useDefaultValue, 2),
      innerCurrent = _useDefaultValue2[0],
      setInnerCurrent = _useDefaultValue2[1];
    var overlayLayerRef = VueCompositionAPI.ref();
    var highlightLayerRef = VueCompositionAPI.ref();
    var referenceLayerRef = VueCompositionAPI.ref();
    var currentHighlightLayerElm = VueCompositionAPI.ref();
    var dialogWrapperRef = VueCompositionAPI.ref();
    var dialogTooltipRef = VueCompositionAPI.ref();
    var activated = VueCompositionAPI.ref(false);
    var stepsTotal = VueCompositionAPI.computed(function () {
      return props2.steps.length;
    });
    var currentStepInfo = VueCompositionAPI.computed(function () {
      var _props2$steps;
      return (_props2$steps = props2.steps) === null || _props2$steps === void 0 ? void 0 : _props2$steps[innerCurrent.value];
    });
    var isPopup = VueCompositionAPI.computed(function () {
      return getCurrentCrossProps("mode") === "popup";
    });
    var currentElmIsFixed = VueCompositionAPI.computed(function () {
      return utils_dom.isFixed(currentHighlightLayerElm.value || document.body);
    });
    var getCurrentCrossProps = function getCurrentCrossProps(propsName) {
      var _currentStepInfo$valu;
      return (_currentStepInfo$valu = currentStepInfo.value[propsName]) !== null && _currentStepInfo$valu !== void 0 ? _currentStepInfo$valu : props2[propsName];
    };
    var setHighlightLayerPosition = function setHighlightLayerPosition(highlightLayer) {
      var _getRelativePosition = guide_utils_getRelativePosition["default"](currentHighlightLayerElm.value),
        top = _getRelativePosition.top,
        left = _getRelativePosition.left;
      var _currentHighlightLaye = currentHighlightLayerElm.value.getBoundingClientRect(),
        width = _currentHighlightLaye.width,
        height = _currentHighlightLaye.height;
      var highlightPadding = getCurrentCrossProps("highlightPadding");
      if (isPopup.value) {
        width += highlightPadding * 2;
        height += highlightPadding * 2;
        top -= highlightPadding;
        left -= highlightPadding;
      } else {
        var _getWindowScroll = utils_dom.getWindowScroll(),
          scrollTop = _getWindowScroll.scrollTop,
          scrollLeft = _getWindowScroll.scrollLeft;
        top += scrollTop;
        left += scrollLeft;
      }
      _common_js_utils_setStyle["default"](highlightLayer, {
        width: "".concat(width, "px"),
        height: "".concat(height, "px"),
        top: "".concat(top, "px"),
        left: "".concat(left, "px")
      });
    };
    var showPopupGuide = function showPopupGuide() {
      VueCompositionAPI.nextTick(function () {
        currentHighlightLayerElm.value = guide_utils_getTargetElm["default"](currentStepInfo.value.element);
        if (!currentHighlightLayerElm.value) return;
        guide_utils_getScrollParent.scrollToParentVisibleArea(currentHighlightLayerElm.value);
        setHighlightLayerPosition(highlightLayerRef.value);
        setHighlightLayerPosition(referenceLayerRef.value);
        guide_utils_scrollToElm["default"](currentHighlightLayerElm.value);
      });
    };
    var destroyTooltipElm = function destroyTooltipElm() {
      var _referenceLayerRef$va;
      (_referenceLayerRef$va = referenceLayerRef.value) === null || _referenceLayerRef$va === void 0 || _referenceLayerRef$va.parentNode.removeChild(referenceLayerRef.value);
    };
    var showDialogGuide = function showDialogGuide() {
      VueCompositionAPI.nextTick(function () {
        currentHighlightLayerElm.value = dialogTooltipRef.value;
        guide_utils_getScrollParent.scrollToParentVisibleArea(currentHighlightLayerElm.value);
        setHighlightLayerPosition(highlightLayerRef.value);
        guide_utils_scrollToElm["default"](currentHighlightLayerElm.value);
      });
    };
    var destroyDialogTooltipElm = function destroyDialogTooltipElm() {
      var _dialogTooltipRef$val, _dialogWrapperRef$val;
      (_dialogTooltipRef$val = dialogTooltipRef.value) === null || _dialogTooltipRef$val === void 0 || _dialogTooltipRef$val.parentNode.removeChild(dialogTooltipRef.value);
      (_dialogWrapperRef$val = dialogWrapperRef.value) === null || _dialogWrapperRef$val === void 0 || _dialogWrapperRef$val.parentNode.removeChild(dialogWrapperRef.value);
    };
    var showGuide = function showGuide() {
      if (isPopup.value) {
        destroyDialogTooltipElm();
        showPopupGuide();
      } else {
        destroyTooltipElm();
        showDialogGuide();
      }
    };
    var destroyGuide = function destroyGuide() {
      var _highlightLayerRef$va, _overlayLayerRef$valu;
      destroyTooltipElm();
      destroyDialogTooltipElm();
      (_highlightLayerRef$va = highlightLayerRef.value) === null || _highlightLayerRef$va === void 0 || _highlightLayerRef$va.parentNode.removeChild(highlightLayerRef.value);
      (_overlayLayerRef$valu = overlayLayerRef.value) === null || _overlayLayerRef$valu === void 0 || _overlayLayerRef$valu.parentNode.removeChild(overlayLayerRef.value);
      utils_dom.removeClass(document.body, LOCK_CLASS.value);
    };
    var handleSkip = function handleSkip(e) {
      var _props2$onSkip;
      var total = stepsTotal.value;
      activated.value = false;
      setInnerCurrent(-1, {
        e: e,
        total: total
      });
      var eventParams = {
        e: e,
        current: innerCurrent.value,
        total: total
      };
      (_props2$onSkip = props2.onSkip) === null || _props2$onSkip === void 0 || _props2$onSkip.call(props2, eventParams);
      context.emit("skip", eventParams);
    };
    var handlePrev = function handlePrev(e) {
      var _props2$onPrevStepCli;
      var total = stepsTotal.value;
      setInnerCurrent(innerCurrent.value - 1, {
        e: e,
        total: total
      });
      var eventParams = {
        e: e,
        prev: innerCurrent.value - 1,
        current: innerCurrent.value,
        total: total
      };
      (_props2$onPrevStepCli = props2.onPrevStepClick) === null || _props2$onPrevStepCli === void 0 || _props2$onPrevStepCli.call(props2, eventParams);
      context.emit("prev-step-click", eventParams);
    };
    var handleNext = function handleNext(e) {
      var _props2$onNextStepCli;
      var total = stepsTotal.value;
      setInnerCurrent(innerCurrent.value + 1, {
        e: e,
        total: total
      });
      var eventParams = {
        e: e,
        next: innerCurrent.value + 1,
        current: innerCurrent.value,
        total: total
      };
      (_props2$onNextStepCli = props2.onNextStepClick) === null || _props2$onNextStepCli === void 0 || _props2$onNextStepCli.call(props2, eventParams);
      context.emit("next-step-click", eventParams);
    };
    var handleFinish = function handleFinish(e) {
      var _props2$onFinish;
      var total = stepsTotal.value;
      activated.value = false;
      setInnerCurrent(-1, {
        e: e,
        total: total
      });
      (_props2$onFinish = props2.onFinish) === null || _props2$onFinish === void 0 || _props2$onFinish.call(props2, {
        e: e,
        current: innerCurrent.value,
        total: total
      });
      context.emit("finish", {
        e: e,
        current: innerCurrent.value,
        total: total
      });
    };
    var initGuide = function initGuide() {
      var _props2$steps2;
      if (innerCurrent.value >= 0 && innerCurrent.value < ((_props2$steps2 = props2.steps) === null || _props2$steps2 === void 0 ? void 0 : _props2$steps2.length)) {
        if (!activated.value) {
          activated.value = true;
          utils_dom.addClass(document.body, LOCK_CLASS.value);
        }
        showGuide();
      }
    };
    VueCompositionAPI.watch(innerCurrent, function (val) {
      var _props2$steps3;
      if (val >= 0 && val < ((_props2$steps3 = props2.steps) === null || _props2$steps3 === void 0 ? void 0 : _props2$steps3.length)) {
        initGuide();
      } else {
        activated.value = false;
        destroyGuide();
      }
    });
    VueCompositionAPI.onMounted(function () {
      initGuide();
    });
    return {
      classPrefix: classPrefix,
      componentName: COMPONENT_NAME,
      innerCurrent: innerCurrent,
      isPopup: isPopup,
      currentElmIsFixed: currentElmIsFixed,
      currentStepInfo: currentStepInfo,
      stepsTotal: stepsTotal,
      handlePrev: handlePrev,
      handleNext: handleNext,
      handleSkip: handleSkip,
      handleFinish: handleFinish,
      getCurrentCrossProps: getCurrentCrossProps,
      global: global,
      highlightLayerRef: highlightLayerRef,
      overlayLayerRef: overlayLayerRef,
      referenceLayerRef: referenceLayerRef,
      currentHighlightLayerElm: currentHighlightLayerElm,
      dialogWrapperRef: dialogWrapperRef,
      dialogTooltipRef: dialogTooltipRef,
      activated: activated
    };
  },
  render: function render(h) {
    var _this = this;
    var stepsTotal = this.stepsTotal;
    var currentStepInfo = this.currentStepInfo;
    var globalConfig = this.global;
    var getCurrentCrossProps = this.getCurrentCrossProps;
    var renderTooltipTitle = function renderTooltipTitle(h2) {
      var currentStepInfo2 = _this.currentStepInfo;
      var functionTitle = isFunction.isFunction(currentStepInfo2.title) ? currentStepInfo2.title(h2) : void 0;
      var slotTitle = _this.$scopedSlots.title ? _this.$scopedSlots.title(h2) : void 0;
      var title = functionTitle || slotTitle || currentStepInfo2.title;
      return title ? h("div", {
        "class": "".concat(_this.componentName, "__title")
      }, [title]) : null;
    };
    var getHighlightContent = function getHighlightContent(h2) {
      var params = h2;
      params.currentStepInfo = _this.currentStepInfo;
      var highlightContent = _this.currentStepInfo.highlightContent;
      var node = highlightContent;
      if (isFunction.isFunction(highlightContent)) {
        node = highlightContent(params);
      } else if (_this.$scopedSlots.highlightContent) {
        node = _this.$scopedSlots.highlightContent(params);
      } else if (_this.$scopedSlots["highlight-content"]) {
        node = _this.$scopedSlots["highlight-content"](params);
      } else if (highlightContent) {
        node = h(node);
      }
      if (node) {
        node.props = node.props || {};
        node.props["class"] = "".concat(_this.componentName, "__highlight--mask ").concat(node.props["class"] || "");
      }
      return node;
    };
    var renderOverlayLayer = function renderOverlayLayer() {
      return h("div", {
        "ref": "overlayLayerRef",
        "directives": [{
          name: "transfer-dom",
          value: "body"
        }],
        "class": "".concat(_this.componentName, "__overlay"),
        "style": {
          zIndex: _this.zIndex - 2
        }
      });
    };
    var renderAction = function renderAction(mode) {
      var _getCurrentCrossProps, _getCurrentCrossProps2, _getCurrentCrossProps3, _this$finishButtonPro;
      var isLast = _this.innerCurrent === stepsTotal - 1;
      var isFirst = _this.innerCurrent === 0;
      var buttonSize = mode === "popup" ? "small" : "medium";
      return h("div", {
        "class": "".concat(_this.componentName, "__action")
      }, [!_this.hideSkip && !isLast && h(button_index.Button, {
        "class": "".concat(_this.componentName, "__skip"),
        "props": _objectSpread({}, _objectSpread({
          theme: "default",
          size: buttonSize,
          variant: "base",
          onClick: _this.handleSkip
        }, (_getCurrentCrossProps = getCurrentCrossProps("skipButtonProps")) !== null && _getCurrentCrossProps !== void 0 ? _getCurrentCrossProps : globalConfig.skipButtonProps))
      }), !_this.hidePrev && !isFirst && h(button_index.Button, {
        "class": "".concat(_this.componentName, "__prev"),
        "props": _objectSpread({}, _objectSpread({
          theme: "primary",
          size: buttonSize,
          variant: "base",
          onClick: _this.handlePrev
        }, (_getCurrentCrossProps2 = getCurrentCrossProps("prevButtonProps")) !== null && _getCurrentCrossProps2 !== void 0 ? _getCurrentCrossProps2 : globalConfig.prevButtonProps))
      }), !isLast && h(button_index.Button, {
        "class": "".concat(_this.componentName, "__next"),
        "props": _objectSpread({}, _objectSpread({
          theme: "primary",
          size: buttonSize,
          variant: "base",
          onClick: _this.handleNext
        }, (_getCurrentCrossProps3 = getCurrentCrossProps("nextButtonProps")) !== null && _getCurrentCrossProps3 !== void 0 ? _getCurrentCrossProps3 : globalConfig.nextButtonProps))
      }), isLast && h(button_index.Button, {
        "class": "".concat(_this.componentName, "__finish"),
        "props": _objectSpread({}, _objectSpread({
          theme: "primary",
          size: buttonSize,
          variant: "base",
          onClick: _this.handleFinish
        }, (_this$finishButtonPro = _this.finishButtonProps) !== null && _this$finishButtonPro !== void 0 ? _this$finishButtonPro : globalConfig.finishButtonProps))
      })]);
    };
    var renderTooltipBody = function renderTooltipBody(h2) {
      var stepBody = _this.currentStepInfo.body;
      var descBody;
      if (isFunction.isFunction(stepBody)) {
        descBody = stepBody(h2);
      } else if (_this.$scopedSlots.body) {
        var hParams = h2;
        Object.assign(hParams, {
          currentStepInfo: _this.currentStepInfo
        });
        descBody = _this.$scopedSlots.body(hParams);
      } else if (typeof stepBody === "string") {
        descBody = stepBody;
      } else {
        descBody = h(stepBody);
      }
      return descBody ? h("div", {
        "class": "".concat(_this.componentName, "__desc")
      }, [descBody]) : null;
    };
    var renderPopupContent = function renderPopupContent() {
      var footerClasses = ["".concat(_this.componentName, "__footer"), "".concat(_this.componentName, "__footer--popup")];
      var action = h("div", {
        "class": footerClasses
      }, [renderCounter(), renderAction("popup")]);
      return h("div", {
        "class": "".concat(_this.componentName, "__tooltip")
      }, [renderTooltipTitle(h), renderTooltipBody(h), action]);
    };
    var renderHighlightLayer = function renderHighlightLayer() {
      var style = {
        zIndex: _this.zIndex - 1
      };
      var highlightClass = ["".concat(_this.componentName, "__highlight"), "".concat(_this.componentName, "__highlight--").concat(_this.isPopup ? "popup" : "dialog"), "".concat(_this.componentName, "--").concat(_this.currentElmIsFixed && _this.isPopup ? "fixed" : "absolute")];
      var showOverlay = getCurrentCrossProps("showOverlay");
      var maskClass = ["".concat(_this.componentName, "__highlight--").concat(showOverlay ? "mask" : "nomask")];
      var innerHighlightContent = getHighlightContent(h);
      var showHighlightContent = Boolean(innerHighlightContent && _this.isPopup);
      return h("div", {
        "ref": "highlightLayerRef",
        "directives": [{
          name: "transfer-dom",
          value: "body"
        }],
        "class": highlightClass.concat(showHighlightContent ? [] : maskClass),
        "style": style
      }, [showHighlightContent && innerHighlightContent]);
    };
    var renderCounter = function renderCounter() {
      var popupSlotCounter = utils_renderTnode.renderTNodeJSX(_this, "counter", {
        params: {
          total: _this.stepsTotal,
          current: _this.innerCurrent
        }
      });
      var popupDefaultCounter = h("div", {
        "class": "".concat(_this.componentName, "__counter")
      }, [popupSlotCounter || "".concat(_this.innerCurrent + 1, "/").concat(_this.stepsTotal)]);
      return !_this.hideCounter ? popupDefaultCounter : null;
    };
    var renderDialogGuide = function renderDialogGuide() {
      var style = {
        zIndex: _this.zIndex
      };
      var wrapperClasses = ["".concat(_this.componentName, "__wrapper"), _defineProperty__default["default"]({}, "".concat(_this.componentName, "__wrapper--center"), currentStepInfo.placement === "center")];
      var dialogClasses = ["".concat(_this.componentName, "__reference"), "".concat(_this.componentName, "--absolute"), "".concat(_this.componentName, "__dialog"), _defineProperty__default["default"](_defineProperty__default["default"]({}, "".concat(_this.componentName, "__dialog--nomask"), !getCurrentCrossProps("showOverlay")), currentStepInfo.stepOverlayClass, !!currentStepInfo.stepOverlayClass)];
      var footerClasses = ["".concat(_this.componentName, "__footer"), "".concat(_this.componentName, "__footer--popup")];
      return h("div", [h("div", {
        "ref": "dialogWrapperRef",
        "directives": [{
          name: "transfer-dom",
          value: "body"
        }],
        "class": wrapperClasses,
        "style": style
      }, [h("div", {
        "ref": "dialogTooltipRef",
        "class": dialogClasses
      }, [renderTooltipTitle(h), renderTooltipBody(h), h("div", {
        "class": footerClasses
      }, [renderCounter(), renderAction("dialog")])])])]);
    };
    var renderPopupGuide = function renderPopupGuide() {
      var _currentStepInfo$popu;
      var content = currentStepInfo.content;
      var contentProps = {
        handlePrev: _this.handlePrev,
        handleNext: _this.handleNext,
        handleSkip: _this.handleSkip,
        handleFinish: _this.handleFinish,
        current: _this.innerCurrent,
        total: _this.stepsTotal
      };
      var hParams = h;
      hParams.currentStepInfo = _this.currentStepInfo;
      var renderBody;
      if (isFunction.isFunction(content)) {
        renderBody = function renderBody() {
          return content(hParams);
        };
      } else if (_this.$scopedSlots.content) {
        renderBody = function renderBody() {
          return _this.$scopedSlots.content(hParams);
        };
      } else if (typeof content === "string") {
        renderBody = content;
      } else if (content) {
        renderBody = function renderBody() {
          return h(content, helper.helper([{}, {
            "props": contentProps
          }]));
        };
      } else {
        renderBody = renderPopupContent;
      }
      var classes = ["".concat(_this.componentName, "__reference"), "".concat(_this.componentName, "--").concat(_this.currentElmIsFixed ? "fixed" : "absolute")];
      var innerClassName = [_defineProperty__default["default"]({}, "".concat(_this.classPrefix, "-guide__popup--content"), !!content)];
      return h(popup_index.Popup, helper.helper([{
        "attrs": {
          "visible": true,
          "show-arrow": !content,
          "zIndex": _this.zIndex,
          "placement": currentStepInfo.placement
        }
      }, {
        "props": currentStepInfo.popupProps
      }, {
        "attrs": {
          "content": renderBody,
          "overlayClassName": ["".concat(_this.componentName, "__popup"), currentStepInfo === null || currentStepInfo === void 0 ? void 0 : currentStepInfo.stepOverlayClass],
          "overlayInnerClassName": innerClassName.concat((_currentStepInfo$popu = currentStepInfo.popupProps) === null || _currentStepInfo$popu === void 0 ? void 0 : _currentStepInfo$popu.overlayInnerClassName)
        }
      }]), [h("div", {
        "ref": "referenceLayerRef",
        "directives": [{
          name: "transfer-dom",
          value: "body"
        }],
        "class": classes
      })]);
    };
    return this.activated ? h("div", [renderOverlayLayer(), renderHighlightLayer(), this.isPopup ? renderPopupGuide() : renderDialogGuide()]) : null;
  }
});

exports["default"] = _Guide;
//# sourceMappingURL=guide.js.map
