/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var VueCompositionAPI = require('@vue/composition-api');
var hooks_renderTnode = require('./render-tnode.js');
var isFunction = require('../_chunks/dep-ecccff93.js');
var camelCase = require('../_chunks/dep-7c854ec6.js');
var kebabCase = require('../_chunks/dep-47bca35e.js');
var isEmpty = require('../_chunks/dep-a6490a32.js');
require('../_chunks/dep-a4cecac4.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-738b4f21.js');
require('../_chunks/dep-a4308f57.js');
require('../_chunks/dep-fcf0662d.js');
require('../_chunks/dep-e4278c54.js');
require('../_chunks/dep-eceed11d.js');
require('../_chunks/dep-201f7798.js');
require('../_chunks/dep-d3015b4c.js');
require('../_chunks/dep-f8a85d6a.js');
require('../_chunks/dep-5b117689.js');
require('../_chunks/dep-6478392e.js');
require('../_chunks/dep-3eec664c.js');
require('../_chunks/dep-8b1e056e.js');
require('../_chunks/dep-5db8defc.js');
require('../_chunks/dep-6e4c473c.js');
require('../_chunks/dep-3d8ab37d.js');
require('../_chunks/dep-eeb2e214.js');
require('../_chunks/dep-6ad3de7c.js');

function handleSlots(slots, name, params) {
  var _slots$camelCase, _slots$kebabCase;
  var finaleParams = VueCompositionAPI.h;
  if (params) {
    Object.assign(finaleParams, params);
  }
  var node = (_slots$camelCase = slots[camelCase.camelCase(name)]) === null || _slots$camelCase === void 0 ? void 0 : _slots$camelCase.call(slots, finaleParams);
  if (node) return node;
  node = (_slots$kebabCase = slots[kebabCase.kebabCase(name)]) === null || _slots$kebabCase === void 0 ? void 0 : _slots$kebabCase.call(slots, finaleParams);
  if (node) return node;
  return null;
}
var useTNodeJSX = function useTNodeJSX() {
  var instance = VueCompositionAPI.getCurrentInstance();
  return function (name, options) {
    var params = hooks_renderTnode.getParams(options);
    var defaultNode = hooks_renderTnode.getDefaultNode(options);
    var slots = instance.setupContext.slots;
    var propsNode;
    if (Object.keys(instance.props).includes(name)) {
      propsNode = instance.props[name];
    }
    if (propsNode === false) return;
    if (propsNode === true) {
      return handleSlots(slots, name, params) || defaultNode;
    }
    if (isFunction.isFunction(propsNode)) return propsNode(VueCompositionAPI.h, params);
    var isPropsEmpty = [void 0, params, ""].includes(propsNode);
    if (isPropsEmpty && (slots[camelCase.camelCase(name)] || slots[kebabCase.kebabCase(name)])) {
      return handleSlots(slots, name, params);
    }
    return propsNode;
  };
};
var useTNodeDefault = function useTNodeDefault() {
  var renderTNodeJSX = useTNodeJSX();
  return function (name, options) {
    var defaultNode = hooks_renderTnode.getDefaultNode(options);
    return renderTNodeJSX(name, options) || defaultNode;
  };
};
var useContent = function useContent() {
  var renderTNodeJSX = useTNodeJSX();
  return function (name1, name2, options) {
    var params = hooks_renderTnode.getParams(options);
    var defaultNode = hooks_renderTnode.getDefaultNode(options);
    var toParams = params ? {
      params: params
    } : void 0;
    var node1 = renderTNodeJSX(name1, toParams);
    var node2 = renderTNodeJSX(name2, toParams);
    var res = isEmpty.isEmpty(node1) ? node2 : node1;
    return isEmpty.isEmpty(res) ? defaultNode : res;
  };
};

exports.useContent = useContent;
exports.useTNodeDefault = useTNodeDefault;
exports.useTNodeJSX = useTNodeJSX;
//# sourceMappingURL=tnode.js.map
