/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var VueCompositionAPI = require('@vue/composition-api');

function useFormDisabled() {
  var formDisabled = VueCompositionAPI.computed(function () {
    var currentInstance = VueCompositionAPI.getCurrentInstance();
    if (!currentInstance) return null;
    var parent = currentInstance.parent;
    while (parent) {
      if (parent.proxy.$options.name === "TForm") {
        return parent.props.disabled;
      }
      parent = parent.parent;
    }
    return false;
  });
  return {
    formDisabled: formDisabled
  };
}

exports["default"] = useFormDisabled;
exports.useFormDisabled = useFormDisabled;
//# sourceMappingURL=useFormDisabled.js.map
