/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _slicedToArray = require('@babel/runtime/helpers/slicedToArray');
var VueCompositionAPI = require('@vue/composition-api');
var _common_js_upload_utils = require('../_common/js/upload/utils.js');
require('../_common/js/log/log.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _slicedToArray__default = /*#__PURE__*/_interopDefaultLegacy(_slicedToArray);

function useImagePreviewUrl(imgUrl) {
  var previewUrl = VueCompositionAPI.ref("");
  VueCompositionAPI.watch([imgUrl], function (_ref, _ref2) {
    var _ref3 = _slicedToArray__default["default"](_ref, 1),
      imgUrl2 = _ref3[0];
    var _ref4 = _slicedToArray__default["default"](_ref2, 1),
      preImgUrl = _ref4[0];
    if (preImgUrl === imgUrl2) return;
    if (typeof imgUrl2 === "string") {
      previewUrl.value = imgUrl2;
      return;
    }
    _common_js_upload_utils.getFileUrlByFileRaw(imgUrl2).then(function (url) {
      previewUrl.value = url;
    });
  }, {
    immediate: true
  });
  return {
    previewUrl: previewUrl
  };
}

exports["default"] = useImagePreviewUrl;
exports.useImagePreviewUrl = useImagePreviewUrl;
//# sourceMappingURL=useImagePreviewUrl.js.map
