import { ComputedRef } from '@vue/composition-api';
import { ImageScale } from './type';
interface InitTransform {
    translateX: number;
    translateY: number;
}
export declare function useDrag(initTransform: InitTransform): {
    transform: import("@vue/composition-api").Ref<{
        translateX: number;
        translateY: number;
    }>;
    mouseDownHandler: (e: MouseEvent) => void;
    resetTransform: () => void;
};
export declare function useMirror(): {
    mirror: import("@vue/composition-api").Ref<number>;
    onMirror: () => void;
    resetMirror: () => void;
};
export declare function useScale(imageScale: ComputedRef<ImageScale>): {
    scale: import("@vue/composition-api").Ref<number>;
    onZoomIn: () => void;
    onZoomOut: () => void;
    resetScale: () => void;
};
export declare function useRotate(): {
    rotate: import("@vue/composition-api").Ref<number>;
    onRotate: () => void;
    resetRotate: () => void;
};
export {};
