/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _slicedToArray = require('@babel/runtime/helpers/slicedToArray');
var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var VueCompositionAPI = require('@vue/composition-api');
var tdesignIconsVue = require('tdesign-icons-vue');
var imageViewer_props = require('./props.js');
var imageViewer_base_Container = require('./base/Container.js');
var imageViewer_base_ImageModalIcon = require('./base/ImageModalIcon.js');
var imageViewer_base_ImageViewerUtils = require('./base/ImageViewerUtils.js');
var imageViewer_base_ImageItem = require('./base/ImageItem.js');
var imageViewer_base_ImageViewerModal = require('./base/ImageViewerModal.js');
var hooks_useVModel = require('../hooks/useVModel.js');
var hooks_useDefaultValue = require('../hooks/useDefaultValue.js');
var hooks_useConfig = require('../hooks/useConfig.js');
var utils_renderTnode = require('../utils/render-tnode.js');
var utils_helper = require('../utils/helper.js');
var imageViewer_hooks = require('./hooks.js');
var imageViewer_utils = require('./utils.js');
var imageViewer_const = require('./const.js');
var image_index = require('../image/index.js');
require('vue');
require('../utils/dom.js');
require('raf');
require('../utils/easing.js');
require('../_chunks/dep-738b4f21.js');
require('../_chunks/dep-a4308f57.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-fcf0662d.js');
require('../_chunks/dep-e4278c54.js');
require('../hooks/tnode.js');
require('../hooks/render-tnode.js');
require('../_chunks/dep-a4cecac4.js');
require('../_chunks/dep-7c854ec6.js');
require('../_chunks/dep-eceed11d.js');
require('../_chunks/dep-201f7798.js');
require('../_chunks/dep-d3015b4c.js');
require('../_chunks/dep-f8a85d6a.js');
require('../_chunks/dep-5b117689.js');
require('../_chunks/dep-6478392e.js');
require('../_chunks/dep-47bca35e.js');
require('../_chunks/dep-ecccff93.js');
require('../_chunks/dep-a6490a32.js');
require('../_chunks/dep-3eec664c.js');
require('../_chunks/dep-8b1e056e.js');
require('../_chunks/dep-5db8defc.js');
require('../_chunks/dep-6e4c473c.js');
require('../_chunks/dep-3d8ab37d.js');
require('../_chunks/dep-eeb2e214.js');
require('../_chunks/dep-6ad3de7c.js');
require('../tooltip/index.js');
require('../tooltip/tooltip.js');
require('../_chunks/dep-ece3c062.js');
require('../tooltip/props.js');
require('../popup/props.js');
require('../popup/popup.js');
require('@popperjs/core');
require('../_common/js/utils/setStyle.js');
require('../popup/container.js');
require('../config-provider/config-receiver.js');
require('../_chunks/dep-07fb8c0e.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-a4a18104.js');
require('../_chunks/dep-27dd8cc6.js');
require('dayjs');
require('../_chunks/dep-87c765cc.js');
require('../_chunks/dep-75cd6d52.js');
require('../_chunks/dep-b1a02818.js');
require('../_chunks/dep-ab142eaf.js');
require('../_chunks/dep-234b7c02.js');
require('../_chunks/dep-a4747856.js');
require('../_chunks/dep-932dd69e.js');
require('../_chunks/dep-9f4caea4.js');
require('../_chunks/dep-dbd838d6.js');
require('../_chunks/dep-b3120c1b.js');
require('../_chunks/dep-68ba2357.js');
require('../_chunks/dep-173eb46c.js');
require('../utils/mixins.js');
require('../utils/event.js');
require('../popup/utils.js');
require('../_chunks/dep-f3761329.js');
require('../_chunks/dep-848a5a32.js');
require('../utils/map-props.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('../utils/withInstall.js');
require('@babel/runtime/helpers/readOnlyError');
require('../config-provider/useConfig.js');
require('../_common/js/input-number/large-number.js');
require('../_common/js/log/log.js');
require('../_chunks/dep-aa0a4aac.js');
require('../hooks/useImagePreviewUrl.js');
require('../_common/js/upload/utils.js');
require('../dialog/index.js');
require('../dialog/dialog.js');
require('../button/index.js');
require('../button/button.js');
require('../loading/index.js');
require('../loading/directive.js');
require('../loading/plugin.js');
require('../loading/loading.js');
require('../loading/icon/gradient.js');
require('../_common/js/loading/circle-adapter.js');
require('../_common/js/utils/helper.js');
require('@babel/runtime/helpers/toConsumableArray');
require('../_chunks/dep-62de1188.js');
require('../_chunks/dep-867c284e.js');
require('../utils/transfer-dom.js');
require('../loading/props.js');
require('../config.js');
require('../_chunks/dep-013a3403.js');
require('../_chunks/dep-8cb0d589.js');
require('../_chunks/dep-d23147db.js');
require('../_chunks/dep-de60f5aa.js');
require('../_chunks/dep-63b02f7b.js');
require('../_chunks/dep-bebcd284.js');
require('../_chunks/dep-315a67f0.js');
require('../_chunks/dep-f84d1ea5.js');
require('../_chunks/dep-362bc4d7.js');
require('../_chunks/dep-2e32c1f2.js');
require('../_chunks/dep-f14aac54.js');
require('../button/props.js');
require('../utils/ripple.js');
require('../dialog/actions.js');
require('../dialog/props.js');
require('../hooks/useDestroyOnClose.js');
require('../dialog/stack.js');
require('../_common/js/utils/getScrollbarWidth.js');
require('../_chunks/dep-13309278.js');
require('../dialog/plugin.js');
require('../config-provider/config-provider.js');
require('../config-provider/props.js');
require('../_chunks/dep-f45125c9.js');
require('../_chunks/dep-f33eb57d.js');
require('../image/image.js');
require('../_common/js/utils/observe.js');
require('../image/props.js');
require('../space/index.js');
require('../space/space.js');
require('../space/props.js');
require('../_chunks/dep-6dc0a916.js');
require('../_chunks/dep-b5c96567.js');
require('../_chunks/dep-a9e7deb2.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _slicedToArray__default = /*#__PURE__*/_interopDefaultLegacy(_slicedToArray);
var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var _ImageViewer = VueCompositionAPI.defineComponent({
  name: "TImageViewer",
  props: _objectSpread({}, imageViewer_props["default"]),
  model: {
    prop: "visible",
    event: "change"
  },
  setup: function setup(props2, _ref) {
    var _props2$defaultIndex;
    var emit = _ref.emit,
      listeners = _ref.listeners;
    var classPrefix = hooks_useConfig.usePrefixClass();
    var COMPONENT_NAME = hooks_useConfig.usePrefixClass("image-viewer");
    var isExpand = VueCompositionAPI.ref(true);
    var showOverlayValue = VueCompositionAPI.computed(function () {
      return imageViewer_utils.getOverlay(props2);
    });
    var _toRefs = VueCompositionAPI.toRefs(props2),
      index = _toRefs.index,
      visible = _toRefs.visible;
    var _useDefaultValue = hooks_useDefaultValue["default"](index, (_props2$defaultIndex = props2.defaultIndex) !== null && _props2$defaultIndex !== void 0 ? _props2$defaultIndex : 0, props2.onIndexChange, "index", "index-change"),
      _useDefaultValue2 = _slicedToArray__default["default"](_useDefaultValue, 2),
      indexValue = _useDefaultValue2[0],
      setIndexValue = _useDefaultValue2[1];
    var _useVModel = hooks_useVModel.useVModel(visible, props2.defaultVisible, function () {}, "change", "visible"),
      _useVModel2 = _slicedToArray__default["default"](_useVModel, 2),
      visibleValue = _useVModel2[0],
      setVisibleValue = _useVModel2[1];
    var rootClass = VueCompositionAPI.computed(function () {
      return ["".concat(COMPONENT_NAME.value)];
    });
    var wrapClass = VueCompositionAPI.computed(function () {
      return [COMPONENT_NAME.value, "".concat(COMPONENT_NAME.value, "-preview-image"), _defineProperty__default["default"]({}, "".concat(classPrefix.value, "-is-hide"), !visibleValue.value)];
    });
    var headerClass = VueCompositionAPI.computed(function () {
      return ["".concat(classPrefix.value, "-image-viewer__modal-header"), _defineProperty__default["default"]({}, "".concat(classPrefix.value, "-is-show"), isExpand.value)];
    });
    var zIndexValue = VueCompositionAPI.computed(function () {
      var _props2$zIndex;
      return (_props2$zIndex = props2.zIndex) !== null && _props2$zIndex !== void 0 ? _props2$zIndex : 2600;
    });
    var toggleExpand = function toggleExpand() {
      isExpand.value = !isExpand.value;
    };
    var imageScaleRef = VueCompositionAPI.computed(function () {
      var _props2$imageScale;
      return (_props2$imageScale = props2.imageScale) !== null && _props2$imageScale !== void 0 ? _props2$imageScale : imageViewer_const.DEFAULT_IMAGE_SCALE;
    });
    var _useMirror = imageViewer_hooks.useMirror(),
      mirror = _useMirror.mirror,
      onMirror = _useMirror.onMirror,
      resetMirror = _useMirror.resetMirror;
    var _useScale = imageViewer_hooks.useScale(imageScaleRef),
      scale = _useScale.scale,
      onZoomIn = _useScale.onZoomIn,
      onZoomOut = _useScale.onZoomOut,
      resetScale = _useScale.resetScale;
    var _useRotate = imageViewer_hooks.useRotate(),
      rotate = _useRotate.rotate,
      onRotate = _useRotate.onRotate,
      resetRotate = _useRotate.resetRotate;
    var onRest = function onRest() {
      resetMirror();
      resetScale();
      resetRotate();
    };
    var imagesList = VueCompositionAPI.computed(function () {
      return imageViewer_utils.formatImages(props2.images);
    });
    var currentImage = VueCompositionAPI.computed(function () {
      var _imagesList$value$ind;
      return (_imagesList$value$ind = imagesList.value[indexValue.value]) !== null && _imagesList$value$ind !== void 0 ? _imagesList$value$ind : {
        mainImage: ""
      };
    });
    var prevImage = function prevImage() {
      var newIndex = indexValue.value - 1;
      onRest();
      setIndexValue(newIndex < 0 ? 0 : newIndex, {
        trigger: "prev"
      });
    };
    var nextImage = function nextImage() {
      var newIndex = indexValue.value + 1;
      onRest();
      setIndexValue(newIndex >= imagesList.value.length ? indexValue.value : newIndex, {
        trigger: "next"
      });
    };
    var onImgClick = function onImgClick(i) {
      setIndexValue(i, {
        trigger: "current"
      });
    };
    var onDownloadClick = function onDownloadClick(url) {
      if (props2.onDownload || listeners.download) {
        var _props2$onDownload;
        (_props2$onDownload = props2.onDownload) === null || _props2$onDownload === void 0 || _props2$onDownload.call(props2, url);
        emit("download", url);
        return;
      }
      imageViewer_utils.downloadFile(url);
    };
    var openHandler = function openHandler() {
      setVisibleValue(true);
    };
    var onCloseHandle = function onCloseHandle(ctx) {
      var _props2$onClose;
      setVisibleValue(false);
      unmountContent();
      (_props2$onClose = props2.onClose) === null || _props2$onClose === void 0 || _props2$onClose.call(props2, ctx);
      emit("close", ctx);
    };
    var closeBtnAction = function closeBtnAction(e) {
      onCloseHandle({
        e: e,
        trigger: "close-btn"
      });
    };
    var clickOverlayHandler = function clickOverlayHandler(e) {
      if (props2.closeOnOverlay) {
        onCloseHandle({
          e: e,
          trigger: "overlay"
        });
      }
    };
    var keydownHandler = function keydownHandler(e) {
      e.stopPropagation();
      switch (e.code) {
        case imageViewer_const.EVENT_CODE.left:
          prevImage();
          break;
        case imageViewer_const.EVENT_CODE.right:
          nextImage();
          break;
        case imageViewer_const.EVENT_CODE.up:
          onZoomIn();
          break;
        case imageViewer_const.EVENT_CODE.down:
          onZoomOut();
          break;
        case imageViewer_const.EVENT_CODE.esc:
          if (props2.closeOnEscKeydown) {
            onCloseHandle({
              e: e,
              trigger: "esc"
            });
          }
          break;
      }
    };
    var containerRef = VueCompositionAPI.ref();
    var mountContent = function mountContent() {
      if (containerRef) {
        containerRef.value.mountContent();
      }
    };
    var unmountContent = function unmountContent() {
      if (containerRef) {
        containerRef.value.unmountContent();
      }
    };
    var divRef = VueCompositionAPI.ref();
    var getFocus = function getFocus() {
      if (divRef.value) {
        divRef.value.focus();
      }
    };
    VueCompositionAPI.watch(function () {
      return visibleValue.value;
    }, function (val) {
      if (val) {
        onRest();
        mountContent();
        getFocus();
      }
    });
    var onWheel = function onWheel(e) {
      e.preventDefault();
      var deltaY = e.deltaY;
      deltaY > 0 ? onZoomOut() : onZoomIn();
    };
    var transStyle = VueCompositionAPI.computed(function () {
      return utils_helper.setTransform("translateX(calc(-".concat(indexValue.value, " * (40px / 9 * 16 + 4px)))"));
    });
    var isMultipleImg = VueCompositionAPI.computed(function () {
      return imagesList.value.length > 1;
    });
    return {
      COMPONENT_NAME: COMPONENT_NAME,
      rootClass: rootClass,
      classPrefix: classPrefix,
      prevImage: prevImage,
      nextImage: nextImage,
      zIndexValue: zIndexValue,
      visibleValue: visibleValue,
      indexValue: indexValue,
      imagesList: imagesList,
      showOverlayValue: showOverlayValue,
      wrapClass: wrapClass,
      rotate: rotate,
      mirror: mirror,
      currentImage: currentImage,
      onRotate: onRotate,
      onZoomIn: onZoomIn,
      onZoomOut: onZoomOut,
      onMirror: onMirror,
      onRest: onRest,
      onDownloadClick: onDownloadClick,
      openHandler: openHandler,
      onCloseHandle: onCloseHandle,
      onWheel: onWheel,
      clickOverlayHandler: clickOverlayHandler,
      headerClass: headerClass,
      toggleExpand: toggleExpand,
      transStyle: transStyle,
      onImgClick: onImgClick,
      closeBtnAction: closeBtnAction,
      scale: scale,
      isMultipleImg: isMultipleImg,
      containerRef: containerRef,
      keydownHandler: keydownHandler,
      divRef: divRef
    };
  },
  methods: {
    renderHeader: function renderHeader() {
      var _this = this;
      var h = this.$createElement;
      return h("div", {
        "class": this.headerClass
      }, [h(imageViewer_base_ImageModalIcon["default"], {
        "attrs": {
          "icon": function icon() {
            return h(tdesignIconsVue.ChevronDownIcon);
          },
          "clickHandler": this.toggleExpand
        },
        "class": "".concat(this.COMPONENT_NAME, "__header-pre-bt")
      }), h("div", {
        "class": "".concat(this.COMPONENT_NAME, "__header-prev")
      }, [h("div", {
        "class": "".concat(this.COMPONENT_NAME, "__header-trans"),
        "style": this.transStyle
      }, [this.imagesList.map(function (image, index) {
        return h("div", {
          "key": index,
          "class": ["".concat(_this.COMPONENT_NAME, "__header-box"), _defineProperty__default["default"]({}, "".concat(_this.classPrefix, "-is-active"), index === _this.indexValue)]
        }, [h(image_index.Image, {
          "attrs": {
            "alt": "",
            "error": "",
            "src": image.thumbnail || image.mainImage
          },
          "class": "".concat(_this.COMPONENT_NAME, "__header-img"),
          "on": {
            "click": function click() {
              return _this.onImgClick(index);
            }
          }
        })]);
      })])])]);
    },
    renderNavigationArrow: function renderNavigationArrow(type) {
      var h = this.$createElement;
      var rotateDeg = type === "prev" ? 0 : 180;
      var _icon = utils_renderTnode.renderTNodeJSX(this, "navigationArrow", h(tdesignIconsVue.ChevronLeftIcon, {
        "style": utils_helper.setTransform("rotate(".concat(rotateDeg, "deg)")),
        "attrs": {
          "size": "24px"
        }
      }));
      return h(imageViewer_base_ImageModalIcon["default"], {
        "class": "".concat(this.COMPONENT_NAME, "__modal-").concat(type, "-bt"),
        "attrs": {
          "clickHandler": type === "prev" ? this.prevImage : this.nextImage,
          "icon": function icon() {
            return _icon;
          }
        }
      });
    },
    renderModal: function renderModal() {
      var h = this.$createElement;
      return h(imageViewer_base_ImageViewerModal["default"], {
        "attrs": {
          "zIndex": this.zIndexValue,
          "visible": this.visibleValue,
          "index": this.indexValue,
          "images": this.imagesList,
          "scale": this.scale,
          "rotate": this.rotate,
          "mirror": this.mirror,
          "currentImage": this.currentImage,
          "rotateHandler": this.onRotate,
          "zoomInHandler": this.onZoomIn,
          "zoomOutHandler": this.onZoomOut,
          "mirrorHandler": this.onMirror,
          "downloadHandler": this.onDownloadClick,
          "resetHandler": this.onRest,
          "closeHandler": this.onCloseHandle,
          "draggable": this.draggable,
          "showOverlay": this.showOverlayValue,
          "closeBtn": this.closeBtn,
          "imageReferrerpolicy": this.imageReferrerpolicy
        }
      });
    },
    renderCloseBtn: function renderCloseBtn() {
      var h = this.$createElement;
      if (this.closeBtn === false) {
        return;
      }
      return h("div", {
        "class": ["".concat(this.COMPONENT_NAME, "__modal-icon"), "".concat(this.COMPONENT_NAME, "__modal-close-bt")],
        "on": {
          "click": this.closeBtnAction
        }
      }, [utils_renderTnode.renderTNodeJSX(this, "closeBtn", h(tdesignIconsVue.CloseIcon, {
        "attrs": {
          "size": "24px"
        }
      }))]);
    },
    renderViewer: function renderViewer() {
      var h = this.$createElement;
      return h("div", {
        "attrs": {
          "tabindex": -1
        },
        "on": {
          "keydown": this.keydownHandler,
          "wheel": this.onWheel
        },
        "ref": "divRef",
        "class": this.wrapClass,
        "style": {
          zIndex: this.zIndexValue
        }
      }, [!!this.showOverlayValue && h("div", {
        "class": "".concat(this.COMPONENT_NAME, "__modal-mask"),
        "on": {
          "click": this.clickOverlayHandler
        }
      }), this.isMultipleImg && this.renderHeader(), this.isMultipleImg && this.renderNavigationArrow("prev"), this.isMultipleImg && this.renderNavigationArrow("next"), this.isMultipleImg && h("div", {
        "class": "".concat(this.COMPONENT_NAME, "__modal-index")
      }, [utils_renderTnode.renderTNodeJSX(this, "title"), "".concat(this.indexValue + 1, "/").concat(this.imagesList.length)]), this.renderCloseBtn(), h(imageViewer_base_ImageViewerUtils["default"], {
        "attrs": {
          "zoomInHandler": this.onZoomIn,
          "zoomOutHandler": this.onZoomOut,
          "mirrorHandler": this.onMirror,
          "downloadHandler": this.onDownloadClick,
          "resetHandler": this.onRest,
          "rotateHandler": this.onRotate,
          "scale": this.scale,
          "currentImage": this.currentImage
        }
      }), h(imageViewer_base_ImageItem["default"], {
        "attrs": {
          "scale": this.scale,
          "rotate": this.rotate,
          "mirror": this.mirror,
          "src": this.currentImage.mainImage,
          "placementSrc": this.currentImage.thumbnail,
          "imageReferrerpolicy": this.imageReferrerpolicy
        }
      })]);
    }
  },
  render: function render() {
    var h = arguments[0];
    return h(imageViewer_base_Container["default"], {
      "ref": "containerRef",
      "attrs": {
        "mode": this.mode,
        "renderModal": this.renderModal,
        "renderViewer": this.renderViewer
      }
    }, [utils_renderTnode.renderTNodeJSX(this, "trigger", {
      params: {
        open: this.openHandler
      }
    })]);
  }
});

exports["default"] = _ImageViewer;
//# sourceMappingURL=image-viewer.js.map
