/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var VueCompositionAPI = require('@vue/composition-api');
var components = require('./_chunks/dep-441947f3.js');
var button_index = require('./button/index.js');
var icon_index = require('./icon/index.js');
var link_index = require('./link/index.js');
var grid_index = require('./grid/index.js');
var layout_index = require('./layout/index.js');
var divider_index = require('./divider/index.js');
var space_index = require('./space/index.js');
var affix_index = require('./affix/index.js');
var anchor_index = require('./anchor/index.js');
var backTop_index = require('./back-top/index.js');
var breadcrumb_index = require('./breadcrumb/index.js');
var dropdown_index = require('./dropdown/index.js');
var menu_index = require('./menu/index.js');
var pagination_index = require('./pagination/index.js');
var steps_index = require('./steps/index.js');
var stickyTool_index = require('./sticky-tool/index.js');
var tabs_index = require('./tabs/index.js');
var autoComplete_index = require('./auto-complete/index.js');
var cascader_index = require('./cascader/index.js');
var checkbox_index = require('./checkbox/index.js');
var colorPicker_index = require('./color-picker/index.js');
var datePicker_index = require('./date-picker/index.js');
var form_index = require('./form/index.js');
var inputAdornment_index = require('./input-adornment/index.js');
var input_index = require('./input/index.js');
var rangeInput_index = require('./range-input/index.js');
var inputNumber_index = require('./input-number/index.js');
var radio_index = require('./radio/index.js');
var select_index = require('./select/index.js');
var slider_index = require('./slider/index.js');
var switch_index = require('./switch/index.js');
var tagInput_index = require('./tag-input/index.js');
var selectInput_index = require('./select-input/index.js');
var textarea_index = require('./textarea/index.js');
var transfer_index = require('./transfer/index.js');
var timePicker_interface = require('./time-picker/interface.js');
var timePicker_index = require('./time-picker/index.js');
var treeSelect_index = require('./tree-select/index.js');
var avatar_index = require('./avatar/index.js');
var badge_index = require('./badge/index.js');
var calendar_index = require('./calendar/index.js');
var card_index = require('./card/index.js');
var comment_index = require('./comment/index.js');
var descriptions_index = require('./descriptions/index.js');
var empty_index = require('./empty/index.js');
var image_index = require('./image/index.js');
var imageViewer_index = require('./image-viewer/index.js');
var list_index = require('./list/index.js');
var loading_plugin = require('./loading/plugin.js');
var loading_directive = require('./loading/directive.js');
var loading_index = require('./loading/index.js');
var progress_index = require('./progress/index.js');
var skeleton_index = require('./skeleton/index.js');
var statistic_index = require('./statistic/index.js');
var swiper_index = require('./swiper/index.js');
var table_index = require('./table/index.js');
var tag_index = require('./tag/index.js');
var tooltip_index = require('./tooltip/index.js');
var tree_index = require('./tree/index.js');
var watermark_index = require('./watermark/index.js');
var collapse_index = require('./collapse/index.js');
var rate_index = require('./rate/index.js');
var timeline_index = require('./timeline/index.js');
var alert_index = require('./alert/index.js');
var dialog_plugin = require('./dialog/plugin.js');
var dialog_index = require('./dialog/index.js');
var drawer_plugin = require('./drawer/plugin.js');
var drawer_index = require('./drawer/index.js');
var guide_index = require('./guide/index.js');
var message_plugin = require('./message/plugin.js');
var message_index = require('./message/index.js');
var notification_plugin = require('./notification/plugin.js');
var notification_index = require('./notification/index.js');
var popconfirm_index = require('./popconfirm/index.js');
var popup_plugin = require('./popup/plugin.js');
var popup_index = require('./popup/index.js');
var upload_index = require('./upload/index.js');
var configProvider_index = require('./config-provider/index.js');
require('./button/button.js');
require('@babel/runtime/helpers/defineProperty');
require('./button/props.js');
require('./utils/render-tnode.js');
require('@babel/runtime/helpers/readOnlyError');
require('@babel/runtime/helpers/typeof');
require('vue');
require('./_chunks/dep-7c854ec6.js');
require('./_chunks/dep-eceed11d.js');
require('./_chunks/dep-201f7798.js');
require('./_chunks/dep-a4308f57.js');
require('./_chunks/dep-fcf0662d.js');
require('./_chunks/dep-d3015b4c.js');
require('./_chunks/dep-e4278c54.js');
require('./_chunks/dep-f8a85d6a.js');
require('./_chunks/dep-5b117689.js');
require('./_chunks/dep-6478392e.js');
require('./_chunks/dep-47bca35e.js');
require('./utils/ripple.js');
require('./_common/js/utils/setStyle.js');
require('./config.js');
require('./config-provider/config-receiver.js');
require('./_chunks/dep-07fb8c0e.js');
require('./_common/js/global-config/default-config.js');
require('./_common/js/global-config/locale/zh_CN.js');
require('./_chunks/dep-a4a18104.js');
require('./_chunks/dep-27dd8cc6.js');
require('dayjs');
require('./_chunks/dep-87c765cc.js');
require('./_chunks/dep-75cd6d52.js');
require('./_chunks/dep-b1a02818.js');
require('./_chunks/dep-3d8ab37d.js');
require('./_chunks/dep-ecccff93.js');
require('./_chunks/dep-a4cecac4.js');
require('./_chunks/dep-ab142eaf.js');
require('./_chunks/dep-6ad3de7c.js');
require('./_chunks/dep-8b1e056e.js');
require('./_chunks/dep-5db8defc.js');
require('./_chunks/dep-6e4c473c.js');
require('./_chunks/dep-234b7c02.js');
require('./_chunks/dep-a4747856.js');
require('./_chunks/dep-932dd69e.js');
require('./_chunks/dep-9f4caea4.js');
require('./_chunks/dep-dbd838d6.js');
require('./_chunks/dep-b3120c1b.js');
require('./_chunks/dep-68ba2357.js');
require('./_chunks/dep-173eb46c.js');
require('./utils/mixins.js');
require('./loading/loading.js');
require('./loading/icon/gradient.js');
require('./_common/js/loading/circle-adapter.js');
require('./_common/js/utils/helper.js');
require('@babel/runtime/helpers/toConsumableArray');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/slicedToArray');
require('./_chunks/dep-62de1188.js');
require('./_chunks/dep-867c284e.js');
require('./_chunks/dep-738b4f21.js');
require('./_chunks/dep-aa0a4aac.js');
require('./utils/dom.js');
require('raf');
require('./utils/easing.js');
require('./utils/transfer-dom.js');
require('./loading/props.js');
require('./_chunks/dep-013a3403.js');
require('./_chunks/dep-8cb0d589.js');
require('./_chunks/dep-d23147db.js');
require('./_chunks/dep-de60f5aa.js');
require('./_chunks/dep-63b02f7b.js');
require('./_chunks/dep-bebcd284.js');
require('./_chunks/dep-3eec664c.js');
require('./_chunks/dep-eeb2e214.js');
require('./_chunks/dep-315a67f0.js');
require('./_chunks/dep-f84d1ea5.js');
require('./_chunks/dep-362bc4d7.js');
require('./_chunks/dep-2e32c1f2.js');
require('./_chunks/dep-f14aac54.js');
require('./utils/withInstall.js');
require('tdesign-icons-vue');
require('./link/link.js');
require('./link/props.js');
require('./grid/col.js');
require('./utils/responsive.js');
require('./grid/col-props.js');
require('./grid/row.js');
require('./_chunks/dep-ece3c062.js');
require('./grid/row-props.js');
require('./layout/layout.js');
require('./layout/header.js');
require('./layout/header-props.js');
require('./layout/footer.js');
require('./layout/footer-props.js');
require('./layout/aside.js');
require('./layout/aside-props.js');
require('./layout/content.js');
require('./layout/content-props.js');
require('./divider/divider.js');
require('./divider/props.js');
require('./space/space.js');
require('./space/props.js');
require('./hooks/useConfig.js');
require('./config-provider/useConfig.js');
require('./affix/affix.js');
require('./affix/props.js');
require('./anchor/anchor.js');
require('@babel/runtime/helpers/asyncToGenerator');
require('@babel/runtime/regenerator');
require('./anchor/utils.js');
require('./anchor/props.js');
require('./anchor/anchor-item.js');
require('./anchor/anchor-item-props.js');
require('./_chunks/dep-a6490a32.js');
require('./anchor/anchor-target.js');
require('./utils/clipboard.js');
require('clipboard');
require('./anchor/anchor-target-props.js');
require('./message/messageList.js');
require('./message/const.js');
require('./message/message.js');
require('./message/props.js');
require('./message/animation.js');
require('./popup/popup.js');
require('@popperjs/core');
require('./utils/helper.js');
require('./popup/props.js');
require('./popup/container.js');
require('./utils/event.js');
require('./popup/utils.js');
require('./_chunks/dep-f3761329.js');
require('./_chunks/dep-848a5a32.js');
require('./utils/map-props.js');
require('./_common/js/log/log.js');
require('./back-top/back-top.js');
require('./hooks/useGlobalIcon.js');
require('./back-top/props.js');
require('./breadcrumb/breadcrumb.js');
require('./breadcrumb/props.js');
require('./breadcrumb/breadcrumb-item.js');
require('./breadcrumb/breadcrumb-item-props.js');
require('./tooltip/tooltip.js');
require('./tooltip/props.js');
require('./dropdown/dropdown-item.js');
require('./dropdown/dropdown-item-props.js');
require('./hooks/tnode.js');
require('./hooks/render-tnode.js');
require('./dropdown/dropdown.js');
require('./dropdown/dropdown-menu.js');
require('./dropdown/props.js');
require('./dropdown/hooks/useDropdownOptions.js');
require('./_chunks/dep-6dc0a916.js');
require('./_chunks/dep-f33eb57d.js');
require('./_chunks/dep-b5c96567.js');
require('./_chunks/dep-a9e7deb2.js');
require('./menu/menu.js');
require('./menu/props.js');
require('./menu/v-menu.js');
require('@babel/runtime/helpers/classCallCheck');
require('@babel/runtime/helpers/createClass');
require('./menu/head-menu.js');
require('./menu/head-menu-props.js');
require('./tabs/tabs.js');
require('./tabs/props.js');
require('./tabs/tab-panel.js');
require('./tabs/tab-panel-props.js');
require('./hooks/useDestroyOnClose.js');
require('./tabs/tab-nav.js');
require('./tabs/tab-nav-item.js');
require('./_common/js/tabs/base.js');
require('./menu/submenu.js');
require('./menu/submenu-props.js');
require('./common-components/fake-arrow.js');
require('./hooks/useCollapseAnimation.js');
require('./menu/menu-item.js');
require('./menu/menu-item-props.js');
require('./menu/menu-group.js');
require('./menu/menu-group-props.js');
require('./pagination/pagination.js');
require('./pagination/props.js');
require('./input-number/input-number.js');
require('./input-number/props.js');
require('./input-number/useInputNumber.js');
require('./hooks/useCommonClassName.js');
require('./hooks/useVModel.js');
require('./_common/js/input-number/number.js');
require('./_common/js/input-number/large-number.js');
require('./hooks/useFormDisabled.js');
require('./input/input.js');
require('./input/props.js');
require('./input/input-group.js');
require('./select/select.js');
require('./hooks/useDefaultValue.js');
require('./select/props.js');
require('./select/option.js');
require('./select/option-props.js');
require('./hooks/useLazyLoad.js');
require('./_common/js/utils/observe.js');
require('./select/util.js');
require('./_chunks/dep-f45125c9.js');
require('./checkbox/group.js');
require('./checkbox/checkbox.js');
require('./checkbox/props.js');
require('./checkbox/constants.js');
require('./checkbox/store.js');
require('./checkbox/hooks/useKeyboardEvent.js');
require('./_common/js/common.js');
require('./hooks/useElementLazyRender.js');
require('./checkbox/checkbox-group-props.js');
require('./_chunks/dep-e83685df.js');
require('./_chunks/dep-502c56be.js');
require('./hooks/slots.js');
require('./select/select-panel.js');
require('./select/optionGroup.js');
require('./select/option-group-props.js');
require('./hooks/useVirtualScroll.js');
require('./select/hooks/useSelectOptions.js');
require('./tag/tag.js');
require('tinycolor2');
require('./tag/props.js');
require('./tag/check-tag.js');
require('./tag/check-tag-props.js');
require('./tag/check-tag-group.js');
require('./tag/check-tag-group-props.js');
require('./select-input/select-input.js');
require('./select-input/props.js');
require('./select-input/useSingle.js');
require('./_chunks/dep-71fa6788.js');
require('./_chunks/dep-73fb598e.js');
require('./select-input/useMultiple.js');
require('./tag-input/tag-input.js');
require('./tag-input/props.js');
require('./tag-input/hooks/useTagScroll.js');
require('./tag-input/useTagList.js');
require('./tag-input/hooks/useHover.js');
require('./tag-input/hooks/useDragSorter.js');
require('./select-input/useOverlayInnerStyle.js');
require('./input-adornment/input-adornment.js');
require('./input-adornment/props.js');
require('./pagination/pagination-mini.js');
require('./pagination/pagination-mini-props.js');
require('./steps/steps.js');
require('./steps/props.js');
require('./steps/step-item.js');
require('./steps/step-item-props.js');
require('./sticky-tool/sticky-tool.js');
require('./sticky-tool/props.js');
require('./sticky-tool/sticky-item.js');
require('./sticky-tool/sticky-item-props.js');
require('./auto-complete/auto-complete.js');
require('./auto-complete/props.js');
require('./auto-complete/option-list.js');
require('./auto-complete/highlight-option.js');
require('./_chunks/dep-67cf27bf.js');
require('./cascader/cascader.js');
require('./cascader/components/Panel.js');
require('./cascader/components/Item.js');
require('./cascader/core/helper.js');
require('./cascader/core/className.js');
require('./cascader/props.js');
require('./cascader/core/effect.js');
require('./cascader/hooks.js');
require('./_common/js/tree/tree-store.js');
require('mitt');
require('./_common/js/tree/tree-node.js');
require('./_common/js/tree/tree-node-model.js');
require('./_chunks/dep-5b9bb086.js');
require('./_chunks/dep-db8e4c0d.js');
require('./_chunks/dep-8b3c7277.js');
require('./_chunks/dep-7f8c4040.js');
require('./_chunks/dep-a0ae49c9.js');
require('./cascader/cascader-panel.js');
require('./color-picker/color-picker-panel.js');
require('./color-picker/props.js');
require('./color-picker/panel/index.js');
require('./_common/js/color-picker/constants.js');
require('./color-picker/panel/header.js');
require('./color-picker/hooks.js');
require('./radio/radio.js');
require('./radio/props.js');
require('./radio/group.js');
require('./radio/radio-group-props.js');
require('./radio/radio-button.js');
require('./color-picker/panel/linear-gradient.js');
require('./color-picker/panel/base-props.js');
require('./_common/js/color-picker/color.js');
require('./_common/js/color-picker/cmyk.js');
require('./_common/js/color-picker/gradient.js');
require('./color-picker/panel/saturation.js');
require('./_common/js/color-picker/draggable.js');
require('./color-picker/panel/hue.js');
require('./color-picker/panel/slider.js');
require('./color-picker/panel/alpha.js');
require('./color-picker/panel/format/index.js');
require('./color-picker/panel/format/inputs.js');
require('./color-picker/panel/format/config.js');
require('./_chunks/dep-13309278.js');
require('./color-picker/panel/swatches.js');
require('./color-picker/color-picker.js');
require('./color-picker/trigger.js');
require('./date-picker/DatePicker.js');
require('./date-picker/hooks/useSingle.js');
require('./_common/js/date-picker/format.js');
require('./date-picker/hooks/useSingleValue.js');
require('./_common/js/date-picker/utils.js');
require('@babel/runtime/helpers/objectDestructuringEmpty');
require('@babel/runtime/helpers/extends');
require('./_chunks/dep-9931ceef.js');
require('./_chunks/dep-5284fe1d.js');
require('./date-picker/props.js');
require('./date-picker/panel/SinglePanel.js');
require('./date-picker/panel/PanelContent.js');
require('./date-picker/base/Header.js');
require('./date-picker/base/Table.js');
require('./date-picker/base/Cell.js');
require('./time-picker/panel/time-picker-panel.js');
require('./_common/js/time-picker/const.js');
require('./time-picker/panel/props.js');
require('./time-picker/props.js');
require('./time-picker/panel/single-panel.js');
require('./_common/js/time-picker/utils.js');
require('./date-picker/panel/ExtraContent.js');
require('./date-picker/base/Footer.js');
require('./date-picker/hooks/useTableData.js');
require('./date-picker/hooks/useDisableDate.js');
require('./date-picker/utils.js');
require('./date-picker/DatePickerPanel.js');
require('./date-picker/date-picker-panel-props.js');
require('./date-picker/DateRangePicker.js');
require('./date-picker/date-range-picker-props.js');
require('./date-picker/panel/RangePanel.js');
require('./date-picker/hooks/useRange.js');
require('./date-picker/hooks/useRangeValue.js');
require('./range-input/range-input.js');
require('./range-input/props.js');
require('./range-input/range-input-popup.js');
require('./range-input/range-input-popup-props.js');
require('./date-picker/DateRangePickerPanel.js');
require('./date-picker/date-range-picker-panel-props.js');
require('./form/form.js');
require('./form/props.js');
require('./form/const.js');
require('./form/form-item.js');
require('./form/form-model.js');
require('./form/form-item-props.js');
require('./_chunks/dep-7a2463e1.js');
require('./slider/slider.js');
require('./slider/props.js');
require('./slider/slider-mark.js');
require('./slider/slider-button.js');
require('./_common/js/slider/utils.js');
require('./switch/switch.js');
require('./switch/props.js');
require('./textarea/textarea.js');
require('./textarea/calcTextareaHeight.js');
require('./textarea/props.js');
require('./transfer/transfer.js');
require('./transfer/components/transfer-list.js');
require('./transfer/utils.js');
require('./transfer/components/transfer-search.js');
require('./transfer/props.js');
require('./transfer/components/transfer-operations.js');
require('./time-picker/time-picker.js');
require('./time-picker/time-range-picker.js');
require('./time-picker/time-range-picker-props.js');
require('./tree-select/tree-select.js');
require('./tree-select/props.js');
require('./tree-select/useTreeSelect.js');
require('./tree-select/utils.js');
require('./tree/tree.js');
require('./tree/adapt.js');
require('./hooks/useVirtualScrollNew.js');
require('./hooks/useResizeObserver.js');
require('./tree/props.js');
require('./tree/hooks/useTreeStore.js');
require('./tree/hooks/useTreeStyles.js');
require('./tree/hooks/useTreeState.js');
require('./tree/hooks/useTreeAction.js');
require('./tree/util.js');
require('./tree/hooks/useTreeScroll.js');
require('./tree/hooks/useTreeNodes.js');
require('./tree/tree-item.js');
require('./tree/hooks/useItemState.js');
require('./tree/hooks/useTreeItem.js');
require('./tree/hooks/useItemEvents.js');
require('./tree/hooks/useRenderIcon.js');
require('./tree/hooks/useRenderLabel.js');
require('./tree/hooks/useRenderLine.js');
require('./tree/hooks/useRenderOperations.js');
require('./tree/hooks/useDraggable.js');
require('./tree/hooks/useTreeEvents.js');
require('./tree/hooks/useDragHandle.js');
require('./avatar/avatar.js');
require('./avatar/props.js');
require('./image/image.js');
require('./image/props.js');
require('./hooks/useImagePreviewUrl.js');
require('./_common/js/upload/utils.js');
require('./avatar/group.js');
require('./avatar/avatar-group-props.js');
require('./badge/badge.js');
require('./badge/props.js');
require('./calendar/calendar.js');
require('./calendar/props.js');
require('./calendar/utils.js');
require('./calendar/const.js');
require('./calendar/calendar-cell.js');
require('./utils/render-component.js');
require('./card/card.js');
require('./card/props.js');
require('./comment/comment.js');
require('./comment/props.js');
require('./descriptions/descriptions.js');
require('./descriptions/props.js');
require('./descriptions/const/index.js');
require('./descriptions/descriptions-body.js');
require('./descriptions/utils/index.js');
require('./descriptions/interface.js');
require('./descriptions/descriptions-item.js');
require('./descriptions/description-item-props.js');
require('./empty/empty.js');
require('./empty/props.js');
require('./empty/assets/MaintenanceSvg.js');
require('./empty/assets/NetworkErrorSvg.js');
require('./empty/assets/EmptySvg.js');
require('./empty/assets/FailSvg.js');
require('./empty/assets/SuccessSvg.js');
require('./image-viewer/image-viewer.js');
require('./image-viewer/props.js');
require('./image-viewer/base/Container.js');
require('./image-viewer/base/ImageModalIcon.js');
require('./image-viewer/base/ImageViewerUtils.js');
require('./image-viewer/base/ImageItem.js');
require('./image-viewer/hooks.js');
require('./image-viewer/const.js');
require('./image-viewer/base/ImageViewerModal.js');
require('./dialog/dialog.js');
require('./dialog/actions.js');
require('./dialog/props.js');
require('./dialog/stack.js');
require('./_common/js/utils/getScrollbarWidth.js');
require('./config-provider/config-provider.js');
require('./config-provider/props.js');
require('./image-viewer/utils.js');
require('./list/list.js');
require('./list/list-item.js');
require('./list/list-item-props.js');
require('./list/props.js');
require('./list/const.js');
require('./list/hooks/useListVirtualScroll.js');
require('./list/hooks/useListItem.js');
require('./list/list-item-meta.js');
require('./list/list-item-meta-props.js');
require('./progress/progress.js');
require('./progress/constants.js');
require('./progress/props.js');
require('./skeleton/skeleton.js');
require('./skeleton/props.js');
require('./statistic/statistic.js');
require('./statistic/props.js');
require('./_common/js/statistic/tween.js');
require('./_common/js/statistic/utils.js');
require('./swiper/swiper.js');
require('./swiper/props.js');
require('./swiper/swiper-item.js');
require('./table/base-table.js');
require('./table/base-table-props.js');
require('./table/hooks/useTableHeader.js');
require('./table/hooks/useMultiHeader.js');
require('./table/hooks/useClassName.js');
require('./table/ellipsis.js');
require('./table/hooks/useColumnResize.js');
require('./table/hooks/useFixed.js');
require('./table/hooks/usePagination.js');
require('./table/hooks/useAffix.js');
require('./table/tbody.js');
require('./table/tr.js');
require('./table/utils.js');
require('./table/hooks/useRowspanAndColspan.js');
require('./table/hooks/useStyle.js');
require('./table/hooks/useRowHighlight.js');
require('./table/hooks/useHoverKeyboardEvent.js');
require('./table/thead.js');
require('./table/tfoot.js');
require('./table/primary-table.js');
require('./table/primary-table-props.js');
require('./table/hooks/useColumnController.js');
require('./table/column-checkbox-group.js');
require('./table/hooks/useRowExpand.js');
require('./table/hooks/useRowSelect.js');
require('./_common/js/table/utils.js');
require('./table/hooks/useSorter.js');
require('./table/sorter-button.js');
require('./table/hooks/useFilter.js');
require('./table/filter-controller.js');
require('./table/hooks/useDragSort.js');
require('sortablejs');
require('./_common/js/utils/swapDragArrayElement.js');
require('./table/hooks/useAsyncLoading.js');
require('./table/hooks/useEditableCell.js');
require('./table/editable-cell.js');
require('@babel/runtime/helpers/toArray');
require('./table/hooks/useEditableRow.js');
require('./table/enhanced-table.js');
require('./table/enhanced-table-props.js');
require('./table/hooks/useTreeData.js');
require('./_common/js/table/tree-store.js');
require('./table/hooks/useTreeDataExpand.js');
require('./table/hooks/useTreeSelect.js');
require('./watermark/watermark.js');
require('./_common/js/watermark/generateBase64Url.js');
require('./_common/js/watermark/randomMovingStyle.js');
require('./_common/js/utils/injectStyle.js');
require('./watermark/hooks.js');
require('./watermark/props.js');
require('./collapse/collapse.js');
require('./collapse/props.js');
require('./collapse/collapse-panel.js');
require('./collapse/collapse-panel-props.js');
require('./rate/rate.js');
require('./rate/props.js');
require('./timeline/timeline.js');
require('./timeline/utils.js');
require('./timeline/timeline-item.js');
require('./timeline/timeline-item-props.js');
require('./timeline/props.js');
require('./alert/alert.js');
require('./alert/props.js');
require('./drawer/drawer.js');
require('./drawer/props.js');
require('./_common/js/drawer/utils.js');
require('./guide/guide.js');
require('./guide/utils/getScrollParent.js');
require('./guide/utils/getRelativePosition.js');
require('./guide/utils/getTargetElm.js');
require('./guide/utils/scrollToElm.js');
require('./guide/props.js');
require('./notification/notificationList.js');
require('./notification/notification.js');
require('./notification/props.js');
require('./notification/const.js');
require('./popconfirm/popconfirm.js');
require('./popconfirm/props.js');
require('./upload/upload.js');
require('./upload/props.js');
require('./upload/themes/normal-file.js');
require('./upload/constants.js');
require('./upload/themes/dragger-file.js');
require('./upload/hooks/useDrag.js');
require('./upload/themes/image-card.js');
require('./upload/themes/multiple-flow-list.js');
require('./upload/hooks/useUpload.js');
require('./_common/js/upload/main.js');
require('./_common/js/upload/xhr.js');
require('./upload/themes/custom-file.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var VueCompositionAPI__default = /*#__PURE__*/_interopDefaultLegacy(VueCompositionAPI);

function install(Vue, config) {
  if (Vue._installedPlugins.indexOf(VueCompositionAPI__default["default"]) === -1) {
    Vue.use(VueCompositionAPI__default["default"]);
  }
  Object.keys(components.components).forEach(function (key) {
    if (components.components[key]) {
      if (/directive/i.test(key)) return;
      /plugin/i.test(key) ? Vue.use(components.components[key]) : Vue.use(components.components[key], config);
    }
  });
}
if (typeof window !== "undefined" && window.Vue) {
  install(window.Vue);
}
var tdesign = {
  install: install,
  version: "1.11.2"
};

exports.Button = button_index.Button;
exports.Icon = icon_index.Icon;
exports.Link = link_index.Link;
exports.Col = grid_index.Col;
exports.Row = grid_index.Row;
exports.Aside = layout_index.Aside;
exports.Content = layout_index.Content;
exports.Footer = layout_index.Footer;
exports.Header = layout_index.Header;
exports.Layout = layout_index.Layout;
exports.Divider = divider_index.Divider;
exports.Space = space_index.Space;
exports.Affix = affix_index.Affix;
exports.Anchor = anchor_index.Anchor;
exports.AnchorItem = anchor_index.AnchorItem;
exports.AnchorTarget = anchor_index.AnchorTarget;
exports.BackTop = backTop_index.BackTop;
exports.Breadcrumb = breadcrumb_index.Breadcrumb;
exports.BreadcrumbItem = breadcrumb_index.BreadcrumbItem;
exports.Dropdown = dropdown_index.Dropdown;
exports.DropdownItem = dropdown_index.DropdownItem;
exports.DropdownMenu = dropdown_index.DropdownMenu;
exports.HeadMenu = menu_index.HeadMenu;
exports.Menu = menu_index.Menu;
exports.MenuGroup = menu_index.MenuGroup;
exports.MenuItem = menu_index.MenuItem;
exports.Submenu = menu_index.Submenu;
exports.Pagination = pagination_index.Pagination;
exports.PaginationMini = pagination_index.PaginationMini;
exports.StepItem = steps_index.StepItem;
exports.Steps = steps_index.Steps;
exports.StickyItem = stickyTool_index.StickyItem;
exports.StickyTool = stickyTool_index.StickyTool;
exports.TabPanel = tabs_index.TabPanel;
exports.Tabs = tabs_index.Tabs;
exports.AutoComplete = autoComplete_index.AutoComplete;
exports.HighlightOption = autoComplete_index.HighlightOption;
exports.Cascader = cascader_index.Cascader;
exports.CascaderPanel = cascader_index.CascaderPanel;
exports.Checkbox = checkbox_index.Checkbox;
exports.CheckboxGroup = checkbox_index.CheckboxGroup;
exports.ColorPicker = colorPicker_index.ColorPicker;
exports.ColorPickerPanel = colorPicker_index.ColorPickerPanel;
exports.DatePicker = datePicker_index.DatePicker;
exports.DatePickerPanel = datePicker_index.DatePickerPanel;
exports.DateRangePicker = datePicker_index.DateRangePicker;
exports.DateRangePickerPanel = datePicker_index.DateRangePickerPanel;
exports.Form = form_index.Form;
exports.FormItem = form_index.FormItem;
exports.InputAdornment = inputAdornment_index.InputAdornment;
exports.Input = input_index.Input;
exports.InputGroup = input_index.InputGroup;
exports.RangeInput = rangeInput_index.RangeInput;
exports.RangeInputPopup = rangeInput_index.RangeInputPopup;
exports.InputNumber = inputNumber_index.InputNumber;
exports.Radio = radio_index.Radio;
exports.RadioButton = radio_index.RadioButton;
exports.RadioGroup = radio_index.RadioGroup;
exports.Option = select_index.Option;
exports.OptionGroup = select_index.OptionGroup;
exports.Select = select_index.Select;
exports.Slider = slider_index.Slider;
exports.Switch = switch_index.Switch;
exports.TagInput = tagInput_index.TagInput;
exports.SelectInput = selectInput_index.SelectInput;
exports.Textarea = textarea_index.Textarea;
exports.Transfer = transfer_index.Transfer;
exports.EPickerCols = timePicker_interface.EPickerCols;
exports.KeyboardDirection = timePicker_interface.KeyboardDirection;
exports.TimePicker = timePicker_index.TimePicker;
exports.TimePickerPanel = timePicker_index.TimePickerPanel;
exports.TimeRangePicker = timePicker_index.TimeRangePicker;
exports.TreeSelect = treeSelect_index.TreeSelect;
exports.Avatar = avatar_index.Avatar;
exports.AvatarGroup = avatar_index.AvatarGroup;
exports.Badge = badge_index.Badge;
exports.Calendar = calendar_index.Calendar;
exports.Card = card_index.Card;
exports.Comment = comment_index.Comment;
exports.Descriptions = descriptions_index.Descriptions;
exports.DescriptionsItem = descriptions_index.DescriptionsItem;
exports.Empty = empty_index.Empty;
exports.Image = image_index.Image;
exports.ImageViewer = imageViewer_index.ImageViewer;
exports.List = list_index.List;
exports.ListItem = list_index.ListItem;
exports.ListItemMeta = list_index.ListItemMeta;
exports.LoadingPlugin = loading_plugin.LoadingPlugin;
exports.LoadingDirective = loading_directive["default"];
exports.Loading = loading_index.Loading;
exports.Progress = progress_index.Progress;
exports.Skeleton = skeleton_index.Skeleton;
exports.Statistic = statistic_index.Statistic;
exports.Swiper = swiper_index.Swiper;
exports.SwiperItem = swiper_index.SwiperItem;
exports.BaseTable = table_index.BaseTable;
exports.EnhancedTable = table_index.EnhancedTable;
exports.PrimaryTable = table_index.PrimaryTable;
exports.Table = table_index.Table;
exports.CheckTag = tag_index.CheckTag;
exports.CheckTagGroup = tag_index.CheckTagGroup;
exports.Tag = tag_index.Tag;
exports.Tooltip = tooltip_index.Tooltip;
exports.Tree = tree_index.Tree;
exports.Watermark = watermark_index.Watermark;
exports.Collapse = collapse_index.Collapse;
exports.CollapsePanel = collapse_index.CollapsePanel;
exports.Rate = rate_index.Rate;
exports.Timeline = timeline_index.Timeline;
exports.TimelineItem = timeline_index.TimelineItem;
exports.Alert = alert_index.Alert;
exports.DialogPlugin = dialog_plugin.DialogPlugin;
exports.Dialog = dialog_index.Dialog;
exports.DrawerPlugin = drawer_plugin.DrawerPlugin;
exports.Drawer = drawer_index.Drawer;
exports.Guide = guide_index.Guide;
exports.MessagePlugin = message_plugin.MessagePlugin;
exports.message = message_plugin.message;
exports.Message = message_index.Message;
exports.NotificationPlugin = notification_plugin.NotificationPlugin;
exports.NotifyPlugin = notification_plugin.NotifyPlugin;
exports.notify = notification_plugin.notify;
exports.Notification = notification_index.Notification;
exports.Popconfirm = popconfirm_index.Popconfirm;
exports.PopupPlugin = popup_plugin.PopupPlugin;
exports.createPopupPlugin = popup_plugin.createPopupPlugin;
exports.Popup = popup_index.Popup;
exports.Upload = upload_index.Upload;
exports.ConfigProvider = configProvider_index.ConfigProvider;
exports["default"] = tdesign;
//# sourceMappingURL=index.js.map
