/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var inputAdornment_props = require('./props.js');
var configProvider_configReceiver = require('../config-provider/config-receiver.js');
var utils_mixins = require('../utils/mixins.js');
var isString = require('../_chunks/dep-738b4f21.js');
var isNumber = require('../_chunks/dep-aa0a4aac.js');
require('vue');
require('../_chunks/dep-07fb8c0e.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-a4a18104.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-27dd8cc6.js');
require('dayjs');
require('../_chunks/dep-87c765cc.js');
require('../_chunks/dep-75cd6d52.js');
require('../_chunks/dep-b1a02818.js');
require('../_chunks/dep-3d8ab37d.js');
require('../_chunks/dep-ecccff93.js');
require('../_chunks/dep-a4308f57.js');
require('../_chunks/dep-a4cecac4.js');
require('../_chunks/dep-ab142eaf.js');
require('../_chunks/dep-6ad3de7c.js');
require('../_chunks/dep-e4278c54.js');
require('../_chunks/dep-fcf0662d.js');
require('../_chunks/dep-8b1e056e.js');
require('../_chunks/dep-5db8defc.js');
require('../_chunks/dep-6e4c473c.js');
require('../_chunks/dep-234b7c02.js');
require('../_chunks/dep-a4747856.js');
require('../_chunks/dep-932dd69e.js');
require('../_chunks/dep-9f4caea4.js');
require('../_chunks/dep-dbd838d6.js');
require('../_chunks/dep-b3120c1b.js');
require('../_chunks/dep-68ba2357.js');
require('../_chunks/dep-173eb46c.js');

var classPrefixMixins = configProvider_configReceiver.getClassPrefixMixins("input-adornment");
var _InputAdornment = utils_mixins["default"](classPrefixMixins).extend({
  name: "TInputAdornment",
  props: inputAdornment_props["default"],
  methods: {
    renderAddon: function renderAddon(h, type, addon) {
      var addonNode;
      var isContentNode = isString.isString(addon) || isNumber.isNumber(addon);
      if (!this.$scopedSlots[type] && isString.isString(addon) && !addon) return null;
      if (this.$scopedSlots[type]) {
        if (this.$scopedSlots[type](null).length === 1 && this.$scopedSlots[type](null)[0].text) {
          addonNode = h("span", {
            "class": "".concat(this.componentName, "__text")
          }, [this.$scopedSlots[type](null)]);
        } else {
          addonNode = this.$scopedSlots[type](null);
        }
      } else if (typeof addon === "function") {
        addonNode = addon(h);
      } else {
        addonNode = isContentNode ? h("span", {
          "class": "".concat(this.componentName, "__text")
        }, [addon]) : addon;
      }
      return addonNode ? h("span", {
        "class": "".concat(this.componentName, "__").concat(type)
      }, [addonNode]) : addonNode;
    }
  },
  render: function render(h) {
    var prepend = this.renderAddon(h, "prepend", this.prepend);
    var append = this.renderAddon(h, "append", this.append);
    var defaultSlot = this.$scopedSlots["default"] ? this.$scopedSlots["default"](null) : [null];
    if (!prepend && !append) {
      return defaultSlot[0];
    }
    return h("div", {
      "class": this.componentName
    }, [prepend, defaultSlot[0], append]);
  }
});

exports["default"] = _InputAdornment;
//# sourceMappingURL=input-adornment.js.map
