import { TdInputProps } from './type';
import { PropType } from 'vue';
declare const _default: {
    align: {
        type: PropType<"center" | "left" | "right">;
        default: "center" | "left" | "right";
        validator(val: TdInputProps['align']): boolean;
    };
    allowInputOverMax: BooleanConstructor;
    autoWidth: BooleanConstructor;
    autocomplete: {
        type: StringConstructor;
        default: any;
    };
    autofocus: BooleanConstructor;
    borderless: BooleanConstructor;
    clearable: BooleanConstructor;
    disabled: {
        type: BooleanConstructor;
        default: any;
    };
    format: {
        type: PropType<import("./type").InputFormatType>;
    };
    inputClass: {
        type: PropType<import("..").ClassName>;
    };
    label: {
        type: PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    maxcharacter: {
        type: NumberConstructor;
    };
    maxlength: {
        type: PropType<string | number>;
    };
    name: {
        type: StringConstructor;
        default: string;
    };
    placeholder: {
        type: StringConstructor;
        default: any;
    };
    prefixIcon: {
        type: PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    readonly: {
        type: BooleanConstructor;
        default: any;
    };
    showClearIconOnEmpty: BooleanConstructor;
    showLimitNumber: BooleanConstructor;
    size: {
        type: PropType<import("..").SizeEnum>;
        default: import("..").SizeEnum;
        validator(val: TdInputProps['size']): boolean;
    };
    spellCheck: BooleanConstructor;
    status: {
        type: PropType<"error" | "default" | "success" | "warning">;
        default: "error" | "default" | "success" | "warning";
        validator(val: TdInputProps['status']): boolean;
    };
    suffix: {
        type: PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    suffixIcon: {
        type: PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    tips: {
        type: PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    type: {
        type: PropType<"number" | "search" | "password" | "url" | "hidden" | "text" | "submit" | "tel">;
        default: "number" | "search" | "password" | "url" | "hidden" | "text" | "submit" | "tel";
        validator(val: TdInputProps['type']): boolean;
    };
    value: {
        type: PropType<import("./type").InputValue>;
        default: any;
    };
    defaultValue: {
        type: PropType<import("./type").InputValue>;
    };
    onBlur: PropType<(value: import("./type").InputValue, context: {
        e: FocusEvent;
    }) => void>;
    onChange: PropType<(value: import("./type").InputValue, context?: {
        e?: MouseEvent | CompositionEvent | InputEvent;
        trigger: "input" | "clear" | "initial";
    }) => void>;
    onClear: PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onClick: PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onCompositionend: PropType<(value: string, context: {
        e: CompositionEvent;
    }) => void>;
    onCompositionstart: PropType<(value: string, context: {
        e: CompositionEvent;
    }) => void>;
    onEnter: PropType<(value: import("./type").InputValue, context: {
        e: KeyboardEvent;
    }) => void>;
    onFocus: PropType<(value: import("./type").InputValue, context: {
        e: FocusEvent;
    }) => void>;
    onKeydown: PropType<(value: import("./type").InputValue, context: {
        e: KeyboardEvent;
    }) => void>;
    onKeypress: PropType<(value: import("./type").InputValue, context: {
        e: KeyboardEvent;
    }) => void>;
    onKeyup: PropType<(value: import("./type").InputValue, context: {
        e: KeyboardEvent;
    }) => void>;
    onMouseenter: PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onMouseleave: PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onPaste: PropType<(context: {
        e: ClipboardEvent;
        pasteValue: string;
    }) => void>;
    onValidate: PropType<(context: {
        error?: "exceed-maximum" | "below-minimum";
    }) => void>;
    onWheel: PropType<(context: {
        e: WheelEvent;
    }) => void>;
};
export default _default;
