/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var utils_renderTnode = require('../utils/render-tnode.js');
var link_props = require('./props.js');
var configProvider_configReceiver = require('../config-provider/config-receiver.js');
var utils_mixins = require('../utils/mixins.js');
require('@babel/runtime/helpers/readOnlyError');
require('@babel/runtime/helpers/typeof');
require('vue');
require('@vue/composition-api');
require('../_chunks/dep-7c854ec6.js');
require('../_chunks/dep-eceed11d.js');
require('../_chunks/dep-201f7798.js');
require('../_chunks/dep-a4308f57.js');
require('../_chunks/dep-fcf0662d.js');
require('../_chunks/dep-d3015b4c.js');
require('../_chunks/dep-e4278c54.js');
require('../_chunks/dep-f8a85d6a.js');
require('../_chunks/dep-5b117689.js');
require('../_chunks/dep-6478392e.js');
require('../_chunks/dep-47bca35e.js');
require('../_chunks/dep-07fb8c0e.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-a4a18104.js');
require('../_chunks/dep-27dd8cc6.js');
require('dayjs');
require('../_chunks/dep-87c765cc.js');
require('../_chunks/dep-75cd6d52.js');
require('../_chunks/dep-b1a02818.js');
require('../_chunks/dep-3d8ab37d.js');
require('../_chunks/dep-ecccff93.js');
require('../_chunks/dep-a4cecac4.js');
require('../_chunks/dep-ab142eaf.js');
require('../_chunks/dep-6ad3de7c.js');
require('../_chunks/dep-8b1e056e.js');
require('../_chunks/dep-5db8defc.js');
require('../_chunks/dep-6e4c473c.js');
require('../_chunks/dep-234b7c02.js');
require('../_chunks/dep-a4747856.js');
require('../_chunks/dep-932dd69e.js');
require('../_chunks/dep-9f4caea4.js');
require('../_chunks/dep-dbd838d6.js');
require('../_chunks/dep-b3120c1b.js');
require('../_chunks/dep-68ba2357.js');
require('../_chunks/dep-173eb46c.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

var classPrefixMixins = configProvider_configReceiver.getClassPrefixMixins("link");
var _Link = utils_mixins["default"](classPrefixMixins).extend({
  name: "TLink",
  props: link_props["default"],
  methods: {
    handleClick: function handleClick(e) {
      var _this$onClick;
      if (this.disabled) return;
      this.$emit("click", e);
      (_this$onClick = this.onClick) === null || _this$onClick === void 0 || _this$onClick.call(this, e);
    }
  },
  render: function render() {
    var h = arguments[0];
    var linkContent = utils_renderTnode.renderContent(this, "default", "content");
    var prefixContent = utils_renderTnode.renderTNodeJSX(this, "prefixIcon");
    var suffixContent = utils_renderTnode.renderTNodeJSX(this, "suffixIcon");
    var linkClass = [this.componentName, "".concat(this.componentName, "--theme-").concat(this.theme), _defineProperty__default["default"](_defineProperty__default["default"](_defineProperty__default["default"](_defineProperty__default["default"]({}, this.commonSizeClassName[this.size], this.size !== "medium"), this.commonStatusClassName.disabled, this.disabled), "".concat(this.classPrefix, "-is-underline"), this.underline), "".concat(this.componentName, "--hover-").concat(this.hover), !this.disabled)];
    return h("a", {
      "class": linkClass,
      "attrs": {
        "href": this.disabled || !this.href ? void 0 : this.href,
        "target": this.target,
        "download": this.download
      },
      "on": {
        "click": this.handleClick
      }
    }, [prefixContent && h("span", {
      "class": "".concat(this.componentName, "__prefix-icon")
    }, [prefixContent]), linkContent, suffixContent && h("span", {
      "class": "".concat(this.componentName, "__suffix-icon")
    }, [suffixContent])]);
  }
});

exports["default"] = _Link;
//# sourceMappingURL=link.js.map
