/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var helper = require('../_chunks/dep-ece3c062.js');
var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var VueCompositionAPI = require('@vue/composition-api');
var loading_index = require('../loading/index.js');
var list_listItem = require('./list-item.js');
var list_props = require('./props.js');
var list_const = require('./const.js');
var hooks_useConfig = require('../hooks/useConfig.js');
var list_hooks_useListVirtualScroll = require('./hooks/useListVirtualScroll.js');
var utils_renderTnode = require('../utils/render-tnode.js');
var list_hooks_useListItem = require('./hooks/useListItem.js');
var configProvider_useConfig = require('../config-provider/useConfig.js');
var isString = require('../_chunks/dep-738b4f21.js');
var omit = require('../_chunks/dep-6dc0a916.js');
require('../loading/directive.js');
require('../loading/plugin.js');
require('vue');
require('../loading/loading.js');
require('../loading/icon/gradient.js');
require('../_common/js/loading/circle-adapter.js');
require('../_common/js/utils/setStyle.js');
require('../_common/js/utils/helper.js');
require('@babel/runtime/helpers/toConsumableArray');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/slicedToArray');
require('../_chunks/dep-62de1188.js');
require('../_chunks/dep-867c284e.js');
require('../_chunks/dep-fcf0662d.js');
require('../_chunks/dep-aa0a4aac.js');
require('../_chunks/dep-a4308f57.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-e4278c54.js');
require('../config-provider/config-receiver.js');
require('../_chunks/dep-07fb8c0e.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-a4a18104.js');
require('../_chunks/dep-27dd8cc6.js');
require('dayjs');
require('../_chunks/dep-87c765cc.js');
require('../_chunks/dep-75cd6d52.js');
require('../_chunks/dep-b1a02818.js');
require('../_chunks/dep-3d8ab37d.js');
require('../_chunks/dep-ecccff93.js');
require('../_chunks/dep-a4cecac4.js');
require('../_chunks/dep-ab142eaf.js');
require('../_chunks/dep-6ad3de7c.js');
require('../_chunks/dep-8b1e056e.js');
require('../_chunks/dep-5db8defc.js');
require('../_chunks/dep-6e4c473c.js');
require('../_chunks/dep-234b7c02.js');
require('../_chunks/dep-a4747856.js');
require('../_chunks/dep-932dd69e.js');
require('../_chunks/dep-9f4caea4.js');
require('../_chunks/dep-dbd838d6.js');
require('../_chunks/dep-b3120c1b.js');
require('../_chunks/dep-68ba2357.js');
require('../_chunks/dep-173eb46c.js');
require('../utils/mixins.js');
require('../utils/dom.js');
require('raf');
require('../utils/easing.js');
require('../utils/transfer-dom.js');
require('../loading/props.js');
require('../config.js');
require('@babel/runtime/helpers/readOnlyError');
require('../_chunks/dep-7c854ec6.js');
require('../_chunks/dep-eceed11d.js');
require('../_chunks/dep-201f7798.js');
require('../_chunks/dep-d3015b4c.js');
require('../_chunks/dep-f8a85d6a.js');
require('../_chunks/dep-5b117689.js');
require('../_chunks/dep-6478392e.js');
require('../_chunks/dep-47bca35e.js');
require('../_chunks/dep-013a3403.js');
require('../_chunks/dep-8cb0d589.js');
require('../_chunks/dep-d23147db.js');
require('../_chunks/dep-de60f5aa.js');
require('../_chunks/dep-63b02f7b.js');
require('../_chunks/dep-bebcd284.js');
require('../_chunks/dep-3eec664c.js');
require('../_chunks/dep-eeb2e214.js');
require('../_chunks/dep-315a67f0.js');
require('../_chunks/dep-f84d1ea5.js');
require('../_chunks/dep-362bc4d7.js');
require('../_chunks/dep-2e32c1f2.js');
require('../_chunks/dep-f14aac54.js');
require('../utils/withInstall.js');
require('./list-item-props.js');
require('../hooks/useVirtualScrollNew.js');
require('../hooks/useResizeObserver.js');
require('../utils/helper.js');
require('../_chunks/dep-f33eb57d.js');
require('../_chunks/dep-b5c96567.js');
require('../_chunks/dep-a9e7deb2.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

var _List = VueCompositionAPI.defineComponent({
  name: "TList",
  props: list_props["default"],
  setup: function setup(props2, _ref) {
    var emit = _ref.emit;
    var listRef = VueCompositionAPI.ref();
    var _useConfig = configProvider_useConfig.useConfig("list"),
      globalConfig = _useConfig.globalConfig;
    var componentName = hooks_useConfig.usePrefixClass("list");
    var _useCommonClassName = hooks_useConfig.useCommonClassName(),
      SIZE = _useCommonClassName.SIZE;
    var _useListItems = list_hooks_useListItem["default"](),
      listItems = _useListItems.listItems;
    var listClass = VueCompositionAPI.computed(function () {
      return ["".concat(componentName.value), SIZE.value[props2.size], _defineProperty__default["default"](_defineProperty__default["default"](_defineProperty__default["default"]({}, "".concat(componentName.value, "--split"), props2.split), "".concat(componentName.value, "--stripe"), props2.stripe), "".concat(componentName.value, "--vertical-action"), props2.layout === "vertical")];
    });
    var loadingClass = VueCompositionAPI.computed(function () {
      return isString.isString(props2.asyncLoading) && ["loading", "load-more"].includes(props2.asyncLoading) ? "".concat(componentName.value, "__load ").concat(componentName.value, "__load--").concat(props2.asyncLoading) : "".concat(componentName.value, "__load");
    });
    var _useListVirtualScroll = list_hooks_useListVirtualScroll["default"](props2.scroll, listRef, listItems),
      virtualConfig = _useListVirtualScroll.virtualConfig,
      cursorStyle = _useListVirtualScroll.cursorStyle,
      listStyle = _useListVirtualScroll.listStyle,
      isVirtualScroll = _useListVirtualScroll.isVirtualScroll,
      onInnerVirtualScroll = _useListVirtualScroll.onInnerVirtualScroll;
    var handleScroll = function handleScroll(e) {
      var _props2$onScroll;
      var listElement = e.target;
      var scrollTop = listElement.scrollTop,
        scrollHeight = listElement.scrollHeight,
        clientHeight = listElement.clientHeight;
      if (isVirtualScroll.value) onInnerVirtualScroll(e);
      var scrollParams = {
        e: e,
        scrollTop: scrollTop,
        scrollBottom: scrollHeight - clientHeight - scrollTop
      };
      emit("scroll", scrollParams);
      (_props2$onScroll = props2.onScroll) === null || _props2$onScroll === void 0 || _props2$onScroll.call(props2, scrollParams);
    };
    var handleLoadMore = function handleLoadMore(e) {
      var _props2$onLoadMore;
      if (isString.isString(props2.asyncLoading) && props2.asyncLoading !== list_const.LOAD_MORE) return;
      emit("load-more", {
        e: e
      });
      (_props2$onLoadMore = props2.onLoadMore) === null || _props2$onLoadMore === void 0 || _props2$onLoadMore.call(props2, {
        e: e
      });
    };
    return {
      componentName: componentName,
      listClass: listClass,
      loadingClass: loadingClass,
      handleScroll: handleScroll,
      handleLoadMore: handleLoadMore,
      listRef: listRef,
      globalConfig: globalConfig,
      virtualConfig: virtualConfig,
      cursorStyle: cursorStyle,
      listStyle: listStyle,
      isVirtualScroll: isVirtualScroll
    };
  },
  render: function render() {
    var _this = this;
    var h = arguments[0];
    var isVirtualScroll = this.isVirtualScroll,
      cursorStyle = this.cursorStyle,
      listStyle = this.listStyle,
      componentName = this.componentName,
      globalConfig = this.globalConfig,
      virtualConfig = this.virtualConfig;
    var propsHeaderContent = utils_renderTnode.renderTNodeJSX(this, "header");
    var propsFooterContent = utils_renderTnode.renderTNodeJSX(this, "footer");
    var renderLoading = function renderLoading() {
      if (_this.asyncLoading && isString.isString(_this.asyncLoading)) {
        if (_this.asyncLoading === list_const.LOADING) {
          return h("div", [h(loading_index.Loading), h("span", [globalConfig.loadingText])]);
        }
        if (_this.asyncLoading === list_const.LOAD_MORE) {
          return h("span", [globalConfig.loadingMoreText]);
        }
      }
      return utils_renderTnode.renderTNodeJSX(_this, "asyncLoading");
    };
    return h("div", {
      "class": this.listClass,
      "on": {
        "scroll": this.handleScroll
      },
      "ref": "listRef",
      "style": isVirtualScroll ? "position:relative" : void 0
    }, [propsHeaderContent ? h("div", {
      "class": "".concat(componentName, "__header")
    }, [propsHeaderContent]) : null, isVirtualScroll ? h("div", [h("div", {
      "style": cursorStyle
    }), h("ul", {
      "class": "".concat(componentName, "__inner"),
      "style": listStyle
    }, [virtualConfig.visibleData.value.map(function (item) {
      return h(list_listItem["default"], helper.helper([{}, omit.omit(item, "slots"), {
        "scopedSlots": {
          "default": item.slots
        }
      }]));
    })])]) : h("ul", {
      "class": "".concat(componentName, "__inner")
    }, [utils_renderTnode.renderTNodeJSX(this, "default")]), propsFooterContent ? h("div", {
      "class": "".concat(componentName, "__footer")
    }, [propsFooterContent]) : null, h("div", {
      "class": this.loadingClass,
      "on": {
        "click": this.handleLoadMore
      }
    }, [renderLoading()])]);
  }
});

exports["default"] = _List;
//# sourceMappingURL=list.js.map
