/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var VueCompositionAPI = require('@vue/composition-api');
var menu_menu = require('./menu.js');
var menu_headMenu = require('./head-menu.js');
var menu_submenu = require('./submenu.js');
var menu_menuItem = require('./menu-item.js');
var menu_menuGroup = require('./menu-group.js');
var utils_withInstall = require('../utils/withInstall.js');
var utils_mapProps = require('../utils/map-props.js');
require('@babel/runtime/helpers/toConsumableArray');
require('@babel/runtime/helpers/defineProperty');
require('./props.js');
require('../utils/render-tnode.js');
require('@babel/runtime/helpers/readOnlyError');
require('@babel/runtime/helpers/typeof');
require('vue');
require('../_chunks/dep-7c854ec6.js');
require('../_chunks/dep-eceed11d.js');
require('../_chunks/dep-201f7798.js');
require('../_chunks/dep-a4308f57.js');
require('../_chunks/dep-fcf0662d.js');
require('../_chunks/dep-d3015b4c.js');
require('../_chunks/dep-e4278c54.js');
require('../_chunks/dep-f8a85d6a.js');
require('../_chunks/dep-5b117689.js');
require('../_chunks/dep-6478392e.js');
require('../_chunks/dep-47bca35e.js');
require('./v-menu.js');
require('@babel/runtime/helpers/classCallCheck');
require('@babel/runtime/helpers/createClass');
require('../hooks/useConfig.js');
require('../config-provider/useConfig.js');
require('../_chunks/dep-07fb8c0e.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-a4a18104.js');
require('../_chunks/dep-27dd8cc6.js');
require('dayjs');
require('../_chunks/dep-87c765cc.js');
require('../_chunks/dep-75cd6d52.js');
require('../_chunks/dep-b1a02818.js');
require('../_chunks/dep-3d8ab37d.js');
require('../_chunks/dep-ecccff93.js');
require('../_chunks/dep-a4cecac4.js');
require('../_chunks/dep-ab142eaf.js');
require('../_chunks/dep-6ad3de7c.js');
require('../_chunks/dep-8b1e056e.js');
require('../_chunks/dep-5db8defc.js');
require('../_chunks/dep-6e4c473c.js');
require('../_chunks/dep-234b7c02.js');
require('../_chunks/dep-a4747856.js');
require('../_chunks/dep-932dd69e.js');
require('../_chunks/dep-9f4caea4.js');
require('../_chunks/dep-dbd838d6.js');
require('../_chunks/dep-b3120c1b.js');
require('../_chunks/dep-68ba2357.js');
require('../_chunks/dep-173eb46c.js');
require('./head-menu-props.js');
require('../tabs/index.js');
require('../tabs/tabs.js');
require('../_chunks/dep-ece3c062.js');
require('../utils/helper.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/slicedToArray');
require('../tabs/props.js');
require('../tabs/tab-panel.js');
require('../tabs/tab-panel-props.js');
require('../hooks/useDestroyOnClose.js');
require('../config-provider/config-receiver.js');
require('../utils/mixins.js');
require('../tabs/tab-nav.js');
require('tdesign-icons-vue');
require('../tabs/tab-nav-item.js');
require('../utils/event.js');
require('../utils/ripple.js');
require('../_common/js/utils/setStyle.js');
require('../config.js');
require('../_common/js/tabs/base.js');
require('../_chunks/dep-f3761329.js');
require('../_chunks/dep-848a5a32.js');
require('./submenu-props.js');
require('../common-components/fake-arrow.js');
require('../popup/index.js');
require('../popup/popup.js');
require('@popperjs/core');
require('../utils/dom.js');
require('raf');
require('../utils/easing.js');
require('../_chunks/dep-738b4f21.js');
require('../popup/props.js');
require('../popup/container.js');
require('../popup/utils.js');
require('../popup/plugin.js');
require('../_common/js/log/log.js');
require('../hooks/useCollapseAnimation.js');
require('./menu-item-props.js');
require('../tooltip/index.js');
require('../tooltip/tooltip.js');
require('../tooltip/props.js');
require('./menu-group-props.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var VueCompositionAPI__default = /*#__PURE__*/_interopDefaultLegacy(VueCompositionAPI);

var Menu = utils_withInstall.withInstall(utils_mapProps["default"]([{
  name: "value",
  event: ["change", "update:value"]
}, {
  name: "expanded",
  event: ["expand", "update:expanded"]
}], {
  model: {
    prop: "value",
    event: "change"
  }
})(menu_menu["default"]), VueCompositionAPI__default["default"]);
var HeadMenu = utils_withInstall.withInstall(utils_mapProps["default"]([{
  name: "value",
  event: ["change", "update:value"]
}, {
  name: "expanded",
  event: ["expand", "update:expanded"]
}], {
  model: {
    prop: "value",
    event: "change"
  }
})(menu_headMenu["default"]), VueCompositionAPI__default["default"]);
var Submenu = utils_withInstall.withInstall(menu_submenu["default"], VueCompositionAPI__default["default"]);
var MenuItem = utils_withInstall.withInstall(menu_menuItem["default"], VueCompositionAPI__default["default"]);
var MenuGroup = utils_withInstall.withInstall(menu_menuGroup["default"], VueCompositionAPI__default["default"]);

exports.HeadMenu = HeadMenu;
exports.Menu = Menu;
exports.MenuGroup = MenuGroup;
exports.MenuItem = MenuItem;
exports.Submenu = Submenu;
//# sourceMappingURL=index.js.map
