/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var helper = require('../_chunks/dep-ece3c062.js');
var _toConsumableArray = require('@babel/runtime/helpers/toConsumableArray');
var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var VueCompositionAPI = require('@vue/composition-api');
var menu_submenuProps = require('./submenu-props.js');
var utils_renderTnode = require('../utils/render-tnode.js');
var commonComponents_fakeArrow = require('../common-components/fake-arrow.js');
var utils_ripple = require('../utils/ripple.js');
var configProvider_configReceiver = require('../config-provider/config-receiver.js');
var hooks_useConfig = require('../hooks/useConfig.js');
var popup_index = require('../popup/index.js');
var hooks_useCollapseAnimation = require('../hooks/useCollapseAnimation.js');
var isFunction = require('../_chunks/dep-ecccff93.js');
require('@babel/runtime/helpers/readOnlyError');
require('@babel/runtime/helpers/typeof');
require('vue');
require('../_chunks/dep-7c854ec6.js');
require('../_chunks/dep-eceed11d.js');
require('../_chunks/dep-201f7798.js');
require('../_chunks/dep-a4308f57.js');
require('../_chunks/dep-fcf0662d.js');
require('../_chunks/dep-d3015b4c.js');
require('../_chunks/dep-e4278c54.js');
require('../_chunks/dep-f8a85d6a.js');
require('../_chunks/dep-5b117689.js');
require('../_chunks/dep-6478392e.js');
require('../_chunks/dep-47bca35e.js');
require('../utils/mixins.js');
require('../_common/js/utils/setStyle.js');
require('../config.js');
require('../_chunks/dep-07fb8c0e.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-a4a18104.js');
require('../_chunks/dep-27dd8cc6.js');
require('dayjs');
require('../_chunks/dep-87c765cc.js');
require('../_chunks/dep-75cd6d52.js');
require('../_chunks/dep-b1a02818.js');
require('../_chunks/dep-3d8ab37d.js');
require('../_chunks/dep-a4cecac4.js');
require('../_chunks/dep-ab142eaf.js');
require('../_chunks/dep-6ad3de7c.js');
require('../_chunks/dep-8b1e056e.js');
require('../_chunks/dep-5db8defc.js');
require('../_chunks/dep-6e4c473c.js');
require('../_chunks/dep-234b7c02.js');
require('../_chunks/dep-a4747856.js');
require('../_chunks/dep-932dd69e.js');
require('../_chunks/dep-9f4caea4.js');
require('../_chunks/dep-dbd838d6.js');
require('../_chunks/dep-b3120c1b.js');
require('../_chunks/dep-68ba2357.js');
require('../_chunks/dep-173eb46c.js');
require('../config-provider/useConfig.js');
require('../popup/popup.js');
require('@popperjs/core');
require('../utils/dom.js');
require('raf');
require('../utils/easing.js');
require('../_chunks/dep-738b4f21.js');
require('../utils/helper.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/slicedToArray');
require('../popup/props.js');
require('../popup/container.js');
require('../utils/event.js');
require('../popup/utils.js');
require('../_chunks/dep-f3761329.js');
require('../_chunks/dep-848a5a32.js');
require('../utils/map-props.js');
require('../utils/withInstall.js');
require('../popup/plugin.js');
require('../_common/js/log/log.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _toConsumableArray__default = /*#__PURE__*/_interopDefaultLegacy(_toConsumableArray);
var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var keepAnimationMixins = configProvider_configReceiver.getKeepAnimationMixins();
var _Submenu = VueCompositionAPI.defineComponent({
  name: "TSubmenu",
  components: {
    FakeArrow: commonComponents_fakeArrow["default"]
  },
  mixins: [keepAnimationMixins],
  directives: {
    ripple: utils_ripple["default"]
  },
  props: menu_submenuProps["default"],
  setup: function setup(props2) {
    var menu = VueCompositionAPI.inject("TdMenu");
    var theme = menu.theme,
      activeValues = menu.activeValues,
      expandValues = menu.expandValues,
      mode = menu.mode,
      isHead = menu.isHead,
      open = menu.open;
    var submenu = VueCompositionAPI.inject("TdSubmenu", {});
    var setSubPopup = submenu.setSubPopup,
      closeParentPopup = submenu.closeParentPopup;
    var classPrefix = hooks_useConfig.usePrefixClass();
    var isActive = VueCompositionAPI.computed(function () {
      return activeValues.value.indexOf(props2.value) > -1;
    });
    var popupVisible = VueCompositionAPI.ref(false);
    var isCursorInPopup = VueCompositionAPI.ref(false);
    var rippleColor = VueCompositionAPI.computed(function () {
      return theme.value === "light" ? "#E7E7E7" : "#383838";
    });
    var isOpen = VueCompositionAPI.computed(function () {
      if (mode.value === "popup") {
        return popupVisible.value;
      }
      return expandValues ? expandValues.value.includes(props2.value) : false;
    });
    var menuItems = VueCompositionAPI.ref([]);
    var isNested = VueCompositionAPI.ref(false);
    var popupWrapperRef = VueCompositionAPI.ref();
    var subPopupRef = VueCompositionAPI.ref();
    var submenuRef = VueCompositionAPI.ref();
    var transitionClass = hooks_useConfig.usePrefixClass("slide-down");
    var classes = VueCompositionAPI.computed(function () {
      return ["".concat(classPrefix.value, "-submenu"), _defineProperty__default["default"](_defineProperty__default["default"]({}, "".concat(classPrefix.value, "-is-disabled"), props2.disabled), "".concat(classPrefix.value, "-is-opened"), isOpen.value)];
    });
    var overlayInnerClassName = VueCompositionAPI.computed(function () {
      return ["".concat(classPrefix.value, "-menu__popup"), "".concat(classPrefix.value, "-is-").concat(isHead ? "horizontal" : "vertical"), _defineProperty__default["default"]({}, "".concat(classPrefix.value, "-is-opened"), popupVisible.value)];
    });
    var overlayClassName = VueCompositionAPI.computed(function () {
      var _props2$popupProps;
      return ["".concat(classPrefix.value, "-menu--").concat(theme.value), isHead && "".concat(classPrefix.value, "-is-head-menu"), _defineProperty__default["default"]({}, "".concat(classPrefix.value, "-menu-is-nested"), isNested.value), (_props2$popupProps = props2.popupProps) === null || _props2$popupProps === void 0 ? void 0 : _props2$popupProps.overlayClassName];
    });
    var submenuClass = VueCompositionAPI.computed(function () {
      return ["".concat(classPrefix.value, "-menu__item"), "".concat(classPrefix.value, "-menu__item-spacer"), "".concat(classPrefix.value, "-menu__item-spacer--").concat(isHead && !isNested.value ? "bottom" : "right"), _defineProperty__default["default"](_defineProperty__default["default"](_defineProperty__default["default"]({}, "".concat(classPrefix.value, "-is-disabled"), props2.disabled), "".concat(classPrefix.value, "-is-opened"), isOpen.value), "".concat(classPrefix.value, "-is-active"), isActive.value)];
    });
    var subClass = VueCompositionAPI.computed(function () {
      return ["".concat(classPrefix.value, "-menu__sub"), _defineProperty__default["default"]({}, "".concat(classPrefix.value, "-is-opened"), isOpen.value)];
    });
    var arrowClass = VueCompositionAPI.computed(function () {
      return [_defineProperty__default["default"]({}, "".concat(classPrefix.value, "-fake-arrow--active"), isOpen.value)];
    });
    var passSubPopupRefToParent = function passSubPopupRefToParent(val) {
      if (isFunction.isFunction(setSubPopup)) {
        setSubPopup(val);
      }
    };
    var handleMouseEnter = function handleMouseEnter() {
      if (props2.disabled) return;
      setTimeout(function () {
        if (!popupVisible.value) {
          open(props2.value);
          VueCompositionAPI.nextTick(function () {
            passSubPopupRefToParent(popupWrapperRef.value);
          });
        }
        popupVisible.value = true;
      }, 0);
    };
    var targetInPopup = function targetInPopup(el) {
      return el === null || el === void 0 ? void 0 : el.classList.contains("".concat(classPrefix.value, "-menu__popup"));
    };
    var _loopInPopup = function loopInPopup(el) {
      if (!el) return false;
      return targetInPopup(el) || _loopInPopup(el.parentElement);
    };
    var handleMouseLeave = function handleMouseLeave(e) {
      setTimeout(function () {
        var inPopup = targetInPopup(e.relatedTarget);
        if (isCursorInPopup.value || inPopup) return;
        popupVisible.value = false;
      }, 0);
    };
    var handleMouseLeavePopup = function handleMouseLeavePopup(e) {
      var toElement = e.toElement,
        relatedTarget = e.relatedTarget;
      var target = toElement || relatedTarget;
      if (target === subPopupRef.value) return;
      var isSubmenu = function isSubmenu(el) {
        return el === submenuRef.value;
      };
      while (target !== null && target !== document && !isSubmenu(target)) {
        target = target.parentNode;
      }
      isCursorInPopup.value = false;
      if (!isSubmenu(target)) {
        popupVisible.value = false;
      }
      closeParentPopup === null || closeParentPopup === void 0 || closeParentPopup(e);
    };
    var handleEnterPopup = function handleEnterPopup() {
      isCursorInPopup.value = true;
    };
    var handleSubmenuItemClick = function handleSubmenuItemClick() {
      if (props2.disabled) return;
      open(props2.value);
    };
    VueCompositionAPI.watch(popupVisible, function (visible) {
      menu.open(props2.value, visible ? "add" : "remove");
    });
    var _toRefs = VueCompositionAPI.toRefs(props2),
      value = _toRefs.value;
    VueCompositionAPI.provide("TdSubmenu", VueCompositionAPI.reactive({
      value: value,
      addMenuItem: function addMenuItem(item) {
        menuItems.value.push(item);
        if (submenu) {
          submenu.addMenuItem(item);
        }
      },
      setSubPopup: function setSubPopup(ref2) {
        subPopupRef.value = ref2;
      },
      closeParentPopup: function closeParentPopup(e) {
        var related = e.relatedTarget;
        if (_loopInPopup(related)) return;
        handleMouseLeavePopup(e);
      }
    }));
    VueCompositionAPI.watch(popupWrapperRef, function () {
      passSubPopupRefToParent(popupWrapperRef.value);
    });
    VueCompositionAPI.onMounted(function () {
      var _menu$vMenu;
      menu === null || menu === void 0 || (_menu$vMenu = menu.vMenu) === null || _menu$vMenu === void 0 || _menu$vMenu.add({
        value: props2.value,
        parent: submenu === null || submenu === void 0 ? void 0 : submenu.value,
        vnode: isFunction.isFunction(props2.title) ? [props2.title(VueCompositionAPI.h)] : props2.title
      });
      var instance = VueCompositionAPI.getCurrentInstance();
      var node = instance.parent;
      while (node && !/^t(head)?menu/i.test((_node$vnode = node.vnode) === null || _node$vnode === void 0 ? void 0 : _node$vnode.tag)) {
        var _node$vnode, _node$vnode2, _node;
        if (/submenu/i.test((_node$vnode2 = node.vnode) === null || _node$vnode2 === void 0 ? void 0 : _node$vnode2.tag)) {
          isNested.value = true;
          break;
        }
        node = (_node = node) === null || _node === void 0 ? void 0 : _node.parent;
      }
    });
    return {
      theme: theme,
      mode: mode,
      isHead: isHead,
      isNested: isNested,
      popupVisible: popupVisible,
      classes: classes,
      subClass: subClass,
      isOpen: isOpen,
      transitionClass: transitionClass,
      arrowClass: arrowClass,
      overlayInnerClassName: overlayInnerClassName,
      overlayClassName: overlayClassName,
      submenuClass: submenuClass,
      rippleColor: rippleColor,
      popupWrapperRef: popupWrapperRef,
      handleEnterPopup: handleEnterPopup,
      handleMouseEnter: handleMouseEnter,
      handleMouseLeave: handleMouseLeave,
      handleMouseLeavePopup: handleMouseLeavePopup,
      handleSubmenuItemClick: handleSubmenuItemClick,
      classPrefix: classPrefix
    };
  },
  methods: {
    renderPopup: function renderPopup(triggerElement) {
      var _this$popupProps, _this$popupProps$plac, _this$popupProps2;
      var h = this.$createElement;
      var placement = "right-top";
      if (!this.isNested && this.isHead) {
        placement = "bottom-left";
      }
      var popupWrapper = h("div", {
        "ref": "popupWrapperRef",
        "class": ["".concat(this.classPrefix, "-menu__spacer"), "".concat(this.classPrefix, "-menu__spacer--").concat(!this.isNested && this.isHead ? "top" : "left")],
        "on": {
          "mouseenter": this.handleEnterPopup,
          "mouseleave": this.handleMouseLeavePopup
        }
      }, [h("ul", {
        "class": "".concat(this.classPrefix, "-menu__popup-wrapper")
      }, [utils_renderTnode.renderContent(this, "default", "content")])]);
      var realPopup = h(popup_index.Popup, helper.helper([{}, (_this$popupProps = this.popupProps) !== null && _this$popupProps !== void 0 ? _this$popupProps : {}, {
        "attrs": {
          "overlayInnerClassName": _toConsumableArray__default["default"](this.overlayInnerClassName),
          "overlayClassName": _toConsumableArray__default["default"](this.overlayClassName),
          "visible": this.popupVisible,
          "placement": (_this$popupProps$plac = (_this$popupProps2 = this.popupProps) === null || _this$popupProps2 === void 0 ? void 0 : _this$popupProps2.placement) !== null && _this$popupProps$plac !== void 0 ? _this$popupProps$plac : placement,
          "content": function content() {
            return popupWrapper;
          }
        }
      }]), [h("div", {
        "ref": "submenuRef",
        "class": this.submenuClass
      }, [triggerElement])]);
      return realPopup;
    },
    renderHeadSubmenu: function renderHeadSubmenu() {
      var h = this.$createElement;
      var icon = utils_renderTnode.renderTNodeJSX(this, "icon");
      var rippleVal = this.keepAnimation.ripple ? this.rippleColor : false;
      var normalSubmenu = [h("div", {
        "directives": [{
          name: "ripple",
          value: rippleVal
        }],
        "class": this.submenuClass,
        "on": {
          "click": this.handleSubmenuItemClick
        }
      }, [utils_renderTnode.renderTNodeJSX(this, "title")]), h("ul", {
        "style": "opacity: 0; width: 0; height: 0; overflow: hidden"
      }, [utils_renderTnode.renderContent(this, "default", "content")])];
      var needRotate = this.mode === "popup" && this.isNested;
      var triggerElement = [icon, h("span", {
        "class": ["".concat(this.classPrefix, "-menu__content")]
      }, [utils_renderTnode.renderTNodeJSX(this, "title", {
        silent: true
      })]), h(commonComponents_fakeArrow["default"], {
        "attrs": {
          "overlayClassName": /menu/i.test(this.$parent.$options.name) ? this.arrowClass : null,
          "overlayStyle": {
            transform: "rotate(".concat(needRotate ? -90 : 0, "deg)")
          }
        }
      })];
      return this.mode === "normal" ? normalSubmenu : this.renderPopup(triggerElement);
    },
    renderSubmenu: function renderSubmenu() {
      var _this$$parent$$vnode;
      var h = this.$createElement;
      var hasContent = this.$slots.content || this.$slots["default"];
      var icon = utils_renderTnode.renderTNodeJSX(this, "icon");
      var child = utils_renderTnode.renderContent(this, "default", "content");
      var paddingLeft = 44;
      if (/submenu/i.test((_this$$parent$$vnode = this.$parent.$vnode) === null || _this$$parent$$vnode === void 0 ? void 0 : _this$$parent$$vnode.tag)) {
        paddingLeft += 16;
      }
      var _useCollapseAnimation = hooks_useCollapseAnimation["default"](),
        beforeEnter = _useCollapseAnimation.beforeEnter,
        enter = _useCollapseAnimation.enter,
        afterEnter = _useCollapseAnimation.afterEnter,
        beforeLeave = _useCollapseAnimation.beforeLeave,
        leave = _useCollapseAnimation.leave,
        afterLeave = _useCollapseAnimation.afterLeave;
      var needRotate = this.mode === "popup";
      var rippleVal = this.keepAnimation.ripple ? this.rippleColor : false;
      var normalSubmenu = [h("div", {
        "directives": [{
          name: "ripple",
          value: rippleVal
        }],
        "class": this.submenuClass,
        "on": {
          "click": this.handleSubmenuItemClick
        }
      }, [icon, h("span", {
        "class": ["".concat(this.classPrefix, "-menu__content")]
      }, [utils_renderTnode.renderTNodeJSX(this, "title")]), hasContent && h("fake-arrow", {
        "attrs": {
          "overlayClassName": this.arrowClass,
          "overlayStyle": {
            transform: "rotate(".concat(needRotate ? -90 : 0, "deg)")
          }
        }
      })]), h("transition", {
        "attrs": {
          "name": this.transitionClass
        },
        "on": {
          "beforeEnter": beforeEnter,
          "enter": enter,
          "afterEnter": afterEnter,
          "beforeLeave": beforeLeave,
          "leave": leave,
          "afterLeave": afterLeave
        }
      }, [h("ul", {
        "directives": [{
          name: "show",
          value: this.isOpen
        }],
        "attrs": {
          "level": this.level
        },
        "class": this.subClass,
        "style": {
          "--padding-left": "".concat(paddingLeft, "px")
        }
      }, [child])])];
      var triggerElement = [icon, h("span", {
        "class": ["".concat(this.classPrefix, "-menu__content")]
      }, [utils_renderTnode.renderTNodeJSX(this, "title", {
        silent: true
      })]), h(commonComponents_fakeArrow["default"], {
        "attrs": {
          "overlayClassName": /menu/i.test(this.$parent.$options.name) ? this.arrowClass : null,
          "overlayStyle": {
            transform: "rotate(".concat(needRotate ? -90 : 0, "deg)"),
            "margin-left": "auto"
          }
        }
      })];
      return this.mode === "normal" ? normalSubmenu : this.renderPopup(triggerElement);
    }
  },
  render: function render() {
    var h = arguments[0];
    var child = null;
    var events = {};
    if (this.mode === "popup") {
      events = {
        mouseenter: this.handleMouseEnter,
        mouseleave: this.handleMouseLeave
      };
    }
    if (Object.keys(this.$slots).length > 0) {
      child = this.isHead ? this.renderHeadSubmenu() : this.renderSubmenu();
    }
    return h("li", {
      "class": this.classes,
      "on": _objectSpread({}, events)
    }, [child]);
  }
});

exports["default"] = _Submenu;
//# sourceMappingURL=submenu.js.map
