/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var VueCompositionAPI = require('@vue/composition-api');
var tdesignIconsVue = require('tdesign-icons-vue');
var pagination_paginationMiniProps = require('./pagination-mini-props.js');
var hooks_useConfig = require('../hooks/useConfig.js');
var hooks_useGlobalIcon = require('../hooks/useGlobalIcon.js');
var button_index = require('../button/index.js');
var isObject = require('../_chunks/dep-a4cecac4.js');
require('../config-provider/useConfig.js');
require('../_chunks/dep-07fb8c0e.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-a4a18104.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-27dd8cc6.js');
require('dayjs');
require('../_chunks/dep-87c765cc.js');
require('../_chunks/dep-75cd6d52.js');
require('../_chunks/dep-b1a02818.js');
require('../_chunks/dep-3d8ab37d.js');
require('../_chunks/dep-ecccff93.js');
require('../_chunks/dep-a4308f57.js');
require('../_chunks/dep-ab142eaf.js');
require('../_chunks/dep-6ad3de7c.js');
require('../_chunks/dep-e4278c54.js');
require('../_chunks/dep-fcf0662d.js');
require('../_chunks/dep-8b1e056e.js');
require('../_chunks/dep-5db8defc.js');
require('../_chunks/dep-6e4c473c.js');
require('../_chunks/dep-234b7c02.js');
require('../_chunks/dep-a4747856.js');
require('../_chunks/dep-932dd69e.js');
require('../_chunks/dep-9f4caea4.js');
require('../_chunks/dep-dbd838d6.js');
require('../_chunks/dep-b3120c1b.js');
require('../_chunks/dep-68ba2357.js');
require('../_chunks/dep-173eb46c.js');
require('../button/button.js');
require('../loading/index.js');
require('../loading/directive.js');
require('../loading/plugin.js');
require('vue');
require('../loading/loading.js');
require('../loading/icon/gradient.js');
require('../_common/js/loading/circle-adapter.js');
require('../_common/js/utils/setStyle.js');
require('../_common/js/utils/helper.js');
require('@babel/runtime/helpers/toConsumableArray');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/slicedToArray');
require('../_chunks/dep-62de1188.js');
require('../_chunks/dep-867c284e.js');
require('../_chunks/dep-738b4f21.js');
require('../_chunks/dep-aa0a4aac.js');
require('../config-provider/config-receiver.js');
require('../utils/mixins.js');
require('../utils/dom.js');
require('raf');
require('../utils/easing.js');
require('../utils/render-tnode.js');
require('@babel/runtime/helpers/readOnlyError');
require('../_chunks/dep-7c854ec6.js');
require('../_chunks/dep-eceed11d.js');
require('../_chunks/dep-201f7798.js');
require('../_chunks/dep-d3015b4c.js');
require('../_chunks/dep-f8a85d6a.js');
require('../_chunks/dep-5b117689.js');
require('../_chunks/dep-6478392e.js');
require('../_chunks/dep-47bca35e.js');
require('../utils/transfer-dom.js');
require('../loading/props.js');
require('../config.js');
require('../_chunks/dep-013a3403.js');
require('../_chunks/dep-8cb0d589.js');
require('../_chunks/dep-d23147db.js');
require('../_chunks/dep-de60f5aa.js');
require('../_chunks/dep-63b02f7b.js');
require('../_chunks/dep-bebcd284.js');
require('../_chunks/dep-3eec664c.js');
require('../_chunks/dep-eeb2e214.js');
require('../_chunks/dep-315a67f0.js');
require('../_chunks/dep-f84d1ea5.js');
require('../_chunks/dep-362bc4d7.js');
require('../_chunks/dep-2e32c1f2.js');
require('../_chunks/dep-f14aac54.js');
require('../utils/withInstall.js');
require('../button/props.js');
require('../utils/ripple.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var _PaginationMini = VueCompositionAPI.defineComponent({
  name: "TPaginationMini",
  props: _objectSpread({}, pagination_paginationMiniProps["default"]),
  setup: function setup(props2, _ref) {
    var emit = _ref.emit;
    var COMPONENT_NAME = hooks_useConfig.usePrefixClass("pagination-mini");
    var _useGlobalIcon = hooks_useGlobalIcon.useGlobalIcon({
        ChevronLeftIcon: tdesignIconsVue.ChevronLeftIcon,
        RoundIcon: tdesignIconsVue.RoundIcon,
        ChevronRightIcon: tdesignIconsVue.ChevronRightIcon,
        ChevronUpIcon: tdesignIconsVue.ChevronUpIcon,
        ChevronDownIcon: tdesignIconsVue.ChevronDownIcon
      }),
      ChevronLeftIcon = _useGlobalIcon.ChevronLeftIcon,
      RoundIcon = _useGlobalIcon.RoundIcon,
      ChevronRightIcon = _useGlobalIcon.ChevronRightIcon,
      ChevronUpIcon = _useGlobalIcon.ChevronUpIcon,
      ChevronDownIcon = _useGlobalIcon.ChevronDownIcon;
    var titleConfig = VueCompositionAPI.computed(function () {
      if (isObject.isObject(props2.tips)) return props2.tips;
      if (props2.tips === true) return {
        prev: "\u4E0A\u4E00\u9875",
        current: "\u5F53\u524D",
        next: "\u4E0B\u4E00\u9875"
      };
      return {};
    });
    var disabledConfig = VueCompositionAPI.computed(function () {
      if (isObject.isObject(props2.disabled)) return props2.disabled;
      if (props2.disabled === true) return {
        prev: true,
        current: true,
        next: true
      };
      return {
        prev: false,
        current: false,
        next: false
      };
    });
    function handleChange(context) {
      var _props2$onChange;
      emit("change", context);
      (_props2$onChange = props2.onChange) === null || _props2$onChange === void 0 || _props2$onChange.call(props2, context);
    }
    return {
      COMPONENT_NAME: COMPONENT_NAME,
      ChevronLeftIcon: ChevronLeftIcon,
      RoundIcon: RoundIcon,
      ChevronRightIcon: ChevronRightIcon,
      ChevronUpIcon: ChevronUpIcon,
      ChevronDownIcon: ChevronDownIcon,
      titleConfig: titleConfig,
      disabledConfig: disabledConfig,
      handleChange: handleChange
    };
  },
  render: function render() {
    var h = arguments[0];
    var COMPONENT_NAME = this.COMPONENT_NAME,
      ChevronLeftIcon = this.ChevronLeftIcon,
      RoundIcon = this.RoundIcon,
      ChevronRightIcon = this.ChevronRightIcon,
      ChevronUpIcon = this.ChevronUpIcon,
      ChevronDownIcon = this.ChevronDownIcon,
      titleConfig = this.titleConfig,
      disabledConfig = this.disabledConfig,
      handleChange = this.handleChange;
    var jumperClass = [COMPONENT_NAME, _defineProperty__default["default"]({}, "".concat(COMPONENT_NAME, "--outline"), this.variant === "outline")];
    return h("div", {
      "class": jumperClass
    }, [h(button_index.Button, {
      "attrs": {
        "title": titleConfig.prev,
        "variant": this.variant,
        "size": this.size,
        "shape": "square",
        "icon": this.layout === "horizontal" ? function () {
          return h(ChevronLeftIcon);
        } : function () {
          return h(ChevronUpIcon);
        },
        "disabled": disabledConfig.prev
      },
      "on": {
        "click": function click(e) {
          return handleChange({
            e: e,
            trigger: "prev"
          });
        }
      },
      "class": "".concat(COMPONENT_NAME, "__prev")
    }), this.showCurrent && h(button_index.Button, {
      "attrs": {
        "title": titleConfig.current,
        "variant": this.variant,
        "size": this.size,
        "shape": "square",
        "icon": function icon() {
          return h(RoundIcon);
        },
        "disabled": disabledConfig.current
      },
      "on": {
        "click": function click(e) {
          return handleChange({
            e: e,
            trigger: "current"
          });
        }
      },
      "class": "".concat(COMPONENT_NAME, "__current")
    }), h(button_index.Button, {
      "attrs": {
        "title": titleConfig.next,
        "variant": this.variant,
        "size": this.size,
        "shape": "square",
        "icon": this.layout === "horizontal" ? function () {
          return h(ChevronRightIcon);
        } : function () {
          return h(ChevronDownIcon);
        },
        "disabled": disabledConfig.next
      },
      "on": {
        "click": function click(e) {
          return handleChange({
            e: e,
            trigger: "next"
          });
        }
      },
      "class": "".concat(COMPONENT_NAME, "__next")
    })]);
  }
});

exports["default"] = _PaginationMini;
//# sourceMappingURL=pagination-mini.js.map
