import { TdPopupProps } from './type';
import './style';
export declare type PopupProps = TdPopupProps;
export * from './type';
export * from './plugin';
export declare const Popup: import("vue/types/vue").ExtendedVue<{
    classPrefix: string;
    componentName: string;
    commonSizeClassName: Record<string, string>;
    commonStatusClassName: Record<string, string>;
} & Record<never, any> & import("../config-provider/config-receiver").ConfigComponent & import("vue").default & {
    globalAttach(): import("..").AttachNode;
}, {
    popper: import("@popperjs/core").Instance;
    timeout: any;
    hasDocumentEvent: boolean;
    visibleState: number;
    mouseInRange: boolean;
    contentClicked: boolean;
    isLeaving: boolean;
}, {
    updatePopper(): void;
    popupMounted(): void;
    getOverlayStyle(): import("..").Styles;
    updateOverlayInnerStyle(): void;
    destroyPopper(): void;
    handleToggle(context: import("./type").PopupVisibleChangeContext): void;
    handleOnScroll(e: WheelEvent): void;
    handleOpen(context: Pick<import("./type").PopupVisibleChangeContext, "trigger">): void;
    handleClose(context: Pick<import("./type").PopupVisibleChangeContext, "trigger">): void;
    handleDocumentClick(ev?: MouseEvent): void;
    emitPopVisible(visible: boolean, context: import("./type").PopupVisibleChangeContext): void;
    onMouseEnter(): void;
    onMouseLeave(ev: MouseEvent): void;
    onBeforeEnter(): void;
    onAfterEnter(): void;
    onLeave(): void;
    onAfterLeave(): void;
    preventClosing(preventing: boolean): void;
}, {
    overlayClasses: any;
    hasTrigger: Record<"click" | "focus" | "hover" | "context-menu", boolean>;
    normalizedDelay: {
        open: number;
        close: number;
    };
    computeAttach: import("..").AttachNode;
}, {
    expandAnimation: boolean;
    updateScrollTop: Function;
    attach: import("..").AttachNode;
    content: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    default: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    delay: number | number[];
    destroyOnClose: boolean;
    disabled: boolean;
    hideEmptyPopup: boolean;
    overlayClassName: import("..").ClassName;
    overlayInnerClassName: import("..").ClassName;
    overlayInnerStyle: import("..").Styles | ((triggerElement: HTMLElement, popupElement: HTMLElement) => import("..").Styles);
    overlayStyle: import("..").Styles | ((triggerElement: HTMLElement, popupElement: HTMLElement) => import("..").Styles);
    placement: string;
    popperOptions: object;
    showArrow: boolean;
    trigger: "click" | "focus" | "mousedown" | "hover" | "context-menu";
    triggerElement: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    visible: any;
    defaultVisible: boolean;
    zIndex: number;
    onScroll: (context: {
        e: WheelEvent;
    }) => void;
    onScrollToBottom: (context: {
        e: WheelEvent;
    }) => void;
    onVisibleChange: (visible: boolean, context: import("./type").PopupVisibleChangeContext) => void;
}> & import("vue").PluginObject<import("vue/types/vue").ExtendedVue<{
    classPrefix: string;
    componentName: string;
    commonSizeClassName: Record<string, string>;
    commonStatusClassName: Record<string, string>;
} & Record<never, any> & import("../config-provider/config-receiver").ConfigComponent & import("vue").default & {
    globalAttach(): import("..").AttachNode;
}, {
    popper: import("@popperjs/core").Instance;
    timeout: any;
    hasDocumentEvent: boolean;
    visibleState: number;
    mouseInRange: boolean;
    contentClicked: boolean;
    isLeaving: boolean;
}, {
    updatePopper(): void;
    popupMounted(): void;
    getOverlayStyle(): import("..").Styles;
    updateOverlayInnerStyle(): void;
    destroyPopper(): void;
    handleToggle(context: import("./type").PopupVisibleChangeContext): void;
    handleOnScroll(e: WheelEvent): void;
    handleOpen(context: Pick<import("./type").PopupVisibleChangeContext, "trigger">): void;
    handleClose(context: Pick<import("./type").PopupVisibleChangeContext, "trigger">): void;
    handleDocumentClick(ev?: MouseEvent): void;
    emitPopVisible(visible: boolean, context: import("./type").PopupVisibleChangeContext): void;
    onMouseEnter(): void;
    onMouseLeave(ev: MouseEvent): void;
    onBeforeEnter(): void;
    onAfterEnter(): void;
    onLeave(): void;
    onAfterLeave(): void;
    preventClosing(preventing: boolean): void;
}, {
    overlayClasses: any;
    hasTrigger: Record<"click" | "focus" | "hover" | "context-menu", boolean>;
    normalizedDelay: {
        open: number;
        close: number;
    };
    computeAttach: import("..").AttachNode;
}, {
    expandAnimation: boolean;
    updateScrollTop: Function;
    attach: import("..").AttachNode;
    content: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    default: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    delay: number | number[];
    destroyOnClose: boolean;
    disabled: boolean;
    hideEmptyPopup: boolean;
    overlayClassName: import("..").ClassName;
    overlayInnerClassName: import("..").ClassName;
    overlayInnerStyle: import("..").Styles | ((triggerElement: HTMLElement, popupElement: HTMLElement) => import("..").Styles);
    overlayStyle: import("..").Styles | ((triggerElement: HTMLElement, popupElement: HTMLElement) => import("..").Styles);
    placement: string;
    popperOptions: object;
    showArrow: boolean;
    trigger: "click" | "focus" | "mousedown" | "hover" | "context-menu";
    triggerElement: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    visible: any;
    defaultVisible: boolean;
    zIndex: number;
    onScroll: (context: {
        e: WheelEvent;
    }) => void;
    onScrollToBottom: (context: {
        e: WheelEvent;
    }) => void;
    onVisibleChange: (visible: boolean, context: import("./type").PopupVisibleChangeContext) => void;
}>> & import("vue").PluginObject<import("vue/types/vue").ExtendedVue<{
    classPrefix: string;
    componentName: string;
    commonSizeClassName: Record<string, string>;
    commonStatusClassName: Record<string, string>;
} & Record<never, any> & import("../config-provider/config-receiver").ConfigComponent & import("vue").default & {
    globalAttach(): import("..").AttachNode;
}, {
    popper: import("@popperjs/core").Instance;
    timeout: any;
    hasDocumentEvent: boolean;
    visibleState: number;
    mouseInRange: boolean;
    contentClicked: boolean;
    isLeaving: boolean;
}, {
    updatePopper(): void;
    popupMounted(): void;
    getOverlayStyle(): import("..").Styles;
    updateOverlayInnerStyle(): void;
    destroyPopper(): void;
    handleToggle(context: import("./type").PopupVisibleChangeContext): void;
    handleOnScroll(e: WheelEvent): void;
    handleOpen(context: Pick<import("./type").PopupVisibleChangeContext, "trigger">): void;
    handleClose(context: Pick<import("./type").PopupVisibleChangeContext, "trigger">): void;
    handleDocumentClick(ev?: MouseEvent): void;
    emitPopVisible(visible: boolean, context: import("./type").PopupVisibleChangeContext): void;
    onMouseEnter(): void;
    onMouseLeave(ev: MouseEvent): void;
    onBeforeEnter(): void;
    onAfterEnter(): void;
    onLeave(): void;
    onAfterLeave(): void;
    preventClosing(preventing: boolean): void;
}, {
    overlayClasses: any;
    hasTrigger: Record<"click" | "focus" | "hover" | "context-menu", boolean>;
    normalizedDelay: {
        open: number;
        close: number;
    };
    computeAttach: import("..").AttachNode;
}, {
    expandAnimation: boolean;
    updateScrollTop: Function;
    attach: import("..").AttachNode;
    content: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    default: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    delay: number | number[];
    destroyOnClose: boolean;
    disabled: boolean;
    hideEmptyPopup: boolean;
    overlayClassName: import("..").ClassName;
    overlayInnerClassName: import("..").ClassName;
    overlayInnerStyle: import("..").Styles | ((triggerElement: HTMLElement, popupElement: HTMLElement) => import("..").Styles);
    overlayStyle: import("..").Styles | ((triggerElement: HTMLElement, popupElement: HTMLElement) => import("..").Styles);
    placement: string;
    popperOptions: object;
    showArrow: boolean;
    trigger: "click" | "focus" | "mousedown" | "hover" | "context-menu";
    triggerElement: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    visible: any;
    defaultVisible: boolean;
    zIndex: number;
    onScroll: (context: {
        e: WheelEvent;
    }) => void;
    onScrollToBottom: (context: {
        e: WheelEvent;
    }) => void;
    onVisibleChange: (visible: boolean, context: import("./type").PopupVisibleChangeContext) => void;
}> & import("vue").PluginObject<import("vue/types/vue").ExtendedVue<{
    classPrefix: string;
    componentName: string;
    commonSizeClassName: Record<string, string>;
    commonStatusClassName: Record<string, string>;
} & Record<never, any> & import("../config-provider/config-receiver").ConfigComponent & import("vue").default & {
    globalAttach(): import("..").AttachNode;
}, {
    popper: import("@popperjs/core").Instance;
    timeout: any;
    hasDocumentEvent: boolean;
    visibleState: number;
    mouseInRange: boolean;
    contentClicked: boolean;
    isLeaving: boolean;
}, {
    updatePopper(): void;
    popupMounted(): void;
    getOverlayStyle(): import("..").Styles;
    updateOverlayInnerStyle(): void;
    destroyPopper(): void;
    handleToggle(context: import("./type").PopupVisibleChangeContext): void;
    handleOnScroll(e: WheelEvent): void;
    handleOpen(context: Pick<import("./type").PopupVisibleChangeContext, "trigger">): void;
    handleClose(context: Pick<import("./type").PopupVisibleChangeContext, "trigger">): void;
    handleDocumentClick(ev?: MouseEvent): void;
    emitPopVisible(visible: boolean, context: import("./type").PopupVisibleChangeContext): void;
    onMouseEnter(): void;
    onMouseLeave(ev: MouseEvent): void;
    onBeforeEnter(): void;
    onAfterEnter(): void;
    onLeave(): void;
    onAfterLeave(): void;
    preventClosing(preventing: boolean): void;
}, {
    overlayClasses: any;
    hasTrigger: Record<"click" | "focus" | "hover" | "context-menu", boolean>;
    normalizedDelay: {
        open: number;
        close: number;
    };
    computeAttach: import("..").AttachNode;
}, {
    expandAnimation: boolean;
    updateScrollTop: Function;
    attach: import("..").AttachNode;
    content: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    default: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    delay: number | number[];
    destroyOnClose: boolean;
    disabled: boolean;
    hideEmptyPopup: boolean;
    overlayClassName: import("..").ClassName;
    overlayInnerClassName: import("..").ClassName;
    overlayInnerStyle: import("..").Styles | ((triggerElement: HTMLElement, popupElement: HTMLElement) => import("..").Styles);
    overlayStyle: import("..").Styles | ((triggerElement: HTMLElement, popupElement: HTMLElement) => import("..").Styles);
    placement: string;
    popperOptions: object;
    showArrow: boolean;
    trigger: "click" | "focus" | "mousedown" | "hover" | "context-menu";
    triggerElement: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    visible: any;
    defaultVisible: boolean;
    zIndex: number;
    onScroll: (context: {
        e: WheelEvent;
    }) => void;
    onScrollToBottom: (context: {
        e: WheelEvent;
    }) => void;
    onVisibleChange: (visible: boolean, context: import("./type").PopupVisibleChangeContext) => void;
}>>>;
export default Popup;
