/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _typeof = require('@babel/runtime/helpers/typeof');
var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var core = require('@popperjs/core');
var utils_dom = require('../utils/dom.js');
var utils_renderTnode = require('../utils/render-tnode.js');
var utils_helper = require('../utils/helper.js');
var _common_js_utils_setStyle = require('../_common/js/utils/setStyle.js');
var popup_props = require('./props.js');
var popup_container = require('./container.js');
var configProvider_configReceiver = require('../config-provider/config-receiver.js');
var utils_mixins = require('../utils/mixins.js');
var utils_event = require('../utils/event.js');
var popup_utils = require('./utils.js');
var debounce = require('../_chunks/dep-f3761329.js');
require('vue');
require('raf');
require('../utils/easing.js');
require('../_chunks/dep-738b4f21.js');
require('../_chunks/dep-a4308f57.js');
require('../_chunks/dep-fcf0662d.js');
require('../_chunks/dep-e4278c54.js');
require('@babel/runtime/helpers/readOnlyError');
require('@vue/composition-api');
require('../_chunks/dep-7c854ec6.js');
require('../_chunks/dep-eceed11d.js');
require('../_chunks/dep-201f7798.js');
require('../_chunks/dep-d3015b4c.js');
require('../_chunks/dep-f8a85d6a.js');
require('../_chunks/dep-5b117689.js');
require('../_chunks/dep-6478392e.js');
require('../_chunks/dep-47bca35e.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/slicedToArray');
require('../_chunks/dep-ecccff93.js');
require('../_chunks/dep-a4cecac4.js');
require('../_chunks/dep-07fb8c0e.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-a4a18104.js');
require('../_chunks/dep-27dd8cc6.js');
require('dayjs');
require('../_chunks/dep-87c765cc.js');
require('../_chunks/dep-75cd6d52.js');
require('../_chunks/dep-b1a02818.js');
require('../_chunks/dep-3d8ab37d.js');
require('../_chunks/dep-ab142eaf.js');
require('../_chunks/dep-6ad3de7c.js');
require('../_chunks/dep-8b1e056e.js');
require('../_chunks/dep-5db8defc.js');
require('../_chunks/dep-6e4c473c.js');
require('../_chunks/dep-234b7c02.js');
require('../_chunks/dep-a4747856.js');
require('../_chunks/dep-932dd69e.js');
require('../_chunks/dep-9f4caea4.js');
require('../_chunks/dep-dbd838d6.js');
require('../_chunks/dep-b3120c1b.js');
require('../_chunks/dep-68ba2357.js');
require('../_chunks/dep-173eb46c.js');
require('../_chunks/dep-848a5a32.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _typeof__default = /*#__PURE__*/_interopDefaultLegacy(_typeof);
var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var classPrefixMixins = configProvider_configReceiver.getClassPrefixMixins("popup");
var injectionKey = "__T_POPUP";
var Popup = utils_mixins["default"](classPrefixMixins, configProvider_configReceiver.getAttachConfigMixins("popup")).extend({
  name: "TPopup",
  provide: function provide() {
    return _defineProperty__default["default"]({}, injectionKey, this);
  },
  inject: {
    popup: {
      from: injectionKey,
      "default": void 0
    }
  },
  props: _objectSpread(_objectSpread({}, popup_props["default"]), {}, {
    expandAnimation: {
      type: Boolean
    },
    updateScrollTop: {
      type: Function
    }
  }),
  data: function data() {
    return {
      popper: null,
      timeout: null,
      hasDocumentEvent: false,
      visibleState: 0,
      mouseInRange: false,
      contentClicked: false,
      isLeaving: false
    };
  },
  computed: {
    overlayClasses: function overlayClasses() {
      return ["".concat(this.componentName, "__content"), _defineProperty__default["default"](_defineProperty__default["default"](_defineProperty__default["default"]({}, "".concat(this.componentName, "__content--text"), this.content === "string"), "".concat(this.componentName, "__content--arrow"), this.showArrow), this.commonStatusClassName.disabled, this.disabled), this.overlayInnerClassName];
    },
    hasTrigger: function hasTrigger() {
      var _this = this;
      return popup_utils.triggers.reduce(function (map, trigger) {
        return _objectSpread(_objectSpread({}, map), {}, _defineProperty__default["default"]({}, trigger, _this.trigger.includes(trigger)));
      }, {});
    },
    normalizedDelay: function normalizedDelay() {
      var _this$delay, _delay$;
      var delay = [].concat((_this$delay = this.delay) !== null && _this$delay !== void 0 ? _this$delay : popup_utils.defaultVisibleDelay);
      return {
        open: delay[0],
        close: (_delay$ = delay[1]) !== null && _delay$ !== void 0 ? _delay$ : delay[0]
      };
    },
    computeAttach: function computeAttach() {
      return this.attach || this.globalAttach();
    }
  },
  watch: {
    visible: function visible(_visible) {
      var _this2 = this;
      var hasTrigger = this.hasTrigger,
        triggerEl = this.$el;
      if (_visible) {
        this.preventClosing(true);
        if (!this.hasDocumentEvent) {
          utils_dom.on(document, "mousedown", this.handleDocumentClick, true);
          this.hasDocumentEvent = true;
        }
        if (triggerEl && hasTrigger.focus) {
          utils_dom.once(triggerEl, "keydown", function (ev) {
            if (ev.code === "Escape") {
              _this2.handleClose({
                trigger: "keydown-esc"
              });
            }
          });
        }
        this.$nextTick(function () {
          _this2.popupMounted();
          _this2.updateOverlayInnerStyle();
        });
      } else {
        this.preventClosing(false);
        utils_dom.off(document, "mousedown", this.handleDocumentClick, true);
        this.hasDocumentEvent = false;
        this.mouseInRange = false;
      }
    },
    overlayInnerStyle: function overlayInnerStyle() {
      this.updateOverlayInnerStyle();
      this.updatePopper();
    },
    placement: function placement() {
      var _this$popper;
      (_this$popper = this.popper) === null || _this$popper === void 0 || _this$popper.destroy();
      this.popper = null;
      this.updatePopper();
    },
    contentClicked: function contentClicked(clicked) {
      if (this.popup) {
        this.popup.contentClicked = clicked;
      }
    }
  },
  mounted: function mounted() {
    var _this3 = this;
    var trigger = popup_utils.attachListeners(this.$el);
    var updateTrigger = function updateTrigger() {
      trigger.clean();
      var hasTrigger = _this3.hasTrigger;
      if (hasTrigger.hover) {
        trigger.add("mouseenter", function () {
          return _this3.handleOpen({
            trigger: "trigger-element-hover"
          });
        });
        trigger.add("mouseleave", function () {
          return _this3.handleClose({
            trigger: "trigger-element-hover"
          });
        });
      } else if (hasTrigger.focus) {
        trigger.add("focusin", function () {
          return _this3.handleOpen({
            trigger: "trigger-element-focus"
          });
        });
        trigger.add("focusout", function () {
          return _this3.handleClose({
            trigger: "trigger-element-blur"
          });
        });
      } else if (hasTrigger.click) {
        trigger.add("click", function (e) {
          _this3.handleToggle({
            e: e,
            trigger: "trigger-element-click"
          });
          if (utils_helper.getIEVersion() < 11) {
            _this3.handleDocumentClick(e);
          }
        });
      } else if (hasTrigger["context-menu"]) {
        trigger.add("contextmenu", function (e) {
          e.preventDefault();
          e.button === 2 && _this3.handleToggle({
            trigger: "context-menu"
          });
        });
      }
    };
    updateTrigger();
    this.$watch("trigger", updateTrigger);
  },
  updated: function updated() {
    var _this$$refs$container;
    (_this$$refs$container = this.$refs.container) === null || _this$$refs$container === void 0 || _this$$refs$container.updateContent();
  },
  beforeDestroy: function beforeDestroy() {
    if (this.visible) {
      var _this$popup;
      (_this$popup = this.popup) === null || _this$popup === void 0 || _this$popup.preventClosing(false);
    }
    this.destroyPopper();
    utils_dom.off(document, "mousedown", this.handleDocumentClick, true);
    clearTimeout(this.timeout);
  },
  methods: {
    updatePopper: function updatePopper() {
      var _this4 = this;
      var triggerEl = this.$el;
      var popperEl = this.$refs.popper;
      if (!popperEl || !this.visible) return;
      if (this.popper) {
        this.popper.update();
        return;
      }
      this.popper = core.createPopper(triggerEl, popperEl, _objectSpread({
        modifiers: utils_helper.getIEVersion() > 9 ? [] : [{
          name: "computeStyles",
          options: {
            gpuAcceleration: false
          }
        }],
        placement: popup_utils.getPopperPlacement(this.placement),
        onFirstUpdate: function onFirstUpdate() {
          _this4.$nextTick(_this4.updatePopper);
        }
      }, this.popperOptions));
    },
    popupMounted: function popupMounted() {
      var _this$$refs;
      var overlayEl = (_this$$refs = this.$refs) === null || _this$$refs === void 0 ? void 0 : _this$$refs.overlay;
      if (overlayEl) {
        var _this$updateScrollTop;
        (_this$updateScrollTop = this.updateScrollTop) === null || _this$updateScrollTop === void 0 || _this$updateScrollTop.call(this, overlayEl);
      }
    },
    getOverlayStyle: function getOverlayStyle() {
      var _this$$refs2;
      var overlayStyle = this.overlayStyle;
      var triggerEl = this.$el;
      var overlayEl = (_this$$refs2 = this.$refs) === null || _this$$refs2 === void 0 ? void 0 : _this$$refs2.overlay;
      if (typeof overlayStyle === "function") {
        return overlayStyle(triggerEl, overlayEl);
      }
      if (_typeof__default["default"](overlayStyle) === "object") {
        return overlayStyle;
      }
    },
    updateOverlayInnerStyle: function updateOverlayInnerStyle() {
      var _this$$refs3;
      var overlayInnerStyle = this.overlayInnerStyle;
      var triggerEl = this.$el;
      var overlayEl = (_this$$refs3 = this.$refs) === null || _this$$refs3 === void 0 ? void 0 : _this$$refs3.overlay;
      if (!triggerEl || !overlayEl) return;
      if (typeof overlayInnerStyle === "function") {
        _common_js_utils_setStyle["default"](overlayEl, overlayInnerStyle(triggerEl, overlayEl));
      } else if (_typeof__default["default"](overlayInnerStyle) === "object") {
        _common_js_utils_setStyle["default"](overlayEl, overlayInnerStyle);
      }
    },
    destroyPopper: function destroyPopper() {
      if (this.popper) {
        this.popper.destroy();
        this.popper = null;
      }
      if (this.destroyOnClose) {
        var _this$$refs$container2;
        (_this$$refs$container2 = this.$refs.container) === null || _this$$refs$container2 === void 0 || _this$$refs$container2.unmountContent();
      }
    },
    handleToggle: function handleToggle(context) {
      this.emitPopVisible(!this.visible, context);
    },
    handleOnScroll: function handleOnScroll(e) {
      var _this5 = this;
      var _e$target = e.target,
        scrollTop = _e$target.scrollTop,
        clientHeight = _e$target.clientHeight,
        scrollHeight = _e$target.scrollHeight;
      var debounceOnScrollBottom = debounce.debounce(function (e2) {
        return utils_event.emitEvent(_this5, "scroll-to-bottom", {
          e: e2
        });
      }, 100);
      if (clientHeight + Math.floor(scrollTop) === scrollHeight) {
        debounceOnScrollBottom(e);
      }
      utils_event.emitEvent(this, "scroll", {
        e: e
      });
    },
    handleOpen: function handleOpen(context) {
      var _this6 = this;
      clearTimeout(this.timeout);
      this.timeout = setTimeout(function () {
        _this6.emitPopVisible(true, context);
      }, this.hasTrigger.click ? 0 : this.normalizedDelay.open);
    },
    handleClose: function handleClose(context) {
      var _this7 = this;
      clearTimeout(this.timeout);
      this.timeout = setTimeout(function () {
        _this7.emitPopVisible(false, context);
      }, this.hasTrigger.click ? 0 : this.normalizedDelay.close);
    },
    handleDocumentClick: function handleDocumentClick(ev) {
      var _this8 = this;
      setTimeout(function () {
        if (_this8.contentClicked) {
          setTimeout(function () {
            _this8.contentClicked = false;
          });
          return;
        }
        var triggerEl = _this8.$el;
        if (triggerEl.contains(ev.target)) return;
        var popperEl = _this8.$refs.popper;
        if (popperEl !== null && popperEl !== void 0 && popperEl.contains(ev.target)) return;
        _this8.visibleState = 0;
        _this8.emitPopVisible(false, {
          trigger: "document",
          e: ev
        });
      });
    },
    emitPopVisible: function emitPopVisible(visible, context) {
      if (this.disabled || visible === !!this.visible) return;
      if (!visible && this.visibleState > 1) return;
      if (visible && this.mouseInRange) return;
      this.$emit("visible-change", visible, context);
      if (typeof this.onVisibleChange === "function") {
        this.onVisibleChange(visible, context);
      }
    },
    onMouseEnter: function onMouseEnter() {
      if (this.destroyOnClose && this.isLeaving) {
        return;
      }
      this.mouseInRange = true;
      this.handleOpen({});
    },
    onMouseLeave: function onMouseLeave(ev) {
      if (this.visibleState > 1) {
        var rect = this.$refs.popper.getBoundingClientRect();
        if (ev.x > rect.x && ev.x < rect.x + rect.width && ev.y > rect.y && ev.y < rect.y + rect.height) return;
      }
      this.mouseInRange = false;
      this.handleClose({});
      var parent = this.popup;
      if (parent !== null && parent !== void 0 && parent.mouseInRange) {
        parent.onMouseLeave(ev);
      }
    },
    onBeforeEnter: function onBeforeEnter() {
      if (this.visible) {
        this.updatePopper();
      }
    },
    onAfterEnter: function onAfterEnter() {
      if (this.visible) {
        this.updatePopper();
      }
    },
    onLeave: function onLeave() {
      this.isLeaving = true;
    },
    onAfterLeave: function onAfterLeave() {
      this.isLeaving = false;
      this.destroyPopper();
    },
    preventClosing: function preventClosing(preventing) {
      var parent = this.popup;
      parent === null || parent === void 0 || parent.preventClosing(preventing);
      if (preventing) {
        this.visibleState += 1;
      } else if (this.visibleState) {
        this.visibleState -= 1;
        if (!this.visibleState) {
          this.emitPopVisible(false, {});
          if (parent !== null && parent !== void 0 && parent.hasTrigger.hover && !(parent !== null && parent !== void 0 && parent.mouseInRange)) {
            parent.emitPopVisible(false, {});
          }
        }
      }
    }
  },
  render: function render(h) {
    var _this9 = this;
    var visible = this.visible,
      destroyOnClose = this.destroyOnClose,
      hasTrigger = this.hasTrigger,
      handleOnScroll = this.handleOnScroll;
    var ref = utils_renderTnode.renderContent(this, "default", "triggerElement");
    var content = utils_renderTnode.renderTNodeJSX(this, "content");
    var hidePopup = this.hideEmptyPopup && ["", void 0, null].includes(content);
    var overlay = visible || !destroyOnClose ? h("div", {
      "class": [this.componentName, this.overlayClassName],
      ref: "popper",
      style: [hidePopup && {
        visibility: "hidden",
        pointerEvents: "none"
      }, {
        zIndex: this.zIndex
      }, this.getOverlayStyle()],
      directives: destroyOnClose ? void 0 : [{
        name: "show",
        rawName: "v-show",
        value: visible && !hidePopup,
        expression: "visible"
      }],
      on: _objectSpread({
        mousedown: function mousedown() {
          _this9.contentClicked = true;
        }
      }, hasTrigger.hover && {
        mouseenter: this.onMouseEnter,
        mouseleave: this.onMouseLeave
      })
    }, [h("div", {
      "class": this.overlayClasses,
      ref: "overlay",
      on: {
        scroll: function scroll(e) {
          handleOnScroll(e);
        }
      }
    }, [content, this.showArrow && h("div", {
      "class": "".concat(this.componentName, "__arrow")
    })])]) : null;
    return h(popup_container["default"], {
      "ref": "container",
      "on": {
        "contentMounted": function contentMounted() {
          if (visible) {
            _this9.updatePopper();
            _this9.updateOverlayInnerStyle();
          }
        },
        "resize": function resize() {
          if (visible) {
            _this9.updatePopper();
            _this9.updateOverlayInnerStyle();
          }
        }
      },
      "attrs": {
        "parent": this,
        "visible": visible,
        "attach": function attach() {
          return {
            attach: _this9.computeAttach,
            current: _this9.$el
          };
        }
      }
    }, [h("transition", {
      "slot": "content",
      "attrs": {
        "name": this.expandAnimation ? "".concat(this.componentName, "--animation-expand") : "".concat(this.componentName, "--animation"),
        "appear": true
      },
      "on": {
        "beforeEnter": this.onBeforeEnter,
        "afterEnter": this.onAfterEnter,
        "leave": this.onLeave,
        "afterLeave": this.onAfterLeave
      }
    }, [overlay]), ref]);
  }
});

exports["default"] = Popup;
//# sourceMappingURL=popup.js.map
