/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var utils_dom = require('../utils/dom.js');
require('vue');
require('raf');
require('../utils/easing.js');
require('../_chunks/dep-738b4f21.js');
require('../_chunks/dep-a4308f57.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-fcf0662d.js');
require('../_chunks/dep-e4278c54.js');

var triggers = ["click", "hover", "focus", "context-menu"];
var defaultVisibleDelay = [250, 150];
function getPopperPlacement(placement) {
  return placement.replace(/-(left|top)$/, "-start").replace(/-(right|bottom)$/, "-end");
}
function attachListeners(elm) {
  var offs = [];
  return {
    add: function add(type, listener) {
      utils_dom.on(elm, type, listener);
      offs.push(function () {
        utils_dom.off(elm, type, listener);
      });
    },
    clean: function clean() {
      offs.forEach(function (handler) {
        return handler === null || handler === void 0 ? void 0 : handler();
      });
      offs.length = 0;
    }
  };
}

exports.attachListeners = attachListeners;
exports.defaultVisibleDelay = defaultVisibleDelay;
exports.getPopperPlacement = getPopperPlacement;
exports.triggers = triggers;
//# sourceMappingURL=utils.js.map
