/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var helper = require('../_chunks/dep-ece3c062.js');
var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var radio_radioGroupProps = require('./radio-group-props.js');
var radio_radio = require('./radio.js');
var radio_radioButton = require('./radio-button.js');
var utils_event = require('../utils/event.js');
var configProvider_configReceiver = require('../config-provider/config-receiver.js');
var utils_mixins = require('../utils/mixins.js');
var utils_dom = require('../utils/dom.js');
var _common_js_common = require('../_common/js/common.js');
var isNumber = require('../_chunks/dep-aa0a4aac.js');
var isString = require('../_chunks/dep-738b4f21.js');
require('vue');
require('../utils/helper.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/slicedToArray');
require('../_chunks/dep-7c854ec6.js');
require('../_chunks/dep-eceed11d.js');
require('../_chunks/dep-201f7798.js');
require('../_chunks/dep-a4308f57.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-fcf0662d.js');
require('../_chunks/dep-d3015b4c.js');
require('../_chunks/dep-e4278c54.js');
require('../_chunks/dep-f8a85d6a.js');
require('../_chunks/dep-5b117689.js');
require('../_chunks/dep-6478392e.js');
require('../utils/render-tnode.js');
require('@babel/runtime/helpers/readOnlyError');
require('@vue/composition-api');
require('../_chunks/dep-47bca35e.js');
require('./props.js');
require('../_chunks/dep-07fb8c0e.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-a4a18104.js');
require('../_chunks/dep-27dd8cc6.js');
require('dayjs');
require('../_chunks/dep-87c765cc.js');
require('../_chunks/dep-75cd6d52.js');
require('../_chunks/dep-b1a02818.js');
require('../_chunks/dep-3d8ab37d.js');
require('../_chunks/dep-ecccff93.js');
require('../_chunks/dep-a4cecac4.js');
require('../_chunks/dep-ab142eaf.js');
require('../_chunks/dep-6ad3de7c.js');
require('../_chunks/dep-8b1e056e.js');
require('../_chunks/dep-5db8defc.js');
require('../_chunks/dep-6e4c473c.js');
require('../_chunks/dep-234b7c02.js');
require('../_chunks/dep-a4747856.js');
require('../_chunks/dep-932dd69e.js');
require('../_chunks/dep-9f4caea4.js');
require('../_chunks/dep-dbd838d6.js');
require('../_chunks/dep-b3120c1b.js');
require('../_chunks/dep-68ba2357.js');
require('../_chunks/dep-173eb46c.js');
require('raf');
require('../utils/easing.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var classPrefixMixins = configProvider_configReceiver.getClassPrefixMixins("radio-group");
var _RadioGroup = utils_mixins["default"](classPrefixMixins).extend({
  name: "TRadioGroup",
  props: _objectSpread({}, radio_radioGroupProps["default"]),
  components: {
    Radio: radio_radio["default"]
  },
  provide: function provide() {
    return {
      radioGroup: this
    };
  },
  data: function data() {
    return {
      barStyle: {
        width: "0px",
        left: "0px"
      },
      observer: null
    };
  },
  computed: {
    checkedClassName: function checkedClassName() {
      return ".".concat(this.classPrefix, "-radio-button.").concat(this.commonStatusClassName.checked);
    }
  },
  render: function render(h) {
    var _this = this;
    var $scopedSlots = this.$scopedSlots;
    var children = $scopedSlots["default"] && $scopedSlots["default"](null);
    if (this.options && this.options.length) {
      children = this.options.map(function (option, index) {
        var opt = option;
        if (isNumber.isNumber(option) || isString.isString(option)) {
          opt = {
            value: option,
            label: option.toString()
          };
        }
        var RadioComponent = _this.theme === "button" ? radio_radioButton["default"] : radio_radio["default"];
        return h(RadioComponent, helper.helper([{}, {
          "props": option
        }, {
          "key": "radio-group-options-".concat(opt.value, "-").concat(index),
          "attrs": {
            "name": _this.name,
            "checked": _this.value === opt.value,
            "disabled": "disabled" in opt ? opt.disabled : _this.disabled,
            "value": opt.value
          }
        }]), [typeof opt.label === "function" ? opt.label(h) : opt.label]);
      });
    }
    var groupClass = ["".concat(this.componentName), this.commonSizeClassName[this.size], _defineProperty__default["default"](_defineProperty__default["default"](_defineProperty__default["default"]({}, "".concat(this.componentName, "__outline"), this.variant === "outline"), "".concat(this.componentName, "--filled"), this.variant.includes("filled")), "".concat(this.componentName, "--primary-filled"), this.variant === "primary-filled")];
    if (this.variant.includes("filled")) {
      children && children.push(h("div", {
        "style": this.barStyle,
        "class": "".concat(this.componentName, "__bg-block")
      }));
    }
    return h("div", {
      "class": groupClass
    }, [children]);
  },
  watch: {
    value: function value() {
      var _this2 = this;
      this.$nextTick(function () {
        return _this2.calcBarStyle();
      });
    }
  },
  mounted: function mounted() {
    this.calcBarStyle();
    var observer = new MutationObserver(this.calcBarStyle);
    observer.observe(this.$el, {
      childList: true,
      attributes: true,
      subtree: true,
      characterData: true
    });
    this.observer = observer;
    this.addKeyboardListeners();
  },
  beforeDestroy: function beforeDestroy() {
    this.observer.disconnect();
    this.removeKeyboardListeners();
  },
  methods: {
    addKeyboardListeners: function addKeyboardListeners() {
      utils_dom.on(this.$el, "keydown", this.checkRadioInGroup);
    },
    removeKeyboardListeners: function removeKeyboardListeners() {
      utils_dom.off(this.$el, "keydown", this.checkRadioInGroup);
    },
    checkRadioInGroup: function checkRadioInGroup(e) {
      var isCheckedCode = _common_js_common.CHECKED_CODE_REG.test(e.key) || _common_js_common.CHECKED_CODE_REG.test(e.code);
      if (isCheckedCode) {
        e.preventDefault();
        var inputNode = e.target.querySelector("input");
        var data = inputNode.dataset;
        if (inputNode.checked && data.allowUncheck) {
          this.handleRadioChange(void 0, {
            e: e
          });
        } else {
          var value = !isNaN(Number(data.value)) ? Number(data.value) : data.value;
          value = typeof value === "string" && {
            "true": true,
            "false": false
          }[value] || value;
          value = typeof value === "string" && value[0] === "'" ? value.replace(/'/g, "") : value;
          this.handleRadioChange(value, {
            e: e
          });
        }
      }
    },
    handleRadioChange: function handleRadioChange(value, context) {
      utils_event.emitEvent(this, "change", value, context);
    },
    calcDefaultBarStyle: function calcDefaultBarStyle() {
      var defaultNode = this.$el.cloneNode(true);
      var div = document.createElement("div");
      div.setAttribute("style", "position: absolute; visibility: hidden;");
      div.appendChild(defaultNode);
      document.body.appendChild(div);
      var defaultCheckedRadio = div.querySelector(this.checkedClassName);
      var offsetWidth = defaultCheckedRadio.offsetWidth,
        offsetLeft = defaultCheckedRadio.offsetLeft;
      document.body.removeChild(div);
      return {
        offsetWidth: offsetWidth,
        offsetLeft: offsetLeft
      };
    },
    calcBarStyle: function calcBarStyle() {
      if (this.variant === "outline") return;
      var checkedRadio = this.$el.querySelector(this.checkedClassName);
      if (!checkedRadio) return;
      var offsetWidth = checkedRadio.offsetWidth,
        offsetLeft = checkedRadio.offsetLeft;
      if (!offsetWidth) {
        var _this$calcDefaultBarS = this.calcDefaultBarStyle(),
          width2 = _this$calcDefaultBarS.offsetWidth,
          left2 = _this$calcDefaultBarS.offsetLeft;
        offsetWidth = width2;
        offsetLeft = left2;
      }
      var width = "".concat(offsetWidth, "px");
      var left = "".concat(offsetLeft, "px");
      if (this.barStyle.width === width && this.barStyle.left === left) return;
      this.barStyle = {
        width: width,
        left: left
      };
    }
  }
});

exports["default"] = _RadioGroup;
//# sourceMappingURL=group.js.map
