/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var VueCompositionAPI = require('@vue/composition-api');
var utils_helper = require('../../utils/helper.js');
var select_option = require('../option.js');
var select_optionGroup = require('../optionGroup.js');
var omit = require('../../_chunks/dep-6dc0a916.js');
var get = require('../../_chunks/dep-f84d1ea5.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/slicedToArray');
require('../../_chunks/dep-7c854ec6.js');
require('../../_chunks/dep-eceed11d.js');
require('../../_chunks/dep-201f7798.js');
require('../../_chunks/dep-a4308f57.js');
require('@babel/runtime/helpers/typeof');
require('../../_chunks/dep-fcf0662d.js');
require('../../_chunks/dep-d3015b4c.js');
require('../../_chunks/dep-e4278c54.js');
require('../../_chunks/dep-f8a85d6a.js');
require('../../_chunks/dep-5b117689.js');
require('../../_chunks/dep-6478392e.js');
require('../../utils/render-tnode.js');
require('@babel/runtime/helpers/readOnlyError');
require('vue');
require('../../_chunks/dep-47bca35e.js');
require('../../utils/ripple.js');
require('../../_common/js/utils/setStyle.js');
require('../../config.js');
require('../../config-provider/config-receiver.js');
require('../../_chunks/dep-07fb8c0e.js');
require('../../_common/js/global-config/default-config.js');
require('../../_common/js/global-config/locale/zh_CN.js');
require('../../_chunks/dep-a4a18104.js');
require('../../_chunks/dep-27dd8cc6.js');
require('dayjs');
require('../../_chunks/dep-87c765cc.js');
require('../../_chunks/dep-75cd6d52.js');
require('../../_chunks/dep-b1a02818.js');
require('../../_chunks/dep-3d8ab37d.js');
require('../../_chunks/dep-ecccff93.js');
require('../../_chunks/dep-a4cecac4.js');
require('../../_chunks/dep-ab142eaf.js');
require('../../_chunks/dep-6ad3de7c.js');
require('../../_chunks/dep-8b1e056e.js');
require('../../_chunks/dep-5db8defc.js');
require('../../_chunks/dep-6e4c473c.js');
require('../../_chunks/dep-234b7c02.js');
require('../../_chunks/dep-a4747856.js');
require('../../_chunks/dep-932dd69e.js');
require('../../_chunks/dep-9f4caea4.js');
require('../../_chunks/dep-dbd838d6.js');
require('../../_chunks/dep-b3120c1b.js');
require('../../_chunks/dep-68ba2357.js');
require('../../_chunks/dep-173eb46c.js');
require('../option-props.js');
require('../../checkbox/index.js');
require('../../checkbox/group.js');
require('../../_chunks/dep-ece3c062.js');
require('@babel/runtime/helpers/toConsumableArray');
require('../../checkbox/checkbox.js');
require('../../checkbox/props.js');
require('../../checkbox/constants.js');
require('../../checkbox/store.js');
require('@babel/runtime/helpers/classCallCheck');
require('@babel/runtime/helpers/createClass');
require('../../checkbox/hooks/useKeyboardEvent.js');
require('../../_common/js/common.js');
require('../../hooks/useConfig.js');
require('../../config-provider/useConfig.js');
require('../../hooks/useVModel.js');
require('../../hooks/useFormDisabled.js');
require('../../hooks/useElementLazyRender.js');
require('../../_common/js/utils/observe.js');
require('../../checkbox/checkbox-group-props.js');
require('../../_chunks/dep-e83685df.js');
require('../../_chunks/dep-d23147db.js');
require('../../_chunks/dep-502c56be.js');
require('../../_chunks/dep-62de1188.js');
require('../../hooks/slots.js');
require('../../utils/withInstall.js');
require('../../hooks/useLazyLoad.js');
require('../util.js');
require('../../_chunks/dep-f45125c9.js');
require('../../_chunks/dep-f33eb57d.js');
require('../../_chunks/dep-63b02f7b.js');
require('../../_chunks/dep-bebcd284.js');
require('../../_chunks/dep-3eec664c.js');
require('../../_chunks/dep-eeb2e214.js');
require('../../hooks/useCommonClassName.js');
require('../option-group-props.js');
require('../../hooks/tnode.js');
require('../../hooks/render-tnode.js');
require('../../_chunks/dep-738b4f21.js');
require('../../_chunks/dep-a6490a32.js');
require('../../_chunks/dep-362bc4d7.js');
require('../../_chunks/dep-b5c96567.js');
require('../../_chunks/dep-a9e7deb2.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function useSelectOptions(props, instance, keys) {
  var options = VueCompositionAPI.ref([]);
  var optionsCache = VueCompositionAPI.ref([]);
  var innerSlotRecord = null;
  var getOptions = function getOptions() {
    var _props$options;
    var dynamicIndex = 0;
    var innerOptions = ((_props$options = props.options) === null || _props$options === void 0 ? void 0 : _props$options.map(function (option) {
      var getFormatOption = function getFormatOption(option2) {
        var _keys$value = keys.value,
          value = _keys$value.value,
          label = _keys$value.label,
          disabled = _keys$value.disabled;
        var restOption = omit.omit(option2, [value, label, disabled]);
        var res = _objectSpread(_objectSpread({}, restOption), {}, {
          index: dynamicIndex,
          label: get.get(option2, label),
          value: get.get(option2, value),
          disabled: get.get(option2, disabled)
        });
        dynamicIndex += 1;
        return res;
      };
      if (option.children) {
        return _objectSpread(_objectSpread({}, option), {}, {
          children: option.children.map(function (child) {
            return getFormatOption(child);
          })
        });
      }
      return getFormatOption(option);
    })) || [];
    if (props.options === void 0) {
      innerSlotRecord = instance.proxy.$slots["default"];
      var currentSlots = instance.proxy.$slots["default"] || [];
      currentSlots.forEach(function (child) {
        if (!child.componentOptions) {
          return;
        }
        var componentName = utils_helper.getVNodeComponentName(child);
        if (componentName && componentName === utils_helper.getVueComponentName(select_option["default"])) {
          innerOptions.push(_objectSpread(_objectSpread({
            "class": child.data.staticClass,
            style: child.data.staticStyle
          }, child.componentOptions.propsData), {}, {
            slots: function slots() {
              return child.componentOptions.children;
            },
            index: dynamicIndex
          }));
          dynamicIndex += 1;
        } else if (componentName && componentName === utils_helper.getVueComponentName(select_optionGroup["default"])) {
          var _child$componentOptio, _child$componentOptio2, _child$componentOptio3;
          var groupOption = _objectSpread(_objectSpread({
            group: (_child$componentOptio = child.componentOptions.propsData) === null || _child$componentOptio === void 0 ? void 0 : _child$componentOptio.label
          }, child.componentOptions.propsData), {}, {
            children: []
          });
          (_child$componentOptio2 = child.componentOptions.children) === null || _child$componentOptio2 === void 0 || (_child$componentOptio3 = _child$componentOptio2.forEach) === null || _child$componentOptio3 === void 0 || _child$componentOptio3.call(_child$componentOptio2, function (groupChild) {
            groupOption.children.push(_objectSpread(_objectSpread({
              "class": groupChild.data.staticClass,
              style: groupChild.data.staticStyle
            }, groupChild.componentOptions.propsData), {}, {
              slots: function slots() {
                return groupChild.componentOptions.children;
              },
              index: dynamicIndex
            }));
            dynamicIndex += 1;
          });
          innerOptions.push(groupOption);
        }
      });
    }
    options.value = innerOptions;
  };
  var optionsMap = VueCompositionAPI.computed(function () {
    var res = /* @__PURE__ */new Map();
    optionsCache.value.concat(optionsList.value).forEach(function (option) {
      res.set(option.value, option);
    });
    return res;
  });
  var optionsList = VueCompositionAPI.computed(function () {
    var res = [];
    var _getOptionsList = function getOptionsList(options2) {
      options2.forEach(function (option) {
        if (option.children) {
          _getOptionsList(option.children);
        } else {
          res.push(option);
        }
      });
    };
    _getOptionsList(options.value);
    return res;
  });
  getOptions();
  VueCompositionAPI.watch(function () {
    return props.options;
  }, function () {
    getOptions();
  });
  VueCompositionAPI.onBeforeUpdate(function () {
    if (props.options === void 0 && innerSlotRecord !== instance.proxy.$slots["default"]) {
      getOptions();
    }
  });
  return {
    options: options,
    optionsMap: optionsMap,
    optionsList: optionsList,
    optionsCache: optionsCache
  };
}

exports["default"] = useSelectOptions;
//# sourceMappingURL=useSelectOptions.js.map
