/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var VueCompositionAPI = require('@vue/composition-api');
var select_optionGroupProps = require('./option-group-props.js');
var hooks_tnode = require('../hooks/tnode.js');
var configProvider_useConfig = require('../config-provider/useConfig.js');
var hooks_useCommonClassName = require('../hooks/useCommonClassName.js');
require('../hooks/render-tnode.js');
require('../_chunks/dep-a4cecac4.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-738b4f21.js');
require('../_chunks/dep-a4308f57.js');
require('../_chunks/dep-fcf0662d.js');
require('../_chunks/dep-e4278c54.js');
require('../_chunks/dep-7c854ec6.js');
require('../_chunks/dep-eceed11d.js');
require('../_chunks/dep-201f7798.js');
require('../_chunks/dep-d3015b4c.js');
require('../_chunks/dep-f8a85d6a.js');
require('../_chunks/dep-5b117689.js');
require('../_chunks/dep-6478392e.js');
require('../_chunks/dep-47bca35e.js');
require('../_chunks/dep-ecccff93.js');
require('../_chunks/dep-a6490a32.js');
require('../_chunks/dep-3eec664c.js');
require('../_chunks/dep-8b1e056e.js');
require('../_chunks/dep-5db8defc.js');
require('../_chunks/dep-6e4c473c.js');
require('../_chunks/dep-3d8ab37d.js');
require('../_chunks/dep-eeb2e214.js');
require('../_chunks/dep-6ad3de7c.js');
require('../_chunks/dep-07fb8c0e.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-a4a18104.js');
require('../_chunks/dep-27dd8cc6.js');
require('dayjs');
require('../_chunks/dep-87c765cc.js');
require('../_chunks/dep-75cd6d52.js');
require('../_chunks/dep-b1a02818.js');
require('../_chunks/dep-ab142eaf.js');
require('../_chunks/dep-234b7c02.js');
require('../_chunks/dep-a4747856.js');
require('../_chunks/dep-932dd69e.js');
require('../_chunks/dep-9f4caea4.js');
require('../_chunks/dep-dbd838d6.js');
require('../_chunks/dep-b3120c1b.js');
require('../_chunks/dep-68ba2357.js');
require('../_chunks/dep-173eb46c.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var _OptionGroup = VueCompositionAPI.defineComponent({
  name: "TOptionGroup",
  props: _objectSpread({}, select_optionGroupProps["default"]),
  setup: function setup(props2) {
    var _toRefs = VueCompositionAPI.toRefs(props2),
      divider = _toRefs.divider;
    var tSelect = VueCompositionAPI.inject("tSelect");
    var _useCommonClassName = hooks_useCommonClassName["default"](),
      sizeClassNames = _useCommonClassName.sizeClassNames;
    var COMPONENT_NAME = configProvider_useConfig.usePrefixClass("select");
    var _useConfig = configProvider_useConfig.useConfig("classPrefix"),
      classPrefix = _useConfig.classPrefix;
    var classes = VueCompositionAPI.computed(function () {
      return ["".concat(COMPONENT_NAME.value, "-option-group"), _defineProperty__default["default"](_defineProperty__default["default"]({}, sizeClassNames[tSelect.size], tSelect && tSelect.size), "".concat(COMPONENT_NAME.value, "-option-group__divider"), divider)];
    });
    return {
      classes: classes,
      classPrefix: classPrefix,
      componentName: COMPONENT_NAME
    };
  },
  render: function render() {
    var _this$label;
    var h = arguments[0];
    var renderTNode = hooks_tnode.useTNodeJSX();
    var children = renderTNode("default");
    return h("li", {
      "class": this.classes
    }, [((_this$label = this.label) !== null && _this$label !== void 0 ? _this$label : false) && h("div", {
      "class": "".concat(this.componentName, "-option-group__header")
    }, [this.label]), children]);
  }
});

exports["default"] = _OptionGroup;
//# sourceMappingURL=optionGroup.js.map
