/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var helper = require('../_chunks/dep-ece3c062.js');
var _toConsumableArray = require('@babel/runtime/helpers/toConsumableArray');
var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var VueCompositionAPI = require('@vue/composition-api');
var hooks_tnode = require('../hooks/tnode.js');
var utils_renderTnode = require('../utils/render-tnode.js');
var configProvider_useConfig = require('../config-provider/useConfig.js');
var select_option = require('./option.js');
var select_optionGroup = require('./optionGroup.js');
var hooks_useVirtualScroll = require('../hooks/useVirtualScroll.js');
var select_util = require('./util.js');
var isFunction = require('../_chunks/dep-ecccff93.js');
require('../hooks/render-tnode.js');
require('../_chunks/dep-a4cecac4.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-738b4f21.js');
require('../_chunks/dep-a4308f57.js');
require('../_chunks/dep-fcf0662d.js');
require('../_chunks/dep-e4278c54.js');
require('../_chunks/dep-7c854ec6.js');
require('../_chunks/dep-eceed11d.js');
require('../_chunks/dep-201f7798.js');
require('../_chunks/dep-d3015b4c.js');
require('../_chunks/dep-f8a85d6a.js');
require('../_chunks/dep-5b117689.js');
require('../_chunks/dep-6478392e.js');
require('../_chunks/dep-47bca35e.js');
require('../_chunks/dep-a6490a32.js');
require('../_chunks/dep-3eec664c.js');
require('../_chunks/dep-8b1e056e.js');
require('../_chunks/dep-5db8defc.js');
require('../_chunks/dep-6e4c473c.js');
require('../_chunks/dep-3d8ab37d.js');
require('../_chunks/dep-eeb2e214.js');
require('../_chunks/dep-6ad3de7c.js');
require('@babel/runtime/helpers/readOnlyError');
require('vue');
require('../_chunks/dep-07fb8c0e.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-a4a18104.js');
require('../_chunks/dep-27dd8cc6.js');
require('dayjs');
require('../_chunks/dep-87c765cc.js');
require('../_chunks/dep-75cd6d52.js');
require('../_chunks/dep-b1a02818.js');
require('../_chunks/dep-ab142eaf.js');
require('../_chunks/dep-234b7c02.js');
require('../_chunks/dep-a4747856.js');
require('../_chunks/dep-932dd69e.js');
require('../_chunks/dep-9f4caea4.js');
require('../_chunks/dep-dbd838d6.js');
require('../_chunks/dep-b3120c1b.js');
require('../_chunks/dep-68ba2357.js');
require('../_chunks/dep-173eb46c.js');
require('../utils/ripple.js');
require('../_common/js/utils/setStyle.js');
require('../config.js');
require('../config-provider/config-receiver.js');
require('./option-props.js');
require('../checkbox/index.js');
require('../checkbox/group.js');
require('@babel/runtime/helpers/slicedToArray');
require('../utils/helper.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('../checkbox/checkbox.js');
require('../checkbox/props.js');
require('../checkbox/constants.js');
require('../checkbox/store.js');
require('@babel/runtime/helpers/classCallCheck');
require('@babel/runtime/helpers/createClass');
require('../checkbox/hooks/useKeyboardEvent.js');
require('../_common/js/common.js');
require('../hooks/useConfig.js');
require('../hooks/useVModel.js');
require('../hooks/useFormDisabled.js');
require('../hooks/useElementLazyRender.js');
require('../_common/js/utils/observe.js');
require('../checkbox/checkbox-group-props.js');
require('../_chunks/dep-e83685df.js');
require('../_chunks/dep-d23147db.js');
require('../_chunks/dep-502c56be.js');
require('../_chunks/dep-62de1188.js');
require('../hooks/slots.js');
require('../utils/withInstall.js');
require('../hooks/useLazyLoad.js');
require('../hooks/useCommonClassName.js');
require('../_chunks/dep-f45125c9.js');
require('../_chunks/dep-f33eb57d.js');
require('../_chunks/dep-63b02f7b.js');
require('../_chunks/dep-bebcd284.js');
require('./option-group-props.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _toConsumableArray__default = /*#__PURE__*/_interopDefaultLegacy(_toConsumableArray);
var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var sizeClassMap = {
  small: "s",
  medium: "m",
  large: "l"
};
var SelectPanel = VueCompositionAPI.defineComponent({
  name: "TSelectPanel",
  components: {
    TOption: select_option["default"],
    TOptionGroup: select_optionGroup["default"]
  },
  props: ["inputValue", "panelTopContent", "panelBottomContent", "size", "options", "empty", "filter", "loading", "loadingText", "multiple", "scroll", "creatable", "filterable"],
  setup: function setup(props) {
    var _props$scroll5;
    var _toRefs = VueCompositionAPI.toRefs(props),
      options = _toRefs.options,
      inputValue = _toRefs.inputValue;
    var renderTNode = hooks_tnode.useTNodeJSX();
    var _useConfig = configProvider_useConfig.useConfig("select"),
      t = _useConfig.t,
      global = _useConfig.global;
    var selectProvider = VueCompositionAPI.inject("tSelect");
    var COMPONENT_NAME = configProvider_useConfig.usePrefixClass("select");
    var panelContentRef = VueCompositionAPI.computed(function () {
      return selectProvider.getOverlayElm();
    });
    var _ref = props.scroll || {},
      type = _ref.type,
      _ref$rowHeight = _ref.rowHeight,
      rowHeight = _ref$rowHeight === void 0 ? 28 : _ref$rowHeight,
      _ref$bufferSize = _ref.bufferSize,
      bufferSize = _ref$bufferSize === void 0 ? 20 : _ref$bufferSize,
      _ref$isFixedRowHeight = _ref.isFixedRowHeight,
      isFixedRowHeight = _ref$isFixedRowHeight === void 0 ? false : _ref$isFixedRowHeight,
      _ref$threshold = _ref.threshold,
      threshold = _ref$threshold === void 0 ? 100 : _ref$threshold;
    var displayOptions = VueCompositionAPI.computed(function () {
      if (!inputValue.value || !(props.filterable || isFunction.isFunction(props.filter)) || selectProvider.isRemoteSearch) return options.value;
      var filterMethods = function filterMethods(option) {
        var _option$label, _option$label$toLower;
        if (isFunction.isFunction(props.filter)) {
          return props.filter("".concat(props.inputValue), option);
        }
        if ((option === null || option === void 0 ? void 0 : option.checkAll) === true) return true;
        return ((_option$label = option.label) === null || _option$label === void 0 || (_option$label$toLower = _option$label.toLowerCase) === null || _option$label$toLower === void 0 ? void 0 : _option$label$toLower.call(_option$label).indexOf("".concat(props.inputValue).toLowerCase())) > -1;
      };
      var res = [];
      var groupIndex = isCreateOptionShown.value ? 1 : 0;
      props.options.forEach(function (option) {
        if (option.group && option.children) {
          res.push(_objectSpread(_objectSpread({}, option), {}, {
            children: option.children.filter(filterMethods).reduce(function (pre, cur) {
              pre.push(_objectSpread(_objectSpread({}, cur), {}, {
                index: groupIndex
              }));
              groupIndex += 1;
              return pre;
            }, [])
          }));
        } else if (filterMethods(option)) {
          res.push(_objectSpread(_objectSpread({}, option), {}, {
            index: groupIndex + res.length
          }));
        }
      });
      return res;
    });
    var getDisplayOptions = function getDisplayOptions() {
      var arr = [];
      if (isCreateOptionShown.value) {
        arr.push({
          label: String(inputValue.value),
          value: String(inputValue.value),
          isCreated: true
        });
      }
      arr.push.apply(arr, _toConsumableArray__default["default"](displayOptions.value));
      return arr;
    };
    var isCreateOptionShown = VueCompositionAPI.computed(function () {
      return !!(props.creatable && props.filterable && props.inputValue && select_util.flattenOptions(options.value).find(function (v) {
        return v.label === props.inputValue;
      }) === void 0);
    });
    var isEmpty = VueCompositionAPI.computed(function () {
      return !(displayOptions.value.length > 0);
    });
    var isVirtual = VueCompositionAPI.computed(function () {
      var _props$scroll, _props$options, _props$scroll2;
      return ((_props$scroll = props.scroll) === null || _props$scroll === void 0 ? void 0 : _props$scroll.type) === "virtual" && ((_props$options = props.options) === null || _props$options === void 0 ? void 0 : _props$options.length) > (((_props$scroll2 = props.scroll) === null || _props$scroll2 === void 0 ? void 0 : _props$scroll2.threshold) || 100);
    });
    var _ref2 = type === "virtual" ? hooks_useVirtualScroll["default"]({
        container: panelContentRef,
        data: displayOptions,
        fixedHeight: isFixedRowHeight,
        lineHeight: rowHeight,
        bufferSize: bufferSize,
        threshold: threshold
      }) : {},
      _ref2$trs = _ref2.trs,
      trs = _ref2$trs === void 0 ? null : _ref2$trs,
      _ref2$visibleData = _ref2.visibleData,
      visibleData = _ref2$visibleData === void 0 ? null : _ref2$visibleData,
      _ref2$handleScroll = _ref2.handleScroll,
      handleVirtualScroll = _ref2$handleScroll === void 0 ? null : _ref2$handleScroll,
      _ref2$scrollHeight = _ref2.scrollHeight,
      scrollHeight = _ref2$scrollHeight === void 0 ? null : _ref2$scrollHeight,
      _ref2$translateY = _ref2.translateY,
      translateY = _ref2$translateY === void 0 ? null : _ref2$translateY,
      _ref2$handleRowMounte = _ref2.handleRowMounted,
      handleRowMounted = _ref2$handleRowMounte === void 0 ? null : _ref2$handleRowMounte;
    var lastScrollY = -1;
    var onInnerVirtualScroll = function onInnerVirtualScroll(e) {
      if (!isVirtual.value) {
        return;
      }
      var target = e.target || e.srcElement;
      var top = target.scrollTop;
      if (Math.abs(lastScrollY - top) > 5) {
        handleVirtualScroll();
        lastScrollY = top;
      } else {
        lastScrollY = -1;
      }
    };
    VueCompositionAPI.onMounted(function () {
      var _props$scroll3;
      if (((_props$scroll3 = props.scroll) === null || _props$scroll3 === void 0 ? void 0 : _props$scroll3.type) === "virtual") {
        var _selectProvider$getOv;
        (_selectProvider$getOv = selectProvider.getOverlayElm()) === null || _selectProvider$getOv === void 0 || _selectProvider$getOv.addEventListener("scroll", onInnerVirtualScroll);
      }
    });
    VueCompositionAPI.onBeforeUnmount(function () {
      var _props$scroll4;
      if (((_props$scroll4 = props.scroll) === null || _props$scroll4 === void 0 ? void 0 : _props$scroll4.type) === "virtual") {
        var _selectProvider$getOv2;
        (_selectProvider$getOv2 = selectProvider.getOverlayElm()) === null || _selectProvider$getOv2 === void 0 || _selectProvider$getOv2.removeEventListener("scroll", onInnerVirtualScroll);
      }
    });
    return {
      t: t,
      global: global,
      isEmpty: isEmpty,
      renderTNode: renderTNode,
      selectProvider: selectProvider,
      isCreateOptionShown: isCreateOptionShown,
      trs: trs,
      isVirtual: isVirtual,
      onInnerVirtualScroll: onInnerVirtualScroll,
      visibleData: visibleData,
      scrollHeight: scrollHeight,
      translateY: translateY,
      scrollType: (_props$scroll5 = props.scroll) === null || _props$scroll5 === void 0 ? void 0 : _props$scroll5.type,
      handleRowMounted: handleRowMounted,
      bufferSize: bufferSize,
      threshold: threshold,
      displayOptions: displayOptions,
      getDisplayOptions: getDisplayOptions,
      componentName: COMPONENT_NAME
    };
  },
  methods: {
    renderEmptyContent: function renderEmptyContent() {
      var h = this.$createElement;
      if (this.empty && typeof this.empty === "string") {
        return h("div", {
          "class": "".concat(this.componentName, "__empty")
        }, [this.empty]);
      }
      return utils_renderTnode.renderTNodeJSXDefault(this, "empty", h("div", {
        "class": "".concat(this.componentName, "__empty")
      }, [this.t(this.global.empty)]));
    },
    renderLoadingContent: function renderLoadingContent() {
      var h = this.$createElement;
      if (this.loadingText && typeof this.loadingText === "string") {
        return h("div", {
          "class": "".concat(this.componentName, "__loading-tips")
        }, [this.loadingText]);
      }
      return utils_renderTnode.renderTNodeJSXDefault(this, "loadingText", h("div", {
        "class": "".concat(this.componentName, "__loading-tips")
      }, [this.t(this.global.loadingText)]));
    },
    renderCreateOption: function renderCreateOption() {
      var h = this.$createElement;
      var on = this.isVirtual ? {
        onRowMounted: this.handleRowMounted
      } : {};
      return h("ul", {
        "class": ["".concat(this.componentName, "__create-option"), "".concat(this.componentName, "__list")]
      }, [h("t-option", helper.helper([{
        "attrs": {
          "multiple": this.multiple,
          "index": 0,
          "isCreatedOption": true,
          "value": this.inputValue,
          "label": this.inputValue,
          "trs": this.trs,
          "scrollType": this.scrollType,
          "isVirtual": this.isVirtual,
          "bufferSize": this.bufferSize
        },
        "class": "".concat(this.componentName, "__create-option--special")
      }, {
        "on": on
      }]))]);
    },
    renderOptionsContent: function renderOptionsContent(options) {
      var _this = this;
      var h = this.$createElement;
      var on = this.isVirtual ? {
        onRowMounted: this.handleRowMounted
      } : {};
      return h("ul", {
        "class": "".concat(this.componentName, "__list")
      }, [options.map(function (item, index) {
        if (item.children) {
          return h("t-option-group", {
            "attrs": {
              "label": item.group,
              "divider": item.divider
            }
          }, [_this.renderOptionsContent(item.children)]);
        }
        var scrollProps = _this.isVirtual ? {
          rowIndex: item.$index,
          trs: _this.trs,
          scrollType: _this.scrollType,
          isVirtual: _this.isVirtual,
          bufferSize: _this.bufferSize
        } : {
          key: index
        };
        return h("t-option", helper.helper([{
          "class": item["class"],
          "style": item.style,
          "props": _objectSpread({}, _objectSpread(_objectSpread({}, item), scrollProps)),
          "attrs": {
            "multiple": _this.multiple
          },
          "scopedSlots": {
            "default": item.slots
          },
          "key": "".concat(item.$index || "", "_").concat(index)
        }, {
          "on": on
        }]));
      })]);
    },
    renderPanelContent: function renderPanelContent() {
      var innerStyle = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var h = this.$createElement;
      var loading = this.loading;
      return h("div", {
        "class": ["".concat(this.componentName, "__dropdown-inner"), "".concat(this.componentName, "__dropdown-inner--size-").concat(sizeClassMap[this.size])],
        "style": innerStyle
      }, [this.renderTNode("panelTopContent"), this.isCreateOptionShown && this.renderCreateOption(), loading && this.renderLoadingContent(), !loading && this.isEmpty && !this.isCreateOptionShown && this.renderEmptyContent(), !loading && !this.isEmpty && this.renderOptionsContent(this.isVirtual && this.visibleData ? this.visibleData : this.displayOptions), this.renderTNode("panelBottomContent")]);
    }
  },
  render: function render() {
    var h = arguments[0];
    if (this.isVirtual) {
      var cursorTranslate = "translate(0, ".concat(this.scrollHeight, "px)");
      var cursorTranslateStyle = {
        position: "absolute",
        width: "1px",
        height: "1px",
        transition: "transform 0.2s",
        transform: cursorTranslate,
        "-ms-transform": cursorTranslate,
        "-moz-transform": cursorTranslate,
        "-webkit-transform": cursorTranslate
      };
      var translate = "translate(0, ".concat(this.translateY, "px)");
      var virtualStyle = {
        transform: translate,
        "-ms-transform": translate,
        "-moz-transform": translate,
        "-webkit-transform": translate
      };
      return h("div", [h("div", {
        "style": _objectSpread({}, cursorTranslateStyle)
      }), this.renderPanelContent(virtualStyle)]);
    }
    return this.renderPanelContent();
  }
});

exports["default"] = SelectPanel;
//# sourceMappingURL=select-panel.js.map
