/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var configProvider_configReceiver = require('../config-provider/config-receiver.js');
var utils_mixins = require('../utils/mixins.js');
require('vue');
require('../_chunks/dep-07fb8c0e.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-a4a18104.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-27dd8cc6.js');
require('dayjs');
require('../_chunks/dep-87c765cc.js');
require('../_chunks/dep-75cd6d52.js');
require('../_chunks/dep-b1a02818.js');
require('../_chunks/dep-3d8ab37d.js');
require('../_chunks/dep-ecccff93.js');
require('../_chunks/dep-a4308f57.js');
require('../_chunks/dep-a4cecac4.js');
require('../_chunks/dep-ab142eaf.js');
require('../_chunks/dep-6ad3de7c.js');
require('../_chunks/dep-e4278c54.js');
require('../_chunks/dep-fcf0662d.js');
require('../_chunks/dep-8b1e056e.js');
require('../_chunks/dep-5db8defc.js');
require('../_chunks/dep-6e4c473c.js');
require('../_chunks/dep-234b7c02.js');
require('../_chunks/dep-a4747856.js');
require('../_chunks/dep-932dd69e.js');
require('../_chunks/dep-9f4caea4.js');
require('../_chunks/dep-dbd838d6.js');
require('../_chunks/dep-b3120c1b.js');
require('../_chunks/dep-68ba2357.js');
require('../_chunks/dep-173eb46c.js');

var classPrefixMixins = configProvider_configReceiver.getClassPrefixMixins("slider");
var TSliderMark = utils_mixins["default"](classPrefixMixins).extend({
  name: "TSliderMark",
  props: {
    mark: {
      type: [Object, Array, String]
    },
    point: {
      type: Number
    }
  },
  methods: {
    changeValue: function changeValue(event) {
      event.stopPropagation();
      this.$emit("change-value", this.point);
    }
  },
  render: function render() {
    var h = arguments[0];
    var label = this.mark;
    return h("div", {
      "class": "".concat(this.componentName, "__mark-text"),
      "on": {
        "click": this.changeValue
      }
    }, [label]);
  }
});

exports["default"] = TSliderMark;
//# sourceMappingURL=slider-mark.js.map
