/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var props = {
  align: {
    type: String,
    validator: function validator(val) {
      if (!val) return true;
      return ["start", "end", "center", "baseline"].includes(val);
    }
  },
  breakLine: Boolean,
  direction: {
    type: String,
    "default": "horizontal",
    validator: function validator(val) {
      if (!val) return true;
      return ["vertical", "horizontal"].includes(val);
    }
  },
  separator: {
    type: [String, Function]
  },
  size: {
    type: [String, Number, Array],
    "default": "medium"
  }
};

exports["default"] = props;
//# sourceMappingURL=props.js.map
