/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var props = {
  current: {
    type: [String, Number]
  },
  defaultCurrent: {
    type: [String, Number]
  },
  layout: {
    type: String,
    "default": "horizontal",
    validator: function validator(val) {
      if (!val) return true;
      return ["horizontal", "vertical"].includes(val);
    }
  },
  options: {
    type: Array
  },
  readonly: Boolean,
  separator: {
    type: String,
    "default": "line",
    validator: function validator(val) {
      if (!val) return true;
      return ["line", "dashed", "arrow"].includes(val);
    }
  },
  sequence: {
    type: String,
    "default": "positive",
    validator: function validator(val) {
      if (!val) return true;
      return ["positive", "reverse"].includes(val);
    }
  },
  theme: {
    type: String,
    "default": "default",
    validator: function validator(val) {
      if (!val) return true;
      return ["default", "dot"].includes(val);
    }
  },
  onChange: Function
};

exports["default"] = props;
//# sourceMappingURL=props.js.map
