/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var tdesignIconsVue = require('tdesign-icons-vue');
var utils_mixins = require('../utils/mixins.js');
var configProvider_configReceiver = require('../config-provider/config-receiver.js');
var steps_stepItemProps = require('./step-item-props.js');
var utils_renderTnode = require('../utils/render-tnode.js');
var isFunction = require('../_chunks/dep-ecccff93.js');
require('vue');
require('../_chunks/dep-07fb8c0e.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-a4a18104.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-27dd8cc6.js');
require('dayjs');
require('../_chunks/dep-87c765cc.js');
require('../_chunks/dep-75cd6d52.js');
require('../_chunks/dep-b1a02818.js');
require('../_chunks/dep-3d8ab37d.js');
require('../_chunks/dep-a4308f57.js');
require('../_chunks/dep-a4cecac4.js');
require('../_chunks/dep-ab142eaf.js');
require('../_chunks/dep-6ad3de7c.js');
require('../_chunks/dep-e4278c54.js');
require('../_chunks/dep-fcf0662d.js');
require('../_chunks/dep-8b1e056e.js');
require('../_chunks/dep-5db8defc.js');
require('../_chunks/dep-6e4c473c.js');
require('../_chunks/dep-234b7c02.js');
require('../_chunks/dep-a4747856.js');
require('../_chunks/dep-932dd69e.js');
require('../_chunks/dep-9f4caea4.js');
require('../_chunks/dep-dbd838d6.js');
require('../_chunks/dep-b3120c1b.js');
require('../_chunks/dep-68ba2357.js');
require('../_chunks/dep-173eb46c.js');
require('@babel/runtime/helpers/readOnlyError');
require('@vue/composition-api');
require('../_chunks/dep-7c854ec6.js');
require('../_chunks/dep-eceed11d.js');
require('../_chunks/dep-201f7798.js');
require('../_chunks/dep-d3015b4c.js');
require('../_chunks/dep-f8a85d6a.js');
require('../_chunks/dep-5b117689.js');
require('../_chunks/dep-6478392e.js');
require('../_chunks/dep-47bca35e.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var _StepItem = utils_mixins["default"](configProvider_configReceiver["default"]("steps"), configProvider_configReceiver.getGlobalIconMixins()).extend({
  name: "TStepItem",
  props: _objectSpread(_objectSpread({}, steps_stepItemProps["default"]), {}, {
    index: Number
  }),
  inject: {
    steps: {
      "default": void 0
    }
  },
  computed: {
    current: function current() {
      return this.steps && this.steps.current;
    },
    baseClass: function baseClass() {
      return ["".concat(this.componentName, "-item"), _defineProperty__default["default"]({}, "".concat(this.componentName, "-item--").concat(this.status), this.status)];
    },
    iconClass: function iconClass() {
      return ["".concat(this.componentName, "-item__icon"), _defineProperty__default["default"]({}, "".concat(this.componentName, "-item--").concat(this.status), this.status)];
    },
    canClick: function canClick() {
      var _this$steps;
      return this.status !== "process" && !((_this$steps = this.steps) !== null && _this$steps !== void 0 && _this$steps.readonly);
    }
  },
  methods: {
    renderIcon: function renderIcon() {
      var h = this.$createElement;
      var defaultIcon;
      if (this.steps.theme === "default") {
        var icon = "";
        var _this$useGlobalIcon = this.useGlobalIcon({
            CheckIcon: tdesignIconsVue.CheckIcon,
            CloseIcon: tdesignIconsVue.CloseIcon
          }),
          CheckIcon = _this$useGlobalIcon.CheckIcon,
          CloseIcon = _this$useGlobalIcon.CloseIcon;
        switch (this.status) {
          case "finish":
            if (isFunction.isFunction(this.global.checkIcon)) {
              icon = this.global.checkIcon(this.$createElement);
            } else {
              icon = h(CheckIcon);
            }
            break;
          case "error":
            if (isFunction.isFunction(this.global.errorIcon)) {
              icon = this.global.errorIcon(this.$createElement);
            } else {
              icon = h(CloseIcon);
            }
            break;
          default:
            icon = String(this.index + 1);
            break;
        }
        defaultIcon = h("span", {
          "class": "".concat(this.componentName, "-item__icon--number")
        }, [icon]);
      }
      return utils_renderTnode.renderTNodeJSX(this, "icon", defaultIcon);
    },
    onStepClick: function onStepClick(e) {
      if (!this.canClick) return;
      var val = this.value === void 0 ? this.index : this.value;
      this.steps.handleChange(val, this.current, e);
    }
  },
  render: function render() {
    var h = arguments[0];
    var content = utils_renderTnode.renderContent(this, "default", "content");
    return h("div", {
      "class": this.baseClass
    }, [h("div", {
      "class": "".concat(this.componentName, "-item__inner ").concat(this.canClick ? "".concat(this.componentName, "-item--clickable") : ""),
      "on": {
        "click": this.onStepClick
      }
    }, [h("div", {
      "class": this.iconClass
    }, [this.renderIcon()]), h("div", {
      "class": "".concat(this.componentName, "-item__content")
    }, [h("div", {
      "class": "".concat(this.componentName, "-item__title")
    }, [utils_renderTnode.renderTNodeJSX(this, "title")]), h("div", {
      "class": "".concat(this.componentName, "-item__description")
    }, [content]), h("div", {
      "class": "".concat(this.componentName, "-item__extra")
    }, [utils_renderTnode.renderTNodeJSX(this, "extra")])])])]);
  }
});

exports["default"] = _StepItem;
//# sourceMappingURL=step-item.js.map
