/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var helper = require('../_chunks/dep-ece3c062.js');
var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var stickyTool_props = require('./props.js');
var stickyTool_stickyItem = require('./sticky-item.js');
var utils_mixins = require('../utils/mixins.js');
var configProvider_configReceiver = require('../config-provider/config-receiver.js');
var utils_event = require('../utils/event.js');
require('./sticky-item-props.js');
require('../popup/index.js');
require('../popup/popup.js');
require('@babel/runtime/helpers/typeof');
require('@popperjs/core');
require('../utils/dom.js');
require('vue');
require('raf');
require('../utils/easing.js');
require('../_chunks/dep-738b4f21.js');
require('../_chunks/dep-a4308f57.js');
require('../_chunks/dep-fcf0662d.js');
require('../_chunks/dep-e4278c54.js');
require('../utils/render-tnode.js');
require('@babel/runtime/helpers/readOnlyError');
require('@vue/composition-api');
require('../_chunks/dep-7c854ec6.js');
require('../_chunks/dep-eceed11d.js');
require('../_chunks/dep-201f7798.js');
require('../_chunks/dep-d3015b4c.js');
require('../_chunks/dep-f8a85d6a.js');
require('../_chunks/dep-5b117689.js');
require('../_chunks/dep-6478392e.js');
require('../_chunks/dep-47bca35e.js');
require('../utils/helper.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/slicedToArray');
require('../_common/js/utils/setStyle.js');
require('../popup/props.js');
require('../popup/container.js');
require('../_chunks/dep-ecccff93.js');
require('../_chunks/dep-a4cecac4.js');
require('../popup/utils.js');
require('../_chunks/dep-f3761329.js');
require('../_chunks/dep-848a5a32.js');
require('../utils/map-props.js');
require('../utils/withInstall.js');
require('../popup/plugin.js');
require('../_common/js/log/log.js');
require('../_chunks/dep-07fb8c0e.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-a4a18104.js');
require('../_chunks/dep-27dd8cc6.js');
require('dayjs');
require('../_chunks/dep-87c765cc.js');
require('../_chunks/dep-75cd6d52.js');
require('../_chunks/dep-b1a02818.js');
require('../_chunks/dep-3d8ab37d.js');
require('../_chunks/dep-ab142eaf.js');
require('../_chunks/dep-6ad3de7c.js');
require('../_chunks/dep-8b1e056e.js');
require('../_chunks/dep-5db8defc.js');
require('../_chunks/dep-6e4c473c.js');
require('../_chunks/dep-234b7c02.js');
require('../_chunks/dep-a4747856.js');
require('../_chunks/dep-932dd69e.js');
require('../_chunks/dep-9f4caea4.js');
require('../_chunks/dep-dbd838d6.js');
require('../_chunks/dep-b3120c1b.js');
require('../_chunks/dep-68ba2357.js');
require('../_chunks/dep-173eb46c.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var _StickyTool = utils_mixins["default"](configProvider_configReceiver["default"]("sticky-tool")).extend({
  name: "TStickyTool",
  components: {
    TStickyItem: stickyTool_stickyItem["default"]
  },
  props: _objectSpread({}, stickyTool_props["default"]),
  computed: {
    classes: function classes() {
      return [this.componentName, "".concat(this.componentName, "--").concat(this.shape)];
    },
    styles: function styles() {
      var styles = this.getOffset();
      if (this.width) styles.width = typeof this.width === "number" ? "".concat(this.width, "px") : this.width;
      return styles;
    }
  },
  render: function render() {
    var _this$$scopedSlots,
      _this = this;
    var h = arguments[0];
    var nodes = ((_this$$scopedSlots = this.$scopedSlots) === null || _this$$scopedSlots === void 0 ? void 0 : _this$$scopedSlots["default"]) && this.$scopedSlots["default"](null);
    var list = this.getList();
    var content = list.map(function (item, index) {
      var type = _this.type,
        shape = _this.shape,
        placement = _this.placement,
        popupProps = _this.popupProps,
        handleClick = _this.handleClick,
        handleHover = _this.handleHover;
      var itemProps = _objectSpread(_objectSpread({}, item), {}, {
        type: type,
        shape: shape,
        placement: placement,
        basePopupProps: popupProps,
        baseWidth: _this.styles.width,
        onClick: handleClick,
        onHover: handleHover,
        fatherCompName: _this.componentName
      });
      var stickyItem = h("t-sticky-item", helper.helper([{}, {
        "props": itemProps
      }, {
        "key": index
      }]));
      if (nodes && nodes[index]) {
        var vnode = nodes[index];
        if (vnode.componentOptions) {
          vnode.componentOptions.propsData = itemProps;
          return vnode;
        }
        return stickyItem;
      }
      return stickyItem;
    });
    return h("div", {
      "class": this.classes,
      "style": this.styles
    }, [content]);
  },
  methods: {
    getList: function getList() {
      var _this$$scopedSlots2, _this$list;
      var nodes = ((_this$$scopedSlots2 = this.$scopedSlots) === null || _this$$scopedSlots2 === void 0 ? void 0 : _this$$scopedSlots2["default"]) && this.$scopedSlots["default"](null);
      var list;
      if ((_this$list = this.list) !== null && _this$list !== void 0 && _this$list.length) {
        list = this.list;
      } else {
        list = this.getListBySlots(nodes);
      }
      return list;
    },
    getListBySlots: function getListBySlots(nodes) {
      var arr = [];
      nodes === null || nodes === void 0 || nodes.forEach(function (node) {
        var _node$componentOption;
        var option = node === null || node === void 0 || (_node$componentOption = node.componentOptions) === null || _node$componentOption === void 0 ? void 0 : _node$componentOption.propsData;
        if (!option) return;
        arr.push(option);
      });
      return arr;
    },
    getOffset: function getOffset() {
      var _this$offset;
      var position = this.offset ? [80, 24] : ["80px", "24px"];
      (_this$offset = this.offset) === null || _this$offset === void 0 || _this$offset.forEach(function (item, index) {
        position[index] = isNaN(Number(item)) ? "calc( ".concat(position[index], "px + ").concat(item, ")") : "".concat(position[index] + item, "px");
      });
      var offsetStyle = {};
      this.placement.split("-").forEach(function (item, index) {
        if (item !== "center") {
          offsetStyle[item] = position[index];
        } else {
          offsetStyle.top = "50%";
          offsetStyle.transform = "translate(0, -50%)";
        }
      });
      return offsetStyle;
    },
    handleClick: function handleClick(context) {
      utils_event.emitEvent(this, "click", context);
    },
    handleHover: function handleHover(context) {
      utils_event.emitEvent(this, "hover", context);
    }
  }
});

exports["default"] = _StickyTool;
//# sourceMappingURL=sticky-tool.js.map
