import { TdBaseTableProps } from '../table/type';
import { PropType } from 'vue';
declare const _default: {
    activeRowKeys: {
        type: PropType<(string | number)[]>;
        default: () => TdBaseTableProps['activeRowKeys'];
    };
    defaultActiveRowKeys: {
        type: PropType<(string | number)[]>;
        default: () => TdBaseTableProps['defaultActiveRowKeys'];
    };
    activeRowType: {
        type: PropType<"multiple" | "single">;
        default: string;
    };
    allowResizeColumnWidth: {
        type: BooleanConstructor;
        default: any;
    };
    attach: {
        type: PropType<import("..").AttachNode>;
    };
    bordered: BooleanConstructor;
    bottomContent: {
        type: PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    cellEmptyContent: {
        type: PropType<string | ((h: import("vue").CreateElement, props: import("../table/type").BaseTableCellParams<import("../table/type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    columns: {
        type: PropType<import("../table/type").BaseTableCol<import("../table/type").TableRowData>[]>;
        default: () => TdBaseTableProps['columns'];
    };
    data: {
        type: PropType<import("../table/type").TableRowData[]>;
        default: () => TdBaseTableProps['data'];
    };
    disableDataPage: BooleanConstructor;
    disableSpaceInactiveRow: {
        type: BooleanConstructor;
        default: any;
    };
    empty: {
        type: PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: string;
    };
    firstFullRow: {
        type: PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    fixedRows: {
        type: PropType<number[]>;
    };
    footData: {
        type: PropType<import("../table/type").TableRowData[]>;
        default: () => TdBaseTableProps['footData'];
    };
    footerAffixProps: {
        type: PropType<Partial<import("..").TdAffixProps>>;
    };
    footerAffixedBottom: {
        type: PropType<boolean | Partial<import("..").TdAffixProps>>;
        default: boolean;
    };
    footerSummary: {
        type: PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    headerAffixProps: {
        type: PropType<Partial<import("..").TdAffixProps>>;
    };
    headerAffixedTop: {
        type: PropType<boolean | Partial<import("..").TdAffixProps>>;
        default: boolean;
    };
    height: {
        type: PropType<string | number>;
    };
    horizontalScrollAffixedBottom: {
        type: PropType<boolean | Partial<import("..").TdAffixProps>>;
    };
    hover: BooleanConstructor;
    keyboardRowHover: {
        type: BooleanConstructor;
        default: boolean;
    };
    lastFullRow: {
        type: PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    lazyLoad: BooleanConstructor;
    loading: {
        type: PropType<boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: any;
    };
    loadingProps: {
        type: PropType<Partial<import("..").TdLoadingProps>>;
    };
    locale: {
        type: PropType<import("..").TableConfig>;
    };
    maxHeight: {
        type: PropType<string | number>;
    };
    pagination: {
        type: PropType<import("..").TdPaginationProps>;
    };
    paginationAffixedBottom: {
        type: PropType<boolean | Partial<import("..").TdAffixProps>>;
    };
    resizable: BooleanConstructor;
    rowAttributes: {
        type: PropType<import("../table/type").TableRowAttributes<import("../table/type").TableRowData>>;
    };
    rowClassName: {
        type: PropType<import("..").ClassName | ((params: import("../table/type").RowClassNameParams<import("../table/type").TableRowData>) => import("..").ClassName)>;
    };
    rowKey: {
        type: StringConstructor;
        default: string;
        required: boolean;
    };
    rowspanAndColspan: {
        type: PropType<import("../table/type").TableRowspanAndColspanFunc<import("../table/type").TableRowData>>;
    };
    rowspanAndColspanInFooter: {
        type: PropType<import("../table/type").TableRowspanAndColspanFunc<import("../table/type").TableRowData>>;
    };
    scroll: {
        type: PropType<import("..").TScroll>;
    };
    showHeader: {
        type: BooleanConstructor;
        default: boolean;
    };
    size: {
        type: PropType<import("..").SizeEnum>;
        validator(val: TdBaseTableProps['size']): boolean;
    };
    stripe: BooleanConstructor;
    tableContentWidth: {
        type: StringConstructor;
        default: string;
    };
    tableLayout: {
        type: PropType<"fixed" | "auto">;
        default: "fixed" | "auto";
        validator(val: TdBaseTableProps['tableLayout']): boolean;
    };
    topContent: {
        type: PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    verticalAlign: {
        type: PropType<"top" | "bottom" | "middle">;
        default: "top" | "bottom" | "middle";
        validator(val: TdBaseTableProps['verticalAlign']): boolean;
    };
    onActiveChange: PropType<(activeRowKeys: (string | number)[], context: import("../table/type").ActiveChangeContext<import("../table/type").TableRowData>) => void>;
    onActiveRowAction: PropType<(context: import("../table/type").ActiveRowActionContext<import("../table/type").TableRowData>) => void>;
    onCellClick: PropType<(context: import("../table/type").BaseTableCellEventContext<import("../table/type").TableRowData>) => void>;
    onColumnResizeChange: PropType<(context: {
        columnsWidth: {
            [colKey: string]: number;
        };
    }) => void>;
    onPageChange: PropType<(pageInfo: import("..").PageInfo, newDataSource: import("../table/type").TableRowData[]) => void>;
    onRowClick: PropType<(context: import("../table/type").RowEventContext<import("../table/type").TableRowData>) => void>;
    onRowDblclick: PropType<(context: import("../table/type").RowEventContext<import("../table/type").TableRowData>) => void>;
    onRowMousedown: PropType<(context: import("../table/type").RowEventContext<import("../table/type").TableRowData>) => void>;
    onRowMouseenter: PropType<(context: import("../table/type").RowEventContext<import("../table/type").TableRowData>) => void>;
    onRowMouseleave: PropType<(context: import("../table/type").RowEventContext<import("../table/type").TableRowData>) => void>;
    onRowMouseover: PropType<(context: import("../table/type").RowEventContext<import("../table/type").TableRowData>) => void>;
    onRowMouseup: PropType<(context: import("../table/type").RowEventContext<import("../table/type").TableRowData>) => void>;
    onScroll: PropType<(params: {
        e: WheelEvent;
    }) => void>;
    onScrollX: PropType<(params: {
        e: WheelEvent;
    }) => void>;
    onScrollY: PropType<(params: {
        e: WheelEvent;
    }) => void>;
};
export default _default;
