/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var helper = require('../_chunks/dep-ece3c062.js');
var _slicedToArray = require('@babel/runtime/helpers/slicedToArray');
var _toArray = require('@babel/runtime/helpers/toArray');
var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var _typeof = require('@babel/runtime/helpers/typeof');
var VueCompositionAPI = require('@vue/composition-api');
var tdesignIconsVue = require('tdesign-icons-vue');
var hooks_useGlobalIcon = require('../hooks/useGlobalIcon.js');
var table_tr = require('./tr.js');
var form_formModel = require('../form/form-model.js');
var _common_js_log_log = require('../_common/js/log/log.js');
var utils_dom = require('../utils/dom.js');
var configProvider_useConfig = require('../config-provider/useConfig.js');
var cloneDeep = require('../_chunks/dep-f45125c9.js');
var set = require('../_chunks/dep-7a2463e1.js');
var isFunction = require('../_chunks/dep-ecccff93.js');
var get = require('../_chunks/dep-f84d1ea5.js');
require('../_chunks/dep-07fb8c0e.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-a4a18104.js');
require('../_chunks/dep-27dd8cc6.js');
require('dayjs');
require('../_chunks/dep-87c765cc.js');
require('../_chunks/dep-75cd6d52.js');
require('../_chunks/dep-b1a02818.js');
require('../_chunks/dep-3d8ab37d.js');
require('../_chunks/dep-a4308f57.js');
require('../_chunks/dep-a4cecac4.js');
require('../_chunks/dep-ab142eaf.js');
require('../_chunks/dep-6ad3de7c.js');
require('../_chunks/dep-e4278c54.js');
require('../_chunks/dep-fcf0662d.js');
require('../_chunks/dep-8b1e056e.js');
require('../_chunks/dep-5db8defc.js');
require('../_chunks/dep-6e4c473c.js');
require('../_chunks/dep-234b7c02.js');
require('../_chunks/dep-a4747856.js');
require('../_chunks/dep-932dd69e.js');
require('../_chunks/dep-9f4caea4.js');
require('../_chunks/dep-dbd838d6.js');
require('../_chunks/dep-b3120c1b.js');
require('../_chunks/dep-68ba2357.js');
require('../_chunks/dep-173eb46c.js');
require('./utils.js');
require('../_chunks/dep-362bc4d7.js');
require('../_chunks/dep-d3015b4c.js');
require('../_chunks/dep-201f7798.js');
require('./hooks/useFixed.js');
require('../_common/js/utils/getScrollbarWidth.js');
require('../_common/js/utils/helper.js');
require('@babel/runtime/helpers/toConsumableArray');
require('@babel/runtime/helpers/objectWithoutProperties');
require('../_chunks/dep-62de1188.js');
require('../_chunks/dep-867c284e.js');
require('../_chunks/dep-738b4f21.js');
require('../_chunks/dep-aa0a4aac.js');
require('../_chunks/dep-bebcd284.js');
require('../_chunks/dep-a0ae49c9.js');
require('../_chunks/dep-d23147db.js');
require('../_chunks/dep-502c56be.js');
require('../_chunks/dep-a9e7deb2.js');
require('../_chunks/dep-eeb2e214.js');
require('../_chunks/dep-de60f5aa.js');
require('../_chunks/dep-b5c96567.js');
require('../_chunks/dep-71fa6788.js');
require('../_chunks/dep-73fb598e.js');
require('../_chunks/dep-2e32c1f2.js');
require('../_chunks/dep-f3761329.js');
require('../_chunks/dep-848a5a32.js');
require('vue');
require('raf');
require('../utils/easing.js');
require('./hooks/useClassName.js');
require('./ellipsis.js');
require('../utils/render-tnode.js');
require('@babel/runtime/helpers/readOnlyError');
require('../_chunks/dep-7c854ec6.js');
require('../_chunks/dep-eceed11d.js');
require('../_chunks/dep-f8a85d6a.js');
require('../_chunks/dep-5b117689.js');
require('../_chunks/dep-6478392e.js');
require('../_chunks/dep-47bca35e.js');
require('../tooltip/index.js');
require('../tooltip/tooltip.js');
require('../tooltip/props.js');
require('../popup/props.js');
require('../popup/popup.js');
require('@popperjs/core');
require('../utils/helper.js');
require('../_common/js/utils/setStyle.js');
require('../popup/container.js');
require('../config-provider/config-receiver.js');
require('../utils/mixins.js');
require('../utils/event.js');
require('../popup/utils.js');
require('../utils/map-props.js');
require('../utils/withInstall.js');
require('./base-table-props.js');
require('./hooks/useRowspanAndColspan.js');
require('../hooks/useLazyLoad.js');
require('../_common/js/utils/observe.js');
require('@babel/runtime/helpers/asyncToGenerator');
require('@babel/runtime/regenerator');
require('../_chunks/dep-a6490a32.js');
require('../_chunks/dep-3eec664c.js');
require('../_chunks/dep-f33eb57d.js');
require('../_chunks/dep-63b02f7b.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _slicedToArray__default = /*#__PURE__*/_interopDefaultLegacy(_slicedToArray);
var _toArray__default = /*#__PURE__*/_interopDefaultLegacy(_toArray);
var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);
var _typeof__default = /*#__PURE__*/_interopDefaultLegacy(_typeof);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var EditableCell = VueCompositionAPI.defineComponent({
  name: "TableEditableCell",
  props: {
    rowKey: String,
    row: Object,
    rowIndex: Number,
    col: Object,
    colIndex: Number,
    oldCell: [Function, String],
    tableBaseClass: Object,
    cellEmptyContent: [Function, String],
    editable: {
      type: Boolean,
      "default": void 0
    },
    readonly: {
      type: Boolean
    },
    errors: {
      type: Array,
      "default": void 0
    },
    onChange: Function,
    onValidate: Function,
    onRuleChange: Function,
    onEditableChange: Function
  },
  emits: ["update-edited-cell"],
  setup: function setup(props, context) {
    var _col$value$edit2;
    var _toRefs = VueCompositionAPI.toRefs(props),
      row = _toRefs.row,
      col = _toRefs.col;
    var tableEditableCellRef = VueCompositionAPI.ref(null);
    var isKeepEditMode = VueCompositionAPI.computed(function () {
      var _col$value$edit;
      return (_col$value$edit = col.value.edit) === null || _col$value$edit === void 0 ? void 0 : _col$value$edit.keepEditMode;
    });
    var isEdit = VueCompositionAPI.ref(isKeepEditMode.value || ((_col$value$edit2 = col.value.edit) === null || _col$value$edit2 === void 0 ? void 0 : _col$value$edit2.defaultEditable) || false);
    var editValue = VueCompositionAPI.ref();
    var errorList = VueCompositionAPI.ref();
    var classPrefix = configProvider_useConfig.usePrefixClass();
    var _useGlobalIcon = hooks_useGlobalIcon.useGlobalIcon({
        Edit1Icon: tdesignIconsVue.Edit1Icon
      }),
      Edit1Icon = _useGlobalIcon.Edit1Icon;
    var updateEditedCellValue = function updateEditedCellValue(obj) {
      if (_typeof__default["default"](obj) === "object" && ("rowValue" in obj || obj.isUpdateCurrentRow)) {
        var newObj = _objectSpread({}, obj);
        var rowValue = newObj.isUpdateCurrentRow ? get.get(row.value, props.rowKey) : newObj.rowValue;
        delete newObj.rowValue;
        delete newObj.isUpdateCurrentRow;
        context.emit("update-edited-cell", rowValue, row.value, newObj);
      } else {
        editValue.value = obj;
      }
    };
    VueCompositionAPI.watch([isKeepEditMode], function (val) {
      if (val) {
        isEdit.value = true;
      }
    });
    var editOnListeners = VueCompositionAPI.computed(function () {
      var _col$value$edit3, _col$value$edit3$on;
      var listeners2 = ((_col$value$edit3 = col.value.edit) === null || _col$value$edit3 === void 0 || (_col$value$edit3$on = _col$value$edit3.on) === null || _col$value$edit3$on === void 0 ? void 0 : _col$value$edit3$on.call(_col$value$edit3, _objectSpread(_objectSpread({}, cellParams.value), {}, {
        editedRow: currentRow.value,
        updateEditedCellValue: updateEditedCellValue
      }))) || {};
      Object.keys(listeners2).forEach(function (eventName) {
        if (eventName.slice(0, 2) === "on") {
          listeners2[eventName.slice(2).toLocaleLowerCase()] = listeners2[eventName];
          delete listeners2[eventName];
        }
      });
      return listeners2;
    });
    var currentRow = VueCompositionAPI.computed(function () {
      var colKey = col.value.colKey;
      var _ref = colKey.split(".") || [],
        _ref2 = _toArray__default["default"](_ref),
        firstKey = _ref2[0],
        restKeys = _ref2.slice(1);
      var newRow = _objectSpread({}, row.value);
      if (restKeys.length) {
        newRow[firstKey] = cloneDeep.cloneDeep(row.value[firstKey]);
        set.set(newRow[firstKey], restKeys.join("."), editValue.value);
      } else {
        set.set(newRow, colKey, editValue.value);
      }
      return newRow;
    });
    var cellParams = VueCompositionAPI.computed(function () {
      return {
        rowIndex: props.rowIndex,
        colIndex: props.colIndex,
        col: props.col,
        row: props.row
      };
    });
    var cellNode = VueCompositionAPI.computed(function () {
      var node = table_tr.renderCell({
        row: currentRow.value,
        col: _objectSpread(_objectSpread({}, col.value), {}, {
          cell: props.oldCell
        }),
        rowIndex: props.rowIndex,
        colIndex: props.colIndex
      }, context.slots, {
        cellEmptyContent: props.cellEmptyContent
      });
      return node;
    });
    var componentProps = VueCompositionAPI.computed(function () {
      var _edit$abortEditOnEven;
      var edit = col.value.edit;
      if (!edit) return {};
      var editProps = isFunction.isFunction(edit.props) ? edit.props(_objectSpread(_objectSpread({}, cellParams.value), {}, {
        editedRow: currentRow.value,
        updateEditedCellValue: updateEditedCellValue
      })) : _objectSpread({}, edit.props);
      delete editProps.onChange;
      delete editProps.value;
      (_edit$abortEditOnEven = edit.abortEditOnEvent) === null || _edit$abortEditOnEven === void 0 || _edit$abortEditOnEven.forEach(function (item) {
        delete editProps[item];
      });
      return editProps;
    });
    var isAbortEditOnChange = VueCompositionAPI.computed(function () {
      var _edit$abortEditOnEven2;
      var edit = col.value.edit;
      if (!edit) return false;
      return Boolean((_edit$abortEditOnEven2 = edit.abortEditOnEvent) === null || _edit$abortEditOnEven2 === void 0 ? void 0 : _edit$abortEditOnEven2.includes("onChange"));
    });
    var validateEdit = function validateEdit(trigger) {
      return new Promise(function (resolve) {
        var params = {
          result: [_objectSpread(_objectSpread({}, cellParams.value), {}, {
            errorList: [],
            value: editValue.value
          })],
          trigger: trigger
        };
        var rules = isFunction.isFunction(col.value.edit.rules) ? col.value.edit.rules(cellParams.value) : col.value.edit.rules;
        if (!col.value.edit || !rules || !rules.length) {
          var _props$onValidate;
          (_props$onValidate = props.onValidate) === null || _props$onValidate === void 0 || _props$onValidate.call(props, params);
          resolve(true);
          return;
        }
        form_formModel.validate(editValue.value, rules).then(function (result) {
          var _props$onValidate2;
          var list = result === null || result === void 0 ? void 0 : result.filter(function (t) {
            return !t.result;
          });
          params.result[0].errorList = list;
          (_props$onValidate2 = props.onValidate) === null || _props$onValidate2 === void 0 || _props$onValidate2.call(props, params);
          if (!list || !list.length) {
            errorList.value = [];
            resolve(true);
          } else {
            errorList.value = list;
            resolve(list);
          }
        });
      });
    };
    var isSame = function isSame(a, b) {
      if (_typeof__default["default"](a) === "object" && _typeof__default["default"](b) === "object") {
        return JSON.stringify(a) === JSON.stringify(b);
      }
      return a === b;
    };
    var updateAndSaveAbort = function updateAndSaveAbort(outsideAbortEvent, eventName) {
      for (var _len = arguments.length, args = new Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
        args[_key - 2] = arguments[_key];
      }
      validateEdit("self").then(function (result) {
        var _editOnListeners$valu, _editOnListeners$valu2;
        if (result !== true) return;
        var oldValue = get.get(row.value, col.value.colKey);
        if (!isSame(editValue.value, oldValue)) {
          editValue.value = oldValue;
          outsideAbortEvent === null || outsideAbortEvent === void 0 || outsideAbortEvent.apply(void 0, args);
        }
        (_editOnListeners$valu = (_editOnListeners$valu2 = editOnListeners.value)[eventName]) === null || _editOnListeners$valu === void 0 || _editOnListeners$valu.call(_editOnListeners$valu2, args[2]);
        var timer = setTimeout(function () {
          var _props$onEditableChan;
          if (!isKeepEditMode.value) {
            isEdit.value = false;
          }
          errorList.value = [];
          (_props$onEditableChan = props.onEditableChange) === null || _props$onEditableChan === void 0 || _props$onEditableChan.call(props, _objectSpread(_objectSpread({}, cellParams.value), {}, {
            value: editValue.value,
            editedRow: _objectSpread(_objectSpread({}, props.row), {}, _defineProperty__default["default"]({}, props.col.colKey, editValue.value)),
            validateEdit: validateEdit,
            isEdit: false
          }));
          clearTimeout(timer);
        }, 0);
      });
    };
    var listeners = VueCompositionAPI.computed(function () {
      var _edit$abortEditOnEven3;
      var edit = col.value.edit;
      var isCellEditable = props.editable === void 0;
      if (!isEdit.value || !isCellEditable) return;
      if (!(edit !== null && edit !== void 0 && (_edit$abortEditOnEven3 = edit.abortEditOnEvent) !== null && _edit$abortEditOnEven3 !== void 0 && _edit$abortEditOnEven3.length)) return {};
      var tListeners = {};
      var outsideAbortEvent = edit === null || edit === void 0 ? void 0 : edit.onEdited;
      edit.abortEditOnEvent.forEach(function (itemEvent) {
        if (itemEvent === "onChange") return;
        var eventName = itemEvent.slice(2, 3).toLocaleLowerCase() + itemEvent.slice(3);
        tListeners[eventName] = function () {
          for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
            args[_key2] = arguments[_key2];
          }
          updateAndSaveAbort.apply(void 0, [outsideAbortEvent, eventName, _objectSpread(_objectSpread({}, cellParams.value), {}, {
            trigger: itemEvent,
            newRowData: currentRow.value
          })].concat(args));
        };
      });
      return tListeners;
    });
    var onEditChange = function onEditChange(val) {
      var _props$onChange, _props$onRuleChange, _col$value$edit5;
      editValue.value = val;
      var params = _objectSpread(_objectSpread({}, cellParams.value), {}, {
        value: val,
        editedRow: _objectSpread(_objectSpread({}, props.row), {}, _defineProperty__default["default"]({}, props.col.colKey, val))
      });
      (_props$onChange = props.onChange) === null || _props$onChange === void 0 || _props$onChange.call(props, params);
      (_props$onRuleChange = props.onRuleChange) === null || _props$onRuleChange === void 0 || _props$onRuleChange.call(props, params);
      var isCellEditable = props.editable === void 0;
      if (isCellEditable && isAbortEditOnChange.value) {
        var _col$value$edit4;
        var outsideAbortEvent = (_col$value$edit4 = col.value.edit) === null || _col$value$edit4 === void 0 ? void 0 : _col$value$edit4.onEdited;
        for (var _len3 = arguments.length, args = new Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
          args[_key3 - 1] = arguments[_key3];
        }
        updateAndSaveAbort.apply(void 0, [outsideAbortEvent, "change", _objectSpread(_objectSpread({}, cellParams.value), {}, {
          trigger: "onChange",
          newRowData: currentRow.value
        })].concat(args));
      }
      if (((_col$value$edit5 = col.value.edit) === null || _col$value$edit5 === void 0 ? void 0 : _col$value$edit5.validateTrigger) === "change") {
        validateEdit("self");
      }
    };
    var documentClickHandler = function documentClickHandler(e) {
      var _e$composedPath;
      if (!col.value.edit || !col.value.edit.component) return;
      if (!isEdit.value) return;
      var path = ((_e$composedPath = e.composedPath) === null || _e$composedPath === void 0 ? void 0 : _e$composedPath.call(e)) || e.path || [];
      var node = path.find(function (node2) {
        var _node2$classList;
        return (_node2$classList = node2.classList) === null || _node2$classList === void 0 ? void 0 : _node2$classList.contains("".concat(classPrefix.value, "-popup__content"));
      });
      if (node) return;
      var outsideAbortEvent = col.value.edit.onEdited;
      updateAndSaveAbort(outsideAbortEvent, "", _objectSpread(_objectSpread({}, cellParams.value), {}, {
        trigger: "document",
        newRowData: currentRow.value
      }));
    };
    var cellValue = VueCompositionAPI.computed(function () {
      return get.get(row.value, col.value.colKey);
    });
    var enterEdit = function enterEdit() {
      var _props$onEditableChan2;
      (_props$onEditableChan2 = props.onEditableChange) === null || _props$onEditableChan2 === void 0 || _props$onEditableChan2.call(props, _objectSpread(_objectSpread({}, cellParams.value), {}, {
        value: editValue.value,
        editedRow: props.row,
        isEdit: true,
        validateEdit: validateEdit
      }));
    };
    var onCellClick = function onCellClick(e) {
      isEdit.value = true;
      enterEdit();
      e.stopPropagation();
    };
    VueCompositionAPI.onMounted(function () {
      var _props$col$edit;
      if ((_props$col$edit = props.col.edit) !== null && _props$col$edit !== void 0 && _props$col$edit.defaultEditable) {
        enterEdit();
      }
    });
    VueCompositionAPI.watch(cellValue, function (cellValue2) {
      editValue.value = cellValue2;
    }, {
      immediate: true
    });
    VueCompositionAPI.watch(isEdit, function (isEdit2) {
      var isCellEditable = props.editable === void 0;
      if (!col.value.edit || !col.value.edit.component || !isCellEditable) return;
      if (isEdit2) {
        utils_dom.on(document, "click", documentClickHandler);
      } else {
        utils_dom.off(document, "click", documentClickHandler);
      }
    }, {
      immediate: true
    });
    VueCompositionAPI.watch(function () {
      return [props.editable, props.row, props.col, props.rowIndex, props.colIndex];
    }, function (_ref3) {
      var _ref4 = _slicedToArray__default["default"](_ref3, 1),
        editable = _ref4[0];
      if (editable === false) {
        editValue.value = cellValue.value;
      } else {
        var _props$onRuleChange2;
        (_props$onRuleChange2 = props.onRuleChange) === null || _props$onRuleChange2 === void 0 || _props$onRuleChange2.call(props, _objectSpread(_objectSpread({}, cellParams.value), {}, {
          value: cellValue.value,
          editedRow: row.value
        }));
      }
    }, {
      immediate: true
    });
    VueCompositionAPI.watch(function () {
      return props.errors;
    }, function (errors) {
      errorList.value = errors;
    });
    return {
      editValue: editValue,
      isEdit: isEdit,
      cellNode: cellNode,
      isAbortEditOnChange: isAbortEditOnChange,
      listeners: listeners,
      componentProps: componentProps,
      tableEditableCellRef: tableEditableCellRef,
      errorList: errorList,
      currentRow: currentRow,
      editOnListeners: editOnListeners,
      onEditChange: onEditChange,
      Edit1Icon: Edit1Icon,
      validateEdit: validateEdit,
      onCellClick: onCellClick,
      cellParams: cellParams
    };
  },
  render: function render() {
    var _this$col$edit2, _this$errorList, _this$col$edit3, _this$tableBaseClass2, _this$errorList2;
    var h = arguments[0];
    if (this.readonly) {
      return h("div", [this.cellNode]);
    }
    if (this.editable === void 0 && !this.isEdit || this.editable === false) {
      var _this$tableBaseClass, _this$col$edit;
      var Edit1Icon = this.Edit1Icon;
      return h("div", {
        "class": (_this$tableBaseClass = this.tableBaseClass) === null || _this$tableBaseClass === void 0 ? void 0 : _this$tableBaseClass.cellEditable,
        "on": {
          "click": this.onCellClick
        }
      }, [this.cellNode, ((_this$col$edit = this.col.edit) === null || _this$col$edit === void 0 ? void 0 : _this$col$edit.showEditIcon) !== false && h(Edit1Icon)]);
    }
    var Component = (_this$col$edit2 = this.col.edit) === null || _this$col$edit2 === void 0 ? void 0 : _this$col$edit2.component;
    if (!Component) {
      _common_js_log_log["default"].error("Table", "edit.component is required.");
      return null;
    }
    var errorMessage = (_this$errorList = this.errorList) === null || _this$errorList === void 0 || (_this$errorList = _this$errorList[0]) === null || _this$errorList === void 0 ? void 0 : _this$errorList.message;
    var tmpEditOnListeners = _objectSpread({}, this.editOnListeners);
    if ((_this$col$edit3 = this.col.edit) !== null && _this$col$edit3 !== void 0 && (_this$col$edit3 = _this$col$edit3.abortEditOnEvent) !== null && _this$col$edit3 !== void 0 && _this$col$edit3.length) {
      this.col.edit.abortEditOnEvent.forEach(function (onEventName) {
        var vue2EventName = onEventName.slice(2).toLocaleLowerCase();
        if (tmpEditOnListeners[vue2EventName]) {
          delete tmpEditOnListeners[vue2EventName];
        }
      });
    }
    return h("div", {
      "class": (_this$tableBaseClass2 = this.tableBaseClass) === null || _this$tableBaseClass2 === void 0 ? void 0 : _this$tableBaseClass2.cellEditWrap,
      "ref": "tableEditableCellRef",
      "on": {
        "click": function click(e) {
          e.stopPropagation();
        }
      }
    }, [h(Component, helper.helper([{
      "attrs": {
        "status": errorMessage ? ((_this$errorList2 = this.errorList) === null || _this$errorList2 === void 0 || (_this$errorList2 = _this$errorList2[0]) === null || _this$errorList2 === void 0 ? void 0 : _this$errorList2.type) || "error" : void 0,
        "tips": errorMessage
      }
    }, {
      "props": this.componentProps
    }, {}, {
      "on": _objectSpread(_objectSpread({}, this.listeners), tmpEditOnListeners)
    }, {
      "attrs": {
        "value": this.editValue
      },
      "on": {
        "change": this.onEditChange
      }
    }]))]);
  }
});

exports["default"] = EditableCell;
//# sourceMappingURL=editable-cell.js.map
