/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var helper = require('../_chunks/dep-ece3c062.js');
var _typeof = require('@babel/runtime/helpers/typeof');
var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var VueCompositionAPI = require('@vue/composition-api');
var tdesignIconsVue = require('tdesign-icons-vue');
var popup_index = require('../popup/index.js');
var checkbox_index = require('../checkbox/index.js');
var radio_index = require('../radio/index.js');
var input_index = require('../input/index.js');
var button_index = require('../button/index.js');
var hooks_tnode = require('../hooks/tnode.js');
var hooks_useGlobalIcon = require('../hooks/useGlobalIcon.js');
var configProvider_useConfig = require('../config-provider/useConfig.js');
var _common_js_log_log = require('../_common/js/log/log.js');
var isEmpty = require('../_chunks/dep-a6490a32.js');
var escapeRegExp = require('../_chunks/dep-67cf27bf.js');
var isObject = require('../_chunks/dep-a4cecac4.js');
var isFunction = require('../_chunks/dep-ecccff93.js');
var capitalize = require('../_chunks/dep-eceed11d.js');
require('../popup/popup.js');
require('@popperjs/core');
require('../utils/dom.js');
require('vue');
require('raf');
require('../utils/easing.js');
require('../_chunks/dep-738b4f21.js');
require('../_chunks/dep-a4308f57.js');
require('../_chunks/dep-fcf0662d.js');
require('../_chunks/dep-e4278c54.js');
require('../utils/render-tnode.js');
require('@babel/runtime/helpers/readOnlyError');
require('../_chunks/dep-7c854ec6.js');
require('../_chunks/dep-6478392e.js');
require('../_chunks/dep-201f7798.js');
require('../_chunks/dep-d3015b4c.js');
require('../_chunks/dep-47bca35e.js');
require('../_chunks/dep-f8a85d6a.js');
require('../_chunks/dep-5b117689.js');
require('../utils/helper.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/slicedToArray');
require('../_common/js/utils/setStyle.js');
require('../popup/props.js');
require('../popup/container.js');
require('../config-provider/config-receiver.js');
require('../_chunks/dep-07fb8c0e.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-a4a18104.js');
require('../_chunks/dep-27dd8cc6.js');
require('dayjs');
require('../_chunks/dep-87c765cc.js');
require('../_chunks/dep-75cd6d52.js');
require('../_chunks/dep-b1a02818.js');
require('../_chunks/dep-3d8ab37d.js');
require('../_chunks/dep-ab142eaf.js');
require('../_chunks/dep-6ad3de7c.js');
require('../_chunks/dep-8b1e056e.js');
require('../_chunks/dep-5db8defc.js');
require('../_chunks/dep-6e4c473c.js');
require('../_chunks/dep-234b7c02.js');
require('../_chunks/dep-a4747856.js');
require('../_chunks/dep-932dd69e.js');
require('../_chunks/dep-9f4caea4.js');
require('../_chunks/dep-dbd838d6.js');
require('../_chunks/dep-b3120c1b.js');
require('../_chunks/dep-68ba2357.js');
require('../_chunks/dep-173eb46c.js');
require('../utils/mixins.js');
require('../utils/event.js');
require('../popup/utils.js');
require('../_chunks/dep-f3761329.js');
require('../_chunks/dep-848a5a32.js');
require('../utils/map-props.js');
require('../utils/withInstall.js');
require('../popup/plugin.js');
require('../checkbox/group.js');
require('@babel/runtime/helpers/toConsumableArray');
require('../checkbox/checkbox.js');
require('../checkbox/props.js');
require('../checkbox/constants.js');
require('../checkbox/store.js');
require('@babel/runtime/helpers/classCallCheck');
require('@babel/runtime/helpers/createClass');
require('../checkbox/hooks/useKeyboardEvent.js');
require('../_common/js/common.js');
require('../hooks/useConfig.js');
require('../hooks/useVModel.js');
require('../hooks/useFormDisabled.js');
require('../hooks/useElementLazyRender.js');
require('../_common/js/utils/observe.js');
require('../checkbox/checkbox-group-props.js');
require('../_chunks/dep-e83685df.js');
require('../_chunks/dep-d23147db.js');
require('../_chunks/dep-502c56be.js');
require('../_chunks/dep-62de1188.js');
require('../hooks/slots.js');
require('../radio/radio.js');
require('../radio/props.js');
require('../radio/group.js');
require('../radio/radio-group-props.js');
require('../radio/radio-button.js');
require('../_chunks/dep-aa0a4aac.js');
require('../input/input.js');
require('../_common/js/utils/helper.js');
require('../_chunks/dep-867c284e.js');
require('../input/props.js');
require('../input/input-group.js');
require('../button/button.js');
require('../loading/index.js');
require('../loading/directive.js');
require('../loading/plugin.js');
require('../loading/loading.js');
require('../loading/icon/gradient.js');
require('../_common/js/loading/circle-adapter.js');
require('../utils/transfer-dom.js');
require('../loading/props.js');
require('../config.js');
require('../_chunks/dep-013a3403.js');
require('../_chunks/dep-8cb0d589.js');
require('../_chunks/dep-de60f5aa.js');
require('../_chunks/dep-63b02f7b.js');
require('../_chunks/dep-bebcd284.js');
require('../_chunks/dep-3eec664c.js');
require('../_chunks/dep-eeb2e214.js');
require('../_chunks/dep-315a67f0.js');
require('../_chunks/dep-f84d1ea5.js');
require('../_chunks/dep-362bc4d7.js');
require('../_chunks/dep-2e32c1f2.js');
require('../_chunks/dep-f14aac54.js');
require('../button/props.js');
require('../utils/ripple.js');
require('../hooks/render-tnode.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _typeof__default = /*#__PURE__*/_interopDefaultLegacy(_typeof);
var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

/**
 * Converts the first character of `string` to lower case.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category String
 * @param {string} [string=''] The string to convert.
 * @returns {string} Returns the converted string.
 * @example
 *
 * _.lowerFirst('Fred');
 * // => 'fred'
 *
 * _.lowerFirst('FRED');
 * // => 'fRED'
 */
var lowerFirst = capitalize.createCaseFirst('toLowerCase');
var lowerFirst$1 = lowerFirst;

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var TableFilterController = VueCompositionAPI.defineComponent({
  name: "TableFilterController",
  props: {
    column: Object,
    colIndex: Number,
    tFilterValue: Object,
    innerFilterValue: Object,
    tableFilterClasses: Object,
    isFocusClass: String,
    primaryTableElement: {},
    popupProps: Object,
    attach: [String, Function],
    filterIcon: [Function]
  },
  setup: function setup(props, _ref) {
    var emit = _ref.emit;
    var triggerElementRef = VueCompositionAPI.ref(null);
    var renderTNode = hooks_tnode.useTNodeDefault();
    var _useConfig = configProvider_useConfig.useConfig("table", props.locale),
      t = _useConfig.t,
      global = _useConfig.global;
    var _useGlobalIcon = hooks_useGlobalIcon.useGlobalIcon({
        FilterIcon: tdesignIconsVue.FilterIcon
      }),
      FilterIcon = _useGlobalIcon.FilterIcon;
    var filterPopupVisible = VueCompositionAPI.ref(false);
    var listFilterValue = VueCompositionAPI.ref("");
    var onFilterPopupVisibleChange = function onFilterPopupVisibleChange(visible) {
      filterPopupVisible.value = visible;
      emit("visible-change", visible);
    };
    var getFilterDisplayList = function getFilterDisplayList(column) {
      var _column$filter = column.filter,
        filter = _column$filter === void 0 ? {} : _column$filter;
      var listFilterConfig = filter.listFilterConfig;
      if (!listFilterValue.value || !filter.listFilterConfig) {
        return filter.list;
      }
      var regExp = new RegExp(escapeRegExp.escapeRegExp(listFilterValue.value));
      if (listFilterConfig === true) {
        return filter.list.filter(function (item) {
          return regExp.test(item.label);
        });
      }
      if (isObject.isObject(listFilterConfig)) {
        return isFunction.isFunction(listFilterConfig.filterMethod) ? filter.list.filter(function (item) {
          return listFilterConfig.filterMethod(item, listFilterValue.value);
        }) : filter.list.filter(function (item) {
          return regExp.test(item.label);
        });
      }
    };
    return {
      t: t,
      global: global,
      FilterIcon: FilterIcon,
      filterPopupVisible: filterPopupVisible,
      triggerElementRef: triggerElementRef,
      listFilterValue: listFilterValue,
      renderTNode: renderTNode,
      getFilterDisplayList: getFilterDisplayList,
      onFilterPopupVisibleChange: onFilterPopupVisibleChange
    };
  },
  render: function render(h) {
    var _this = this,
      _this$tFilterValue;
    var getFilterContent = function getFilterContent(h2, column2) {
      var _column2$filter;
      var types = ["single", "multiple", "input"];
      if (column2.type && !types.includes(column2.filter.type)) {
        _common_js_log_log["default"].error("Table", "filter.type must be the following: ".concat(JSON.stringify(types)));
        return;
      }
      if (!column2.filter.type && !column2.filter.component) {
        _common_js_log_log["default"].error("Table", "both filter.type and filter.component can not be empty.");
        return;
      }
      var component = {
        single: radio_index.RadioGroup,
        multiple: checkbox_index.CheckboxGroup,
        input: input_index.Input
      }[column2.filter.type] || column2.filter.component;
      if (!component && !column2.filter.component) return;
      var filterComponentProps = _objectSpread({
        options: ["single", "multiple"].includes(column2.filter.type) ? _this.getFilterDisplayList(column2) : void 0
      }, ((_column2$filter = column2.filter) === null || _column2$filter === void 0 ? void 0 : _column2$filter.props) || {});
      if (column2.colKey && _this.innerFilterValue && column2.colKey in _this.innerFilterValue) {
        filterComponentProps.value = _this.innerFilterValue[column2.colKey];
      }
      var on = {
        change: function change(val) {
          var _column2$filter2;
          _this.$emit("inner-filter-change", val, column2);
          if ((_column2$filter2 = column2.filter) !== null && _column2$filter2 !== void 0 && (_column2$filter2 = _column2$filter2.confirmEvents) !== null && _column2$filter2 !== void 0 && _column2$filter2.includes("onChange")) {
            _this.filterPopupVisible = false;
          }
        }
      };
      if (column2.filter.confirmEvents) {
        column2.filter.confirmEvents.forEach(function (event) {
          if (event === "onChange") return;
          var pureEvent = lowerFirst$1(event.replace("on", ""));
          on[pureEvent] = function () {
            _this.$emit("confirm", column2);
            _this.filterPopupVisible = false;
          };
        });
      }
      var wrapperListeners = {};
      if (column2.filter.showConfirmAndReset) {
        wrapperListeners.click = function (e) {
          return e.stopPropagation();
        };
      }
      var renderComponent = function renderComponent() {
        if (!component) return null;
        var isVueComponent = component.install && component.component;
        if (typeof component === "function" && !isVueComponent) {
          return component(function (v, b) {
            var attributes = _typeof__default["default"](b) === "object" && "attrs" in b ? b.attrs : {};
            return h2(v, {
              props: _objectSpread({}, filterComponentProps),
              attrs: attributes,
              on: on
            });
          });
        }
        var filter = _this.column.filter || {};
        return h(component, helper.helper([{}, {
          "attrs": filter.attrs
        }, {
          "class": filter.classNames,
          "style": filter.style
        }, {
          "props": _objectSpread({}, filterComponentProps)
        }, {}, {
          "on": _objectSpread({}, on)
        }]));
      };
      var inputObj = isObject.isObject(column2.filter.listFilterConfig) ? column2.filter.listFilterConfig : {};
      return h("div", helper.helper([{
        "class": _this.tableFilterClasses.contentInner
      }, {
        "on": wrapperListeners
      }]), [column2.filter.listFilterConfig && h(input_index.Input, helper.helper([{
        "attrs": {
          "borderless": true
        },
        "class": [_this.tableFilterClasses.inputFilter, inputObj.className].filter(Boolean),
        "scopedSlots": _objectSpread({
          prefixIcon: function prefixIcon() {
            return h(tdesignIconsVue.SearchIcon);
          }
        }, inputObj.slots)
      }, {
        "props": inputObj.props
      }, {
        "style": inputObj.style,
        "model": {
          value: _this.listFilterValue,
          callback: function callback($$v) {
            _this.listFilterValue = $$v;
          }
        }
      }])), renderComponent()]);
    };
    var getBottomButtons = function getBottomButtons(h2, column2) {
      if (!column2.filter.showConfirmAndReset) return;
      return h("div", {
        "class": _this.tableFilterClasses.bottomButtons
      }, [h(button_index.Button, {
        "attrs": {
          "theme": "default",
          "size": "small"
        },
        "on": {
          "click": function click() {
            _this.$emit("reset", column2);
            _this.filterPopupVisible = false;
          }
        }
      }, [_this.global.resetText]), h(button_index.Button, {
        "attrs": {
          "theme": "primary",
          "size": "small"
        },
        "on": {
          "click": function click() {
            _this.$emit("confirm", column2);
            _this.filterPopupVisible = false;
          }
        }
      }, [_this.global.confirmText])]);
    };
    var column = this.column,
      FilterIcon = this.FilterIcon,
      popupProps = this.popupProps;
    if (!column.filter || column.filter && !Object.keys(column.filter).length) return null;
    var defaultFilterIcon = this.t(this.global.filterIcon) || h(FilterIcon);
    var filterValue = (_this$tFilterValue = this.tFilterValue) === null || _this$tFilterValue === void 0 ? void 0 : _this$tFilterValue[column.colKey];
    var isObjectTrue = _typeof__default["default"](filterValue) === "object" && !isEmpty.isEmpty(filterValue);
    var isValueExist = ![null, void 0, ""].includes(filterValue) && _typeof__default["default"](filterValue) !== "object";
    return h(popup_index.Popup, helper.helper([{
      "attrs": {
        "attach": this.attach || (this.primaryTableElement ? function () {
          return _this.primaryTableElement;
        } : void 0),
        "visible": this.filterPopupVisible,
        "destroyOnClose": true,
        "trigger": "click",
        "placement": "bottom",
        "showArrow": true,
        "overlayClassName": this.tableFilterClasses.popup
      }
    }, {
      "on": {
        "visible-change": function visibleChange(val) {
          return _this.onFilterPopupVisibleChange(val);
        }
      }
    }, {
      "class": [this.tableFilterClasses.icon, _defineProperty__default["default"]({}, this.isFocusClass, isObjectTrue || isValueExist)],
      "attrs": {
        "content": function content() {
          return h("div", {
            "class": _this.tableFilterClasses.popupContent
          }, [getFilterContent(h, column), getBottomButtons(h, column)]);
        }
      }
    }, {
      "props": popupProps
    }]), [h("div", {
      "ref": "triggerElementRef"
    }, [this.renderTNode("filterIcon", {
      defaultNode: defaultFilterIcon,
      params: {
        col: column,
        colIndex: this.colIndex
      }
    })])]);
  }
});

exports["default"] = TableFilterController;
//# sourceMappingURL=filter-controller.js.map
