/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var helper = require('../../_chunks/dep-ece3c062.js');
var table_editableCell = require('../editable-cell.js');
require('@babel/runtime/helpers/slicedToArray');
require('@babel/runtime/helpers/toArray');
require('@babel/runtime/helpers/defineProperty');
require('@babel/runtime/helpers/typeof');
require('@vue/composition-api');
require('tdesign-icons-vue');
require('../../hooks/useGlobalIcon.js');
require('../../config-provider/useConfig.js');
require('../../_chunks/dep-07fb8c0e.js');
require('../../_common/js/global-config/default-config.js');
require('../../_common/js/global-config/locale/zh_CN.js');
require('../../_chunks/dep-a4a18104.js');
require('../../_chunks/dep-27dd8cc6.js');
require('dayjs');
require('../../_chunks/dep-87c765cc.js');
require('../../_chunks/dep-75cd6d52.js');
require('../../_chunks/dep-b1a02818.js');
require('../../_chunks/dep-3d8ab37d.js');
require('../../_chunks/dep-ecccff93.js');
require('../../_chunks/dep-a4308f57.js');
require('../../_chunks/dep-a4cecac4.js');
require('../../_chunks/dep-ab142eaf.js');
require('../../_chunks/dep-6ad3de7c.js');
require('../../_chunks/dep-e4278c54.js');
require('../../_chunks/dep-fcf0662d.js');
require('../../_chunks/dep-8b1e056e.js');
require('../../_chunks/dep-5db8defc.js');
require('../../_chunks/dep-6e4c473c.js');
require('../../_chunks/dep-234b7c02.js');
require('../../_chunks/dep-a4747856.js');
require('../../_chunks/dep-932dd69e.js');
require('../../_chunks/dep-9f4caea4.js');
require('../../_chunks/dep-dbd838d6.js');
require('../../_chunks/dep-b3120c1b.js');
require('../../_chunks/dep-68ba2357.js');
require('../../_chunks/dep-173eb46c.js');
require('../tr.js');
require('../utils.js');
require('../../_chunks/dep-f84d1ea5.js');
require('../../_chunks/dep-362bc4d7.js');
require('../../_chunks/dep-d3015b4c.js');
require('../../_chunks/dep-201f7798.js');
require('./useFixed.js');
require('../../_common/js/log/log.js');
require('../../_common/js/utils/getScrollbarWidth.js');
require('../../_common/js/utils/helper.js');
require('@babel/runtime/helpers/toConsumableArray');
require('@babel/runtime/helpers/objectWithoutProperties');
require('../../_chunks/dep-62de1188.js');
require('../../_chunks/dep-867c284e.js');
require('../../_chunks/dep-738b4f21.js');
require('../../_chunks/dep-aa0a4aac.js');
require('../../utils/dom.js');
require('vue');
require('raf');
require('../../utils/easing.js');
require('../../_chunks/dep-bebcd284.js');
require('../../_chunks/dep-a0ae49c9.js');
require('../../_chunks/dep-d23147db.js');
require('../../_chunks/dep-502c56be.js');
require('../../_chunks/dep-a9e7deb2.js');
require('../../_chunks/dep-eeb2e214.js');
require('../../_chunks/dep-de60f5aa.js');
require('../../_chunks/dep-b5c96567.js');
require('../../_chunks/dep-71fa6788.js');
require('../../_chunks/dep-73fb598e.js');
require('../../_chunks/dep-2e32c1f2.js');
require('../../_chunks/dep-f3761329.js');
require('../../_chunks/dep-848a5a32.js');
require('./useClassName.js');
require('../ellipsis.js');
require('../../utils/render-tnode.js');
require('@babel/runtime/helpers/readOnlyError');
require('../../_chunks/dep-7c854ec6.js');
require('../../_chunks/dep-eceed11d.js');
require('../../_chunks/dep-f8a85d6a.js');
require('../../_chunks/dep-5b117689.js');
require('../../_chunks/dep-6478392e.js');
require('../../_chunks/dep-47bca35e.js');
require('../../tooltip/index.js');
require('../../tooltip/tooltip.js');
require('../../tooltip/props.js');
require('../../popup/props.js');
require('../../popup/popup.js');
require('@popperjs/core');
require('../../utils/helper.js');
require('../../_common/js/utils/setStyle.js');
require('../../popup/container.js');
require('../../config-provider/config-receiver.js');
require('../../utils/mixins.js');
require('../../utils/event.js');
require('../../popup/utils.js');
require('../../utils/map-props.js');
require('../../utils/withInstall.js');
require('../base-table-props.js');
require('./useRowspanAndColspan.js');
require('../../hooks/useLazyLoad.js');
require('../../_common/js/utils/observe.js');
require('../../form/form-model.js');
require('@babel/runtime/helpers/asyncToGenerator');
require('@babel/runtime/regenerator');
require('../../_chunks/dep-a6490a32.js');
require('../../_chunks/dep-3eec664c.js');
require('../../_chunks/dep-f45125c9.js');
require('../../_chunks/dep-f33eb57d.js');
require('../../_chunks/dep-63b02f7b.js');
require('../../_chunks/dep-7a2463e1.js');

function useEditableCell(props, context, events) {
  var renderEditableCell = function renderEditableCell(h, p) {
    return h(table_editableCell["default"], helper.helper([{}, {
      "props": p
    }, {}, {
      "on": events
    }, {
      "scopedSlots": context.slots
    }]));
  };
  return {
    renderEditableCell: renderEditableCell
  };
}

exports["default"] = useEditableCell;
//# sourceMappingURL=useEditableCell.js.map
