import { SetupContext } from '@vue/composition-api';
import { CreateElement } from 'vue';
import { TdPrimaryTableProps, PrimaryTableCol, TableRowData, TableExpandedRowParams, RowEventContext, RowClassNameParams } from '../type';
export default function useRowExpand(props: TdPrimaryTableProps, context: SetupContext): {
    showExpandedRow: import("@vue/composition-api").ComputedRef<boolean>;
    showExpandIconColumn: import("@vue/composition-api").ComputedRef<boolean>;
    getExpandColumn: (h: CreateElement) => PrimaryTableCol<TableRowData>;
    renderExpandedRow: (h: CreateElement, p: TableExpandedRowParams<TableRowData> & {
        tableWidth: number;
        isWidthOverflow: boolean;
    }) => JSX.Element;
    onInnerExpandRowClick: (p: RowEventContext<TableRowData>) => void;
    getExpandedRowClass: (params: RowClassNameParams<TableRowData>) => string;
};
