/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _slicedToArray = require('@babel/runtime/helpers/slicedToArray');
var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var tdesignIconsVue = require('tdesign-icons-vue');
var tabs_tabNavItem = require('./tab-nav-item.js');
var utils_event = require('../utils/event.js');
var utils_helper = require('../utils/helper.js');
var tabs_props = require('./props.js');
var utils_renderTnode = require('../utils/render-tnode.js');
var configProvider_configReceiver = require('../config-provider/config-receiver.js');
var utils_mixins = require('../utils/mixins.js');
var _common_js_tabs_base = require('../_common/js/tabs/base.js');
var debounce = require('../_chunks/dep-f3761329.js');
require('../utils/ripple.js');
require('../_common/js/utils/setStyle.js');
require('../config.js');
require('./tab-panel-props.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('../_chunks/dep-7c854ec6.js');
require('../_chunks/dep-eceed11d.js');
require('../_chunks/dep-201f7798.js');
require('../_chunks/dep-a4308f57.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-fcf0662d.js');
require('../_chunks/dep-d3015b4c.js');
require('../_chunks/dep-e4278c54.js');
require('../_chunks/dep-f8a85d6a.js');
require('../_chunks/dep-5b117689.js');
require('../_chunks/dep-6478392e.js');
require('@babel/runtime/helpers/readOnlyError');
require('vue');
require('@vue/composition-api');
require('../_chunks/dep-47bca35e.js');
require('../_chunks/dep-07fb8c0e.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-a4a18104.js');
require('../_chunks/dep-27dd8cc6.js');
require('dayjs');
require('../_chunks/dep-87c765cc.js');
require('../_chunks/dep-75cd6d52.js');
require('../_chunks/dep-b1a02818.js');
require('../_chunks/dep-3d8ab37d.js');
require('../_chunks/dep-ecccff93.js');
require('../_chunks/dep-a4cecac4.js');
require('../_chunks/dep-ab142eaf.js');
require('../_chunks/dep-6ad3de7c.js');
require('../_chunks/dep-8b1e056e.js');
require('../_chunks/dep-5db8defc.js');
require('../_chunks/dep-6e4c473c.js');
require('../_chunks/dep-234b7c02.js');
require('../_chunks/dep-a4747856.js');
require('../_chunks/dep-932dd69e.js');
require('../_chunks/dep-9f4caea4.js');
require('../_chunks/dep-dbd838d6.js');
require('../_chunks/dep-b3120c1b.js');
require('../_chunks/dep-68ba2357.js');
require('../_chunks/dep-173eb46c.js');
require('../_chunks/dep-848a5a32.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _slicedToArray__default = /*#__PURE__*/_interopDefaultLegacy(_slicedToArray);
var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var classPrefixMixins = configProvider_configReceiver.getClassPrefixMixins("tab__nav");
var TTabNav = utils_mixins["default"](classPrefixMixins, configProvider_configReceiver.getGlobalIconMixins()).extend({
  name: "TTabNav",
  components: {
    TTabNavItem: tabs_tabNavItem["default"]
  },
  props: {
    theme: tabs_props["default"].theme,
    panels: {
      type: Array,
      "default": function _default() {
        return [];
      }
    },
    value: tabs_props["default"].value,
    placement: tabs_props["default"].placement,
    scrollPosition: tabs_props["default"].scrollPosition,
    size: tabs_props["default"].size,
    disabled: tabs_props["default"].disabled,
    addable: tabs_props["default"].addable
  },
  data: function data() {
    return {
      scrollLeft: 0,
      maxScrollLeft: 0,
      navBarStyle: {}
    };
  },
  computed: {
    navs: function navs() {
      var _this = this;
      return this.panels.map(function (panel, index) {
        return {
          ref: "tabItem".concat(index),
          key: panel.value,
          theme: _this.theme,
          size: _this.size,
          placement: _this.placement,
          active: panel.value === _this.value,
          disabled: _this.disabled || panel.disabled,
          removable: panel.removable,
          value: panel.value,
          panel: panel
        };
      });
    },
    wrapTransformStyle: function wrapTransformStyle() {
      if (["left", "right"].includes(this.placement.toLowerCase())) return {};
      return {
        transform: "translate(".concat(-this.scrollLeft, "px, 0)")
      };
    },
    dataCanUpdateNavBarStyle: function dataCanUpdateNavBarStyle() {
      return [this.scrollLeft, this.placement, this.theme, this.navs, this.value];
    },
    iconBaseClass: function iconBaseClass() {
      return _defineProperty__default["default"](_defineProperty__default["default"](_defineProperty__default["default"]({}, "".concat(this.classPrefix, "-tabs__btn"), true), "".concat(this.classPrefix, "-size-m"), this.size === "medium"), "".concat(this.classPrefix, "-size-l"), this.size === "large");
    },
    leftIconClass: function leftIconClass() {
      return _objectSpread(_defineProperty__default["default"]({}, "".concat(this.classPrefix, "-tabs__btn--left"), true), this.iconBaseClass);
    },
    rightIconClass: function rightIconClass() {
      return _objectSpread(_defineProperty__default["default"]({}, "".concat(this.classPrefix, "-tabs__btn--right"), true), this.iconBaseClass);
    },
    addIconClass: function addIconClass() {
      return _objectSpread(_defineProperty__default["default"]({}, "".concat(this.classPrefix, "-tabs__add-btn"), true), this.iconBaseClass);
    },
    navContainerClass: function navContainerClass() {
      return _defineProperty__default["default"](_defineProperty__default["default"](_defineProperty__default["default"](_defineProperty__default["default"]({}, "".concat(this.classPrefix, "-tabs__nav-container"), true), "".concat(this.classPrefix, "-tabs__nav--card"), this.theme === "card"), "".concat(this.classPrefix, "-is-").concat(this.placement), true), "".concat(this.classPrefix, "-is-addable"), this.theme === "card" && this.addable);
    },
    navScrollContainerClass: function navScrollContainerClass() {
      return _defineProperty__default["default"](_defineProperty__default["default"]({}, "".concat(this.classPrefix, "-tabs__nav-scroll"), true), "".concat(this.classPrefix, "-is-scrollable"), this.canToLeft || this.canToRight);
    },
    navsWrapClass: function navsWrapClass() {
      return ["".concat(this.classPrefix, "-tabs__nav-wrap"), "".concat(this.classPrefix, "-is-smooth"), _defineProperty__default["default"]({}, "".concat(this.classPrefix, "-is-vertical"), this.placement === "left" || this.placement === "right")];
    },
    navBarClass: function navBarClass() {
      return ["".concat(this.classPrefix, "-tabs__bar"), "".concat(this.classPrefix, "-is-").concat(this.placement)];
    },
    navsContainerStyle: function navsContainerStyle() {
      return this.addable ? {
        "min-height": "48px"
      } : null;
    },
    activeElement: function activeElement() {
      var activeIndx = this.navs.findIndex(function (nav) {
        return nav.active;
      });
      if (activeIndx > -1) {
        var _this$$refs;
        return (_this$$refs = this.$refs["tabItem".concat(activeIndx)]) === null || _this$$refs === void 0 ? void 0 : _this$$refs.$el;
      }
      return null;
    },
    canToLeft: function canToLeft() {
      return this.scrollLeft > 1;
    },
    canToRight: function canToRight() {
      return this.scrollLeft < this.maxScrollLeft - 1;
    }
  },
  watch: {
    dataCanUpdateNavBarStyle: function dataCanUpdateNavBarStyle() {
      var _this2 = this;
      this.$nextTick(function () {
        _this2.calculateNavBarStyle();
      });
    },
    value: function value() {
      var _this3 = this;
      this.$nextTick(function () {
        _this3.moveActiveTabIntoView();
      });
    },
    navs: function navs() {
      var _this4 = this;
      this.$nextTick(function () {
        _this4.getMaxScrollLeft();
        _this4.moveActiveTabIntoView();
      });
    }
  },
  methods: {
    calculateNavBarStyle: function calculateNavBarStyle() {
      var _this5 = this;
      var getNavBarStyle = function getNavBarStyle() {
        if (_this5.theme === "card") return {};
        var getPropName = function getPropName() {
          if (["left", "right"].includes(_this5.placement.toLowerCase())) {
            return ["height", "top"];
          }
          return ["width", "left"];
        };
        var offset = 0;
        var activeElement = _this5.activeElement;
        if (!activeElement) return {};
        var _getPropName = getPropName(),
          _getPropName2 = _slicedToArray__default["default"](_getPropName, 2),
          sizePropName = _getPropName2[0],
          offsetPropName = _getPropName2[1];
        var i = 0;
        for (; i < _this5.navs.length; i++) {
          var _this5$$refs;
          if (_this5.navs[i].active) {
            break;
          }
          offset += ((_this5$$refs = _this5.$refs["tabItem".concat(i)]) === null || _this5$$refs === void 0 || (_this5$$refs = _this5$$refs.$el) === null || _this5$$refs === void 0 ? void 0 : _this5$$refs["client".concat(utils_helper.firstUpperCase(sizePropName))]) || 0;
        }
        return _defineProperty__default["default"](_defineProperty__default["default"]({}, offsetPropName, "".concat(offset, "px")), sizePropName, "".concat((activeElement === null || activeElement === void 0 ? void 0 : activeElement["client".concat(utils_helper.firstUpperCase(sizePropName))]) || 0, "px"));
      };
      this.navBarStyle = getNavBarStyle();
    },
    watchDomChange: function watchDomChange() {
      var _this6 = this;
      var onResize = debounce.debounce(function () {
        _this6.getMaxScrollLeft();
      }, 300);
      window.addEventListener("resize", onResize);
      this.$once("beforeDestroy", function () {
        window.removeEventListener("resize", onResize);
      });
      if (!this.$refs.navsContainer) return;
      if (!window.ResizeObserver) return;
      var resizeObserver = new window.ResizeObserver(onResize);
      resizeObserver.observe(this.$refs.navsContainer);
      this.$once("beforeDestroy", function () {
        resizeObserver.disconnect();
      });
    },
    setOffset: function setOffset(offset) {
      this.scrollLeft = _common_js_tabs_base.calcValidOffset(offset, this.maxScrollLeft);
    },
    getMaxScrollLeft: function getMaxScrollLeft() {
      this.maxScrollLeft = _common_js_tabs_base.calcMaxOffset({
        navsWrap: this.$refs.navsWrap,
        navsContainer: this.$refs.navsContainer,
        rightOperations: this.$refs.rightOperationsZone,
        toRightBtn: this.$refs.rightIcon
      });
    },
    handleScroll: function handleScroll(action) {
      var offset = _common_js_tabs_base.calcPrevOrNextOffset({
        navsContainer: this.$refs.navsContainer,
        activeTab: this.activeElement
      }, this.scrollLeft, action);
      this.setOffset(offset);
    },
    handleWheel: function handleWheel(e) {
      if (!this.canToLeft && !this.canToRight) return;
      e.preventDefault();
      var deltaX = e.deltaX,
        deltaY = e.deltaY;
      if (Math.abs(deltaX) > Math.abs(deltaY)) {
        this.setOffset(this.scrollLeft + deltaX);
      } else {
        this.setOffset(this.scrollLeft + deltaY);
      }
    },
    moveActiveTabIntoView: function moveActiveTabIntoView() {
      if (["left", "right"].includes(this.placement.toLowerCase())) return;
      this.setOffset(_common_js_tabs_base.calculateOffset({
        activeTab: this.activeElement,
        navsContainer: this.$refs.navsContainer,
        leftOperations: this.$refs.leftOperationsZone,
        rightOperations: this.$refs.rightOperationsZone
      }, this.scrollLeft, this.scrollPosition));
    },
    handleAddTab: function handleAddTab(e) {
      utils_event.emitEvent(this, "add", {
        e: e
      });
    },
    tabClick: function tabClick(event, nav) {
      var value = nav.value,
        disabled = nav.disabled;
      if (disabled || this.value === value) {
        return false;
      }
      utils_event.emitEvent(this, "change", value);
    },
    removeBtnClick: function removeBtnClick(_ref6) {
      var e = _ref6.e,
        value = _ref6.value,
        index = _ref6.index;
      utils_event.emitEvent(this, "remove", {
        e: e,
        value: value,
        index: index
      });
    },
    renderPanelContent: function renderPanelContent() {
      var _this7 = this;
      var h = this.$createElement;
      return this.navs.map(function (panel, index) {
        return h(tabs_tabNavItem["default"], {
          "ref": "tabItem".concat(index),
          "attrs": {
            "index": index,
            "theme": panel.theme,
            "size": panel.size,
            "placement": panel.placement,
            "active": panel.active,
            "disabled": panel.disabled,
            "removable": panel.removable,
            "value": panel.value,
            "label": utils_renderTnode.renderTNodeJSX(panel.panel, "label", "\u9009\u9879\u5361".concat(index + 1))
          },
          "key": panel.value,
          "on": {
            "click": function click(e) {
              return _this7.tabClick(e, panel.panel);
            },
            "remove": _this7.removeBtnClick
          }
        });
      });
    },
    renderArrows: function renderArrows() {
      var _this8 = this;
      var h = this.$createElement;
      var _this$useGlobalIcon = this.useGlobalIcon({
          ChevronLeftIcon: tdesignIconsVue.ChevronLeftIcon,
          ChevronRightIcon: tdesignIconsVue.ChevronRightIcon,
          AddIcon: tdesignIconsVue.AddIcon
        }),
        ChevronLeftIcon = _this$useGlobalIcon.ChevronLeftIcon,
        ChevronRightIcon = _this$useGlobalIcon.ChevronRightIcon,
        AddIcon = _this$useGlobalIcon.AddIcon;
      return [h("div", {
        "ref": "leftOperationsZone",
        "class": ["".concat(this.classPrefix, "-tabs__operations"), "".concat(this.classPrefix, "-tabs__operations--left")]
      }, [h("transition", {
        "attrs": {
          "name": "fade",
          "mode": "out-in",
          "appear": true
        }
      }, [this.canToLeft ? h("div", {
        "ref": "leftIcon",
        "class": this.leftIconClass,
        "on": {
          "click": function click() {
            return _this8.handleScroll("prev");
          }
        }
      }, [h(ChevronLeftIcon)]) : null])]), h("div", {
        "ref": "rightOperationsZone",
        "class": ["".concat(this.classPrefix, "-tabs__operations"), "".concat(this.classPrefix, "-tabs__operations--right")]
      }, [h("transition", {
        "attrs": {
          "name": "fade",
          "mode": "out-in",
          "appear": true
        }
      }, [this.canToRight ? h("div", {
        "ref": "rightIcon",
        "class": this.rightIconClass,
        "on": {
          "click": function click() {
            return _this8.handleScroll("next");
          }
        }
      }, [h(ChevronRightIcon)]) : null]), this.addable ? h("div", {
        "class": this.addIconClass,
        "on": {
          "click": this.handleAddTab
        }
      }, [h(AddIcon)]) : null])];
    },
    renderNavs: function renderNavs() {
      var h = this.$createElement;
      return h("div", {
        "class": this.navContainerClass
      }, [h("div", {
        "class": this.navScrollContainerClass,
        "on": {
          "wheel": this.handleWheel
        }
      }, [h("div", {
        "ref": "navsWrap",
        "class": this.navsWrapClass,
        "style": this.wrapTransformStyle
      }, [this.renderNavBar(), this.renderPanelContent()])])]);
    },
    renderNavBar: function renderNavBar() {
      var h = this.$createElement;
      if (this.theme === "card") return null;
      return h("div", {
        "class": this.navBarClass,
        "style": this.navBarStyle
      });
    }
  },
  mounted: function mounted() {
    var _this9 = this;
    this.$nextTick(function () {
      _this9.watchDomChange();
      _this9.calculateNavBarStyle();
      _this9.getMaxScrollLeft();
    });
    setTimeout(function () {
      _this9.moveActiveTabIntoView();
    });
  },
  render: function render() {
    var h = arguments[0];
    return h("div", {
      "ref": "navsContainer",
      "class": ["".concat(this.classPrefix, "-tabs__nav")],
      "style": this.navsContainerStyle
    }, [this.renderArrows(), this.renderNavs()]);
  }
});

exports["default"] = TTabNav;
//# sourceMappingURL=tab-nav.js.map
