/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _slicedToArray = require('@babel/runtime/helpers/slicedToArray');
var VueCompositionAPI = require('@vue/composition-api');
var hooks_useConfig = require('../hooks/useConfig.js');
var tag_checkTagGroupProps = require('./check-tag-group-props.js');
var tag_checkTag = require('./check-tag.js');
var hooks_useVModel = require('../hooks/useVModel.js');
var isFunction = require('../_chunks/dep-ecccff93.js');
require('../config-provider/useConfig.js');
require('../_chunks/dep-07fb8c0e.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-a4a18104.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-27dd8cc6.js');
require('dayjs');
require('../_chunks/dep-87c765cc.js');
require('../_chunks/dep-75cd6d52.js');
require('../_chunks/dep-b1a02818.js');
require('../_chunks/dep-3d8ab37d.js');
require('../_chunks/dep-a4308f57.js');
require('../_chunks/dep-a4cecac4.js');
require('../_chunks/dep-ab142eaf.js');
require('../_chunks/dep-6ad3de7c.js');
require('../_chunks/dep-e4278c54.js');
require('../_chunks/dep-fcf0662d.js');
require('../_chunks/dep-8b1e056e.js');
require('../_chunks/dep-5db8defc.js');
require('../_chunks/dep-6e4c473c.js');
require('../_chunks/dep-234b7c02.js');
require('../_chunks/dep-a4747856.js');
require('../_chunks/dep-932dd69e.js');
require('../_chunks/dep-9f4caea4.js');
require('../_chunks/dep-dbd838d6.js');
require('../_chunks/dep-b3120c1b.js');
require('../_chunks/dep-68ba2357.js');
require('../_chunks/dep-173eb46c.js');
require('../_chunks/dep-ece3c062.js');
require('@babel/runtime/helpers/defineProperty');
require('./check-tag-props.js');
require('./tag.js');
require('tdesign-icons-vue');
require('tinycolor2');
require('./props.js');
require('../utils/mixins.js');
require('vue');
require('../config-provider/config-receiver.js');
require('../utils/render-tnode.js');
require('@babel/runtime/helpers/readOnlyError');
require('../_chunks/dep-7c854ec6.js');
require('../_chunks/dep-eceed11d.js');
require('../_chunks/dep-201f7798.js');
require('../_chunks/dep-d3015b4c.js');
require('../_chunks/dep-f8a85d6a.js');
require('../_chunks/dep-5b117689.js');
require('../_chunks/dep-6478392e.js');
require('../_chunks/dep-47bca35e.js');
require('../utils/event.js');
require('../utils/helper.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('../_chunks/dep-738b4f21.js');
require('../_common/js/common.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _slicedToArray__default = /*#__PURE__*/_interopDefaultLegacy(_slicedToArray);

var _CheckTagGroup = VueCompositionAPI.defineComponent({
  name: "TCheckTagGroup",
  props: tag_checkTagGroupProps["default"],
  setup: function setup(props2, context) {
    var _toRefs = VueCompositionAPI.toRefs(props2),
      value = _toRefs.value;
    var componentName = hooks_useConfig.usePrefixClass("check-tag-group");
    var checkTagGroupClasses = VueCompositionAPI.computed(function () {
      return [componentName.value];
    });
    var _useVModel = hooks_useVModel.useVModel(value, props2.defaultValue, props2.onChange),
      _useVModel2 = _slicedToArray__default["default"](_useVModel, 2),
      innerValue = _useVModel2[0],
      setInnerValue = _useVModel2[1];
    var onCheckTagChange = function onCheckTagChange(checked, ctx) {
      var value2 = ctx.value;
      if (checked) {
        if (props2.multiple) {
          setInnerValue(innerValue.value.concat(value2), {
            e: ctx.e,
            type: "check",
            value: value2
          });
        } else {
          setInnerValue([value2], {
            e: ctx.e,
            type: "check",
            value: value2
          });
        }
      } else {
        var newValue = [];
        if (props2.multiple) {
          newValue = innerValue.value.filter(function (t) {
            return t !== value2;
          });
        }
        setInnerValue(newValue, {
          e: ctx.e,
          type: "uncheck",
          value: value2
        });
      }
    };
    var getTagContent = function getTagContent(option) {
      if (context.slots.option) return context.slots.option(option);
      if (context.slots.label) return context.slots.label(option);
      if (option.label) {
        return isFunction.isFunction(option.label) ? option.label(VueCompositionAPI.h) : option.label;
      }
      if (option.content && isFunction.isFunction(option.content)) return option.content(VueCompositionAPI.h);
      if (option["default"] && isFunction.isFunction(option["default"])) return option["default"](VueCompositionAPI.h);
      return option.value;
    };
    return {
      innerValue: innerValue,
      checkTagGroupClasses: checkTagGroupClasses,
      onCheckTagChange: onCheckTagChange,
      getTagContent: getTagContent
    };
  },
  render: function render() {
    var _this = this;
    var h = arguments[0];
    return h("div", {
      "class": this.checkTagGroupClasses
    }, [(this.options || []).map(function (option) {
      return h(tag_checkTag["default"], {
        "key": option.value,
        "attrs": {
          "value": option.value,
          "checkedProps": _this.checkedProps,
          "uncheckedProps": _this.uncheckedProps,
          "checked": _this.innerValue.includes(option.value),
          "disabled": option.disabled,
          "size": option.size,
          "data-value": option.value
        },
        "on": {
          "change": _this.onCheckTagChange
        }
      }, [_this.getTagContent(option)]);
    })]);
  }
});

exports["default"] = _CheckTagGroup;
//# sourceMappingURL=check-tag-group.js.map
