/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _slicedToArray = require('@babel/runtime/helpers/slicedToArray');
var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var VueCompositionAPI = require('@vue/composition-api');
var dayjs = require('dayjs');
var customParseFormat = require('../_chunks/dep-9931ceef.js');
var tdesignIconsVue = require('tdesign-icons-vue');
var timePicker_panel_timePickerPanel = require('./panel/time-picker-panel.js');
var selectInput_index = require('../select-input/index.js');
var _common_js_timePicker_utils = require('../_common/js/time-picker/utils.js');
var hooks_useVModel = require('../hooks/useVModel.js');
var hooks_useConfig = require('../hooks/useConfig.js');
var hooks_useGlobalIcon = require('../hooks/useGlobalIcon.js');
var hooks_useFormDisabled = require('../hooks/useFormDisabled.js');
var timePicker_props = require('./props.js');
var configProvider_useConfig = require('../config-provider/useConfig.js');
require('../_chunks/dep-27dd8cc6.js');
require('../_common/js/time-picker/const.js');
require('./panel/props.js');
require('./panel/single-panel.js');
require('../_chunks/dep-f3761329.js');
require('../_chunks/dep-a4cecac4.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-a4308f57.js');
require('../_chunks/dep-848a5a32.js');
require('../_chunks/dep-d3015b4c.js');
require('../_chunks/dep-e4278c54.js');
require('../_chunks/dep-173eb46c.js');
require('../_chunks/dep-ab142eaf.js');
require('../_chunks/dep-5db8defc.js');
require('../_chunks/dep-ecccff93.js');
require('../_chunks/dep-234b7c02.js');
require('../_chunks/dep-5284fe1d.js');
require('../_chunks/dep-201f7798.js');
require('../_chunks/dep-fcf0662d.js');
require('../_chunks/dep-f8a85d6a.js');
require('../_chunks/dep-5b117689.js');
require('../_chunks/dep-f14aac54.js');
require('../button/button.js');
require('../loading/index.js');
require('../loading/directive.js');
require('../loading/plugin.js');
require('vue');
require('../loading/loading.js');
require('../loading/icon/gradient.js');
require('../_common/js/loading/circle-adapter.js');
require('../_common/js/utils/setStyle.js');
require('../_common/js/utils/helper.js');
require('@babel/runtime/helpers/toConsumableArray');
require('@babel/runtime/helpers/objectWithoutProperties');
require('../_chunks/dep-62de1188.js');
require('../_chunks/dep-867c284e.js');
require('../_chunks/dep-738b4f21.js');
require('../_chunks/dep-aa0a4aac.js');
require('../config-provider/config-receiver.js');
require('../_chunks/dep-07fb8c0e.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-a4a18104.js');
require('../_chunks/dep-87c765cc.js');
require('../_chunks/dep-75cd6d52.js');
require('../_chunks/dep-b1a02818.js');
require('../_chunks/dep-3d8ab37d.js');
require('../_chunks/dep-6ad3de7c.js');
require('../_chunks/dep-8b1e056e.js');
require('../_chunks/dep-6e4c473c.js');
require('../_chunks/dep-a4747856.js');
require('../_chunks/dep-932dd69e.js');
require('../_chunks/dep-9f4caea4.js');
require('../_chunks/dep-dbd838d6.js');
require('../_chunks/dep-b3120c1b.js');
require('../_chunks/dep-68ba2357.js');
require('../utils/mixins.js');
require('../utils/dom.js');
require('raf');
require('../utils/easing.js');
require('../utils/render-tnode.js');
require('@babel/runtime/helpers/readOnlyError');
require('../_chunks/dep-7c854ec6.js');
require('../_chunks/dep-eceed11d.js');
require('../_chunks/dep-6478392e.js');
require('../_chunks/dep-47bca35e.js');
require('../utils/transfer-dom.js');
require('../loading/props.js');
require('../config.js');
require('../_chunks/dep-013a3403.js');
require('../_chunks/dep-8cb0d589.js');
require('../_chunks/dep-d23147db.js');
require('../_chunks/dep-de60f5aa.js');
require('../_chunks/dep-63b02f7b.js');
require('../_chunks/dep-bebcd284.js');
require('../_chunks/dep-3eec664c.js');
require('../_chunks/dep-eeb2e214.js');
require('../_chunks/dep-315a67f0.js');
require('../_chunks/dep-f84d1ea5.js');
require('../_chunks/dep-362bc4d7.js');
require('../_chunks/dep-2e32c1f2.js');
require('../utils/withInstall.js');
require('../button/props.js');
require('../utils/ripple.js');
require('../_common/js/log/log.js');
require('../select-input/select-input.js');
require('../_chunks/dep-ece3c062.js');
require('../popup/index.js');
require('../popup/popup.js');
require('@popperjs/core');
require('../utils/helper.js');
require('../popup/props.js');
require('../popup/container.js');
require('../utils/event.js');
require('../popup/utils.js');
require('../utils/map-props.js');
require('../popup/plugin.js');
require('../select-input/props.js');
require('../select-input/useSingle.js');
require('../input/index.js');
require('../input/input.js');
require('../input/props.js');
require('../input/input-group.js');
require('../hooks/tnode.js');
require('../hooks/render-tnode.js');
require('../_chunks/dep-a6490a32.js');
require('../hooks/useDefaultValue.js');
require('../_chunks/dep-71fa6788.js');
require('../_chunks/dep-73fb598e.js');
require('../_chunks/dep-a9e7deb2.js');
require('../select-input/useMultiple.js');
require('../tag-input/index.js');
require('../tag-input/tag-input.js');
require('../tag-input/props.js');
require('../tag-input/hooks/useTagScroll.js');
require('../tag-input/useTagList.js');
require('../tag/index.js');
require('../tag/tag.js');
require('tinycolor2');
require('../tag/props.js');
require('../tag/check-tag.js');
require('../tag/check-tag-props.js');
require('../_common/js/common.js');
require('../tag/check-tag-group.js');
require('../tag/check-tag-group-props.js');
require('../tag-input/hooks/useHover.js');
require('../tag-input/hooks/useDragSorter.js');
require('../select-input/useOverlayInnerStyle.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _slicedToArray__default = /*#__PURE__*/_interopDefaultLegacy(_slicedToArray);
var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);
var dayjs__default = /*#__PURE__*/_interopDefaultLegacy(dayjs);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
dayjs__default["default"].extend(customParseFormat.customParseFormat);
var _TimePicker = VueCompositionAPI.defineComponent({
  name: "TTimePicker",
  props: _objectSpread({}, timePicker_props["default"]),
  setup: function setup(props2, ctx) {
    var _useConfig = configProvider_useConfig.useConfig("classPrefix"),
      classPrefix = _useConfig.classPrefix;
    var componentName = hooks_useConfig.usePrefixClass("time-picker");
    var _useGlobalIcon = hooks_useGlobalIcon.useGlobalIcon({
        TimeIcon: tdesignIconsVue.TimeIcon
      }),
      TimeIcon = _useGlobalIcon.TimeIcon;
    var _useFormDisabled = hooks_useFormDisabled.useFormDisabled(),
      formDisabled = _useFormDisabled.formDisabled;
    var currentValue = VueCompositionAPI.ref("");
    var isShowPanel = VueCompositionAPI.ref(false);
    var _useConfig2 = configProvider_useConfig.useConfig("timePicker"),
      global = _useConfig2.global;
    var isDisabled = VueCompositionAPI.computed(function () {
      return formDisabled.value || props2.disabled;
    });
    var _toRefs = VueCompositionAPI.toRefs(props2),
      value = _toRefs.value;
    var _useVModel = hooks_useVModel.useVModel(value, props2.defaultValue, props2.onChange, "change"),
      _useVModel2 = _slicedToArray__default["default"](_useVModel, 2),
      innerValue = _useVModel2[0],
      setInnerValue = _useVModel2[1];
    var inputClasses = VueCompositionAPI.computed(function () {
      return ["".concat(componentName.value, "__group"), _defineProperty__default["default"]({}, "".concat(classPrefix.value, "-is-focused"), isShowPanel.value)];
    });
    var handleShowPopup = function handleShowPopup(visible, context) {
      isShowPanel.value = visible;
      if (visible) {
        var _props2$onOpen;
        (_props2$onOpen = props2.onOpen) === null || _props2$onOpen === void 0 || _props2$onOpen.call(props2, context);
        ctx.emit("open", context);
      } else {
        var _props2$onClose;
        (_props2$onClose = props2.onClose) === null || _props2$onClose === void 0 || _props2$onClose.call(props2, context);
        ctx.emit("close", context);
      }
    };
    var handleClear = function handleClear(context) {
      var e = context.e;
      e.stopPropagation();
      currentValue.value = null;
      setInnerValue(null);
    };
    var handleInputChange = function handleInputChange(value2) {
      currentValue.value = value2;
    };
    var handleInputBlur = function handleInputBlur(value2, _ref2) {
      var _props2$onBlur;
      var e = _ref2.e;
      if (props2.allowInput) {
        var isValidTime = _common_js_timePicker_utils.validateInputValue(currentValue.value, props2.format);
        if (isValidTime) {
          setInnerValue(_common_js_timePicker_utils.formatInputValue(currentValue.value, props2.format));
        }
      }
      (_props2$onBlur = props2.onBlur) === null || _props2$onBlur === void 0 || _props2$onBlur.call(props2, {
        value: value2,
        e: e
      });
      ctx.emit("blur", {
        value: value2,
        e: e
      });
    };
    var handleClickConfirm = function handleClickConfirm() {
      var isValidTime = _common_js_timePicker_utils.validateInputValue(currentValue.value, props2.format);
      if (isValidTime) setInnerValue(currentValue.value);
      isShowPanel.value = false;
    };
    var handlePanelChange = function handlePanelChange(v) {
      currentValue.value = v;
    };
    var handleOnFocus = function handleOnFocus(context) {
      var _props2$onFocus;
      (_props2$onFocus = props2.onFocus) === null || _props2$onFocus === void 0 || _props2$onFocus.call(props2, context);
      ctx.emit("focus", context);
    };
    var handleOnPick = function handleOnPick(v, e) {
      var _props2$onPick;
      (_props2$onPick = props2.onPick) === null || _props2$onPick === void 0 || _props2$onPick.call(props2, v, {
        e: e
      });
      ctx.emit("pick", v, {
        e: e
      });
    };
    VueCompositionAPI.watch(function () {
      return isShowPanel.value;
    }, function () {
      var _innerValue$value;
      currentValue.value = isShowPanel.value ? (_innerValue$value = innerValue.value) !== null && _innerValue$value !== void 0 ? _innerValue$value : "" : "";
    });
    return {
      handleClickConfirm: handleClickConfirm,
      handlePanelChange: handlePanelChange,
      handleInputBlur: handleInputBlur,
      handleInputChange: handleInputChange,
      handleClear: handleClear,
      handleShowPopup: handleShowPopup,
      handleOnFocus: handleOnFocus,
      handleOnPick: handleOnPick,
      inputClasses: inputClasses,
      componentName: componentName,
      innerValue: innerValue,
      isShowPanel: isShowPanel,
      global: global,
      currentValue: currentValue,
      TimeIcon: TimeIcon,
      isDisabled: isDisabled
    };
  },
  render: function render() {
    var _this$innerValue,
      _this$innerValue2,
      _this = this;
    var h = arguments[0];
    var TimeIcon = this.TimeIcon;
    return h("div", {
      "class": this.componentName
    }, [h(selectInput_index.SelectInput, {
      "props": _objectSpread({}, {
        onFocus: this.handleOnFocus,
        onClear: this.handleClear,
        onBlur: this.handleInputBlur,
        onInputChange: this.handleInputChange,
        borderless: this.borderless,
        disabled: this.isDisabled,
        readonly: this.readonly,
        clearable: this.clearable,
        allowInput: this.allowInput,
        "class": this.inputClasses,
        suffixIcon: function suffixIcon() {
          return h(TimeIcon);
        },
        popupVisible: this.isShowPanel,
        placeholder: !this.innerValue ? this.placeholder || this.global.placeholder : void 0,
        value: this.isShowPanel ? this.currentValue : (_this$innerValue = this.innerValue) !== null && _this$innerValue !== void 0 ? _this$innerValue : void 0,
        inputValue: this.isShowPanel ? this.currentValue : (_this$innerValue2 = this.innerValue) !== null && _this$innerValue2 !== void 0 ? _this$innerValue2 : void 0,
        inputProps: _objectSpread(_objectSpread({}, this.inputProps), {}, {
          size: this.size
        }),
        status: this.status,
        tips: this.tips,
        panel: function panel() {
          return h(timePicker_panel_timePickerPanel["default"], {
            "props": _objectSpread({}, {
              steps: _this.steps,
              format: _this.format,
              value: _this.currentValue,
              isFooterDisplay: true,
              isShowPanel: _this.isShowPanel,
              disableTime: _this.disableTime,
              onChange: _this.handlePanelChange,
              onPick: _this.handleOnPick,
              hideDisabledTime: _this.hideDisabledTime,
              handleConfirmClick: _this.handleClickConfirm,
              presets: _this.presets
            })
          });
        },
        popupProps: _objectSpread({
          overlayInnerStyle: {
            width: "auto",
            padding: 0
          },
          onVisibleChange: this.handleShowPopup
        }, this.popupProps)
      })
    })]);
  }
});

exports["default"] = _TimePicker;
//# sourceMappingURL=time-picker.js.map
