/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _slicedToArray = require('@babel/runtime/helpers/slicedToArray');
var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var VueCompositionAPI = require('@vue/composition-api');
var dayjs = require('dayjs');
var customParseFormat = require('../_chunks/dep-9931ceef.js');
var tdesignIconsVue = require('tdesign-icons-vue');
var rangeInput_index = require('../range-input/index.js');
var timePicker_panel_timePickerPanel = require('./panel/time-picker-panel.js');
var _common_js_timePicker_const = require('../_common/js/time-picker/const.js');
var _common_js_timePicker_utils = require('../_common/js/time-picker/utils.js');
var timePicker_timeRangePickerProps = require('./time-range-picker-props.js');
var hooks_useVModel = require('../hooks/useVModel.js');
var hooks_useConfig = require('../hooks/useConfig.js');
var hooks_useGlobalIcon = require('../hooks/useGlobalIcon.js');
var hooks_useFormDisabled = require('../hooks/useFormDisabled.js');
var configProvider_useConfig = require('../config-provider/useConfig.js');
require('../_chunks/dep-27dd8cc6.js');
require('../range-input/range-input.js');
require('../input/index.js');
require('../input/input.js');
require('../_chunks/dep-ece3c062.js');
require('@babel/runtime/helpers/toConsumableArray');
require('@babel/runtime/helpers/typeof');
require('../_common/js/utils/helper.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('../_chunks/dep-62de1188.js');
require('../_chunks/dep-867c284e.js');
require('../_chunks/dep-738b4f21.js');
require('../_chunks/dep-a4308f57.js');
require('../_chunks/dep-fcf0662d.js');
require('../_chunks/dep-e4278c54.js');
require('../_chunks/dep-aa0a4aac.js');
require('../utils/helper.js');
require('../_chunks/dep-7c854ec6.js');
require('../_chunks/dep-eceed11d.js');
require('../_chunks/dep-201f7798.js');
require('../_chunks/dep-d3015b4c.js');
require('../_chunks/dep-f8a85d6a.js');
require('../_chunks/dep-5b117689.js');
require('../_chunks/dep-6478392e.js');
require('../config-provider/config-receiver.js');
require('vue');
require('../_chunks/dep-07fb8c0e.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-a4a18104.js');
require('../_chunks/dep-87c765cc.js');
require('../_chunks/dep-75cd6d52.js');
require('../_chunks/dep-b1a02818.js');
require('../_chunks/dep-3d8ab37d.js');
require('../_chunks/dep-ecccff93.js');
require('../_chunks/dep-a4cecac4.js');
require('../_chunks/dep-ab142eaf.js');
require('../_chunks/dep-6ad3de7c.js');
require('../_chunks/dep-8b1e056e.js');
require('../_chunks/dep-5db8defc.js');
require('../_chunks/dep-6e4c473c.js');
require('../_chunks/dep-234b7c02.js');
require('../_chunks/dep-a4747856.js');
require('../_chunks/dep-932dd69e.js');
require('../_chunks/dep-9f4caea4.js');
require('../_chunks/dep-dbd838d6.js');
require('../_chunks/dep-b3120c1b.js');
require('../_chunks/dep-68ba2357.js');
require('../_chunks/dep-173eb46c.js');
require('../utils/mixins.js');
require('../utils/event.js');
require('../input/props.js');
require('../utils/render-tnode.js');
require('@babel/runtime/helpers/readOnlyError');
require('../_chunks/dep-47bca35e.js');
require('../_common/js/log/log.js');
require('../input/input-group.js');
require('../utils/map-props.js');
require('../utils/withInstall.js');
require('../range-input/props.js');
require('../hooks/tnode.js');
require('../hooks/render-tnode.js');
require('../_chunks/dep-a6490a32.js');
require('../_chunks/dep-3eec664c.js');
require('../_chunks/dep-eeb2e214.js');
require('../range-input/range-input-popup.js');
require('../popup/index.js');
require('../popup/popup.js');
require('@popperjs/core');
require('../utils/dom.js');
require('raf');
require('../utils/easing.js');
require('../_common/js/utils/setStyle.js');
require('../popup/props.js');
require('../popup/container.js');
require('../popup/utils.js');
require('../_chunks/dep-f3761329.js');
require('../_chunks/dep-848a5a32.js');
require('../popup/plugin.js');
require('../range-input/range-input-popup-props.js');
require('../select-input/useOverlayInnerStyle.js');
require('./panel/props.js');
require('./props.js');
require('./panel/single-panel.js');
require('../_chunks/dep-5284fe1d.js');
require('../_chunks/dep-f14aac54.js');
require('../button/button.js');
require('../loading/index.js');
require('../loading/directive.js');
require('../loading/plugin.js');
require('../loading/loading.js');
require('../loading/icon/gradient.js');
require('../_common/js/loading/circle-adapter.js');
require('../utils/transfer-dom.js');
require('../loading/props.js');
require('../config.js');
require('../_chunks/dep-013a3403.js');
require('../_chunks/dep-8cb0d589.js');
require('../_chunks/dep-d23147db.js');
require('../_chunks/dep-de60f5aa.js');
require('../_chunks/dep-63b02f7b.js');
require('../_chunks/dep-bebcd284.js');
require('../_chunks/dep-315a67f0.js');
require('../_chunks/dep-f84d1ea5.js');
require('../_chunks/dep-362bc4d7.js');
require('../_chunks/dep-2e32c1f2.js');
require('../button/props.js');
require('../utils/ripple.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _slicedToArray__default = /*#__PURE__*/_interopDefaultLegacy(_slicedToArray);
var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);
var dayjs__default = /*#__PURE__*/_interopDefaultLegacy(dayjs);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
dayjs__default["default"].extend(customParseFormat.customParseFormat);
var _TimeRangePicker = VueCompositionAPI.defineComponent({
  name: "TTimeRangePicker",
  props: _objectSpread(_objectSpread({}, timePicker_timeRangePickerProps["default"]), {}, {
    rangeInputProps: Object,
    popupProps: Object
  }),
  setup: function setup(props2, ctx) {
    var componentName = hooks_useConfig.usePrefixClass("time-range-picker");
    var _useConfig = configProvider_useConfig.useConfig("timePicker"),
      global = _useConfig.global;
    var _useConfig2 = configProvider_useConfig.useConfig("classPrefix"),
      classPrefix = _useConfig2.classPrefix;
    var _useGlobalIcon = hooks_useGlobalIcon.useGlobalIcon({
        TimeIcon: tdesignIconsVue.TimeIcon
      }),
      TimeIcon = _useGlobalIcon.TimeIcon;
    var _useFormDisabled = hooks_useFormDisabled.useFormDisabled(),
      formDisabled = _useFormDisabled.formDisabled;
    var currentPanelIdx = VueCompositionAPI.ref(void 0);
    var currentValue = VueCompositionAPI.ref(_common_js_timePicker_const.TIME_PICKER_EMPTY);
    var isShowPanel = VueCompositionAPI.ref(false);
    var inputClasses = VueCompositionAPI.computed(function () {
      return ["".concat(componentName.value, "__group"), _defineProperty__default["default"]({}, "".concat(classPrefix.value, "-is-focused"), isShowPanel.value)];
    });
    var isDisabled = VueCompositionAPI.computed(function () {
      return formDisabled.value || props2.disabled;
    });
    var _toRefs = VueCompositionAPI.toRefs(props2),
      value = _toRefs.value,
      format = _toRefs.format;
    var _useVModel = hooks_useVModel.useVModel(value, props2.defaultValue, props2.onChange, "change"),
      _useVModel2 = _slicedToArray__default["default"](_useVModel, 2),
      innerValue = _useVModel2[0],
      setInnerValue = _useVModel2[1];
    var handleShowPopup = function handleShowPopup(visible, context) {
      if (context.trigger === "trigger-element-click") {
        isShowPanel.value = true;
        return;
      }
      isShowPanel.value = visible;
    };
    var handleClear = function handleClear(context) {
      var e = context.e;
      e.stopPropagation();
      currentValue.value = _common_js_timePicker_const.TIME_PICKER_EMPTY;
      setInnerValue(null);
    };
    var handleClick = function handleClick(_ref2) {
      var position = _ref2.position;
      currentPanelIdx.value = position === "first" ? 0 : 1;
    };
    var handleTimeChange = function handleTimeChange(newValue) {
      if (currentPanelIdx.value === 0) {
        var _currentValue$value$;
        currentValue.value = [newValue, (_currentValue$value$ = currentValue.value[1]) !== null && _currentValue$value$ !== void 0 ? _currentValue$value$ : newValue];
      } else {
        var _currentValue$value$2;
        currentValue.value = [(_currentValue$value$2 = currentValue.value[0]) !== null && _currentValue$value$2 !== void 0 ? _currentValue$value$2 : newValue, newValue];
      }
    };
    var handleInputBlur = function handleInputBlur(value2, _ref3) {
      var _props2$onBlur;
      var e = _ref3.e;
      if (props2.allowInput) {
        var isValidTime = _common_js_timePicker_utils.validateInputValue(currentValue.value[currentPanelIdx.value], format.value);
        if (isValidTime) {
          var _currentValue$value$3, _currentValue$value$4;
          var formattedVal = _common_js_timePicker_utils.formatInputValue(currentValue.value[currentPanelIdx.value], format.value);
          currentPanelIdx.value === 0 ? currentValue.value = [formattedVal, (_currentValue$value$3 = currentValue.value[1]) !== null && _currentValue$value$3 !== void 0 ? _currentValue$value$3 : formattedVal] : currentValue.value = [(_currentValue$value$4 = currentValue.value[0]) !== null && _currentValue$value$4 !== void 0 ? _currentValue$value$4 : formattedVal, formattedVal];
        }
      }
      (_props2$onBlur = props2.onBlur) === null || _props2$onBlur === void 0 || _props2$onBlur.call(props2, {
        value: value2,
        e: e
      });
    };
    var handleInputChange = function handleInputChange(inputVal, _ref4) {
      var _props2$onInput;
      var e = _ref4.e,
        position = _ref4.position;
      currentValue.value = inputVal;
      (_props2$onInput = props2.onInput) === null || _props2$onInput === void 0 || _props2$onInput.call(props2, {
        value: innerValue.value,
        e: e,
        position: position === "first" ? "start" : "end"
      });
      ctx.emit("input", {
        value: innerValue.value,
        e: e,
        position: position === "first" ? "start" : "end"
      });
    };
    var handleClickConfirm = function handleClickConfirm() {
      var isValidTime = !currentValue.value.find(function (v) {
        return !_common_js_timePicker_utils.validateInputValue(v, format.value);
      });
      if (isValidTime) setInnerValue(currentValue.value);
      if (props2.autoSwap) autoSwapTime();
      isShowPanel.value = false;
    };
    var handleFocus = function handleFocus(value2, _ref5) {
      var _props2$onFocus;
      var e = _ref5.e,
        position = _ref5.position;
      (_props2$onFocus = props2.onFocus) === null || _props2$onFocus === void 0 || _props2$onFocus.call(props2, {
        value: value2,
        e: e,
        position: position === "first" ? "start" : "end"
      });
      ctx.emit("focus", {
        value: value2,
        e: e,
        position: position === "first" ? "start" : "end"
      });
    };
    var autoSwapTime = function autoSwapTime() {
      var _currentValue$value = _slicedToArray__default["default"](currentValue.value, 2),
        startTime = _currentValue$value[0],
        endTime = _currentValue$value[1];
      var startDayjs = dayjs__default["default"](startTime, props2.format);
      var endDayjs = dayjs__default["default"](endTime, props2.format);
      if (startDayjs.isAfter(endDayjs, "second")) {
        setInnerValue([currentValue.value[1], currentValue.value[0]]);
      } else {
        setInnerValue([currentValue.value[0], currentValue.value[1]]);
      }
    };
    var handleOnPick = function handleOnPick(pickValue, e) {
      var _props2$onPick;
      var pickedRangeValue = [];
      var context = {
        e: e
      };
      if (currentPanelIdx.value === 0) {
        var _currentValue$value$5;
        pickedRangeValue = [pickValue, (_currentValue$value$5 = currentValue.value[1]) !== null && _currentValue$value$5 !== void 0 ? _currentValue$value$5 : pickValue];
        context = {
          position: "start",
          e: e
        };
      } else {
        var _currentValue$value$6;
        pickedRangeValue = [(_currentValue$value$6 = currentValue.value[0]) !== null && _currentValue$value$6 !== void 0 ? _currentValue$value$6 : pickValue, pickValue];
        context = {
          position: "end",
          e: e
        };
      }
      (_props2$onPick = props2.onPick) === null || _props2$onPick === void 0 || _props2$onPick.call(props2, pickedRangeValue, context);
      ctx.emit("pick", pickedRangeValue, context);
    };
    VueCompositionAPI.watch(function () {
      return isShowPanel.value;
    }, function () {
      var _innerValue$value;
      currentValue.value = isShowPanel.value ? (_innerValue$value = innerValue.value) !== null && _innerValue$value !== void 0 ? _innerValue$value : _common_js_timePicker_const.TIME_PICKER_EMPTY : _common_js_timePicker_const.TIME_PICKER_EMPTY;
      if (!isShowPanel.value) currentPanelIdx.value = void 0;
    });
    return {
      global: global,
      componentName: componentName,
      currentValue: currentValue,
      currentPanelIdx: currentPanelIdx,
      inputClasses: inputClasses,
      innerValue: innerValue,
      isShowPanel: isShowPanel,
      handleInputChange: handleInputChange,
      handleShowPopup: handleShowPopup,
      handleClear: handleClear,
      handleFocus: handleFocus,
      handleOnPick: handleOnPick,
      handleClickConfirm: handleClickConfirm,
      handleClick: handleClick,
      handleInputBlur: handleInputBlur,
      handleTimeChange: handleTimeChange,
      TimeIcon: TimeIcon,
      isDisabled: isDisabled
    };
  },
  render: function render() {
    var _this$innerValue,
      _this = this;
    var h = arguments[0];
    var TimeIcon = this.TimeIcon;
    return h("div", {
      "class": this.componentName
    }, [h(rangeInput_index.RangeInputPopup, {
      "props": _objectSpread({}, {
        onInputChange: this.handleInputChange,
        disabled: this.isDisabled,
        readonly: this.readonly,
        popupVisible: this.isShowPanel,
        inputValue: this.isShowPanel ? this.currentValue : (_this$innerValue = this.innerValue) !== null && _this$innerValue !== void 0 ? _this$innerValue : _common_js_timePicker_const.TIME_PICKER_EMPTY,
        popupProps: _objectSpread({
          overlayInnerStyle: {
            width: "auto",
            padding: 0
          },
          onVisibleChange: this.handleShowPopup
        }, this.popupProps),
        status: this.status,
        tips: this.tips,
        rangeInputProps: _objectSpread({
          size: this.size,
          borderless: this.borderless,
          clearable: this.clearable,
          "class": this.inputClasses,
          placeholder: this.placeholder || [this.global.placeholder, this.global.placeholder],
          suffixIcon: function suffixIcon() {
            return h(TimeIcon);
          },
          onClear: this.handleClear,
          onClick: this.handleClick,
          onFocus: this.handleFocus,
          onBlur: this.handleInputBlur,
          readonly: this.readonly || !this.allowInput,
          activeIndex: this.currentPanelIdx
        }, this.rangeInputProps),
        panel: function panel() {
          return h(timePicker_panel_timePickerPanel["default"], {
            "props": _objectSpread({}, {
              steps: _this.steps,
              format: _this.format,
              isShowPanel: _this.isShowPanel,
              disableTime: _this.disableTime,
              hideDisabledTime: _this.hideDisabledTime,
              isFooterDisplay: true,
              value: _this.currentValue[_this.currentPanelIdx || 0],
              onChange: _this.handleTimeChange,
              onPick: _this.handleOnPick,
              handleConfirmClick: _this.handleClickConfirm,
              position: _this.currentPanelIdx === 0 ? "start" : "end",
              activeIndex: _this.currentPanelIdx,
              presets: _this.presets
            })
          });
        }
      })
    })]);
  }
});

exports["default"] = _TimeRangePicker;
//# sourceMappingURL=time-range-picker.js.map
