/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var VueCompositionAPI = require('@vue/composition-api');
var timeline_timeline = require('./timeline.js');
var timeline_timelineItem = require('./timeline-item.js');
var utils_withInstall = require('../utils/withInstall.js');
require('@babel/runtime/helpers/defineProperty');
require('./utils.js');
require('../_common/js/log/log.js');
require('./props.js');
require('../hooks/useConfig.js');
require('../config-provider/useConfig.js');
require('../_chunks/dep-07fb8c0e.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-a4a18104.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-27dd8cc6.js');
require('dayjs');
require('../_chunks/dep-87c765cc.js');
require('../_chunks/dep-75cd6d52.js');
require('../_chunks/dep-b1a02818.js');
require('../_chunks/dep-3d8ab37d.js');
require('../_chunks/dep-ecccff93.js');
require('../_chunks/dep-a4308f57.js');
require('../_chunks/dep-a4cecac4.js');
require('../_chunks/dep-ab142eaf.js');
require('../_chunks/dep-6ad3de7c.js');
require('../_chunks/dep-e4278c54.js');
require('../_chunks/dep-fcf0662d.js');
require('../_chunks/dep-8b1e056e.js');
require('../_chunks/dep-5db8defc.js');
require('../_chunks/dep-6e4c473c.js');
require('../_chunks/dep-234b7c02.js');
require('../_chunks/dep-a4747856.js');
require('../_chunks/dep-932dd69e.js');
require('../_chunks/dep-9f4caea4.js');
require('../_chunks/dep-dbd838d6.js');
require('../_chunks/dep-b3120c1b.js');
require('../_chunks/dep-68ba2357.js');
require('../_chunks/dep-173eb46c.js');
require('../loading/index.js');
require('../loading/directive.js');
require('../loading/plugin.js');
require('vue');
require('../loading/loading.js');
require('../loading/icon/gradient.js');
require('../_common/js/loading/circle-adapter.js');
require('../_common/js/utils/setStyle.js');
require('../_common/js/utils/helper.js');
require('@babel/runtime/helpers/toConsumableArray');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/slicedToArray');
require('../_chunks/dep-62de1188.js');
require('../_chunks/dep-867c284e.js');
require('../_chunks/dep-738b4f21.js');
require('../_chunks/dep-aa0a4aac.js');
require('../config-provider/config-receiver.js');
require('../utils/mixins.js');
require('../utils/dom.js');
require('raf');
require('../utils/easing.js');
require('../utils/render-tnode.js');
require('@babel/runtime/helpers/readOnlyError');
require('../_chunks/dep-7c854ec6.js');
require('../_chunks/dep-eceed11d.js');
require('../_chunks/dep-201f7798.js');
require('../_chunks/dep-d3015b4c.js');
require('../_chunks/dep-f8a85d6a.js');
require('../_chunks/dep-5b117689.js');
require('../_chunks/dep-6478392e.js');
require('../_chunks/dep-47bca35e.js');
require('../utils/transfer-dom.js');
require('../loading/props.js');
require('../config.js');
require('../_chunks/dep-013a3403.js');
require('../_chunks/dep-8cb0d589.js');
require('../_chunks/dep-d23147db.js');
require('../_chunks/dep-de60f5aa.js');
require('../_chunks/dep-63b02f7b.js');
require('../_chunks/dep-bebcd284.js');
require('../_chunks/dep-3eec664c.js');
require('../_chunks/dep-eeb2e214.js');
require('../_chunks/dep-315a67f0.js');
require('../_chunks/dep-f84d1ea5.js');
require('../_chunks/dep-362bc4d7.js');
require('../_chunks/dep-2e32c1f2.js');
require('../_chunks/dep-f14aac54.js');
require('./timeline-item-props.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var VueCompositionAPI__default = /*#__PURE__*/_interopDefaultLegacy(VueCompositionAPI);

var Timeline = utils_withInstall.withInstall(timeline_timeline["default"], VueCompositionAPI__default["default"]);
var TimelineItem = utils_withInstall.withInstall(timeline_timelineItem["default"], VueCompositionAPI__default["default"]);

exports.Timeline = Timeline;
exports.TimelineItem = TimelineItem;
exports["default"] = Timeline;
//# sourceMappingURL=index.js.map
