/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var helper = require('../../_chunks/dep-ece3c062.js');
var _toConsumableArray = require('@babel/runtime/helpers/toConsumableArray');
var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var _typeof = require('@babel/runtime/helpers/typeof');
var utils_mixins = require('../../utils/mixins.js');
var pagination_index = require('../../pagination/index.js');
var checkbox_index = require('../../checkbox/index.js');
var transfer_utils = require('../utils.js');
var utils_ripple = require('../../utils/ripple.js');
var transfer_components_transferSearch = require('./transfer-search.js');
var utils_renderTnode = require('../../utils/render-tnode.js');
var configProvider_configReceiver = require('../../config-provider/config-receiver.js');
var transfer_props = require('../props.js');
require('vue');
require('../../pagination/pagination.js');
require('tdesign-icons-vue');
require('../../input-number/index.js');
require('@vue/composition-api');
require('../../input-number/input-number.js');
require('../../button/index.js');
require('../../button/button.js');
require('../../loading/index.js');
require('../../loading/directive.js');
require('../../loading/plugin.js');
require('../../loading/loading.js');
require('../../loading/icon/gradient.js');
require('../../_common/js/loading/circle-adapter.js');
require('../../_common/js/utils/setStyle.js');
require('../../_common/js/utils/helper.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/slicedToArray');
require('../../_chunks/dep-62de1188.js');
require('../../_chunks/dep-867c284e.js');
require('../../_chunks/dep-738b4f21.js');
require('../../_chunks/dep-a4308f57.js');
require('../../_chunks/dep-fcf0662d.js');
require('../../_chunks/dep-e4278c54.js');
require('../../_chunks/dep-aa0a4aac.js');
require('../../utils/dom.js');
require('raf');
require('../../utils/easing.js');
require('../../utils/transfer-dom.js');
require('../../loading/props.js');
require('@babel/runtime/helpers/readOnlyError');
require('../../_chunks/dep-7c854ec6.js');
require('../../_chunks/dep-eceed11d.js');
require('../../_chunks/dep-201f7798.js');
require('../../_chunks/dep-d3015b4c.js');
require('../../_chunks/dep-f8a85d6a.js');
require('../../_chunks/dep-5b117689.js');
require('../../_chunks/dep-6478392e.js');
require('../../_chunks/dep-47bca35e.js');
require('../../_chunks/dep-07fb8c0e.js');
require('../../_common/js/global-config/default-config.js');
require('../../_common/js/global-config/locale/zh_CN.js');
require('../../_chunks/dep-a4a18104.js');
require('../../_chunks/dep-27dd8cc6.js');
require('dayjs');
require('../../_chunks/dep-87c765cc.js');
require('../../_chunks/dep-75cd6d52.js');
require('../../_chunks/dep-b1a02818.js');
require('../../_chunks/dep-3d8ab37d.js');
require('../../_chunks/dep-ecccff93.js');
require('../../_chunks/dep-a4cecac4.js');
require('../../_chunks/dep-ab142eaf.js');
require('../../_chunks/dep-6ad3de7c.js');
require('../../_chunks/dep-8b1e056e.js');
require('../../_chunks/dep-5db8defc.js');
require('../../_chunks/dep-6e4c473c.js');
require('../../_chunks/dep-234b7c02.js');
require('../../_chunks/dep-a4747856.js');
require('../../_chunks/dep-932dd69e.js');
require('../../_chunks/dep-9f4caea4.js');
require('../../_chunks/dep-dbd838d6.js');
require('../../_chunks/dep-b3120c1b.js');
require('../../_chunks/dep-68ba2357.js');
require('../../_chunks/dep-173eb46c.js');
require('../../config.js');
require('../../_chunks/dep-013a3403.js');
require('../../_chunks/dep-8cb0d589.js');
require('../../_chunks/dep-d23147db.js');
require('../../_chunks/dep-de60f5aa.js');
require('../../_chunks/dep-63b02f7b.js');
require('../../_chunks/dep-bebcd284.js');
require('../../_chunks/dep-3eec664c.js');
require('../../_chunks/dep-eeb2e214.js');
require('../../_chunks/dep-315a67f0.js');
require('../../_chunks/dep-f84d1ea5.js');
require('../../_chunks/dep-362bc4d7.js');
require('../../_chunks/dep-2e32c1f2.js');
require('../../_chunks/dep-f14aac54.js');
require('../../utils/withInstall.js');
require('../../button/props.js');
require('../../input/index.js');
require('../../input/input.js');
require('../../utils/helper.js');
require('../../utils/event.js');
require('../../input/props.js');
require('../../_common/js/log/log.js');
require('../../input/input-group.js');
require('../../utils/map-props.js');
require('../../input-number/props.js');
require('../../input-number/useInputNumber.js');
require('../../hooks/useCommonClassName.js');
require('../../config-provider/useConfig.js');
require('../../hooks/useVModel.js');
require('../../_common/js/input-number/number.js');
require('../../_common/js/input-number/large-number.js');
require('../../hooks/useFormDisabled.js');
require('../../hooks/useGlobalIcon.js');
require('../../select/index.js');
require('../../select/select.js');
require('../../hooks/useDefaultValue.js');
require('../../hooks/tnode.js');
require('../../hooks/render-tnode.js');
require('../../_chunks/dep-a6490a32.js');
require('../../select/props.js');
require('../../popup/index.js');
require('../../popup/popup.js');
require('@popperjs/core');
require('../../popup/props.js');
require('../../popup/container.js');
require('../../popup/utils.js');
require('../../_chunks/dep-f3761329.js');
require('../../_chunks/dep-848a5a32.js');
require('../../popup/plugin.js');
require('../../tag/index.js');
require('../../tag/tag.js');
require('tinycolor2');
require('../../tag/props.js');
require('../../tag/check-tag.js');
require('../../tag/check-tag-props.js');
require('../../hooks/useConfig.js');
require('../../_common/js/common.js');
require('../../tag/check-tag-group.js');
require('../../tag/check-tag-group-props.js');
require('../../select-input/index.js');
require('../../select-input/select-input.js');
require('../../select-input/props.js');
require('../../select-input/useSingle.js');
require('../../_chunks/dep-71fa6788.js');
require('../../_chunks/dep-73fb598e.js');
require('../../_chunks/dep-a9e7deb2.js');
require('../../select-input/useMultiple.js');
require('../../tag-input/index.js');
require('../../tag-input/tag-input.js');
require('../../tag-input/props.js');
require('../../tag-input/hooks/useTagScroll.js');
require('../../tag-input/useTagList.js');
require('../../tag-input/hooks/useHover.js');
require('../../tag-input/hooks/useDragSorter.js');
require('../../select-input/useOverlayInnerStyle.js');
require('../../common-components/fake-arrow.js');
require('../../select/option.js');
require('../../select/option-props.js');
require('../../hooks/useLazyLoad.js');
require('../../_common/js/utils/observe.js');
require('../../select/util.js');
require('../../_chunks/dep-f45125c9.js');
require('../../_chunks/dep-f33eb57d.js');
require('../../checkbox/group.js');
require('../../checkbox/checkbox.js');
require('../../checkbox/props.js');
require('../../checkbox/constants.js');
require('../../checkbox/store.js');
require('@babel/runtime/helpers/classCallCheck');
require('@babel/runtime/helpers/createClass');
require('../../checkbox/hooks/useKeyboardEvent.js');
require('../../hooks/useElementLazyRender.js');
require('../../checkbox/checkbox-group-props.js');
require('../../_chunks/dep-e83685df.js');
require('../../_chunks/dep-502c56be.js');
require('../../hooks/slots.js');
require('../../select/select-panel.js');
require('../../select/optionGroup.js');
require('../../select/option-group-props.js');
require('../../hooks/useVirtualScroll.js');
require('../../select/hooks/useSelectOptions.js');
require('../../_chunks/dep-6dc0a916.js');
require('../../_chunks/dep-b5c96567.js');
require('../../input-adornment/index.js');
require('../../input-adornment/input-adornment.js');
require('../../input-adornment/props.js');
require('../../pagination/props.js');
require('../../pagination/pagination-mini.js');
require('../../pagination/pagination-mini-props.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _toConsumableArray__default = /*#__PURE__*/_interopDefaultLegacy(_toConsumableArray);
var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);
var _typeof__default = /*#__PURE__*/_interopDefaultLegacy(_typeof);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var classPrefixMixins = configProvider_configReceiver.getClassPrefixMixins("transfer");
var keepAnimationMixins = configProvider_configReceiver.getKeepAnimationMixins();
var TransferList = utils_mixins["default"](keepAnimationMixins, classPrefixMixins).extend({
  name: "TTransferList",
  components: {
    Search: transfer_components_transferSearch["default"],
    TCheckbox: checkbox_index.Checkbox,
    TCheckboxGroup: checkbox_index.CheckboxGroup
  },
  directives: {
    ripple: utils_ripple["default"]
  },
  props: {
    checkboxProps: {
      type: Object,
      "default": function _default() {
        return {};
      }
    },
    dataSource: {
      type: Array,
      "default": function _default() {
        return [];
      }
    },
    listType: {
      type: String,
      "default": "target"
    },
    title: {
      type: [String, Function]
    },
    checkedValue: {
      type: Array,
      "default": function _default() {
        return [];
      }
    },
    disabled: {
      type: Boolean,
      "default": false
    },
    search: {
      type: [Boolean, Object],
      "default": false
    },
    transferItem: Function,
    empty: {
      type: [Function, String]
    },
    pagination: [Boolean, Object],
    footer: [Function, String],
    checkAll: Boolean,
    t: Function,
    global: Object,
    tree: transfer_props["default"].tree,
    isTreeMode: {
      type: Boolean,
      "default": false
    },
    draggable: Boolean,
    currentValue: {
      type: Array
    }
  },
  data: function data() {
    return {
      filterValue: "",
      defaultCurrent: null,
      defaultPageSize: null,
      draggingIndex: null,
      dragoverIndex: null,
      dragoverPos: ""
    };
  },
  computed: {
    currentPage: function currentPage() {
      var _ref, _ref2, _this$pagination$curr, _this$pagination, _this$pagination2;
      return (_ref = (_ref2 = (_this$pagination$curr = (_this$pagination = this.pagination) === null || _this$pagination === void 0 ? void 0 : _this$pagination.current) !== null && _this$pagination$curr !== void 0 ? _this$pagination$curr : this.defaultCurrent) !== null && _ref2 !== void 0 ? _ref2 : (_this$pagination2 = this.pagination) === null || _this$pagination2 === void 0 ? void 0 : _this$pagination2.defaultCurrent) !== null && _ref !== void 0 ? _ref : 1;
    },
    pageSize: function pageSize() {
      var _ref3, _ref4, _this$pagination$page, _this$pagination3, _this$pagination4;
      return (_ref3 = (_ref4 = (_this$pagination$page = (_this$pagination3 = this.pagination) === null || _this$pagination3 === void 0 ? void 0 : _this$pagination3.pageSize) !== null && _this$pagination$page !== void 0 ? _this$pagination$page : this.defaultPageSize) !== null && _ref4 !== void 0 ? _ref4 : (_this$pagination4 = this.pagination) === null || _this$pagination4 === void 0 ? void 0 : _this$pagination4.defaultPageSize) !== null && _ref3 !== void 0 ? _ref3 : 10;
    },
    pageTotal: function pageTotal() {
      return this.filteredData && this.filteredData.length || 0;
    },
    filteredData: function filteredData() {
      var _this = this;
      if (!this.isTreeMode) {
        return this.dataSource.filter(function (item) {
          var label = item && item.label.toString();
          return label.toLowerCase().indexOf(_this.filterValue.toLowerCase()) > -1;
        });
      }
      return transfer_utils.filterTreeData(this.dataSource, this.filterValue);
    },
    curPageData: function curPageData() {
      var pageData = this.filteredData;
      if (!this.pagination) return pageData;
      if (this.pageSize === 0) return pageData;
      var startIndex = (this.currentPage - 1) * this.pageSize;
      var endIndex = this.currentPage * this.pageSize;
      pageData = pageData.slice(startIndex, endIndex);
      return pageData;
    },
    paginationProps: function paginationProps() {
      var defaultPaginationProps = {
        totalContent: false,
        pageSizeOptions: []
      };
      return _typeof__default["default"](this.pagination) === "object" ? _objectSpread(_objectSpread(_objectSpread({}, defaultPaginationProps), this.pagination), {}, {
        size: "small",
        theme: "simple",
        current: this.currentPage,
        total: this.pageTotal,
        pageSize: this.pageSize
      }) : {};
    },
    hasFooter: function hasFooter() {
      return !!this.$slots["default"];
    },
    indeterminate: function indeterminate() {
      return !this.isAllChecked && this.checkedValue.length > 0;
    },
    isAllChecked: function isAllChecked() {
      var _this2 = this;
      var allValue = transfer_utils.getDataValues(this.dataSource, [], {
        isTreeMode: this.isTreeMode,
        include: false
      });
      return this.checkedValue.length > 0 && (this.isTreeMode ? allValue.every(function (item) {
        return _this2.checkedValue.includes(item);
      }) : (this.search ? this.filteredData : this.dataSource).every(function (item) {
        return item.disabled || _this2.checkedValue.includes(item.value);
      }));
    },
    totalCount: function totalCount() {
      return transfer_utils.getLeafCount(this.dataSource);
    }
  },
  watch: {
    totalCount: function totalCount(val) {
      if (val <= (this.currentPage - 1) * this.pageSize && val !== 0) {
        var lastPage = Math.ceil(val / this.pageSize);
        this.defaultCurrent = lastPage;
      }
    }
  },
  methods: {
    handlePaginationChange: function handlePaginationChange(pageInfo) {
      this.$emit("pageChange", pageInfo);
      this.defaultCurrent = pageInfo.current;
      this.defaultPageSize = pageInfo.pageSize;
    },
    handleCheckedChange: function handleCheckedChange(val) {
      this.$emit("checkedChange", val);
    },
    handleCheckedAllChange: function handleCheckedAllChange(checked) {
      if (checked) {
        var allValue = transfer_utils.getDataValues(this.search ? this.filteredData : this.dataSource, [], {
          isTreeMode: this.isTreeMode,
          include: false
        });
        this.handleCheckedChange(allValue);
      } else {
        this.handleCheckedChange([]);
      }
    },
    scroll: function scroll(e) {
      this.$emit("scroll", e);
    },
    handleSearch: function handleSearch(e) {
      var event = {
        query: e.value,
        type: this.listType,
        e: e.e,
        trigger: e.trigger
      };
      this.$emit("search", event);
    },
    onDragStart: function onDragStart(e) {
      var index = Number(e.target.dataset.index);
      this.draggingIndex = index;
    },
    onDragOver: function onDragOver(e) {
      e.preventDefault();
      if (e.currentTarget) {
        var currentElement = e.currentTarget;
        var index = Number(currentElement.dataset.index);
        var elemHeight = currentElement.offsetHeight;
        var dragY = e.clientY - currentElement.getBoundingClientRect().top;
        var insertAreaPercent = 0.3;
        var insertAreaHeight = elemHeight * insertAreaPercent;
        this.dragoverIndex = index;
        if (this.dragoverIndex === this.draggingIndex) {
          this.dragoverPos = "";
          return;
        }
        if (dragY < insertAreaHeight) {
          this.dragoverPos = "top";
        } else if (dragY > elemHeight - insertAreaHeight) {
          this.dragoverPos = "bottom";
        } else {
          this.dragoverPos = "center";
        }
      }
    },
    onDragLeave: function onDragLeave() {
      this.dragoverPos = "";
      this.dragoverIndex = null;
    },
    onDragEnd: function onDragEnd() {
      this.draggingIndex = null;
      this.dragoverIndex = null;
      this.dragoverPos = "";
    },
    onDrop: function onDrop(e) {
      e.preventDefault();
      var draggingIndex = this.draggingIndex,
        dragoverIndex = this.dragoverIndex,
        dragoverPos = this.dragoverPos;
      this.draggingIndex = null;
      this.dragoverIndex = null;
      this.dragoverPos = "";
      if (draggingIndex === dragoverIndex) {
        return;
      }
      var newData = _toConsumableArray__default["default"](this.currentValue);
      var sourceItem = this.curPageData[draggingIndex].value;
      var targetItem = this.curPageData[dragoverIndex].value;
      var sourceIndex = newData.indexOf(sourceItem);
      var targetIndex = newData.indexOf(targetItem);
      newData.splice(sourceIndex, 1);
      if (dragoverPos === "bottom") {
        targetIndex += 1;
      }
      newData.splice(targetIndex, 0, sourceItem);
      this.$emit("dataChange", newData);
    },
    renderTitle: function renderTitle() {
      var h = this.$createElement;
      var defaultNode = this.title && typeof this.title === "string" ? h("template", [this.title]) : null;
      var titleNode = utils_renderTnode.renderTNodeJSXDefault(this, "title", {
        defaultNode: defaultNode,
        params: {
          type: this.listType
        }
      });
      return h("span", [titleNode]);
    },
    renderContent: function renderContent() {
      var _this3 = this;
      var h = this.$createElement;
      var rootNode = transfer_utils.findTopNode(this);
      var isDraggable = this.draggable && this.listType === transfer_utils.TARGET;
      var defaultNode;
      if (!isDraggable) {
        defaultNode = h(checkbox_index.CheckboxGroup, {
          "attrs": {
            "value": this.checkedValue
          },
          "on": {
            "change": this.handleCheckedChange
          }
        }, [this.curPageData.map(function (item, index) {
          return h(checkbox_index.Checkbox, {
            "attrs": {
              "disabled": _this3.disabled || item.disabled,
              "value": item.value
            },
            "class": ["".concat(_this3.componentName, "__list-item")],
            "key": item.key,
            "directives": [{
              name: "ripple",
              value: _this3.keepAnimation.ripple && !_this3.draggable
            }],
            "props": _objectSpread({}, _this3.checkboxProps)
          }, [utils_renderTnode.renderTNodeJSXDefault(_this3, "transferItem", {
            defaultNode: h("span", [item.label]),
            params: {
              data: item.data,
              index: index,
              type: _this3.listType
            }
          })]);
        })]);
      } else {
        defaultNode = h(checkbox_index.CheckboxGroup, {
          "attrs": {
            "value": this.checkedValue
          },
          "on": {
            "change": this.handleCheckedChange
          },
          "key": JSON.stringify(this.currentValue)
        }, [this.curPageData.map(function (item, index) {
          return h("div", {
            "attrs": {
              "draggable": isDraggable,
              "data-index": index
            },
            "on": {
              "dragend": _this3.onDragEnd,
              "dragstart": _this3.onDragStart,
              "dragover": _this3.onDragOver,
              "dragleave": _this3.onDragLeave,
              "drop": _this3.onDrop
            }
          }, [h(checkbox_index.Checkbox, {
            "attrs": {
              "disabled": _this3.disabled || item.disabled,
              "value": item.value
            },
            "class": ["".concat(_this3.componentName, "__list-item")],
            "key": item.key,
            "directives": [{
              name: "ripple",
              value: _this3.keepAnimation.ripple && !_this3.draggable
            }],
            "props": _objectSpread({}, _this3.checkboxProps)
          }, [utils_renderTnode.renderTNodeJSXDefault(_this3, "transferItem", {
            defaultNode: h("span", [item.label]),
            params: {
              data: item.data,
              index: index,
              type: _this3.listType
            }
          })])]);
        })]);
      }
      return h("div", {
        "class": "".concat(this.componentName, "__list-content narrow-scrollbar"),
        "on": {
          "scroll": this.scroll
        }
      }, [utils_renderTnode.renderTNodeJSXDefault(rootNode, "tree", {
        defaultNode: defaultNode,
        params: {
          data: this.curPageData,
          value: this.checkedValue,
          onChange: this.handleCheckedChange
        }
      })]);
    },
    renderEmpty: function renderEmpty() {
      var h = this.$createElement;
      var empty = this.empty || this.t(this.global.empty);
      var defaultNode = typeof empty === "string" ? h("span", [empty]) : null;
      return h("div", {
        "class": "".concat(this.componentName, "__empty")
      }, [utils_renderTnode.renderTNodeJSXDefault(this, "empty", {
        defaultNode: defaultNode,
        params: {
          type: this.listType
        }
      })]);
    },
    renderFooter: function renderFooter() {
      var h = this.$createElement;
      var defaultNode = typeof this.footer === "string" ? h("div", {
        "class": "".concat(this.componentName, "__footer")
      }, [this.footer]) : null;
      return utils_renderTnode.renderTNodeJSXDefault(this, "footer", {
        defaultNode: defaultNode,
        params: {
          type: this.listType
        }
      });
    }
  },
  render: function render() {
    var _this4 = this;
    var h = arguments[0];
    return h("div", {
      "class": "".concat(this.componentName, "__list ").concat(this.componentName, "__list-").concat(this.listType)
    }, [h("div", {
      "class": "".concat(this.componentName, "__list-header")
    }, [h("div", [this.checkAll && h(checkbox_index.Checkbox, {
      "attrs": {
        "disabled": this.disabled || !this.dataSource.length,
        "checked": this.isAllChecked,
        "indeterminate": this.indeterminate
      },
      "on": {
        "change": this.handleCheckedAllChange
      }
    }), h("span", [this.t(this.global.title, {
      checked: this.checkedValue.length,
      total: this.totalCount
    })])]), this.renderTitle()]), h("div", {
      "class": ["".concat(this.componentName, "__list-body"), this.search ? "".concat(this.componentName, "__list--with-search") : ""]
    }, [this.search && h("search", {
      "attrs": {
        "searchValue": this.filterValue,
        "placeholder": this.t(this.global.placeholder),
        "disabled": this.disabled,
        "search": this.search,
        "classPrefix": this.classPrefix
      },
      "on": {
        "change": function change(e) {
          return _this4.filterValue = e;
        },
        "search": this.handleSearch
      }
    }), this.curPageData.length > 0 ? this.renderContent() : this.renderEmpty()]), this.pagination && this.pageSize > 0 && this.pageTotal > 0 && h("div", {
      "class": "".concat(this.componentName, "__list-pagination")
    }, [h(pagination_index.Pagination, helper.helper([{}, {
      "props": this.paginationProps
    }, {
      "on": {
        "change": this.handlePaginationChange
      }
    }]))]), this.renderFooter()]);
  }
});

exports["default"] = TransferList;
//# sourceMappingURL=transfer-list.js.map
