/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var VueCompositionAPI = require('@vue/composition-api');
var Vue = require('vue');
var utils_withInstall = require('../utils/withInstall.js');
var hooks_useVModel = require('../hooks/useVModel.js');
var hooks_useDefaultValue = require('../hooks/useDefaultValue.js');
var tdesignIconsVue = require('tdesign-icons-vue');
var checkbox_index = require('../checkbox/index.js');
var loading_index = require('../loading/index.js');
var hooks_useConfig = require('../hooks/useConfig.js');
var hooks_useGlobalIcon = require('../hooks/useGlobalIcon.js');
var hooks_useLazyLoad = require('../hooks/useLazyLoad.js');
var hooks_useVirtualScrollNew = require('../hooks/useVirtualScrollNew.js');
var _common_js_tree_treeNode = require('../_common/js/tree/tree-node.js');
var configProvider_useConfig = require('../config-provider/useConfig.js');
require('@babel/runtime/helpers/defineProperty');
require('../_chunks/dep-eceed11d.js');
require('../_chunks/dep-201f7798.js');
require('../_chunks/dep-a4308f57.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-fcf0662d.js');
require('../_chunks/dep-d3015b4c.js');
require('../_chunks/dep-e4278c54.js');
require('../_chunks/dep-f8a85d6a.js');
require('../_chunks/dep-5b117689.js');
require('../_chunks/dep-47bca35e.js');
require('../_chunks/dep-6478392e.js');
require('../checkbox/group.js');
require('../_chunks/dep-ece3c062.js');
require('@babel/runtime/helpers/toConsumableArray');
require('@babel/runtime/helpers/slicedToArray');
require('../utils/helper.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('../_chunks/dep-7c854ec6.js');
require('../checkbox/checkbox.js');
require('../checkbox/props.js');
require('../checkbox/constants.js');
require('../checkbox/store.js');
require('@babel/runtime/helpers/classCallCheck');
require('@babel/runtime/helpers/createClass');
require('../checkbox/hooks/useKeyboardEvent.js');
require('../_common/js/common.js');
require('../hooks/useFormDisabled.js');
require('../hooks/useElementLazyRender.js');
require('../_common/js/utils/observe.js');
require('../utils/render-tnode.js');
require('@babel/runtime/helpers/readOnlyError');
require('../_chunks/dep-07fb8c0e.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-a4a18104.js');
require('../_chunks/dep-27dd8cc6.js');
require('dayjs');
require('../_chunks/dep-87c765cc.js');
require('../_chunks/dep-75cd6d52.js');
require('../_chunks/dep-b1a02818.js');
require('../_chunks/dep-3d8ab37d.js');
require('../_chunks/dep-ecccff93.js');
require('../_chunks/dep-a4cecac4.js');
require('../_chunks/dep-ab142eaf.js');
require('../_chunks/dep-6ad3de7c.js');
require('../_chunks/dep-8b1e056e.js');
require('../_chunks/dep-5db8defc.js');
require('../_chunks/dep-6e4c473c.js');
require('../_chunks/dep-234b7c02.js');
require('../_chunks/dep-a4747856.js');
require('../_chunks/dep-932dd69e.js');
require('../_chunks/dep-9f4caea4.js');
require('../_chunks/dep-dbd838d6.js');
require('../_chunks/dep-b3120c1b.js');
require('../_chunks/dep-68ba2357.js');
require('../_chunks/dep-173eb46c.js');
require('../checkbox/checkbox-group-props.js');
require('../_chunks/dep-e83685df.js');
require('../_chunks/dep-d23147db.js');
require('../_chunks/dep-502c56be.js');
require('../_chunks/dep-62de1188.js');
require('../hooks/slots.js');
require('../loading/directive.js');
require('../loading/plugin.js');
require('../loading/loading.js');
require('../loading/icon/gradient.js');
require('../_common/js/loading/circle-adapter.js');
require('../_common/js/utils/setStyle.js');
require('../_common/js/utils/helper.js');
require('../_chunks/dep-867c284e.js');
require('../_chunks/dep-738b4f21.js');
require('../_chunks/dep-aa0a4aac.js');
require('../config-provider/config-receiver.js');
require('../utils/mixins.js');
require('../utils/dom.js');
require('raf');
require('../utils/easing.js');
require('../utils/transfer-dom.js');
require('../loading/props.js');
require('../config.js');
require('../_chunks/dep-013a3403.js');
require('../_chunks/dep-8cb0d589.js');
require('../_chunks/dep-de60f5aa.js');
require('../_chunks/dep-63b02f7b.js');
require('../_chunks/dep-bebcd284.js');
require('../_chunks/dep-3eec664c.js');
require('../_chunks/dep-eeb2e214.js');
require('../_chunks/dep-315a67f0.js');
require('../_chunks/dep-f84d1ea5.js');
require('../_chunks/dep-362bc4d7.js');
require('../_chunks/dep-2e32c1f2.js');
require('../_chunks/dep-f14aac54.js');
require('../hooks/useResizeObserver.js');
require('@babel/runtime/helpers/asyncToGenerator');
require('@babel/runtime/regenerator');
require('../_common/js/tree/tree-node-model.js');
require('../_common/js/log/log.js');
require('../_chunks/dep-5b9bb086.js');
require('../_chunks/dep-6dc0a916.js');
require('../_chunks/dep-f33eb57d.js');
require('../_chunks/dep-b5c96567.js');
require('../_chunks/dep-a9e7deb2.js');
require('../_chunks/dep-db8e4c0d.js');
require('../_chunks/dep-8b3c7277.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var VueCompositionAPI__default = /*#__PURE__*/_interopDefaultLegacy(VueCompositionAPI);
var Vue__default = /*#__PURE__*/_interopDefaultLegacy(Vue);

var isVueNext = false;
var TransitionGroup = Vue__default["default"].component("TransitionGroup");
var onDrag = {
  "default": void 0
};
var TreeItemDefinition = {
  name: "TTreeItem",
  inject: {
    onDrag: onDrag
  }
};
function useRipple(el) {}
function withInstall(construct) {
  return utils_withInstall.withInstall(construct, VueCompositionAPI__default["default"]);
}
function getCreateElement(h) {
  return h;
}
function getScopedSlots(instance) {
  return instance.$scopedSlots;
}
function useVModel(props, refsProps) {
  var propName = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : "value";
  var defaultPropName = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : "defaultValue";
  var eventPropName = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : "onChange";
  var eventName = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : "change";
  if (propName === "value") {
    return hooks_useVModel.useVModel(refsProps[propName], props[defaultPropName], props[eventPropName], eventName, propName);
  }
  return hooks_useDefaultValue["default"](refsProps[propName], props[defaultPropName], props[eventPropName], propName, eventName);
}

Object.defineProperty(exports, 'computed', {
  enumerable: true,
  get: function () { return VueCompositionAPI.computed; }
});
Object.defineProperty(exports, 'defineComponent', {
  enumerable: true,
  get: function () { return VueCompositionAPI.defineComponent; }
});
Object.defineProperty(exports, 'onMounted', {
  enumerable: true,
  get: function () { return VueCompositionAPI.onMounted; }
});
Object.defineProperty(exports, 'reactive', {
  enumerable: true,
  get: function () { return VueCompositionAPI.reactive; }
});
Object.defineProperty(exports, 'ref', {
  enumerable: true,
  get: function () { return VueCompositionAPI.ref; }
});
Object.defineProperty(exports, 'toRefs', {
  enumerable: true,
  get: function () { return VueCompositionAPI.toRefs; }
});
Object.defineProperty(exports, 'watch', {
  enumerable: true,
  get: function () { return VueCompositionAPI.watch; }
});
Object.defineProperty(exports, 'TdCaretRightSmallIcon', {
  enumerable: true,
  get: function () { return tdesignIconsVue.CaretRightSmallIcon; }
});
exports.TCheckBox = checkbox_index.Checkbox;
exports.TLoading = loading_index.Loading;
exports.usePrefixClass = hooks_useConfig.usePrefixClass;
exports.useGlobalIcon = hooks_useGlobalIcon.useGlobalIcon;
exports.useLazyLoad = hooks_useLazyLoad["default"];
exports.useVirtualScroll = hooks_useVirtualScrollNew["default"];
exports.TreeNode = _common_js_tree_treeNode.TreeNode;
exports.privateKey = _common_js_tree_treeNode.privateKey;
exports.useConfig = configProvider_useConfig.useConfig;
exports.TransitionGroup = TransitionGroup;
exports.TreeItemDefinition = TreeItemDefinition;
exports.getCreateElement = getCreateElement;
exports.getScopedSlots = getScopedSlots;
exports.isVueNext = isVueNext;
exports.useRipple = useRipple;
exports.useVModel = useVModel;
exports.withInstall = withInstall;
//# sourceMappingURL=adapt.js.map
