/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var VueCompositionAPI = require('@vue/composition-api');

function useItemState(props, context) {
  var refProps = VueCompositionAPI.toRefs(props);
  var treeItemRef = VueCompositionAPI.ref(null);
  var treeScope = props.treeScope;
  var store = treeScope.store;
  var node = store.privateMap.get(props.itemKey);
  var state = {
    stateId: props.stateId,
    props: props,
    context: context,
    treeScope: treeScope,
    refProps: refProps,
    node: node,
    treeItemRef: treeItemRef
  };
  return {
    state: state
  };
}

exports["default"] = useItemState;
//# sourceMappingURL=useItemState.js.map
