/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var tree_util = require('../util.js');
var hooks_useConfig = require('../../hooks/useConfig.js');
var loading_index = require('../../loading/index.js');
var hooks_useGlobalIcon = require('../../hooks/useGlobalIcon.js');
var tdesignIconsVue = require('tdesign-icons-vue');
require('@babel/runtime/helpers/defineProperty');
require('../../_chunks/dep-7c854ec6.js');
require('../../_chunks/dep-eceed11d.js');
require('../../_chunks/dep-201f7798.js');
require('../../_chunks/dep-a4308f57.js');
require('@babel/runtime/helpers/typeof');
require('../../_chunks/dep-fcf0662d.js');
require('../../_chunks/dep-d3015b4c.js');
require('../../_chunks/dep-e4278c54.js');
require('../../_chunks/dep-f8a85d6a.js');
require('../../_chunks/dep-5b117689.js');
require('../../_chunks/dep-6478392e.js');
require('@vue/composition-api');
require('../../config-provider/useConfig.js');
require('../../_chunks/dep-07fb8c0e.js');
require('../../_common/js/global-config/default-config.js');
require('../../_common/js/global-config/locale/zh_CN.js');
require('../../_chunks/dep-a4a18104.js');
require('../../_chunks/dep-27dd8cc6.js');
require('dayjs');
require('../../_chunks/dep-87c765cc.js');
require('../../_chunks/dep-75cd6d52.js');
require('../../_chunks/dep-b1a02818.js');
require('../../_chunks/dep-3d8ab37d.js');
require('../../_chunks/dep-ecccff93.js');
require('../../_chunks/dep-a4cecac4.js');
require('../../_chunks/dep-ab142eaf.js');
require('../../_chunks/dep-6ad3de7c.js');
require('../../_chunks/dep-8b1e056e.js');
require('../../_chunks/dep-5db8defc.js');
require('../../_chunks/dep-6e4c473c.js');
require('../../_chunks/dep-234b7c02.js');
require('../../_chunks/dep-a4747856.js');
require('../../_chunks/dep-932dd69e.js');
require('../../_chunks/dep-9f4caea4.js');
require('../../_chunks/dep-dbd838d6.js');
require('../../_chunks/dep-b3120c1b.js');
require('../../_chunks/dep-68ba2357.js');
require('../../_chunks/dep-173eb46c.js');
require('../../loading/directive.js');
require('../../loading/plugin.js');
require('vue');
require('../../loading/loading.js');
require('../../loading/icon/gradient.js');
require('../../_common/js/loading/circle-adapter.js');
require('../../_common/js/utils/setStyle.js');
require('../../_common/js/utils/helper.js');
require('@babel/runtime/helpers/toConsumableArray');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/slicedToArray');
require('../../_chunks/dep-62de1188.js');
require('../../_chunks/dep-867c284e.js');
require('../../_chunks/dep-738b4f21.js');
require('../../_chunks/dep-aa0a4aac.js');
require('../../config-provider/config-receiver.js');
require('../../utils/mixins.js');
require('../../utils/dom.js');
require('raf');
require('../../utils/easing.js');
require('../../utils/render-tnode.js');
require('@babel/runtime/helpers/readOnlyError');
require('../../_chunks/dep-47bca35e.js');
require('../../utils/transfer-dom.js');
require('../../loading/props.js');
require('../../config.js');
require('../../_chunks/dep-013a3403.js');
require('../../_chunks/dep-8cb0d589.js');
require('../../_chunks/dep-d23147db.js');
require('../../_chunks/dep-de60f5aa.js');
require('../../_chunks/dep-63b02f7b.js');
require('../../_chunks/dep-bebcd284.js');
require('../../_chunks/dep-3eec664c.js');
require('../../_chunks/dep-eeb2e214.js');
require('../../_chunks/dep-315a67f0.js');
require('../../_chunks/dep-f84d1ea5.js');
require('../../_chunks/dep-362bc4d7.js');
require('../../_chunks/dep-2e32c1f2.js');
require('../../_chunks/dep-f14aac54.js');
require('../../utils/withInstall.js');

function useRenderIcon(state) {
  var classPrefix = hooks_useConfig.usePrefixClass().value;
  var componentName = hooks_useConfig.usePrefixClass("tree").value;
  var getFolderIcon = function getFolderIcon(h) {
    var _useGlobalIcon = hooks_useGlobalIcon.useGlobalIcon({
        CaretRightSmallIcon: tdesignIconsVue.CaretRightSmallIcon
      }),
      CaretRightSmallIcon = _useGlobalIcon.CaretRightSmallIcon;
    return h(CaretRightSmallIcon);
  };
  var handleMousedown = function handleMousedown(evt) {
    evt.preventDefault();
  };
  var renderIcon = function renderIcon(h) {
    var node = state.node,
      treeScope = state.treeScope;
    var scopedSlots = treeScope.scopedSlots;
    var treeProps = (treeScope === null || treeScope === void 0 ? void 0 : treeScope.treeProps) || {};
    var icon = treeProps.icon;
    var isDefaultIcon = false;
    var iconNode = null;
    if (icon === true) {
      if (scopedSlots !== null && scopedSlots !== void 0 && scopedSlots.icon) {
        iconNode = scopedSlots.icon({
          node: node === null || node === void 0 ? void 0 : node.getModel()
        });
      } else if (!node.vmIsLeaf) {
        isDefaultIcon = true;
        iconNode = getFolderIcon(h);
        if (node.loading && node.expanded) {
          iconNode = h(loading_index.Loading);
        }
      } else {
        iconNode = "";
      }
    } else if (icon) {
      iconNode = tree_util.getTNode(icon, {
        createElement: h,
        node: node
      });
    }
    var wrapIconNode = h("span", {
      "class": ["".concat(componentName, "__icon"), "".concat(classPrefix, "-folder-icon"), isDefaultIcon ? "".concat(componentName, "__icon--default") : ""],
      "attrs": {
        "trigger": "expand",
        "ignore": "active"
      },
      "on": {
        "mousedown": handleMousedown
      }
    }, [iconNode]);
    return wrapIconNode;
  };
  return {
    renderIcon: renderIcon
  };
}

exports["default"] = useRenderIcon;
//# sourceMappingURL=useRenderIcon.js.map
