/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var helper = require('../../_chunks/dep-ece3c062.js');
var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var tree_util = require('../util.js');
var tree_hooks_useItemEvents = require('./useItemEvents.js');
var hooks_useConfig = require('../../hooks/useConfig.js');
var isBoolean = require('../../_chunks/dep-5b9bb086.js');
var checkbox_index = require('../../checkbox/index.js');
var VueCompositionAPI = require('@vue/composition-api');
require('../../_chunks/dep-7c854ec6.js');
require('../../_chunks/dep-eceed11d.js');
require('../../_chunks/dep-201f7798.js');
require('../../_chunks/dep-a4308f57.js');
require('@babel/runtime/helpers/typeof');
require('../../_chunks/dep-fcf0662d.js');
require('../../_chunks/dep-d3015b4c.js');
require('../../_chunks/dep-e4278c54.js');
require('../../_chunks/dep-f8a85d6a.js');
require('../../_chunks/dep-5b117689.js');
require('../../_chunks/dep-6478392e.js');
require('../../config-provider/useConfig.js');
require('../../_chunks/dep-07fb8c0e.js');
require('../../_common/js/global-config/default-config.js');
require('../../_common/js/global-config/locale/zh_CN.js');
require('../../_chunks/dep-a4a18104.js');
require('../../_chunks/dep-27dd8cc6.js');
require('dayjs');
require('../../_chunks/dep-87c765cc.js');
require('../../_chunks/dep-75cd6d52.js');
require('../../_chunks/dep-b1a02818.js');
require('../../_chunks/dep-3d8ab37d.js');
require('../../_chunks/dep-ecccff93.js');
require('../../_chunks/dep-a4cecac4.js');
require('../../_chunks/dep-ab142eaf.js');
require('../../_chunks/dep-6ad3de7c.js');
require('../../_chunks/dep-8b1e056e.js');
require('../../_chunks/dep-5db8defc.js');
require('../../_chunks/dep-6e4c473c.js');
require('../../_chunks/dep-234b7c02.js');
require('../../_chunks/dep-a4747856.js');
require('../../_chunks/dep-932dd69e.js');
require('../../_chunks/dep-9f4caea4.js');
require('../../_chunks/dep-dbd838d6.js');
require('../../_chunks/dep-b3120c1b.js');
require('../../_chunks/dep-68ba2357.js');
require('../../_chunks/dep-173eb46c.js');
require('../../checkbox/group.js');
require('@babel/runtime/helpers/toConsumableArray');
require('@babel/runtime/helpers/slicedToArray');
require('../../utils/helper.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('../../checkbox/checkbox.js');
require('../../checkbox/props.js');
require('../../checkbox/constants.js');
require('../../checkbox/store.js');
require('@babel/runtime/helpers/classCallCheck');
require('@babel/runtime/helpers/createClass');
require('../../checkbox/hooks/useKeyboardEvent.js');
require('../../_common/js/common.js');
require('../../hooks/useVModel.js');
require('../../_chunks/dep-47bca35e.js');
require('../../hooks/useFormDisabled.js');
require('../../hooks/useElementLazyRender.js');
require('../../_common/js/utils/observe.js');
require('../../utils/render-tnode.js');
require('@babel/runtime/helpers/readOnlyError');
require('vue');
require('../../checkbox/checkbox-group-props.js');
require('../../_chunks/dep-e83685df.js');
require('../../_chunks/dep-d23147db.js');
require('../../_chunks/dep-502c56be.js');
require('../../_chunks/dep-62de1188.js');
require('../../hooks/slots.js');
require('../../utils/withInstall.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function useRenderLabel(state) {
  var classPrefix = hooks_useConfig.usePrefixClass().value;
  var componentName = hooks_useConfig.usePrefixClass("tree").value;
  var _useItemEvents = tree_hooks_useItemEvents["default"](state),
    handleChange = _useItemEvents.handleChange;
  var renderLabel = function renderLabel(h) {
    var node = state.node,
      treeScope = state.treeScope;
    var scopedSlots = treeScope.scopedSlots,
      _treeScope$treeProps = treeScope.treeProps,
      treeProps = _treeScope$treeProps === void 0 ? {} : _treeScope$treeProps;
    var label = treeProps.label,
      expandOnClickNode = treeProps.expandOnClickNode;
    var checkProps = (treeProps === null || treeProps === void 0 ? void 0 : treeProps.checkProps) || {};
    var labelNode = null;
    if (label === true) {
      if (scopedSlots !== null && scopedSlots !== void 0 && scopedSlots.label) {
        labelNode = scopedSlots.label({
          node: node === null || node === void 0 ? void 0 : node.getModel()
        });
      } else {
        labelNode = node.label || "";
      }
    } else {
      labelNode = tree_util.getTNode(label, {
        createElement: h,
        node: node
      });
    }
    var labelClasses = ["".concat(componentName, "__label"), _defineProperty__default["default"]({}, "".concat(classPrefix, "-is-active"), node.isActivable() ? node.actived : false)];
    var shouldStopLabelTrigger = VueCompositionAPI.computed(function () {
      var _node$children;
      var isNormalBranchNode = Array.isArray(node.children) && ((_node$children = node.children) === null || _node$children === void 0 ? void 0 : _node$children.length) > 0;
      var isLazyLoadChildBranchNode = isBoolean.isBoolean(node.children) && node.children;
      var isBranchNode = isNormalBranchNode || isLazyLoadChildBranchNode;
      return expandOnClickNode && isBranchNode;
    });
    if (node.vmCheckable) {
      var checkboxDisabled = false;
      if (node.vmIsLocked && !node.vmIsRest) {
        checkboxDisabled = true;
      }
      if (node.isDisabled()) {
        checkboxDisabled = true;
      }
      var itemCheckProps = _objectSpread(_objectSpread({}, checkProps), {}, {
        disabled: checkboxDisabled
      });
      labelNode = h(checkbox_index.Checkbox, helper.helper([{
        "class": labelClasses,
        "attrs": {
          "checked": node.checked,
          "indeterminate": node.indeterminate,
          "disabled": checkboxDisabled,
          "name": String(node.value),
          "stopLabelTrigger": shouldStopLabelTrigger.value,
          "ignore": treeProps.expandOnClickNode ? "active" : "expand,active"
        },
        "on": {
          "change": handleChange
        }
      }, {
        "props": itemCheckProps
      }]), [labelNode]);
    } else {
      var inner = h("span", {
        "style": "position: relative"
      }, [labelNode]);
      labelNode = node.isActivable() ? h("span", {
        "key": "1",
        "ref": "label",
        "class": labelClasses,
        "attrs": {
          "title": node.label
        }
      }, [inner]) : h("span", {
        "key": "2",
        "class": labelClasses,
        "attrs": {
          "title": node.label
        }
      }, [inner]);
    }
    return labelNode;
  };
  return {
    renderLabel: renderLabel
  };
}

exports["default"] = useRenderLabel;
//# sourceMappingURL=useRenderLabel.js.map
