/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var tree_treeItem = require('../tree-item.js');
var tree_hooks_useTreeEvents = require('./useTreeEvents.js');
var isUndefined = require('../../_chunks/dep-62de1188.js');
var _common_js_tree_treeNode = require('../../_common/js/tree/tree-node.js');
var VueCompositionAPI = require('@vue/composition-api');
require('@babel/runtime/helpers/defineProperty');
require('../adapt.js');
require('vue');
require('../../utils/withInstall.js');
require('../../_chunks/dep-eceed11d.js');
require('../../_chunks/dep-201f7798.js');
require('../../_chunks/dep-a4308f57.js');
require('@babel/runtime/helpers/typeof');
require('../../_chunks/dep-fcf0662d.js');
require('../../_chunks/dep-d3015b4c.js');
require('../../_chunks/dep-e4278c54.js');
require('../../_chunks/dep-f8a85d6a.js');
require('../../_chunks/dep-5b117689.js');
require('../../hooks/useVModel.js');
require('../../_chunks/dep-47bca35e.js');
require('../../_chunks/dep-6478392e.js');
require('../../hooks/useDefaultValue.js');
require('tdesign-icons-vue');
require('../../checkbox/index.js');
require('../../checkbox/group.js');
require('../../_chunks/dep-ece3c062.js');
require('@babel/runtime/helpers/toConsumableArray');
require('@babel/runtime/helpers/slicedToArray');
require('../../utils/helper.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('../../_chunks/dep-7c854ec6.js');
require('../../checkbox/checkbox.js');
require('../../checkbox/props.js');
require('../../checkbox/constants.js');
require('../../checkbox/store.js');
require('@babel/runtime/helpers/classCallCheck');
require('@babel/runtime/helpers/createClass');
require('../../checkbox/hooks/useKeyboardEvent.js');
require('../../_common/js/common.js');
require('../../hooks/useConfig.js');
require('../../config-provider/useConfig.js');
require('../../_chunks/dep-07fb8c0e.js');
require('../../_common/js/global-config/default-config.js');
require('../../_common/js/global-config/locale/zh_CN.js');
require('../../_chunks/dep-a4a18104.js');
require('../../_chunks/dep-27dd8cc6.js');
require('dayjs');
require('../../_chunks/dep-87c765cc.js');
require('../../_chunks/dep-75cd6d52.js');
require('../../_chunks/dep-b1a02818.js');
require('../../_chunks/dep-3d8ab37d.js');
require('../../_chunks/dep-ecccff93.js');
require('../../_chunks/dep-a4cecac4.js');
require('../../_chunks/dep-ab142eaf.js');
require('../../_chunks/dep-6ad3de7c.js');
require('../../_chunks/dep-8b1e056e.js');
require('../../_chunks/dep-5db8defc.js');
require('../../_chunks/dep-6e4c473c.js');
require('../../_chunks/dep-234b7c02.js');
require('../../_chunks/dep-a4747856.js');
require('../../_chunks/dep-932dd69e.js');
require('../../_chunks/dep-9f4caea4.js');
require('../../_chunks/dep-dbd838d6.js');
require('../../_chunks/dep-b3120c1b.js');
require('../../_chunks/dep-68ba2357.js');
require('../../_chunks/dep-173eb46c.js');
require('../../hooks/useFormDisabled.js');
require('../../hooks/useElementLazyRender.js');
require('../../_common/js/utils/observe.js');
require('../../utils/render-tnode.js');
require('@babel/runtime/helpers/readOnlyError');
require('../../checkbox/checkbox-group-props.js');
require('../../_chunks/dep-e83685df.js');
require('../../_chunks/dep-d23147db.js');
require('../../_chunks/dep-502c56be.js');
require('../../hooks/slots.js');
require('../../loading/index.js');
require('../../loading/directive.js');
require('../../loading/plugin.js');
require('../../loading/loading.js');
require('../../loading/icon/gradient.js');
require('../../_common/js/loading/circle-adapter.js');
require('../../_common/js/utils/setStyle.js');
require('../../_common/js/utils/helper.js');
require('../../_chunks/dep-867c284e.js');
require('../../_chunks/dep-738b4f21.js');
require('../../_chunks/dep-aa0a4aac.js');
require('../../config-provider/config-receiver.js');
require('../../utils/mixins.js');
require('../../utils/dom.js');
require('raf');
require('../../utils/easing.js');
require('../../utils/transfer-dom.js');
require('../../loading/props.js');
require('../../config.js');
require('../../_chunks/dep-013a3403.js');
require('../../_chunks/dep-8cb0d589.js');
require('../../_chunks/dep-de60f5aa.js');
require('../../_chunks/dep-63b02f7b.js');
require('../../_chunks/dep-bebcd284.js');
require('../../_chunks/dep-3eec664c.js');
require('../../_chunks/dep-eeb2e214.js');
require('../../_chunks/dep-315a67f0.js');
require('../../_chunks/dep-f84d1ea5.js');
require('../../_chunks/dep-362bc4d7.js');
require('../../_chunks/dep-2e32c1f2.js');
require('../../_chunks/dep-f14aac54.js');
require('../../hooks/useGlobalIcon.js');
require('../../hooks/useLazyLoad.js');
require('../../hooks/useVirtualScrollNew.js');
require('../../hooks/useResizeObserver.js');
require('@babel/runtime/helpers/asyncToGenerator');
require('@babel/runtime/regenerator');
require('../../_common/js/tree/tree-node-model.js');
require('../../_common/js/log/log.js');
require('../../_chunks/dep-5b9bb086.js');
require('../../_chunks/dep-6dc0a916.js');
require('../../_chunks/dep-f33eb57d.js');
require('../../_chunks/dep-b5c96567.js');
require('../../_chunks/dep-a9e7deb2.js');
require('../../_chunks/dep-db8e4c0d.js');
require('../../_chunks/dep-8b3c7277.js');
require('./useItemState.js');
require('./useTreeItem.js');
require('./useItemEvents.js');
require('./useRenderIcon.js');
require('../util.js');
require('./useRenderLabel.js');
require('./useRenderLine.js');
require('./useRenderOperations.js');
require('./useDraggable.js');
require('../../_chunks/dep-13309278.js');
require('../../_chunks/dep-f3761329.js');
require('../../_chunks/dep-848a5a32.js');
require('./useTreeAction.js');

function useTreeNodes(state) {
  var store = state.store,
    scope = state.scope,
    allNodes = state.allNodes,
    nodes = state.nodes,
    virtualConfig = state.virtualConfig;
  var _useTreeEvents = tree_hooks_useTreeEvents["default"](state),
    handleClick = _useTreeEvents.handleClick,
    handleChange = _useTreeEvents.handleChange;
  var nodesEmpty = VueCompositionAPI.ref(false);
  var cacheMap = /* @__PURE__ */new Map();
  var refresh = function refresh() {
    allNodes.value = store.getNodes();
  };
  var refreshVisibleNodes = function refreshVisibleNodes() {
    var isVirtual = virtualConfig === null || virtualConfig === void 0 ? void 0 : virtualConfig.isVirtualScroll.value;
    if (isVirtual) return;
    var list = [];
    var hasVisibleNode = false;
    allNodes.value.forEach(function (node) {
      if (node.visible) {
        hasVisibleNode = true;
        cacheMap.set(node.value, node.value);
      }
      if (!isUndefined.isUndefined(cacheMap.get(node.value))) {
        list.push(node);
      }
    });
    cacheMap.forEach(function (value) {
      if (!store.getNode(value)) {
        cacheMap["delete"](value);
      }
    });
    nodes.value = list;
    nodesEmpty.value = !hasVisibleNode;
  };
  var refreshVirtualNodes = function refreshVirtualNodes() {
    var isVirtual = virtualConfig === null || virtualConfig === void 0 ? void 0 : virtualConfig.isVirtualScroll.value;
    if (!isVirtual) return;
    var list = virtualConfig.visibleData.value;
    nodes.value = list;
    nodesEmpty.value = list.length <= 0;
  };
  var renderItem = function renderItem(h, node, index, stateId) {
    var rowIndex = node.__VIRTUAL_SCROLL_INDEX || index;
    var nodeUniqueId = node[_common_js_tree_treeNode.privateKey];
    var treeItem = h(tree_treeItem["default"], {
      "key": nodeUniqueId,
      "attrs": {
        "rowIndex": rowIndex,
        "stateId": stateId,
        "itemKey": nodeUniqueId,
        "treeScope": scope
      },
      "on": {
        "click": handleClick,
        "change": handleChange
      }
    });
    return treeItem;
  };
  var renderTreeNodes = function renderTreeNodes(h) {
    var stateId = "render-".concat(new Date().getTime());
    var treeNodeViews = nodes.value.map(function (node, index) {
      return renderItem(h, node, index, stateId);
    });
    return treeNodeViews;
  };
  VueCompositionAPI.watch(allNodes, refreshVisibleNodes);
  VueCompositionAPI.watch(virtualConfig.visibleData, refreshVirtualNodes);
  refresh();
  refreshVisibleNodes();
  refreshVirtualNodes();
  store.emitter.on("update", refresh);
  return {
    nodesEmpty: nodesEmpty,
    renderTreeNodes: renderTreeNodes
  };
}

exports["default"] = useTreeNodes;
//# sourceMappingURL=useTreeNodes.js.map
