/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var VueCompositionAPI = require('@vue/composition-api');
var upload_hooks_useDrag = require('../hooks/useDrag.js');
var upload_constants = require('../constants.js');
var utils_renderTnode = require('../../utils/render-tnode.js');
var isFunction = require('../../_chunks/dep-ecccff93.js');
require('../../_common/js/upload/utils.js');
require('../../_common/js/log/log.js');
require('@babel/runtime/helpers/readOnlyError');
require('@babel/runtime/helpers/typeof');
require('vue');
require('../../_chunks/dep-7c854ec6.js');
require('../../_chunks/dep-eceed11d.js');
require('../../_chunks/dep-201f7798.js');
require('../../_chunks/dep-a4308f57.js');
require('../../_chunks/dep-fcf0662d.js');
require('../../_chunks/dep-d3015b4c.js');
require('../../_chunks/dep-e4278c54.js');
require('../../_chunks/dep-f8a85d6a.js');
require('../../_chunks/dep-5b117689.js');
require('../../_chunks/dep-6478392e.js');
require('../../_chunks/dep-47bca35e.js');
require('../../_chunks/dep-a4cecac4.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var CustomFile = VueCompositionAPI.defineComponent({
  name: "UploadCustomFile",
  props: _objectSpread(_objectSpread({}, upload_constants.commonProps), {}, {
    dragEvents: Object,
    draggable: Boolean,
    dragContent: Function,
    trigger: Function,
    triggerUpload: Function,
    childrenNode: Function
  }),
  setup: function setup(props) {
    var _toRefs = VueCompositionAPI.toRefs(props),
      accept = _toRefs.accept;
    var drag = upload_hooks_useDrag["default"](props.dragEvents, accept);
    var dragActive = drag.dragActive;
    return _objectSpread({
      dragActive: dragActive
    }, drag);
  },
  render: function render() {
    var _this = this,
      _this$$scopedSlots$de,
      _this$$scopedSlots;
    var h = arguments[0];
    var renderDragContent = function renderDragContent() {
      var params = {
        dragActive: _this.dragActive || false,
        files: _this.displayFiles
      };
      return h("div", {
        "class": "".concat(_this.classPrefix, "-upload__dragger ").concat(_this.classPrefix, "-upload__dragger-center"),
        "on": {
          "drop": _this.handleDrop,
          "dragenter": _this.handleDragenter,
          "dragover": _this.handleDragover,
          "dragleave": _this.handleDragleave,
          "click": _this.triggerUpload
        }
      }, [h("div", {
        "class": "".concat(_this.classPrefix, "-upload__trigger")
      }, [utils_renderTnode.renderContent(_this, "dragContent", "trigger", {
        params: params
      }) || isFunction.isFunction(_this.childrenNode) && _this.childrenNode(params)])]);
    };
    return this.draggable ? renderDragContent() : h("div", {
      "class": "".concat(this.classPrefix, "-upload__trigger"),
      "on": {
        "click": this.triggerUpload
      }
    }, [isFunction.isFunction(this.childrenNode) && this.childrenNode({
      files: this.displayFiles
    }) || ((_this$$scopedSlots$de = (_this$$scopedSlots = this.$scopedSlots)["default"]) === null || _this$$scopedSlots$de === void 0 ? void 0 : _this$$scopedSlots$de.call(_this$$scopedSlots, null))]);
  }
});

exports["default"] = CustomFile;
//# sourceMappingURL=custom-file.js.map
