/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _toConsumableArray = require('@babel/runtime/helpers/toConsumableArray');
var helper = require('../../_chunks/dep-ece3c062.js');
var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var VueCompositionAPI = require('@vue/composition-api');
var tdesignIconsVue = require('tdesign-icons-vue');
var loading_index = require('../../loading/index.js');
var hooks_useGlobalIcon = require('../../hooks/useGlobalIcon.js');
var imageViewer_index = require('../../image-viewer/index.js');
var upload_constants = require('../constants.js');
var _common_js_upload_utils = require('../../_common/js/upload/utils.js');
var utils_renderTnode = require('../../utils/render-tnode.js');
var link_index = require('../../link/index.js');
var image_index = require('../../image/index.js');
require('../../loading/directive.js');
require('../../loading/plugin.js');
require('vue');
require('../../loading/loading.js');
require('../../loading/icon/gradient.js');
require('../../_common/js/loading/circle-adapter.js');
require('../../_common/js/utils/setStyle.js');
require('../../_common/js/utils/helper.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/slicedToArray');
require('../../_chunks/dep-62de1188.js');
require('../../_chunks/dep-867c284e.js');
require('../../_chunks/dep-738b4f21.js');
require('../../_chunks/dep-a4308f57.js');
require('@babel/runtime/helpers/typeof');
require('../../_chunks/dep-fcf0662d.js');
require('../../_chunks/dep-e4278c54.js');
require('../../_chunks/dep-aa0a4aac.js');
require('../../config-provider/config-receiver.js');
require('../../_chunks/dep-07fb8c0e.js');
require('../../_common/js/global-config/default-config.js');
require('../../_common/js/global-config/locale/zh_CN.js');
require('../../_chunks/dep-a4a18104.js');
require('../../_chunks/dep-27dd8cc6.js');
require('dayjs');
require('../../_chunks/dep-87c765cc.js');
require('../../_chunks/dep-75cd6d52.js');
require('../../_chunks/dep-b1a02818.js');
require('../../_chunks/dep-3d8ab37d.js');
require('../../_chunks/dep-ecccff93.js');
require('../../_chunks/dep-a4cecac4.js');
require('../../_chunks/dep-ab142eaf.js');
require('../../_chunks/dep-6ad3de7c.js');
require('../../_chunks/dep-8b1e056e.js');
require('../../_chunks/dep-5db8defc.js');
require('../../_chunks/dep-6e4c473c.js');
require('../../_chunks/dep-234b7c02.js');
require('../../_chunks/dep-a4747856.js');
require('../../_chunks/dep-932dd69e.js');
require('../../_chunks/dep-9f4caea4.js');
require('../../_chunks/dep-dbd838d6.js');
require('../../_chunks/dep-b3120c1b.js');
require('../../_chunks/dep-68ba2357.js');
require('../../_chunks/dep-173eb46c.js');
require('../../utils/mixins.js');
require('../../utils/dom.js');
require('raf');
require('../../utils/easing.js');
require('../../utils/transfer-dom.js');
require('../../loading/props.js');
require('@babel/runtime/helpers/readOnlyError');
require('../../_chunks/dep-7c854ec6.js');
require('../../_chunks/dep-eceed11d.js');
require('../../_chunks/dep-201f7798.js');
require('../../_chunks/dep-d3015b4c.js');
require('../../_chunks/dep-f8a85d6a.js');
require('../../_chunks/dep-5b117689.js');
require('../../_chunks/dep-6478392e.js');
require('../../_chunks/dep-47bca35e.js');
require('../../config.js');
require('../../_chunks/dep-013a3403.js');
require('../../_chunks/dep-8cb0d589.js');
require('../../_chunks/dep-d23147db.js');
require('../../_chunks/dep-de60f5aa.js');
require('../../_chunks/dep-63b02f7b.js');
require('../../_chunks/dep-bebcd284.js');
require('../../_chunks/dep-3eec664c.js');
require('../../_chunks/dep-eeb2e214.js');
require('../../_chunks/dep-315a67f0.js');
require('../../_chunks/dep-f84d1ea5.js');
require('../../_chunks/dep-362bc4d7.js');
require('../../_chunks/dep-2e32c1f2.js');
require('../../_chunks/dep-f14aac54.js');
require('../../utils/withInstall.js');
require('../../config-provider/useConfig.js');
require('../../image-viewer/image-viewer.js');
require('../../image-viewer/props.js');
require('../../image-viewer/base/Container.js');
require('../../image-viewer/base/ImageModalIcon.js');
require('../../hooks/useConfig.js');
require('../../hooks/tnode.js');
require('../../hooks/render-tnode.js');
require('../../_chunks/dep-a6490a32.js');
require('../../image-viewer/base/ImageViewerUtils.js');
require('../../tooltip/index.js');
require('../../tooltip/tooltip.js');
require('../../tooltip/props.js');
require('../../popup/props.js');
require('../../popup/popup.js');
require('@popperjs/core');
require('../../utils/helper.js');
require('../../popup/container.js');
require('../../utils/event.js');
require('../../popup/utils.js');
require('../../_chunks/dep-f3761329.js');
require('../../_chunks/dep-848a5a32.js');
require('../../utils/map-props.js');
require('../../_common/js/input-number/large-number.js');
require('../../_common/js/log/log.js');
require('../../hooks/useImagePreviewUrl.js');
require('../../image-viewer/base/ImageItem.js');
require('../../image-viewer/hooks.js');
require('../../image-viewer/const.js');
require('../../image-viewer/base/ImageViewerModal.js');
require('../../dialog/index.js');
require('../../dialog/dialog.js');
require('../../button/index.js');
require('../../button/button.js');
require('../../button/props.js');
require('../../utils/ripple.js');
require('../../dialog/actions.js');
require('../../dialog/props.js');
require('../../hooks/useDestroyOnClose.js');
require('../../dialog/stack.js');
require('../../_common/js/utils/getScrollbarWidth.js');
require('../../_chunks/dep-13309278.js');
require('../../dialog/plugin.js');
require('../../config-provider/config-provider.js');
require('../../config-provider/props.js');
require('../../_chunks/dep-f45125c9.js');
require('../../_chunks/dep-f33eb57d.js');
require('../../hooks/useVModel.js');
require('../../hooks/useDefaultValue.js');
require('../../image-viewer/utils.js');
require('../../image/image.js');
require('../../_common/js/utils/observe.js');
require('../../image/props.js');
require('../../space/index.js');
require('../../space/space.js');
require('../../space/props.js');
require('../../_chunks/dep-6dc0a916.js');
require('../../_chunks/dep-b5c96567.js');
require('../../_chunks/dep-a9e7deb2.js');
require('../../link/link.js');
require('../../link/props.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _toConsumableArray__default = /*#__PURE__*/_interopDefaultLegacy(_toConsumableArray);
var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var ImageCard = VueCompositionAPI.defineComponent({
  name: "UploadImageCard",
  props: _objectSpread(_objectSpread({}, upload_constants.commonProps), {}, {
    multiple: Boolean,
    max: Number,
    disabled: Boolean,
    showUploadProgress: Boolean,
    triggerUpload: Function,
    uploadFiles: Function,
    cancelUpload: Function,
    showImageFileName: Boolean
  }),
  setup: function setup(props) {
    var _toRefs = VueCompositionAPI.toRefs(props),
      displayFiles = _toRefs.displayFiles,
      multiple = _toRefs.multiple,
      max = _toRefs.max;
    var icons = hooks_useGlobalIcon.useGlobalIcon({
      AddIcon: tdesignIconsVue.AddIcon,
      BrowseIcon: tdesignIconsVue.BrowseIcon,
      DeleteIcon: tdesignIconsVue.DeleteIcon,
      ErrorCircleFilledIcon: tdesignIconsVue.ErrorCircleFilledIcon
    });
    var showTrigger = VueCompositionAPI.computed(function () {
      var _displayFiles$value;
      if (multiple.value) {
        return !max.value || displayFiles.value.length < max.value;
      }
      return !((_displayFiles$value = displayFiles.value) !== null && _displayFiles$value !== void 0 && _displayFiles$value[0]);
    });
    return {
      icons: icons,
      showTrigger: showTrigger
    };
  },
  methods: {
    renderMainContent: function renderMainContent(file, index) {
      var _this = this;
      var h = this.$createElement;
      var _this$icons = this.icons,
        BrowseIcon = _this$icons.BrowseIcon,
        DeleteIcon = _this$icons.DeleteIcon;
      return h("div", {
        "class": "".concat(this.classPrefix, "-upload__card-content ").concat(this.classPrefix, "-upload__card-box")
      }, [h(image_index.Image, {
        "class": "".concat(this.classPrefix, "-upload__card-image"),
        "attrs": {
          "src": file.url || file.raw,
          "error": "",
          "fit": "contain"
        }
      }), h("div", {
        "class": "".concat(this.classPrefix, "-upload__card-mask")
      }, [h("span", {
        "class": "".concat(this.classPrefix, "-upload__card-mask-item"),
        "on": {
          "click": function click(e) {
            return e.stopPropagation();
          }
        }
      }, [h(imageViewer_index.ImageViewer, helper.helper([{
        "attrs": {
          "images": this.displayFiles.map(function (t) {
            return t.url || t.raw;
          }),
          "defaultIndex": index,
          "trigger": function trigger(h, _ref) {
            var open = _ref.open;
            return h(BrowseIcon, {
              "on": {
                "click": function click(_ref2) {
                  var e = _ref2.e;
                  _this.$emit("preview", {
                    file: file,
                    index: index,
                    e: e
                  });
                  open();
                }
              }
            });
          }
        }
      }, {
        "props": this.imageViewerProps
      }]))]), !this.disabled && [h("span", {
        "class": "".concat(this.classPrefix, "-upload__card-mask-item-divider")
      }), h("span", {
        "class": "".concat(this.classPrefix, "-upload__card-mask-item"),
        "on": {
          "click": function click(e) {
            return e.stopPropagation();
          }
        }
      }, [h(DeleteIcon, {
        "on": {
          "click": function click(_ref3) {
            var _this$onRemove;
            var e = _ref3.e;
            return (_this$onRemove = _this.onRemove) === null || _this$onRemove === void 0 ? void 0 : _this$onRemove.call(_this, {
              e: e,
              file: file,
              index: index
            });
          }
        }
      })])]])]);
    },
    renderProgressFile: function renderProgressFile(file, loadCard) {
      var _this$locale;
      var h = this.$createElement;
      return h("div", {
        "class": [loadCard, "".concat(this.classPrefix, "-upload__").concat(this.theme, "-").concat(file.status)]
      }, [h(loading_index.Loading, {
        "attrs": {
          "loading": true,
          "size": "medium"
        }
      }), h("p", [(_this$locale = this.locale) === null || _this$locale === void 0 || (_this$locale = _this$locale.progress) === null || _this$locale === void 0 ? void 0 : _this$locale.uploadingText, this.showUploadProgress ? " ".concat(file.percent, "%") : ""])]);
    },
    renderFailFile: function renderFailFile(file, index, loadCard) {
      var _file$response,
        _this$locale2,
        _this2 = this;
      var h = this.$createElement;
      var _this$icons2 = this.icons,
        ErrorCircleFilledIcon = _this$icons2.ErrorCircleFilledIcon,
        DeleteIcon = _this$icons2.DeleteIcon;
      return h("div", {
        "class": loadCard
      }, [h(ErrorCircleFilledIcon), h("p", [((_file$response = file.response) === null || _file$response === void 0 ? void 0 : _file$response.error) || ((_this$locale2 = this.locale) === null || _this$locale2 === void 0 || (_this$locale2 = _this$locale2.progress) === null || _this$locale2 === void 0 ? void 0 : _this$locale2.failText)]), h("div", {
        "class": "".concat(this.classPrefix, "-upload__card-mask")
      }, [h("span", {
        "class": "".concat(this.classPrefix, "-upload__card-mask-item"),
        "on": {
          "click": function click(e) {
            return e.stopPropagation();
          }
        }
      }, [h(DeleteIcon, {
        "on": {
          "click": function click(_ref4) {
            var _this2$onRemove;
            var e = _ref4.e;
            return (_this2$onRemove = _this2.onRemove) === null || _this2$onRemove === void 0 ? void 0 : _this2$onRemove.call(_this2, {
              e: e,
              file: file,
              index: index
            });
          }
        }
      })])])]);
    }
  },
  render: function render() {
    var _this$displayFiles,
      _this3 = this,
      _this$locale3;
    var h = arguments[0];
    var customList = utils_renderTnode.renderTNodeJSX(this, "fileListDisplay", {
      params: {
        files: this.displayFiles,
        onPreview: this.onPreview,
        toUploadFiles: this.toUploadFiles,
        sizeOverLimitMessage: this.sizeOverLimitMessage,
        locale: this.locale,
        triggerUpload: this.triggerUpload,
        uploadFiles: this.uploadFiles,
        cancelUpload: this.cancelUpload,
        onRemove: this.onRemove
      }
    });
    if (customList) return customList;
    var cardItemClasses = "".concat(this.classPrefix, "-upload__card-item ").concat(this.classPrefix, "-is-background");
    var AddIcon = this.icons.AddIcon;
    return h("div", [h("ul", {
      "class": "".concat(this.classPrefix, "-upload__card")
    }, [(_this$displayFiles = this.displayFiles) === null || _this$displayFiles === void 0 ? void 0 : _this$displayFiles.map(function (file, index) {
      var loadCard = "".concat(_this3.classPrefix, "-upload__card-container ").concat(_this3.classPrefix, "-upload__card-box");
      var fileName = _this3.abridgeName ? _common_js_upload_utils.abridgeName.apply(void 0, [file.name].concat(_toConsumableArray__default["default"](_this3.abridgeName))) : file.name;
      var fileNameClassName = "".concat(_this3.classPrefix, "-upload__card-name");
      return h("li", {
        "class": cardItemClasses,
        "key": index
      }, [file.status === "progress" && _this3.renderProgressFile(file, loadCard), file.status === "fail" && _this3.renderFailFile(file, index, loadCard), !["progress", "fail"].includes(file.status) && _this3.renderMainContent(file, index), fileName && _this3.showImageFileName && (file.url ? h(link_index.Link, {
        "attrs": {
          "href": file.url,
          "target": "_blank",
          "hover": "color",
          "size": "small"
        },
        "class": fileNameClassName
      }, [fileName]) : h("span", {
        "class": fileNameClassName
      }, [fileName]))]);
    }), this.showTrigger && h("li", {
      "class": cardItemClasses,
      "on": {
        "click": this.triggerUpload
      }
    }, [h("div", {
      "class": ["".concat(this.classPrefix, "-upload__image-add ").concat(this.classPrefix, "-upload__card-container ").concat(this.classPrefix, "-upload__card-box"), _defineProperty__default["default"]({}, "".concat(this.classPrefix, "-is-disabled"), this.disabled)]
    }, [h(AddIcon), h("p", {
      "class": "".concat(this.classPrefix, "-size-s ").concat(this.classPrefix, "-upload__add-text")
    }, [(_this$locale3 = this.locale) === null || _this$locale3 === void 0 || (_this$locale3 = _this$locale3.triggerUploadText) === null || _this$locale3 === void 0 ? void 0 : _this$locale3.image])])])])]);
  }
});

exports["default"] = ImageCard;
//# sourceMappingURL=image-card.js.map
