/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var helper = require('../../_chunks/dep-ece3c062.js');
var _toConsumableArray = require('@babel/runtime/helpers/toConsumableArray');
var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var VueCompositionAPI = require('@vue/composition-api');
var tdesignIconsVue = require('tdesign-icons-vue');
var hooks_useGlobalIcon = require('../../hooks/useGlobalIcon.js');
var imageViewer_index = require('../../image-viewer/index.js');
var upload_constants = require('../constants.js');
var button_index = require('../../button/index.js');
var upload_hooks_useDrag = require('../hooks/useDrag.js');
var _common_js_upload_utils = require('../../_common/js/upload/utils.js');
var loading_index = require('../../loading/index.js');
var link_index = require('../../link/index.js');
var utils_renderTnode = require('../../utils/render-tnode.js');
var image_index = require('../../image/index.js');
var isFunction = require('../../_chunks/dep-ecccff93.js');
var isObject = require('../../_chunks/dep-a4cecac4.js');
require('../../config-provider/useConfig.js');
require('../../_chunks/dep-07fb8c0e.js');
require('../../_common/js/global-config/default-config.js');
require('../../_common/js/global-config/locale/zh_CN.js');
require('../../_chunks/dep-a4a18104.js');
require('@babel/runtime/helpers/typeof');
require('../../_chunks/dep-27dd8cc6.js');
require('dayjs');
require('../../_chunks/dep-87c765cc.js');
require('../../_chunks/dep-75cd6d52.js');
require('../../_chunks/dep-b1a02818.js');
require('../../_chunks/dep-3d8ab37d.js');
require('../../_chunks/dep-a4308f57.js');
require('../../_chunks/dep-ab142eaf.js');
require('../../_chunks/dep-6ad3de7c.js');
require('../../_chunks/dep-e4278c54.js');
require('../../_chunks/dep-fcf0662d.js');
require('../../_chunks/dep-8b1e056e.js');
require('../../_chunks/dep-5db8defc.js');
require('../../_chunks/dep-6e4c473c.js');
require('../../_chunks/dep-234b7c02.js');
require('../../_chunks/dep-a4747856.js');
require('../../_chunks/dep-932dd69e.js');
require('../../_chunks/dep-9f4caea4.js');
require('../../_chunks/dep-dbd838d6.js');
require('../../_chunks/dep-b3120c1b.js');
require('../../_chunks/dep-68ba2357.js');
require('../../_chunks/dep-173eb46c.js');
require('../../image-viewer/image-viewer.js');
require('@babel/runtime/helpers/slicedToArray');
require('../../image-viewer/props.js');
require('../../image-viewer/base/Container.js');
require('vue');
require('../../utils/dom.js');
require('raf');
require('../../utils/easing.js');
require('../../_chunks/dep-738b4f21.js');
require('../../image-viewer/base/ImageModalIcon.js');
require('../../hooks/useConfig.js');
require('../../hooks/tnode.js');
require('../../hooks/render-tnode.js');
require('../../_chunks/dep-7c854ec6.js');
require('../../_chunks/dep-eceed11d.js');
require('../../_chunks/dep-201f7798.js');
require('../../_chunks/dep-d3015b4c.js');
require('../../_chunks/dep-f8a85d6a.js');
require('../../_chunks/dep-5b117689.js');
require('../../_chunks/dep-6478392e.js');
require('../../_chunks/dep-47bca35e.js');
require('../../_chunks/dep-a6490a32.js');
require('../../_chunks/dep-3eec664c.js');
require('../../_chunks/dep-eeb2e214.js');
require('../../image-viewer/base/ImageViewerUtils.js');
require('../../tooltip/index.js');
require('../../tooltip/tooltip.js');
require('../../tooltip/props.js');
require('../../popup/props.js');
require('../../popup/popup.js');
require('@popperjs/core');
require('../../utils/helper.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('../../_common/js/utils/setStyle.js');
require('../../popup/container.js');
require('../../config-provider/config-receiver.js');
require('../../utils/mixins.js');
require('../../utils/event.js');
require('../../popup/utils.js');
require('../../_chunks/dep-f3761329.js');
require('../../_chunks/dep-848a5a32.js');
require('@babel/runtime/helpers/readOnlyError');
require('../../utils/map-props.js');
require('../../utils/withInstall.js');
require('../../_common/js/input-number/large-number.js');
require('../../_common/js/log/log.js');
require('../../_chunks/dep-aa0a4aac.js');
require('../../hooks/useImagePreviewUrl.js');
require('../../image-viewer/base/ImageItem.js');
require('../../image-viewer/hooks.js');
require('../../image-viewer/const.js');
require('../../image-viewer/base/ImageViewerModal.js');
require('../../dialog/index.js');
require('../../dialog/dialog.js');
require('../../dialog/actions.js');
require('../../button/button.js');
require('../../button/props.js');
require('../../utils/ripple.js');
require('../../config.js');
require('../../loading/directive.js');
require('../../loading/plugin.js');
require('../../loading/loading.js');
require('../../loading/icon/gradient.js');
require('../../_common/js/loading/circle-adapter.js');
require('../../_common/js/utils/helper.js');
require('../../_chunks/dep-62de1188.js');
require('../../_chunks/dep-867c284e.js');
require('../../utils/transfer-dom.js');
require('../../loading/props.js');
require('../../_chunks/dep-013a3403.js');
require('../../_chunks/dep-8cb0d589.js');
require('../../_chunks/dep-d23147db.js');
require('../../_chunks/dep-de60f5aa.js');
require('../../_chunks/dep-63b02f7b.js');
require('../../_chunks/dep-bebcd284.js');
require('../../_chunks/dep-315a67f0.js');
require('../../_chunks/dep-f84d1ea5.js');
require('../../_chunks/dep-362bc4d7.js');
require('../../_chunks/dep-2e32c1f2.js');
require('../../_chunks/dep-f14aac54.js');
require('../../dialog/props.js');
require('../../hooks/useDestroyOnClose.js');
require('../../dialog/stack.js');
require('../../_common/js/utils/getScrollbarWidth.js');
require('../../_chunks/dep-13309278.js');
require('../../dialog/plugin.js');
require('../../config-provider/config-provider.js');
require('../../config-provider/props.js');
require('../../_chunks/dep-f45125c9.js');
require('../../_chunks/dep-f33eb57d.js');
require('../../hooks/useVModel.js');
require('../../hooks/useDefaultValue.js');
require('../../image-viewer/utils.js');
require('../../image/image.js');
require('../../_common/js/utils/observe.js');
require('../../image/props.js');
require('../../space/index.js');
require('../../space/space.js');
require('../../space/props.js');
require('../../_chunks/dep-6dc0a916.js');
require('../../_chunks/dep-b5c96567.js');
require('../../_chunks/dep-a9e7deb2.js');
require('../../link/link.js');
require('../../link/props.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _toConsumableArray__default = /*#__PURE__*/_interopDefaultLegacy(_toConsumableArray);
var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var MultipleFlowList = VueCompositionAPI.defineComponent({
  name: "UploadMultipleFlowList",
  props: _objectSpread(_objectSpread({}, upload_constants.commonProps), {}, {
    uploadFiles: Function,
    cancelUpload: Function,
    dragEvents: Object,
    disabled: Boolean,
    isBatchUpload: Boolean,
    draggable: Boolean,
    showThumbnail: Boolean,
    showImageFileName: Boolean,
    uploadButton: Object,
    cancelUploadButton: Object
  }),
  setup: function setup(props, context) {
    var _toRefs = VueCompositionAPI.toRefs(props),
      locale = _toRefs.locale,
      uploading = _toRefs.uploading,
      classPrefix = _toRefs.classPrefix,
      accept = _toRefs.accept;
    var uploadPrefix = "".concat(classPrefix.value, "-upload");
    var icons = hooks_useGlobalIcon.useGlobalIcon({
      BrowseIcon: tdesignIconsVue.BrowseIcon,
      DeleteIcon: tdesignIconsVue.DeleteIcon,
      CheckCircleFilledIcon: tdesignIconsVue.CheckCircleFilledIcon,
      ErrorCircleFilledIcon: tdesignIconsVue.ErrorCircleFilledIcon,
      TimeFilledIcon: tdesignIconsVue.TimeFilledIcon,
      FileExcelIcon: tdesignIconsVue.FileExcelIcon,
      FilePdfIcon: tdesignIconsVue.FilePdfIcon,
      FileWordIcon: tdesignIconsVue.FileWordIcon,
      FilePowerpointIcon: tdesignIconsVue.FilePowerpointIcon,
      FileIcon: tdesignIconsVue.FileIcon,
      VideoIcon: tdesignIconsVue.VideoIcon
    });
    var drag = upload_hooks_useDrag["default"](props.dragEvents, accept);
    var currentPreviewFile = VueCompositionAPI.ref([]);
    var previewIndex = VueCompositionAPI.ref(0);
    var uploadText = VueCompositionAPI.computed(function () {
      if (uploading.value) return "".concat(locale.value.progress.uploadingText);
      return locale.value.triggerUploadText.normal;
    });
    var innerDragEvents = VueCompositionAPI.computed(function () {
      var draggable = props.draggable === void 0 ? true : props.draggable;
      return draggable ? {
        drop: drag.handleDrop,
        dragenter: drag.handleDragenter,
        dragover: drag.handleDragover,
        dragleave: drag.handleDragleave
      } : {};
    });
    var browseIconClick = function browseIconClick(_ref) {
      var e = _ref.e,
        index = _ref.index,
        file = _ref.file,
        viewFiles = _ref.viewFiles;
      previewIndex.value = index;
      currentPreviewFile.value = viewFiles;
      context.emit("preview", {
        file: file,
        index: index,
        e: e
      });
    };
    var previewIndexChange = function previewIndexChange(index) {
      previewIndex.value = index;
    };
    var closePreview = function closePreview() {
      currentPreviewFile.value = [];
    };
    var onVue2Preview = function onVue2Preview(params) {
      context.emit("preview", params);
    };
    return {
      icons: icons,
      dragActive: drag.dragActive,
      uploadPrefix: uploadPrefix,
      uploadText: uploadText,
      innerDragEvents: innerDragEvents,
      currentPreviewFile: currentPreviewFile,
      previewIndex: previewIndex,
      onVue2Preview: onVue2Preview,
      browseIconClick: browseIconClick,
      closePreview: closePreview,
      previewIndexChange: previewIndexChange
    };
  },
  methods: {
    getStatusMap: function getStatusMap() {
      var h = this.$createElement;
      var _this$icons = this.icons,
        CheckCircleFilledIcon = _this$icons.CheckCircleFilledIcon,
        ErrorCircleFilledIcon = _this$icons.ErrorCircleFilledIcon,
        TimeFilledIcon = _this$icons.TimeFilledIcon;
      var iconMap = {
        success: h(CheckCircleFilledIcon),
        fail: h(ErrorCircleFilledIcon),
        progress: h(loading_index.Loading),
        waiting: h(TimeFilledIcon)
      };
      var progress = this.locale.progress;
      var textMap = {
        success: progress === null || progress === void 0 ? void 0 : progress.successText,
        fail: progress === null || progress === void 0 ? void 0 : progress.failText,
        progress: progress === null || progress === void 0 ? void 0 : progress.uploadingText,
        waiting: progress === null || progress === void 0 ? void 0 : progress.waitingText
      };
      return {
        iconMap: iconMap,
        textMap: textMap
      };
    },
    renderEmpty: function renderEmpty() {
      var h = this.$createElement;
      return h("div", {
        "class": "".concat(this.uploadPrefix, "__flow-empty")
      }, [this.dragActive ? this.locale.dragger.dragDropText : this.locale.dragger.clickAndDragText]);
    },
    renderImgItem: function renderImgItem(file, index) {
      var _this = this;
      var h = this.$createElement;
      var _this$getStatusMap = this.getStatusMap(),
        iconMap = _this$getStatusMap.iconMap,
        textMap = _this$getStatusMap.textMap;
      var _this$icons2 = this.icons,
        BrowseIcon = _this$icons2.BrowseIcon,
        DeleteIcon = _this$icons2.DeleteIcon;
      var fileName = this.abridgeName && file.name ? _common_js_upload_utils.abridgeName.apply(void 0, [file.name].concat(_toConsumableArray__default["default"](this.abridgeName))) : file.name;
      return h("li", {
        "class": "".concat(this.uploadPrefix, "__card-item"),
        "key": file.name + index + file.percent + file.status
      }, [h("div", {
        "class": ["".concat(this.uploadPrefix, "__card-content"), _defineProperty__default["default"]({}, "".concat(this.classPrefix, "-is-bordered"), file.status !== "waiting")]
      }, [["fail", "progress"].includes(file.status) && h("div", {
        "class": "".concat(this.uploadPrefix, "__card-status-wrap ").concat(this.uploadPrefix, "__").concat(this.theme, "-").concat(file.status)
      }, [iconMap[file.status], h("p", [textMap[file.status], file.status === "progress" ? " ".concat(file.percent, "%") : ""])]), (["waiting", "success"].includes(file.status) || !file.status && file.url) && h(image_index.Image, {
        "class": "".concat(this.uploadPrefix, "__card-image"),
        "attrs": {
          "src": file.url || file.raw,
          "error": "",
          "loading": "",
          "fit": "contain"
        }
      }), h("div", {
        "class": "".concat(this.uploadPrefix, "__card-mask")
      }, [(file.url || file.raw) && !["progress", "fail"].includes(file.status) && h("span", {
        "class": "".concat(this.uploadPrefix, "__card-mask-item")
      }, [h(BrowseIcon, {
        "on": {
          "click": function click(_ref3) {
            var e = _ref3.e;
            _this.browseIconClick({
              e: e,
              index: index,
              file: file,
              viewFiles: _this.displayFiles
            });
          }
        }
      }), h("span", {
        "class": "".concat(this.uploadPrefix, "__card-mask-item-divider")
      })]), !this.disabled && h("span", {
        "class": "".concat(this.uploadPrefix, "__card-mask-item ").concat(this.uploadPrefix, "__delete"),
        "on": {
          "click": function click(e) {
            return _this.onRemove({
              e: e,
              index: index,
              file: file
            });
          }
        }
      }, [h(DeleteIcon)])])]), this.showImageFileName && h("p", {
        "class": ["".concat(this.uploadPrefix, "__card-name"), "".concat(this.uploadPrefix, "__flow-status")]
      }, [["success", "waiting"].includes(file.status) && iconMap[file.status], fileName])]);
    },
    renderStatus: function renderStatus(file) {
      var _file$response, _file$response2;
      var h = this.$createElement;
      var _this$getStatusMap2 = this.getStatusMap(),
        iconMap = _this$getStatusMap2.iconMap,
        textMap = _this$getStatusMap2.textMap;
      return h("div", {
        "class": "".concat(this.uploadPrefix, "__flow-status")
      }, [iconMap[file.status], h("span", {
        "class": "".concat(this.uploadPrefix, "__").concat(this.theme, "-").concat(file.status)
      }, [(_file$response = file.response) !== null && _file$response !== void 0 && _file$response.error ? ((_file$response2 = file.response) === null || _file$response2 === void 0 ? void 0 : _file$response2.error) || textMap[file.status] : textMap[file.status], this.showUploadProgress && file.status === "progress" ? " ".concat(file.percent || 0, "%") : ""])]);
    },
    renderNormalActionCol: function renderNormalActionCol(file, index) {
      var _this$locale,
        _this2 = this;
      var h = this.$createElement;
      return h("td", [h(button_index.Button, {
        "attrs": {
          "theme": "primary",
          "variant": "text",
          "content": (_this$locale = this.locale) === null || _this$locale === void 0 || (_this$locale = _this$locale.triggerUploadText) === null || _this$locale === void 0 ? void 0 : _this$locale["delete"]
        },
        "class": "".concat(this.uploadPrefix, "__delete"),
        "on": {
          "click": function click(e) {
            return _this2.onRemove({
              e: e,
              index: index,
              file: file
            });
          }
        }
      })]);
    },
    renderBatchActionCol: function renderBatchActionCol(index) {
      var _this$locale2,
        _this3 = this;
      var h = this.$createElement;
      return index === 0 ? h("td", {
        "attrs": {
          "rowSpan": this.displayFiles.length
        },
        "class": "".concat(this.uploadPrefix, "__flow-table__batch-row")
      }, [h(button_index.Button, {
        "attrs": {
          "theme": "primary",
          "variant": "text",
          "content": (_this$locale2 = this.locale) === null || _this$locale2 === void 0 || (_this$locale2 = _this$locale2.triggerUploadText) === null || _this$locale2 === void 0 ? void 0 : _this$locale2["delete"]
        },
        "class": "".concat(this.uploadPrefix, "__delete"),
        "on": {
          "click": function click(e) {
            return _this3.onRemove({
              e: e,
              index: -1,
              file: void 0
            });
          }
        }
      })]) : null;
    },
    renderFileList: function renderFileList() {
      var _this$locale$file,
        _this$locale$file2,
        _this$locale$file3,
        _this$locale$file4,
        _this4 = this;
      var h = this.$createElement;
      var list = utils_renderTnode.renderTNodeJSX(this, "fileListDisplay", {
        params: {
          cancelUpload: this.cancelUpload,
          uploadFiles: this.uploadFiles,
          onRemove: this.onRemove,
          toUploadFiles: this.toUploadFiles,
          sizeOverLimitMessage: this.sizeOverLimitMessage,
          locale: this.locale,
          files: this.displayFiles,
          dragEvents: this.innerDragEvents
        }
      });
      if (list) return list;
      return h("table", helper.helper([{
        "class": "".concat(this.uploadPrefix, "__flow-table")
      }, {
        "on": this.innerDragEvents
      }]), [h("thead", [h("tr", [h("th", [(_this$locale$file = this.locale.file) === null || _this$locale$file === void 0 ? void 0 : _this$locale$file.fileNameText]), h("th", {
        "style": {
          minWidth: "120px"
        }
      }, [(_this$locale$file2 = this.locale.file) === null || _this$locale$file2 === void 0 ? void 0 : _this$locale$file2.fileSizeText]), h("th", {
        "style": {
          minWidth: "120px"
        }
      }, [(_this$locale$file3 = this.locale.file) === null || _this$locale$file3 === void 0 ? void 0 : _this$locale$file3.fileStatusText]), this.disabled ? null : h("th", [(_this$locale$file4 = this.locale.file) === null || _this$locale$file4 === void 0 ? void 0 : _this$locale$file4.fileOperationText])])]), h("tbody", [!this.displayFiles.length && h("tr", [h("td", {
        "attrs": {
          "colSpan": 4
        }
      }, [this.renderEmpty()])]), this.displayFiles.map(function (file, index) {
        var _this4$abridgeName;
        var showBatchUploadAction = _this4.isBatchUpload;
        var deleteNode = showBatchUploadAction && _this4.displayFiles.every(function (item) {
          return item.status === "success" || !item.status;
        }) ? _this4.renderBatchActionCol(index) : _this4.renderNormalActionCol(file, index);
        var fileName = (_this4$abridgeName = _this4.abridgeName) !== null && _this4$abridgeName !== void 0 && _this4$abridgeName.length ? _common_js_upload_utils.abridgeName.apply(void 0, [file.name].concat(_toConsumableArray__default["default"](_this4.abridgeName))) : file.name;
        var thumbnailNode = _this4.showThumbnail ? h("div", {
          "class": "".concat(_this4.uploadPrefix, "__file-info")
        }, [_this4.renderFileThumbnail(file), fileName]) : fileName;
        var fileNameNode = file.url ? h(link_index.Link, {
          "attrs": {
            "href": file.url,
            "target": "_blank",
            "hover": "color"
          }
        }, [thumbnailNode]) : thumbnailNode;
        return h("tr", {
          "key": file.name + index
        }, [h("td", {
          "class": "".concat(_this4.uploadPrefix, "__file-name")
        }, [fileNameNode]), h("td", [_common_js_upload_utils.returnFileSize(file.size)]), h("td", [_this4.renderStatus(file)]), _this4.disabled ? null : deleteNode]);
      })])]);
    },
    renderImageList: function renderImageList() {
      var _this5 = this;
      var h = this.$createElement;
      var customList = utils_renderTnode.renderTNodeJSX(this, "fileListDisplay", {
        params: {
          cancelUpload: this.cancelUpload,
          uploadFiles: this.uploadFiles,
          onRemove: this.onRemove,
          onPreview: this.onVue2Preview,
          toUploadFiles: this.toUploadFiles,
          sizeOverLimitMessage: this.sizeOverLimitMessage,
          locale: this.locale,
          files: this.displayFiles,
          dragEvents: this.innerDragEvents
        }
      });
      if (customList) return customList;
      return h("ul", {
        "class": "".concat(this.uploadPrefix, "__card clearfix")
      }, [this.displayFiles.map(function (file, index) {
        return _this5.renderImgItem(file, index);
      })]);
    },
    getFileThumbnailIcon: function getFileThumbnailIcon(fileType) {
      var h = this.$createElement;
      var _this$icons3 = this.icons,
        FilePdfIcon = _this$icons3.FilePdfIcon,
        FileExcelIcon = _this$icons3.FileExcelIcon,
        FileWordIcon = _this$icons3.FileWordIcon,
        FilePowerpointIcon = _this$icons3.FilePowerpointIcon,
        VideoIcon = _this$icons3.VideoIcon,
        FileIcon = _this$icons3.FileIcon;
      if (_common_js_upload_utils.FILE_PDF_REGEXP.test(fileType)) {
        return h(FilePdfIcon);
      }
      if (_common_js_upload_utils.FILE_EXCEL_REGEXP.test(fileType)) {
        return h(FileExcelIcon);
      }
      if (_common_js_upload_utils.FILE_WORD_REGEXP.test(fileType)) {
        return h(FileWordIcon);
      }
      if (_common_js_upload_utils.FILE_PPT_REGEXP.test(fileType)) {
        return h(FilePowerpointIcon);
      }
      if (_common_js_upload_utils.VIDEO_REGEXP.test(fileType)) {
        return h(VideoIcon);
      }
      return h(FileIcon);
    },
    renderFileThumbnail: function renderFileThumbnail(file) {
      var _this6 = this;
      var h = this.$createElement;
      if (!file || !file.raw && file.url) return null;
      var fileType = file.raw.type;
      var className = "".concat(this.uploadPrefix, "__file-thumbnail");
      if (_common_js_upload_utils.IMAGE_REGEXP.test(fileType)) {
        return h(image_index.Image, {
          "class": className,
          "attrs": {
            "src": file.url || file.raw,
            "fit": "scale-down",
            "error": "",
            "loading": ""
          },
          "on": {
            "click": function click(e) {
              e.preventDefault();
              _this6.browseIconClick({
                e: e,
                index: 0,
                file: file,
                viewFiles: [file]
              });
            }
          }
        });
      }
      return h("div", {
        "class": className
      }, [this.getFileThumbnailIcon(fileType)]);
    }
  },
  render: function render() {
    var _this$$scopedSlots$de,
      _this$$scopedSlots,
      _this$locale3,
      _this$locale4,
      _this7 = this;
    var h = arguments[0];
    var cardClassName = "".concat(this.uploadPrefix, "__flow-card-area");
    var isShowBottomButton = !this.autoUpload && (this.uploadButton !== null || this.cancelUploadButton !== null);
    var cancelUploadDisabled = this.disabled || !this.uploading;
    var hasCancelUploadTNode = this.$scopedSlots.uploadButton || isFunction.isFunction(this.uploadButton);
    var uploadButtonDisabled = Boolean(this.disabled || this.uploading || !this.displayFiles.length);
    var hasUploadButtonTNode = this.$scopedSlots.cancelUploadButton || isFunction.isFunction(this.cancelUploadButton);
    return h("div", {
      "class": "".concat(this.uploadPrefix, "__flow ").concat(this.uploadPrefix, "__flow-").concat(this.theme)
    }, [h("div", {
      "class": "".concat(this.uploadPrefix, "__flow-op")
    }, [(_this$$scopedSlots$de = (_this$$scopedSlots = this.$scopedSlots)["default"]) === null || _this$$scopedSlots$de === void 0 ? void 0 : _this$$scopedSlots$de.call(_this$$scopedSlots, null), this.placeholder && h("small", {
      "class": "".concat(this.uploadPrefix, "__flow-placeholder ").concat(this.uploadPrefix, "__placeholder")
    }, [this.placeholder])]), this.theme === "image-flow" && h("div", helper.helper([{
      "class": cardClassName
    }, {
      "on": this.innerDragEvents
    }]), [this.displayFiles.length ? this.renderImageList() : this.renderEmpty()]), this.theme === "file-flow" && (this.displayFiles.length ? this.renderFileList() : h("div", helper.helper([{
      "class": cardClassName
    }, {
      "on": this.innerDragEvents
    }]), [this.renderEmpty()])), isShowBottomButton && h("div", {
      "class": "".concat(this.uploadPrefix, "__flow-bottom")
    }, [this.cancelUploadButton !== null && (hasCancelUploadTNode ? utils_renderTnode.renderTNodeJSX(this, "cancelUploadButton", {
      params: {
        disabled: cancelUploadDisabled,
        cancelUploadText: (_this$locale3 = this.locale) === null || _this$locale3 === void 0 ? void 0 : _this$locale3.cancelUploadText,
        cancelUpload: this.cancelUpload
      }
    }) : h(button_index.Button, helper.helper([{
      "attrs": {
        "theme": "default",
        "disabled": this.disabled || !this.uploading,
        "content": (_this$locale4 = this.locale) === null || _this$locale4 === void 0 ? void 0 : _this$locale4.cancelUploadText
      },
      "class": "".concat(this.uploadPrefix, "__cancel")
    }, {
      "props": isObject.isObject(this.cancelUploadButton) ? this.cancelUploadButton : {}
    }, {
      "on": {
        "click": function click(e) {
          var _this7$cancelUpload;
          return (_this7$cancelUpload = _this7.cancelUpload) === null || _this7$cancelUpload === void 0 ? void 0 : _this7$cancelUpload.call(_this7, {
            e: e
          });
        }
      }
    }]))), this.uploadButton !== null && (hasUploadButtonTNode ? utils_renderTnode.renderTNodeJSX(this, "uploadButton", {
      params: {
        disabled: uploadButtonDisabled,
        uploading: this.uploading,
        uploadText: this.uploadText,
        uploadFiles: this.uploadFiles
      }
    }) : h(button_index.Button, helper.helper([{
      "attrs": {
        "disabled": this.disabled || this.uploading || !this.displayFiles.length,
        "theme": "primary",
        "loading": this.uploading,
        "content": this.uploadText
      },
      "class": "".concat(this.uploadPrefix, "__continue")
    }, {
      "props": isObject.isObject(this.uploadButton) ? this.uploadButton : {}
    }, {
      "on": {
        "click": function click() {
          var _this7$uploadFiles;
          return (_this7$uploadFiles = _this7.uploadFiles) === null || _this7$uploadFiles === void 0 ? void 0 : _this7$uploadFiles.call(_this7);
        }
      }
    }])))]), h(imageViewer_index.ImageViewer, helper.helper([{
      "attrs": {
        "images": this.currentPreviewFile.map(function (t) {
          return t.url || t.raw;
        }),
        "visible": !!this.currentPreviewFile.length,
        "index": this.previewIndex
      },
      "on": {
        "close": this.closePreview
      }
    }, {
      "on": {
        "index-change": this.previewIndexChange
      }
    }, {}, {
      "props": this.imageViewerProps
    }]))]);
  }
});

exports["default"] = MultipleFlowList;
//# sourceMappingURL=multiple-flow-list.js.map
