/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _toConsumableArray = require('@babel/runtime/helpers/toConsumableArray');
var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var VueCompositionAPI = require('@vue/composition-api');
var tdesignIconsVue = require('tdesign-icons-vue');
var loading_index = require('../../loading/index.js');
var link_index = require('../../link/index.js');
var utils_renderTnode = require('../../utils/render-tnode.js');
var _common_js_upload_utils = require('../../_common/js/upload/utils.js');
var hooks_useGlobalIcon = require('../../hooks/useGlobalIcon.js');
var upload_constants = require('../constants.js');
require('../../loading/directive.js');
require('../../loading/plugin.js');
require('vue');
require('../../loading/loading.js');
require('../../loading/icon/gradient.js');
require('../../_common/js/loading/circle-adapter.js');
require('../../_common/js/utils/setStyle.js');
require('../../_common/js/utils/helper.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/slicedToArray');
require('../../_chunks/dep-62de1188.js');
require('../../_chunks/dep-867c284e.js');
require('../../_chunks/dep-738b4f21.js');
require('../../_chunks/dep-a4308f57.js');
require('@babel/runtime/helpers/typeof');
require('../../_chunks/dep-fcf0662d.js');
require('../../_chunks/dep-e4278c54.js');
require('../../_chunks/dep-aa0a4aac.js');
require('../../config-provider/config-receiver.js');
require('../../_chunks/dep-07fb8c0e.js');
require('../../_common/js/global-config/default-config.js');
require('../../_common/js/global-config/locale/zh_CN.js');
require('../../_chunks/dep-a4a18104.js');
require('../../_chunks/dep-27dd8cc6.js');
require('dayjs');
require('../../_chunks/dep-87c765cc.js');
require('../../_chunks/dep-75cd6d52.js');
require('../../_chunks/dep-b1a02818.js');
require('../../_chunks/dep-3d8ab37d.js');
require('../../_chunks/dep-ecccff93.js');
require('../../_chunks/dep-a4cecac4.js');
require('../../_chunks/dep-ab142eaf.js');
require('../../_chunks/dep-6ad3de7c.js');
require('../../_chunks/dep-8b1e056e.js');
require('../../_chunks/dep-5db8defc.js');
require('../../_chunks/dep-6e4c473c.js');
require('../../_chunks/dep-234b7c02.js');
require('../../_chunks/dep-a4747856.js');
require('../../_chunks/dep-932dd69e.js');
require('../../_chunks/dep-9f4caea4.js');
require('../../_chunks/dep-dbd838d6.js');
require('../../_chunks/dep-b3120c1b.js');
require('../../_chunks/dep-68ba2357.js');
require('../../_chunks/dep-173eb46c.js');
require('../../utils/mixins.js');
require('../../utils/dom.js');
require('raf');
require('../../utils/easing.js');
require('../../utils/transfer-dom.js');
require('../../loading/props.js');
require('@babel/runtime/helpers/readOnlyError');
require('../../_chunks/dep-7c854ec6.js');
require('../../_chunks/dep-eceed11d.js');
require('../../_chunks/dep-201f7798.js');
require('../../_chunks/dep-d3015b4c.js');
require('../../_chunks/dep-f8a85d6a.js');
require('../../_chunks/dep-5b117689.js');
require('../../_chunks/dep-6478392e.js');
require('../../_chunks/dep-47bca35e.js');
require('../../config.js');
require('../../_chunks/dep-013a3403.js');
require('../../_chunks/dep-8cb0d589.js');
require('../../_chunks/dep-d23147db.js');
require('../../_chunks/dep-de60f5aa.js');
require('../../_chunks/dep-63b02f7b.js');
require('../../_chunks/dep-bebcd284.js');
require('../../_chunks/dep-3eec664c.js');
require('../../_chunks/dep-eeb2e214.js');
require('../../_chunks/dep-315a67f0.js');
require('../../_chunks/dep-f84d1ea5.js');
require('../../_chunks/dep-362bc4d7.js');
require('../../_chunks/dep-2e32c1f2.js');
require('../../_chunks/dep-f14aac54.js');
require('../../utils/withInstall.js');
require('../../link/link.js');
require('../../link/props.js');
require('../../_common/js/log/log.js');
require('../../config-provider/useConfig.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _toConsumableArray__default = /*#__PURE__*/_interopDefaultLegacy(_toConsumableArray);
var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var NormalFile = VueCompositionAPI.defineComponent({
  name: "UploadNormalFile",
  props: _objectSpread({
    multiple: Boolean
  }, upload_constants.commonProps),
  setup: function setup(props) {
    var icons = hooks_useGlobalIcon.useGlobalIcon({
      CloseIcon: tdesignIconsVue.CloseIcon,
      TimeFilledIcon: tdesignIconsVue.TimeFilledIcon,
      CheckCircleFilledIcon: tdesignIconsVue.CheckCircleFilledIcon,
      ErrorCircleFilledIcon: tdesignIconsVue.ErrorCircleFilledIcon,
      CloseCircleFilledIcon: tdesignIconsVue.CloseCircleFilledIcon
    });
    var uploadPrefix = VueCompositionAPI.computed(function () {
      return "".concat(props.classPrefix, "-upload");
    });
    var classes = VueCompositionAPI.computed(function () {
      return ["".concat(uploadPrefix.value, "__single"), "".concat(uploadPrefix.value, "__single-").concat(props.theme)];
    });
    return {
      classes: classes,
      uploadPrefix: uploadPrefix,
      icons: icons
    };
  },
  methods: {
    renderProgress: function renderProgress(percent) {
      var h = this.$createElement;
      return h("div", {
        "class": "".concat(this.uploadPrefix, "__single-progress")
      }, [h(loading_index.Loading), h("span", {
        "class": "".concat(this.uploadPrefix, "__single-percent")
      }, [percent || 0, "%"])]);
    },
    renderFilePreviewAsText: function renderFilePreviewAsText(files) {
      var _files$,
        _this = this;
      var h = this.$createElement;
      if (this.theme !== "file") return null;
      if (!this.multiple && ((_files$ = files[0]) === null || _files$ === void 0 ? void 0 : _files$.status) === "fail" && this.autoUpload) {
        return null;
      }
      var _this$icons = this.icons,
        ErrorCircleFilledIcon = _this$icons.ErrorCircleFilledIcon,
        TimeFilledIcon = _this$icons.TimeFilledIcon,
        CloseIcon = _this$icons.CloseIcon;
      return files.map(function (file, index) {
        var fileName = _this.abridgeName && file.name ? _common_js_upload_utils.abridgeName.apply(void 0, [file.name].concat(_toConsumableArray__default["default"](_this.abridgeName))) : file.name;
        return h("div", {
          "class": "".concat(_this.uploadPrefix, "__single-display-text ").concat(_this.uploadPrefix, "__display-text--margin"),
          "key": file.name + index + file.percent + file.status
        }, [file.url ? h(link_index.Link, {
          "attrs": {
            "href": file.url,
            "target": "_blank",
            "hover": "color",
            "size": "small"
          },
          "class": "".concat(_this.uploadPrefix, "__single-name")
        }, [fileName]) : h("span", {
          "class": "".concat(_this.uploadPrefix, "__single-name")
        }, [fileName]), file.status === "fail" && h("div", {
          "class": "".concat(_this.uploadPrefix, "__flow-status ").concat(_this.uploadPrefix, "__file-fail")
        }, [h(ErrorCircleFilledIcon)]), file.status === "waiting" && h("div", {
          "class": "".concat(_this.uploadPrefix, "__flow-status ").concat(_this.uploadPrefix, "__file-waiting")
        }, [h(TimeFilledIcon)]), file.status === "progress" && _this.renderProgress(file.percent), !_this.disabled && file.status !== "progress" && h(CloseIcon, {
          "class": "".concat(_this.uploadPrefix, "__icon-delete"),
          "on": {
            "click": function click(_ref) {
              var e = _ref.e;
              return _this.onRemove({
                e: e,
                file: file,
                index: index
              });
            }
          }
        })]);
      });
    },
    renderFilePreviewAsInput: function renderFilePreviewAsInput() {
      var _this$abridgeName,
        _this2 = this;
      var h = this.$createElement;
      if (this.theme !== "file-input") return;
      var _this$icons2 = this.icons,
        TimeFilledIcon = _this$icons2.TimeFilledIcon,
        CheckCircleFilledIcon = _this$icons2.CheckCircleFilledIcon,
        ErrorCircleFilledIcon = _this$icons2.ErrorCircleFilledIcon,
        CloseCircleFilledIcon = _this$icons2.CloseCircleFilledIcon;
      var file = this.displayFiles[0] || {};
      var inputTextClass = ["".concat(this.classPrefix, "-input__inner"), _defineProperty__default["default"]({}, "".concat(this.uploadPrefix, "__placeholder"), !this.displayFiles[0])];
      var disabledClass = this.disabled ? "".concat(this.classPrefix, "-is-disabled") : "";
      var fileName = (_this$abridgeName = this.abridgeName) !== null && _this$abridgeName !== void 0 && _this$abridgeName.length && file !== null && file !== void 0 && file.name ? _common_js_upload_utils.abridgeName.apply(void 0, [file.name].concat(_toConsumableArray__default["default"](this.abridgeName))) : file === null || file === void 0 ? void 0 : file.name;
      return h("div", {
        "class": "".concat(this.uploadPrefix, "__single-input-preview ").concat(this.classPrefix, "-input ").concat(disabledClass)
      }, [h("div", {
        "class": inputTextClass
      }, [h("span", {
        "class": ["".concat(this.uploadPrefix, "__single-input-text"), _defineProperty__default["default"]({}, this.placeholderClass, this.placeholder)]
      }, [file.name ? fileName : this.placeholder]), file.status === "progress" && this.renderProgress(file.percent), file.status === "waiting" && h(TimeFilledIcon, {
        "class": "".concat(this.uploadPrefix, "__status-icon ").concat(this.uploadPrefix, "__file-waiting")
      }), file.status === "success" && h(CheckCircleFilledIcon, {
        "class": "".concat(this.uploadPrefix, "__status-icon")
      }), file.name && file.status === "fail" && h(ErrorCircleFilledIcon, {
        "class": "".concat(this.uploadPrefix, "__status-icon ").concat(this.uploadPrefix, "__file-fail")
      }), Boolean(!this.disabled && file.name) && h(CloseCircleFilledIcon, {
        "class": "".concat(this.uploadPrefix, "__single-input-clear"),
        "on": {
          "click": function click(_ref4) {
            var e = _ref4.e;
            return _this2.onRemove({
              e: e,
              file: file,
              index: 0
            });
          }
        }
      })])]);
    }
  },
  render: function render() {
    var _this$$scopedSlots$de, _this$$scopedSlots, _this$displayFiles$, _this$displayFiles$0$;
    var h = arguments[0];
    var fileListDisplay = utils_renderTnode.renderTNodeJSX(this, "fileListDisplay", {
      params: {
        onRemove: this.onRemove,
        toUploadFiles: this.toUploadFiles,
        sizeOverLimitMessage: this.sizeOverLimitMessage,
        locale: this.locale,
        files: this.displayFiles
      }
    });
    if (this.fileListDisplay === null || fileListDisplay === null) {
      fileListDisplay = null;
    }
    return h("div", {
      "class": this.classes
    }, [this.theme === "file-input" && this.renderFilePreviewAsInput(), (_this$$scopedSlots$de = (_this$$scopedSlots = this.$scopedSlots)["default"]) === null || _this$$scopedSlots$de === void 0 ? void 0 : _this$$scopedSlots$de.call(_this$$scopedSlots, null), this.theme === "file" && this.placeholder && !this.displayFiles[0] && h("small", {
      "class": [this.tipsClasses, this.placeholderClass]
    }, [this.placeholder]), fileListDisplay === null ? null : fileListDisplay || this.renderFilePreviewAsText(this.displayFiles), !this.multiple && ((_this$displayFiles$ = this.displayFiles[0]) === null || _this$displayFiles$ === void 0 ? void 0 : _this$displayFiles$.status) === "fail" && this.theme === "file" ? h("small", {
      "class": [this.errorClasses, this.placeholderClass]
    }, [((_this$displayFiles$0$ = this.displayFiles[0].response) === null || _this$displayFiles$0$ === void 0 ? void 0 : _this$displayFiles$0$.error) || this.locale.progress.failText]) : null]);
  }
});

exports["default"] = NormalFile;
//# sourceMappingURL=normal-file.js.map
