/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var helper = require('../_chunks/dep-ece3c062.js');
var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var VueCompositionAPI = require('@vue/composition-api');
var tdesignIconsVue = require('tdesign-icons-vue');
var upload_props = require('./props.js');
var upload_themes_normalFile = require('./themes/normal-file.js');
var upload_themes_draggerFile = require('./themes/dragger-file.js');
var upload_themes_imageCard = require('./themes/image-card.js');
var upload_themes_multipleFlowList = require('./themes/multiple-flow-list.js');
var upload_hooks_useUpload = require('./hooks/useUpload.js');
var button_index = require('../button/index.js');
var upload_themes_customFile = require('./themes/custom-file.js');
var utils_renderTnode = require('../utils/render-tnode.js');
var hooks_useGlobalIcon = require('../hooks/useGlobalIcon.js');
require('@babel/runtime/helpers/toConsumableArray');
require('../loading/index.js');
require('../loading/directive.js');
require('../loading/plugin.js');
require('vue');
require('../loading/loading.js');
require('../loading/icon/gradient.js');
require('../_common/js/loading/circle-adapter.js');
require('../_common/js/utils/setStyle.js');
require('../_common/js/utils/helper.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/slicedToArray');
require('../_chunks/dep-62de1188.js');
require('../_chunks/dep-867c284e.js');
require('../_chunks/dep-738b4f21.js');
require('../_chunks/dep-a4308f57.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-fcf0662d.js');
require('../_chunks/dep-e4278c54.js');
require('../_chunks/dep-aa0a4aac.js');
require('../config-provider/config-receiver.js');
require('../_chunks/dep-07fb8c0e.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-a4a18104.js');
require('../_chunks/dep-27dd8cc6.js');
require('dayjs');
require('../_chunks/dep-87c765cc.js');
require('../_chunks/dep-75cd6d52.js');
require('../_chunks/dep-b1a02818.js');
require('../_chunks/dep-3d8ab37d.js');
require('../_chunks/dep-ecccff93.js');
require('../_chunks/dep-a4cecac4.js');
require('../_chunks/dep-ab142eaf.js');
require('../_chunks/dep-6ad3de7c.js');
require('../_chunks/dep-8b1e056e.js');
require('../_chunks/dep-5db8defc.js');
require('../_chunks/dep-6e4c473c.js');
require('../_chunks/dep-234b7c02.js');
require('../_chunks/dep-a4747856.js');
require('../_chunks/dep-932dd69e.js');
require('../_chunks/dep-9f4caea4.js');
require('../_chunks/dep-dbd838d6.js');
require('../_chunks/dep-b3120c1b.js');
require('../_chunks/dep-68ba2357.js');
require('../_chunks/dep-173eb46c.js');
require('../utils/mixins.js');
require('../utils/dom.js');
require('raf');
require('../utils/easing.js');
require('../utils/transfer-dom.js');
require('../loading/props.js');
require('@babel/runtime/helpers/readOnlyError');
require('../_chunks/dep-7c854ec6.js');
require('../_chunks/dep-eceed11d.js');
require('../_chunks/dep-201f7798.js');
require('../_chunks/dep-d3015b4c.js');
require('../_chunks/dep-f8a85d6a.js');
require('../_chunks/dep-5b117689.js');
require('../_chunks/dep-6478392e.js');
require('../_chunks/dep-47bca35e.js');
require('../config.js');
require('../_chunks/dep-013a3403.js');
require('../_chunks/dep-8cb0d589.js');
require('../_chunks/dep-d23147db.js');
require('../_chunks/dep-de60f5aa.js');
require('../_chunks/dep-63b02f7b.js');
require('../_chunks/dep-bebcd284.js');
require('../_chunks/dep-3eec664c.js');
require('../_chunks/dep-eeb2e214.js');
require('../_chunks/dep-315a67f0.js');
require('../_chunks/dep-f84d1ea5.js');
require('../_chunks/dep-362bc4d7.js');
require('../_chunks/dep-2e32c1f2.js');
require('../_chunks/dep-f14aac54.js');
require('../utils/withInstall.js');
require('../link/index.js');
require('../link/link.js');
require('../link/props.js');
require('../_common/js/upload/utils.js');
require('../_common/js/log/log.js');
require('./constants.js');
require('../hooks/useCommonClassName.js');
require('../config-provider/useConfig.js');
require('./hooks/useDrag.js');
require('../image-viewer/index.js');
require('../image-viewer/image-viewer.js');
require('../image-viewer/props.js');
require('../image-viewer/base/Container.js');
require('../image-viewer/base/ImageModalIcon.js');
require('../hooks/useConfig.js');
require('../hooks/tnode.js');
require('../hooks/render-tnode.js');
require('../_chunks/dep-a6490a32.js');
require('../image-viewer/base/ImageViewerUtils.js');
require('../tooltip/index.js');
require('../tooltip/tooltip.js');
require('../tooltip/props.js');
require('../popup/props.js');
require('../popup/popup.js');
require('@popperjs/core');
require('../utils/helper.js');
require('../popup/container.js');
require('../utils/event.js');
require('../popup/utils.js');
require('../_chunks/dep-f3761329.js');
require('../_chunks/dep-848a5a32.js');
require('../utils/map-props.js');
require('../_common/js/input-number/large-number.js');
require('../hooks/useImagePreviewUrl.js');
require('../image-viewer/base/ImageItem.js');
require('../image-viewer/hooks.js');
require('../image-viewer/const.js');
require('../image-viewer/base/ImageViewerModal.js');
require('../dialog/index.js');
require('../dialog/dialog.js');
require('../dialog/actions.js');
require('../dialog/props.js');
require('../hooks/useDestroyOnClose.js');
require('../dialog/stack.js');
require('../_common/js/utils/getScrollbarWidth.js');
require('../_chunks/dep-13309278.js');
require('../button/button.js');
require('../button/props.js');
require('../utils/ripple.js');
require('../dialog/plugin.js');
require('../config-provider/config-provider.js');
require('../config-provider/props.js');
require('../_chunks/dep-f45125c9.js');
require('../_chunks/dep-f33eb57d.js');
require('../hooks/useVModel.js');
require('../hooks/useDefaultValue.js');
require('../image-viewer/utils.js');
require('../image/index.js');
require('../image/image.js');
require('../_common/js/utils/observe.js');
require('../image/props.js');
require('../space/index.js');
require('../space/space.js');
require('../space/props.js');
require('../_chunks/dep-6dc0a916.js');
require('../_chunks/dep-b5c96567.js');
require('../_chunks/dep-a9e7deb2.js');
require('../hooks/useFormDisabled.js');
require('../_common/js/upload/main.js');
require('@babel/runtime/helpers/toArray');
require('../_common/js/upload/xhr.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var _Upload = VueCompositionAPI.defineComponent({
  name: "TUpload",
  props: upload_props["default"],
  setup: function setup(props2, context) {
    var uploadData = upload_hooks_useUpload["default"](props2, context);
    var localeConfig = uploadData.localeConfig,
      classPrefix = uploadData.classPrefix,
      toUploadFiles = uploadData.toUploadFiles,
      displayFiles = uploadData.displayFiles,
      uploadValue = uploadData.uploadValue,
      sizeOverLimitMessage = uploadData.sizeOverLimitMessage,
      uploading = uploadData.uploading,
      tipsClasses = uploadData.tipsClasses,
      errorClasses = uploadData.errorClasses,
      placeholderClass = uploadData.placeholderClass,
      innerDisabled = uploadData.innerDisabled,
      onInnerRemove = uploadData.onInnerRemove,
      onDragFileChange = uploadData.onDragFileChange,
      onPasteFileChange = uploadData.onPasteFileChange;
    var tDisabled = VueCompositionAPI.computed(function () {
      return innerDisabled.value;
    });
    var icons = hooks_useGlobalIcon.useGlobalIcon({
      UploadIcon: tdesignIconsVue.UploadIcon
    });
    var commonDisplayFileProps = VueCompositionAPI.computed(function () {
      return {
        accept: props2.accept,
        files: uploadValue.value,
        toUploadFiles: toUploadFiles.value,
        displayFiles: displayFiles.value,
        theme: props2.theme,
        placeholder: props2.placeholder,
        disabled: tDisabled.value,
        tips: props2.tips,
        status: props2.status,
        sizeOverLimitMessage: sizeOverLimitMessage.value,
        uploading: uploading.value,
        classPrefix: classPrefix.value,
        tipsClasses: tipsClasses,
        errorClasses: errorClasses,
        placeholderClass: placeholderClass,
        locale: localeConfig.value,
        autoUpload: props2.autoUpload,
        showUploadProgress: props2.showUploadProgress,
        abridgeName: props2.abridgeName,
        imageViewerProps: props2.imageViewerProps,
        fileListDisplay: props2.fileListDisplay,
        onRemove: onInnerRemove
      };
    });
    var dragProps = VueCompositionAPI.computed(function () {
      return {
        onDragFileChange: onDragFileChange,
        onDragenter: function onDragenter(p) {
          var _props2$onDragenter;
          (_props2$onDragenter = props2.onDragenter) === null || _props2$onDragenter === void 0 || _props2$onDragenter.call(props2, p);
          context.emit("dragenter", p);
        },
        onDragleave: function onDragleave(p) {
          var _props2$onDragleave;
          (_props2$onDragleave = props2.onDragleave) === null || _props2$onDragleave === void 0 || _props2$onDragleave.call(props2, p);
          context.emit("dragleave", p);
        },
        onDrop: function onDrop(p) {
          var _props2$onDrop;
          (_props2$onDrop = props2.onDrop) === null || _props2$onDrop === void 0 || _props2$onDrop.call(props2, p);
          context.emit("drop", p);
        }
      };
    });
    var uploadClasses = VueCompositionAPI.computed(function () {
      return ["".concat(classPrefix.value, "-upload"), _defineProperty__default["default"]({}, "".concat(classPrefix.value, "-upload--theme-").concat(props2.theme), props2.theme === "file-input")];
    });
    var handlePasteFileChange = function handlePasteFileChange(e) {
      if (props2.uploadPastedFiles) {
        onPasteFileChange(e);
      }
    };
    return _objectSpread(_objectSpread({}, uploadData), {}, {
      handlePasteFileChange: handlePasteFileChange,
      commonDisplayFileProps: commonDisplayFileProps,
      dragProps: dragProps,
      uploadClasses: uploadClasses,
      sizeOverLimitMessage: sizeOverLimitMessage,
      tDisabled: tDisabled,
      icons: icons
    });
  },
  methods: {
    renderTrigger: function renderTrigger() {
      var _this = this;
      var h = this.$createElement;
      var UploadIcon = this.icons.UploadIcon;
      var getDefaultTrigger = function getDefaultTrigger() {
        if (_this.theme === "file-input") {
          return h(button_index.Button, helper.helper([{
            "attrs": {
              "disabled": _this.tDisabled,
              "variant": "outline"
            }
          }, {
            "props": _this.triggerButtonProps
          }]), [_this.triggerUploadText]);
        }
        return h(button_index.Button, helper.helper([{
          "attrs": {
            "disabled": _this.tDisabled,
            "variant": "outline",
            "icon": function icon() {
              return h(UploadIcon);
            }
          }
        }, {
          "props": _this.triggerButtonProps
        }]), [_this.triggerUploadText]);
      };
      return utils_renderTnode.renderContent(this, "default", "trigger", {
        params: {
          dragActive: false,
          files: this.uploadValue,
          disabled: this.tDisabled
        }
      }) || getDefaultTrigger();
    },
    getNormalFileNode: function getNormalFileNode() {
      var h = this.$createElement;
      return h(upload_themes_normalFile["default"], helper.helper([{}, {
        "props": this.commonDisplayFileProps
      }, {
        "attrs": {
          "multiple": this.multiple
        },
        "scopedSlots": {
          fileListDisplay: this.$scopedSlots.fileListDisplay,
          "file-list-display": this.$scopedSlots["file-list-display"]
        }
      }]), [h("div", {
        "class": "".concat(this.classPrefix, "-upload__trigger"),
        "on": {
          "click": this.triggerUpload
        }
      }, [this.renderTrigger()])]);
    },
    getSingleFileDraggerUploadNode: function getSingleFileDraggerUploadNode() {
      var h = this.$createElement;
      return h(upload_themes_draggerFile["default"], helper.helper([{}, {
        "props": this.commonDisplayFileProps
      }, {
        "attrs": {
          "dragEvents": this.dragProps,
          "trigger": this.trigger,
          "cancelUpload": this.cancelUpload,
          "triggerUpload": this.triggerUpload,
          "uploadFiles": this.uploadFiles
        },
        "on": {
          "cancelUpload": this.innerCancelUpload
        },
        "scopedSlots": {
          fileListDisplay: this.$scopedSlots.fileListDisplay,
          "file-list-display": this.$scopedSlots["file-list-display"]
        }
      }]));
    },
    getImageCardUploadNode: function getImageCardUploadNode() {
      var h = this.$createElement;
      return h(upload_themes_imageCard["default"], helper.helper([{}, {
        "props": this.commonDisplayFileProps
      }, {
        "attrs": {
          "multiple": this.multiple,
          "max": this.max,
          "showUploadProgress": this.showUploadProgress,
          "triggerUpload": this.triggerUpload,
          "uploadFiles": this.uploadFiles,
          "cancelUpload": this.cancelUpload,
          "showImageFileName": this.showImageFileName
        }
      }, {
        "on": {
          preview: this.onInnerPreview
        }
      }, {
        "scopedSlots": {
          fileListDisplay: this.$scopedSlots.fileListDisplay,
          "file-list-display": this.$scopedSlots["file-list-display"]
        }
      }]));
    },
    getFlowListNode: function getFlowListNode() {
      var h = this.$createElement;
      return h(upload_themes_multipleFlowList["default"], helper.helper([{}, {
        "props": this.commonDisplayFileProps
      }, {
        "attrs": {
          "isBatchUpload": this.isBatchUpload,
          "draggable": this.draggable,
          "dragEvents": this.dragProps,
          "uploadFiles": this.uploadFiles,
          "cancelUpload": this.cancelUpload,
          "showThumbnail": this.showThumbnail,
          "showImageFileName": this.showImageFileName,
          "uploadButton": this.uploadButton,
          "cancelUploadButton": this.cancelUploadButton
        },
        "on": {
          "preview": this.onInnerPreview
        },
        "scopedSlots": {
          fileListDisplay: this.$scopedSlots.fileListDisplay,
          "file-list-display": this.$scopedSlots["file-list-display"],
          uploadButton: this.$scopedSlots.uploadButton,
          "upload-button": this.$scopedSlots["upload-button"],
          cancelUploadButton: this.$scopedSlots.cancelUploadButton,
          "cancel-upload-button": this.$scopedSlots["cancel-upload-button"]
        }
      }]), [h("div", {
        "class": "".concat(this.classPrefix, "-upload__trigger"),
        "on": {
          "click": this.triggerUpload
        }
      }, [this.renderTrigger()])]);
    },
    getCustomFile: function getCustomFile() {
      var h = this.$createElement;
      return h(upload_themes_customFile["default"], helper.helper([{}, {
        "props": this.commonDisplayFileProps
      }, {
        "attrs": {
          "draggable": this.draggable,
          "dragContent": this.dragContent,
          "dragEvents": this.dragProps,
          "triggerUpload": this.triggerUpload,
          "trigger": this.trigger,
          "childrenNode": this.$scopedSlots["default"]
        },
        "scopedSlots": {
          dragContent: this.$scopedSlots.dragContent,
          "drag-content": this.$scopedSlots["drag-content"],
          trigger: this.$scopedSlots.trigger
        }
      }]), [!this.draggable && this.renderTrigger()]);
    }
  },
  render: function render() {
    var h = arguments[0];
    return h("div", {
      "class": this.uploadClasses,
      "on": {
        "paste": this.handlePasteFileChange
      }
    }, [h("input", helper.helper([{
      "ref": "inputRef",
      "attrs": {
        "type": "file",
        "disabled": this.tDisabled,
        "multiple": this.multiple,
        "accept": this.accept,
        "hidden": true
      },
      "on": {
        "change": this.onNormalFileChange
      }
    }, {
      "attrs": this.inputAttributes
    }])), ["file", "file-input"].includes(this.theme) && !this.draggable && this.getNormalFileNode(), ["file", "image"].includes(this.theme) && this.draggable && this.getSingleFileDraggerUploadNode(), this.theme === "image" && !this.draggable && this.getImageCardUploadNode(), ["image-flow", "file-flow"].includes(this.theme) && this.getFlowListNode(), this.theme === "custom" && this.getCustomFile(), Boolean(this.tips || this.$scopedSlots.tips) && h("small", {
      "class": [this.tipsClasses, _defineProperty__default["default"]({}, "".concat(this.classPrefix, "-upload__tips-").concat(this.status), this.status)]
    }, [utils_renderTnode.renderTNodeJSX(this, "tips")]), this.sizeOverLimitMessage && h("small", {
      "class": this.errorClasses
    }, [this.sizeOverLimitMessage])]);
  }
});

exports["default"] = _Upload;
//# sourceMappingURL=upload.js.map
