import 'dayjs/locale/it';
declare const _default: {
    readonly autoComplete: {
        readonly empty: "Nessun dato";
    };
    readonly pagination: {
        readonly itemsPerPage: "{size} articoli/pagina";
        readonly jumpTo: "Vai a";
        readonly page: "pagina";
        readonly total: "totale {total} elementi dati";
    };
    readonly cascader: {
        readonly empty: "Nessun dato";
        readonly loadingText: "Caricamento in corso";
        readonly placeholder: "Seleziona";
    };
    readonly calendar: {
        readonly yearSelection: "{year} anno";
        readonly monthSelection: "{month} mese";
        readonly yearRadio: "anno";
        readonly monthRadio: "mese";
        readonly hideWeekend: "Nascondi weekend";
        readonly showWeekend: "Mostra weekend";
        readonly today: "Oggi";
        readonly thisMonth: "Questo mese";
        readonly week: "Lun,Mar,Mer,Gio,Ven,Sab,Dom";
        readonly cellMonth: "Gen,Feb,Mar,Apr,Mag,Giu,Lug,Ago,Set,Ott,Nov,Dic";
    };
    readonly transfer: {
        readonly title: "{checked} / {total} elementi";
        readonly empty: "Nessun dato";
        readonly placeholder: "Inserisci la parola chiave per la ricerca";
    };
    readonly timePicker: {
        readonly dayjsLocale: "it";
        readonly now: "Ora";
        readonly confirm: "Conferma";
        readonly anteMeridiem: "AM";
        readonly postMeridiem: "PM";
        readonly placeholder: "Seleziona ora";
    };
    readonly dialog: {
        readonly confirm: "OK";
        readonly cancel: "Annulla";
    };
    readonly drawer: {
        readonly confirm: "OK";
        readonly cancel: "Annulla";
    };
    readonly popconfirm: {
        readonly confirm: {
            readonly content: "OK";
        };
        readonly cancel: {
            readonly content: "Annulla";
        };
    };
    readonly table: {
        readonly empty: "Nessun dato";
        readonly loadingText: "Caricamento in corso, attendere";
        readonly loadingMoreText: "Clicca per caricare di più";
        readonly filterInputPlaceholder: "Inserisci il contenuto (nessun valore predefinito)";
        readonly sortAscendingOperationText: "Clicca per ordinare in modo crescente";
        readonly sortCancelOperationText: "Clicca per annullare l'ordinamento";
        readonly sortDescendingOperationText: "Clicca per ordinare in modo decrescente";
        readonly clearFilterResultButtonText: "Pulisci il filtro";
        readonly columnConfigButtonText: "Configurazione delle colonne";
        readonly columnConfigTitleText: "Configurazione delle colonne della tabella";
        readonly columnConfigDescriptionText: "Seleziona le colonne dei dati da visualizzare nella tabella";
        readonly confirmText: "Conferma";
        readonly cancelText: "Annulla";
        readonly resetText: "Ripristina";
        readonly selectAllText: "Seleziona tutto";
        readonly searchResultText: "Ricerca \"{result}\", trovati {count} risultati";
    };
    readonly select: {
        readonly empty: "Nessun dato";
        readonly loadingText: "Caricamento in corso";
        readonly placeholder: "Seleziona";
    };
    readonly tree: {
        readonly empty: "Nessun dato";
    };
    readonly treeSelect: {
        readonly empty: "Nessun dato";
        readonly loadingText: "Caricamento in corso";
        readonly placeholder: "Seleziona";
    };
    readonly datePicker: {
        readonly dayjsLocale: "it";
        readonly placeholder: {
            readonly date: "Seleziona la data";
            readonly month: "Seleziona il mese";
            readonly year: "Seleziona l'anno";
            readonly quarter: "Seleziona il trimestre";
            readonly week: "Seleziona una settimana";
        };
        readonly weekdays: readonly ["Lun", "Mar", "Mer", "Gio", "Ven", "Sab", "Dom"];
        readonly months: readonly ["Gen", "Feb", "Mar", "Apr", "Mag", "Giu", "Lug", "Ago", "Set", "Ott", "Nov", "Dic"];
        readonly quarters: readonly ["Primo trimestre", "Secondo trimestre", "Terzo trimestre", "Quarto trimestre"];
        readonly rangeSeparator: " - ";
        readonly direction: "ltr";
        readonly format: "DD-MM-YYYY";
        readonly dayAriaLabel: "Giorno";
        readonly weekAbbreviation: "Sett.";
        readonly yearAriaLabel: "Anno";
        readonly monthAriaLabel: "Mese";
        readonly confirm: "Conferma";
        readonly selectTime: "Seleziona ora";
        readonly selectDate: "Seleziona data";
        readonly nextYear: "Anno successivo";
        readonly preYear: "Anno precedente";
        readonly nextMonth: "Mese successivo";
        readonly preMonth: "Mese precedente";
        readonly preDecade: "Decennio precedente";
        readonly nextDecade: "Decennio successivo";
        readonly now: "Ora";
    };
    readonly upload: {
        readonly sizeLimitMessage: "La dimensione del file non può superare {sizeLimit}";
        readonly cancelUploadText: "Annulla caricamento";
        readonly triggerUploadText: {
            readonly fileInput: "Seleziona file";
            readonly image: "Clicca per caricare immagine";
            readonly normal: "Clicca per caricare";
            readonly reupload: "Seleziona di nuovo";
            readonly continueUpload: "Continua a selezionare";
            readonly delete: "Elimina";
            readonly uploading: "Caricamento in corso";
        };
        readonly dragger: {
            readonly dragDropText: "Rilascia il mouse";
            readonly draggingText: "Trascina in questa area";
            readonly clickAndDragText: "Clicca su \"Seleziona file\" sopra o trascina i file in questa area";
        };
        readonly file: {
            readonly fileNameText: "Nome del file";
            readonly fileSizeText: "Dimensione del file";
            readonly fileStatusText: "Stato";
            readonly fileOperationText: "Operazione";
            readonly fileOperationDateText: "Data di caricamento";
        };
        readonly progress: {
            readonly uploadingText: "Caricamento in corso";
            readonly waitingText: "In attesa di caricamento";
            readonly failText: "Caricamento fallito";
            readonly successText: "Caricamento riuscito";
        };
    };
    readonly form: {
        readonly errorMessage: {
            readonly date: "Inserisci la ${name} corretta";
            readonly url: "Inserisci la ${name} corretta";
            readonly whitespace: "Il ${name} non può essere vuoto";
            readonly required: "${name} obbligatorio";
            readonly max: "La lunghezza dei caratteri di ${name} non può superare i ${validate} caratteri";
            readonly min: "La lunghezza dei caratteri di ${name} non può essere inferiore a ${validate} caratteri";
            readonly len: "La lunghezza dei caratteri di ${name} deve essere ${validate}";
            readonly enum: "${name} può essere solo ${validate}, ecc.";
            readonly idcard: "Inserisci la ${name} corretta";
            readonly telnumber: "Inserisci la ${name} corretta";
            readonly pattern: "Inserisci la ${name} corretta";
            readonly validator: "${name} non conforme ai requisiti";
            readonly boolean: "Il tipo di dati di ${name} deve essere booleano";
            readonly number: "${name} deve essere un numero";
        };
        readonly colonText: ":";
    };
    readonly input: {
        readonly placeholder: "Inserisci";
    };
    readonly list: {
        readonly loadingText: "Caricamento in corso, attendere prego";
        readonly loadingMoreText: "Clicca per caricare di più";
    };
    readonly alert: {
        readonly expandText: "Espandi per maggiori dettagli";
        readonly collapseText: "Riduci";
    };
    readonly anchor: {
        readonly copySuccessText: "Link copiato con successo";
        readonly copyText: "Copia link";
    };
    readonly colorPicker: {
        readonly swatchColorTitle: "Colori predefiniti dal sistema";
        readonly recentColorTitle: "Colori usati di recente";
        readonly clearConfirmText: "Sei sicuro di voler cancellare i colori usati di recente?";
        readonly singleColor: "Singolo";
        readonly gradientColor: "Gradiente";
    };
    readonly guide: {
        readonly finishButtonProps: {
            readonly content: "Finito";
            readonly theme: "primario";
        };
        readonly nextButtonProps: {
            readonly content: "Prossimo";
            readonly theme: "primario";
        };
        readonly skipButtonProps: {
            readonly content: "Salta";
            readonly theme: "predefinito";
        };
        readonly prevButtonProps: {
            readonly content: "Precedente";
            readonly theme: "predefinito";
        };
    };
    readonly image: {
        readonly errorText: "L'immagine non può essere visualizzata";
        readonly loadingText: "Caricamento immagine in corso";
    };
    readonly imageViewer: {
        readonly errorText: "Caricamento immagine fallito, puoi provare a ricaricare";
        readonly mirrorTipText: "Specchio";
        readonly rotateTipText: "Ruota";
        readonly originalSizeTipText: "Dimensione originale";
    };
    readonly typography: {
        readonly expandText: "Espandere";
        readonly collapseText: "ripiegare";
        readonly copiedText: "Copia completata";
    };
    readonly rate: {
        readonly rateText: readonly ["Terribile", "Deluso", "Ordinario", "Soddisfatto", "Sorpreso"];
    };
    readonly empty: {
        readonly titleText: {
            readonly maintenance: "In costruzione";
            readonly success: "Successo";
            readonly fail: "Fallimento";
            readonly empty: "Nessun dato";
            readonly networkError: "Errore di rete";
        };
    };
    readonly descriptions: {
        readonly colonText: ":";
    };
    readonly chat: {
        readonly placeholder: "Inserisci il messaggio...";
        readonly stopBtnText: "Interrompi";
        readonly refreshTipText: "Rigenera";
        readonly copyTipText: "Copia";
        readonly likeTipText: "Mi piace";
        readonly dislikeTipText: "Non mi piace";
        readonly copyCodeBtnText: "Copia codice";
        readonly copyCodeSuccessText: "Copiato";
        readonly clearHistoryBtnText: "Cancella cronologia";
        readonly copyTextSuccess: "Copiato negli appunti";
        readonly copyTextFail: "Copia negli appunti non riuscita";
        readonly confirmClearHistory: "Sei sicuro di voler cancellare tutti i messaggi?";
        readonly loadingText: "Penso...";
        readonly loadingEndText: "Penso finito";
    };
};
export default _default;
