import 'dayjs/locale/ko';
declare const _default: {
    readonly autoComplete: {
        readonly empty: "데이터 없음";
    };
    readonly pagination: {
        readonly itemsPerPage: "{size} /페이지";
        readonly jumpTo: "건너뛰다";
        readonly page: "페이지";
        readonly total: "흔한 {total} 아이템 데이터";
    };
    readonly cascader: {
        readonly empty: "데이터 없음";
        readonly loadingText: "로딩 중";
        readonly placeholder: "선택해주세요";
    };
    readonly calendar: {
        readonly yearSelection: "{year} 년도";
        readonly monthSelection: "{month} 달";
        readonly yearRadio: "년도";
        readonly monthRadio: "달";
        readonly hideWeekend: "주말을 숨기다";
        readonly showWeekend: "주말 쇼";
        readonly today: "오늘";
        readonly thisMonth: "이번 달";
        readonly week: "하나,둘,셋,넷,다섯,여섯,하루";
        readonly cellMonth: "1월,2월,3월,4월,5월,6월,7월,8월,9월,10월,11월,12월";
    };
    readonly transfer: {
        readonly title: "{checked} / {total} 안건";
        readonly empty: "데이터 없음";
        readonly placeholder: "검색할 키워드를 입력하세요";
    };
    readonly timePicker: {
        readonly dayjsLocale: "ko";
        readonly now: "지금";
        readonly confirm: "확신하는";
        readonly anteMeridiem: "아침";
        readonly postMeridiem: "오후";
        readonly placeholder: "선발 기간";
    };
    readonly dialog: {
        readonly confirm: "확인하다";
        readonly cancel: "취소";
    };
    readonly drawer: {
        readonly confirm: "확인하다";
        readonly cancel: "취소";
    };
    readonly popconfirm: {
        readonly confirm: {
            readonly content: "확신하는";
        };
        readonly cancel: {
            readonly content: "취소";
        };
    };
    readonly table: {
        readonly empty: "데이터 없음";
        readonly loadingText: "로딩 중 기다려주세요";
        readonly loadingMoreText: "더 로드하려면 클릭하세요";
        readonly filterInputPlaceholder: "아무거나 입력하세요(기본값 없음)";
        readonly sortAscendingOperationText: "오름차순으로 클릭";
        readonly sortCancelOperationText: "클릭하여 정렬 해제";
        readonly sortDescendingOperationText: "내림차순으로 클릭";
        readonly clearFilterResultButtonText: "클리어 필터";
        readonly columnConfigButtonText: "열 구성";
        readonly columnConfigTitleText: "테이블 열 구성";
        readonly columnConfigDescriptionText: "테이블에 표시할 데이터 열을 선택하십시오";
        readonly confirmText: "확인하다";
        readonly cancelText: "취소";
        readonly resetText: "초기화";
        readonly selectAllText: "모두 선택";
        readonly searchResultText: "검색“{result}”，일어나 {count} 결과";
    };
    readonly select: {
        readonly empty: "데이터 없음";
        readonly loadingText: "로딩 중";
        readonly placeholder: "선택해주세요";
    };
    readonly tree: {
        readonly empty: "데이터 없음";
    };
    readonly treeSelect: {
        readonly empty: "데이터 없음";
        readonly loadingText: "로딩 중";
        readonly placeholder: "선택해주세요";
    };
    readonly datePicker: {
        readonly dayjsLocale: "ko";
        readonly placeholder: {
            readonly date: "날짜를 선택하세요Z";
            readonly month: "월을 선택하세요";
            readonly year: "연도를 선택하세요";
            readonly quarter: "분기별 선택";
            readonly week: "요일 선택";
        };
        readonly weekdays: readonly ["월", "화", "수", "목", "금", "토", "일"];
        readonly months: readonly ["1 월", "2 월", "3 월", "4 월", "5 월", "6 월", "7 월", "8 월", "9 월", "10 월", "11 월", "12 월"];
        readonly quarters: readonly ["Q1", "Q2", "Q3", "Q4"];
        readonly rangeSeparator: " - ";
        readonly direction: "ltr";
        readonly format: "YYYY-MM-DD";
        readonly dayAriaLabel: "낮";
        readonly weekAbbreviation: "주";
        readonly yearAriaLabel: "년도";
        readonly monthAriaLabel: "달";
        readonly confirm: "확신하는";
        readonly selectTime: "선발 기간";
        readonly selectDate: "날짜 선택";
        readonly nextYear: "내년";
        readonly preYear: "작년";
        readonly nextMonth: "다음 달";
        readonly preMonth: "지난 달";
        readonly preDecade: "지난 십 년";
        readonly nextDecade: "다음 10년";
        readonly now: "현재의";
    };
    readonly upload: {
        readonly sizeLimitMessage: "이미지 크기는 다음을 초과할 수 없습니다 {sizeLimit}";
        readonly cancelUploadText: "업로드 취소";
        readonly triggerUploadText: {
            readonly fileInput: "파일 선택";
            readonly image: "이미지를 업로드하려면 클릭하세요";
            readonly normal: "업로드하려면 클릭";
            readonly reupload: "재업로드";
            readonly continueUpload: "계속 업로드";
            readonly delete: "삭제";
            readonly uploading: "업로드";
        };
        readonly dragger: {
            readonly dragDropText: "마우스를 놓으십시오";
            readonly draggingText: "이 영역으로 드래그 앤 드롭";
            readonly clickAndDragText: "위의 \"파일 선택\"을 클릭하거나 파일을 이 영역으로 끌어다 놓습니다";
        };
        readonly file: {
            readonly fileNameText: "파일 이름";
            readonly fileSizeText: "파일 크기";
            readonly fileStatusText: "상태";
            readonly fileOperationText: "작동하다";
            readonly fileOperationDateText: "업로드 날짜";
        };
        readonly progress: {
            readonly uploadingText: "업로드";
            readonly waitingText: "업로드 보류 중";
            readonly failText: "업로드 실패";
            readonly successText: "성공적으로 업로드됨";
        };
    };
    readonly form: {
        readonly errorMessage: {
            readonly date: "정확한 내용을 입력해주세요${name}";
            readonly url: "정확한 내용을 입력해주세요${name}";
            readonly required: "${name}필수의";
            readonly whitespace: "${name}은 비어 있을 수 없습니다";
            readonly max: "${name}문자 길이는 초과할 수 없습니다 ${validate} 캐릭터，한자는 두 글자와 같다";
            readonly min: "${name}문자 길이는 다음보다 작을 수 없습니다 ${validate} 캐릭터，한자는 두 글자와 같다";
            readonly len: "${name}문자 길이는 다음과 같아야 합니다. ${validate}";
            readonly enum: "${name}만 될 수 있습니다${validate}그리고 더";
            readonly idcard: "정확한 내용을 입력해주세요${name}";
            readonly telnumber: "정확한 내용을 입력해주세요${name}";
            readonly pattern: "정확한 내용을 입력해주세요${name}";
            readonly validator: "${name}비준수";
            readonly boolean: "${name}데이터 유형은 부울이어야 합니다";
            readonly number: "${name}숫자여야 합니다";
        };
        readonly colonText: ":";
    };
    readonly input: {
        readonly placeholder: "들어 오세요";
    };
    readonly list: {
        readonly loadingText: "로딩 중 기다려주세요";
        readonly loadingMoreText: "더 로드하려면 클릭하세요";
    };
    readonly alert: {
        readonly expandText: "더 확장";
        readonly collapseText: "치워";
    };
    readonly anchor: {
        readonly copySuccessText: "링크 복사 성공";
        readonly copyText: "링크 복사";
    };
    readonly colorPicker: {
        readonly swatchColorTitle: "시스템 기본 색상";
        readonly recentColorTitle: "최근 사용한 색상";
        readonly clearConfirmText: "최근에 사용한 색상을 지우시겠습니까?";
        readonly singleColor: "단색";
        readonly gradientColor: "그라데이션";
    };
    readonly guide: {
        readonly finishButtonProps: {
            readonly content: "완료";
            readonly theme: "primary";
        };
        readonly nextButtonProps: {
            readonly content: "다음 단계";
            readonly theme: "primary";
        };
        readonly skipButtonProps: {
            readonly content: "건너뛰기";
            readonly theme: "default";
        };
        readonly prevButtonProps: {
            readonly content: "마지막 단계";
            readonly theme: "default";
        };
    };
    readonly image: {
        readonly errorText: "사진을 표시할 수 없습니다.";
        readonly loadingText: "이미지 로딩";
    };
    readonly imageViewer: {
        readonly errorText: "이미지를 로드하지 못했습니다. 새로고침해 보세요.";
        readonly mirrorTipText: "미러 이미지";
        readonly rotateTipText: "회전하다";
        readonly originalSizeTipText: "원본 크기";
    };
    readonly typography: {
        readonly expandText: "펼치다";
        readonly collapseText: "접다";
        readonly copiedText: "복사 성공";
    };
    readonly rate: {
        readonly rateText: readonly ["최악", "실망", "보통", "만족", "놀람"];
    };
    readonly empty: {
        readonly titleText: {
            readonly maintenance: "건설 중";
            readonly success: "성공";
            readonly fail: "실패";
            readonly empty: "데이터 없음";
            readonly networkError: "네트워크 오류";
        };
    };
    readonly descriptions: {
        readonly colonText: ":";
    };
    readonly chat: {
        readonly placeholder: "메시지를 입력하세요...";
        readonly stopBtnText: "중지";
        readonly refreshTipText: "다시 생성";
        readonly copyTipText: "복사";
        readonly likeTipText: "좋아요";
        readonly dislikeTipText: "싫어요";
        readonly copyCodeBtnText: "코드 복사";
        readonly copyCodeSuccessText: "복사됨";
        readonly clearHistoryBtnText: "기록 지우기";
        readonly copyTextSuccess: "클립보드에 복사되었습니다";
        readonly copyTextFail: "클립보드에 복사하지 못했습니다";
        readonly confirmClearHistory: "채팅 기록을 지우시겠습니까?";
        readonly loadingText: "생각 중...";
        readonly loadingEndText: "깊이 생각함";
    };
};
export default _default;
