import 'dayjs/locale/zh-tw';
declare const _default: {
    readonly autoComplete: {
        readonly empty: "暫無數據";
    };
    readonly pagination: {
        readonly itemsPerPage: "{size} 項/頁";
        readonly jumpTo: "跳至";
        readonly page: "頁";
        readonly total: "共 {total} 項數據";
    };
    readonly cascader: {
        readonly empty: "暫無數據";
        readonly loadingText: "載入中";
        readonly placeholder: "請選擇";
    };
    readonly calendar: {
        readonly yearSelection: "{year} 年";
        readonly monthSelection: "{month} 月";
        readonly yearRadio: "年";
        readonly monthRadio: "月";
        readonly hideWeekend: "隱藏週末";
        readonly showWeekend: "顯示週末";
        readonly today: "今天";
        readonly thisMonth: "本月";
        readonly week: "一,二,三,四,五,六,日";
        readonly cellMonth: "1 月,2 月,3 月,4 月,5 月,6 月,7 月,8 月,9 月,10 月,11 月,12 月";
    };
    readonly transfer: {
        readonly title: "{checked} / {total} 項";
        readonly empty: "暫無數據";
        readonly placeholder: "請輸入關鍵詞搜尋";
    };
    readonly timePicker: {
        readonly dayjsLocale: "zh-tw";
        readonly now: "此刻";
        readonly confirm: "確認";
        readonly anteMeridiem: "上午";
        readonly postMeridiem: "下午";
        readonly placeholder: "選擇時間";
    };
    readonly dialog: {
        readonly confirm: "確認";
        readonly cancel: "取消";
    };
    readonly drawer: {
        readonly confirm: "確認";
        readonly cancel: "取消";
    };
    readonly popconfirm: {
        readonly confirm: {
            readonly content: "確認";
        };
        readonly cancel: {
            readonly content: "取消";
        };
    };
    readonly table: {
        readonly empty: "暫無數據";
        readonly loadingText: "正在載入中，請稍後";
        readonly loadingMoreText: "點擊載入更多";
        readonly filterInputPlaceholder: "請輸入内容（無默認值）";
        readonly sortAscendingOperationText: "點擊升序";
        readonly sortCancelOperationText: "點擊取消排序";
        readonly sortDescendingOperationText: "點擊降序";
        readonly clearFilterResultButtonText: "清空篩選";
        readonly columnConfigButtonText: "行配置";
        readonly columnConfigTitleText: "表格行配置";
        readonly columnConfigDescriptionText: "請選擇需要在表格中顯示的數據行";
        readonly confirmText: "確認";
        readonly cancelText: "取消";
        readonly resetText: "重置";
        readonly selectAllText: "全選";
        readonly searchResultText: "搜尋\"{result}\"，找到{count}項結果";
    };
    readonly select: {
        readonly empty: "暫無數據";
        readonly loadingText: "載入中";
        readonly placeholder: "請選擇";
    };
    readonly tree: {
        readonly empty: "暫無數據";
    };
    readonly treeSelect: {
        readonly empty: "暫無數據";
        readonly loadingText: "載入中";
        readonly placeholder: "請選擇";
    };
    readonly datePicker: {
        readonly dayjsLocale: "zh-tw";
        readonly placeholder: {
            readonly date: "請選擇日期";
            readonly month: "請選擇月份";
            readonly year: "請選擇年份";
            readonly quarter: "請選擇季度";
            readonly week: "請選擇周";
        };
        readonly weekdays: readonly ["一", "二", "三", "四", "五", "六", "日"];
        readonly months: readonly ["1月", "2月", "3月", "4月", "5月", "6月", "7月", "8月", "9月", "10月", "11月", "12月"];
        readonly quarters: readonly ["一季度", "二季度", "三季度", "四季度"];
        readonly rangeSeparator: " - ";
        readonly direction: "ltr";
        readonly format: "YYYY-MM-DD";
        readonly dayAriaLabel: "日";
        readonly weekAbbreviation: "週";
        readonly yearAriaLabel: "年";
        readonly monthAriaLabel: "月";
        readonly confirm: "確認";
        readonly selectTime: "選擇時間";
        readonly selectDate: "選擇日期";
        readonly nextYear: "下一年";
        readonly preYear: "上一年";
        readonly nextMonth: "下個月";
        readonly preMonth: "上個月";
        readonly preDecade: "上十年";
        readonly nextDecade: "下十年";
        readonly now: "當前";
    };
    readonly upload: {
        readonly sizeLimitMessage: "文件大小不能超過 {sizeLimit}";
        readonly cancelUploadText: "取消上傳";
        readonly triggerUploadText: {
            readonly fileInput: "選擇文件";
            readonly image: "點擊上傳圖片";
            readonly normal: "點擊上傳";
            readonly reupload: "重新選擇";
            readonly continueUpload: "繼續選擇";
            readonly delete: "刪除";
            readonly uploading: "上傳中";
        };
        readonly dragger: {
            readonly dragDropText: "釋放鼠標";
            readonly draggingText: "拖拽到此區域";
            readonly clickAndDragText: "點擊上方“選擇文件”或將文件拖拽到此區域";
        };
        readonly file: {
            readonly fileNameText: "文件名";
            readonly fileSizeText: "文件大小";
            readonly fileStatusText: "狀態";
            readonly fileOperationText: "操作";
            readonly fileOperationDateText: "上傳日期";
        };
        readonly progress: {
            readonly uploadingText: "正在上傳";
            readonly waitingText: "等待上傳";
            readonly failText: "上傳失敗";
            readonly successText: "上傳成功";
        };
    };
    readonly form: {
        readonly errorMessage: {
            readonly date: "請輸入正確的${name}";
            readonly url: "請輸入正確的${name}";
            readonly whitespace: "${name}不能為空";
            readonly required: "${name}必填";
            readonly max: "${name}字符長度不能超過 ${validate} 個字符，一個中文等於兩個字符";
            readonly min: "${name}字符長度不能少於 ${validate} 個字符，一個中文等於兩個字符";
            readonly len: "${name}字符長度必須是 ${validate}";
            readonly enum: "${name}只能是${validate}等";
            readonly idcard: "請輸入正確的${name}";
            readonly telnumber: "請輸入正確的${name}";
            readonly pattern: "請輸入正確的${name}";
            readonly validator: "${name}不符合要求";
            readonly boolean: "${name}數據類型必須是布林類型";
            readonly number: "${name}必須是數字";
        };
        readonly colonText: "：";
    };
    readonly input: {
        readonly placeholder: "請輸入";
    };
    readonly list: {
        readonly loadingText: "正在載入中，請稍後";
        readonly loadingMoreText: "點擊載入更多";
    };
    readonly alert: {
        readonly expandText: "展開更多";
        readonly collapseText: "收起";
    };
    readonly anchor: {
        readonly copySuccessText: "連結複製成功";
        readonly copyText: "複製連結";
    };
    readonly colorPicker: {
        readonly swatchColorTitle: "系統預設顔色";
        readonly recentColorTitle: "最近使用的顔色";
        readonly clearConfirmText: "確定清空最近使用的顔色嗎？";
        readonly singleColor: "單色";
        readonly gradientColor: "漸變";
    };
    readonly guide: {
        readonly finishButtonProps: {
            readonly content: "完成";
            readonly theme: "primary";
        };
        readonly nextButtonProps: {
            readonly content: "下一步";
            readonly theme: "primary";
        };
        readonly skipButtonProps: {
            readonly content: "跳過";
            readonly theme: "default";
        };
        readonly prevButtonProps: {
            readonly content: "上一步";
            readonly theme: "default";
        };
    };
    readonly image: {
        readonly errorText: "圖片無法顯示";
        readonly loadingText: "圖片載入中";
    };
    readonly imageViewer: {
        readonly errorText: "圖片載入失敗，可嘗試重新載入";
        readonly mirrorTipText: "鏡像";
        readonly rotateTipText: "旋轉";
        readonly originalSizeTipText: "原始大小";
    };
    readonly typography: {
        readonly expandText: "展開";
        readonly collapseText: "收起";
        readonly copiedText: "復製成功";
    };
    readonly rate: {
        readonly rateText: readonly ["極差", "失望", "一般", "滿意", "驚喜"];
    };
    readonly empty: {
        readonly titleText: {
            readonly maintenance: "建設中";
            readonly success: "成功";
            readonly fail: "失敗";
            readonly empty: "暫無數據";
            readonly networkError: "網絡錯誤";
        };
    };
    readonly descriptions: {
        readonly colonText: "：";
    };
    readonly chat: {
        readonly placeholder: "請輸入訊息...";
        readonly stopBtnText: "中止";
        readonly refreshTipText: "重新生成";
        readonly copyTipText: "複製";
        readonly likeTipText: "讚";
        readonly dislikeTipText: "踩";
        readonly copyCodeBtnText: "複製程式碼";
        readonly copyCodeSuccessText: "已複製";
        readonly clearHistoryBtnText: "清空歷史記錄";
        readonly copyTextSuccess: "已成功複製到剪貼簿";
        readonly copyTextFail: "複製到剪貼簿失敗";
        readonly confirmClearHistory: "確定要清空所有的消息嗎？";
        readonly loadingText: "思考中...";
        readonly loadingEndText: "已深度思考";
    };
};
export default _default;
