import { PropType } from '@vue/composition-api';
import { TdTimePickerProps } from '../../time-picker';
declare const _default: import("vue").ComponentOptions<import("vue").default, import("@vue/composition-api").ShallowUnwrapRef<{
    COMPONENT_NAME: import("@vue/composition-api").ComputedRef<string>;
    startTableData: import("@vue/composition-api").ComputedRef<any[]>;
    endTableData: import("@vue/composition-api").ComputedRef<any[]>;
    panelContentProps: import("@vue/composition-api").ComputedRef<{
        format: string;
        mode: "month" | "year" | "quarter" | "week" | "date";
        firstDayOfWeek: number;
        popupVisible: boolean;
        enableTimePicker: boolean;
        timePickerProps: {
            allowInput?: boolean;
            borderless?: boolean;
            clearable?: boolean;
            disableTime: ((h: number, m: number, s: number, ms: number) => Partial<{
                hour: number[];
                minute: number[];
                second: number[];
                millisecond: number[];
            }>) | ((h: number, m: number, s: number, context: {
                partial: import("../../time-picker").TimeRangePickerPartial;
            }) => Partial<{
                hour: number[];
                minute: number[];
                second: number[];
            }>);
            disabled?: boolean;
            readonly?: boolean;
            format?: string;
            hideDisabledTime?: boolean;
            inputProps?: import("../..").InputProps<import("../..").InputValue>;
            placeholder?: string;
            popupProps?: import("../..").TdPopupProps;
            presets?: import("../../time-picker").PresetTime;
            size?: "small" | "medium" | "large";
            status?: "error" | "default" | "success" | "warning";
            steps?: (string | number)[];
            tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
            value?: string;
            defaultValue?: string;
            onBlur?: (context: {
                value: string;
                e: FocusEvent;
            }) => void;
            onChange?: (value: string) => void;
            onClose?: (context: {
                e: MouseEvent;
            }) => void;
            onFocus?: (context: {
                value: string;
                e: FocusEvent;
            }) => void;
            onInput?: (context: {
                value: string;
                e: InputEvent;
            }) => void;
            onOpen?: (context: {
                e: MouseEvent;
            }) => void;
            onPick?: (value: string, context: {
                e: MouseEvent;
            }) => void;
        };
        onMonthChange: Function;
        onYearChange: Function;
        onJumperClick: Function;
        onCellClick: Function;
        onCellMouseEnter: Function;
        onCellMouseLeave: Function;
        onTimePickerChange: Function;
    }>;
}> & import("@vue/composition-api").Data, {}, {}, {
    hoverValue: PropType<string[]>;
    activeIndex: NumberConstructor;
    isFirstValueSelected: BooleanConstructor;
    disableDate: PropType<import("../type").DisableRangeDate>;
    disableTime: PropType<(times: Date[], context: {
        partial: import("../type").DateRangePickerPartial;
    }) => Partial<{
        hour: number[];
        minute: number[];
        second: number[];
    }>>;
    mode: {
        type: PropType<"month" | "year" | "quarter" | "week" | "date">;
        default: string;
    };
    format: PropType<string>;
    presetsPlacement: {
        type: PropType<"left" | "top" | "bottom" | "right">;
        default: string;
    };
    value: PropType<string[]>;
    timePickerProps: PropType<TdTimePickerProps>;
    presets: PropType<import("../type").PresetRange>;
    enableTimePicker: BooleanConstructor;
    firstDayOfWeek: NumberConstructor;
    panelPreselection: BooleanConstructor;
    hidePreselection: {
        type: BooleanConstructor;
        defaultValue: boolean;
    };
    popupVisible: BooleanConstructor;
    year: PropType<number[]>;
    month: PropType<number[]>;
    time: PropType<string[]>;
    cancelRangeSelectLimit: BooleanConstructor;
    onClick: FunctionConstructor;
    onCellClick: FunctionConstructor;
    onCellMouseEnter: FunctionConstructor;
    onCellMouseLeave: FunctionConstructor;
    onJumperClick: FunctionConstructor;
    onConfirmClick: FunctionConstructor;
    onPresetClick: FunctionConstructor;
    onYearChange: FunctionConstructor;
    onMonthChange: FunctionConstructor;
    onTimePickerChange: FunctionConstructor;
}, import("@vue/composition-api").ExtractPropTypes<{
    hoverValue: PropType<string[]>;
    activeIndex: NumberConstructor;
    isFirstValueSelected: BooleanConstructor;
    disableDate: PropType<import("../type").DisableRangeDate>;
    disableTime: PropType<(times: Date[], context: {
        partial: import("../type").DateRangePickerPartial;
    }) => Partial<{
        hour: number[];
        minute: number[];
        second: number[];
    }>>;
    mode: {
        type: PropType<"month" | "year" | "quarter" | "week" | "date">;
        default: string;
    };
    format: PropType<string>;
    presetsPlacement: {
        type: PropType<"left" | "top" | "bottom" | "right">;
        default: string;
    };
    value: PropType<string[]>;
    timePickerProps: PropType<TdTimePickerProps>;
    presets: PropType<import("../type").PresetRange>;
    enableTimePicker: BooleanConstructor;
    firstDayOfWeek: NumberConstructor;
    panelPreselection: BooleanConstructor;
    hidePreselection: {
        type: BooleanConstructor;
        defaultValue: boolean;
    };
    popupVisible: BooleanConstructor;
    year: PropType<number[]>;
    month: PropType<number[]>;
    time: PropType<string[]>;
    cancelRangeSelectLimit: BooleanConstructor;
    onClick: FunctionConstructor;
    onCellClick: FunctionConstructor;
    onCellMouseEnter: FunctionConstructor;
    onCellMouseLeave: FunctionConstructor;
    onJumperClick: FunctionConstructor;
    onConfirmClick: FunctionConstructor;
    onPresetClick: FunctionConstructor;
    onYearChange: FunctionConstructor;
    onMonthChange: FunctionConstructor;
    onTimePickerChange: FunctionConstructor;
}>> & Omit<import("vue").VueConstructor<import("vue").default>, never> & (new (...args: any[]) => import("@vue/composition-api").ComponentRenderProxy<{
    popupVisible: boolean;
    mode: "month" | "year" | "quarter" | "week" | "date";
    enableTimePicker: boolean;
    presetsPlacement: "left" | "top" | "bottom" | "right";
    cancelRangeSelectLimit: boolean;
    panelPreselection: boolean;
    isFirstValueSelected: boolean;
    hidePreselection: boolean;
} & {
    value?: string[];
    time?: string[];
    month?: number[];
    year?: number[];
    onClick?: Function;
    format?: string;
    firstDayOfWeek?: number;
    onCellClick?: Function;
    onMonthChange?: Function;
    activeIndex?: number;
    disableTime?: (times: Date[], context: {
        partial: import("../type").DateRangePickerPartial;
    }) => Partial<{
        hour: number[];
        minute: number[];
        second: number[];
    }>;
    presets?: import("../type").PresetRange;
    disableDate?: unknown;
    timePickerProps?: unknown;
    onPresetClick?: Function;
    onYearChange?: Function;
    onJumperClick?: Function;
    onCellMouseEnter?: Function;
    onCellMouseLeave?: Function;
    onTimePickerChange?: Function;
    onConfirmClick?: Function;
    hoverValue?: string[];
}, import("@vue/composition-api").ShallowUnwrapRef<{
    COMPONENT_NAME: import("@vue/composition-api").ComputedRef<string>;
    startTableData: import("@vue/composition-api").ComputedRef<any[]>;
    endTableData: import("@vue/composition-api").ComputedRef<any[]>;
    panelContentProps: import("@vue/composition-api").ComputedRef<{
        format: string;
        mode: "month" | "year" | "quarter" | "week" | "date";
        firstDayOfWeek: number;
        popupVisible: boolean;
        enableTimePicker: boolean;
        timePickerProps: {
            allowInput?: boolean;
            borderless?: boolean;
            clearable?: boolean;
            disableTime: ((h: number, m: number, s: number, ms: number) => Partial<{
                hour: number[];
                minute: number[];
                second: number[];
                millisecond: number[];
            }>) | ((h: number, m: number, s: number, context: {
                partial: import("../../time-picker").TimeRangePickerPartial;
            }) => Partial<{
                hour: number[];
                minute: number[];
                second: number[];
            }>);
            disabled?: boolean;
            readonly?: boolean;
            format?: string;
            hideDisabledTime?: boolean;
            inputProps?: import("../..").InputProps<import("../..").InputValue>;
            placeholder?: string;
            popupProps?: import("../..").TdPopupProps;
            presets?: import("../../time-picker").PresetTime;
            size?: "small" | "medium" | "large";
            status?: "error" | "default" | "success" | "warning";
            steps?: (string | number)[];
            tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
            value?: string;
            defaultValue?: string;
            onBlur?: (context: {
                value: string;
                e: FocusEvent;
            }) => void;
            onChange?: (value: string) => void;
            onClose?: (context: {
                e: MouseEvent;
            }) => void;
            onFocus?: (context: {
                value: string;
                e: FocusEvent;
            }) => void;
            onInput?: (context: {
                value: string;
                e: InputEvent;
            }) => void;
            onOpen?: (context: {
                e: MouseEvent;
            }) => void;
            onPick?: (value: string, context: {
                e: MouseEvent;
            }) => void;
        };
        onMonthChange: Function;
        onYearChange: Function;
        onJumperClick: Function;
        onCellClick: Function;
        onCellMouseEnter: Function;
        onCellMouseLeave: Function;
        onTimePickerChange: Function;
    }>;
}>, import("@vue/composition-api").Data, {}, {}, {}, {}, {}, {
    popupVisible: boolean;
    mode: "month" | "year" | "quarter" | "week" | "date";
    enableTimePicker: boolean;
    presetsPlacement: "left" | "top" | "bottom" | "right";
    cancelRangeSelectLimit: boolean;
    panelPreselection: boolean;
    isFirstValueSelected: boolean;
    hidePreselection: boolean;
} & {
    value?: string[];
    time?: string[];
    month?: number[];
    year?: number[];
    onClick?: Function;
    format?: string;
    firstDayOfWeek?: number;
    onCellClick?: Function;
    onMonthChange?: Function;
    activeIndex?: number;
    disableTime?: (times: Date[], context: {
        partial: import("../type").DateRangePickerPartial;
    }) => Partial<{
        hour: number[];
        minute: number[];
        second: number[];
    }>;
    presets?: import("../type").PresetRange;
    disableDate?: unknown;
    timePickerProps?: unknown;
    onPresetClick?: Function;
    onYearChange?: Function;
    onJumperClick?: Function;
    onCellMouseEnter?: Function;
    onCellMouseLeave?: Function;
    onTimePickerChange?: Function;
    onConfirmClick?: Function;
    hoverValue?: string[];
}, {
    popupVisible: boolean;
    mode: "month" | "year" | "quarter" | "week" | "date";
    enableTimePicker: boolean;
    presetsPlacement: "left" | "top" | "bottom" | "right";
    cancelRangeSelectLimit: boolean;
    panelPreselection: boolean;
    isFirstValueSelected: boolean;
    hidePreselection: boolean;
}, true>);
export default _default;
