import { TdDatePickerProps } from './type';
import { PropType } from 'vue';
declare const _default: {
    allowInput: BooleanConstructor;
    borderless: BooleanConstructor;
    clearable: BooleanConstructor;
    defaultTime: {
        type: StringConstructor;
        default: string;
    };
    disableDate: {
        type: PropType<import("./type").DisableDate>;
    };
    disableTime: {
        type: PropType<(time: Date) => Partial<{
            hour: number[];
            minute: number[];
            second: number[];
            millisecond: number[];
        }>>;
    };
    disabled: BooleanConstructor;
    readonly: {
        type: BooleanConstructor;
        default: any;
    };
    enableTimePicker: BooleanConstructor;
    firstDayOfWeek: {
        type: NumberConstructor;
        validator(val: TdDatePickerProps['firstDayOfWeek']): boolean;
    };
    format: {
        type: StringConstructor;
        default: any;
    };
    inputProps: {
        type: PropType<import("..").InputProps<import("..").InputValue>>;
    };
    label: {
        type: PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    mode: {
        type: PropType<"month" | "year" | "quarter" | "week" | "date">;
        default: "month" | "year" | "quarter" | "week" | "date";
        validator(val: TdDatePickerProps['mode']): boolean;
    };
    multiple: BooleanConstructor;
    placeholder: {
        type: PropType<string>;
        default: any;
    };
    popupProps: {
        type: PropType<import("..").TdPopupProps>;
    };
    prefixIcon: {
        type: PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    presets: {
        type: PropType<import("./type").PresetDate>;
    };
    presetsPlacement: {
        type: PropType<"left" | "top" | "bottom" | "right">;
        default: "left" | "top" | "bottom" | "right";
        validator(val: TdDatePickerProps['presetsPlacement']): boolean;
    };
    size: {
        type: PropType<import("..").SizeEnum>;
        default: import("..").SizeEnum;
        validator(val: TdDatePickerProps['size']): boolean;
    };
    status: {
        type: PropType<"error" | "default" | "success" | "warning">;
        default: "error" | "default" | "success" | "warning";
        validator(val: TdDatePickerProps['status']): boolean;
    };
    suffixIcon: {
        type: PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    timePickerProps: {
        type: PropType<import("..").TdTimePickerProps>;
    };
    tips: {
        type: PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    value: {
        type: PropType<import("./type").DateValue | import("./type").DateMultipleValue>;
        default: string;
    };
    defaultValue: {
        type: PropType<import("./type").DateValue | import("./type").DateMultipleValue>;
        default: string;
    };
    valueType: {
        type: PropType<import("./type").DatePickerValueType>;
        default: string;
    };
    onBlur: PropType<(context: {
        value: import("./type").DateValue | import("./type").DateMultipleValue;
        e: FocusEvent;
    }) => void>;
    onChange: PropType<(value: import("./type").DateValue | import("./type").DateMultipleValue, context: {
        dayjsValue?: import("dayjs").Dayjs;
        trigger?: import("./type").DatePickerTriggerSource;
    }) => void>;
    onConfirm: PropType<(context: {
        date: Date;
        e: MouseEvent;
    }) => void>;
    onFocus: PropType<(context: {
        value: import("./type").DateValue | import("./type").DateMultipleValue;
        e: FocusEvent;
    }) => void>;
    onPick: PropType<(value: import("./type").DateValue) => void>;
    onPresetClick: PropType<(context: {
        preset: import("./type").PresetDate;
        e: MouseEvent;
    }) => void>;
};
export default _default;
