/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

import _defineProperty from '@babel/runtime/helpers/defineProperty';
import props from './props.js';
import { renderContent } from '../utils/render-tnode.js';
import { getClassPrefixMixins } from '../config-provider/config-receiver.js';
import mixins from '../utils/mixins.js';
import '@babel/runtime/helpers/readOnlyError';
import '@babel/runtime/helpers/typeof';
import 'vue';
import '@vue/composition-api';
import 'lodash-es';
import '../config-provider/context.js';
import '../_common/js/global-config/default-config.js';
import '../_common/js/global-config/locale/zh_CN.js';
import '../_chunks/dep-a883488c.js';
import '../_chunks/dep-90ffe67f.js';
import 'dayjs';
import '../_chunks/dep-9d1c0d31.js';
import '../config-provider/type.js';

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var classPrefixMixins = getClassPrefixMixins("divider");
var _Divider = mixins(classPrefixMixins).extend({
  name: "TDivider",
  props: _objectSpread({}, props),
  render: function render() {
    var h = arguments[0];
    var children = renderContent(this, "default", "content");
    if (this.theme) {
      console.warn("TDesign Divider Warn: `theme` is going to be deprecated, please use `layout` instead.");
    }
    var dividerClassNames = ["".concat(this.componentName), ["".concat(this.componentName, "--").concat(this.layout || this.theme || "horizontal")], _defineProperty(_defineProperty(_defineProperty({}, "".concat(this.componentName, "--dashed"), !!this.dashed), "".concat(this.componentName, "--with-text"), !!children), "".concat(this.componentName, "--with-text-").concat(this.align), !!children)];
    return h("div", {
      "class": dividerClassNames
    }, [children && h("span", {
      "class": "".concat(this.componentName, "__inner-text")
    }, [children])]);
  }
});

export { _Divider as default };
//# sourceMappingURL=divider.js.map
