/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

import _defineProperty from '@babel/runtime/helpers/defineProperty';
import { renderTNodeJSX } from '../utils/render-tnode.js';
import { getClassPrefixMixins } from '../config-provider/config-receiver.js';
import mixins from '../utils/mixins.js';
import '@babel/runtime/helpers/readOnlyError';
import '@babel/runtime/helpers/typeof';
import 'vue';
import '@vue/composition-api';
import 'lodash-es';
import '../config-provider/context.js';
import '../_common/js/global-config/default-config.js';
import '../_common/js/global-config/locale/zh_CN.js';
import '../_chunks/dep-a883488c.js';
import '../_chunks/dep-90ffe67f.js';
import 'dayjs';
import '../_chunks/dep-9d1c0d31.js';
import '../config-provider/type.js';

var classPrefixMixins = getClassPrefixMixins("input-group");
var _InputGroup = mixins(classPrefixMixins).extend({
  name: "TInputGroup",
  props: {
    separate: {
      type: Boolean,
      "default": false
    }
  },
  computed: {
    classes: function classes() {
      return [this.componentName, _defineProperty({}, "".concat(this.componentName, "--separate"), this.separate)];
    }
  },
  render: function render() {
    var h = arguments[0];
    return h("div", {
      "class": this.classes
    }, [renderTNodeJSX(this, "default")]);
  }
});

export { _InputGroup as default };
//# sourceMappingURL=input-group.js.map
