/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

import _defineProperty from '@babel/runtime/helpers/defineProperty';
import { getCurrentInstance, computed } from '@vue/composition-api';
import { getVNodeComponentName, getVueComponentName } from '../../utils/helper.js';
import _ListItem from '../list-item.js';
import '@babel/runtime/helpers/objectWithoutProperties';
import '@babel/runtime/helpers/slicedToArray';
import 'lodash-es';
import '../list-item-props.js';
import '../../hooks/useConfig.js';
import '../../config-provider/useConfig.js';
import '../../config-provider/context.js';
import '../../_common/js/global-config/default-config.js';
import '../../_common/js/global-config/locale/zh_CN.js';
import '../../_chunks/dep-a883488c.js';
import '@babel/runtime/helpers/typeof';
import '../../_chunks/dep-90ffe67f.js';
import 'dayjs';
import '../../_chunks/dep-9d1c0d31.js';
import '../../config-provider/type.js';
import '../../utils/render-tnode.js';
import '@babel/runtime/helpers/readOnlyError';
import 'vue';

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var useListItems = function useListItems() {
  var instance = getCurrentInstance();
  var currentSlots = instance.proxy.$slots["default"] || [];
  var listItems = computed(function () {
    var computedListItems = [];
    currentSlots.forEach(function (child) {
      var componentName = getVNodeComponentName(child);
      if (componentName && componentName === getVueComponentName(_ListItem)) {
        computedListItems.push(_objectSpread(_objectSpread({
          "class": child.data.staticClass,
          style: child.data.staticStyle
        }, child.componentOptions.propsData), {}, {
          slots: function slots() {
            return child.componentOptions.children;
          }
        }));
      }
    });
    return computedListItems;
  });
  return {
    listItems: listItems
  };
};

export { useListItems as default };
//# sourceMappingURL=useListItem.js.map
