/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

import _defineProperty from '@babel/runtime/helpers/defineProperty';
import { defineComponent, computed } from '@vue/composition-api';
import { Popup } from '../popup/index.js';
import { usePrefixClass } from '../hooks/useConfig.js';
import _RangeInput from './range-input.js';
import props from './range-input-popup-props.js';
import useOverlayInnerStyle from '../select-input/useOverlayInnerStyle.js';
import '../popup/popup.js';
import '@babel/runtime/helpers/typeof';
import '@popperjs/core';
import 'lodash-es';
import '../utils/dom.js';
import 'vue';
import 'raf';
import '../utils/easing.js';
import '../utils/render-tnode.js';
import '@babel/runtime/helpers/readOnlyError';
import '../utils/helper.js';
import '@babel/runtime/helpers/objectWithoutProperties';
import '@babel/runtime/helpers/slicedToArray';
import '../_common/js/utils/setStyle.js';
import '../popup/props.js';
import '../popup/container.js';
import '../config-provider/config-receiver.js';
import '../config-provider/context.js';
import '../_common/js/global-config/default-config.js';
import '../_common/js/global-config/locale/zh_CN.js';
import '../_chunks/dep-a883488c.js';
import '../_chunks/dep-90ffe67f.js';
import 'dayjs';
import '../_chunks/dep-9d1c0d31.js';
import '../config-provider/type.js';
import '../utils/mixins.js';
import '../utils/event.js';
import '../popup/utils.js';
import '../utils/map-props.js';
import '../utils/withInstall.js';
import './style/css.js';
import '../popup/type.js';
import '../popup/plugin.js';
import '../_common/js/log/index.js';
import '../_common/js/log/log.js';
import '../config-provider/useConfig.js';
import 'tdesign-icons-vue';
import '../input/index.js';
import '../input/input.js';
import '../_chunks/dep-8db32566.js';
import '@babel/runtime/helpers/toConsumableArray';
import '../_common/js/utils/helper.js';
import '../input/props.js';
import '../input/input-group.js';
import '../input/type.js';
import './props.js';
import '../hooks/useVModel.js';
import '../hooks/useGlobalIcon.js';
import '../hooks/tnode.js';
import '../hooks/render-tnode.js';

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var _RangeInputPopup = defineComponent({
  name: "TRangeInputPopup",
  props: props,
  setup: function setup(props2) {
    var COMPONENT_NAME = usePrefixClass("range-input-popup");
    var _useOverlayInnerStyle = useOverlayInnerStyle(props2),
      tOverlayInnerStyle = _useOverlayInnerStyle.tOverlayInnerStyle,
      innerPopupVisible = _useOverlayInnerStyle.innerPopupVisible,
      onInnerPopupVisibleChange = _useOverlayInnerStyle.onInnerPopupVisibleChange;
    var popupClasses = computed(function () {
      return [COMPONENT_NAME.value, _defineProperty({}, "".concat(COMPONENT_NAME.value, "--visible"), props2.popupVisible || innerPopupVisible.value)];
    });
    return {
      COMPONENT_NAME: COMPONENT_NAME,
      tOverlayInnerStyle: tOverlayInnerStyle,
      innerPopupVisible: innerPopupVisible,
      onInnerPopupVisibleChange: onInnerPopupVisibleChange,
      popupClasses: popupClasses
    };
  },
  render: function render() {
    var h = arguments[0];
    var tOverlayInnerStyle = this.tOverlayInnerStyle,
      innerPopupVisible = this.innerPopupVisible,
      onInnerPopupVisibleChange = this.onInnerPopupVisibleChange,
      popupClasses = this.popupClasses;
    return h("div", {
      "class": popupClasses
    }, [h(Popup, {
      "attrs": {
        "hideEmptyPopup": true,
        "content": this.panel,
        "trigger": "click",
        "placement": "bottom-left",
        "visible": this.popupVisible || innerPopupVisible
      },
      "props": _objectSpread({}, _objectSpread({
        disabled: this.disabled || this.readonly,
        overlayInnerStyle: tOverlayInnerStyle,
        onVisibleChange: onInnerPopupVisibleChange
      }, this.popupProps))
    }, [h(_RangeInput, {
      "props": _objectSpread({}, _objectSpread({
        value: this.inputValue,
        onChange: this.onInputChange,
        disabled: this.disabled,
        label: this.label,
        status: this.status,
        tips: this.tips
      }, this.rangeInputProps))
    })])]);
  }
});

export { _RangeInputPopup as default };
//# sourceMappingURL=range-input-popup.js.map
