import { RangeInputValue, RangeInputPosition } from './type';
declare const _default: import("vue").ComponentOptions<import("vue").default, import("@vue/composition-api").ShallowUnwrapRef<{
    COMPONENT_NAME: import("@vue/composition-api").ComputedRef<string>;
    SIZE: import("@vue/composition-api").ComputedRef<{
        small: string;
        medium: string;
        large: string;
        default: string;
        xs: string;
        xl: string;
        block: string;
    }>;
    STATUS: import("@vue/composition-api").ComputedRef<{
        loading: string;
        loadMore: string;
        disabled: string;
        focused: string;
        success: string;
        error: string;
        warning: string;
        selected: string;
        active: string;
        checked: string;
        current: string;
        hidden: string;
        visible: string;
        expanded: string;
        indeterminate: string;
    }>;
    focused: import("@vue/composition-api").Ref<boolean>;
    classPrefix: import("@vue/composition-api").ComputedRef<string>;
    inputRefs: {
        firstInputRef: import("@vue/composition-api").Ref<any>;
        secondInputRef: import("@vue/composition-api").Ref<any>;
    };
    calcInputProps: import("@vue/composition-api").ComputedRef<any[]>;
    calcFormat: import("@vue/composition-api").ComputedRef<any[]>;
    calcPlaceholder: import("@vue/composition-api").ComputedRef<any[]>;
    innerValue: import("@vue/composition-api").Ref<RangeInputValue>;
    isShowClearIcon: import("@vue/composition-api").ComputedRef<boolean>;
    handleMouseEnter: (e: MouseEvent) => void;
    handleMouseLeave: (e: MouseEvent) => void;
    handleEnter: (rangeValue: RangeInputValue, context: {
        e: MouseEvent;
    }) => void;
    handleFocus: (rangeValue: RangeInputValue, context: {
        e: MouseEvent;
    }) => void;
    handleBlur: (rangeValue: RangeInputValue, context: {
        e: MouseEvent;
    }) => void;
    setInnerValue: import("../hooks/useVModel").ChangeHandler<RangeInputValue, [context?: {
        e?: MouseEvent | CompositionEvent | InputEvent;
        position?: RangeInputPosition;
        trigger?: "input" | "clear" | "initial";
    }]>;
    renderTNodeJSX: (name: string, options?: import("../hooks/render-tnode").OptionsType) => any;
    handleClear: (context: {
        e: MouseEvent;
    }) => void;
    CloseCircleFilledIcon: import("tdesign-icons-vue").GlobalIconType;
    firstInputElement: any;
    secondInputElement: any;
    focus: (options: any) => void;
    blur: (options: any) => void;
    select: (options: any) => void;
}> & import("@vue/composition-api").Data, {}, {}, {
    activeIndex: {
        type: NumberConstructor;
    };
    borderless: BooleanConstructor;
    clearable: BooleanConstructor;
    disabled: {
        type: BooleanConstructor;
        default: any;
    };
    format: {
        type: import("vue").PropType<import("../input").InputFormatType | import("../input").InputFormatType[]>;
    };
    inputProps: {
        type: import("vue").PropType<import("../input").InputProps<import("../input").InputValue> | import("../input").InputProps<import("../input").InputValue>[]>;
    };
    label: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    placeholder: {
        type: import("vue").PropType<string | string[]>;
    };
    prefixIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    readonly: BooleanConstructor;
    separator: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: string;
    };
    showClearIconOnEmpty: BooleanConstructor;
    size: {
        type: import("vue").PropType<"small" | "medium" | "large">;
        default: "small" | "medium" | "large";
        validator(val: "small" | "medium" | "large"): boolean;
    };
    status: {
        type: import("vue").PropType<"error" | "default" | "success" | "warning">;
        default: "error" | "default" | "success" | "warning";
        validator(val: "error" | "default" | "success" | "warning"): boolean;
    };
    suffix: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    suffixIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    tips: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    value: {
        type: import("vue").PropType<RangeInputValue>;
        default: any;
    };
    defaultValue: {
        type: import("vue").PropType<RangeInputValue>;
        default: () => RangeInputValue;
    };
    onBlur: import("vue").PropType<(value: RangeInputValue, context?: {
        e?: FocusEvent;
        position?: RangeInputPosition;
    }) => void>;
    onChange: import("vue").PropType<(value: RangeInputValue, context?: {
        e?: MouseEvent | CompositionEvent | InputEvent;
        position?: RangeInputPosition;
        trigger?: "input" | "clear" | "initial";
    }) => void>;
    onClear: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onClick: import("vue").PropType<(context?: {
        e?: MouseEvent;
        position?: RangeInputPosition;
    }) => void>;
    onEnter: import("vue").PropType<(value: RangeInputValue, context?: {
        e?: MouseEvent | InputEvent;
        position?: RangeInputPosition;
    }) => void>;
    onFocus: import("vue").PropType<(value: RangeInputValue, context?: {
        e?: FocusEvent;
        position?: RangeInputPosition;
    }) => void>;
    onMouseenter: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onMouseleave: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
}, import("@vue/composition-api").ExtractPropTypes<{
    activeIndex: {
        type: NumberConstructor;
    };
    borderless: BooleanConstructor;
    clearable: BooleanConstructor;
    disabled: {
        type: BooleanConstructor;
        default: any;
    };
    format: {
        type: import("vue").PropType<import("../input").InputFormatType | import("../input").InputFormatType[]>;
    };
    inputProps: {
        type: import("vue").PropType<import("../input").InputProps<import("../input").InputValue> | import("../input").InputProps<import("../input").InputValue>[]>;
    };
    label: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    placeholder: {
        type: import("vue").PropType<string | string[]>;
    };
    prefixIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    readonly: BooleanConstructor;
    separator: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: string;
    };
    showClearIconOnEmpty: BooleanConstructor;
    size: {
        type: import("vue").PropType<"small" | "medium" | "large">;
        default: "small" | "medium" | "large";
        validator(val: "small" | "medium" | "large"): boolean;
    };
    status: {
        type: import("vue").PropType<"error" | "default" | "success" | "warning">;
        default: "error" | "default" | "success" | "warning";
        validator(val: "error" | "default" | "success" | "warning"): boolean;
    };
    suffix: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    suffixIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    tips: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    value: {
        type: import("vue").PropType<RangeInputValue>;
        default: any;
    };
    defaultValue: {
        type: import("vue").PropType<RangeInputValue>;
        default: () => RangeInputValue;
    };
    onBlur: import("vue").PropType<(value: RangeInputValue, context?: {
        e?: FocusEvent;
        position?: RangeInputPosition;
    }) => void>;
    onChange: import("vue").PropType<(value: RangeInputValue, context?: {
        e?: MouseEvent | CompositionEvent | InputEvent;
        position?: RangeInputPosition;
        trigger?: "input" | "clear" | "initial";
    }) => void>;
    onClear: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onClick: import("vue").PropType<(context?: {
        e?: MouseEvent;
        position?: RangeInputPosition;
    }) => void>;
    onEnter: import("vue").PropType<(value: RangeInputValue, context?: {
        e?: MouseEvent | InputEvent;
        position?: RangeInputPosition;
    }) => void>;
    onFocus: import("vue").PropType<(value: RangeInputValue, context?: {
        e?: FocusEvent;
        position?: RangeInputPosition;
    }) => void>;
    onMouseenter: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onMouseleave: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
}>> & Omit<import("vue").VueConstructor<import("vue").default>, never> & (new (...args: any[]) => import("@vue/composition-api").ComponentRenderProxy<{
    value: RangeInputValue;
    disabled: boolean;
    size: "small" | "medium" | "large";
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    defaultValue: RangeInputValue;
    borderless: boolean;
    clearable: boolean;
    showClearIconOnEmpty: boolean;
    separator: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
} & {
    label?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onClick?: (context?: {
        e?: MouseEvent;
        position?: RangeInputPosition;
    }) => void;
    onChange?: (value: RangeInputValue, context?: {
        e?: MouseEvent | CompositionEvent | InputEvent;
        position?: RangeInputPosition;
        trigger?: "input" | "clear" | "initial";
    }) => void;
    format?: import("../input").InputFormatType | import("../input").InputFormatType[];
    prefixIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    suffix?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    suffixIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onBlur?: (value: RangeInputValue, context?: {
        e?: FocusEvent;
        position?: RangeInputPosition;
    }) => void;
    onClear?: (context: {
        e: MouseEvent;
    }) => void;
    onEnter?: (value: RangeInputValue, context?: {
        e?: MouseEvent | InputEvent;
        position?: RangeInputPosition;
    }) => void;
    onFocus?: (value: RangeInputValue, context?: {
        e?: FocusEvent;
        position?: RangeInputPosition;
    }) => void;
    onMouseenter?: (context: {
        e: MouseEvent;
    }) => void;
    onMouseleave?: (context: {
        e: MouseEvent;
    }) => void;
    placeholder?: string | string[];
    inputProps?: unknown;
    activeIndex?: number;
}, import("@vue/composition-api").ShallowUnwrapRef<{
    COMPONENT_NAME: import("@vue/composition-api").ComputedRef<string>;
    SIZE: import("@vue/composition-api").ComputedRef<{
        small: string;
        medium: string;
        large: string;
        default: string;
        xs: string;
        xl: string;
        block: string;
    }>;
    STATUS: import("@vue/composition-api").ComputedRef<{
        loading: string;
        loadMore: string;
        disabled: string;
        focused: string;
        success: string;
        error: string;
        warning: string;
        selected: string;
        active: string;
        checked: string;
        current: string;
        hidden: string;
        visible: string;
        expanded: string;
        indeterminate: string;
    }>;
    focused: import("@vue/composition-api").Ref<boolean>;
    classPrefix: import("@vue/composition-api").ComputedRef<string>;
    inputRefs: {
        firstInputRef: import("@vue/composition-api").Ref<any>;
        secondInputRef: import("@vue/composition-api").Ref<any>;
    };
    calcInputProps: import("@vue/composition-api").ComputedRef<any[]>;
    calcFormat: import("@vue/composition-api").ComputedRef<any[]>;
    calcPlaceholder: import("@vue/composition-api").ComputedRef<any[]>;
    innerValue: import("@vue/composition-api").Ref<RangeInputValue>;
    isShowClearIcon: import("@vue/composition-api").ComputedRef<boolean>;
    handleMouseEnter: (e: MouseEvent) => void;
    handleMouseLeave: (e: MouseEvent) => void;
    handleEnter: (rangeValue: RangeInputValue, context: {
        e: MouseEvent;
    }) => void;
    handleFocus: (rangeValue: RangeInputValue, context: {
        e: MouseEvent;
    }) => void;
    handleBlur: (rangeValue: RangeInputValue, context: {
        e: MouseEvent;
    }) => void;
    setInnerValue: import("../hooks/useVModel").ChangeHandler<RangeInputValue, [context?: {
        e?: MouseEvent | CompositionEvent | InputEvent;
        position?: RangeInputPosition;
        trigger?: "input" | "clear" | "initial";
    }]>;
    renderTNodeJSX: (name: string, options?: import("../hooks/render-tnode").OptionsType) => any;
    handleClear: (context: {
        e: MouseEvent;
    }) => void;
    CloseCircleFilledIcon: import("tdesign-icons-vue").GlobalIconType;
    firstInputElement: any;
    secondInputElement: any;
    focus: (options: any) => void;
    blur: (options: any) => void;
    select: (options: any) => void;
}>, import("@vue/composition-api").Data, {}, {}, {}, {}, {}, {
    value: RangeInputValue;
    disabled: boolean;
    size: "small" | "medium" | "large";
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    defaultValue: RangeInputValue;
    borderless: boolean;
    clearable: boolean;
    showClearIconOnEmpty: boolean;
    separator: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
} & {
    label?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onClick?: (context?: {
        e?: MouseEvent;
        position?: RangeInputPosition;
    }) => void;
    onChange?: (value: RangeInputValue, context?: {
        e?: MouseEvent | CompositionEvent | InputEvent;
        position?: RangeInputPosition;
        trigger?: "input" | "clear" | "initial";
    }) => void;
    format?: import("../input").InputFormatType | import("../input").InputFormatType[];
    prefixIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    suffix?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    suffixIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onBlur?: (value: RangeInputValue, context?: {
        e?: FocusEvent;
        position?: RangeInputPosition;
    }) => void;
    onClear?: (context: {
        e: MouseEvent;
    }) => void;
    onEnter?: (value: RangeInputValue, context?: {
        e?: MouseEvent | InputEvent;
        position?: RangeInputPosition;
    }) => void;
    onFocus?: (value: RangeInputValue, context?: {
        e?: FocusEvent;
        position?: RangeInputPosition;
    }) => void;
    onMouseenter?: (context: {
        e: MouseEvent;
    }) => void;
    onMouseleave?: (context: {
        e: MouseEvent;
    }) => void;
    placeholder?: string | string[];
    inputProps?: unknown;
    activeIndex?: number;
}, {
    value: RangeInputValue;
    disabled: boolean;
    size: "small" | "medium" | "large";
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    defaultValue: RangeInputValue;
    borderless: boolean;
    clearable: boolean;
    showClearIconOnEmpty: boolean;
    separator: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
}, true>);
export default _default;
