/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

var props = {
  autoWidth: Boolean,
  autofocus: Boolean,
  borderless: Boolean,
  clearable: Boolean,
  collapsedItems: {
    type: Function
  },
  creatable: Boolean,
  disabled: Boolean,
  empty: {
    type: [String, Function]
  },
  filter: {
    type: Function
  },
  filterable: Boolean,
  inputProps: {
    type: Object
  },
  inputValue: {
    type: [String, Number]
  },
  defaultInputValue: {
    type: [String, Number]
  },
  keys: {
    type: Object
  },
  label: {
    type: [String, Function]
  },
  loading: Boolean,
  loadingText: {
    type: [String, Function]
  },
  max: {
    type: Number,
    "default": 0
  },
  minCollapsedNum: {
    type: Number,
    "default": 0
  },
  multiple: Boolean,
  options: {
    type: Array
  },
  panelBottomContent: {
    type: [String, Function]
  },
  panelTopContent: {
    type: [String, Function]
  },
  placeholder: {
    type: String,
    "default": void 0
  },
  popupProps: {
    type: Object
  },
  popupVisible: {
    type: Boolean,
    "default": void 0
  },
  defaultPopupVisible: Boolean,
  prefixIcon: {
    type: Function
  },
  readonly: Boolean,
  reserveKeyword: Boolean,
  scroll: {
    type: Object
  },
  selectInputProps: {
    type: Object
  },
  showArrow: {
    type: Boolean,
    "default": true
  },
  size: {
    type: String,
    "default": "medium",
    validator: function validator(val) {
      if (!val) return true;
      return ["small", "medium", "large"].includes(val);
    }
  },
  status: {
    type: String,
    "default": "default",
    validator: function validator(val) {
      if (!val) return true;
      return ["default", "success", "warning", "error"].includes(val);
    }
  },
  suffix: {
    type: [String, Function]
  },
  suffixIcon: {
    type: Function
  },
  tagInputProps: {
    type: Object
  },
  tagProps: {
    type: Object
  },
  tips: {
    type: [String, Function]
  },
  value: {
    type: [String, Number, Boolean, Object, Array],
    "default": void 0
  },
  defaultValue: {
    type: [String, Number, Boolean, Object, Array],
    "default": void 0
  },
  valueDisplay: {
    type: [String, Function]
  },
  valueType: {
    type: String,
    "default": "value",
    validator: function validator(val) {
      if (!val) return true;
      return ["value", "object"].includes(val);
    }
  },
  onBlur: Function,
  onChange: Function,
  onClear: Function,
  onCreate: Function,
  onEnter: Function,
  onFocus: Function,
  onInputChange: Function,
  onPopupVisibleChange: Function,
  onRemove: Function,
  onSearch: Function
};

export { props as default };
//# sourceMappingURL=props.js.map
