/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

var primaryTableProps = {
  asyncLoading: {
    type: [String, Function]
  },
  columnController: {
    type: Object
  },
  columnControllerVisible: {
    type: Boolean,
    "default": void 0
  },
  defaultColumnControllerVisible: {
    type: Boolean,
    "default": void 0
  },
  columns: {
    type: Array,
    "default": function _default() {
      return [];
    }
  },
  displayColumns: {
    type: Array
  },
  defaultDisplayColumns: {
    type: Array
  },
  dragSort: {
    type: String,
    validator: function validator(val) {
      if (!val) return true;
      return ["row", "row-handler", "col", "row-handler-col", "drag-col"].includes(val);
    }
  },
  dragSortOptions: {
    type: Object
  },
  editableCellState: {
    type: Function
  },
  editableRowKeys: {
    type: Array
  },
  expandIcon: {
    type: [Boolean, Function],
    "default": true
  },
  expandOnRowClick: Boolean,
  expandedRow: {
    type: [String, Function]
  },
  expandedRowKeys: {
    type: Array,
    "default": function _default() {
      return [];
    }
  },
  defaultExpandedRowKeys: {
    type: Array,
    "default": function _default() {
      return [];
    }
  },
  filterIcon: {
    type: Function
  },
  filterRow: {
    type: [String, Function]
  },
  filterValue: {
    type: Object
  },
  defaultFilterValue: {
    type: Object
  },
  hideSortTips: Boolean,
  indeterminateSelectedRowKeys: {
    type: Array
  },
  multipleSort: Boolean,
  reserveSelectedRowOnPaginate: {
    type: Boolean,
    "default": true
  },
  rowSelectionAllowUncheck: Boolean,
  rowSelectionType: {
    type: String,
    validator: function validator(val) {
      if (!val) return true;
      return ["single", "multiple"].includes(val);
    }
  },
  selectOnRowClick: Boolean,
  selectedRowKeys: {
    type: Array,
    "default": function _default() {
      return [];
    }
  },
  defaultSelectedRowKeys: {
    type: Array,
    "default": function _default() {
      return [];
    }
  },
  showSortColumnBgColor: Boolean,
  sort: {
    type: [Object, Array]
  },
  defaultSort: {
    type: [Object, Array]
  },
  sortIcon: {
    type: Function
  },
  sortOnRowDraggable: Boolean,
  onAsyncLoadingClick: Function,
  onCellClick: Function,
  onChange: Function,
  onColumnChange: Function,
  onColumnControllerVisibleChange: Function,
  onDataChange: Function,
  onDisplayColumnsChange: Function,
  onDragSort: Function,
  onExpandChange: Function,
  onFilterChange: Function,
  onRowEdit: Function,
  onRowValidate: Function,
  onSelectChange: Function,
  onSortChange: Function,
  onValidate: Function
};

export { primaryTableProps as default };
//# sourceMappingURL=primary-table-props.js.map
