import { TdTimePickerProps, TdTimeRangePickerProps } from './type';
import './style';
export * from './interface';
export declare type TimePickerProps = TdTimePickerProps;
export declare type TimeRangePickerProps = TdTimeRangePickerProps;
export declare const TimePicker: import("vue").ComponentOptions<import("vue").default, import("@vue/composition-api").ShallowUnwrapRef<{
    handleClickConfirm: () => void;
    handlePanelChange: (v: string) => void;
    handleInputBlur: (value: string, { e }: {
        e: FocusEvent;
    }) => void;
    handleInputChange: (value: string) => void;
    handleClear: (context: {
        e: MouseEvent;
    }) => void;
    handleShowPopup: (visible: boolean, context: {
        e: MouseEvent;
    }) => void;
    handleOnFocus: (context: {
        value: string;
        e: FocusEvent;
    }) => void;
    handleOnPick: (v: string, e: MouseEvent) => void;
    inputClasses: import("@vue/composition-api").ComputedRef<(string | {
        [x: string]: boolean;
    })[]>;
    componentName: import("@vue/composition-api").ComputedRef<string>;
    innerValue: import("@vue/composition-api").Ref<string>;
    isShowPanel: import("@vue/composition-api").Ref<boolean>;
    global: import("@vue/composition-api").ComputedRef<{} & (import("..").TimePickerConfig | {
        readonly dayjsLocale: "zh-cn";
        readonly now: "此刻";
        readonly confirm: "确定";
        readonly anteMeridiem: "上午";
        readonly postMeridiem: "下午";
        readonly placeholder: "选择时间";
    }) & import("..").TimePickerConfig>;
    currentValue: import("@vue/composition-api").Ref<string>;
    TimeIcon: import("tdesign-icons-vue").GlobalIconType;
    isDisabled: import("@vue/composition-api").ComputedRef<boolean>;
}> & import("@vue/composition-api").Data, {}, {}, {
    allowInput: BooleanConstructor;
    borderless: BooleanConstructor;
    clearable: BooleanConstructor;
    disableTime: {
        type: import("vue").PropType<(h: number, m: number, s: number, ms: number) => Partial<{
            hour: number[];
            minute: number[];
            second: number[];
            millisecond: number[];
        }>>;
    };
    disabled: {
        type: BooleanConstructor;
        default: any;
    };
    readonly: {
        type: BooleanConstructor;
        default: any;
    };
    format: {
        type: StringConstructor;
        default: string;
    };
    hideDisabledTime: {
        type: BooleanConstructor;
        default: boolean;
    };
    inputProps: {
        type: import("vue").PropType<import("..").InputProps<import("..").InputValue>>;
    };
    placeholder: {
        type: StringConstructor;
        default: any;
    };
    popupProps: {
        type: import("vue").PropType<import("..").TdPopupProps>;
    };
    presets: {
        type: import("vue").PropType<import("./type").PresetTime>;
    };
    size: {
        type: import("vue").PropType<"small" | "medium" | "large">;
        default: "small" | "medium" | "large";
        validator(val: "small" | "medium" | "large"): boolean;
    };
    status: {
        type: import("vue").PropType<"error" | "default" | "success" | "warning">;
        default: "error" | "default" | "success" | "warning";
        validator(val: "error" | "default" | "success" | "warning"): boolean;
    };
    steps: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    tips: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    value: {
        type: import("vue").PropType<string>;
        default: any;
    };
    defaultValue: {
        type: import("vue").PropType<string>;
        default: string;
    };
    onBlur: import("vue").PropType<(context: {
        value: string;
        e: FocusEvent;
    }) => void>;
    onChange: import("vue").PropType<(value: string) => void>;
    onClose: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onFocus: import("vue").PropType<(context: {
        value: string;
        e: FocusEvent;
    }) => void>;
    onInput: import("vue").PropType<(context: {
        value: string;
        e: InputEvent;
    }) => void>;
    onOpen: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onPick: import("vue").PropType<(value: string, context: {
        e: MouseEvent;
    }) => void>;
}, import("@vue/composition-api").ExtractPropTypes<{
    allowInput: BooleanConstructor;
    borderless: BooleanConstructor;
    clearable: BooleanConstructor;
    disableTime: {
        type: import("vue").PropType<(h: number, m: number, s: number, ms: number) => Partial<{
            hour: number[];
            minute: number[];
            second: number[];
            millisecond: number[];
        }>>;
    };
    disabled: {
        type: BooleanConstructor;
        default: any;
    };
    readonly: {
        type: BooleanConstructor;
        default: any;
    };
    format: {
        type: StringConstructor;
        default: string;
    };
    hideDisabledTime: {
        type: BooleanConstructor;
        default: boolean;
    };
    inputProps: {
        type: import("vue").PropType<import("..").InputProps<import("..").InputValue>>;
    };
    placeholder: {
        type: StringConstructor;
        default: any;
    };
    popupProps: {
        type: import("vue").PropType<import("..").TdPopupProps>;
    };
    presets: {
        type: import("vue").PropType<import("./type").PresetTime>;
    };
    size: {
        type: import("vue").PropType<"small" | "medium" | "large">;
        default: "small" | "medium" | "large";
        validator(val: "small" | "medium" | "large"): boolean;
    };
    status: {
        type: import("vue").PropType<"error" | "default" | "success" | "warning">;
        default: "error" | "default" | "success" | "warning";
        validator(val: "error" | "default" | "success" | "warning"): boolean;
    };
    steps: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    tips: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    value: {
        type: import("vue").PropType<string>;
        default: any;
    };
    defaultValue: {
        type: import("vue").PropType<string>;
        default: string;
    };
    onBlur: import("vue").PropType<(context: {
        value: string;
        e: FocusEvent;
    }) => void>;
    onChange: import("vue").PropType<(value: string) => void>;
    onClose: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onFocus: import("vue").PropType<(context: {
        value: string;
        e: FocusEvent;
    }) => void>;
    onInput: import("vue").PropType<(context: {
        value: string;
        e: InputEvent;
    }) => void>;
    onOpen: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onPick: import("vue").PropType<(value: string, context: {
        e: MouseEvent;
    }) => void>;
}>> & Omit<import("vue").VueConstructor<import("vue").default>, never> & (new (...args: any[]) => import("@vue/composition-api").ComponentRenderProxy<{
    value: string;
    disabled: boolean;
    size: "small" | "medium" | "large";
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    defaultValue: string;
    steps: (string | number)[];
    format: string;
    borderless: boolean;
    clearable: boolean;
    placeholder: string;
    allowInput: boolean;
    hideDisabledTime: boolean;
} & {
    onChange?: (value: string) => void;
    onClose?: (context: {
        e: MouseEvent;
    }) => void;
    tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onBlur?: (context: {
        value: string;
        e: FocusEvent;
    }) => void;
    onFocus?: (context: {
        value: string;
        e: FocusEvent;
    }) => void;
    inputProps?: unknown;
    popupProps?: unknown;
    disableTime?: (h: number, m: number, s: number, ms: number) => Partial<{
        hour: number[];
        minute: number[];
        second: number[];
        millisecond: number[];
    }>;
    presets?: import("./type").PresetTime;
    onInput?: (context: {
        value: string;
        e: InputEvent;
    }) => void;
    onOpen?: (context: {
        e: MouseEvent;
    }) => void;
    onPick?: (value: string, context: {
        e: MouseEvent;
    }) => void;
}, import("@vue/composition-api").ShallowUnwrapRef<{
    handleClickConfirm: () => void;
    handlePanelChange: (v: string) => void;
    handleInputBlur: (value: string, { e }: {
        e: FocusEvent;
    }) => void;
    handleInputChange: (value: string) => void;
    handleClear: (context: {
        e: MouseEvent;
    }) => void;
    handleShowPopup: (visible: boolean, context: {
        e: MouseEvent;
    }) => void;
    handleOnFocus: (context: {
        value: string;
        e: FocusEvent;
    }) => void;
    handleOnPick: (v: string, e: MouseEvent) => void;
    inputClasses: import("@vue/composition-api").ComputedRef<(string | {
        [x: string]: boolean;
    })[]>;
    componentName: import("@vue/composition-api").ComputedRef<string>;
    innerValue: import("@vue/composition-api").Ref<string>;
    isShowPanel: import("@vue/composition-api").Ref<boolean>;
    global: import("@vue/composition-api").ComputedRef<{} & (import("..").TimePickerConfig | {
        readonly dayjsLocale: "zh-cn";
        readonly now: "此刻";
        readonly confirm: "确定";
        readonly anteMeridiem: "上午";
        readonly postMeridiem: "下午";
        readonly placeholder: "选择时间";
    }) & import("..").TimePickerConfig>;
    currentValue: import("@vue/composition-api").Ref<string>;
    TimeIcon: import("tdesign-icons-vue").GlobalIconType;
    isDisabled: import("@vue/composition-api").ComputedRef<boolean>;
}>, import("@vue/composition-api").Data, {}, {}, {}, {}, {}, {
    value: string;
    disabled: boolean;
    size: "small" | "medium" | "large";
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    defaultValue: string;
    steps: (string | number)[];
    format: string;
    borderless: boolean;
    clearable: boolean;
    placeholder: string;
    allowInput: boolean;
    hideDisabledTime: boolean;
} & {
    onChange?: (value: string) => void;
    onClose?: (context: {
        e: MouseEvent;
    }) => void;
    tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onBlur?: (context: {
        value: string;
        e: FocusEvent;
    }) => void;
    onFocus?: (context: {
        value: string;
        e: FocusEvent;
    }) => void;
    inputProps?: unknown;
    popupProps?: unknown;
    disableTime?: (h: number, m: number, s: number, ms: number) => Partial<{
        hour: number[];
        minute: number[];
        second: number[];
        millisecond: number[];
    }>;
    presets?: import("./type").PresetTime;
    onInput?: (context: {
        value: string;
        e: InputEvent;
    }) => void;
    onOpen?: (context: {
        e: MouseEvent;
    }) => void;
    onPick?: (value: string, context: {
        e: MouseEvent;
    }) => void;
}, {
    value: string;
    disabled: boolean;
    size: "small" | "medium" | "large";
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    defaultValue: string;
    steps: (string | number)[];
    format: string;
    borderless: boolean;
    clearable: boolean;
    placeholder: string;
    allowInput: boolean;
    hideDisabledTime: boolean;
}, true>) & import("vue").PluginObject<import("vue").ComponentOptions<import("vue").default, import("@vue/composition-api").ShallowUnwrapRef<{
    handleClickConfirm: () => void;
    handlePanelChange: (v: string) => void;
    handleInputBlur: (value: string, { e }: {
        e: FocusEvent;
    }) => void;
    handleInputChange: (value: string) => void;
    handleClear: (context: {
        e: MouseEvent;
    }) => void;
    handleShowPopup: (visible: boolean, context: {
        e: MouseEvent;
    }) => void;
    handleOnFocus: (context: {
        value: string;
        e: FocusEvent;
    }) => void;
    handleOnPick: (v: string, e: MouseEvent) => void;
    inputClasses: import("@vue/composition-api").ComputedRef<(string | {
        [x: string]: boolean;
    })[]>;
    componentName: import("@vue/composition-api").ComputedRef<string>;
    innerValue: import("@vue/composition-api").Ref<string>;
    isShowPanel: import("@vue/composition-api").Ref<boolean>;
    global: import("@vue/composition-api").ComputedRef<{} & (import("..").TimePickerConfig | {
        readonly dayjsLocale: "zh-cn";
        readonly now: "此刻";
        readonly confirm: "确定";
        readonly anteMeridiem: "上午";
        readonly postMeridiem: "下午";
        readonly placeholder: "选择时间";
    }) & import("..").TimePickerConfig>;
    currentValue: import("@vue/composition-api").Ref<string>;
    TimeIcon: import("tdesign-icons-vue").GlobalIconType;
    isDisabled: import("@vue/composition-api").ComputedRef<boolean>;
}> & import("@vue/composition-api").Data, {}, {}, {
    allowInput: BooleanConstructor;
    borderless: BooleanConstructor;
    clearable: BooleanConstructor;
    disableTime: {
        type: import("vue").PropType<(h: number, m: number, s: number, ms: number) => Partial<{
            hour: number[];
            minute: number[];
            second: number[];
            millisecond: number[];
        }>>;
    };
    disabled: {
        type: BooleanConstructor;
        default: any;
    };
    readonly: {
        type: BooleanConstructor;
        default: any;
    };
    format: {
        type: StringConstructor;
        default: string;
    };
    hideDisabledTime: {
        type: BooleanConstructor;
        default: boolean;
    };
    inputProps: {
        type: import("vue").PropType<import("..").InputProps<import("..").InputValue>>;
    };
    placeholder: {
        type: StringConstructor;
        default: any;
    };
    popupProps: {
        type: import("vue").PropType<import("..").TdPopupProps>;
    };
    presets: {
        type: import("vue").PropType<import("./type").PresetTime>;
    };
    size: {
        type: import("vue").PropType<"small" | "medium" | "large">;
        default: "small" | "medium" | "large";
        validator(val: "small" | "medium" | "large"): boolean;
    };
    status: {
        type: import("vue").PropType<"error" | "default" | "success" | "warning">;
        default: "error" | "default" | "success" | "warning";
        validator(val: "error" | "default" | "success" | "warning"): boolean;
    };
    steps: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    tips: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    value: {
        type: import("vue").PropType<string>;
        default: any;
    };
    defaultValue: {
        type: import("vue").PropType<string>;
        default: string;
    };
    onBlur: import("vue").PropType<(context: {
        value: string;
        e: FocusEvent;
    }) => void>;
    onChange: import("vue").PropType<(value: string) => void>;
    onClose: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onFocus: import("vue").PropType<(context: {
        value: string;
        e: FocusEvent;
    }) => void>;
    onInput: import("vue").PropType<(context: {
        value: string;
        e: InputEvent;
    }) => void>;
    onOpen: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onPick: import("vue").PropType<(value: string, context: {
        e: MouseEvent;
    }) => void>;
}, import("@vue/composition-api").ExtractPropTypes<{
    allowInput: BooleanConstructor;
    borderless: BooleanConstructor;
    clearable: BooleanConstructor;
    disableTime: {
        type: import("vue").PropType<(h: number, m: number, s: number, ms: number) => Partial<{
            hour: number[];
            minute: number[];
            second: number[];
            millisecond: number[];
        }>>;
    };
    disabled: {
        type: BooleanConstructor;
        default: any;
    };
    readonly: {
        type: BooleanConstructor;
        default: any;
    };
    format: {
        type: StringConstructor;
        default: string;
    };
    hideDisabledTime: {
        type: BooleanConstructor;
        default: boolean;
    };
    inputProps: {
        type: import("vue").PropType<import("..").InputProps<import("..").InputValue>>;
    };
    placeholder: {
        type: StringConstructor;
        default: any;
    };
    popupProps: {
        type: import("vue").PropType<import("..").TdPopupProps>;
    };
    presets: {
        type: import("vue").PropType<import("./type").PresetTime>;
    };
    size: {
        type: import("vue").PropType<"small" | "medium" | "large">;
        default: "small" | "medium" | "large";
        validator(val: "small" | "medium" | "large"): boolean;
    };
    status: {
        type: import("vue").PropType<"error" | "default" | "success" | "warning">;
        default: "error" | "default" | "success" | "warning";
        validator(val: "error" | "default" | "success" | "warning"): boolean;
    };
    steps: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    tips: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    value: {
        type: import("vue").PropType<string>;
        default: any;
    };
    defaultValue: {
        type: import("vue").PropType<string>;
        default: string;
    };
    onBlur: import("vue").PropType<(context: {
        value: string;
        e: FocusEvent;
    }) => void>;
    onChange: import("vue").PropType<(value: string) => void>;
    onClose: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onFocus: import("vue").PropType<(context: {
        value: string;
        e: FocusEvent;
    }) => void>;
    onInput: import("vue").PropType<(context: {
        value: string;
        e: InputEvent;
    }) => void>;
    onOpen: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onPick: import("vue").PropType<(value: string, context: {
        e: MouseEvent;
    }) => void>;
}>> & Omit<import("vue").VueConstructor<import("vue").default>, never> & (new (...args: any[]) => import("@vue/composition-api").ComponentRenderProxy<{
    value: string;
    disabled: boolean;
    size: "small" | "medium" | "large";
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    defaultValue: string;
    steps: (string | number)[];
    format: string;
    borderless: boolean;
    clearable: boolean;
    placeholder: string;
    allowInput: boolean;
    hideDisabledTime: boolean;
} & {
    onChange?: (value: string) => void;
    onClose?: (context: {
        e: MouseEvent;
    }) => void;
    tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onBlur?: (context: {
        value: string;
        e: FocusEvent;
    }) => void;
    onFocus?: (context: {
        value: string;
        e: FocusEvent;
    }) => void;
    inputProps?: unknown;
    popupProps?: unknown;
    disableTime?: (h: number, m: number, s: number, ms: number) => Partial<{
        hour: number[];
        minute: number[];
        second: number[];
        millisecond: number[];
    }>;
    presets?: import("./type").PresetTime;
    onInput?: (context: {
        value: string;
        e: InputEvent;
    }) => void;
    onOpen?: (context: {
        e: MouseEvent;
    }) => void;
    onPick?: (value: string, context: {
        e: MouseEvent;
    }) => void;
}, import("@vue/composition-api").ShallowUnwrapRef<{
    handleClickConfirm: () => void;
    handlePanelChange: (v: string) => void;
    handleInputBlur: (value: string, { e }: {
        e: FocusEvent;
    }) => void;
    handleInputChange: (value: string) => void;
    handleClear: (context: {
        e: MouseEvent;
    }) => void;
    handleShowPopup: (visible: boolean, context: {
        e: MouseEvent;
    }) => void;
    handleOnFocus: (context: {
        value: string;
        e: FocusEvent;
    }) => void;
    handleOnPick: (v: string, e: MouseEvent) => void;
    inputClasses: import("@vue/composition-api").ComputedRef<(string | {
        [x: string]: boolean;
    })[]>;
    componentName: import("@vue/composition-api").ComputedRef<string>;
    innerValue: import("@vue/composition-api").Ref<string>;
    isShowPanel: import("@vue/composition-api").Ref<boolean>;
    global: import("@vue/composition-api").ComputedRef<{} & (import("..").TimePickerConfig | {
        readonly dayjsLocale: "zh-cn";
        readonly now: "此刻";
        readonly confirm: "确定";
        readonly anteMeridiem: "上午";
        readonly postMeridiem: "下午";
        readonly placeholder: "选择时间";
    }) & import("..").TimePickerConfig>;
    currentValue: import("@vue/composition-api").Ref<string>;
    TimeIcon: import("tdesign-icons-vue").GlobalIconType;
    isDisabled: import("@vue/composition-api").ComputedRef<boolean>;
}>, import("@vue/composition-api").Data, {}, {}, {}, {}, {}, {
    value: string;
    disabled: boolean;
    size: "small" | "medium" | "large";
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    defaultValue: string;
    steps: (string | number)[];
    format: string;
    borderless: boolean;
    clearable: boolean;
    placeholder: string;
    allowInput: boolean;
    hideDisabledTime: boolean;
} & {
    onChange?: (value: string) => void;
    onClose?: (context: {
        e: MouseEvent;
    }) => void;
    tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onBlur?: (context: {
        value: string;
        e: FocusEvent;
    }) => void;
    onFocus?: (context: {
        value: string;
        e: FocusEvent;
    }) => void;
    inputProps?: unknown;
    popupProps?: unknown;
    disableTime?: (h: number, m: number, s: number, ms: number) => Partial<{
        hour: number[];
        minute: number[];
        second: number[];
        millisecond: number[];
    }>;
    presets?: import("./type").PresetTime;
    onInput?: (context: {
        value: string;
        e: InputEvent;
    }) => void;
    onOpen?: (context: {
        e: MouseEvent;
    }) => void;
    onPick?: (value: string, context: {
        e: MouseEvent;
    }) => void;
}, {
    value: string;
    disabled: boolean;
    size: "small" | "medium" | "large";
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    defaultValue: string;
    steps: (string | number)[];
    format: string;
    borderless: boolean;
    clearable: boolean;
    placeholder: string;
    allowInput: boolean;
    hideDisabledTime: boolean;
}, true>)>;
export declare const TimeRangePicker: import("vue").ComponentOptions<import("vue").default, import("@vue/composition-api").ShallowUnwrapRef<{
    global: import("@vue/composition-api").ComputedRef<{} & (import("..").TimePickerConfig | {
        readonly dayjsLocale: "zh-cn";
        readonly now: "此刻";
        readonly confirm: "确定";
        readonly anteMeridiem: "上午";
        readonly postMeridiem: "下午";
        readonly placeholder: "选择时间";
    }) & import("..").TimePickerConfig>;
    componentName: import("@vue/composition-api").ComputedRef<string>;
    currentValue: import("@vue/composition-api").Ref<string[]>;
    currentPanelIdx: any;
    inputClasses: import("@vue/composition-api").ComputedRef<(string | {
        [x: string]: boolean;
    })[]>;
    innerValue: import("@vue/composition-api").Ref<import("./type").TimeRangeValue>;
    isShowPanel: import("@vue/composition-api").Ref<boolean>;
    handleInputChange: (inputVal: import("./type").TimeRangeValue, { e, position }: {
        e: InputEvent;
        position: import("..").RangeInputPosition;
    }) => void;
    handleShowPopup: (visible: boolean, context: any) => void;
    handleClear: (context: {
        e: MouseEvent;
    }) => void;
    handleFocus: (value: import("./type").TimeRangeValue, { e, position }: {
        e: FocusEvent;
        position: import("..").RangeInputPosition;
    }) => void;
    handleOnPick: (pickValue: string, e: MouseEvent) => void;
    handleClickConfirm: () => void;
    handleClick: ({ position }: {
        position: "second" | "first";
    }) => void;
    handleInputBlur: (value: import("./type").TimeRangeValue, { e }: {
        e: FocusEvent;
    }) => void;
    handleTimeChange: (newValue: string) => void;
    TimeIcon: import("tdesign-icons-vue").GlobalIconType;
    isDisabled: import("@vue/composition-api").ComputedRef<boolean | boolean[]>;
}> & import("@vue/composition-api").Data, {}, {}, {
    rangeInputProps: ObjectConstructor;
    popupProps: ObjectConstructor;
    allowInput: BooleanConstructor;
    autoSwap: {
        type: BooleanConstructor;
        default: boolean;
    };
    borderless: BooleanConstructor;
    clearable: BooleanConstructor;
    disableTime: {
        type: import("vue").PropType<(h: number, m: number, s: number, context: {
            partial: import("./type").TimeRangePickerPartial;
        }) => Partial<{
            hour: number[];
            minute: number[];
            second: number[];
        }>>;
    };
    disabled: {
        type: import("vue").PropType<boolean | boolean[]>;
        default: any;
    };
    readonly: {
        type: BooleanConstructor;
        default: any;
    };
    format: {
        type: StringConstructor;
        default: string;
    };
    hideDisabledTime: {
        type: BooleanConstructor;
        default: boolean;
    };
    placeholder: {
        type: import("vue").PropType<string | string[]>;
        default: any;
    };
    presets: {
        type: import("vue").PropType<import("./type").PresetTimeRange>;
    };
    size: {
        type: import("vue").PropType<"small" | "medium" | "large">;
        default: "small" | "medium" | "large";
        validator(val: "small" | "medium" | "large"): boolean;
    };
    status: {
        type: import("vue").PropType<"error" | "default" | "success" | "warning">;
        default: "error" | "default" | "success" | "warning";
        validator(val: "error" | "default" | "success" | "warning"): boolean;
    };
    steps: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    tips: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    value: {
        type: import("vue").PropType<import("./type").TimeRangeValue>;
        default: any;
    };
    defaultValue: {
        type: import("vue").PropType<import("./type").TimeRangeValue>;
    };
    onBlur: import("vue").PropType<(context: {
        value: import("./type").TimeRangeValue;
        e?: FocusEvent;
        position?: import("./type").TimeRangePickerPartial;
    }) => void>;
    onChange: import("vue").PropType<(value: import("./type").TimeRangeValue) => void>;
    onFocus: import("vue").PropType<(context?: {
        value: import("./type").TimeRangeValue;
        e?: FocusEvent;
        position?: import("./type").TimeRangePickerPartial;
    }) => void>;
    onInput: import("vue").PropType<(context: {
        value: import("./type").TimeRangeValue;
        e?: InputEvent;
        position?: import("./type").TimeRangePickerPartial;
    }) => void>;
    onPick: import("vue").PropType<(value: import("./type").TimeRangeValue, context: {
        e: MouseEvent;
        position?: import("./type").TimeRangePickerPartial;
    }) => void>;
}, import("@vue/composition-api").ExtractPropTypes<{
    rangeInputProps: ObjectConstructor;
    popupProps: ObjectConstructor;
    allowInput: BooleanConstructor;
    autoSwap: {
        type: BooleanConstructor;
        default: boolean;
    };
    borderless: BooleanConstructor;
    clearable: BooleanConstructor;
    disableTime: {
        type: import("vue").PropType<(h: number, m: number, s: number, context: {
            partial: import("./type").TimeRangePickerPartial;
        }) => Partial<{
            hour: number[];
            minute: number[];
            second: number[];
        }>>;
    };
    disabled: {
        type: import("vue").PropType<boolean | boolean[]>;
        default: any;
    };
    readonly: {
        type: BooleanConstructor;
        default: any;
    };
    format: {
        type: StringConstructor;
        default: string;
    };
    hideDisabledTime: {
        type: BooleanConstructor;
        default: boolean;
    };
    placeholder: {
        type: import("vue").PropType<string | string[]>;
        default: any;
    };
    presets: {
        type: import("vue").PropType<import("./type").PresetTimeRange>;
    };
    size: {
        type: import("vue").PropType<"small" | "medium" | "large">;
        default: "small" | "medium" | "large";
        validator(val: "small" | "medium" | "large"): boolean;
    };
    status: {
        type: import("vue").PropType<"error" | "default" | "success" | "warning">;
        default: "error" | "default" | "success" | "warning";
        validator(val: "error" | "default" | "success" | "warning"): boolean;
    };
    steps: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    tips: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    value: {
        type: import("vue").PropType<import("./type").TimeRangeValue>;
        default: any;
    };
    defaultValue: {
        type: import("vue").PropType<import("./type").TimeRangeValue>;
    };
    onBlur: import("vue").PropType<(context: {
        value: import("./type").TimeRangeValue;
        e?: FocusEvent;
        position?: import("./type").TimeRangePickerPartial;
    }) => void>;
    onChange: import("vue").PropType<(value: import("./type").TimeRangeValue) => void>;
    onFocus: import("vue").PropType<(context?: {
        value: import("./type").TimeRangeValue;
        e?: FocusEvent;
        position?: import("./type").TimeRangePickerPartial;
    }) => void>;
    onInput: import("vue").PropType<(context: {
        value: import("./type").TimeRangeValue;
        e?: InputEvent;
        position?: import("./type").TimeRangePickerPartial;
    }) => void>;
    onPick: import("vue").PropType<(value: import("./type").TimeRangeValue, context: {
        e: MouseEvent;
        position?: import("./type").TimeRangePickerPartial;
    }) => void>;
}>> & Omit<import("vue").VueConstructor<import("vue").default>, never> & (new (...args: any[]) => import("@vue/composition-api").ComponentRenderProxy<{
    value: import("./type").TimeRangeValue;
    disabled: boolean | boolean[];
    size: "small" | "medium" | "large";
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    steps: (string | number)[];
    format: string;
    borderless: boolean;
    clearable: boolean;
    placeholder: string | string[];
    allowInput: boolean;
    hideDisabledTime: boolean;
    autoSwap: boolean;
} & {
    onChange?: (value: import("./type").TimeRangeValue) => void;
    defaultValue?: import("./type").TimeRangeValue;
    tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onBlur?: (context: {
        value: import("./type").TimeRangeValue;
        e?: FocusEvent;
        position?: import("./type").TimeRangePickerPartial;
    }) => void;
    onFocus?: (context?: {
        value: import("./type").TimeRangeValue;
        e?: FocusEvent;
        position?: import("./type").TimeRangePickerPartial;
    }) => void;
    popupProps?: Record<string, any>;
    rangeInputProps?: Record<string, any>;
    disableTime?: (h: number, m: number, s: number, context: {
        partial: import("./type").TimeRangePickerPartial;
    }) => Partial<{
        hour: number[];
        minute: number[];
        second: number[];
    }>;
    presets?: import("./type").PresetTimeRange;
    onInput?: (context: {
        value: import("./type").TimeRangeValue;
        e?: InputEvent;
        position?: import("./type").TimeRangePickerPartial;
    }) => void;
    onPick?: (value: import("./type").TimeRangeValue, context: {
        e: MouseEvent;
        position?: import("./type").TimeRangePickerPartial;
    }) => void;
}, import("@vue/composition-api").ShallowUnwrapRef<{
    global: import("@vue/composition-api").ComputedRef<{} & (import("..").TimePickerConfig | {
        readonly dayjsLocale: "zh-cn";
        readonly now: "此刻";
        readonly confirm: "确定";
        readonly anteMeridiem: "上午";
        readonly postMeridiem: "下午";
        readonly placeholder: "选择时间";
    }) & import("..").TimePickerConfig>;
    componentName: import("@vue/composition-api").ComputedRef<string>;
    currentValue: import("@vue/composition-api").Ref<string[]>;
    currentPanelIdx: any;
    inputClasses: import("@vue/composition-api").ComputedRef<(string | {
        [x: string]: boolean;
    })[]>;
    innerValue: import("@vue/composition-api").Ref<import("./type").TimeRangeValue>;
    isShowPanel: import("@vue/composition-api").Ref<boolean>;
    handleInputChange: (inputVal: import("./type").TimeRangeValue, { e, position }: {
        e: InputEvent;
        position: import("..").RangeInputPosition;
    }) => void;
    handleShowPopup: (visible: boolean, context: any) => void;
    handleClear: (context: {
        e: MouseEvent;
    }) => void;
    handleFocus: (value: import("./type").TimeRangeValue, { e, position }: {
        e: FocusEvent;
        position: import("..").RangeInputPosition;
    }) => void;
    handleOnPick: (pickValue: string, e: MouseEvent) => void;
    handleClickConfirm: () => void;
    handleClick: ({ position }: {
        position: "second" | "first";
    }) => void;
    handleInputBlur: (value: import("./type").TimeRangeValue, { e }: {
        e: FocusEvent;
    }) => void;
    handleTimeChange: (newValue: string) => void;
    TimeIcon: import("tdesign-icons-vue").GlobalIconType;
    isDisabled: import("@vue/composition-api").ComputedRef<boolean | boolean[]>;
}>, import("@vue/composition-api").Data, {}, {}, {}, {}, {}, {
    value: import("./type").TimeRangeValue;
    disabled: boolean | boolean[];
    size: "small" | "medium" | "large";
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    steps: (string | number)[];
    format: string;
    borderless: boolean;
    clearable: boolean;
    placeholder: string | string[];
    allowInput: boolean;
    hideDisabledTime: boolean;
    autoSwap: boolean;
} & {
    onChange?: (value: import("./type").TimeRangeValue) => void;
    defaultValue?: import("./type").TimeRangeValue;
    tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onBlur?: (context: {
        value: import("./type").TimeRangeValue;
        e?: FocusEvent;
        position?: import("./type").TimeRangePickerPartial;
    }) => void;
    onFocus?: (context?: {
        value: import("./type").TimeRangeValue;
        e?: FocusEvent;
        position?: import("./type").TimeRangePickerPartial;
    }) => void;
    popupProps?: Record<string, any>;
    rangeInputProps?: Record<string, any>;
    disableTime?: (h: number, m: number, s: number, context: {
        partial: import("./type").TimeRangePickerPartial;
    }) => Partial<{
        hour: number[];
        minute: number[];
        second: number[];
    }>;
    presets?: import("./type").PresetTimeRange;
    onInput?: (context: {
        value: import("./type").TimeRangeValue;
        e?: InputEvent;
        position?: import("./type").TimeRangePickerPartial;
    }) => void;
    onPick?: (value: import("./type").TimeRangeValue, context: {
        e: MouseEvent;
        position?: import("./type").TimeRangePickerPartial;
    }) => void;
}, {
    value: import("./type").TimeRangeValue;
    disabled: boolean | boolean[];
    size: "small" | "medium" | "large";
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    steps: (string | number)[];
    format: string;
    borderless: boolean;
    clearable: boolean;
    placeholder: string | string[];
    allowInput: boolean;
    hideDisabledTime: boolean;
    autoSwap: boolean;
}, true>) & import("vue").PluginObject<import("vue").ComponentOptions<import("vue").default, import("@vue/composition-api").ShallowUnwrapRef<{
    global: import("@vue/composition-api").ComputedRef<{} & (import("..").TimePickerConfig | {
        readonly dayjsLocale: "zh-cn";
        readonly now: "此刻";
        readonly confirm: "确定";
        readonly anteMeridiem: "上午";
        readonly postMeridiem: "下午";
        readonly placeholder: "选择时间";
    }) & import("..").TimePickerConfig>;
    componentName: import("@vue/composition-api").ComputedRef<string>;
    currentValue: import("@vue/composition-api").Ref<string[]>;
    currentPanelIdx: any;
    inputClasses: import("@vue/composition-api").ComputedRef<(string | {
        [x: string]: boolean;
    })[]>;
    innerValue: import("@vue/composition-api").Ref<import("./type").TimeRangeValue>;
    isShowPanel: import("@vue/composition-api").Ref<boolean>;
    handleInputChange: (inputVal: import("./type").TimeRangeValue, { e, position }: {
        e: InputEvent;
        position: import("..").RangeInputPosition;
    }) => void;
    handleShowPopup: (visible: boolean, context: any) => void;
    handleClear: (context: {
        e: MouseEvent;
    }) => void;
    handleFocus: (value: import("./type").TimeRangeValue, { e, position }: {
        e: FocusEvent;
        position: import("..").RangeInputPosition;
    }) => void;
    handleOnPick: (pickValue: string, e: MouseEvent) => void;
    handleClickConfirm: () => void;
    handleClick: ({ position }: {
        position: "second" | "first";
    }) => void;
    handleInputBlur: (value: import("./type").TimeRangeValue, { e }: {
        e: FocusEvent;
    }) => void;
    handleTimeChange: (newValue: string) => void;
    TimeIcon: import("tdesign-icons-vue").GlobalIconType;
    isDisabled: import("@vue/composition-api").ComputedRef<boolean | boolean[]>;
}> & import("@vue/composition-api").Data, {}, {}, {
    rangeInputProps: ObjectConstructor;
    popupProps: ObjectConstructor;
    allowInput: BooleanConstructor;
    autoSwap: {
        type: BooleanConstructor;
        default: boolean;
    };
    borderless: BooleanConstructor;
    clearable: BooleanConstructor;
    disableTime: {
        type: import("vue").PropType<(h: number, m: number, s: number, context: {
            partial: import("./type").TimeRangePickerPartial;
        }) => Partial<{
            hour: number[];
            minute: number[];
            second: number[];
        }>>;
    };
    disabled: {
        type: import("vue").PropType<boolean | boolean[]>;
        default: any;
    };
    readonly: {
        type: BooleanConstructor;
        default: any;
    };
    format: {
        type: StringConstructor;
        default: string;
    };
    hideDisabledTime: {
        type: BooleanConstructor;
        default: boolean;
    };
    placeholder: {
        type: import("vue").PropType<string | string[]>;
        default: any;
    };
    presets: {
        type: import("vue").PropType<import("./type").PresetTimeRange>;
    };
    size: {
        type: import("vue").PropType<"small" | "medium" | "large">;
        default: "small" | "medium" | "large";
        validator(val: "small" | "medium" | "large"): boolean;
    };
    status: {
        type: import("vue").PropType<"error" | "default" | "success" | "warning">;
        default: "error" | "default" | "success" | "warning";
        validator(val: "error" | "default" | "success" | "warning"): boolean;
    };
    steps: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    tips: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    value: {
        type: import("vue").PropType<import("./type").TimeRangeValue>;
        default: any;
    };
    defaultValue: {
        type: import("vue").PropType<import("./type").TimeRangeValue>;
    };
    onBlur: import("vue").PropType<(context: {
        value: import("./type").TimeRangeValue;
        e?: FocusEvent;
        position?: import("./type").TimeRangePickerPartial;
    }) => void>;
    onChange: import("vue").PropType<(value: import("./type").TimeRangeValue) => void>;
    onFocus: import("vue").PropType<(context?: {
        value: import("./type").TimeRangeValue;
        e?: FocusEvent;
        position?: import("./type").TimeRangePickerPartial;
    }) => void>;
    onInput: import("vue").PropType<(context: {
        value: import("./type").TimeRangeValue;
        e?: InputEvent;
        position?: import("./type").TimeRangePickerPartial;
    }) => void>;
    onPick: import("vue").PropType<(value: import("./type").TimeRangeValue, context: {
        e: MouseEvent;
        position?: import("./type").TimeRangePickerPartial;
    }) => void>;
}, import("@vue/composition-api").ExtractPropTypes<{
    rangeInputProps: ObjectConstructor;
    popupProps: ObjectConstructor;
    allowInput: BooleanConstructor;
    autoSwap: {
        type: BooleanConstructor;
        default: boolean;
    };
    borderless: BooleanConstructor;
    clearable: BooleanConstructor;
    disableTime: {
        type: import("vue").PropType<(h: number, m: number, s: number, context: {
            partial: import("./type").TimeRangePickerPartial;
        }) => Partial<{
            hour: number[];
            minute: number[];
            second: number[];
        }>>;
    };
    disabled: {
        type: import("vue").PropType<boolean | boolean[]>;
        default: any;
    };
    readonly: {
        type: BooleanConstructor;
        default: any;
    };
    format: {
        type: StringConstructor;
        default: string;
    };
    hideDisabledTime: {
        type: BooleanConstructor;
        default: boolean;
    };
    placeholder: {
        type: import("vue").PropType<string | string[]>;
        default: any;
    };
    presets: {
        type: import("vue").PropType<import("./type").PresetTimeRange>;
    };
    size: {
        type: import("vue").PropType<"small" | "medium" | "large">;
        default: "small" | "medium" | "large";
        validator(val: "small" | "medium" | "large"): boolean;
    };
    status: {
        type: import("vue").PropType<"error" | "default" | "success" | "warning">;
        default: "error" | "default" | "success" | "warning";
        validator(val: "error" | "default" | "success" | "warning"): boolean;
    };
    steps: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    tips: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    value: {
        type: import("vue").PropType<import("./type").TimeRangeValue>;
        default: any;
    };
    defaultValue: {
        type: import("vue").PropType<import("./type").TimeRangeValue>;
    };
    onBlur: import("vue").PropType<(context: {
        value: import("./type").TimeRangeValue;
        e?: FocusEvent;
        position?: import("./type").TimeRangePickerPartial;
    }) => void>;
    onChange: import("vue").PropType<(value: import("./type").TimeRangeValue) => void>;
    onFocus: import("vue").PropType<(context?: {
        value: import("./type").TimeRangeValue;
        e?: FocusEvent;
        position?: import("./type").TimeRangePickerPartial;
    }) => void>;
    onInput: import("vue").PropType<(context: {
        value: import("./type").TimeRangeValue;
        e?: InputEvent;
        position?: import("./type").TimeRangePickerPartial;
    }) => void>;
    onPick: import("vue").PropType<(value: import("./type").TimeRangeValue, context: {
        e: MouseEvent;
        position?: import("./type").TimeRangePickerPartial;
    }) => void>;
}>> & Omit<import("vue").VueConstructor<import("vue").default>, never> & (new (...args: any[]) => import("@vue/composition-api").ComponentRenderProxy<{
    value: import("./type").TimeRangeValue;
    disabled: boolean | boolean[];
    size: "small" | "medium" | "large";
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    steps: (string | number)[];
    format: string;
    borderless: boolean;
    clearable: boolean;
    placeholder: string | string[];
    allowInput: boolean;
    hideDisabledTime: boolean;
    autoSwap: boolean;
} & {
    onChange?: (value: import("./type").TimeRangeValue) => void;
    defaultValue?: import("./type").TimeRangeValue;
    tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onBlur?: (context: {
        value: import("./type").TimeRangeValue;
        e?: FocusEvent;
        position?: import("./type").TimeRangePickerPartial;
    }) => void;
    onFocus?: (context?: {
        value: import("./type").TimeRangeValue;
        e?: FocusEvent;
        position?: import("./type").TimeRangePickerPartial;
    }) => void;
    popupProps?: Record<string, any>;
    rangeInputProps?: Record<string, any>;
    disableTime?: (h: number, m: number, s: number, context: {
        partial: import("./type").TimeRangePickerPartial;
    }) => Partial<{
        hour: number[];
        minute: number[];
        second: number[];
    }>;
    presets?: import("./type").PresetTimeRange;
    onInput?: (context: {
        value: import("./type").TimeRangeValue;
        e?: InputEvent;
        position?: import("./type").TimeRangePickerPartial;
    }) => void;
    onPick?: (value: import("./type").TimeRangeValue, context: {
        e: MouseEvent;
        position?: import("./type").TimeRangePickerPartial;
    }) => void;
}, import("@vue/composition-api").ShallowUnwrapRef<{
    global: import("@vue/composition-api").ComputedRef<{} & (import("..").TimePickerConfig | {
        readonly dayjsLocale: "zh-cn";
        readonly now: "此刻";
        readonly confirm: "确定";
        readonly anteMeridiem: "上午";
        readonly postMeridiem: "下午";
        readonly placeholder: "选择时间";
    }) & import("..").TimePickerConfig>;
    componentName: import("@vue/composition-api").ComputedRef<string>;
    currentValue: import("@vue/composition-api").Ref<string[]>;
    currentPanelIdx: any;
    inputClasses: import("@vue/composition-api").ComputedRef<(string | {
        [x: string]: boolean;
    })[]>;
    innerValue: import("@vue/composition-api").Ref<import("./type").TimeRangeValue>;
    isShowPanel: import("@vue/composition-api").Ref<boolean>;
    handleInputChange: (inputVal: import("./type").TimeRangeValue, { e, position }: {
        e: InputEvent;
        position: import("..").RangeInputPosition;
    }) => void;
    handleShowPopup: (visible: boolean, context: any) => void;
    handleClear: (context: {
        e: MouseEvent;
    }) => void;
    handleFocus: (value: import("./type").TimeRangeValue, { e, position }: {
        e: FocusEvent;
        position: import("..").RangeInputPosition;
    }) => void;
    handleOnPick: (pickValue: string, e: MouseEvent) => void;
    handleClickConfirm: () => void;
    handleClick: ({ position }: {
        position: "second" | "first";
    }) => void;
    handleInputBlur: (value: import("./type").TimeRangeValue, { e }: {
        e: FocusEvent;
    }) => void;
    handleTimeChange: (newValue: string) => void;
    TimeIcon: import("tdesign-icons-vue").GlobalIconType;
    isDisabled: import("@vue/composition-api").ComputedRef<boolean | boolean[]>;
}>, import("@vue/composition-api").Data, {}, {}, {}, {}, {}, {
    value: import("./type").TimeRangeValue;
    disabled: boolean | boolean[];
    size: "small" | "medium" | "large";
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    steps: (string | number)[];
    format: string;
    borderless: boolean;
    clearable: boolean;
    placeholder: string | string[];
    allowInput: boolean;
    hideDisabledTime: boolean;
    autoSwap: boolean;
} & {
    onChange?: (value: import("./type").TimeRangeValue) => void;
    defaultValue?: import("./type").TimeRangeValue;
    tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onBlur?: (context: {
        value: import("./type").TimeRangeValue;
        e?: FocusEvent;
        position?: import("./type").TimeRangePickerPartial;
    }) => void;
    onFocus?: (context?: {
        value: import("./type").TimeRangeValue;
        e?: FocusEvent;
        position?: import("./type").TimeRangePickerPartial;
    }) => void;
    popupProps?: Record<string, any>;
    rangeInputProps?: Record<string, any>;
    disableTime?: (h: number, m: number, s: number, context: {
        partial: import("./type").TimeRangePickerPartial;
    }) => Partial<{
        hour: number[];
        minute: number[];
        second: number[];
    }>;
    presets?: import("./type").PresetTimeRange;
    onInput?: (context: {
        value: import("./type").TimeRangeValue;
        e?: InputEvent;
        position?: import("./type").TimeRangePickerPartial;
    }) => void;
    onPick?: (value: import("./type").TimeRangeValue, context: {
        e: MouseEvent;
        position?: import("./type").TimeRangePickerPartial;
    }) => void;
}, {
    value: import("./type").TimeRangeValue;
    disabled: boolean | boolean[];
    size: "small" | "medium" | "large";
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    steps: (string | number)[];
    format: string;
    borderless: boolean;
    clearable: boolean;
    placeholder: string | string[];
    allowInput: boolean;
    hideDisabledTime: boolean;
    autoSwap: boolean;
}, true>)>;
export declare const TimePickerPanel: import("vue").ComponentOptions<import("vue").default, import("@vue/composition-api").ShallowUnwrapRef<{
    showNowTimeBtn: import("@vue/composition-api").ComputedRef<boolean>;
    panelClassName: import("@vue/composition-api").ComputedRef<string>;
    triggerScroll: import("@vue/composition-api").Ref<boolean>;
    resetTriggerScroll: () => void;
    defaultValue: import("@vue/composition-api").ComputedRef<string | import("dayjs").Dayjs>;
    global: import("@vue/composition-api").ComputedRef<{} & (import("..").TimePickerConfig | {
        readonly dayjsLocale: "zh-cn";
        readonly now: "此刻";
        readonly confirm: "确定";
        readonly anteMeridiem: "上午";
        readonly postMeridiem: "下午";
        readonly placeholder: "选择时间";
    }) & import("..").TimePickerConfig>;
    handleChange: (v: string, e: MouseEvent) => void;
    handlePresetClick: (presetValue: string | (() => string)) => void;
}> & import("@vue/composition-api").Data, {}, {}, {
    handleConfirmClick: FunctionConstructor;
    onChange: FunctionConstructor;
    onPick: FunctionConstructor;
    disableTime: FunctionConstructor;
    disabled: {
        type: BooleanConstructor;
        default: boolean;
    };
    isFocus: {
        type: BooleanConstructor;
        default: boolean;
    };
    value: {
        type: (ObjectConstructor | StringConstructor)[];
        default: string;
    };
    format: {
        type: StringConstructor;
        default: string;
    };
    position: StringConstructor;
    steps: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => number[];
    };
    isShowPanel: {
        type: BooleanConstructor;
        default: boolean;
    };
    activeIndex: {
        type: NumberConstructor;
    };
    presets: {
        type: import("vue").PropType<import("./type").PresetTime>;
    };
    hideDisabledTime: {
        type: BooleanConstructor;
        default: boolean;
    };
    isFooterDisplay: {
        type: BooleanConstructor;
        default: boolean;
    };
}, import("@vue/composition-api").ExtractPropTypes<{
    handleConfirmClick: FunctionConstructor;
    onChange: FunctionConstructor;
    onPick: FunctionConstructor;
    disableTime: FunctionConstructor;
    disabled: {
        type: BooleanConstructor;
        default: boolean;
    };
    isFocus: {
        type: BooleanConstructor;
        default: boolean;
    };
    value: {
        type: (ObjectConstructor | StringConstructor)[];
        default: string;
    };
    format: {
        type: StringConstructor;
        default: string;
    };
    position: StringConstructor;
    steps: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => number[];
    };
    isShowPanel: {
        type: BooleanConstructor;
        default: boolean;
    };
    activeIndex: {
        type: NumberConstructor;
    };
    presets: {
        type: import("vue").PropType<import("./type").PresetTime>;
    };
    hideDisabledTime: {
        type: BooleanConstructor;
        default: boolean;
    };
    isFooterDisplay: {
        type: BooleanConstructor;
        default: boolean;
    };
}>> & Omit<import("vue").VueConstructor<import("vue").default>, never> & (new (...args: any[]) => import("@vue/composition-api").ComponentRenderProxy<{
    value: string;
    disabled: boolean;
    steps: (string | number)[];
    format: string;
    isFocus: boolean;
    isShowPanel: boolean;
    hideDisabledTime: boolean;
    isFooterDisplay: boolean;
} & {
    position?: string;
    onChange?: Function;
    activeIndex?: number;
    disableTime?: Function;
    presets?: import("./type").PresetTime;
    onPick?: Function;
    handleConfirmClick?: Function;
}, import("@vue/composition-api").ShallowUnwrapRef<{
    showNowTimeBtn: import("@vue/composition-api").ComputedRef<boolean>;
    panelClassName: import("@vue/composition-api").ComputedRef<string>;
    triggerScroll: import("@vue/composition-api").Ref<boolean>;
    resetTriggerScroll: () => void;
    defaultValue: import("@vue/composition-api").ComputedRef<string | import("dayjs").Dayjs>;
    global: import("@vue/composition-api").ComputedRef<{} & (import("..").TimePickerConfig | {
        readonly dayjsLocale: "zh-cn";
        readonly now: "此刻";
        readonly confirm: "确定";
        readonly anteMeridiem: "上午";
        readonly postMeridiem: "下午";
        readonly placeholder: "选择时间";
    }) & import("..").TimePickerConfig>;
    handleChange: (v: string, e: MouseEvent) => void;
    handlePresetClick: (presetValue: string | (() => string)) => void;
}>, import("@vue/composition-api").Data, {}, {}, {}, {}, {}, {
    value: string;
    disabled: boolean;
    steps: (string | number)[];
    format: string;
    isFocus: boolean;
    isShowPanel: boolean;
    hideDisabledTime: boolean;
    isFooterDisplay: boolean;
} & {
    position?: string;
    onChange?: Function;
    activeIndex?: number;
    disableTime?: Function;
    presets?: import("./type").PresetTime;
    onPick?: Function;
    handleConfirmClick?: Function;
}, {
    value: string;
    disabled: boolean;
    steps: (string | number)[];
    format: string;
    isFocus: boolean;
    isShowPanel: boolean;
    hideDisabledTime: boolean;
    isFooterDisplay: boolean;
}, true>) & import("vue").PluginObject<import("vue").ComponentOptions<import("vue").default, import("@vue/composition-api").ShallowUnwrapRef<{
    showNowTimeBtn: import("@vue/composition-api").ComputedRef<boolean>;
    panelClassName: import("@vue/composition-api").ComputedRef<string>;
    triggerScroll: import("@vue/composition-api").Ref<boolean>;
    resetTriggerScroll: () => void;
    defaultValue: import("@vue/composition-api").ComputedRef<string | import("dayjs").Dayjs>;
    global: import("@vue/composition-api").ComputedRef<{} & (import("..").TimePickerConfig | {
        readonly dayjsLocale: "zh-cn";
        readonly now: "此刻";
        readonly confirm: "确定";
        readonly anteMeridiem: "上午";
        readonly postMeridiem: "下午";
        readonly placeholder: "选择时间";
    }) & import("..").TimePickerConfig>;
    handleChange: (v: string, e: MouseEvent) => void;
    handlePresetClick: (presetValue: string | (() => string)) => void;
}> & import("@vue/composition-api").Data, {}, {}, {
    handleConfirmClick: FunctionConstructor;
    onChange: FunctionConstructor;
    onPick: FunctionConstructor;
    disableTime: FunctionConstructor;
    disabled: {
        type: BooleanConstructor;
        default: boolean;
    };
    isFocus: {
        type: BooleanConstructor;
        default: boolean;
    };
    value: {
        type: (ObjectConstructor | StringConstructor)[];
        default: string;
    };
    format: {
        type: StringConstructor;
        default: string;
    };
    position: StringConstructor;
    steps: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => number[];
    };
    isShowPanel: {
        type: BooleanConstructor;
        default: boolean;
    };
    activeIndex: {
        type: NumberConstructor;
    };
    presets: {
        type: import("vue").PropType<import("./type").PresetTime>;
    };
    hideDisabledTime: {
        type: BooleanConstructor;
        default: boolean;
    };
    isFooterDisplay: {
        type: BooleanConstructor;
        default: boolean;
    };
}, import("@vue/composition-api").ExtractPropTypes<{
    handleConfirmClick: FunctionConstructor;
    onChange: FunctionConstructor;
    onPick: FunctionConstructor;
    disableTime: FunctionConstructor;
    disabled: {
        type: BooleanConstructor;
        default: boolean;
    };
    isFocus: {
        type: BooleanConstructor;
        default: boolean;
    };
    value: {
        type: (ObjectConstructor | StringConstructor)[];
        default: string;
    };
    format: {
        type: StringConstructor;
        default: string;
    };
    position: StringConstructor;
    steps: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => number[];
    };
    isShowPanel: {
        type: BooleanConstructor;
        default: boolean;
    };
    activeIndex: {
        type: NumberConstructor;
    };
    presets: {
        type: import("vue").PropType<import("./type").PresetTime>;
    };
    hideDisabledTime: {
        type: BooleanConstructor;
        default: boolean;
    };
    isFooterDisplay: {
        type: BooleanConstructor;
        default: boolean;
    };
}>> & Omit<import("vue").VueConstructor<import("vue").default>, never> & (new (...args: any[]) => import("@vue/composition-api").ComponentRenderProxy<{
    value: string;
    disabled: boolean;
    steps: (string | number)[];
    format: string;
    isFocus: boolean;
    isShowPanel: boolean;
    hideDisabledTime: boolean;
    isFooterDisplay: boolean;
} & {
    position?: string;
    onChange?: Function;
    activeIndex?: number;
    disableTime?: Function;
    presets?: import("./type").PresetTime;
    onPick?: Function;
    handleConfirmClick?: Function;
}, import("@vue/composition-api").ShallowUnwrapRef<{
    showNowTimeBtn: import("@vue/composition-api").ComputedRef<boolean>;
    panelClassName: import("@vue/composition-api").ComputedRef<string>;
    triggerScroll: import("@vue/composition-api").Ref<boolean>;
    resetTriggerScroll: () => void;
    defaultValue: import("@vue/composition-api").ComputedRef<string | import("dayjs").Dayjs>;
    global: import("@vue/composition-api").ComputedRef<{} & (import("..").TimePickerConfig | {
        readonly dayjsLocale: "zh-cn";
        readonly now: "此刻";
        readonly confirm: "确定";
        readonly anteMeridiem: "上午";
        readonly postMeridiem: "下午";
        readonly placeholder: "选择时间";
    }) & import("..").TimePickerConfig>;
    handleChange: (v: string, e: MouseEvent) => void;
    handlePresetClick: (presetValue: string | (() => string)) => void;
}>, import("@vue/composition-api").Data, {}, {}, {}, {}, {}, {
    value: string;
    disabled: boolean;
    steps: (string | number)[];
    format: string;
    isFocus: boolean;
    isShowPanel: boolean;
    hideDisabledTime: boolean;
    isFooterDisplay: boolean;
} & {
    position?: string;
    onChange?: Function;
    activeIndex?: number;
    disableTime?: Function;
    presets?: import("./type").PresetTime;
    onPick?: Function;
    handleConfirmClick?: Function;
}, {
    value: string;
    disabled: boolean;
    steps: (string | number)[];
    format: string;
    isFocus: boolean;
    isShowPanel: boolean;
    hideDisabledTime: boolean;
    isFooterDisplay: boolean;
}, true>)>;
export default TimePicker;
