import './style';
export * from './interface';
export declare const Transfer: import("vue/types/vue").ExtendedVue<{
    t<T>(pattern: T, placement?: import("../config-provider/config-receiver").Placement): string;
} & {
    global: null;
    classPrefix: string;
    componentName: string;
    commonSizeClassName: Record<string, string>;
    commonStatusClassName: Record<string, string>;
} & Record<never, any> & import("../config-provider/config-receiver").ConfigComponent & import("vue").default, {
    SOURCE: import("./type").TransferListType;
    TARGET: import("./type").TransferListType;
    formDisabled: boolean;
}, {
    transferTo(toDirection: import("./type").TransferListType): void;
    transferToRight(): void;
    transferToLeft(): void;
    handleCheckedChange(val: import("./type").TransferValue[], listType: import("./type").TransferListType): void;
    filterMethod(transferList: import("./interface").TransferItemOption[], targetValueList: import("./type").TransferValue[], needMatch: boolean): import("./interface").TransferItemOption[];
    handleScroll(e: Event, listType: import("./type").TransferListType): void;
    handleSearch(e: import("./type").SearchContext): void;
    handlePageChange(pageInfo: import("..").PageInfo, listType: import("./type").TransferListType): void;
    handleDataChange(data: import("./type").TransferValue[]): void;
    renderTransferList(listType: import("./type").TransferListType): JSX.Element;
}, {
    tDisabled: boolean | boolean[];
    isTreeMode: boolean;
    leftButtonDisabled: boolean;
    rightButtonDisabled: boolean;
    transferData: import("./interface").TransferItemOption[];
    sourceList: import("./interface").TransferItemOption[];
    targetList: import("./interface").TransferItemOption[];
    checkedValue: import("./interface").TransferListOptionBase<import("./type").TransferValue[]>;
    hasFooter: boolean;
    showPagination: boolean;
    showSearch: boolean;
    footerOption: import("./interface").TransferListOptionBase<string | Function>;
    emptyOption: import("./interface").TransferListOptionBase<import("./type").EmptyType>;
    searchOption: import("./interface").TransferListOptionBase<import("./type").SearchOption>;
    checkAllOption: import("./interface").TransferListOptionBase<boolean>;
    disabledOption: import("./interface").TransferListOptionBase<boolean>;
    titleOption: import("./interface").TransferListOptionBase<string>;
    paginationOption: import("./interface").TransferListOptionBase<import("..").TdPaginationProps>;
}, {
    checkboxProps: import("..").TdCheckboxProps;
    checked: import("./type").TransferValue[];
    defaultChecked: import("./type").TransferValue[];
    data: import("./type").DataOption[];
    direction: "both" | "left" | "right";
    disabled: boolean | boolean[];
    empty: import("./type").EmptyType | import("./type").EmptyType[];
    footer: (string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue))[] | ((h: import("vue").CreateElement, props: {
        type: import("./type").TransferListType;
    }) => import("vue/types/vnode").ScopedSlotReturnValue);
    keys: import("..").KeysType;
    operation: (string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue))[] | ((h: import("vue").CreateElement, props: {
        direction: "left" | "right";
    }) => import("vue/types/vnode").ScopedSlotReturnValue);
    pagination: import("..").TdPaginationProps | import("..").TdPaginationProps[];
    search: import("./type").SearchOption | import("./type").SearchOption[];
    showCheckAll: boolean | boolean[];
    targetDraggable: boolean;
    targetSort: "push" | "unshift" | "original";
    title: import("./type").TitleType[] | ((h: import("vue").CreateElement, props: {
        type: import("./type").TransferListType;
    }) => import("vue/types/vnode").ScopedSlotReturnValue);
    transferItem: (h: import("vue").CreateElement, props: import("./type").TransferItem<import("./type").DataOption>) => import("vue/types/vnode").ScopedSlotReturnValue;
    tree: (tree: import("..").TreeProps) => (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    value: import("./type").TransferValue[];
    defaultValue: import("./type").TransferValue[];
    onChange: (targetValue: import("./type").TransferValue[], context: import("./type").TargetParams) => void;
    onCheckedChange: (options: import("./type").CheckedOptions) => void;
    onPageChange: (page: import("..").PageInfo, context: {
        type: import("./type").TransferListType;
    }) => void;
    onScroll: (options: {
        e: Event;
        bottomDistance: number;
        type: import("./type").TransferListType;
    }) => void;
    onSearch: (options: import("./type").SearchContext) => void;
}> & import("vue").PluginObject<import("vue/types/vue").ExtendedVue<{
    t<T>(pattern: T, placement?: import("../config-provider/config-receiver").Placement): string;
} & {
    global: null;
    classPrefix: string;
    componentName: string;
    commonSizeClassName: Record<string, string>;
    commonStatusClassName: Record<string, string>;
} & Record<never, any> & import("../config-provider/config-receiver").ConfigComponent & import("vue").default, {
    SOURCE: import("./type").TransferListType;
    TARGET: import("./type").TransferListType;
    formDisabled: boolean;
}, {
    transferTo(toDirection: import("./type").TransferListType): void;
    transferToRight(): void;
    transferToLeft(): void;
    handleCheckedChange(val: import("./type").TransferValue[], listType: import("./type").TransferListType): void;
    filterMethod(transferList: import("./interface").TransferItemOption[], targetValueList: import("./type").TransferValue[], needMatch: boolean): import("./interface").TransferItemOption[];
    handleScroll(e: Event, listType: import("./type").TransferListType): void;
    handleSearch(e: import("./type").SearchContext): void;
    handlePageChange(pageInfo: import("..").PageInfo, listType: import("./type").TransferListType): void;
    handleDataChange(data: import("./type").TransferValue[]): void;
    renderTransferList(listType: import("./type").TransferListType): JSX.Element;
}, {
    tDisabled: boolean | boolean[];
    isTreeMode: boolean;
    leftButtonDisabled: boolean;
    rightButtonDisabled: boolean;
    transferData: import("./interface").TransferItemOption[];
    sourceList: import("./interface").TransferItemOption[];
    targetList: import("./interface").TransferItemOption[];
    checkedValue: import("./interface").TransferListOptionBase<import("./type").TransferValue[]>;
    hasFooter: boolean;
    showPagination: boolean;
    showSearch: boolean;
    footerOption: import("./interface").TransferListOptionBase<string | Function>;
    emptyOption: import("./interface").TransferListOptionBase<import("./type").EmptyType>;
    searchOption: import("./interface").TransferListOptionBase<import("./type").SearchOption>;
    checkAllOption: import("./interface").TransferListOptionBase<boolean>;
    disabledOption: import("./interface").TransferListOptionBase<boolean>;
    titleOption: import("./interface").TransferListOptionBase<string>;
    paginationOption: import("./interface").TransferListOptionBase<import("..").TdPaginationProps>;
}, {
    checkboxProps: import("..").TdCheckboxProps;
    checked: import("./type").TransferValue[];
    defaultChecked: import("./type").TransferValue[];
    data: import("./type").DataOption[];
    direction: "both" | "left" | "right";
    disabled: boolean | boolean[];
    empty: import("./type").EmptyType | import("./type").EmptyType[];
    footer: (string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue))[] | ((h: import("vue").CreateElement, props: {
        type: import("./type").TransferListType;
    }) => import("vue/types/vnode").ScopedSlotReturnValue);
    keys: import("..").KeysType;
    operation: (string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue))[] | ((h: import("vue").CreateElement, props: {
        direction: "left" | "right";
    }) => import("vue/types/vnode").ScopedSlotReturnValue);
    pagination: import("..").TdPaginationProps | import("..").TdPaginationProps[];
    search: import("./type").SearchOption | import("./type").SearchOption[];
    showCheckAll: boolean | boolean[];
    targetDraggable: boolean;
    targetSort: "push" | "unshift" | "original";
    title: import("./type").TitleType[] | ((h: import("vue").CreateElement, props: {
        type: import("./type").TransferListType;
    }) => import("vue/types/vnode").ScopedSlotReturnValue);
    transferItem: (h: import("vue").CreateElement, props: import("./type").TransferItem<import("./type").DataOption>) => import("vue/types/vnode").ScopedSlotReturnValue;
    tree: (tree: import("..").TreeProps) => (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    value: import("./type").TransferValue[];
    defaultValue: import("./type").TransferValue[];
    onChange: (targetValue: import("./type").TransferValue[], context: import("./type").TargetParams) => void;
    onCheckedChange: (options: import("./type").CheckedOptions) => void;
    onPageChange: (page: import("..").PageInfo, context: {
        type: import("./type").TransferListType;
    }) => void;
    onScroll: (options: {
        e: Event;
        bottomDistance: number;
        type: import("./type").TransferListType;
    }) => void;
    onSearch: (options: import("./type").SearchContext) => void;
}>> & import("vue").PluginObject<import("vue/types/vue").ExtendedVue<{
    t<T>(pattern: T, placement?: import("../config-provider/config-receiver").Placement): string;
} & {
    global: null;
    classPrefix: string;
    componentName: string;
    commonSizeClassName: Record<string, string>;
    commonStatusClassName: Record<string, string>;
} & Record<never, any> & import("../config-provider/config-receiver").ConfigComponent & import("vue").default, {
    SOURCE: import("./type").TransferListType;
    TARGET: import("./type").TransferListType;
    formDisabled: boolean;
}, {
    transferTo(toDirection: import("./type").TransferListType): void;
    transferToRight(): void;
    transferToLeft(): void;
    handleCheckedChange(val: import("./type").TransferValue[], listType: import("./type").TransferListType): void;
    filterMethod(transferList: import("./interface").TransferItemOption[], targetValueList: import("./type").TransferValue[], needMatch: boolean): import("./interface").TransferItemOption[];
    handleScroll(e: Event, listType: import("./type").TransferListType): void;
    handleSearch(e: import("./type").SearchContext): void;
    handlePageChange(pageInfo: import("..").PageInfo, listType: import("./type").TransferListType): void;
    handleDataChange(data: import("./type").TransferValue[]): void;
    renderTransferList(listType: import("./type").TransferListType): JSX.Element;
}, {
    tDisabled: boolean | boolean[];
    isTreeMode: boolean;
    leftButtonDisabled: boolean;
    rightButtonDisabled: boolean;
    transferData: import("./interface").TransferItemOption[];
    sourceList: import("./interface").TransferItemOption[];
    targetList: import("./interface").TransferItemOption[];
    checkedValue: import("./interface").TransferListOptionBase<import("./type").TransferValue[]>;
    hasFooter: boolean;
    showPagination: boolean;
    showSearch: boolean;
    footerOption: import("./interface").TransferListOptionBase<string | Function>;
    emptyOption: import("./interface").TransferListOptionBase<import("./type").EmptyType>;
    searchOption: import("./interface").TransferListOptionBase<import("./type").SearchOption>;
    checkAllOption: import("./interface").TransferListOptionBase<boolean>;
    disabledOption: import("./interface").TransferListOptionBase<boolean>;
    titleOption: import("./interface").TransferListOptionBase<string>;
    paginationOption: import("./interface").TransferListOptionBase<import("..").TdPaginationProps>;
}, {
    checkboxProps: import("..").TdCheckboxProps;
    checked: import("./type").TransferValue[];
    defaultChecked: import("./type").TransferValue[];
    data: import("./type").DataOption[];
    direction: "both" | "left" | "right";
    disabled: boolean | boolean[];
    empty: import("./type").EmptyType | import("./type").EmptyType[];
    footer: (string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue))[] | ((h: import("vue").CreateElement, props: {
        type: import("./type").TransferListType;
    }) => import("vue/types/vnode").ScopedSlotReturnValue);
    keys: import("..").KeysType;
    operation: (string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue))[] | ((h: import("vue").CreateElement, props: {
        direction: "left" | "right";
    }) => import("vue/types/vnode").ScopedSlotReturnValue);
    pagination: import("..").TdPaginationProps | import("..").TdPaginationProps[];
    search: import("./type").SearchOption | import("./type").SearchOption[];
    showCheckAll: boolean | boolean[];
    targetDraggable: boolean;
    targetSort: "push" | "unshift" | "original";
    title: import("./type").TitleType[] | ((h: import("vue").CreateElement, props: {
        type: import("./type").TransferListType;
    }) => import("vue/types/vnode").ScopedSlotReturnValue);
    transferItem: (h: import("vue").CreateElement, props: import("./type").TransferItem<import("./type").DataOption>) => import("vue/types/vnode").ScopedSlotReturnValue;
    tree: (tree: import("..").TreeProps) => (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    value: import("./type").TransferValue[];
    defaultValue: import("./type").TransferValue[];
    onChange: (targetValue: import("./type").TransferValue[], context: import("./type").TargetParams) => void;
    onCheckedChange: (options: import("./type").CheckedOptions) => void;
    onPageChange: (page: import("..").PageInfo, context: {
        type: import("./type").TransferListType;
    }) => void;
    onScroll: (options: {
        e: Event;
        bottomDistance: number;
        type: import("./type").TransferListType;
    }) => void;
    onSearch: (options: import("./type").SearchContext) => void;
}> & import("vue").PluginObject<import("vue/types/vue").ExtendedVue<{
    t<T>(pattern: T, placement?: import("../config-provider/config-receiver").Placement): string;
} & {
    global: null;
    classPrefix: string;
    componentName: string;
    commonSizeClassName: Record<string, string>;
    commonStatusClassName: Record<string, string>;
} & Record<never, any> & import("../config-provider/config-receiver").ConfigComponent & import("vue").default, {
    SOURCE: import("./type").TransferListType;
    TARGET: import("./type").TransferListType;
    formDisabled: boolean;
}, {
    transferTo(toDirection: import("./type").TransferListType): void;
    transferToRight(): void;
    transferToLeft(): void;
    handleCheckedChange(val: import("./type").TransferValue[], listType: import("./type").TransferListType): void;
    filterMethod(transferList: import("./interface").TransferItemOption[], targetValueList: import("./type").TransferValue[], needMatch: boolean): import("./interface").TransferItemOption[];
    handleScroll(e: Event, listType: import("./type").TransferListType): void;
    handleSearch(e: import("./type").SearchContext): void;
    handlePageChange(pageInfo: import("..").PageInfo, listType: import("./type").TransferListType): void;
    handleDataChange(data: import("./type").TransferValue[]): void;
    renderTransferList(listType: import("./type").TransferListType): JSX.Element;
}, {
    tDisabled: boolean | boolean[];
    isTreeMode: boolean;
    leftButtonDisabled: boolean;
    rightButtonDisabled: boolean;
    transferData: import("./interface").TransferItemOption[];
    sourceList: import("./interface").TransferItemOption[];
    targetList: import("./interface").TransferItemOption[];
    checkedValue: import("./interface").TransferListOptionBase<import("./type").TransferValue[]>;
    hasFooter: boolean;
    showPagination: boolean;
    showSearch: boolean;
    footerOption: import("./interface").TransferListOptionBase<string | Function>;
    emptyOption: import("./interface").TransferListOptionBase<import("./type").EmptyType>;
    searchOption: import("./interface").TransferListOptionBase<import("./type").SearchOption>;
    checkAllOption: import("./interface").TransferListOptionBase<boolean>;
    disabledOption: import("./interface").TransferListOptionBase<boolean>;
    titleOption: import("./interface").TransferListOptionBase<string>;
    paginationOption: import("./interface").TransferListOptionBase<import("..").TdPaginationProps>;
}, {
    checkboxProps: import("..").TdCheckboxProps;
    checked: import("./type").TransferValue[];
    defaultChecked: import("./type").TransferValue[];
    data: import("./type").DataOption[];
    direction: "both" | "left" | "right";
    disabled: boolean | boolean[];
    empty: import("./type").EmptyType | import("./type").EmptyType[];
    footer: (string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue))[] | ((h: import("vue").CreateElement, props: {
        type: import("./type").TransferListType;
    }) => import("vue/types/vnode").ScopedSlotReturnValue);
    keys: import("..").KeysType;
    operation: (string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue))[] | ((h: import("vue").CreateElement, props: {
        direction: "left" | "right";
    }) => import("vue/types/vnode").ScopedSlotReturnValue);
    pagination: import("..").TdPaginationProps | import("..").TdPaginationProps[];
    search: import("./type").SearchOption | import("./type").SearchOption[];
    showCheckAll: boolean | boolean[];
    targetDraggable: boolean;
    targetSort: "push" | "unshift" | "original";
    title: import("./type").TitleType[] | ((h: import("vue").CreateElement, props: {
        type: import("./type").TransferListType;
    }) => import("vue/types/vnode").ScopedSlotReturnValue);
    transferItem: (h: import("vue").CreateElement, props: import("./type").TransferItem<import("./type").DataOption>) => import("vue/types/vnode").ScopedSlotReturnValue;
    tree: (tree: import("..").TreeProps) => (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    value: import("./type").TransferValue[];
    defaultValue: import("./type").TransferValue[];
    onChange: (targetValue: import("./type").TransferValue[], context: import("./type").TargetParams) => void;
    onCheckedChange: (options: import("./type").CheckedOptions) => void;
    onPageChange: (page: import("..").PageInfo, context: {
        type: import("./type").TransferListType;
    }) => void;
    onScroll: (options: {
        e: Event;
        bottomDistance: number;
        type: import("./type").TransferListType;
    }) => void;
    onSearch: (options: import("./type").SearchContext) => void;
}>>>;
export default Transfer;
