/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

import VueCompositionAPI from '@vue/composition-api';
export { computed, defineComponent, onMounted, reactive, ref, toRefs, watch } from '@vue/composition-api';
import Vue from 'vue';
import { withInstall as withInstall$1 } from '../utils/withInstall.js';
import { useVModel as useVModel$1 } from '../hooks/useVModel.js';
import useDefaultValue from '../hooks/useDefaultValue.js';
export { CaretRightSmallIcon as TdCaretRightSmallIcon } from 'tdesign-icons-vue';
export { Checkbox as TCheckBox } from '../checkbox/index.js';
export { Loading as TLoading } from '../loading/index.js';
export { usePrefixClass } from '../hooks/useConfig.js';
export { useGlobalIcon } from '../hooks/useGlobalIcon.js';
export { default as useLazyLoad } from '../hooks/useLazyLoad.js';
export { default as useVirtualScroll } from '../hooks/useVirtualScrollNew.js';
export { TreeNode, privateKey } from '../_common/js/tree/tree-node.js';
export { useConfig } from '../config-provider/useConfig.js';
import '@babel/runtime/helpers/defineProperty';
import 'lodash-es';
import '../checkbox/group.js';
import '../_chunks/dep-8db32566.js';
import '@babel/runtime/helpers/typeof';
import '@babel/runtime/helpers/toConsumableArray';
import '@babel/runtime/helpers/slicedToArray';
import '../utils/helper.js';
import '@babel/runtime/helpers/objectWithoutProperties';
import '../checkbox/checkbox.js';
import '../checkbox/props.js';
import '../hooks/index.js';
import '../utils/render-tnode.js';
import '@babel/runtime/helpers/readOnlyError';
import '../hooks/slots.js';
import '../hooks/useCommonClassName.js';
import '../hooks/useDestroyOnClose.js';
import '../hooks/useElementLazyRender.js';
import '../_common/js/utils/observe.js';
import '../hooks/useFormDisabled.js';
import '../hooks/useResizeObserver.js';
import '../hooks/useImagePreviewUrl.js';
import '../_common/js/upload/utils.js';
import '../_common/js/log/log.js';
import '../checkbox/constants.js';
import '../checkbox/store.js';
import '@babel/runtime/helpers/classCallCheck';
import '@babel/runtime/helpers/createClass';
import '../checkbox/hooks/useKeyboardEvent.js';
import '../_common/js/common.js';
import '../config-provider/context.js';
import '../_common/js/global-config/default-config.js';
import '../_common/js/global-config/locale/zh_CN.js';
import '../_chunks/dep-a883488c.js';
import '../_chunks/dep-90ffe67f.js';
import 'dayjs';
import '../_chunks/dep-9d1c0d31.js';
import '../config-provider/type.js';
import '../checkbox/checkbox-group-props.js';
import './style/css.js';
import '../checkbox/type.js';
import '../loading/directive.js';
import '../loading/plugin.js';
import '../loading/loading.js';
import '../loading/icon/gradient.js';
import '../_common/js/loading/circle-adapter.js';
import '../_common/js/utils/setStyle.js';
import '../_common/js/utils/helper.js';
import '../config-provider/config-receiver.js';
import '../utils/mixins.js';
import '../utils/dom.js';
import 'raf';
import '../utils/easing.js';
import '../utils/transfer-dom.js';
import '../loading/props.js';
import '../config.js';
import '../loading/type.js';
import '@babel/runtime/helpers/asyncToGenerator';
import '@babel/runtime/regenerator';
import '../_common/js/tree/tree-node-model.js';
import '../_common/js/log/index.js';

var isVueNext = false;
var TransitionGroup = Vue.component("TransitionGroup");
var onDrag = {
  "default": void 0
};
var TreeItemDefinition = {
  name: "TTreeItem",
  inject: {
    onDrag: onDrag
  }
};
function useRipple(el) {}
function withInstall(construct) {
  return withInstall$1(construct, VueCompositionAPI);
}
function getCreateElement(h) {
  return h;
}
function getScopedSlots(instance) {
  return instance.$scopedSlots;
}
function useVModel(props, refsProps) {
  var propName = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : "value";
  var defaultPropName = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : "defaultValue";
  var eventPropName = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : "onChange";
  var eventName = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : "change";
  if (propName === "value") {
    return useVModel$1(refsProps[propName], props[defaultPropName], props[eventPropName], eventName, propName);
  }
  return useDefaultValue(refsProps[propName], props[defaultPropName], props[eventPropName], propName, eventName);
}

export { TransitionGroup, TreeItemDefinition, getCreateElement, getScopedSlots, isVueNext, useRipple, useVModel, withInstall };
//# sourceMappingURL=adapt.js.map
