/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

import _TdTree from './tree.js';
import { withInstall } from './adapt.js';
import './style/css.js';
import './tree-types.js';
import '@babel/runtime/helpers/defineProperty';
import 'lodash-es';
import './props.js';
import './hooks/useTreeStore.js';
import '@babel/runtime/helpers/toConsumableArray';
import '../_common/js/tree/tree-store.js';
import '@babel/runtime/helpers/classCallCheck';
import '@babel/runtime/helpers/createClass';
import 'mitt';
import '../_common/js/tree/tree-node.js';
import '@babel/runtime/helpers/asyncToGenerator';
import '@babel/runtime/regenerator';
import '../_common/js/tree/tree-node-model.js';
import '../_common/js/log/log.js';
import '../_common/js/log/index.js';
import '@vue/composition-api';
import './hooks/useTreeStyles.js';
import '../hooks/useConfig.js';
import '../config-provider/useConfig.js';
import '../config-provider/context.js';
import '../_common/js/global-config/default-config.js';
import '../_common/js/global-config/locale/zh_CN.js';
import '../_chunks/dep-a883488c.js';
import '@babel/runtime/helpers/typeof';
import '../_chunks/dep-90ffe67f.js';
import 'dayjs';
import '../_chunks/dep-9d1c0d31.js';
import '../config-provider/type.js';
import './hooks/useTreeState.js';
import './hooks/useTreeAction.js';
import '@babel/runtime/helpers/slicedToArray';
import './util.js';
import './hooks/useTreeScroll.js';
import '../hooks/useVirtualScrollNew.js';
import '../hooks/useResizeObserver.js';
import './hooks/useTreeNodes.js';
import './tree-item.js';
import './hooks/useItemState.js';
import './hooks/useTreeItem.js';
import './hooks/useItemEvents.js';
import './hooks/useRenderIcon.js';
import '../hooks/useGlobalIcon.js';
import 'tdesign-icons-vue';
import '../loading/index.js';
import '../loading/directive.js';
import '../loading/plugin.js';
import 'vue';
import '../loading/loading.js';
import '../loading/icon/gradient.js';
import '../_common/js/loading/circle-adapter.js';
import '../_common/js/utils/setStyle.js';
import '../_common/js/utils/helper.js';
import '@babel/runtime/helpers/objectWithoutProperties';
import '../config-provider/config-receiver.js';
import '../utils/mixins.js';
import '../utils/dom.js';
import 'raf';
import '../utils/easing.js';
import '../utils/render-tnode.js';
import '@babel/runtime/helpers/readOnlyError';
import '../utils/transfer-dom.js';
import '../loading/props.js';
import '../config.js';
import '../utils/withInstall.js';
import '../loading/type.js';
import './hooks/useRenderLabel.js';
import '../_chunks/dep-8db32566.js';
import '../checkbox/index.js';
import '../checkbox/group.js';
import '../utils/helper.js';
import '../checkbox/checkbox.js';
import '../checkbox/props.js';
import '../hooks/index.js';
import '../hooks/slots.js';
import '../hooks/useCommonClassName.js';
import '../hooks/useDefaultValue.js';
import '../hooks/useDestroyOnClose.js';
import '../hooks/useElementLazyRender.js';
import '../_common/js/utils/observe.js';
import '../hooks/useFormDisabled.js';
import '../hooks/useLazyLoad.js';
import '../hooks/useVModel.js';
import '../hooks/useImagePreviewUrl.js';
import '../_common/js/upload/utils.js';
import '../checkbox/constants.js';
import '../checkbox/store.js';
import '../checkbox/hooks/useKeyboardEvent.js';
import '../_common/js/common.js';
import '../checkbox/checkbox-group-props.js';
import '../checkbox/type.js';
import './hooks/useRenderLine.js';
import './hooks/useRenderOperations.js';
import './hooks/useDraggable.js';
import './hooks/useTreeEvents.js';
import './hooks/useDragHandle.js';
import './type.js';

var Tree = withInstall(_TdTree);

export { Tree, Tree as default };
//# sourceMappingURL=index.js.map
