import 'dayjs/locale/en';
declare const _default: {
    readonly autoComplete: {
        readonly empty: "Empty Data";
    };
    readonly pagination: {
        readonly itemsPerPage: "{size} / page";
        readonly jumpTo: "Jump to";
        readonly page: "";
        readonly total: "{total} items";
    };
    readonly cascader: {
        readonly empty: "Empty Data";
        readonly loadingText: "loading...";
        readonly placeholder: "please select";
    };
    readonly calendar: {
        readonly yearSelection: "{year}";
        readonly monthSelection: "{month}";
        readonly yearRadio: "year";
        readonly monthRadio: "month";
        readonly hideWeekend: "Hide Week";
        readonly showWeekend: "Show Week";
        readonly today: "Today";
        readonly thisMonth: "This Month";
        readonly week: "Monday,Tuesday,Wedsday,Thuresday,Friday,Saturday,Sunday";
        readonly cellMonth: "January,February,March,April,May,June,July,August,September,October,November,December";
    };
    readonly transfer: {
        readonly title: "{checked} / {total}";
        readonly empty: "Empty Data";
        readonly placeholder: "enter keyword to search";
    };
    readonly timePicker: {
        readonly dayjsLocale: "en";
        readonly now: "Now";
        readonly confirm: "Confirm";
        readonly anteMeridiem: "AM";
        readonly postMeridiem: "PM";
        readonly placeholder: "please select";
    };
    readonly dialog: {
        readonly confirm: "Confirm";
        readonly cancel: "Cancel";
    };
    readonly drawer: {
        readonly confirm: "Confirm";
        readonly cancel: "Cancel";
    };
    readonly popconfirm: {
        readonly confirm: {
            readonly content: "OK";
        };
        readonly cancel: {
            readonly content: "Cancel";
        };
    };
    readonly table: {
        readonly empty: "Empty Data";
        readonly loadingText: "loading...";
        readonly loadingMoreText: "loading more";
        readonly filterInputPlaceholder: "";
        readonly sortAscendingOperationText: "click to sort ascending";
        readonly sortCancelOperationText: "click to cancel sorting";
        readonly sortDescendingOperationText: "click to sort descending";
        readonly clearFilterResultButtonText: "Clear";
        readonly columnConfigButtonText: "Column Config";
        readonly columnConfigTitleText: "Table Column Config";
        readonly columnConfigDescriptionText: "Please select columns to show them in the table";
        readonly confirmText: "Confirm";
        readonly cancelText: "Cancel";
        readonly resetText: "Reset";
        readonly selectAllText: "Select All";
        readonly searchResultText: "Search \"{result}\". Find {count} items.";
    };
    readonly select: {
        readonly empty: "Empty Data";
        readonly loadingText: "loading...";
        readonly placeholder: "please select";
    };
    readonly tree: {
        readonly empty: "Empty Data";
    };
    readonly treeSelect: {
        readonly empty: "Empty Data";
        readonly loadingText: "loading...";
        readonly placeholder: "please select";
    };
    readonly datePicker: {
        readonly dayjsLocale: "en";
        readonly placeholder: {
            readonly date: "select date";
            readonly month: "select month";
            readonly year: "select year";
            readonly quarter: "select quarter";
            readonly week: "select week";
        };
        readonly weekdays: readonly ["Mon", "Tue", "Wed", "Thu", "Fri", "Sat", "Sun"];
        readonly months: readonly ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
        readonly quarters: readonly ["Q1", "Q2", "Q3", "Q4"];
        readonly rangeSeparator: " - ";
        readonly direction: "ltr";
        readonly format: "YYYY-MM-DD";
        readonly dayAriaLabel: "D";
        readonly yearAriaLabel: "Y";
        readonly monthAriaLabel: "M";
        readonly weekAbbreviation: "W";
        readonly confirm: "Confirm";
        readonly selectTime: "Select Time";
        readonly selectDate: "Select Date";
        readonly nextYear: "Next Year";
        readonly preYear: "Last Year";
        readonly nextMonth: "Next Month";
        readonly preMonth: "Last Month";
        readonly preDecade: "Last Decade";
        readonly nextDecade: "Next Decade";
        readonly now: "Now";
    };
    readonly upload: {
        readonly sizeLimitMessage: "File is too large to upload. {sizeLimit}";
        readonly cancelUploadText: "Cancel";
        readonly triggerUploadText: {
            readonly fileInput: "Upload";
            readonly image: "Click to upload";
            readonly normal: "Upload";
            readonly reupload: "ReUpload";
            readonly continueUpload: "Continue Upload";
            readonly delete: "Delete";
            readonly uploading: "Uploading";
        };
        readonly dragger: {
            readonly dragDropText: "Drop here";
            readonly draggingText: "Drag file to this area to upload";
            readonly clickAndDragText: "Click \"Upload\" or Drag file to this area to upload";
        };
        readonly file: {
            readonly fileNameText: "filename";
            readonly fileSizeText: "size";
            readonly fileStatusText: "status";
            readonly fileOperationText: "operation";
            readonly fileOperationDateText: "date";
        };
        readonly progress: {
            readonly uploadingText: "Uploading";
            readonly waitingText: "Waiting";
            readonly failText: "Failed";
            readonly successText: "Success";
        };
    };
    readonly form: {
        readonly errorMessage: {
            readonly date: "${name} is invalid";
            readonly url: "${name} is invalid";
            readonly required: "${name} is required";
            readonly whitespace: "${name} cannot be empty";
            readonly max: "${name} must be at least ${validate} characters";
            readonly min: "${name} cannot be longer than ${validate} characters";
            readonly len: "${name} must be exactly ${validate} characters";
            readonly enum: "${name} must be one of ${validate}";
            readonly idcard: "${name} is invalid";
            readonly telnumber: "${name} is invalid";
            readonly pattern: "${name} is invalid";
            readonly validator: "${name} is invalid";
            readonly boolean: "${name} is not a boolean";
            readonly number: "${name} must be a number";
        };
        readonly colonText: ":";
    };
    readonly input: {
        readonly placeholder: "please enter";
    };
    readonly list: {
        readonly loadingText: "loading...";
        readonly loadingMoreText: "loading more";
    };
    readonly alert: {
        readonly expandText: "expand";
        readonly collapseText: "collapse";
    };
    readonly anchor: {
        readonly copySuccessText: "copy the link successfully";
        readonly copyText: "copy link";
    };
    readonly colorPicker: {
        readonly swatchColorTitle: "System Default";
        readonly recentColorTitle: "Recently Used";
        readonly clearConfirmText: "Clear recently used colors?";
        readonly singleColor: "Single";
        readonly gradientColor: "Gradient";
    };
    readonly guide: {
        readonly finishButtonProps: {
            readonly content: "Finish";
            readonly theme: "primary";
        };
        readonly nextButtonProps: {
            readonly content: "Next Step";
            readonly theme: "primary";
        };
        readonly skipButtonProps: {
            readonly content: "Skip";
            readonly theme: "default";
        };
        readonly prevButtonProps: {
            readonly content: "Last Step";
            readonly theme: "default";
        };
    };
    readonly image: {
        readonly errorText: "unable to load";
        readonly loadingText: "loading";
    };
    readonly imageViewer: {
        readonly errorText: "unable to load";
        readonly mirrorTipText: "mirror";
        readonly rotateTipText: "rotate";
        readonly originalSizeTipText: "original";
    };
    readonly typography: {
        readonly expandText: "more";
        readonly collapseText: "collapse";
        readonly copiedText: "copied";
    };
    readonly rate: {
        readonly rateText: readonly ["terrible", "disappointed", "normal", "satisfied", "surprised"];
    };
    readonly empty: {
        readonly titleText: {
            readonly maintenance: "Under Construction";
            readonly success: "Success";
            readonly fail: "Failure";
            readonly empty: "No Data";
            readonly networkError: "Network Error";
        };
    };
    readonly descriptions: {
        readonly colonText: ":";
    };
    readonly chat: {
        readonly placeholder: "please enter message...";
        readonly stopBtnText: "stop";
        readonly refreshTipText: "regenerate";
        readonly copyTipText: "copy";
        readonly likeTipText: "like";
        readonly dislikeTipText: "dislike";
        readonly copyCodeBtnText: "copy code";
        readonly copyCodeSuccessText: "copied";
        readonly clearHistoryBtnText: "clear history";
        readonly copyTextSuccess: "copied";
        readonly copyTextFail: "copy failed";
        readonly confirmClearHistory: "Are you sure to clear all messages?";
        readonly loadingText: "thinking...";
        readonly loadingEndText: "deep thinking end";
    };
};
export default _default;
