/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

import _defineProperty from '@babel/runtime/helpers/defineProperty';
import props from './props.js';
import _BreadcrumbItem from './breadcrumb-item.js';
import mixins from '../utils/mixins.js';
import { getClassPrefixMixins } from '../config-provider/config-receiver.js';
import '../_chunks/dep-8db32566.js';
import 'tdesign-icons-vue';
import '../tooltip/index.js';
import '../tooltip/tooltip.js';
import 'lodash-es';
import '../tooltip/props.js';
import '../popup/props.js';
import '../popup/popup.js';
import '@babel/runtime/helpers/typeof';
import '@popperjs/core';
import '../utils/dom.js';
import 'vue';
import 'raf';
import '../utils/easing.js';
import '../utils/render-tnode.js';
import '@babel/runtime/helpers/readOnlyError';
import '@vue/composition-api';
import '../utils/helper.js';
import '@babel/runtime/helpers/objectWithoutProperties';
import '@babel/runtime/helpers/slicedToArray';
import '../_common/js/utils/setStyle.js';
import '../popup/container.js';
import '../utils/event.js';
import '../popup/utils.js';
import '../utils/map-props.js';
import '../utils/withInstall.js';
import './style/index.js';
import '../tooltip/type.js';
import '../config-provider/context.js';
import '../_common/js/global-config/default-config.js';
import '../_common/js/global-config/locale/zh_CN.js';
import '../_chunks/dep-a883488c.js';
import '../_chunks/dep-90ffe67f.js';
import 'dayjs';
import '../_chunks/dep-9d1c0d31.js';
import '../config-provider/type.js';
import './breadcrumb-item-props.js';

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var classPrefixMixins = getClassPrefixMixins("breadcrumb");
var _Breadcrumb = mixins(classPrefixMixins).extend({
  name: "TBreadcrumb",
  props: _objectSpread({}, props),
  components: {
    BreadcrumbItem: _BreadcrumbItem
  },
  provide: function provide() {
    return {
      tBreadcrumb: this
    };
  },
  render: function render() {
    var h = arguments[0];
    var content = this.$slots["default"];
    if (this.options && this.options.length) {
      content = this.options.map(function (option, index) {
        return h(_BreadcrumbItem, {
          "key": index,
          "attrs": {
            "maxWidth": option.maxWidth,
            "disabled": option.disabled,
            "href": option.href,
            "target": option.target,
            "to": option.to,
            "router": option.router,
            "replace": option.replace
          }
        }, [option["default"] || option.content]);
      });
    }
    return h("div", {
      "class": this.componentName
    }, [content]);
  }
});

export { _Breadcrumb as default };
//# sourceMappingURL=breadcrumb.js.map
