import { TNode } from '../common';
export interface TdBreadcrumbProps {
    maxItemWidth?: string;
    options?: Array<TdBreadcrumbItemProps>;
    separator?: string | TNode;
    theme?: 'light';
}
export interface TdBreadcrumbItemProps {
    content?: string | TNode;
    default?: string | TNode;
    disabled?: boolean;
    href?: string;
    icon?: TNode;
    maxWidth?: string;
    replace?: boolean;
    router?: any;
    target?: '_blank' | '_self' | '_parent' | '_top';
    to?: Route;
}
export interface Route {
    path?: string;
    name?: string;
    hash?: string;
    query?: RouteData;
    params?: RouteData;
}
export declare type RouteData = {
    [key: string]: string | string[];
};
