import { InputProps } from '../input';
import { PopupProps } from '../popup';
import { SelectInputProps } from '../select-input';
import { TNode, SizeEnum } from '../common';
export interface TdColorPickerProps {
    borderless?: boolean;
    clearable?: boolean;
    closeBtn?: string | boolean | TNode;
    colorModes?: Array<'monochrome' | 'linear-gradient'>;
    disabled?: boolean;
    enableAlpha?: boolean;
    enableMultipleGradient?: boolean;
    format?: 'RGB' | 'RGBA' | 'HSL' | 'HSLA' | 'HSB' | 'HSV' | 'HSVA' | 'HEX' | 'CMYK' | 'CSS';
    inputProps?: InputProps;
    multiple?: boolean;
    popupProps?: PopupProps;
    recentColors?: boolean | Array<string> | null;
    defaultRecentColors?: boolean | Array<string> | null;
    selectInputProps?: SelectInputProps;
    showPrimaryColorPreview?: boolean;
    size?: SizeEnum;
    swatchColors?: Array<string> | null;
    value?: string;
    defaultValue?: string;
    onChange?: (value: string, context: {
        color: ColorObject;
        trigger: ColorPickerChangeTrigger;
    }) => void;
    onPaletteBarChange?: (context: {
        color: ColorObject;
    }) => void;
    onRecentColorsChange?: (value: Array<string>) => void;
}
export declare type ColorPickerChangeTrigger = 'palette-saturation-brightness' | 'palette-saturation' | 'palette-brightness' | 'palette-hue-bar' | 'palette-alpha-bar' | 'input' | 'preset' | 'recent';
export interface ColorObject {
    alpha: number;
    css: string;
    hex: string;
    hex8: string;
    hsl: string;
    hsla: string;
    hsv: string;
    hsva: string;
    rgb: string;
    rgba: string;
    saturation: number;
    value: number;
    isGradient: boolean;
    linearGradient?: string;
}
