import Vue from 'vue';
import { FooterButton, DrawerCloseContext } from './type';
import { DrawerConfig } from '../config-provider/config-receiver';
import { AttachNode, ClassName, Styles } from '../common';
declare type FooterButtonType = 'confirm' | 'cancel';
declare const _default: import("vue/types/vue").ExtendedVue<{
    useGlobalIcon(tdIcon: Record<string, any>): import("tdesign-icons-vue").GlobalIconConfig;
} & Record<never, any> & import("../config-provider/config-receiver").ConfigComponent & Vue & {
    globalAttach(): AttachNode;
} & {
    getConfirmBtn(options: import("../dialog/actions").MixinsConfirmBtn): any;
    getCancelBtn(options: import("../dialog/actions").MixinsCancelBtn): any;
    getButtonByProps(button: string | import("../button").TdButtonProps, params: {
        defaultButtonProps: import("../button").TdButtonProps;
        className?: ClassName;
        confirmLoading?: boolean;
    }): JSX.Element;
    confirmBtnAction(e: MouseEvent): void;
    cancelBtnAction(e: MouseEvent): void;
    getDefaultConfirmBtnProps(options: import("../dialog/actions").MixinsConfirmBtn): import("../button").TdButtonProps;
    getDefaultCancelBtnProps(options: import("../dialog/actions").MixinsCancelBtn): import("../button").TdButtonProps;
} & {
    t<T>(pattern: T, placement?: import("../config-provider/config-receiver").Placement): string;
} & {
    global: DrawerConfig;
    classPrefix: string;
    componentName: string;
    commonSizeClassName: Record<string, string>;
    commonStatusClassName: Record<string, string>;
}, {
    isSizeDragging: boolean;
    draggedSizeValue: any;
    animationStart: boolean;
    animationEnd: boolean;
    styleTimer: any;
    styleEl: any;
}, {
    clearStyleFunc(): void;
    beforeEnter(): void;
    afterEnter(): void;
    beforeLeave(): void;
    afterLeave(): void;
    enableDrag(): void;
    handleMouseup(): void;
    handleMousemove(e: MouseEvent): void;
    handleScrollThrough(visible: boolean): void;
    handlePushMode(): void;
    updatePushMode(): void;
    getDefaultBtn(btnType: FooterButtonType, btnApi: FooterButton): JSX.Element;
    isUseDefault(btnApi: FooterButton): boolean;
    getDefaultFooter(): JSX.Element;
    handleCloseBtnClick(e: MouseEvent): void;
    handleWrapperClick(e: MouseEvent): void;
    onKeyDown(e: KeyboardEvent): void;
    confirmBtnAction(e: MouseEvent): void;
    cancelBtnAction(e: MouseEvent): void;
    closeDrawer(params: DrawerCloseContext): void;
}, {
    drawerClasses: ClassName;
    sizeValue: string;
    wrapperStyles: Styles;
    wrapperClasses: ClassName;
    parentNode: HTMLElement;
    modeAndPlacement: string;
    footerStyle: Styles;
    isHorizontal: boolean;
    isVertical: boolean;
    draggableLineStyles: Styles;
    computedAttach: AttachNode;
}, {
    attach: AttachNode;
    body: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    cancelBtn: FooterButton;
    closeBtn: string | boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    closeOnEscKeydown: any;
    closeOnOverlayClick: boolean;
    confirmBtn: FooterButton;
    default: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    destroyOnClose: boolean;
    drawerClassName: string;
    footer: boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    header: string | boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    mode: "push" | "overlay";
    placement: "left" | "top" | "bottom" | "right";
    preventScrollThrough: boolean;
    showInAttachedElement: boolean;
    showOverlay: boolean;
    size: any;
    sizeDraggable: boolean | import("./type").SizeDragLimit;
    visible: boolean;
    zIndex: number;
    onBeforeClose: () => void;
    onBeforeOpen: () => void;
    onCancel: (context: {
        e: MouseEvent;
    }) => void;
    onClose: (context: DrawerCloseContext) => void;
    onCloseBtnClick: (context: {
        e: MouseEvent;
    }) => void;
    onConfirm: (context: {
        e: MouseEvent;
    }) => void;
    onEscKeydown: (context: {
        e: KeyboardEvent;
    }) => void;
    onOverlayClick: (context: {
        e: MouseEvent;
    }) => void;
    onSizeDragEnd: (context: {
        e: MouseEvent;
        size: number;
    }) => void;
}>;
export default _default;
