/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

import _defineProperty from '@babel/runtime/helpers/defineProperty';
import Vue from 'vue';
import _Drawer from './drawer.js';
import { getAttach } from '../utils/dom.js';
import { globalConfigSymbol } from '../config-provider/config-provider.js';
import '../_chunks/dep-8db32566.js';
import '@babel/runtime/helpers/typeof';
import 'tdesign-icons-vue';
import '../button/index.js';
import '../button/button.js';
import '../loading/index.js';
import '../loading/directive.js';
import 'lodash-es';
import '../loading/plugin.js';
import '../loading/loading.js';
import '../loading/icon/gradient.js';
import '../_common/js/loading/circle-adapter.js';
import '../_common/js/utils/setStyle.js';
import '../_common/js/utils/helper.js';
import '@babel/runtime/helpers/toConsumableArray';
import '@babel/runtime/helpers/objectWithoutProperties';
import '@babel/runtime/helpers/slicedToArray';
import '../config-provider/config-receiver.js';
import '../config-provider/context.js';
import '../_common/js/global-config/default-config.js';
import '../_common/js/global-config/locale/zh_CN.js';
import '../_chunks/dep-a883488c.js';
import '../_chunks/dep-90ffe67f.js';
import 'dayjs';
import '../_chunks/dep-9d1c0d31.js';
import '../config-provider/type.js';
import '../utils/mixins.js';
import '../utils/render-tnode.js';
import '@babel/runtime/helpers/readOnlyError';
import '@vue/composition-api';
import '../utils/transfer-dom.js';
import '../loading/props.js';
import '../config.js';
import 'raf';
import '../utils/easing.js';
import '../utils/withInstall.js';
import './style/index.js';
import '../loading/type.js';
import '../button/props.js';
import '../utils/ripple.js';
import '../button/type.js';
import './props.js';
import '../utils/event.js';
import '../utils/helper.js';
import '../dialog/actions.js';
import '../_common/js/utils/getScrollbarWidth.js';
import '../_common/js/drawer/utils.js';
import '../config-provider/props.js';

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var createDrawer = function createDrawer(props) {
  var options = _objectSpread({}, props);
  var globalOptions = Vue.prototype[globalConfigSymbol];
  var drawer = new _Drawer({
    propsData: _objectSpread(_objectSpread({}, options), {}, {
      onClose: options.onClose || function () {
        drawer.visible = false;
      },
      drawerClassName: options.className,
      instanceGlobal: globalOptions === null || globalOptions === void 0 ? void 0 : globalOptions.drawer
    })
  }).$mount();
  drawer.visible = true;
  if (options.style) {
    drawer.$el.style.cssText += options.style;
  }
  var container = getAttach(options.attach);
  if (container) {
    container.appendChild(drawer.$el);
  } else {
    console.error("attach is not exist");
  }
  var drawerNode = {
    show: function show() {
      drawer.visible = true;
    },
    hide: function hide() {
      drawer.visible = false;
    },
    update: function update(options2) {
      Object.assign(drawer, options2);
    },
    destroy: function destroy() {
      drawer.visible = false;
      container.contains(drawer.$el) && container.removeChild(drawer.$el);
    }
  };
  return drawerNode;
};
var DrawerPlugin = createDrawer;
DrawerPlugin.install = function () {
  Vue.prototype.$drawer = createDrawer;
};

export { DrawerPlugin, DrawerPlugin as default };
//# sourceMappingURL=plugin.js.map
