export default function useCommonClassName(): {
    classPrefix: import("@vue/composition-api").Ref<string>;
    sizeClassNames: {
        small: string;
        medium: string;
        large: string;
        default: string;
        xs: string;
        xl: string;
        block: string;
    };
    statusClassNames: {
        loading: string;
        loadMore: string;
        disabled: string;
        focused: string;
        success: string;
        error: string;
        warning: string;
        selected: string;
        active: string;
        checked: string;
        current: string;
        hidden: string;
        visible: string;
        expanded: string;
        indeterminate: string;
    };
    classNames: {
        size: {
            small: string;
            medium: string;
            large: string;
            default: string;
            xs: string;
            xl: string;
            block: string;
        };
        status: {
            loading: string;
            loadMore: string;
            disabled: string;
            focused: string;
            success: string;
            error: string;
            warning: string;
            selected: string;
            active: string;
            checked: string;
            current: string;
            hidden: string;
            visible: string;
            expanded: string;
            indeterminate: string;
        };
    };
};
export declare type CommonClassNameType = ReturnType<typeof useCommonClassName>;
