/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

import { defineComponent } from '@vue/composition-api';
import props from './list-item-props.js';
import { usePrefixClass } from '../hooks/useConfig.js';
import { renderContent, renderTNodeJSX } from '../utils/render-tnode.js';
import '../config-provider/useConfig.js';
import '../config-provider/context.js';
import 'lodash-es';
import '../_common/js/global-config/default-config.js';
import '../_common/js/global-config/locale/zh_CN.js';
import '../_chunks/dep-a883488c.js';
import '@babel/runtime/helpers/typeof';
import '../_chunks/dep-90ffe67f.js';
import 'dayjs';
import '../_chunks/dep-9d1c0d31.js';
import '../config-provider/type.js';
import '@babel/runtime/helpers/defineProperty';
import '@babel/runtime/helpers/readOnlyError';
import 'vue';

var _ListItem = defineComponent({
  name: "TListItem",
  props: props,
  setup: function setup(props2, _ref) {
    var emit = _ref.emit;
    var componentName = usePrefixClass("list-item");
    var handleClick = function handleClick(e) {
      var _props2$onClick;
      emit("click", {
        e: e
      });
      (_props2$onClick = props2.onClick) === null || _props2$onClick === void 0 || _props2$onClick.call(props2, {
        e: e
      });
    };
    return {
      componentName: componentName,
      handleClick: handleClick
    };
  },
  render: function render() {
    var h = arguments[0];
    var componentName = this.componentName,
      handleClick = this.handleClick;
    var content = renderContent(this, "default", "content");
    var propsActionContent = renderTNodeJSX(this, "action");
    return h("li", {
      "class": componentName,
      "on": {
        "click": handleClick
      }
    }, [h("div", {
      "class": "".concat(componentName, "-main")
    }, [h("div", {
      "class": "".concat(componentName, "__content")
    }, [content]), propsActionContent && h("li", {
      "class": "".concat(componentName, "__action")
    }, [propsActionContent])])]);
  }
});

export { _ListItem as default };
//# sourceMappingURL=list-item.js.map
