/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

import { defineComponent } from '@vue/composition-api';
import props from './menu-group-props.js';
import { usePrefixClass } from '../hooks/useConfig.js';
import { renderTNodeJSX } from '../utils/render-tnode.js';
import '../config-provider/useConfig.js';
import '../config-provider/context.js';
import 'lodash-es';
import '../_common/js/global-config/default-config.js';
import '../_common/js/global-config/locale/zh_CN.js';
import '../_chunks/dep-a883488c.js';
import '@babel/runtime/helpers/typeof';
import '../_chunks/dep-90ffe67f.js';
import 'dayjs';
import '../_chunks/dep-9d1c0d31.js';
import '../config-provider/type.js';
import '@babel/runtime/helpers/defineProperty';
import '@babel/runtime/helpers/readOnlyError';
import 'vue';

var _MenuGroup = defineComponent({
  name: "TMenuGroup",
  props: props,
  setup: function setup() {
    var classPrefix = usePrefixClass();
    return {
      classPrefix: classPrefix
    };
  },
  render: function render() {
    var h = arguments[0];
    return h("div", {
      "class": "".concat(this.classPrefix, "-menu-group")
    }, [h("div", {
      "class": "".concat(this.classPrefix, "-menu-group__title")
    }, [renderTNodeJSX(this, "title")]), this.$slots["default"]]);
  }
});

export { _MenuGroup as default };
//# sourceMappingURL=menu-group.js.map
