import { MessageMethod, MessageInfoMethod, MessageErrorMethod, MessageWarningMethod, MessageSuccessMethod, MessageLoadingMethod, MessageQuestionMethod, MessageCloseMethod, MessageCloseAllMethod, MessageConfigMethod } from './type';
interface ExtraApi {
    info: MessageInfoMethod;
    success: MessageSuccessMethod;
    warning: MessageWarningMethod;
    error: MessageErrorMethod;
    question: MessageQuestionMethod;
    loading: MessageLoadingMethod;
    close: MessageCloseMethod;
    closeAll: MessageCloseAllMethod;
    config: MessageConfigMethod;
}
export declare type MessagePluginType = Vue.PluginObject<undefined> & ExtraApi & MessageMethod;
export declare const MessagePlugin: MessagePluginType;
export declare const message: MessagePluginType;
export default MessagePlugin;
declare module 'vue/types/vue' {
    interface Vue {
        $message: MessageMethod & ExtraApi;
    }
}
