import { NotificationMethod, NotificationInfoMethod, NotificationWarningMethod, NotificationErrorMethod, NotificationSuccessMethod, NotificationCloseMethod, NotificationCloseAllMethod } from './type';
interface ExtraApi {
    info: NotificationInfoMethod;
    success: NotificationSuccessMethod;
    warning: NotificationWarningMethod;
    error: NotificationErrorMethod;
    close: NotificationCloseMethod;
    closeAll: NotificationCloseAllMethod;
}
export declare type NotificationPluginType = Vue.PluginObject<undefined> & ExtraApi & NotificationMethod;
export declare const NotificationPlugin: NotificationPluginType;
export declare const notify: NotificationPluginType;
export declare const NotifyPlugin: NotificationPluginType;
export default NotifyPlugin;
declare module 'vue/types/vue' {
    interface Vue {
        $notify: NotificationMethod & ExtraApi;
        $notification: NotificationMethod & ExtraApi;
    }
}
