import { TdRangeInputProps, TdRangeInputPopupProps } from './type';
import './style';
export * from './type';
export declare type RangeInputProps = TdRangeInputProps;
export declare type RangeInputPopupProps = TdRangeInputPopupProps;
export declare const RangeInput: import("vue").ComponentOptions<import("vue").default, import("@vue/composition-api").ShallowUnwrapRef<{
    COMPONENT_NAME: import("@vue/composition-api").ComputedRef<string>;
    SIZE: import("@vue/composition-api").ComputedRef<{
        small: string;
        medium: string;
        large: string;
        default: string;
        xs: string;
        xl: string;
        block: string;
    }>;
    STATUS: import("@vue/composition-api").ComputedRef<{
        loading: string;
        loadMore: string;
        disabled: string;
        focused: string;
        success: string;
        error: string;
        warning: string;
        selected: string;
        active: string;
        checked: string;
        current: string;
        hidden: string;
        visible: string;
        expanded: string;
        indeterminate: string;
    }>;
    focused: import("@vue/composition-api").Ref<boolean>;
    classPrefix: import("@vue/composition-api").ComputedRef<string>;
    inputRefs: {
        firstInputRef: import("@vue/composition-api").Ref<any>;
        secondInputRef: import("@vue/composition-api").Ref<any>;
    };
    calcInputProps: import("@vue/composition-api").ComputedRef<any[]>;
    calcFormat: import("@vue/composition-api").ComputedRef<any[]>;
    calcPlaceholder: import("@vue/composition-api").ComputedRef<any[]>;
    innerValue: import("@vue/composition-api").Ref<import("./type").RangeInputValue>;
    isShowClearIcon: import("@vue/composition-api").ComputedRef<boolean>;
    handleMouseEnter: (e: MouseEvent) => void;
    handleMouseLeave: (e: MouseEvent) => void;
    handleEnter: (rangeValue: import("./type").RangeInputValue, context: {
        e: MouseEvent;
    }) => void;
    handleFocus: (rangeValue: import("./type").RangeInputValue, context: {
        e: MouseEvent;
    }) => void;
    handleBlur: (rangeValue: import("./type").RangeInputValue, context: {
        e: MouseEvent;
    }) => void;
    setInnerValue: import("../hooks").ChangeHandler<import("./type").RangeInputValue, [context?: {
        e?: MouseEvent | CompositionEvent | InputEvent;
        position?: import("./type").RangeInputPosition;
        trigger?: "input" | "clear" | "initial";
    }]>;
    renderTNodeJSX: (name: string, options?: import("../hooks/render-tnode").OptionsType) => any;
    handleClear: (context: {
        e: MouseEvent;
    }) => void;
    CloseCircleFilledIcon: import("tdesign-icons-vue").GlobalIconType;
    firstInputElement: any;
    secondInputElement: any;
    focus: (options: any) => void;
    blur: (options: any) => void;
    select: (options: any) => void;
}> & import("@vue/composition-api").Data, {}, {}, {
    activeIndex: {
        type: NumberConstructor;
    };
    borderless: BooleanConstructor;
    clearable: BooleanConstructor;
    disabled: {
        type: BooleanConstructor;
        default: any;
    };
    format: {
        type: import("vue").PropType<import("..").InputFormatType | import("..").InputFormatType[]>;
    };
    inputProps: {
        type: import("vue").PropType<import("..").InputProps<import("..").InputValue> | import("..").InputProps<import("..").InputValue>[]>;
    };
    label: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    placeholder: {
        type: import("vue").PropType<string | string[]>;
    };
    prefixIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    readonly: BooleanConstructor;
    separator: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: string;
    };
    showClearIconOnEmpty: BooleanConstructor;
    size: {
        type: import("vue").PropType<"small" | "medium" | "large">;
        default: "small" | "medium" | "large";
        validator(val: "small" | "medium" | "large"): boolean;
    };
    status: {
        type: import("vue").PropType<"error" | "default" | "success" | "warning">;
        default: "error" | "default" | "success" | "warning";
        validator(val: "error" | "default" | "success" | "warning"): boolean;
    };
    suffix: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    suffixIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    tips: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    value: {
        type: import("vue").PropType<import("./type").RangeInputValue>;
        default: any;
    };
    defaultValue: {
        type: import("vue").PropType<import("./type").RangeInputValue>;
        default: () => import("./type").RangeInputValue;
    };
    onBlur: import("vue").PropType<(value: import("./type").RangeInputValue, context?: {
        e?: FocusEvent;
        position?: import("./type").RangeInputPosition;
    }) => void>;
    onChange: import("vue").PropType<(value: import("./type").RangeInputValue, context?: {
        e?: MouseEvent | CompositionEvent | InputEvent;
        position?: import("./type").RangeInputPosition;
        trigger?: "input" | "clear" | "initial";
    }) => void>;
    onClear: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onClick: import("vue").PropType<(context?: {
        e?: MouseEvent;
        position?: import("./type").RangeInputPosition;
    }) => void>;
    onEnter: import("vue").PropType<(value: import("./type").RangeInputValue, context?: {
        e?: MouseEvent | InputEvent;
        position?: import("./type").RangeInputPosition;
    }) => void>;
    onFocus: import("vue").PropType<(value: import("./type").RangeInputValue, context?: {
        e?: FocusEvent;
        position?: import("./type").RangeInputPosition;
    }) => void>;
    onMouseenter: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onMouseleave: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
}, import("@vue/composition-api").ExtractPropTypes<{
    activeIndex: {
        type: NumberConstructor;
    };
    borderless: BooleanConstructor;
    clearable: BooleanConstructor;
    disabled: {
        type: BooleanConstructor;
        default: any;
    };
    format: {
        type: import("vue").PropType<import("..").InputFormatType | import("..").InputFormatType[]>;
    };
    inputProps: {
        type: import("vue").PropType<import("..").InputProps<import("..").InputValue> | import("..").InputProps<import("..").InputValue>[]>;
    };
    label: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    placeholder: {
        type: import("vue").PropType<string | string[]>;
    };
    prefixIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    readonly: BooleanConstructor;
    separator: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: string;
    };
    showClearIconOnEmpty: BooleanConstructor;
    size: {
        type: import("vue").PropType<"small" | "medium" | "large">;
        default: "small" | "medium" | "large";
        validator(val: "small" | "medium" | "large"): boolean;
    };
    status: {
        type: import("vue").PropType<"error" | "default" | "success" | "warning">;
        default: "error" | "default" | "success" | "warning";
        validator(val: "error" | "default" | "success" | "warning"): boolean;
    };
    suffix: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    suffixIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    tips: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    value: {
        type: import("vue").PropType<import("./type").RangeInputValue>;
        default: any;
    };
    defaultValue: {
        type: import("vue").PropType<import("./type").RangeInputValue>;
        default: () => import("./type").RangeInputValue;
    };
    onBlur: import("vue").PropType<(value: import("./type").RangeInputValue, context?: {
        e?: FocusEvent;
        position?: import("./type").RangeInputPosition;
    }) => void>;
    onChange: import("vue").PropType<(value: import("./type").RangeInputValue, context?: {
        e?: MouseEvent | CompositionEvent | InputEvent;
        position?: import("./type").RangeInputPosition;
        trigger?: "input" | "clear" | "initial";
    }) => void>;
    onClear: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onClick: import("vue").PropType<(context?: {
        e?: MouseEvent;
        position?: import("./type").RangeInputPosition;
    }) => void>;
    onEnter: import("vue").PropType<(value: import("./type").RangeInputValue, context?: {
        e?: MouseEvent | InputEvent;
        position?: import("./type").RangeInputPosition;
    }) => void>;
    onFocus: import("vue").PropType<(value: import("./type").RangeInputValue, context?: {
        e?: FocusEvent;
        position?: import("./type").RangeInputPosition;
    }) => void>;
    onMouseenter: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onMouseleave: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
}>> & Omit<import("vue").VueConstructor<import("vue").default>, never> & (new (...args: any[]) => import("@vue/composition-api").ComponentRenderProxy<{
    value: import("./type").RangeInputValue;
    disabled: boolean;
    size: "small" | "medium" | "large";
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    defaultValue: import("./type").RangeInputValue;
    borderless: boolean;
    clearable: boolean;
    showClearIconOnEmpty: boolean;
    separator: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
} & {
    label?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onClick?: (context?: {
        e?: MouseEvent;
        position?: import("./type").RangeInputPosition;
    }) => void;
    onChange?: (value: import("./type").RangeInputValue, context?: {
        e?: MouseEvent | CompositionEvent | InputEvent;
        position?: import("./type").RangeInputPosition;
        trigger?: "input" | "clear" | "initial";
    }) => void;
    format?: import("..").InputFormatType | import("..").InputFormatType[];
    prefixIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    suffix?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    suffixIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onBlur?: (value: import("./type").RangeInputValue, context?: {
        e?: FocusEvent;
        position?: import("./type").RangeInputPosition;
    }) => void;
    onClear?: (context: {
        e: MouseEvent;
    }) => void;
    onEnter?: (value: import("./type").RangeInputValue, context?: {
        e?: MouseEvent | InputEvent;
        position?: import("./type").RangeInputPosition;
    }) => void;
    onFocus?: (value: import("./type").RangeInputValue, context?: {
        e?: FocusEvent;
        position?: import("./type").RangeInputPosition;
    }) => void;
    onMouseenter?: (context: {
        e: MouseEvent;
    }) => void;
    onMouseleave?: (context: {
        e: MouseEvent;
    }) => void;
    placeholder?: string | string[];
    inputProps?: unknown;
    activeIndex?: number;
}, import("@vue/composition-api").ShallowUnwrapRef<{
    COMPONENT_NAME: import("@vue/composition-api").ComputedRef<string>;
    SIZE: import("@vue/composition-api").ComputedRef<{
        small: string;
        medium: string;
        large: string;
        default: string;
        xs: string;
        xl: string;
        block: string;
    }>;
    STATUS: import("@vue/composition-api").ComputedRef<{
        loading: string;
        loadMore: string;
        disabled: string;
        focused: string;
        success: string;
        error: string;
        warning: string;
        selected: string;
        active: string;
        checked: string;
        current: string;
        hidden: string;
        visible: string;
        expanded: string;
        indeterminate: string;
    }>;
    focused: import("@vue/composition-api").Ref<boolean>;
    classPrefix: import("@vue/composition-api").ComputedRef<string>;
    inputRefs: {
        firstInputRef: import("@vue/composition-api").Ref<any>;
        secondInputRef: import("@vue/composition-api").Ref<any>;
    };
    calcInputProps: import("@vue/composition-api").ComputedRef<any[]>;
    calcFormat: import("@vue/composition-api").ComputedRef<any[]>;
    calcPlaceholder: import("@vue/composition-api").ComputedRef<any[]>;
    innerValue: import("@vue/composition-api").Ref<import("./type").RangeInputValue>;
    isShowClearIcon: import("@vue/composition-api").ComputedRef<boolean>;
    handleMouseEnter: (e: MouseEvent) => void;
    handleMouseLeave: (e: MouseEvent) => void;
    handleEnter: (rangeValue: import("./type").RangeInputValue, context: {
        e: MouseEvent;
    }) => void;
    handleFocus: (rangeValue: import("./type").RangeInputValue, context: {
        e: MouseEvent;
    }) => void;
    handleBlur: (rangeValue: import("./type").RangeInputValue, context: {
        e: MouseEvent;
    }) => void;
    setInnerValue: import("../hooks").ChangeHandler<import("./type").RangeInputValue, [context?: {
        e?: MouseEvent | CompositionEvent | InputEvent;
        position?: import("./type").RangeInputPosition;
        trigger?: "input" | "clear" | "initial";
    }]>;
    renderTNodeJSX: (name: string, options?: import("../hooks/render-tnode").OptionsType) => any;
    handleClear: (context: {
        e: MouseEvent;
    }) => void;
    CloseCircleFilledIcon: import("tdesign-icons-vue").GlobalIconType;
    firstInputElement: any;
    secondInputElement: any;
    focus: (options: any) => void;
    blur: (options: any) => void;
    select: (options: any) => void;
}>, import("@vue/composition-api").Data, {}, {}, {}, {}, {}, {
    value: import("./type").RangeInputValue;
    disabled: boolean;
    size: "small" | "medium" | "large";
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    defaultValue: import("./type").RangeInputValue;
    borderless: boolean;
    clearable: boolean;
    showClearIconOnEmpty: boolean;
    separator: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
} & {
    label?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onClick?: (context?: {
        e?: MouseEvent;
        position?: import("./type").RangeInputPosition;
    }) => void;
    onChange?: (value: import("./type").RangeInputValue, context?: {
        e?: MouseEvent | CompositionEvent | InputEvent;
        position?: import("./type").RangeInputPosition;
        trigger?: "input" | "clear" | "initial";
    }) => void;
    format?: import("..").InputFormatType | import("..").InputFormatType[];
    prefixIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    suffix?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    suffixIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onBlur?: (value: import("./type").RangeInputValue, context?: {
        e?: FocusEvent;
        position?: import("./type").RangeInputPosition;
    }) => void;
    onClear?: (context: {
        e: MouseEvent;
    }) => void;
    onEnter?: (value: import("./type").RangeInputValue, context?: {
        e?: MouseEvent | InputEvent;
        position?: import("./type").RangeInputPosition;
    }) => void;
    onFocus?: (value: import("./type").RangeInputValue, context?: {
        e?: FocusEvent;
        position?: import("./type").RangeInputPosition;
    }) => void;
    onMouseenter?: (context: {
        e: MouseEvent;
    }) => void;
    onMouseleave?: (context: {
        e: MouseEvent;
    }) => void;
    placeholder?: string | string[];
    inputProps?: unknown;
    activeIndex?: number;
}, {
    value: import("./type").RangeInputValue;
    disabled: boolean;
    size: "small" | "medium" | "large";
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    defaultValue: import("./type").RangeInputValue;
    borderless: boolean;
    clearable: boolean;
    showClearIconOnEmpty: boolean;
    separator: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
}, true>) & import("vue").PluginObject<import("vue").ComponentOptions<import("vue").default, import("@vue/composition-api").ShallowUnwrapRef<{
    COMPONENT_NAME: import("@vue/composition-api").ComputedRef<string>;
    SIZE: import("@vue/composition-api").ComputedRef<{
        small: string;
        medium: string;
        large: string;
        default: string;
        xs: string;
        xl: string;
        block: string;
    }>;
    STATUS: import("@vue/composition-api").ComputedRef<{
        loading: string;
        loadMore: string;
        disabled: string;
        focused: string;
        success: string;
        error: string;
        warning: string;
        selected: string;
        active: string;
        checked: string;
        current: string;
        hidden: string;
        visible: string;
        expanded: string;
        indeterminate: string;
    }>;
    focused: import("@vue/composition-api").Ref<boolean>;
    classPrefix: import("@vue/composition-api").ComputedRef<string>;
    inputRefs: {
        firstInputRef: import("@vue/composition-api").Ref<any>;
        secondInputRef: import("@vue/composition-api").Ref<any>;
    };
    calcInputProps: import("@vue/composition-api").ComputedRef<any[]>;
    calcFormat: import("@vue/composition-api").ComputedRef<any[]>;
    calcPlaceholder: import("@vue/composition-api").ComputedRef<any[]>;
    innerValue: import("@vue/composition-api").Ref<import("./type").RangeInputValue>;
    isShowClearIcon: import("@vue/composition-api").ComputedRef<boolean>;
    handleMouseEnter: (e: MouseEvent) => void;
    handleMouseLeave: (e: MouseEvent) => void;
    handleEnter: (rangeValue: import("./type").RangeInputValue, context: {
        e: MouseEvent;
    }) => void;
    handleFocus: (rangeValue: import("./type").RangeInputValue, context: {
        e: MouseEvent;
    }) => void;
    handleBlur: (rangeValue: import("./type").RangeInputValue, context: {
        e: MouseEvent;
    }) => void;
    setInnerValue: import("../hooks").ChangeHandler<import("./type").RangeInputValue, [context?: {
        e?: MouseEvent | CompositionEvent | InputEvent;
        position?: import("./type").RangeInputPosition;
        trigger?: "input" | "clear" | "initial";
    }]>;
    renderTNodeJSX: (name: string, options?: import("../hooks/render-tnode").OptionsType) => any;
    handleClear: (context: {
        e: MouseEvent;
    }) => void;
    CloseCircleFilledIcon: import("tdesign-icons-vue").GlobalIconType;
    firstInputElement: any;
    secondInputElement: any;
    focus: (options: any) => void;
    blur: (options: any) => void;
    select: (options: any) => void;
}> & import("@vue/composition-api").Data, {}, {}, {
    activeIndex: {
        type: NumberConstructor;
    };
    borderless: BooleanConstructor;
    clearable: BooleanConstructor;
    disabled: {
        type: BooleanConstructor;
        default: any;
    };
    format: {
        type: import("vue").PropType<import("..").InputFormatType | import("..").InputFormatType[]>;
    };
    inputProps: {
        type: import("vue").PropType<import("..").InputProps<import("..").InputValue> | import("..").InputProps<import("..").InputValue>[]>;
    };
    label: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    placeholder: {
        type: import("vue").PropType<string | string[]>;
    };
    prefixIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    readonly: BooleanConstructor;
    separator: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: string;
    };
    showClearIconOnEmpty: BooleanConstructor;
    size: {
        type: import("vue").PropType<"small" | "medium" | "large">;
        default: "small" | "medium" | "large";
        validator(val: "small" | "medium" | "large"): boolean;
    };
    status: {
        type: import("vue").PropType<"error" | "default" | "success" | "warning">;
        default: "error" | "default" | "success" | "warning";
        validator(val: "error" | "default" | "success" | "warning"): boolean;
    };
    suffix: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    suffixIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    tips: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    value: {
        type: import("vue").PropType<import("./type").RangeInputValue>;
        default: any;
    };
    defaultValue: {
        type: import("vue").PropType<import("./type").RangeInputValue>;
        default: () => import("./type").RangeInputValue;
    };
    onBlur: import("vue").PropType<(value: import("./type").RangeInputValue, context?: {
        e?: FocusEvent;
        position?: import("./type").RangeInputPosition;
    }) => void>;
    onChange: import("vue").PropType<(value: import("./type").RangeInputValue, context?: {
        e?: MouseEvent | CompositionEvent | InputEvent;
        position?: import("./type").RangeInputPosition;
        trigger?: "input" | "clear" | "initial";
    }) => void>;
    onClear: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onClick: import("vue").PropType<(context?: {
        e?: MouseEvent;
        position?: import("./type").RangeInputPosition;
    }) => void>;
    onEnter: import("vue").PropType<(value: import("./type").RangeInputValue, context?: {
        e?: MouseEvent | InputEvent;
        position?: import("./type").RangeInputPosition;
    }) => void>;
    onFocus: import("vue").PropType<(value: import("./type").RangeInputValue, context?: {
        e?: FocusEvent;
        position?: import("./type").RangeInputPosition;
    }) => void>;
    onMouseenter: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onMouseleave: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
}, import("@vue/composition-api").ExtractPropTypes<{
    activeIndex: {
        type: NumberConstructor;
    };
    borderless: BooleanConstructor;
    clearable: BooleanConstructor;
    disabled: {
        type: BooleanConstructor;
        default: any;
    };
    format: {
        type: import("vue").PropType<import("..").InputFormatType | import("..").InputFormatType[]>;
    };
    inputProps: {
        type: import("vue").PropType<import("..").InputProps<import("..").InputValue> | import("..").InputProps<import("..").InputValue>[]>;
    };
    label: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    placeholder: {
        type: import("vue").PropType<string | string[]>;
    };
    prefixIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    readonly: BooleanConstructor;
    separator: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: string;
    };
    showClearIconOnEmpty: BooleanConstructor;
    size: {
        type: import("vue").PropType<"small" | "medium" | "large">;
        default: "small" | "medium" | "large";
        validator(val: "small" | "medium" | "large"): boolean;
    };
    status: {
        type: import("vue").PropType<"error" | "default" | "success" | "warning">;
        default: "error" | "default" | "success" | "warning";
        validator(val: "error" | "default" | "success" | "warning"): boolean;
    };
    suffix: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    suffixIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    tips: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    value: {
        type: import("vue").PropType<import("./type").RangeInputValue>;
        default: any;
    };
    defaultValue: {
        type: import("vue").PropType<import("./type").RangeInputValue>;
        default: () => import("./type").RangeInputValue;
    };
    onBlur: import("vue").PropType<(value: import("./type").RangeInputValue, context?: {
        e?: FocusEvent;
        position?: import("./type").RangeInputPosition;
    }) => void>;
    onChange: import("vue").PropType<(value: import("./type").RangeInputValue, context?: {
        e?: MouseEvent | CompositionEvent | InputEvent;
        position?: import("./type").RangeInputPosition;
        trigger?: "input" | "clear" | "initial";
    }) => void>;
    onClear: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onClick: import("vue").PropType<(context?: {
        e?: MouseEvent;
        position?: import("./type").RangeInputPosition;
    }) => void>;
    onEnter: import("vue").PropType<(value: import("./type").RangeInputValue, context?: {
        e?: MouseEvent | InputEvent;
        position?: import("./type").RangeInputPosition;
    }) => void>;
    onFocus: import("vue").PropType<(value: import("./type").RangeInputValue, context?: {
        e?: FocusEvent;
        position?: import("./type").RangeInputPosition;
    }) => void>;
    onMouseenter: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onMouseleave: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
}>> & Omit<import("vue").VueConstructor<import("vue").default>, never> & (new (...args: any[]) => import("@vue/composition-api").ComponentRenderProxy<{
    value: import("./type").RangeInputValue;
    disabled: boolean;
    size: "small" | "medium" | "large";
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    defaultValue: import("./type").RangeInputValue;
    borderless: boolean;
    clearable: boolean;
    showClearIconOnEmpty: boolean;
    separator: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
} & {
    label?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onClick?: (context?: {
        e?: MouseEvent;
        position?: import("./type").RangeInputPosition;
    }) => void;
    onChange?: (value: import("./type").RangeInputValue, context?: {
        e?: MouseEvent | CompositionEvent | InputEvent;
        position?: import("./type").RangeInputPosition;
        trigger?: "input" | "clear" | "initial";
    }) => void;
    format?: import("..").InputFormatType | import("..").InputFormatType[];
    prefixIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    suffix?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    suffixIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onBlur?: (value: import("./type").RangeInputValue, context?: {
        e?: FocusEvent;
        position?: import("./type").RangeInputPosition;
    }) => void;
    onClear?: (context: {
        e: MouseEvent;
    }) => void;
    onEnter?: (value: import("./type").RangeInputValue, context?: {
        e?: MouseEvent | InputEvent;
        position?: import("./type").RangeInputPosition;
    }) => void;
    onFocus?: (value: import("./type").RangeInputValue, context?: {
        e?: FocusEvent;
        position?: import("./type").RangeInputPosition;
    }) => void;
    onMouseenter?: (context: {
        e: MouseEvent;
    }) => void;
    onMouseleave?: (context: {
        e: MouseEvent;
    }) => void;
    placeholder?: string | string[];
    inputProps?: unknown;
    activeIndex?: number;
}, import("@vue/composition-api").ShallowUnwrapRef<{
    COMPONENT_NAME: import("@vue/composition-api").ComputedRef<string>;
    SIZE: import("@vue/composition-api").ComputedRef<{
        small: string;
        medium: string;
        large: string;
        default: string;
        xs: string;
        xl: string;
        block: string;
    }>;
    STATUS: import("@vue/composition-api").ComputedRef<{
        loading: string;
        loadMore: string;
        disabled: string;
        focused: string;
        success: string;
        error: string;
        warning: string;
        selected: string;
        active: string;
        checked: string;
        current: string;
        hidden: string;
        visible: string;
        expanded: string;
        indeterminate: string;
    }>;
    focused: import("@vue/composition-api").Ref<boolean>;
    classPrefix: import("@vue/composition-api").ComputedRef<string>;
    inputRefs: {
        firstInputRef: import("@vue/composition-api").Ref<any>;
        secondInputRef: import("@vue/composition-api").Ref<any>;
    };
    calcInputProps: import("@vue/composition-api").ComputedRef<any[]>;
    calcFormat: import("@vue/composition-api").ComputedRef<any[]>;
    calcPlaceholder: import("@vue/composition-api").ComputedRef<any[]>;
    innerValue: import("@vue/composition-api").Ref<import("./type").RangeInputValue>;
    isShowClearIcon: import("@vue/composition-api").ComputedRef<boolean>;
    handleMouseEnter: (e: MouseEvent) => void;
    handleMouseLeave: (e: MouseEvent) => void;
    handleEnter: (rangeValue: import("./type").RangeInputValue, context: {
        e: MouseEvent;
    }) => void;
    handleFocus: (rangeValue: import("./type").RangeInputValue, context: {
        e: MouseEvent;
    }) => void;
    handleBlur: (rangeValue: import("./type").RangeInputValue, context: {
        e: MouseEvent;
    }) => void;
    setInnerValue: import("../hooks").ChangeHandler<import("./type").RangeInputValue, [context?: {
        e?: MouseEvent | CompositionEvent | InputEvent;
        position?: import("./type").RangeInputPosition;
        trigger?: "input" | "clear" | "initial";
    }]>;
    renderTNodeJSX: (name: string, options?: import("../hooks/render-tnode").OptionsType) => any;
    handleClear: (context: {
        e: MouseEvent;
    }) => void;
    CloseCircleFilledIcon: import("tdesign-icons-vue").GlobalIconType;
    firstInputElement: any;
    secondInputElement: any;
    focus: (options: any) => void;
    blur: (options: any) => void;
    select: (options: any) => void;
}>, import("@vue/composition-api").Data, {}, {}, {}, {}, {}, {
    value: import("./type").RangeInputValue;
    disabled: boolean;
    size: "small" | "medium" | "large";
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    defaultValue: import("./type").RangeInputValue;
    borderless: boolean;
    clearable: boolean;
    showClearIconOnEmpty: boolean;
    separator: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
} & {
    label?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onClick?: (context?: {
        e?: MouseEvent;
        position?: import("./type").RangeInputPosition;
    }) => void;
    onChange?: (value: import("./type").RangeInputValue, context?: {
        e?: MouseEvent | CompositionEvent | InputEvent;
        position?: import("./type").RangeInputPosition;
        trigger?: "input" | "clear" | "initial";
    }) => void;
    format?: import("..").InputFormatType | import("..").InputFormatType[];
    prefixIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    suffix?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    suffixIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onBlur?: (value: import("./type").RangeInputValue, context?: {
        e?: FocusEvent;
        position?: import("./type").RangeInputPosition;
    }) => void;
    onClear?: (context: {
        e: MouseEvent;
    }) => void;
    onEnter?: (value: import("./type").RangeInputValue, context?: {
        e?: MouseEvent | InputEvent;
        position?: import("./type").RangeInputPosition;
    }) => void;
    onFocus?: (value: import("./type").RangeInputValue, context?: {
        e?: FocusEvent;
        position?: import("./type").RangeInputPosition;
    }) => void;
    onMouseenter?: (context: {
        e: MouseEvent;
    }) => void;
    onMouseleave?: (context: {
        e: MouseEvent;
    }) => void;
    placeholder?: string | string[];
    inputProps?: unknown;
    activeIndex?: number;
}, {
    value: import("./type").RangeInputValue;
    disabled: boolean;
    size: "small" | "medium" | "large";
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    defaultValue: import("./type").RangeInputValue;
    borderless: boolean;
    clearable: boolean;
    showClearIconOnEmpty: boolean;
    separator: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
}, true>)>;
export declare const RangeInputPopup: import("vue").ComponentOptions<import("vue").default, import("@vue/composition-api").ShallowUnwrapRef<{
    COMPONENT_NAME: import("@vue/composition-api").ComputedRef<string>;
    tOverlayInnerStyle: import("@vue/composition-api").ComputedRef<import("..").Styles | ((triggerElement: HTMLElement, popupElement: HTMLElement) => import("..").Styles)>;
    innerPopupVisible: import("@vue/composition-api").Ref<boolean>;
    onInnerPopupVisibleChange: (visible: boolean, ctx: import("..").PopupVisibleChangeContext) => void;
    popupClasses: import("@vue/composition-api").ComputedRef<(string | {
        [x: string]: boolean;
    })[]>;
}> & import("@vue/composition-api").Data, {}, {}, {
    autoWidth: BooleanConstructor;
    disabled: BooleanConstructor;
    inputValue: {
        type: import("vue").PropType<import("./type").RangeInputValue>;
        default: any;
    };
    defaultInputValue: {
        type: import("vue").PropType<import("./type").RangeInputValue>;
    };
    label: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    panel: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    popupProps: {
        type: import("vue").PropType<import("..").TdPopupProps>;
    };
    popupVisible: BooleanConstructor;
    rangeInputProps: {
        type: import("vue").PropType<TdRangeInputProps>;
    };
    readonly: BooleanConstructor;
    status: {
        type: import("vue").PropType<"error" | "default" | "success" | "warning">;
        default: "error" | "default" | "success" | "warning";
        validator(val: "error" | "default" | "success" | "warning"): boolean;
    };
    tips: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    onInputChange: import("vue").PropType<(value: import("./type").RangeInputValue, context?: import("./type").RangeInputValueChangeContext) => void>;
    onPopupVisibleChange: import("vue").PropType<(visible: boolean, context: import("..").PopupVisibleChangeContext) => void>;
}, import("@vue/composition-api").ExtractPropTypes<{
    autoWidth: BooleanConstructor;
    disabled: BooleanConstructor;
    inputValue: {
        type: import("vue").PropType<import("./type").RangeInputValue>;
        default: any;
    };
    defaultInputValue: {
        type: import("vue").PropType<import("./type").RangeInputValue>;
    };
    label: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    panel: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    popupProps: {
        type: import("vue").PropType<import("..").TdPopupProps>;
    };
    popupVisible: BooleanConstructor;
    rangeInputProps: {
        type: import("vue").PropType<TdRangeInputProps>;
    };
    readonly: BooleanConstructor;
    status: {
        type: import("vue").PropType<"error" | "default" | "success" | "warning">;
        default: "error" | "default" | "success" | "warning";
        validator(val: "error" | "default" | "success" | "warning"): boolean;
    };
    tips: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    onInputChange: import("vue").PropType<(value: import("./type").RangeInputValue, context?: import("./type").RangeInputValueChangeContext) => void>;
    onPopupVisibleChange: import("vue").PropType<(visible: boolean, context: import("..").PopupVisibleChangeContext) => void>;
}>> & Omit<import("vue").VueConstructor<import("vue").default>, never> & (new (...args: any[]) => import("@vue/composition-api").ComponentRenderProxy<{
    disabled: boolean;
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    autoWidth: boolean;
    inputValue: import("./type").RangeInputValue;
    popupVisible: boolean;
} & {
    label?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    defaultInputValue?: import("./type").RangeInputValue;
    onInputChange?: (value: import("./type").RangeInputValue, context?: import("./type").RangeInputValueChangeContext) => void;
    panel?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    popupProps?: unknown;
    onPopupVisibleChange?: (visible: boolean, context: import("..").PopupVisibleChangeContext) => void;
    rangeInputProps?: unknown;
}, import("@vue/composition-api").ShallowUnwrapRef<{
    COMPONENT_NAME: import("@vue/composition-api").ComputedRef<string>;
    tOverlayInnerStyle: import("@vue/composition-api").ComputedRef<import("..").Styles | ((triggerElement: HTMLElement, popupElement: HTMLElement) => import("..").Styles)>;
    innerPopupVisible: import("@vue/composition-api").Ref<boolean>;
    onInnerPopupVisibleChange: (visible: boolean, ctx: import("..").PopupVisibleChangeContext) => void;
    popupClasses: import("@vue/composition-api").ComputedRef<(string | {
        [x: string]: boolean;
    })[]>;
}>, import("@vue/composition-api").Data, {}, {}, {}, {}, {}, {
    disabled: boolean;
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    autoWidth: boolean;
    inputValue: import("./type").RangeInputValue;
    popupVisible: boolean;
} & {
    label?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    defaultInputValue?: import("./type").RangeInputValue;
    onInputChange?: (value: import("./type").RangeInputValue, context?: import("./type").RangeInputValueChangeContext) => void;
    panel?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    popupProps?: unknown;
    onPopupVisibleChange?: (visible: boolean, context: import("..").PopupVisibleChangeContext) => void;
    rangeInputProps?: unknown;
}, {
    disabled: boolean;
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    autoWidth: boolean;
    inputValue: import("./type").RangeInputValue;
    popupVisible: boolean;
}, true>) & import("vue").PluginObject<import("vue").ComponentOptions<import("vue").default, import("@vue/composition-api").ShallowUnwrapRef<{
    COMPONENT_NAME: import("@vue/composition-api").ComputedRef<string>;
    tOverlayInnerStyle: import("@vue/composition-api").ComputedRef<import("..").Styles | ((triggerElement: HTMLElement, popupElement: HTMLElement) => import("..").Styles)>;
    innerPopupVisible: import("@vue/composition-api").Ref<boolean>;
    onInnerPopupVisibleChange: (visible: boolean, ctx: import("..").PopupVisibleChangeContext) => void;
    popupClasses: import("@vue/composition-api").ComputedRef<(string | {
        [x: string]: boolean;
    })[]>;
}> & import("@vue/composition-api").Data, {}, {}, {
    autoWidth: BooleanConstructor;
    disabled: BooleanConstructor;
    inputValue: {
        type: import("vue").PropType<import("./type").RangeInputValue>;
        default: any;
    };
    defaultInputValue: {
        type: import("vue").PropType<import("./type").RangeInputValue>;
    };
    label: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    panel: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    popupProps: {
        type: import("vue").PropType<import("..").TdPopupProps>;
    };
    popupVisible: BooleanConstructor;
    rangeInputProps: {
        type: import("vue").PropType<TdRangeInputProps>;
    };
    readonly: BooleanConstructor;
    status: {
        type: import("vue").PropType<"error" | "default" | "success" | "warning">;
        default: "error" | "default" | "success" | "warning";
        validator(val: "error" | "default" | "success" | "warning"): boolean;
    };
    tips: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    onInputChange: import("vue").PropType<(value: import("./type").RangeInputValue, context?: import("./type").RangeInputValueChangeContext) => void>;
    onPopupVisibleChange: import("vue").PropType<(visible: boolean, context: import("..").PopupVisibleChangeContext) => void>;
}, import("@vue/composition-api").ExtractPropTypes<{
    autoWidth: BooleanConstructor;
    disabled: BooleanConstructor;
    inputValue: {
        type: import("vue").PropType<import("./type").RangeInputValue>;
        default: any;
    };
    defaultInputValue: {
        type: import("vue").PropType<import("./type").RangeInputValue>;
    };
    label: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    panel: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    popupProps: {
        type: import("vue").PropType<import("..").TdPopupProps>;
    };
    popupVisible: BooleanConstructor;
    rangeInputProps: {
        type: import("vue").PropType<TdRangeInputProps>;
    };
    readonly: BooleanConstructor;
    status: {
        type: import("vue").PropType<"error" | "default" | "success" | "warning">;
        default: "error" | "default" | "success" | "warning";
        validator(val: "error" | "default" | "success" | "warning"): boolean;
    };
    tips: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    onInputChange: import("vue").PropType<(value: import("./type").RangeInputValue, context?: import("./type").RangeInputValueChangeContext) => void>;
    onPopupVisibleChange: import("vue").PropType<(visible: boolean, context: import("..").PopupVisibleChangeContext) => void>;
}>> & Omit<import("vue").VueConstructor<import("vue").default>, never> & (new (...args: any[]) => import("@vue/composition-api").ComponentRenderProxy<{
    disabled: boolean;
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    autoWidth: boolean;
    inputValue: import("./type").RangeInputValue;
    popupVisible: boolean;
} & {
    label?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    defaultInputValue?: import("./type").RangeInputValue;
    onInputChange?: (value: import("./type").RangeInputValue, context?: import("./type").RangeInputValueChangeContext) => void;
    panel?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    popupProps?: unknown;
    onPopupVisibleChange?: (visible: boolean, context: import("..").PopupVisibleChangeContext) => void;
    rangeInputProps?: unknown;
}, import("@vue/composition-api").ShallowUnwrapRef<{
    COMPONENT_NAME: import("@vue/composition-api").ComputedRef<string>;
    tOverlayInnerStyle: import("@vue/composition-api").ComputedRef<import("..").Styles | ((triggerElement: HTMLElement, popupElement: HTMLElement) => import("..").Styles)>;
    innerPopupVisible: import("@vue/composition-api").Ref<boolean>;
    onInnerPopupVisibleChange: (visible: boolean, ctx: import("..").PopupVisibleChangeContext) => void;
    popupClasses: import("@vue/composition-api").ComputedRef<(string | {
        [x: string]: boolean;
    })[]>;
}>, import("@vue/composition-api").Data, {}, {}, {}, {}, {}, {
    disabled: boolean;
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    autoWidth: boolean;
    inputValue: import("./type").RangeInputValue;
    popupVisible: boolean;
} & {
    label?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    defaultInputValue?: import("./type").RangeInputValue;
    onInputChange?: (value: import("./type").RangeInputValue, context?: import("./type").RangeInputValueChangeContext) => void;
    panel?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    popupProps?: unknown;
    onPopupVisibleChange?: (visible: boolean, context: import("..").PopupVisibleChangeContext) => void;
    rangeInputProps?: unknown;
}, {
    disabled: boolean;
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    autoWidth: boolean;
    inputValue: import("./type").RangeInputValue;
    popupVisible: boolean;
}, true>)>;
export default RangeInput;
