import { TdSelectInputProps } from './type';
import './style';
export * from './type';
export declare type SelectInputProps = TdSelectInputProps;
export declare const SelectInput: import("vue").ComponentOptions<import("vue").default, import("@vue/composition-api").ShallowUnwrapRef<{
    selectInputRef: import("@vue/composition-api").Ref<any>;
    innerPopupVisible: import("@vue/composition-api").Ref<boolean>;
    commonInputProps: import("@vue/composition-api").ComputedRef<import("./interface").SelectInputCommonProperties>;
    tOverlayInnerStyle: import("@vue/composition-api").ComputedRef<import("..").Styles | ((triggerElement: HTMLElement, popupElement: HTMLElement) => import("..").Styles)>;
    classes: import("@vue/composition-api").ComputedRef<(string | {
        [x: string]: boolean;
    })[]>;
    onInnerClear: (context: {
        e: MouseEvent;
    }) => void;
    renderSelectSingle: (h: import("vue").CreateElement, popupVisible: boolean) => JSX.Element;
    renderSelectMultiple: (p: import("./useMultiple").RenderSelectMultipleParams, h: import("vue").CreateElement) => JSX.Element;
    onInnerPopupVisibleChange: (visible: boolean, ctx: import("..").PopupVisibleChangeContext) => void;
    classPrefix: import("@vue/composition-api").Ref<string>;
}> & import("@vue/composition-api").Data, {}, {}, {
    updateScrollTop: {
        type: FunctionConstructor;
    };
    allowInput: BooleanConstructor;
    autoWidth: BooleanConstructor;
    autofocus: BooleanConstructor;
    borderless: BooleanConstructor;
    clearable: BooleanConstructor;
    collapsedItems: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: {
            value: import("./type").SelectInputValue;
            collapsedSelectedItems: import("./type").SelectInputValue;
            count: number;
            onClose: (context: {
                index: number;
                e?: MouseEvent;
            }) => void;
        }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    disabled: BooleanConstructor;
    inputProps: {
        type: import("vue").PropType<import("..").InputProps<import("..").InputValue>>;
    };
    inputValue: {
        type: import("vue").PropType<string>;
        default: any;
    };
    defaultInputValue: {
        type: import("vue").PropType<string>;
    };
    keys: {
        type: import("vue").PropType<import("./type").SelectInputKeys>;
    };
    label: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    loading: BooleanConstructor;
    minCollapsedNum: {
        type: NumberConstructor;
        default: number;
    };
    multiple: BooleanConstructor;
    panel: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    placeholder: {
        type: StringConstructor;
        default: string;
    };
    popupProps: {
        type: import("vue").PropType<import("..").TdPopupProps>;
    };
    popupVisible: {
        type: BooleanConstructor;
        default: any;
    };
    defaultPopupVisible: BooleanConstructor;
    readonly: BooleanConstructor;
    reserveKeyword: BooleanConstructor;
    status: {
        type: import("vue").PropType<"error" | "default" | "success" | "warning">;
        default: "error" | "default" | "success" | "warning";
        validator(val: "error" | "default" | "success" | "warning"): boolean;
    };
    suffix: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    suffixIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    tag: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement, props: {
            value: string | number;
        }) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    tagInputProps: {
        type: import("vue").PropType<import("..").TdTagInputProps>;
    };
    tagProps: {
        type: import("vue").PropType<import("..").TdTagProps>;
    };
    tips: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    value: {
        type: import("vue").PropType<import("./type").SelectInputValue>;
        default: any;
    };
    valueDisplay: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement, props: {
            value: import("..").TagInputValue;
            onClose: (index: number, item?: any) => void;
        }) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    onBlur: import("vue").PropType<(value: import("./type").SelectInputValue, context: import("./type").SelectInputBlurContext) => void>;
    onClear: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onEnter: import("vue").PropType<(value: import("./type").SelectInputValue, context: {
        e: KeyboardEvent;
        inputValue: string;
        tagInputValue?: import("..").TagInputValue;
    }) => void>;
    onFocus: import("vue").PropType<(value: import("./type").SelectInputValue, context: import("./type").SelectInputFocusContext) => void>;
    onInputChange: import("vue").PropType<(value: string, context?: import("./type").SelectInputValueChangeContext) => void>;
    onMouseenter: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onMouseleave: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onPaste: import("vue").PropType<(context: {
        e: ClipboardEvent;
        pasteValue: string;
    }) => void>;
    onPopupVisibleChange: import("vue").PropType<(visible: boolean, context: import("..").PopupVisibleChangeContext) => void>;
    onTagChange: import("vue").PropType<(value: import("..").TagInputValue, context: import("..").TagInputChangeContext) => void>;
}, import("@vue/composition-api").ExtractPropTypes<{
    updateScrollTop: {
        type: FunctionConstructor;
    };
    allowInput: BooleanConstructor;
    autoWidth: BooleanConstructor;
    autofocus: BooleanConstructor;
    borderless: BooleanConstructor;
    clearable: BooleanConstructor;
    collapsedItems: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: {
            value: import("./type").SelectInputValue;
            collapsedSelectedItems: import("./type").SelectInputValue;
            count: number;
            onClose: (context: {
                index: number;
                e?: MouseEvent;
            }) => void;
        }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    disabled: BooleanConstructor;
    inputProps: {
        type: import("vue").PropType<import("..").InputProps<import("..").InputValue>>;
    };
    inputValue: {
        type: import("vue").PropType<string>;
        default: any;
    };
    defaultInputValue: {
        type: import("vue").PropType<string>;
    };
    keys: {
        type: import("vue").PropType<import("./type").SelectInputKeys>;
    };
    label: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    loading: BooleanConstructor;
    minCollapsedNum: {
        type: NumberConstructor;
        default: number;
    };
    multiple: BooleanConstructor;
    panel: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    placeholder: {
        type: StringConstructor;
        default: string;
    };
    popupProps: {
        type: import("vue").PropType<import("..").TdPopupProps>;
    };
    popupVisible: {
        type: BooleanConstructor;
        default: any;
    };
    defaultPopupVisible: BooleanConstructor;
    readonly: BooleanConstructor;
    reserveKeyword: BooleanConstructor;
    status: {
        type: import("vue").PropType<"error" | "default" | "success" | "warning">;
        default: "error" | "default" | "success" | "warning";
        validator(val: "error" | "default" | "success" | "warning"): boolean;
    };
    suffix: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    suffixIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    tag: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement, props: {
            value: string | number;
        }) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    tagInputProps: {
        type: import("vue").PropType<import("..").TdTagInputProps>;
    };
    tagProps: {
        type: import("vue").PropType<import("..").TdTagProps>;
    };
    tips: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    value: {
        type: import("vue").PropType<import("./type").SelectInputValue>;
        default: any;
    };
    valueDisplay: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement, props: {
            value: import("..").TagInputValue;
            onClose: (index: number, item?: any) => void;
        }) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    onBlur: import("vue").PropType<(value: import("./type").SelectInputValue, context: import("./type").SelectInputBlurContext) => void>;
    onClear: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onEnter: import("vue").PropType<(value: import("./type").SelectInputValue, context: {
        e: KeyboardEvent;
        inputValue: string;
        tagInputValue?: import("..").TagInputValue;
    }) => void>;
    onFocus: import("vue").PropType<(value: import("./type").SelectInputValue, context: import("./type").SelectInputFocusContext) => void>;
    onInputChange: import("vue").PropType<(value: string, context?: import("./type").SelectInputValueChangeContext) => void>;
    onMouseenter: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onMouseleave: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onPaste: import("vue").PropType<(context: {
        e: ClipboardEvent;
        pasteValue: string;
    }) => void>;
    onPopupVisibleChange: import("vue").PropType<(visible: boolean, context: import("..").PopupVisibleChangeContext) => void>;
    onTagChange: import("vue").PropType<(value: import("..").TagInputValue, context: import("..").TagInputChangeContext) => void>;
}>> & Omit<import("vue").VueConstructor<import("vue").default>, never> & (new (...args: any[]) => import("@vue/composition-api").ComponentRenderProxy<{
    value: any;
    loading: boolean;
    autofocus: boolean;
    disabled: boolean;
    multiple: boolean;
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    autoWidth: boolean;
    borderless: boolean;
    clearable: boolean;
    placeholder: string;
    inputValue: string;
    minCollapsedNum: number;
    allowInput: boolean;
    popupVisible: boolean;
    defaultPopupVisible: boolean;
    reserveKeyword: boolean;
} & {
    keys?: unknown;
    label?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    tag?: string | ((h: import("vue").CreateElement, props: {
        value: string | number;
    }) => import("vue/types/vnode").ScopedSlotReturnValue);
    suffix?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    suffixIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onBlur?: (value: import("./type").SelectInputValue, context: import("./type").SelectInputBlurContext) => void;
    onClear?: (context: {
        e: MouseEvent;
    }) => void;
    onEnter?: (value: import("./type").SelectInputValue, context: {
        e: KeyboardEvent;
        inputValue: string;
        tagInputValue?: import("..").TagInputValue;
    }) => void;
    onFocus?: (value: import("./type").SelectInputValue, context: import("./type").SelectInputFocusContext) => void;
    onMouseenter?: (context: {
        e: MouseEvent;
    }) => void;
    onMouseleave?: (context: {
        e: MouseEvent;
    }) => void;
    onPaste?: (context: {
        e: ClipboardEvent;
        pasteValue: string;
    }) => void;
    updateScrollTop?: Function;
    collapsedItems?: (h: import("vue").CreateElement, props: {
        value: import("./type").SelectInputValue;
        collapsedSelectedItems: import("./type").SelectInputValue;
        count: number;
        onClose: (context: {
            index: number;
            e?: MouseEvent;
        }) => void;
    }) => import("vue/types/vnode").ScopedSlotReturnValue;
    inputProps?: unknown;
    defaultInputValue?: string;
    tagProps?: unknown;
    valueDisplay?: string | ((h: import("vue").CreateElement, props: {
        value: import("..").TagInputValue;
        onClose: (index: number, item?: any) => void;
    }) => import("vue/types/vnode").ScopedSlotReturnValue);
    onInputChange?: (value: string, context?: import("./type").SelectInputValueChangeContext) => void;
    panel?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    popupProps?: unknown;
    tagInputProps?: unknown;
    onPopupVisibleChange?: (visible: boolean, context: import("..").PopupVisibleChangeContext) => void;
    onTagChange?: (value: import("..").TagInputValue, context: import("..").TagInputChangeContext) => void;
}, import("@vue/composition-api").ShallowUnwrapRef<{
    selectInputRef: import("@vue/composition-api").Ref<any>;
    innerPopupVisible: import("@vue/composition-api").Ref<boolean>;
    commonInputProps: import("@vue/composition-api").ComputedRef<import("./interface").SelectInputCommonProperties>;
    tOverlayInnerStyle: import("@vue/composition-api").ComputedRef<import("..").Styles | ((triggerElement: HTMLElement, popupElement: HTMLElement) => import("..").Styles)>;
    classes: import("@vue/composition-api").ComputedRef<(string | {
        [x: string]: boolean;
    })[]>;
    onInnerClear: (context: {
        e: MouseEvent;
    }) => void;
    renderSelectSingle: (h: import("vue").CreateElement, popupVisible: boolean) => JSX.Element;
    renderSelectMultiple: (p: import("./useMultiple").RenderSelectMultipleParams, h: import("vue").CreateElement) => JSX.Element;
    onInnerPopupVisibleChange: (visible: boolean, ctx: import("..").PopupVisibleChangeContext) => void;
    classPrefix: import("@vue/composition-api").Ref<string>;
}>, import("@vue/composition-api").Data, {}, {}, {}, {}, {}, {
    value: any;
    loading: boolean;
    autofocus: boolean;
    disabled: boolean;
    multiple: boolean;
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    autoWidth: boolean;
    borderless: boolean;
    clearable: boolean;
    placeholder: string;
    inputValue: string;
    minCollapsedNum: number;
    allowInput: boolean;
    popupVisible: boolean;
    defaultPopupVisible: boolean;
    reserveKeyword: boolean;
} & {
    keys?: unknown;
    label?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    tag?: string | ((h: import("vue").CreateElement, props: {
        value: string | number;
    }) => import("vue/types/vnode").ScopedSlotReturnValue);
    suffix?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    suffixIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onBlur?: (value: import("./type").SelectInputValue, context: import("./type").SelectInputBlurContext) => void;
    onClear?: (context: {
        e: MouseEvent;
    }) => void;
    onEnter?: (value: import("./type").SelectInputValue, context: {
        e: KeyboardEvent;
        inputValue: string;
        tagInputValue?: import("..").TagInputValue;
    }) => void;
    onFocus?: (value: import("./type").SelectInputValue, context: import("./type").SelectInputFocusContext) => void;
    onMouseenter?: (context: {
        e: MouseEvent;
    }) => void;
    onMouseleave?: (context: {
        e: MouseEvent;
    }) => void;
    onPaste?: (context: {
        e: ClipboardEvent;
        pasteValue: string;
    }) => void;
    updateScrollTop?: Function;
    collapsedItems?: (h: import("vue").CreateElement, props: {
        value: import("./type").SelectInputValue;
        collapsedSelectedItems: import("./type").SelectInputValue;
        count: number;
        onClose: (context: {
            index: number;
            e?: MouseEvent;
        }) => void;
    }) => import("vue/types/vnode").ScopedSlotReturnValue;
    inputProps?: unknown;
    defaultInputValue?: string;
    tagProps?: unknown;
    valueDisplay?: string | ((h: import("vue").CreateElement, props: {
        value: import("..").TagInputValue;
        onClose: (index: number, item?: any) => void;
    }) => import("vue/types/vnode").ScopedSlotReturnValue);
    onInputChange?: (value: string, context?: import("./type").SelectInputValueChangeContext) => void;
    panel?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    popupProps?: unknown;
    tagInputProps?: unknown;
    onPopupVisibleChange?: (visible: boolean, context: import("..").PopupVisibleChangeContext) => void;
    onTagChange?: (value: import("..").TagInputValue, context: import("..").TagInputChangeContext) => void;
}, {
    value: any;
    loading: boolean;
    autofocus: boolean;
    disabled: boolean;
    multiple: boolean;
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    autoWidth: boolean;
    borderless: boolean;
    clearable: boolean;
    placeholder: string;
    inputValue: string;
    minCollapsedNum: number;
    allowInput: boolean;
    popupVisible: boolean;
    defaultPopupVisible: boolean;
    reserveKeyword: boolean;
}, true>) & import("vue").PluginObject<import("vue").ComponentOptions<import("vue").default, import("@vue/composition-api").ShallowUnwrapRef<{
    selectInputRef: import("@vue/composition-api").Ref<any>;
    innerPopupVisible: import("@vue/composition-api").Ref<boolean>;
    commonInputProps: import("@vue/composition-api").ComputedRef<import("./interface").SelectInputCommonProperties>;
    tOverlayInnerStyle: import("@vue/composition-api").ComputedRef<import("..").Styles | ((triggerElement: HTMLElement, popupElement: HTMLElement) => import("..").Styles)>;
    classes: import("@vue/composition-api").ComputedRef<(string | {
        [x: string]: boolean;
    })[]>;
    onInnerClear: (context: {
        e: MouseEvent;
    }) => void;
    renderSelectSingle: (h: import("vue").CreateElement, popupVisible: boolean) => JSX.Element;
    renderSelectMultiple: (p: import("./useMultiple").RenderSelectMultipleParams, h: import("vue").CreateElement) => JSX.Element;
    onInnerPopupVisibleChange: (visible: boolean, ctx: import("..").PopupVisibleChangeContext) => void;
    classPrefix: import("@vue/composition-api").Ref<string>;
}> & import("@vue/composition-api").Data, {}, {}, {
    updateScrollTop: {
        type: FunctionConstructor;
    };
    allowInput: BooleanConstructor;
    autoWidth: BooleanConstructor;
    autofocus: BooleanConstructor;
    borderless: BooleanConstructor;
    clearable: BooleanConstructor;
    collapsedItems: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: {
            value: import("./type").SelectInputValue;
            collapsedSelectedItems: import("./type").SelectInputValue;
            count: number;
            onClose: (context: {
                index: number;
                e?: MouseEvent;
            }) => void;
        }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    disabled: BooleanConstructor;
    inputProps: {
        type: import("vue").PropType<import("..").InputProps<import("..").InputValue>>;
    };
    inputValue: {
        type: import("vue").PropType<string>;
        default: any;
    };
    defaultInputValue: {
        type: import("vue").PropType<string>;
    };
    keys: {
        type: import("vue").PropType<import("./type").SelectInputKeys>;
    };
    label: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    loading: BooleanConstructor;
    minCollapsedNum: {
        type: NumberConstructor;
        default: number;
    };
    multiple: BooleanConstructor;
    panel: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    placeholder: {
        type: StringConstructor;
        default: string;
    };
    popupProps: {
        type: import("vue").PropType<import("..").TdPopupProps>;
    };
    popupVisible: {
        type: BooleanConstructor;
        default: any;
    };
    defaultPopupVisible: BooleanConstructor;
    readonly: BooleanConstructor;
    reserveKeyword: BooleanConstructor;
    status: {
        type: import("vue").PropType<"error" | "default" | "success" | "warning">;
        default: "error" | "default" | "success" | "warning";
        validator(val: "error" | "default" | "success" | "warning"): boolean;
    };
    suffix: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    suffixIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    tag: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement, props: {
            value: string | number;
        }) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    tagInputProps: {
        type: import("vue").PropType<import("..").TdTagInputProps>;
    };
    tagProps: {
        type: import("vue").PropType<import("..").TdTagProps>;
    };
    tips: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    value: {
        type: import("vue").PropType<import("./type").SelectInputValue>;
        default: any;
    };
    valueDisplay: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement, props: {
            value: import("..").TagInputValue;
            onClose: (index: number, item?: any) => void;
        }) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    onBlur: import("vue").PropType<(value: import("./type").SelectInputValue, context: import("./type").SelectInputBlurContext) => void>;
    onClear: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onEnter: import("vue").PropType<(value: import("./type").SelectInputValue, context: {
        e: KeyboardEvent;
        inputValue: string;
        tagInputValue?: import("..").TagInputValue;
    }) => void>;
    onFocus: import("vue").PropType<(value: import("./type").SelectInputValue, context: import("./type").SelectInputFocusContext) => void>;
    onInputChange: import("vue").PropType<(value: string, context?: import("./type").SelectInputValueChangeContext) => void>;
    onMouseenter: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onMouseleave: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onPaste: import("vue").PropType<(context: {
        e: ClipboardEvent;
        pasteValue: string;
    }) => void>;
    onPopupVisibleChange: import("vue").PropType<(visible: boolean, context: import("..").PopupVisibleChangeContext) => void>;
    onTagChange: import("vue").PropType<(value: import("..").TagInputValue, context: import("..").TagInputChangeContext) => void>;
}, import("@vue/composition-api").ExtractPropTypes<{
    updateScrollTop: {
        type: FunctionConstructor;
    };
    allowInput: BooleanConstructor;
    autoWidth: BooleanConstructor;
    autofocus: BooleanConstructor;
    borderless: BooleanConstructor;
    clearable: BooleanConstructor;
    collapsedItems: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: {
            value: import("./type").SelectInputValue;
            collapsedSelectedItems: import("./type").SelectInputValue;
            count: number;
            onClose: (context: {
                index: number;
                e?: MouseEvent;
            }) => void;
        }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    disabled: BooleanConstructor;
    inputProps: {
        type: import("vue").PropType<import("..").InputProps<import("..").InputValue>>;
    };
    inputValue: {
        type: import("vue").PropType<string>;
        default: any;
    };
    defaultInputValue: {
        type: import("vue").PropType<string>;
    };
    keys: {
        type: import("vue").PropType<import("./type").SelectInputKeys>;
    };
    label: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    loading: BooleanConstructor;
    minCollapsedNum: {
        type: NumberConstructor;
        default: number;
    };
    multiple: BooleanConstructor;
    panel: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    placeholder: {
        type: StringConstructor;
        default: string;
    };
    popupProps: {
        type: import("vue").PropType<import("..").TdPopupProps>;
    };
    popupVisible: {
        type: BooleanConstructor;
        default: any;
    };
    defaultPopupVisible: BooleanConstructor;
    readonly: BooleanConstructor;
    reserveKeyword: BooleanConstructor;
    status: {
        type: import("vue").PropType<"error" | "default" | "success" | "warning">;
        default: "error" | "default" | "success" | "warning";
        validator(val: "error" | "default" | "success" | "warning"): boolean;
    };
    suffix: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    suffixIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    tag: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement, props: {
            value: string | number;
        }) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    tagInputProps: {
        type: import("vue").PropType<import("..").TdTagInputProps>;
    };
    tagProps: {
        type: import("vue").PropType<import("..").TdTagProps>;
    };
    tips: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    value: {
        type: import("vue").PropType<import("./type").SelectInputValue>;
        default: any;
    };
    valueDisplay: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement, props: {
            value: import("..").TagInputValue;
            onClose: (index: number, item?: any) => void;
        }) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    onBlur: import("vue").PropType<(value: import("./type").SelectInputValue, context: import("./type").SelectInputBlurContext) => void>;
    onClear: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onEnter: import("vue").PropType<(value: import("./type").SelectInputValue, context: {
        e: KeyboardEvent;
        inputValue: string;
        tagInputValue?: import("..").TagInputValue;
    }) => void>;
    onFocus: import("vue").PropType<(value: import("./type").SelectInputValue, context: import("./type").SelectInputFocusContext) => void>;
    onInputChange: import("vue").PropType<(value: string, context?: import("./type").SelectInputValueChangeContext) => void>;
    onMouseenter: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onMouseleave: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onPaste: import("vue").PropType<(context: {
        e: ClipboardEvent;
        pasteValue: string;
    }) => void>;
    onPopupVisibleChange: import("vue").PropType<(visible: boolean, context: import("..").PopupVisibleChangeContext) => void>;
    onTagChange: import("vue").PropType<(value: import("..").TagInputValue, context: import("..").TagInputChangeContext) => void>;
}>> & Omit<import("vue").VueConstructor<import("vue").default>, never> & (new (...args: any[]) => import("@vue/composition-api").ComponentRenderProxy<{
    value: any;
    loading: boolean;
    autofocus: boolean;
    disabled: boolean;
    multiple: boolean;
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    autoWidth: boolean;
    borderless: boolean;
    clearable: boolean;
    placeholder: string;
    inputValue: string;
    minCollapsedNum: number;
    allowInput: boolean;
    popupVisible: boolean;
    defaultPopupVisible: boolean;
    reserveKeyword: boolean;
} & {
    keys?: unknown;
    label?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    tag?: string | ((h: import("vue").CreateElement, props: {
        value: string | number;
    }) => import("vue/types/vnode").ScopedSlotReturnValue);
    suffix?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    suffixIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onBlur?: (value: import("./type").SelectInputValue, context: import("./type").SelectInputBlurContext) => void;
    onClear?: (context: {
        e: MouseEvent;
    }) => void;
    onEnter?: (value: import("./type").SelectInputValue, context: {
        e: KeyboardEvent;
        inputValue: string;
        tagInputValue?: import("..").TagInputValue;
    }) => void;
    onFocus?: (value: import("./type").SelectInputValue, context: import("./type").SelectInputFocusContext) => void;
    onMouseenter?: (context: {
        e: MouseEvent;
    }) => void;
    onMouseleave?: (context: {
        e: MouseEvent;
    }) => void;
    onPaste?: (context: {
        e: ClipboardEvent;
        pasteValue: string;
    }) => void;
    updateScrollTop?: Function;
    collapsedItems?: (h: import("vue").CreateElement, props: {
        value: import("./type").SelectInputValue;
        collapsedSelectedItems: import("./type").SelectInputValue;
        count: number;
        onClose: (context: {
            index: number;
            e?: MouseEvent;
        }) => void;
    }) => import("vue/types/vnode").ScopedSlotReturnValue;
    inputProps?: unknown;
    defaultInputValue?: string;
    tagProps?: unknown;
    valueDisplay?: string | ((h: import("vue").CreateElement, props: {
        value: import("..").TagInputValue;
        onClose: (index: number, item?: any) => void;
    }) => import("vue/types/vnode").ScopedSlotReturnValue);
    onInputChange?: (value: string, context?: import("./type").SelectInputValueChangeContext) => void;
    panel?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    popupProps?: unknown;
    tagInputProps?: unknown;
    onPopupVisibleChange?: (visible: boolean, context: import("..").PopupVisibleChangeContext) => void;
    onTagChange?: (value: import("..").TagInputValue, context: import("..").TagInputChangeContext) => void;
}, import("@vue/composition-api").ShallowUnwrapRef<{
    selectInputRef: import("@vue/composition-api").Ref<any>;
    innerPopupVisible: import("@vue/composition-api").Ref<boolean>;
    commonInputProps: import("@vue/composition-api").ComputedRef<import("./interface").SelectInputCommonProperties>;
    tOverlayInnerStyle: import("@vue/composition-api").ComputedRef<import("..").Styles | ((triggerElement: HTMLElement, popupElement: HTMLElement) => import("..").Styles)>;
    classes: import("@vue/composition-api").ComputedRef<(string | {
        [x: string]: boolean;
    })[]>;
    onInnerClear: (context: {
        e: MouseEvent;
    }) => void;
    renderSelectSingle: (h: import("vue").CreateElement, popupVisible: boolean) => JSX.Element;
    renderSelectMultiple: (p: import("./useMultiple").RenderSelectMultipleParams, h: import("vue").CreateElement) => JSX.Element;
    onInnerPopupVisibleChange: (visible: boolean, ctx: import("..").PopupVisibleChangeContext) => void;
    classPrefix: import("@vue/composition-api").Ref<string>;
}>, import("@vue/composition-api").Data, {}, {}, {}, {}, {}, {
    value: any;
    loading: boolean;
    autofocus: boolean;
    disabled: boolean;
    multiple: boolean;
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    autoWidth: boolean;
    borderless: boolean;
    clearable: boolean;
    placeholder: string;
    inputValue: string;
    minCollapsedNum: number;
    allowInput: boolean;
    popupVisible: boolean;
    defaultPopupVisible: boolean;
    reserveKeyword: boolean;
} & {
    keys?: unknown;
    label?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    tag?: string | ((h: import("vue").CreateElement, props: {
        value: string | number;
    }) => import("vue/types/vnode").ScopedSlotReturnValue);
    suffix?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    suffixIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onBlur?: (value: import("./type").SelectInputValue, context: import("./type").SelectInputBlurContext) => void;
    onClear?: (context: {
        e: MouseEvent;
    }) => void;
    onEnter?: (value: import("./type").SelectInputValue, context: {
        e: KeyboardEvent;
        inputValue: string;
        tagInputValue?: import("..").TagInputValue;
    }) => void;
    onFocus?: (value: import("./type").SelectInputValue, context: import("./type").SelectInputFocusContext) => void;
    onMouseenter?: (context: {
        e: MouseEvent;
    }) => void;
    onMouseleave?: (context: {
        e: MouseEvent;
    }) => void;
    onPaste?: (context: {
        e: ClipboardEvent;
        pasteValue: string;
    }) => void;
    updateScrollTop?: Function;
    collapsedItems?: (h: import("vue").CreateElement, props: {
        value: import("./type").SelectInputValue;
        collapsedSelectedItems: import("./type").SelectInputValue;
        count: number;
        onClose: (context: {
            index: number;
            e?: MouseEvent;
        }) => void;
    }) => import("vue/types/vnode").ScopedSlotReturnValue;
    inputProps?: unknown;
    defaultInputValue?: string;
    tagProps?: unknown;
    valueDisplay?: string | ((h: import("vue").CreateElement, props: {
        value: import("..").TagInputValue;
        onClose: (index: number, item?: any) => void;
    }) => import("vue/types/vnode").ScopedSlotReturnValue);
    onInputChange?: (value: string, context?: import("./type").SelectInputValueChangeContext) => void;
    panel?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    popupProps?: unknown;
    tagInputProps?: unknown;
    onPopupVisibleChange?: (visible: boolean, context: import("..").PopupVisibleChangeContext) => void;
    onTagChange?: (value: import("..").TagInputValue, context: import("..").TagInputChangeContext) => void;
}, {
    value: any;
    loading: boolean;
    autofocus: boolean;
    disabled: boolean;
    multiple: boolean;
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    autoWidth: boolean;
    borderless: boolean;
    clearable: boolean;
    placeholder: string;
    inputValue: string;
    minCollapsedNum: number;
    allowInput: boolean;
    popupVisible: boolean;
    defaultPopupVisible: boolean;
    reserveKeyword: boolean;
}, true>)>;
export default SelectInput;
