import { TdSliderProps, SliderMarks as _SliderMarks, SliderValue as _SliderValue } from './type';
import './style';
export declare const Slider: import("vue/types/vue").ExtendedVue<{
    classPrefix: string;
    componentName: string;
    commonSizeClassName: Record<string, string>;
    commonStatusClassName: Record<string, string>;
} & Record<never, any> & import("../config-provider/config-receiver").ConfigComponent & import("vue").default, {
    firstValue: number;
    secondValue: number;
    prevValue: number;
    dragging: boolean;
    sliderSize: number;
    inputDecimalPlaces: number;
    inputFormat: any;
    inputPlaceholder: string;
    inputTheme: string;
    showSteps: boolean;
    formDisabled: any;
}, {
    init(): void;
    valueChanged(): boolean;
    setValues(value: _SliderValue): _SliderValue;
    setPosition(percent: number): void;
    onSliderClick(event: MouseEvent): void;
    resetSize(): void;
    emitChange(value: _SliderValue): void;
    emitChangeEnd(): void;
    getStopStyle(position: number): {
        top: string;
        left?: undefined;
    } | {
        left: string;
        top?: undefined;
    };
    changeValue(point: number): void;
    renderMask(): import("vue").VNode;
    renderInputButton(): import("vue").VNode;
}, {
    tDisabled: boolean;
    containerClass: import("..").ClassName;
    sliderClass: import("..").ClassName;
    sliderRailClass: import("..").ClassName;
    sliderNumberClass: import("..").ClassName;
    vertical: boolean;
    rangeDiff: number;
    steps: number[];
    markList: import("./slider").MarkItem[];
    minValue: number;
    maxValue: number;
    barSize: string;
    barStart: string;
    precision: number;
    runwayStyle: object;
    barStyle: object;
    calcInputNumberProps: object;
}, {
    disabled: boolean;
    inputNumberProps: boolean | import("..").InputNumberProps;
    label: string | boolean | ((h: import("vue").CreateElement, props: {
        value: _SliderValue;
        position?: "end" | "start";
    }) => import("vue/types/vnode").ScopedSlotReturnValue);
    layout: "vertical" | "horizontal";
    marks: number[] | _SliderMarks;
    max: number;
    min: number;
    range: boolean;
    step: number;
    tooltipProps: import("..").TdTooltipProps;
    value: _SliderValue;
    defaultValue: _SliderValue;
    onChange: (value: _SliderValue) => void;
    onChangeEnd: (value: _SliderValue) => void;
}> & import("vue").PluginObject<import("vue/types/vue").ExtendedVue<{
    classPrefix: string;
    componentName: string;
    commonSizeClassName: Record<string, string>;
    commonStatusClassName: Record<string, string>;
} & Record<never, any> & import("../config-provider/config-receiver").ConfigComponent & import("vue").default, {
    firstValue: number;
    secondValue: number;
    prevValue: number;
    dragging: boolean;
    sliderSize: number;
    inputDecimalPlaces: number;
    inputFormat: any;
    inputPlaceholder: string;
    inputTheme: string;
    showSteps: boolean;
    formDisabled: any;
}, {
    init(): void;
    valueChanged(): boolean;
    setValues(value: _SliderValue): _SliderValue;
    setPosition(percent: number): void;
    onSliderClick(event: MouseEvent): void;
    resetSize(): void;
    emitChange(value: _SliderValue): void;
    emitChangeEnd(): void;
    getStopStyle(position: number): {
        top: string;
        left?: undefined;
    } | {
        left: string;
        top?: undefined;
    };
    changeValue(point: number): void;
    renderMask(): import("vue").VNode;
    renderInputButton(): import("vue").VNode;
}, {
    tDisabled: boolean;
    containerClass: import("..").ClassName;
    sliderClass: import("..").ClassName;
    sliderRailClass: import("..").ClassName;
    sliderNumberClass: import("..").ClassName;
    vertical: boolean;
    rangeDiff: number;
    steps: number[];
    markList: import("./slider").MarkItem[];
    minValue: number;
    maxValue: number;
    barSize: string;
    barStart: string;
    precision: number;
    runwayStyle: object;
    barStyle: object;
    calcInputNumberProps: object;
}, {
    disabled: boolean;
    inputNumberProps: boolean | import("..").InputNumberProps;
    label: string | boolean | ((h: import("vue").CreateElement, props: {
        value: _SliderValue;
        position?: "end" | "start";
    }) => import("vue/types/vnode").ScopedSlotReturnValue);
    layout: "vertical" | "horizontal";
    marks: number[] | _SliderMarks;
    max: number;
    min: number;
    range: boolean;
    step: number;
    tooltipProps: import("..").TdTooltipProps;
    value: _SliderValue;
    defaultValue: _SliderValue;
    onChange: (value: _SliderValue) => void;
    onChangeEnd: (value: _SliderValue) => void;
}>> & import("vue").PluginObject<import("vue/types/vue").ExtendedVue<{
    classPrefix: string;
    componentName: string;
    commonSizeClassName: Record<string, string>;
    commonStatusClassName: Record<string, string>;
} & Record<never, any> & import("../config-provider/config-receiver").ConfigComponent & import("vue").default, {
    firstValue: number;
    secondValue: number;
    prevValue: number;
    dragging: boolean;
    sliderSize: number;
    inputDecimalPlaces: number;
    inputFormat: any;
    inputPlaceholder: string;
    inputTheme: string;
    showSteps: boolean;
    formDisabled: any;
}, {
    init(): void;
    valueChanged(): boolean;
    setValues(value: _SliderValue): _SliderValue;
    setPosition(percent: number): void;
    onSliderClick(event: MouseEvent): void;
    resetSize(): void;
    emitChange(value: _SliderValue): void;
    emitChangeEnd(): void;
    getStopStyle(position: number): {
        top: string;
        left?: undefined;
    } | {
        left: string;
        top?: undefined;
    };
    changeValue(point: number): void;
    renderMask(): import("vue").VNode;
    renderInputButton(): import("vue").VNode;
}, {
    tDisabled: boolean;
    containerClass: import("..").ClassName;
    sliderClass: import("..").ClassName;
    sliderRailClass: import("..").ClassName;
    sliderNumberClass: import("..").ClassName;
    vertical: boolean;
    rangeDiff: number;
    steps: number[];
    markList: import("./slider").MarkItem[];
    minValue: number;
    maxValue: number;
    barSize: string;
    barStart: string;
    precision: number;
    runwayStyle: object;
    barStyle: object;
    calcInputNumberProps: object;
}, {
    disabled: boolean;
    inputNumberProps: boolean | import("..").InputNumberProps;
    label: string | boolean | ((h: import("vue").CreateElement, props: {
        value: _SliderValue;
        position?: "end" | "start";
    }) => import("vue/types/vnode").ScopedSlotReturnValue);
    layout: "vertical" | "horizontal";
    marks: number[] | _SliderMarks;
    max: number;
    min: number;
    range: boolean;
    step: number;
    tooltipProps: import("..").TdTooltipProps;
    value: _SliderValue;
    defaultValue: _SliderValue;
    onChange: (value: _SliderValue) => void;
    onChangeEnd: (value: _SliderValue) => void;
}> & import("vue").PluginObject<import("vue/types/vue").ExtendedVue<{
    classPrefix: string;
    componentName: string;
    commonSizeClassName: Record<string, string>;
    commonStatusClassName: Record<string, string>;
} & Record<never, any> & import("../config-provider/config-receiver").ConfigComponent & import("vue").default, {
    firstValue: number;
    secondValue: number;
    prevValue: number;
    dragging: boolean;
    sliderSize: number;
    inputDecimalPlaces: number;
    inputFormat: any;
    inputPlaceholder: string;
    inputTheme: string;
    showSteps: boolean;
    formDisabled: any;
}, {
    init(): void;
    valueChanged(): boolean;
    setValues(value: _SliderValue): _SliderValue;
    setPosition(percent: number): void;
    onSliderClick(event: MouseEvent): void;
    resetSize(): void;
    emitChange(value: _SliderValue): void;
    emitChangeEnd(): void;
    getStopStyle(position: number): {
        top: string;
        left?: undefined;
    } | {
        left: string;
        top?: undefined;
    };
    changeValue(point: number): void;
    renderMask(): import("vue").VNode;
    renderInputButton(): import("vue").VNode;
}, {
    tDisabled: boolean;
    containerClass: import("..").ClassName;
    sliderClass: import("..").ClassName;
    sliderRailClass: import("..").ClassName;
    sliderNumberClass: import("..").ClassName;
    vertical: boolean;
    rangeDiff: number;
    steps: number[];
    markList: import("./slider").MarkItem[];
    minValue: number;
    maxValue: number;
    barSize: string;
    barStart: string;
    precision: number;
    runwayStyle: object;
    barStyle: object;
    calcInputNumberProps: object;
}, {
    disabled: boolean;
    inputNumberProps: boolean | import("..").InputNumberProps;
    label: string | boolean | ((h: import("vue").CreateElement, props: {
        value: _SliderValue;
        position?: "end" | "start";
    }) => import("vue/types/vnode").ScopedSlotReturnValue);
    layout: "vertical" | "horizontal";
    marks: number[] | _SliderMarks;
    max: number;
    min: number;
    range: boolean;
    step: number;
    tooltipProps: import("..").TdTooltipProps;
    value: _SliderValue;
    defaultValue: _SliderValue;
    onChange: (value: _SliderValue) => void;
    onChangeEnd: (value: _SliderValue) => void;
}>>>;
export * from './type';
export declare type SliderProps = TdSliderProps;
export declare type SliderMarks = _SliderMarks;
export declare type SliderValue = _SliderValue;
export default Slider;
