/// <reference types="sortablejs" />
import { PrimaryTableCol, TableRowData, DragSortContext, TableRowState } from './type';
import { TableListeners } from './base-table';
import { ComponentScrollToElementParams } from '../common';
declare const _default: import("vue").ComponentOptions<import("vue").default, import("@vue/composition-api").ShallowUnwrapRef<{
    scrollToElement: (params: ComponentScrollToElementParams) => void;
    rowDataKeys: import("@vue/composition-api").ComputedRef<{
        rowKey: string;
        childrenKey: string;
    }>;
    setData: <T>(key: import("./type").TableRowValue, newRowData: T) => void;
    getData: (key: import("./type").TableRowValue) => TableRowState<TableRowData>;
    remove: (key: import("./type").TableRowValue) => void;
    removeChildren: (key: import("./type").TableRowValue) => void;
    appendTo: <T_1>(key: import("./type").TableRowValue, newData: T_1 | T_1[]) => void;
    insertAfter: <T_2>(rowValue: import("./type").TableRowValue, newData: T_2) => void;
    insertBefore: <T_3>(rowValue: import("./type").TableRowValue, newData: T_3) => void;
    toggleExpandData: (p: {
        row: TableRowData;
        rowIndex: number;
    }, trigger?: "expand-fold-icon" | "row-click") => void;
    expandAll: (type?: "default-expand-all" | "expand-all", list?: TableRowData[]) => void;
    foldAll: () => void;
    getTreeNode: () => import("../_common/js/table/types").TableRowData[];
    resetData: (data: TableRowData[]) => void;
    getTreeExpandedRow: (type?: "all" | "data" | "unique") => any[];
    store: import("@vue/composition-api").Ref<{
        treeDataMap: import("../_common/js/table/tree-store").TableTreeDataMap;
        expandAllRowIndex: 0;
        initialTreeStore: (dataSource: import("../_common/js/table/types").TableRowData[], columns: import("../_common/js/table/types").PlainObject[], keys: import("../_common/js/table/tree-store").KeysType) => void;
        getAllUniqueKeys: (data: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType, arr?: import("../_common/js/table/types").TableRowData[]) => import("../_common/js/table/types").TableRowData[];
        getExpandedChildrenKeys: (data: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType, arr?: (string | number)[]) => (string | number)[];
        expandTreeNode: (rowList: (string | number)[], dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        foldTreeNode: (rowList: (string | number)[], dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        toggleExpandData: (p: {
            rowIndex: number;
            row: import("../_common/js/table/types").TableRowData;
        }, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType, type?: "expand" | "fold") => import("../_common/js/table/types").TableRowData[];
        updateExpandRow: (changeRow: import("../_common/js/table/types").TableRowState<import("../_common/js/table/types").TableRowData>, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        getData: (key: import("../_common/js/table/types").TableRowValue) => import("../_common/js/table/types").TableRowState<import("../_common/js/table/types").TableRowData>;
        updateData: (rowValue: import("../_common/js/table/types").TableRowValue, newRowData: import("../_common/js/table/types").TableRowData, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => number;
        remove: (key: import("../_common/js/table/types").TableRowValue, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        removeChildren: (key: import("../_common/js/table/types").TableRowValue, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        appendTo: (rowValue: string | number, newData: import("../_common/js/table/types").TableRowData | import("../_common/js/table/types").TableRowData[], dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        appendToRoot: (newData: import("../_common/js/table/types").TableRowData | import("../_common/js/table/types").TableRowData[], dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        insertAfter: (rowValue: string | number, newData: import("../_common/js/table/types").TableRowData, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        insertBefore: (rowValue: string | number, newData: import("../_common/js/table/types").TableRowData, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        insert: (rowValue: string | number, newData: import("../_common/js/table/types").TableRowData, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType, type: "after" | "before") => import("../_common/js/table/types").TableRowData[];
        swapData: (dataSource: import("../_common/js/table/types").TableRowData[], params: import("../_common/js/table/tree-store").SwapParams<import("../_common/js/table/types").TableRowData>, keys: import("../_common/js/table/tree-store").KeysType) => {
            dataSource: import("../_common/js/table/types").TableRowData[];
            result: boolean;
            code?: number;
            reason?: string;
        };
        expandAll: (dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        foldAll: (dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        getTreeNode: (dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        getTreeExpandedRow: (dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType, type?: "all" | "data" | "unique") => any[];
        initialTreeDataMap: (treeDataMap: import("../_common/js/table/tree-store").TableTreeDataMap, dataSource: import("../_common/js/table/types").TableRowData[], column: import("../_common/js/table/types").PlainObject, keys: import("../_common/js/table/tree-store").KeysType, level?: number, parent?: import("../_common/js/table/types").TableRowState<import("../_common/js/table/types").TableRowData>) => void;
        updateDisabledState: (dataSource: import("../_common/js/table/types").TableRowData[], column: import("../_common/js/table/types").PlainObject, keys: import("../_common/js/table/tree-store").KeysType) => void;
        validateDataExist: (state: import("../_common/js/table/types").TableRowState<import("../_common/js/table/types").TableRowData>, rowValue: string | number) => boolean;
        validateDataDoubleExist: (state: import("../_common/js/table/types").TableRowState<import("../_common/js/table/types").TableRowData>, rowValue: string | number) => boolean;
    }>;
    classPrefix: import("@vue/composition-api").ComputedRef<string>;
    dataSource: import("@vue/composition-api").Ref<{
        [x: string]: any;
        children?: any[];
    }[]>;
    tColumns: import("@vue/composition-api").ComputedRef<PrimaryTableCol<TableRowData>[]>;
    treeDataMap: import("@vue/composition-api").Ref<import("../_common/js/table/tree-store").TableTreeDataMap>;
    tIndeterminateSelectedRowKeys: import("@vue/composition-api").Ref<(string | number)[]>;
    enhancedTableRef: import("@vue/composition-api").Ref<any>;
    primaryTableRef: import("@vue/composition-api").Ref<any>;
    onDragSortChange: (params: DragSortContext<TableRowData>) => void;
    onInnerSelectChange: (rowKeys: (string | number)[], extraData: import("./type").SelectOptions<TableRowData>) => void;
    onEnhancedTableRowClick: (context: import("./type").RowEventContext<TableRowData>) => void;
}> & import("@vue/composition-api").Data, {
    getListener(): TableListeners;
    getRowClassName({ row }: {
        row: TableRowData;
    }): import("../common").ClassName[];
}, {}, {
    beforeDragSort: {
        type: import("vue").PropType<(context: DragSortContext<TableRowData>) => boolean>;
    };
    expandedTreeNodes: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultExpandedTreeNodes: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    tree: {
        type: import("vue").PropType<import("./type").TableTreeConfig>;
    };
    treeExpandAndFoldIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: {
            type: "expand" | "fold";
            row: TableRowData;
        }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    onAbnormalDragSort: import("vue").PropType<(context: import("./type").TableAbnormalDragSortContext<TableRowData>) => void>;
    onExpandedTreeNodesChange: import("vue").PropType<(expandedTreeNodes: (string | number)[], options: import("./type").TableTreeNodeExpandOptions<TableRowData>) => void>;
    onTreeExpandChange: import("vue").PropType<(context: import("./type").TableTreeExpandChangeContext<TableRowData>) => void>;
    asyncLoading: {
        type: import("vue").PropType<"loading" | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue) | "load-more">;
    };
    columnController: {
        type: import("vue").PropType<import("./type").TableColumnController>;
    };
    columnControllerVisible: {
        type: BooleanConstructor;
        default: any;
    };
    defaultColumnControllerVisible: {
        type: BooleanConstructor;
        default: any;
    };
    columns: {
        type: import("vue").PropType<PrimaryTableCol<TableRowData>[]>;
        default: () => PrimaryTableCol<TableRowData>[];
    };
    displayColumns: {
        type: import("vue").PropType<import("..").CheckboxGroupValue>;
    };
    defaultDisplayColumns: {
        type: import("vue").PropType<import("..").CheckboxGroupValue>;
    };
    dragSort: {
        type: import("vue").PropType<"col" | "row" | "row-handler" | "row-handler-col" | "drag-col">;
        validator(val: "col" | "row" | "row-handler" | "row-handler-col" | "drag-col"): boolean;
    };
    dragSortOptions: {
        type: import("vue").PropType<import("sortablejs").SortableOptions>;
    };
    editableCellState: {
        type: import("vue").PropType<import("./type").EditableCellType<TableRowData>>;
    };
    editableRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
    };
    expandIcon: {
        type: import("vue").PropType<boolean | ((h: import("vue").CreateElement, props: import("./type").ExpandArrowRenderParams<TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: boolean;
    };
    expandOnRowClick: BooleanConstructor;
    expandedRow: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: import("./type").TableExpandedRowParams<TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    expandedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultExpandedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    filterIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: {
            col: PrimaryTableCol<TableRowData>;
            colIndex: number;
        }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    filterRow: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    filterValue: {
        type: import("vue").PropType<import("./type").FilterValue>;
    };
    defaultFilterValue: {
        type: import("vue").PropType<import("./type").FilterValue>;
    };
    hideSortTips: BooleanConstructor;
    indeterminateSelectedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
    };
    multipleSort: BooleanConstructor;
    reserveSelectedRowOnPaginate: {
        type: BooleanConstructor;
        default: boolean;
    };
    rowSelectionAllowUncheck: BooleanConstructor;
    rowSelectionType: {
        type: import("vue").PropType<"multiple" | "single">;
        validator(val: "multiple" | "single"): boolean;
    };
    selectOnRowClick: BooleanConstructor;
    selectedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultSelectedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    showSortColumnBgColor: BooleanConstructor;
    sort: {
        type: import("vue").PropType<import("./type").TableSort>;
    };
    defaultSort: {
        type: import("vue").PropType<import("./type").TableSort>;
    };
    sortIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    sortOnRowDraggable: BooleanConstructor;
    onAsyncLoadingClick: import("vue").PropType<(context: {
        status: "loading" | "load-more";
    }) => void>;
    onCellClick: import("vue").PropType<(context: import("./type").PrimaryTableCellEventContext<TableRowData>) => void>;
    onChange: import("vue").PropType<(data: import("./type").TableChangeData, context: import("./type").TableChangeContext<TableRowData>) => void>;
    onColumnChange: import("vue").PropType<(context: import("./type").PrimaryTableColumnChange<TableRowData>) => void>;
    onColumnControllerVisibleChange: import("vue").PropType<(visible: boolean, context: {
        trigger: "cancel" | "confirm";
    }) => void>;
    onDataChange: import("vue").PropType<(data: TableRowData[], context: import("./type").TableDataChangeContext) => void>;
    onDisplayColumnsChange: import("vue").PropType<(value: import("..").CheckboxGroupValue) => void>;
    onDragSort: import("vue").PropType<(context: DragSortContext<TableRowData>) => void>;
    onExpandChange: import("vue").PropType<(expandedRowKeys: (string | number)[], options: import("./type").ExpandOptions<TableRowData>) => void>;
    onFilterChange: import("vue").PropType<(filterValue: import("./type").FilterValue, context: import("./type").TableFilterChangeContext<TableRowData>) => void>;
    onRowEdit: import("vue").PropType<(context: import("./type").PrimaryTableRowEditContext<TableRowData>) => void>;
    onRowValidate: import("vue").PropType<(context: import("./type").PrimaryTableRowValidateContext<TableRowData>) => void>;
    onSelectChange: import("vue").PropType<(selectedRowKeys: (string | number)[], options: import("./type").SelectOptions<TableRowData>) => void>;
    onSortChange: import("vue").PropType<(sort: import("./type").TableSort, options: import("./type").SortOptions<TableRowData>) => void>;
    onValidate: import("vue").PropType<(context: import("./type").PrimaryTableValidateContext) => void>;
    activeRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultActiveRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    activeRowType: {
        type: import("vue").PropType<"multiple" | "single">;
        default: string;
    };
    allowResizeColumnWidth: {
        type: BooleanConstructor;
        default: any;
    };
    attach: {
        type: import("vue").PropType<import("../common").AttachNode>;
    };
    bordered: BooleanConstructor;
    bottomContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    cellEmptyContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement, props: import("./type").BaseTableCellParams<TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    data: {
        type: import("vue").PropType<TableRowData[]>;
        default: () => TableRowData[];
    };
    disableDataPage: BooleanConstructor;
    disableSpaceInactiveRow: {
        type: BooleanConstructor;
        default: any;
    };
    empty: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: string;
    };
    firstFullRow: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    fixedRows: {
        type: import("vue").PropType<number[]>;
    };
    footData: {
        type: import("vue").PropType<TableRowData[]>;
        default: () => TableRowData[];
    };
    footerAffixProps: {
        type: import("vue").PropType<Partial<import("..").TdAffixProps>>;
    };
    footerAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
        default: boolean;
    };
    footerSummary: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    headerAffixProps: {
        type: import("vue").PropType<Partial<import("..").TdAffixProps>>;
    };
    headerAffixedTop: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
        default: boolean;
    };
    height: {
        type: import("vue").PropType<string | number>;
    };
    horizontalScrollAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
    };
    hover: BooleanConstructor;
    keyboardRowHover: {
        type: BooleanConstructor;
        default: boolean;
    };
    lastFullRow: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    lazyLoad: BooleanConstructor;
    loading: {
        type: import("vue").PropType<boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: any;
    };
    loadingProps: {
        type: import("vue").PropType<Partial<import("..").TdLoadingProps>>;
    };
    locale: {
        type: import("vue").PropType<import("..").TableConfig>;
    };
    maxHeight: {
        type: import("vue").PropType<string | number>;
    };
    pagination: {
        type: import("vue").PropType<import("..").TdPaginationProps>;
    };
    paginationAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
    };
    resizable: BooleanConstructor;
    rowAttributes: {
        type: import("vue").PropType<import("./type").TableRowAttributes<TableRowData>>;
    };
    rowClassName: {
        type: import("vue").PropType<import("../common").ClassName | ((params: import("./type").RowClassNameParams<TableRowData>) => import("../common").ClassName)>;
    };
    rowKey: {
        type: StringConstructor;
        default: string;
        required: boolean;
    };
    rowspanAndColspan: {
        type: import("vue").PropType<import("./type").TableRowspanAndColspanFunc<TableRowData>>;
    };
    rowspanAndColspanInFooter: {
        type: import("vue").PropType<import("./type").TableRowspanAndColspanFunc<TableRowData>>;
    };
    scroll: {
        type: import("vue").PropType<import("../common").TScroll>;
    };
    showHeader: {
        type: BooleanConstructor;
        default: boolean;
    };
    size: {
        type: import("vue").PropType<import("../common").SizeEnum>;
        validator(val: import("../common").SizeEnum): boolean;
    };
    stripe: BooleanConstructor;
    tableContentWidth: {
        type: StringConstructor;
        default: string;
    };
    tableLayout: {
        type: import("vue").PropType<"fixed" | "auto">;
        default: "fixed" | "auto";
        validator(val: "fixed" | "auto"): boolean;
    };
    topContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    verticalAlign: {
        type: import("vue").PropType<"top" | "bottom" | "middle">;
        default: "top" | "bottom" | "middle";
        validator(val: "top" | "bottom" | "middle"): boolean;
    };
    onActiveChange: import("vue").PropType<(activeRowKeys: (string | number)[], context: import("./type").ActiveChangeContext<TableRowData>) => void>;
    onActiveRowAction: import("vue").PropType<(context: import("./type").ActiveRowActionContext<TableRowData>) => void>;
    onColumnResizeChange: import("vue").PropType<(context: {
        columnsWidth: {
            [colKey: string]: number;
        };
    }) => void>;
    onPageChange: import("vue").PropType<(pageInfo: import("..").PageInfo, newDataSource: TableRowData[]) => void>;
    onRowClick: import("vue").PropType<(context: import("./type").RowEventContext<TableRowData>) => void>;
    onRowDblclick: import("vue").PropType<(context: import("./type").RowEventContext<TableRowData>) => void>;
    onRowMousedown: import("vue").PropType<(context: import("./type").RowEventContext<TableRowData>) => void>;
    onRowMouseenter: import("vue").PropType<(context: import("./type").RowEventContext<TableRowData>) => void>;
    onRowMouseleave: import("vue").PropType<(context: import("./type").RowEventContext<TableRowData>) => void>;
    onRowMouseover: import("vue").PropType<(context: import("./type").RowEventContext<TableRowData>) => void>;
    onRowMouseup: import("vue").PropType<(context: import("./type").RowEventContext<TableRowData>) => void>;
    onScroll: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
    onScrollX: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
    onScrollY: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
}, import("@vue/composition-api").ExtractPropTypes<{
    beforeDragSort: {
        type: import("vue").PropType<(context: DragSortContext<TableRowData>) => boolean>;
    };
    expandedTreeNodes: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultExpandedTreeNodes: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    tree: {
        type: import("vue").PropType<import("./type").TableTreeConfig>;
    };
    treeExpandAndFoldIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: {
            type: "expand" | "fold";
            row: TableRowData;
        }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    onAbnormalDragSort: import("vue").PropType<(context: import("./type").TableAbnormalDragSortContext<TableRowData>) => void>;
    onExpandedTreeNodesChange: import("vue").PropType<(expandedTreeNodes: (string | number)[], options: import("./type").TableTreeNodeExpandOptions<TableRowData>) => void>;
    onTreeExpandChange: import("vue").PropType<(context: import("./type").TableTreeExpandChangeContext<TableRowData>) => void>;
    asyncLoading: {
        type: import("vue").PropType<"loading" | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue) | "load-more">;
    };
    columnController: {
        type: import("vue").PropType<import("./type").TableColumnController>;
    };
    columnControllerVisible: {
        type: BooleanConstructor;
        default: any;
    };
    defaultColumnControllerVisible: {
        type: BooleanConstructor;
        default: any;
    };
    columns: {
        type: import("vue").PropType<PrimaryTableCol<TableRowData>[]>;
        default: () => PrimaryTableCol<TableRowData>[];
    };
    displayColumns: {
        type: import("vue").PropType<import("..").CheckboxGroupValue>;
    };
    defaultDisplayColumns: {
        type: import("vue").PropType<import("..").CheckboxGroupValue>;
    };
    dragSort: {
        type: import("vue").PropType<"col" | "row" | "row-handler" | "row-handler-col" | "drag-col">;
        validator(val: "col" | "row" | "row-handler" | "row-handler-col" | "drag-col"): boolean;
    };
    dragSortOptions: {
        type: import("vue").PropType<import("sortablejs").SortableOptions>;
    };
    editableCellState: {
        type: import("vue").PropType<import("./type").EditableCellType<TableRowData>>;
    };
    editableRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
    };
    expandIcon: {
        type: import("vue").PropType<boolean | ((h: import("vue").CreateElement, props: import("./type").ExpandArrowRenderParams<TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: boolean;
    };
    expandOnRowClick: BooleanConstructor;
    expandedRow: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: import("./type").TableExpandedRowParams<TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    expandedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultExpandedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    filterIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: {
            col: PrimaryTableCol<TableRowData>;
            colIndex: number;
        }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    filterRow: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    filterValue: {
        type: import("vue").PropType<import("./type").FilterValue>;
    };
    defaultFilterValue: {
        type: import("vue").PropType<import("./type").FilterValue>;
    };
    hideSortTips: BooleanConstructor;
    indeterminateSelectedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
    };
    multipleSort: BooleanConstructor;
    reserveSelectedRowOnPaginate: {
        type: BooleanConstructor;
        default: boolean;
    };
    rowSelectionAllowUncheck: BooleanConstructor;
    rowSelectionType: {
        type: import("vue").PropType<"multiple" | "single">;
        validator(val: "multiple" | "single"): boolean;
    };
    selectOnRowClick: BooleanConstructor;
    selectedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultSelectedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    showSortColumnBgColor: BooleanConstructor;
    sort: {
        type: import("vue").PropType<import("./type").TableSort>;
    };
    defaultSort: {
        type: import("vue").PropType<import("./type").TableSort>;
    };
    sortIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    sortOnRowDraggable: BooleanConstructor;
    onAsyncLoadingClick: import("vue").PropType<(context: {
        status: "loading" | "load-more";
    }) => void>;
    onCellClick: import("vue").PropType<(context: import("./type").PrimaryTableCellEventContext<TableRowData>) => void>;
    onChange: import("vue").PropType<(data: import("./type").TableChangeData, context: import("./type").TableChangeContext<TableRowData>) => void>;
    onColumnChange: import("vue").PropType<(context: import("./type").PrimaryTableColumnChange<TableRowData>) => void>;
    onColumnControllerVisibleChange: import("vue").PropType<(visible: boolean, context: {
        trigger: "cancel" | "confirm";
    }) => void>;
    onDataChange: import("vue").PropType<(data: TableRowData[], context: import("./type").TableDataChangeContext) => void>;
    onDisplayColumnsChange: import("vue").PropType<(value: import("..").CheckboxGroupValue) => void>;
    onDragSort: import("vue").PropType<(context: DragSortContext<TableRowData>) => void>;
    onExpandChange: import("vue").PropType<(expandedRowKeys: (string | number)[], options: import("./type").ExpandOptions<TableRowData>) => void>;
    onFilterChange: import("vue").PropType<(filterValue: import("./type").FilterValue, context: import("./type").TableFilterChangeContext<TableRowData>) => void>;
    onRowEdit: import("vue").PropType<(context: import("./type").PrimaryTableRowEditContext<TableRowData>) => void>;
    onRowValidate: import("vue").PropType<(context: import("./type").PrimaryTableRowValidateContext<TableRowData>) => void>;
    onSelectChange: import("vue").PropType<(selectedRowKeys: (string | number)[], options: import("./type").SelectOptions<TableRowData>) => void>;
    onSortChange: import("vue").PropType<(sort: import("./type").TableSort, options: import("./type").SortOptions<TableRowData>) => void>;
    onValidate: import("vue").PropType<(context: import("./type").PrimaryTableValidateContext) => void>;
    activeRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultActiveRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    activeRowType: {
        type: import("vue").PropType<"multiple" | "single">;
        default: string;
    };
    allowResizeColumnWidth: {
        type: BooleanConstructor;
        default: any;
    };
    attach: {
        type: import("vue").PropType<import("../common").AttachNode>;
    };
    bordered: BooleanConstructor;
    bottomContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    cellEmptyContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement, props: import("./type").BaseTableCellParams<TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    data: {
        type: import("vue").PropType<TableRowData[]>;
        default: () => TableRowData[];
    };
    disableDataPage: BooleanConstructor;
    disableSpaceInactiveRow: {
        type: BooleanConstructor;
        default: any;
    };
    empty: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: string;
    };
    firstFullRow: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    fixedRows: {
        type: import("vue").PropType<number[]>;
    };
    footData: {
        type: import("vue").PropType<TableRowData[]>;
        default: () => TableRowData[];
    };
    footerAffixProps: {
        type: import("vue").PropType<Partial<import("..").TdAffixProps>>;
    };
    footerAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
        default: boolean;
    };
    footerSummary: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    headerAffixProps: {
        type: import("vue").PropType<Partial<import("..").TdAffixProps>>;
    };
    headerAffixedTop: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
        default: boolean;
    };
    height: {
        type: import("vue").PropType<string | number>;
    };
    horizontalScrollAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
    };
    hover: BooleanConstructor;
    keyboardRowHover: {
        type: BooleanConstructor;
        default: boolean;
    };
    lastFullRow: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    lazyLoad: BooleanConstructor;
    loading: {
        type: import("vue").PropType<boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: any;
    };
    loadingProps: {
        type: import("vue").PropType<Partial<import("..").TdLoadingProps>>;
    };
    locale: {
        type: import("vue").PropType<import("..").TableConfig>;
    };
    maxHeight: {
        type: import("vue").PropType<string | number>;
    };
    pagination: {
        type: import("vue").PropType<import("..").TdPaginationProps>;
    };
    paginationAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
    };
    resizable: BooleanConstructor;
    rowAttributes: {
        type: import("vue").PropType<import("./type").TableRowAttributes<TableRowData>>;
    };
    rowClassName: {
        type: import("vue").PropType<import("../common").ClassName | ((params: import("./type").RowClassNameParams<TableRowData>) => import("../common").ClassName)>;
    };
    rowKey: {
        type: StringConstructor;
        default: string;
        required: boolean;
    };
    rowspanAndColspan: {
        type: import("vue").PropType<import("./type").TableRowspanAndColspanFunc<TableRowData>>;
    };
    rowspanAndColspanInFooter: {
        type: import("vue").PropType<import("./type").TableRowspanAndColspanFunc<TableRowData>>;
    };
    scroll: {
        type: import("vue").PropType<import("../common").TScroll>;
    };
    showHeader: {
        type: BooleanConstructor;
        default: boolean;
    };
    size: {
        type: import("vue").PropType<import("../common").SizeEnum>;
        validator(val: import("../common").SizeEnum): boolean;
    };
    stripe: BooleanConstructor;
    tableContentWidth: {
        type: StringConstructor;
        default: string;
    };
    tableLayout: {
        type: import("vue").PropType<"fixed" | "auto">;
        default: "fixed" | "auto";
        validator(val: "fixed" | "auto"): boolean;
    };
    topContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    verticalAlign: {
        type: import("vue").PropType<"top" | "bottom" | "middle">;
        default: "top" | "bottom" | "middle";
        validator(val: "top" | "bottom" | "middle"): boolean;
    };
    onActiveChange: import("vue").PropType<(activeRowKeys: (string | number)[], context: import("./type").ActiveChangeContext<TableRowData>) => void>;
    onActiveRowAction: import("vue").PropType<(context: import("./type").ActiveRowActionContext<TableRowData>) => void>;
    onColumnResizeChange: import("vue").PropType<(context: {
        columnsWidth: {
            [colKey: string]: number;
        };
    }) => void>;
    onPageChange: import("vue").PropType<(pageInfo: import("..").PageInfo, newDataSource: TableRowData[]) => void>;
    onRowClick: import("vue").PropType<(context: import("./type").RowEventContext<TableRowData>) => void>;
    onRowDblclick: import("vue").PropType<(context: import("./type").RowEventContext<TableRowData>) => void>;
    onRowMousedown: import("vue").PropType<(context: import("./type").RowEventContext<TableRowData>) => void>;
    onRowMouseenter: import("vue").PropType<(context: import("./type").RowEventContext<TableRowData>) => void>;
    onRowMouseleave: import("vue").PropType<(context: import("./type").RowEventContext<TableRowData>) => void>;
    onRowMouseover: import("vue").PropType<(context: import("./type").RowEventContext<TableRowData>) => void>;
    onRowMouseup: import("vue").PropType<(context: import("./type").RowEventContext<TableRowData>) => void>;
    onScroll: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
    onScrollX: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
    onScrollY: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
}>> & Omit<import("vue").VueConstructor<import("vue").default>, never> & (new (...args: any[]) => import("@vue/composition-api").ComponentRenderProxy<{
    data: TableRowData[];
    columns: PrimaryTableCol<TableRowData>[];
    tableLayout: "fixed" | "auto";
    verticalAlign: "top" | "bottom" | "middle";
    loading: boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    empty: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    hover: boolean;
    lazyLoad: boolean;
    bordered: boolean;
    showHeader: boolean;
    stripe: boolean;
    activeRowKeys: (string | number)[];
    defaultActiveRowKeys: (string | number)[];
    activeRowType: "multiple" | "single";
    allowResizeColumnWidth: boolean;
    disableDataPage: boolean;
    disableSpaceInactiveRow: boolean;
    footData: TableRowData[];
    footerAffixedBottom: boolean;
    headerAffixedTop: boolean;
    keyboardRowHover: boolean;
    resizable: boolean;
    rowKey: string;
    tableContentWidth: string;
    columnControllerVisible: boolean;
    defaultColumnControllerVisible: boolean;
    expandIcon: boolean | ((h: import("vue").CreateElement, props: import("./type").ExpandArrowRenderParams<TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue);
    expandOnRowClick: boolean;
    expandedRowKeys: (string | number)[];
    defaultExpandedRowKeys: (string | number)[];
    hideSortTips: boolean;
    multipleSort: boolean;
    reserveSelectedRowOnPaginate: boolean;
    rowSelectionAllowUncheck: boolean;
    selectOnRowClick: boolean;
    selectedRowKeys: (string | number)[];
    defaultSelectedRowKeys: (string | number)[];
    showSortColumnBgColor: boolean;
    sortOnRowDraggable: boolean;
    expandedTreeNodes: (string | number)[];
    defaultExpandedTreeNodes: (string | number)[];
} & {
    sort?: import("./type").TableSort;
    height?: string | number;
    maxHeight?: string | number;
    scroll?: import("../common").TScroll;
    size?: import("../common").SizeEnum;
    onChange?: (data: import("./type").TableChangeData, context: import("./type").TableChangeContext<TableRowData>) => void;
    attach?: import("../common").AttachNode;
    pagination?: unknown;
    tree?: unknown;
    onValidate?: (context: import("./type").PrimaryTableValidateContext) => void;
    onScroll?: (params: {
        e: WheelEvent;
    }) => void;
    onDragSort?: (context: DragSortContext<TableRowData>) => void;
    dragSort?: "col" | "row" | "row-handler" | "row-handler-col" | "drag-col";
    onCellClick?: (context: import("./type").PrimaryTableCellEventContext<TableRowData>) => void;
    onPageChange?: (pageInfo: import("..").PageInfo, newDataSource: TableRowData[]) => void;
    filterValue?: unknown;
    loadingProps?: unknown;
    asyncLoading?: "loading" | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue) | "load-more";
    bottomContent?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    cellEmptyContent?: string | ((h: import("vue").CreateElement, props: import("./type").BaseTableCellParams<TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue);
    firstFullRow?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    fixedRows?: number[];
    footerAffixProps?: unknown;
    footerSummary?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    headerAffixProps?: unknown;
    horizontalScrollAffixedBottom?: unknown;
    lastFullRow?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    locale?: unknown;
    paginationAffixedBottom?: unknown;
    rowAttributes?: import("./type").TableRowAttributes<TableRowData>;
    rowClassName?: unknown;
    rowspanAndColspan?: import("./type").TableRowspanAndColspanFunc<TableRowData>;
    rowspanAndColspanInFooter?: import("./type").TableRowspanAndColspanFunc<TableRowData>;
    topContent?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onActiveChange?: (activeRowKeys: (string | number)[], context: import("./type").ActiveChangeContext<TableRowData>) => void;
    onActiveRowAction?: (context: import("./type").ActiveRowActionContext<TableRowData>) => void;
    onColumnResizeChange?: (context: {
        columnsWidth: {
            [colKey: string]: number;
        };
    }) => void;
    onRowClick?: (context: import("./type").RowEventContext<TableRowData>) => void;
    onRowDblclick?: (context: import("./type").RowEventContext<TableRowData>) => void;
    onRowMousedown?: (context: import("./type").RowEventContext<TableRowData>) => void;
    onRowMouseenter?: (context: import("./type").RowEventContext<TableRowData>) => void;
    onRowMouseleave?: (context: import("./type").RowEventContext<TableRowData>) => void;
    onRowMouseover?: (context: import("./type").RowEventContext<TableRowData>) => void;
    onRowMouseup?: (context: import("./type").RowEventContext<TableRowData>) => void;
    onScrollX?: (params: {
        e: WheelEvent;
    }) => void;
    onScrollY?: (params: {
        e: WheelEvent;
    }) => void;
    sortIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    filterIcon?: (h: import("vue").CreateElement, props: {
        col: PrimaryTableCol<TableRowData>;
        colIndex: number;
    }) => import("vue/types/vnode").ScopedSlotReturnValue;
    columnController?: unknown;
    displayColumns?: import("..").CheckboxGroupValue;
    defaultDisplayColumns?: import("..").CheckboxGroupValue;
    dragSortOptions?: unknown;
    editableCellState?: import("./type").EditableCellType<TableRowData>;
    editableRowKeys?: (string | number)[];
    expandedRow?: (h: import("vue").CreateElement, props: import("./type").TableExpandedRowParams<TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue;
    filterRow?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    defaultFilterValue?: unknown;
    indeterminateSelectedRowKeys?: (string | number)[];
    rowSelectionType?: "multiple" | "single";
    defaultSort?: import("./type").TableSort;
    onAsyncLoadingClick?: (context: {
        status: "loading" | "load-more";
    }) => void;
    onColumnChange?: (context: import("./type").PrimaryTableColumnChange<TableRowData>) => void;
    onColumnControllerVisibleChange?: (visible: boolean, context: {
        trigger: "cancel" | "confirm";
    }) => void;
    onDataChange?: (data: TableRowData[], context: import("./type").TableDataChangeContext) => void;
    onDisplayColumnsChange?: (value: import("..").CheckboxGroupValue) => void;
    onExpandChange?: (expandedRowKeys: (string | number)[], options: import("./type").ExpandOptions<TableRowData>) => void;
    onFilterChange?: (filterValue: import("./type").FilterValue, context: import("./type").TableFilterChangeContext<TableRowData>) => void;
    onRowEdit?: (context: import("./type").PrimaryTableRowEditContext<TableRowData>) => void;
    onRowValidate?: (context: import("./type").PrimaryTableRowValidateContext<TableRowData>) => void;
    onSelectChange?: (selectedRowKeys: (string | number)[], options: import("./type").SelectOptions<TableRowData>) => void;
    onSortChange?: (sort: import("./type").TableSort, options: import("./type").SortOptions<TableRowData>) => void;
    beforeDragSort?: (context: DragSortContext<TableRowData>) => boolean;
    treeExpandAndFoldIcon?: (h: import("vue").CreateElement, props: {
        type: "expand" | "fold";
        row: TableRowData;
    }) => import("vue/types/vnode").ScopedSlotReturnValue;
    onAbnormalDragSort?: (context: import("./type").TableAbnormalDragSortContext<TableRowData>) => void;
    onExpandedTreeNodesChange?: (expandedTreeNodes: (string | number)[], options: import("./type").TableTreeNodeExpandOptions<TableRowData>) => void;
    onTreeExpandChange?: (context: import("./type").TableTreeExpandChangeContext<TableRowData>) => void;
}, import("@vue/composition-api").ShallowUnwrapRef<{
    scrollToElement: (params: ComponentScrollToElementParams) => void;
    rowDataKeys: import("@vue/composition-api").ComputedRef<{
        rowKey: string;
        childrenKey: string;
    }>;
    setData: <T>(key: import("./type").TableRowValue, newRowData: T) => void;
    getData: (key: import("./type").TableRowValue) => TableRowState<TableRowData>;
    remove: (key: import("./type").TableRowValue) => void;
    removeChildren: (key: import("./type").TableRowValue) => void;
    appendTo: <T_1>(key: import("./type").TableRowValue, newData: T_1 | T_1[]) => void;
    insertAfter: <T_2>(rowValue: import("./type").TableRowValue, newData: T_2) => void;
    insertBefore: <T_3>(rowValue: import("./type").TableRowValue, newData: T_3) => void;
    toggleExpandData: (p: {
        row: TableRowData;
        rowIndex: number;
    }, trigger?: "expand-fold-icon" | "row-click") => void;
    expandAll: (type?: "default-expand-all" | "expand-all", list?: TableRowData[]) => void;
    foldAll: () => void;
    getTreeNode: () => import("../_common/js/table/types").TableRowData[];
    resetData: (data: TableRowData[]) => void;
    getTreeExpandedRow: (type?: "all" | "data" | "unique") => any[];
    store: import("@vue/composition-api").Ref<{
        treeDataMap: import("../_common/js/table/tree-store").TableTreeDataMap;
        expandAllRowIndex: 0;
        initialTreeStore: (dataSource: import("../_common/js/table/types").TableRowData[], columns: import("../_common/js/table/types").PlainObject[], keys: import("../_common/js/table/tree-store").KeysType) => void;
        getAllUniqueKeys: (data: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType, arr?: import("../_common/js/table/types").TableRowData[]) => import("../_common/js/table/types").TableRowData[];
        getExpandedChildrenKeys: (data: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType, arr?: (string | number)[]) => (string | number)[];
        expandTreeNode: (rowList: (string | number)[], dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        foldTreeNode: (rowList: (string | number)[], dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        toggleExpandData: (p: {
            rowIndex: number;
            row: import("../_common/js/table/types").TableRowData;
        }, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType, type?: "expand" | "fold") => import("../_common/js/table/types").TableRowData[];
        updateExpandRow: (changeRow: import("../_common/js/table/types").TableRowState<import("../_common/js/table/types").TableRowData>, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        getData: (key: import("../_common/js/table/types").TableRowValue) => import("../_common/js/table/types").TableRowState<import("../_common/js/table/types").TableRowData>;
        updateData: (rowValue: import("../_common/js/table/types").TableRowValue, newRowData: import("../_common/js/table/types").TableRowData, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => number;
        remove: (key: import("../_common/js/table/types").TableRowValue, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        removeChildren: (key: import("../_common/js/table/types").TableRowValue, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        appendTo: (rowValue: string | number, newData: import("../_common/js/table/types").TableRowData | import("../_common/js/table/types").TableRowData[], dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        appendToRoot: (newData: import("../_common/js/table/types").TableRowData | import("../_common/js/table/types").TableRowData[], dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        insertAfter: (rowValue: string | number, newData: import("../_common/js/table/types").TableRowData, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        insertBefore: (rowValue: string | number, newData: import("../_common/js/table/types").TableRowData, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        insert: (rowValue: string | number, newData: import("../_common/js/table/types").TableRowData, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType, type: "after" | "before") => import("../_common/js/table/types").TableRowData[];
        swapData: (dataSource: import("../_common/js/table/types").TableRowData[], params: import("../_common/js/table/tree-store").SwapParams<import("../_common/js/table/types").TableRowData>, keys: import("../_common/js/table/tree-store").KeysType) => {
            dataSource: import("../_common/js/table/types").TableRowData[];
            result: boolean;
            code?: number;
            reason?: string;
        };
        expandAll: (dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        foldAll: (dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        getTreeNode: (dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        getTreeExpandedRow: (dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType, type?: "all" | "data" | "unique") => any[];
        initialTreeDataMap: (treeDataMap: import("../_common/js/table/tree-store").TableTreeDataMap, dataSource: import("../_common/js/table/types").TableRowData[], column: import("../_common/js/table/types").PlainObject, keys: import("../_common/js/table/tree-store").KeysType, level?: number, parent?: import("../_common/js/table/types").TableRowState<import("../_common/js/table/types").TableRowData>) => void;
        updateDisabledState: (dataSource: import("../_common/js/table/types").TableRowData[], column: import("../_common/js/table/types").PlainObject, keys: import("../_common/js/table/tree-store").KeysType) => void;
        validateDataExist: (state: import("../_common/js/table/types").TableRowState<import("../_common/js/table/types").TableRowData>, rowValue: string | number) => boolean;
        validateDataDoubleExist: (state: import("../_common/js/table/types").TableRowState<import("../_common/js/table/types").TableRowData>, rowValue: string | number) => boolean;
    }>;
    classPrefix: import("@vue/composition-api").ComputedRef<string>;
    dataSource: import("@vue/composition-api").Ref<{
        [x: string]: any;
        children?: any[];
    }[]>;
    tColumns: import("@vue/composition-api").ComputedRef<PrimaryTableCol<TableRowData>[]>;
    treeDataMap: import("@vue/composition-api").Ref<import("../_common/js/table/tree-store").TableTreeDataMap>;
    tIndeterminateSelectedRowKeys: import("@vue/composition-api").Ref<(string | number)[]>;
    enhancedTableRef: import("@vue/composition-api").Ref<any>;
    primaryTableRef: import("@vue/composition-api").Ref<any>;
    onDragSortChange: (params: DragSortContext<TableRowData>) => void;
    onInnerSelectChange: (rowKeys: (string | number)[], extraData: import("./type").SelectOptions<TableRowData>) => void;
    onEnhancedTableRowClick: (context: import("./type").RowEventContext<TableRowData>) => void;
}>, import("@vue/composition-api").Data, {}, {
    getListener(): TableListeners;
    getRowClassName({ row }: {
        row: TableRowData;
    }): import("../common").ClassName[];
}, {}, {}, {}, {
    data: TableRowData[];
    columns: PrimaryTableCol<TableRowData>[];
    tableLayout: "fixed" | "auto";
    verticalAlign: "top" | "bottom" | "middle";
    loading: boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    empty: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    hover: boolean;
    lazyLoad: boolean;
    bordered: boolean;
    showHeader: boolean;
    stripe: boolean;
    activeRowKeys: (string | number)[];
    defaultActiveRowKeys: (string | number)[];
    activeRowType: "multiple" | "single";
    allowResizeColumnWidth: boolean;
    disableDataPage: boolean;
    disableSpaceInactiveRow: boolean;
    footData: TableRowData[];
    footerAffixedBottom: boolean;
    headerAffixedTop: boolean;
    keyboardRowHover: boolean;
    resizable: boolean;
    rowKey: string;
    tableContentWidth: string;
    columnControllerVisible: boolean;
    defaultColumnControllerVisible: boolean;
    expandIcon: boolean | ((h: import("vue").CreateElement, props: import("./type").ExpandArrowRenderParams<TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue);
    expandOnRowClick: boolean;
    expandedRowKeys: (string | number)[];
    defaultExpandedRowKeys: (string | number)[];
    hideSortTips: boolean;
    multipleSort: boolean;
    reserveSelectedRowOnPaginate: boolean;
    rowSelectionAllowUncheck: boolean;
    selectOnRowClick: boolean;
    selectedRowKeys: (string | number)[];
    defaultSelectedRowKeys: (string | number)[];
    showSortColumnBgColor: boolean;
    sortOnRowDraggable: boolean;
    expandedTreeNodes: (string | number)[];
    defaultExpandedTreeNodes: (string | number)[];
} & {
    sort?: import("./type").TableSort;
    height?: string | number;
    maxHeight?: string | number;
    scroll?: import("../common").TScroll;
    size?: import("../common").SizeEnum;
    onChange?: (data: import("./type").TableChangeData, context: import("./type").TableChangeContext<TableRowData>) => void;
    attach?: import("../common").AttachNode;
    pagination?: unknown;
    tree?: unknown;
    onValidate?: (context: import("./type").PrimaryTableValidateContext) => void;
    onScroll?: (params: {
        e: WheelEvent;
    }) => void;
    onDragSort?: (context: DragSortContext<TableRowData>) => void;
    dragSort?: "col" | "row" | "row-handler" | "row-handler-col" | "drag-col";
    onCellClick?: (context: import("./type").PrimaryTableCellEventContext<TableRowData>) => void;
    onPageChange?: (pageInfo: import("..").PageInfo, newDataSource: TableRowData[]) => void;
    filterValue?: unknown;
    loadingProps?: unknown;
    asyncLoading?: "loading" | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue) | "load-more";
    bottomContent?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    cellEmptyContent?: string | ((h: import("vue").CreateElement, props: import("./type").BaseTableCellParams<TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue);
    firstFullRow?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    fixedRows?: number[];
    footerAffixProps?: unknown;
    footerSummary?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    headerAffixProps?: unknown;
    horizontalScrollAffixedBottom?: unknown;
    lastFullRow?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    locale?: unknown;
    paginationAffixedBottom?: unknown;
    rowAttributes?: import("./type").TableRowAttributes<TableRowData>;
    rowClassName?: unknown;
    rowspanAndColspan?: import("./type").TableRowspanAndColspanFunc<TableRowData>;
    rowspanAndColspanInFooter?: import("./type").TableRowspanAndColspanFunc<TableRowData>;
    topContent?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onActiveChange?: (activeRowKeys: (string | number)[], context: import("./type").ActiveChangeContext<TableRowData>) => void;
    onActiveRowAction?: (context: import("./type").ActiveRowActionContext<TableRowData>) => void;
    onColumnResizeChange?: (context: {
        columnsWidth: {
            [colKey: string]: number;
        };
    }) => void;
    onRowClick?: (context: import("./type").RowEventContext<TableRowData>) => void;
    onRowDblclick?: (context: import("./type").RowEventContext<TableRowData>) => void;
    onRowMousedown?: (context: import("./type").RowEventContext<TableRowData>) => void;
    onRowMouseenter?: (context: import("./type").RowEventContext<TableRowData>) => void;
    onRowMouseleave?: (context: import("./type").RowEventContext<TableRowData>) => void;
    onRowMouseover?: (context: import("./type").RowEventContext<TableRowData>) => void;
    onRowMouseup?: (context: import("./type").RowEventContext<TableRowData>) => void;
    onScrollX?: (params: {
        e: WheelEvent;
    }) => void;
    onScrollY?: (params: {
        e: WheelEvent;
    }) => void;
    sortIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    filterIcon?: (h: import("vue").CreateElement, props: {
        col: PrimaryTableCol<TableRowData>;
        colIndex: number;
    }) => import("vue/types/vnode").ScopedSlotReturnValue;
    columnController?: unknown;
    displayColumns?: import("..").CheckboxGroupValue;
    defaultDisplayColumns?: import("..").CheckboxGroupValue;
    dragSortOptions?: unknown;
    editableCellState?: import("./type").EditableCellType<TableRowData>;
    editableRowKeys?: (string | number)[];
    expandedRow?: (h: import("vue").CreateElement, props: import("./type").TableExpandedRowParams<TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue;
    filterRow?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    defaultFilterValue?: unknown;
    indeterminateSelectedRowKeys?: (string | number)[];
    rowSelectionType?: "multiple" | "single";
    defaultSort?: import("./type").TableSort;
    onAsyncLoadingClick?: (context: {
        status: "loading" | "load-more";
    }) => void;
    onColumnChange?: (context: import("./type").PrimaryTableColumnChange<TableRowData>) => void;
    onColumnControllerVisibleChange?: (visible: boolean, context: {
        trigger: "cancel" | "confirm";
    }) => void;
    onDataChange?: (data: TableRowData[], context: import("./type").TableDataChangeContext) => void;
    onDisplayColumnsChange?: (value: import("..").CheckboxGroupValue) => void;
    onExpandChange?: (expandedRowKeys: (string | number)[], options: import("./type").ExpandOptions<TableRowData>) => void;
    onFilterChange?: (filterValue: import("./type").FilterValue, context: import("./type").TableFilterChangeContext<TableRowData>) => void;
    onRowEdit?: (context: import("./type").PrimaryTableRowEditContext<TableRowData>) => void;
    onRowValidate?: (context: import("./type").PrimaryTableRowValidateContext<TableRowData>) => void;
    onSelectChange?: (selectedRowKeys: (string | number)[], options: import("./type").SelectOptions<TableRowData>) => void;
    onSortChange?: (sort: import("./type").TableSort, options: import("./type").SortOptions<TableRowData>) => void;
    beforeDragSort?: (context: DragSortContext<TableRowData>) => boolean;
    treeExpandAndFoldIcon?: (h: import("vue").CreateElement, props: {
        type: "expand" | "fold";
        row: TableRowData;
    }) => import("vue/types/vnode").ScopedSlotReturnValue;
    onAbnormalDragSort?: (context: import("./type").TableAbnormalDragSortContext<TableRowData>) => void;
    onExpandedTreeNodesChange?: (expandedTreeNodes: (string | number)[], options: import("./type").TableTreeNodeExpandOptions<TableRowData>) => void;
    onTreeExpandChange?: (context: import("./type").TableTreeExpandChangeContext<TableRowData>) => void;
}, {
    data: TableRowData[];
    columns: PrimaryTableCol<TableRowData>[];
    tableLayout: "fixed" | "auto";
    verticalAlign: "top" | "bottom" | "middle";
    loading: boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    empty: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    hover: boolean;
    lazyLoad: boolean;
    bordered: boolean;
    showHeader: boolean;
    stripe: boolean;
    activeRowKeys: (string | number)[];
    defaultActiveRowKeys: (string | number)[];
    activeRowType: "multiple" | "single";
    allowResizeColumnWidth: boolean;
    disableDataPage: boolean;
    disableSpaceInactiveRow: boolean;
    footData: TableRowData[];
    footerAffixedBottom: boolean;
    headerAffixedTop: boolean;
    keyboardRowHover: boolean;
    resizable: boolean;
    rowKey: string;
    tableContentWidth: string;
    columnControllerVisible: boolean;
    defaultColumnControllerVisible: boolean;
    expandIcon: boolean | ((h: import("vue").CreateElement, props: import("./type").ExpandArrowRenderParams<TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue);
    expandOnRowClick: boolean;
    expandedRowKeys: (string | number)[];
    defaultExpandedRowKeys: (string | number)[];
    hideSortTips: boolean;
    multipleSort: boolean;
    reserveSelectedRowOnPaginate: boolean;
    rowSelectionAllowUncheck: boolean;
    selectOnRowClick: boolean;
    selectedRowKeys: (string | number)[];
    defaultSelectedRowKeys: (string | number)[];
    showSortColumnBgColor: boolean;
    sortOnRowDraggable: boolean;
    expandedTreeNodes: (string | number)[];
    defaultExpandedTreeNodes: (string | number)[];
}, true>);
export default _default;
