/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

import { h as helper } from '../../_chunks/dep-8db32566.js';
import EditableCell from '../editable-cell.js';
import '@babel/runtime/helpers/slicedToArray';
import '@babel/runtime/helpers/toArray';
import '@babel/runtime/helpers/defineProperty';
import '@babel/runtime/helpers/typeof';
import '@vue/composition-api';
import 'lodash-es';
import 'tdesign-icons-vue';
import '../../hooks/useGlobalIcon.js';
import '../../hooks/useConfig.js';
import '../../config-provider/useConfig.js';
import '../../config-provider/context.js';
import '../../_common/js/global-config/default-config.js';
import '../../_common/js/global-config/locale/zh_CN.js';
import '../../_chunks/dep-a883488c.js';
import '../../_chunks/dep-90ffe67f.js';
import 'dayjs';
import '../../_chunks/dep-9d1c0d31.js';
import '../../config-provider/type.js';
import '../tr.js';
import '../utils.js';
import './useFixed.js';
import '../../_common/js/log/index.js';
import '../../_common/js/log/log.js';
import '../../_common/js/utils/getScrollbarWidth.js';
import '../../_common/js/utils/helper.js';
import '@babel/runtime/helpers/toConsumableArray';
import '@babel/runtime/helpers/objectWithoutProperties';
import '../../utils/dom.js';
import 'vue';
import 'raf';
import '../../utils/easing.js';
import './useClassName.js';
import '../ellipsis.js';
import '../../utils/render-tnode.js';
import '@babel/runtime/helpers/readOnlyError';
import '../../tooltip/index.js';
import '../../tooltip/tooltip.js';
import '../../tooltip/props.js';
import '../../popup/props.js';
import '../../popup/popup.js';
import '@popperjs/core';
import '../../utils/helper.js';
import '../../_common/js/utils/setStyle.js';
import '../../popup/container.js';
import '../../config-provider/config-receiver.js';
import '../../utils/mixins.js';
import '../../utils/event.js';
import '../../popup/utils.js';
import '../../utils/map-props.js';
import '../../utils/withInstall.js';
import './style/index.js';
import '../../tooltip/type.js';
import '../base-table-props.js';
import './useRowspanAndColspan.js';
import '../../hooks/useLazyLoad.js';
import '../../_common/js/utils/observe.js';
import '../../form/form-model.js';
import '@babel/runtime/helpers/asyncToGenerator';
import '@babel/runtime/regenerator';

function useEditableCell(props, context, events) {
  var renderEditableCell = function renderEditableCell(h, p) {
    return h(EditableCell, helper([{}, {
      "props": p
    }, {}, {
      "on": events
    }, {
      "scopedSlots": context.slots
    }]));
  };
  return {
    renderEditableCell: renderEditableCell
  };
}

export { useEditableCell as default };
//# sourceMappingURL=useEditableCell.js.map
