import { PropType } from '@vue/composition-api';
import { CreateElement } from 'vue';
import { BaseTableProps, RowAndColFixedPosition } from './interface';
import { TdBaseTableProps } from './type';
import { VirtualScrollConfig } from '../hooks/useVirtualScrollNew';
export declare const ROW_AND_TD_LISTENERS: string[];
export interface TableBodyProps extends BaseTableProps {
    classPrefix: string;
    ellipsisOverlayClassName: string;
    rowAndColFixedPosition: RowAndColFixedPosition;
    showColumnShadow: {
        left: boolean;
        right: boolean;
    };
    tableElm: HTMLDivElement;
    tableWidth: number;
    isWidthOverflow: boolean;
    virtualConfig: VirtualScrollConfig;
    tableContentElm: HTMLDivElement;
    cellEmptyContent: TdBaseTableProps['cellEmptyContent'];
    handleRowMounted: (rowData: any) => void;
}
export declare const extendTableProps: string[];
declare const _default: import("vue").ComponentOptions<import("vue").default, import("@vue/composition-api").ShallowUnwrapRef<{
    t: <T>(pattern: T, ...args: any[]) => any;
    global: import("@vue/composition-api").ComputedRef<{} & (import("..").TableConfig | ({
        readonly expandIcon: any;
        readonly sortIcon: any;
        readonly filterIcon: any;
        readonly treeExpandAndFoldIcon: any;
        readonly hideSortTips: false;
        readonly size: "medium";
    } & {
        readonly empty: "暂无数据";
        readonly loadingText: "正在加载中，请稍后";
        readonly loadingMoreText: "点击加载更多";
        readonly filterInputPlaceholder: "请输入内容（无默认值）";
        readonly sortAscendingOperationText: "点击升序";
        readonly sortCancelOperationText: "点击取消排序";
        readonly sortDescendingOperationText: "点击降序";
        readonly clearFilterResultButtonText: "清空筛选";
        readonly columnConfigButtonText: "列配置";
        readonly columnConfigTitleText: "表格列配置";
        readonly columnConfigDescriptionText: "请选择需要在表格中显示的数据列";
        readonly confirmText: "确认";
        readonly cancelText: "取消";
        readonly resetText: "重置";
        readonly selectAllText: "全选";
        readonly searchResultText: "搜索“{result}”，找到 {count} 条结果";
    })) & import("..").TableConfig>;
    tableFullRowClasses: {
        base: string;
        innerFullRow: string;
        innerFullElement: string;
        firstFullRow: string;
        lastFullRow: string;
    };
    tbodyClasses: import("@vue/composition-api").ComputedRef<string[]>;
    tableBaseClass: {
        table: (string | {
            [x: string]: boolean;
        })[];
        columnResizableTable: string;
        overflowVisible: string;
        body: string;
        content: string;
        topContent: string;
        bottomContent: string;
        paginationWrap: string;
        tdLastRow: string;
        tdFirstCol: string;
        thCellInner: string;
        tableRowEdit: string;
        cellEditable: string;
        cellEditWrap: string;
        bordered: string;
        striped: string;
        hover: string;
        loading: string;
        rowspanAndColspan: string;
        empty: string;
        emptyRow: string;
        headerFixed: string;
        columnFixed: string;
        widthOverflow: string;
        multipleHeader: string;
        footerAffixed: string;
        horizontalBarAffixed: string;
        affixedHeader: string;
        affixedHeaderElm: string;
        affixedFooterElm: string;
        affixedFooterWrap: string;
        scrollbarDivider: string;
        fullHeight: string;
        resizeLine: string;
        obviousScrollbar: string;
        affixedHeaderWrap: string;
    };
    isFixedLeftColumn: import("@vue/composition-api").ComputedRef<boolean>;
    skipSpansMap: import("@vue/composition-api").Ref<Map<string, import("./hooks/useRowspanAndColspan").SkipSpansValue>>;
    renderTNode: (name: string, options?: import("../hooks/render-tnode").OptionsType) => any;
    getTrListeners: () => {
        [eventName: string]: (e: MouseEvent) => void;
    };
}> & import("@vue/composition-api").Data, {}, {}, {
    activeRowKeys?: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultActiveRowKeys?: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    activeRowType?: {
        type: import("vue").PropType<"multiple" | "single">;
        default: string;
    };
    allowResizeColumnWidth?: {
        type: BooleanConstructor;
        default: any;
    };
    attach?: {
        type: import("vue").PropType<import("..").AttachNode>;
    };
    bordered?: BooleanConstructor;
    bottomContent?: {
        type: import("vue").PropType<string | ((h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    cellEmptyContent?: {
        type: import("vue").PropType<string | ((h: CreateElement, props: import("./type").BaseTableCellParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    columns: {
        type: import("vue").PropType<import("./type").BaseTableCol<import("./type").TableRowData>[]>;
        default: () => import("./type").BaseTableCol<import("./type").TableRowData>[];
    } | PropType<import("./type").BaseTableCol<import("./type").TableRowData>[]>;
    data: {
        type: import("vue").PropType<import("./type").TableRowData[]>;
        default: () => import("./type").TableRowData[];
    } | PropType<import("./type").TableRowData[]>;
    disableDataPage?: BooleanConstructor;
    disableSpaceInactiveRow?: {
        type: BooleanConstructor;
        default: any;
    };
    empty?: {
        type: import("vue").PropType<string | ((h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: string;
    };
    firstFullRow: (new (...args: string[]) => Function) | (() => string | ((h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)) | ((new (...args: string[]) => Function) | (new (...args: any[]) => ((h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue) & object) | (() => string | ((h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)))[] | {
        type: import("vue").PropType<string | ((h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    fixedRows?: {
        type: import("vue").PropType<number[]>;
    };
    footData?: {
        type: import("vue").PropType<import("./type").TableRowData[]>;
        default: () => import("./type").TableRowData[];
    };
    footerAffixProps?: {
        type: import("vue").PropType<Partial<import("..").TdAffixProps>>;
    };
    footerAffixedBottom?: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
        default: boolean;
    };
    footerSummary?: {
        type: import("vue").PropType<string | ((h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    headerAffixProps?: {
        type: import("vue").PropType<Partial<import("..").TdAffixProps>>;
    };
    headerAffixedTop?: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
        default: boolean;
    };
    height?: {
        type: import("vue").PropType<string | number>;
    };
    horizontalScrollAffixedBottom?: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
    };
    hover?: BooleanConstructor;
    keyboardRowHover?: {
        type: BooleanConstructor;
        default: boolean;
    };
    lastFullRow: (new (...args: string[]) => Function) | (() => string | ((h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)) | ((new (...args: string[]) => Function) | (new (...args: any[]) => ((h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue) & object) | (() => string | ((h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)))[] | {
        type: import("vue").PropType<string | ((h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    lazyLoad?: BooleanConstructor;
    loading?: {
        type: import("vue").PropType<boolean | ((h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: any;
    };
    loadingProps?: {
        type: import("vue").PropType<Partial<import("..").TdLoadingProps>>;
    };
    locale?: {
        type: import("vue").PropType<import("..").TableConfig>;
    };
    maxHeight?: {
        type: import("vue").PropType<string | number>;
    };
    pagination?: {
        type: import("vue").PropType<import("..").TdPaginationProps>;
    };
    paginationAffixedBottom?: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
    };
    resizable?: BooleanConstructor;
    rowAttributes?: {
        type: import("vue").PropType<import("./type").TableRowAttributes<import("./type").TableRowData>>;
    };
    rowClassName?: {
        type: import("vue").PropType<import("..").ClassName | ((params: import("./type").RowClassNameParams<import("./type").TableRowData>) => import("..").ClassName)>;
    };
    rowKey?: {
        type: StringConstructor;
        default: string;
        required: boolean;
    };
    rowspanAndColspan?: {
        type: import("vue").PropType<import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>>;
    };
    rowspanAndColspanInFooter?: {
        type: import("vue").PropType<import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>>;
    };
    scroll?: {
        type: import("vue").PropType<import("..").TScroll>;
    };
    showHeader?: {
        type: BooleanConstructor;
        default: boolean;
    };
    size?: {
        type: import("vue").PropType<import("..").SizeEnum>;
        validator(val: import("..").SizeEnum): boolean;
    };
    stripe?: BooleanConstructor;
    tableContentWidth?: {
        type: StringConstructor;
        default: string;
    };
    tableLayout?: {
        type: import("vue").PropType<"fixed" | "auto">;
        default: "fixed" | "auto";
        validator(val: "fixed" | "auto"): boolean;
    };
    topContent?: {
        type: import("vue").PropType<string | ((h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    verticalAlign?: {
        type: import("vue").PropType<"top" | "bottom" | "middle">;
        default: "top" | "bottom" | "middle";
        validator(val: "top" | "bottom" | "middle"): boolean;
    };
    onActiveChange?: import("vue").PropType<(activeRowKeys: (string | number)[], context: import("./type").ActiveChangeContext<import("./type").TableRowData>) => void>;
    onActiveRowAction?: import("vue").PropType<(context: import("./type").ActiveRowActionContext<import("./type").TableRowData>) => void>;
    onCellClick?: import("vue").PropType<(context: import("./type").BaseTableCellEventContext<import("./type").TableRowData>) => void>;
    onColumnResizeChange?: import("vue").PropType<(context: {
        columnsWidth: {
            [colKey: string]: number;
        };
    }) => void>;
    onPageChange?: import("vue").PropType<(pageInfo: import("..").PageInfo, newDataSource: import("./type").TableRowData[]) => void>;
    onRowClick?: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowDblclick?: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMousedown?: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseenter?: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseleave?: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseover?: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseup?: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onScroll?: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
    onScrollX?: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
    onScrollY?: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
    classPrefix: StringConstructor;
    ellipsisOverlayClassName: StringConstructor;
    rowAndColFixedPosition: PropType<RowAndColFixedPosition>;
    showColumnShadow: PropType<{
        left: boolean;
        right: boolean;
    }>;
    tableElm: {};
    tableWidth: NumberConstructor;
    isWidthOverflow: BooleanConstructor;
    virtualConfig: PropType<{
        visibleData: import("@vue/composition-api").Ref<any[]>;
        translateY: import("@vue/composition-api").Ref<number>;
        scrollHeight: import("@vue/composition-api").Ref<number>;
        isVirtualScroll: import("@vue/composition-api").ComputedRef<boolean>;
        handleScroll: () => void;
        handleRowMounted: (rowData: any) => void;
        scrollToElement: (p: import("../hooks/useVirtualScrollNew").ScrollToElementParams) => void;
    }>;
    tableContentElm: {};
    handleRowMounted: PropType<(rowData: any) => void>;
    renderExpandedRow: PropType<(h: CreateElement, params: import("./type").TableExpandedRowParams<import("./type").TableRowData>) => JSX.Element>;
    activeRow: PropType<(string | number)[]>;
    hoverRow: (StringConstructor | NumberConstructor)[];
}, import("@vue/composition-api").ExtractPropTypes<{
    activeRowKeys?: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultActiveRowKeys?: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    activeRowType?: {
        type: import("vue").PropType<"multiple" | "single">;
        default: string;
    };
    allowResizeColumnWidth?: {
        type: BooleanConstructor;
        default: any;
    };
    attach?: {
        type: import("vue").PropType<import("..").AttachNode>;
    };
    bordered?: BooleanConstructor;
    bottomContent?: {
        type: import("vue").PropType<string | ((h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    cellEmptyContent?: {
        type: import("vue").PropType<string | ((h: CreateElement, props: import("./type").BaseTableCellParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    columns: {
        type: import("vue").PropType<import("./type").BaseTableCol<import("./type").TableRowData>[]>;
        default: () => import("./type").BaseTableCol<import("./type").TableRowData>[];
    } | PropType<import("./type").BaseTableCol<import("./type").TableRowData>[]>;
    data: {
        type: import("vue").PropType<import("./type").TableRowData[]>;
        default: () => import("./type").TableRowData[];
    } | PropType<import("./type").TableRowData[]>;
    disableDataPage?: BooleanConstructor;
    disableSpaceInactiveRow?: {
        type: BooleanConstructor;
        default: any;
    };
    empty?: {
        type: import("vue").PropType<string | ((h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: string;
    };
    firstFullRow: (new (...args: string[]) => Function) | (() => string | ((h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)) | ((new (...args: string[]) => Function) | (new (...args: any[]) => ((h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue) & object) | (() => string | ((h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)))[] | {
        type: import("vue").PropType<string | ((h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    fixedRows?: {
        type: import("vue").PropType<number[]>;
    };
    footData?: {
        type: import("vue").PropType<import("./type").TableRowData[]>;
        default: () => import("./type").TableRowData[];
    };
    footerAffixProps?: {
        type: import("vue").PropType<Partial<import("..").TdAffixProps>>;
    };
    footerAffixedBottom?: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
        default: boolean;
    };
    footerSummary?: {
        type: import("vue").PropType<string | ((h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    headerAffixProps?: {
        type: import("vue").PropType<Partial<import("..").TdAffixProps>>;
    };
    headerAffixedTop?: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
        default: boolean;
    };
    height?: {
        type: import("vue").PropType<string | number>;
    };
    horizontalScrollAffixedBottom?: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
    };
    hover?: BooleanConstructor;
    keyboardRowHover?: {
        type: BooleanConstructor;
        default: boolean;
    };
    lastFullRow: (new (...args: string[]) => Function) | (() => string | ((h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)) | ((new (...args: string[]) => Function) | (new (...args: any[]) => ((h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue) & object) | (() => string | ((h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)))[] | {
        type: import("vue").PropType<string | ((h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    lazyLoad?: BooleanConstructor;
    loading?: {
        type: import("vue").PropType<boolean | ((h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: any;
    };
    loadingProps?: {
        type: import("vue").PropType<Partial<import("..").TdLoadingProps>>;
    };
    locale?: {
        type: import("vue").PropType<import("..").TableConfig>;
    };
    maxHeight?: {
        type: import("vue").PropType<string | number>;
    };
    pagination?: {
        type: import("vue").PropType<import("..").TdPaginationProps>;
    };
    paginationAffixedBottom?: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
    };
    resizable?: BooleanConstructor;
    rowAttributes?: {
        type: import("vue").PropType<import("./type").TableRowAttributes<import("./type").TableRowData>>;
    };
    rowClassName?: {
        type: import("vue").PropType<import("..").ClassName | ((params: import("./type").RowClassNameParams<import("./type").TableRowData>) => import("..").ClassName)>;
    };
    rowKey?: {
        type: StringConstructor;
        default: string;
        required: boolean;
    };
    rowspanAndColspan?: {
        type: import("vue").PropType<import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>>;
    };
    rowspanAndColspanInFooter?: {
        type: import("vue").PropType<import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>>;
    };
    scroll?: {
        type: import("vue").PropType<import("..").TScroll>;
    };
    showHeader?: {
        type: BooleanConstructor;
        default: boolean;
    };
    size?: {
        type: import("vue").PropType<import("..").SizeEnum>;
        validator(val: import("..").SizeEnum): boolean;
    };
    stripe?: BooleanConstructor;
    tableContentWidth?: {
        type: StringConstructor;
        default: string;
    };
    tableLayout?: {
        type: import("vue").PropType<"fixed" | "auto">;
        default: "fixed" | "auto";
        validator(val: "fixed" | "auto"): boolean;
    };
    topContent?: {
        type: import("vue").PropType<string | ((h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    verticalAlign?: {
        type: import("vue").PropType<"top" | "bottom" | "middle">;
        default: "top" | "bottom" | "middle";
        validator(val: "top" | "bottom" | "middle"): boolean;
    };
    onActiveChange?: import("vue").PropType<(activeRowKeys: (string | number)[], context: import("./type").ActiveChangeContext<import("./type").TableRowData>) => void>;
    onActiveRowAction?: import("vue").PropType<(context: import("./type").ActiveRowActionContext<import("./type").TableRowData>) => void>;
    onCellClick?: import("vue").PropType<(context: import("./type").BaseTableCellEventContext<import("./type").TableRowData>) => void>;
    onColumnResizeChange?: import("vue").PropType<(context: {
        columnsWidth: {
            [colKey: string]: number;
        };
    }) => void>;
    onPageChange?: import("vue").PropType<(pageInfo: import("..").PageInfo, newDataSource: import("./type").TableRowData[]) => void>;
    onRowClick?: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowDblclick?: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMousedown?: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseenter?: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseleave?: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseover?: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseup?: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onScroll?: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
    onScrollX?: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
    onScrollY?: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
    classPrefix: StringConstructor;
    ellipsisOverlayClassName: StringConstructor;
    rowAndColFixedPosition: PropType<RowAndColFixedPosition>;
    showColumnShadow: PropType<{
        left: boolean;
        right: boolean;
    }>;
    tableElm: {};
    tableWidth: NumberConstructor;
    isWidthOverflow: BooleanConstructor;
    virtualConfig: PropType<{
        visibleData: import("@vue/composition-api").Ref<any[]>;
        translateY: import("@vue/composition-api").Ref<number>;
        scrollHeight: import("@vue/composition-api").Ref<number>;
        isVirtualScroll: import("@vue/composition-api").ComputedRef<boolean>;
        handleScroll: () => void;
        handleRowMounted: (rowData: any) => void;
        scrollToElement: (p: import("../hooks/useVirtualScrollNew").ScrollToElementParams) => void;
    }>;
    tableContentElm: {};
    handleRowMounted: PropType<(rowData: any) => void>;
    renderExpandedRow: PropType<(h: CreateElement, params: import("./type").TableExpandedRowParams<import("./type").TableRowData>) => JSX.Element>;
    activeRow: PropType<(string | number)[]>;
    hoverRow: (StringConstructor | NumberConstructor)[];
}>> & Omit<import("vue").VueConstructor<import("vue").default>, never> & (new (...args: any[]) => import("@vue/composition-api").ComponentRenderProxy<{
    tableLayout?: "fixed" | "auto";
    verticalAlign?: "top" | "bottom" | "middle";
    loading?: boolean | ((h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    empty?: string | ((h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    hover?: boolean;
    lazyLoad?: boolean;
    bordered?: boolean;
    showHeader?: boolean;
    stripe?: boolean;
    activeRowKeys?: (string | number)[];
    defaultActiveRowKeys?: (string | number)[];
    activeRowType?: "multiple" | "single";
    allowResizeColumnWidth?: boolean;
    disableDataPage?: boolean;
    disableSpaceInactiveRow?: boolean;
    footData?: import("./type").TableRowData[];
    footerAffixedBottom?: boolean;
    headerAffixedTop?: boolean;
    keyboardRowHover?: boolean;
    resizable?: boolean;
    rowKey?: string;
    tableContentWidth?: string;
    isWidthOverflow: boolean;
} & {
    data?: import("./type").TableRowData[];
    height?: string | number;
    columns?: import("./type").BaseTableCol<import("./type").TableRowData>[];
    maxHeight?: string | number;
    scroll?: import("..").TScroll;
    size?: import("..").SizeEnum;
    classPrefix?: string;
    attach?: import("..").AttachNode;
    pagination?: unknown;
    onScroll?: (params: {
        e: WheelEvent;
    }) => void;
    handleRowMounted?: (rowData: any) => void;
    onCellClick?: (context: import("./type").BaseTableCellEventContext<import("./type").TableRowData>) => void;
    virtualConfig?: {
        visibleData: import("@vue/composition-api").Ref<any[]>;
        translateY: import("@vue/composition-api").Ref<number>;
        scrollHeight: import("@vue/composition-api").Ref<number>;
        isVirtualScroll: import("@vue/composition-api").ComputedRef<boolean>;
        handleScroll: () => void;
        handleRowMounted: (rowData: any) => void;
        scrollToElement: (p: import("../hooks/useVirtualScrollNew").ScrollToElementParams) => void;
    };
    onPageChange?: (pageInfo: import("..").PageInfo, newDataSource: import("./type").TableRowData[]) => void;
    loadingProps?: unknown;
    bottomContent?: string | ((h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    cellEmptyContent?: string | ((h: CreateElement, props: import("./type").BaseTableCellParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue);
    firstFullRow?: string | ((h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    fixedRows?: number[];
    footerAffixProps?: unknown;
    footerSummary?: string | ((h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    headerAffixProps?: unknown;
    horizontalScrollAffixedBottom?: unknown;
    lastFullRow?: string | ((h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    locale?: unknown;
    paginationAffixedBottom?: unknown;
    rowAttributes?: import("./type").TableRowAttributes<import("./type").TableRowData>;
    rowClassName?: unknown;
    rowspanAndColspan?: import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>;
    rowspanAndColspanInFooter?: import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>;
    topContent?: string | ((h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onActiveChange?: (activeRowKeys: (string | number)[], context: import("./type").ActiveChangeContext<import("./type").TableRowData>) => void;
    onActiveRowAction?: (context: import("./type").ActiveRowActionContext<import("./type").TableRowData>) => void;
    onColumnResizeChange?: (context: {
        columnsWidth: {
            [colKey: string]: number;
        };
    }) => void;
    onRowClick?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowDblclick?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMousedown?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseenter?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseleave?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseover?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseup?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onScrollX?: (params: {
        e: WheelEvent;
    }) => void;
    onScrollY?: (params: {
        e: WheelEvent;
    }) => void;
    showColumnShadow?: {
        left: boolean;
        right: boolean;
    };
    ellipsisOverlayClassName?: string;
    tableElm?: unknown;
    tableContentElm?: unknown;
    rowAndColFixedPosition?: RowAndColFixedPosition;
    renderExpandedRow?: (h: CreateElement, params: import("./type").TableExpandedRowParams<import("./type").TableRowData>) => JSX.Element;
    tableWidth?: number;
    hoverRow?: string | number;
    activeRow?: (string | number)[];
}, import("@vue/composition-api").ShallowUnwrapRef<{
    t: <T>(pattern: T, ...args: any[]) => any;
    global: import("@vue/composition-api").ComputedRef<{} & (import("..").TableConfig | ({
        readonly expandIcon: any;
        readonly sortIcon: any;
        readonly filterIcon: any;
        readonly treeExpandAndFoldIcon: any;
        readonly hideSortTips: false;
        readonly size: "medium";
    } & {
        readonly empty: "暂无数据";
        readonly loadingText: "正在加载中，请稍后";
        readonly loadingMoreText: "点击加载更多";
        readonly filterInputPlaceholder: "请输入内容（无默认值）";
        readonly sortAscendingOperationText: "点击升序";
        readonly sortCancelOperationText: "点击取消排序";
        readonly sortDescendingOperationText: "点击降序";
        readonly clearFilterResultButtonText: "清空筛选";
        readonly columnConfigButtonText: "列配置";
        readonly columnConfigTitleText: "表格列配置";
        readonly columnConfigDescriptionText: "请选择需要在表格中显示的数据列";
        readonly confirmText: "确认";
        readonly cancelText: "取消";
        readonly resetText: "重置";
        readonly selectAllText: "全选";
        readonly searchResultText: "搜索“{result}”，找到 {count} 条结果";
    })) & import("..").TableConfig>;
    tableFullRowClasses: {
        base: string;
        innerFullRow: string;
        innerFullElement: string;
        firstFullRow: string;
        lastFullRow: string;
    };
    tbodyClasses: import("@vue/composition-api").ComputedRef<string[]>;
    tableBaseClass: {
        table: (string | {
            [x: string]: boolean;
        })[];
        columnResizableTable: string;
        overflowVisible: string;
        body: string;
        content: string;
        topContent: string;
        bottomContent: string;
        paginationWrap: string;
        tdLastRow: string;
        tdFirstCol: string;
        thCellInner: string;
        tableRowEdit: string;
        cellEditable: string;
        cellEditWrap: string;
        bordered: string;
        striped: string;
        hover: string;
        loading: string;
        rowspanAndColspan: string;
        empty: string;
        emptyRow: string;
        headerFixed: string;
        columnFixed: string;
        widthOverflow: string;
        multipleHeader: string;
        footerAffixed: string;
        horizontalBarAffixed: string;
        affixedHeader: string;
        affixedHeaderElm: string;
        affixedFooterElm: string;
        affixedFooterWrap: string;
        scrollbarDivider: string;
        fullHeight: string;
        resizeLine: string;
        obviousScrollbar: string;
        affixedHeaderWrap: string;
    };
    isFixedLeftColumn: import("@vue/composition-api").ComputedRef<boolean>;
    skipSpansMap: import("@vue/composition-api").Ref<Map<string, import("./hooks/useRowspanAndColspan").SkipSpansValue>>;
    renderTNode: (name: string, options?: import("../hooks/render-tnode").OptionsType) => any;
    getTrListeners: () => {
        [eventName: string]: (e: MouseEvent) => void;
    };
}>, import("@vue/composition-api").Data, {}, {}, {}, {}, {}, {
    tableLayout?: "fixed" | "auto";
    verticalAlign?: "top" | "bottom" | "middle";
    loading?: boolean | ((h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    empty?: string | ((h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    hover?: boolean;
    lazyLoad?: boolean;
    bordered?: boolean;
    showHeader?: boolean;
    stripe?: boolean;
    activeRowKeys?: (string | number)[];
    defaultActiveRowKeys?: (string | number)[];
    activeRowType?: "multiple" | "single";
    allowResizeColumnWidth?: boolean;
    disableDataPage?: boolean;
    disableSpaceInactiveRow?: boolean;
    footData?: import("./type").TableRowData[];
    footerAffixedBottom?: boolean;
    headerAffixedTop?: boolean;
    keyboardRowHover?: boolean;
    resizable?: boolean;
    rowKey?: string;
    tableContentWidth?: string;
    isWidthOverflow: boolean;
} & {
    data?: import("./type").TableRowData[];
    height?: string | number;
    columns?: import("./type").BaseTableCol<import("./type").TableRowData>[];
    maxHeight?: string | number;
    scroll?: import("..").TScroll;
    size?: import("..").SizeEnum;
    classPrefix?: string;
    attach?: import("..").AttachNode;
    pagination?: unknown;
    onScroll?: (params: {
        e: WheelEvent;
    }) => void;
    handleRowMounted?: (rowData: any) => void;
    onCellClick?: (context: import("./type").BaseTableCellEventContext<import("./type").TableRowData>) => void;
    virtualConfig?: {
        visibleData: import("@vue/composition-api").Ref<any[]>;
        translateY: import("@vue/composition-api").Ref<number>;
        scrollHeight: import("@vue/composition-api").Ref<number>;
        isVirtualScroll: import("@vue/composition-api").ComputedRef<boolean>;
        handleScroll: () => void;
        handleRowMounted: (rowData: any) => void;
        scrollToElement: (p: import("../hooks/useVirtualScrollNew").ScrollToElementParams) => void;
    };
    onPageChange?: (pageInfo: import("..").PageInfo, newDataSource: import("./type").TableRowData[]) => void;
    loadingProps?: unknown;
    bottomContent?: string | ((h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    cellEmptyContent?: string | ((h: CreateElement, props: import("./type").BaseTableCellParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue);
    firstFullRow?: string | ((h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    fixedRows?: number[];
    footerAffixProps?: unknown;
    footerSummary?: string | ((h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    headerAffixProps?: unknown;
    horizontalScrollAffixedBottom?: unknown;
    lastFullRow?: string | ((h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    locale?: unknown;
    paginationAffixedBottom?: unknown;
    rowAttributes?: import("./type").TableRowAttributes<import("./type").TableRowData>;
    rowClassName?: unknown;
    rowspanAndColspan?: import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>;
    rowspanAndColspanInFooter?: import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>;
    topContent?: string | ((h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onActiveChange?: (activeRowKeys: (string | number)[], context: import("./type").ActiveChangeContext<import("./type").TableRowData>) => void;
    onActiveRowAction?: (context: import("./type").ActiveRowActionContext<import("./type").TableRowData>) => void;
    onColumnResizeChange?: (context: {
        columnsWidth: {
            [colKey: string]: number;
        };
    }) => void;
    onRowClick?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowDblclick?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMousedown?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseenter?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseleave?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseover?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseup?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onScrollX?: (params: {
        e: WheelEvent;
    }) => void;
    onScrollY?: (params: {
        e: WheelEvent;
    }) => void;
    showColumnShadow?: {
        left: boolean;
        right: boolean;
    };
    ellipsisOverlayClassName?: string;
    tableElm?: unknown;
    tableContentElm?: unknown;
    rowAndColFixedPosition?: RowAndColFixedPosition;
    renderExpandedRow?: (h: CreateElement, params: import("./type").TableExpandedRowParams<import("./type").TableRowData>) => JSX.Element;
    tableWidth?: number;
    hoverRow?: string | number;
    activeRow?: (string | number)[];
}, {
    tableLayout?: "fixed" | "auto";
    verticalAlign?: "top" | "bottom" | "middle";
    loading?: boolean | ((h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    empty?: string | ((h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    hover?: boolean;
    lazyLoad?: boolean;
    bordered?: boolean;
    showHeader?: boolean;
    stripe?: boolean;
    activeRowKeys?: (string | number)[];
    defaultActiveRowKeys?: (string | number)[];
    activeRowType?: "multiple" | "single";
    allowResizeColumnWidth?: boolean;
    disableDataPage?: boolean;
    disableSpaceInactiveRow?: boolean;
    footData?: import("./type").TableRowData[];
    footerAffixedBottom?: boolean;
    headerAffixedTop?: boolean;
    keyboardRowHover?: boolean;
    resizable?: boolean;
    rowKey?: string;
    tableContentWidth?: string;
    isWidthOverflow: boolean;
}, true>);
export default _default;
