import { TNode } from '../common';
export interface TdTextareaProps {
    autofocus?: boolean;
    autosize?: boolean | {
        minRows?: number;
        maxRows?: number;
    };
    disabled?: boolean;
    maxcharacter?: number;
    maxlength?: number | string;
    name?: string;
    placeholder?: string;
    readonly?: boolean;
    status?: 'default' | 'success' | 'warning' | 'error';
    tips?: string | TNode;
    value?: TextareaValue;
    defaultValue?: TextareaValue;
    onBlur?: (value: TextareaValue, context: {
        e: FocusEvent;
    }) => void;
    onChange?: (value: TextareaValue, context?: {
        e?: InputEvent;
    }) => void;
    onFocus?: (value: TextareaValue, context: {
        e: FocusEvent;
    }) => void;
    onKeydown?: (value: TextareaValue, context: {
        e: KeyboardEvent;
    }) => void;
    onKeypress?: (value: TextareaValue, context: {
        e: KeyboardEvent;
    }) => void;
    onKeyup?: (value: TextareaValue, context: {
        e: KeyboardEvent;
    }) => void;
}
export declare type TextareaValue = string | number;
