import { TdTimePickerProps } from './type';
import { PropType } from 'vue';
declare const _default: {
    allowInput: BooleanConstructor;
    borderless: BooleanConstructor;
    clearable: BooleanConstructor;
    disableTime: {
        type: PropType<(h: number, m: number, s: number, ms: number) => Partial<{
            hour: number[];
            minute: number[];
            second: number[];
            millisecond: number[];
        }>>;
    };
    disabled: {
        type: BooleanConstructor;
        default: any;
    };
    readonly: {
        type: BooleanConstructor;
        default: any;
    };
    format: {
        type: StringConstructor;
        default: string;
    };
    hideDisabledTime: {
        type: BooleanConstructor;
        default: boolean;
    };
    inputProps: {
        type: PropType<import("..").InputProps<import("..").InputValue>>;
    };
    placeholder: {
        type: StringConstructor;
        default: any;
    };
    popupProps: {
        type: PropType<import("..").TdPopupProps>;
    };
    presets: {
        type: PropType<import("./type").PresetTime>;
    };
    size: {
        type: PropType<"small" | "medium" | "large">;
        default: "small" | "medium" | "large";
        validator(val: TdTimePickerProps['size']): boolean;
    };
    status: {
        type: PropType<"error" | "default" | "success" | "warning">;
        default: "error" | "default" | "success" | "warning";
        validator(val: TdTimePickerProps['status']): boolean;
    };
    steps: {
        type: PropType<(string | number)[]>;
        default: () => TdTimePickerProps['steps'];
    };
    tips: {
        type: PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    value: {
        type: PropType<string>;
        default: any;
    };
    defaultValue: {
        type: PropType<string>;
        default: string;
    };
    onBlur: PropType<(context: {
        value: string;
        e: FocusEvent;
    }) => void>;
    onChange: PropType<(value: string) => void>;
    onClose: PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onFocus: PropType<(context: {
        value: string;
        e: FocusEvent;
    }) => void>;
    onInput: PropType<(context: {
        value: string;
        e: InputEvent;
    }) => void>;
    onOpen: PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onPick: PropType<(value: string, context: {
        e: MouseEvent;
    }) => void>;
};
export default _default;
