/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

var props = {
  allowInput: Boolean,
  borderless: Boolean,
  clearable: Boolean,
  disableTime: {
    type: Function
  },
  disabled: {
    type: Boolean,
    "default": void 0
  },
  readonly: {
    type: Boolean,
    "default": void 0
  },
  format: {
    type: String,
    "default": "HH:mm:ss"
  },
  hideDisabledTime: {
    type: Boolean,
    "default": true
  },
  inputProps: {
    type: Object
  },
  placeholder: {
    type: String,
    "default": void 0
  },
  popupProps: {
    type: Object
  },
  presets: {
    type: Object
  },
  size: {
    type: String,
    "default": "medium",
    validator: function validator(val) {
      if (!val) return true;
      return ["small", "medium", "large"].includes(val);
    }
  },
  status: {
    type: String,
    "default": "default",
    validator: function validator(val) {
      if (!val) return true;
      return ["default", "success", "warning", "error"].includes(val);
    }
  },
  steps: {
    type: Array,
    "default": function _default() {
      return [1, 1, 1];
    }
  },
  tips: {
    type: [String, Function]
  },
  value: {
    type: String,
    "default": void 0
  },
  defaultValue: {
    type: String,
    "default": ""
  },
  onBlur: Function,
  onChange: Function,
  onClose: Function,
  onFocus: Function,
  onInput: Function,
  onOpen: Function,
  onPick: Function
};

export { props as default };
//# sourceMappingURL=props.js.map
