import { Ref, SetupContext, ToRefs, UnwrapNestedRefs } from '@vue/composition-api';
import Vue, { CreateElement, VNode, PropType } from 'vue';
import { CheckboxProps } from '../checkbox';
import { ClassName, TScroll, Styles, TNode, TreeOptionData, TNodeReturnValue } from '../common';
import { TypeTreeEventState as TreeEventState } from '../_common/js/tree/types';
import { TdTreeProps, TreeInstanceFunctions } from './type';
import { VirtualScrollConfig } from '../hooks/useVirtualScrollNew';
import tdUseVModel from '../hooks/useVModel';
import { TreeStore } from '../_common/js/tree/tree-store';
export { ref, reactive, computed, watch, onMounted, toRefs, defineComponent, } from '@vue/composition-api';
export { CaretRightSmallIcon as TdCaretRightSmallIcon } from 'tdesign-icons-vue';
export { Checkbox as TCheckBox } from '../checkbox';
export { Loading as TLoading } from '../loading';
export { useConfig, usePrefixClass } from '../hooks/useConfig';
export { useGlobalIcon } from '../hooks/useGlobalIcon';
export { default as useLazyLoad } from '../hooks/useLazyLoad';
export { default as useVirtualScroll } from '../hooks/useVirtualScrollNew';
export { TreeNode, privateKey } from '../_common/js/tree/tree-node';
export declare type TypeVModel = ReturnType<typeof tdUseVModel>;
export declare type TypeRef<T> = Ref<T>;
export declare type TypeSetupContext = SetupContext;
export declare type TypeCreateElement = CreateElement;
export declare type TypeVNode = VNode;
export declare type TypePropType<T> = PropType<T>;
export declare type TypeCheckboxProps = CheckboxProps;
export declare type TypeClassName = ClassName;
export declare type TypeScroll = TScroll;
export declare type TypeStyles = Styles;
export declare type TypeTNode<T> = TNode<T>;
export declare type TypeTNodeReturnValue = TNodeReturnValue;
export declare type TypeTreeOptionData = TreeOptionData;
export declare type TypeTreeEventState = TreeEventState;
export declare type TypeVirtualScrollConfig = VirtualScrollConfig;
export declare type TypeToRefs<T> = ToRefs<T>;
export declare type TypeUnwrapNestedRefs<T> = UnwrapNestedRefs<T>;
export interface TypeTreeInstance extends Vue, TreeInstanceFunctions {
}
export declare type TreeProps<T extends TypeTreeOptionData = TypeTreeOptionData> = TdTreeProps<T> & {
    treeStore?: TreeStore;
};
export declare const isVueNext = false;
export declare const TransitionGroup: import("vue").VueConstructor<Vue>;
export interface TypeOnDrag {
    default?: unknown;
}
export declare const TreeItemDefinition: {
    name: string;
    inject: {
        onDrag: TypeOnDrag;
    };
};
export declare function useRipple(el: unknown): void;
export declare function withInstall<T>(construct: T): T & import("vue").PluginObject<T>;
export declare function getCreateElement(h: CreateElement): CreateElement;
export declare function getScopedSlots(instance: Vue): {
    [key: string]: import("vue/types/vnode").NormalizedScopedSlot;
};
export declare function useVModel(props: TreeProps, refsProps: ToRefs<TreeProps>, propName?: string, defaultPropName?: string, eventPropName?: string, eventName?: string): [Ref<any>, import("../hooks/useVModel").ChangeHandler<any, any[]>];
