export declare type PlainObject = {
    [key: string]: any;
};
export declare type OptionData = {
    label?: string;
    value?: string | number;
} & PlainObject;
export declare type TreeOptionData<T = string | number> = {
    children?: Array<TreeOptionData<T>> | boolean;
    label?: any;
    text?: string;
    value?: T;
} & PlainObject;
export declare type SizeEnum = 'small' | 'medium' | 'large';
export declare type HorizontalAlignEnum = 'left' | 'center' | 'right';
export declare type VerticalAlignEnum = 'top' | 'middle' | 'bottom';
export declare type ClassName = {
    [className: string]: any;
} | ClassName[] | string;
export declare type CSSSelector = string;
export interface Styles {
    [css: string]: string | number;
}
export declare enum EKeyboardDirection {
    left = 37,
    up = 38,
    right = 39,
    down = 40
}
export declare const ARROW_DOWN_REG: RegExp;
export declare const ARROW_UP_REG: RegExp;
export declare const ARROW_LEFT_REG: RegExp;
export declare const ARROW_RIGHT_REG: RegExp;
export declare const ESCAPE_REG: RegExp;
export declare const SPACE_REG: RegExp;
export declare const ENTER_REG: RegExp;
export declare const SHIFT_REG: RegExp;
export declare const CLEAR_REG: RegExp;
export declare const ALL_REG: RegExp;
export declare const CHECKED_CODE_REG: RegExp;
