import 'dayjs/locale/ja';
declare const _default: {
    readonly autoComplete: {
        readonly empty: "データなし";
    };
    readonly pagination: {
        readonly itemsPerPage: "{size} /ページ";
        readonly jumpTo: "ジャンプする";
        readonly page: "ページ";
        readonly total: "合計 {total} 項目データ";
    };
    readonly cascader: {
        readonly empty: "データなし";
        readonly loadingText: "ローディング";
        readonly placeholder: "選択してください";
    };
    readonly calendar: {
        readonly yearSelection: "{year} 年";
        readonly monthSelection: "{month} 月";
        readonly yearRadio: "年";
        readonly monthRadio: "月";
        readonly hideWeekend: "ヒドゥン・ウィークエンド";
        readonly showWeekend: "ショーウィークエンド";
        readonly today: "今日";
        readonly thisMonth: "今月は";
        readonly week: "月,火,水,木,金,土,日";
        readonly cellMonth: "1 月,2 月,3 月,4 月,5 月,6 月,7 月,8 月,9 月,10 月,11 月,12 月";
    };
    readonly transfer: {
        readonly title: "{checked} / {total} 項目";
        readonly empty: "データなし";
        readonly placeholder: "検索するキーワードを入力してください";
    };
    readonly timePicker: {
        readonly dayjsLocale: "ja";
        readonly now: "このとき";
        readonly confirm: "決定事項";
        readonly anteMeridiem: "モーニング";
        readonly postMeridiem: "午後";
        readonly placeholder: "時間を選択する";
    };
    readonly dialog: {
        readonly confirm: "確認事項";
        readonly cancel: "キャンセルについて";
    };
    readonly drawer: {
        readonly confirm: "確認事項";
        readonly cancel: "キャンセルについて";
    };
    readonly popconfirm: {
        readonly confirm: {
            readonly content: "確認事項";
        };
        readonly cancel: {
            readonly content: "キャンセルについて";
        };
    };
    readonly table: {
        readonly empty: "データなし";
        readonly loadingText: "ロード中です、お待ちください";
        readonly loadingMoreText: "クリックでさらに読み込み";
        readonly filterInputPlaceholder: "内容を入力してください（初期値なし）";
        readonly sortAscendingOperationText: "クリックで昇降";
        readonly sortCancelOperationText: "クリックでソート解除";
        readonly sortDescendingOperationText: "降順でクリック";
        readonly clearFilterResultButtonText: "クリアフィルター";
        readonly columnConfigButtonText: "カラム構成";
        readonly columnConfigTitleText: "テーブルカラムの構成";
        readonly columnConfigDescriptionText: "表に表示するデータの列を選択してください。";
        readonly confirmText: "確認事項";
        readonly cancelText: "キャンセルについて";
        readonly resetText: "リセット";
        readonly selectAllText: "すべて選択";
        readonly searchResultText: "検索“{result}”，探す {count} 記事結果";
    };
    readonly select: {
        readonly empty: "データなし";
        readonly loadingText: "ローディング";
        readonly placeholder: "選択してください";
    };
    readonly tree: {
        readonly empty: "データなし";
    };
    readonly treeSelect: {
        readonly empty: "データなし";
        readonly loadingText: "ローディング";
        readonly placeholder: "選択してください";
    };
    readonly datePicker: {
        readonly dayjsLocale: "ja";
        readonly placeholder: {
            readonly date: "日付を選択してください";
            readonly month: "月を選択してください";
            readonly year: "年度を選択してください";
            readonly quarter: "四半期を選択してください";
            readonly week: "週を選択してください";
        };
        readonly weekdays: readonly ["月", "火", "水", "木", "金", "土", "日"];
        readonly months: readonly ["1 月", "2 月", "3 月", "4 月", "5 月", "6 月", "7 月", "8 月", "9 月", "10 月", "11 月", "12 月"];
        readonly quarters: readonly ["Q1", "Q2", "Q3", "Q4"];
        readonly rangeSeparator: " - ";
        readonly direction: "ltr";
        readonly format: "YYYY-MM-DD";
        readonly dayAriaLabel: "日";
        readonly weekAbbreviation: "週間";
        readonly yearAriaLabel: "年";
        readonly monthAriaLabel: "月";
        readonly confirm: "決定事項";
        readonly selectTime: "時間を選択する";
        readonly selectDate: "日付を選択";
        readonly nextYear: "来年度";
        readonly preYear: "前年度";
        readonly nextMonth: "来月";
        readonly preMonth: "先月";
        readonly preDecade: "過去10年間";
        readonly nextDecade: "次の10年";
        readonly now: "電流";
    };
    readonly upload: {
        readonly sizeLimitMessage: "画像サイズは最大で {sizeLimit}";
        readonly cancelUploadText: "アップロードをキャンセルする";
        readonly triggerUploadText: {
            readonly fileInput: "ファイル選択";
            readonly image: "クリックで画像をアップロード";
            readonly normal: "クリックでアップロード";
            readonly reupload: "再アップロード";
            readonly continueUpload: "アップロードを継続する";
            readonly delete: "削除";
            readonly uploading: "アップロード中";
        };
        readonly dragger: {
            readonly dragDropText: "マウスを離す";
            readonly draggingText: "この領域にドラッグ＆ドロップする";
            readonly clickAndDragText: "上の「ファイルを選択」をクリックするか、このエリアにファイルをドラッグ＆ドロップしてください";
        };
        readonly file: {
            readonly fileNameText: "ファイル名";
            readonly fileSizeText: "ファイルサイズ";
            readonly fileStatusText: "状態です";
            readonly fileOperationText: "操作";
            readonly fileOperationDateText: "アップロード日";
        };
        readonly progress: {
            readonly uploadingText: "アップロード中";
            readonly waitingText: "アップロード予定";
            readonly failText: "アップロードに失敗しました";
            readonly successText: "アップロード成功";
        };
    };
    readonly form: {
        readonly errorMessage: {
            readonly date: "正しく入力してください${name}";
            readonly url: "正しく入力してください${name}";
            readonly required: "${name}必須項目";
            readonly whitespace: "${name}を空にすることはできません";
            readonly max: "${name}文字数制限 ${validate} 文字，一中二文";
            readonly min: "${name}を下回る文字数は使用できません ${validate} 文字，一中二文";
            readonly len: "${name}文字の長さは、必ず ${validate}";
            readonly enum: "${name}でしかありえません${validate}等";
            readonly idcard: "正しく入力してください${name}";
            readonly telnumber: "正しく入力してください${name}";
            readonly pattern: "正しく入力してください${name}";
            readonly validator: "${name}要件を満たしていない";
            readonly boolean: "${name}データ型は Boolean 型であること";
            readonly number: "${name}デジタルであること";
        };
        readonly colonText: ":";
    };
    readonly input: {
        readonly placeholder: "入力してください";
    };
    readonly list: {
        readonly loadingText: "ロード中です、お待ちください";
        readonly loadingMoreText: "クリックでさらに読み込み";
    };
    readonly alert: {
        readonly expandText: "もっと拡大する";
        readonly collapseText: "コレクト";
    };
    readonly anchor: {
        readonly copySuccessText: "リンクが正常にコピーされました";
        readonly copyText: "コピーリンク";
    };
    readonly colorPicker: {
        readonly swatchColorTitle: "システムプリセットカラー";
        readonly recentColorTitle: "最近使用した色";
        readonly clearConfirmText: "最近使用した色をクリアにするのは確実ですか？";
        readonly singleColor: "単色";
        readonly gradientColor: "グラデ";
    };
    readonly guide: {
        readonly finishButtonProps: {
            readonly content: "終了";
            readonly theme: "primary";
        };
        readonly nextButtonProps: {
            readonly content: "次のステップ";
            readonly theme: "primary";
        };
        readonly skipButtonProps: {
            readonly content: "スキップ";
            readonly theme: "default";
        };
        readonly prevButtonProps: {
            readonly content: "前へ";
            readonly theme: "default";
        };
    };
    readonly image: {
        readonly errorText: "画像を表示できません";
        readonly loadingText: "画像の読み込み";
    };
    readonly imageViewer: {
        readonly errorText: "画像の読み込みに失敗しました。再読み込みしてみてください";
        readonly mirrorTipText: "鏡像";
        readonly rotateTipText: "回転する";
        readonly originalSizeTipText: "オリジナルサイズ";
    };
    readonly typography: {
        readonly expandText: "もっと拡大する";
        readonly collapseText: "畳む";
        readonly copiedText: "コピー成功";
    };
    readonly rate: {
        readonly rateText: readonly ["ひどい", "がっかり", "普通", "満足", "驚き"];
    };
    readonly empty: {
        readonly titleText: {
            readonly maintenance: "建設中";
            readonly success: "成功";
            readonly fail: "失敗";
            readonly empty: "データなし";
            readonly networkError: "ネットワークエラー";
        };
    };
    readonly descriptions: {
        readonly colonText: ":";
    };
    readonly chat: {
        readonly placeholder: "メッセージを入力してください...";
        readonly stopBtnText: "停止";
        readonly refreshTipText: "再生成";
        readonly copyTipText: "コピー";
        readonly likeTipText: "いいね";
        readonly dislikeTipText: "低評価";
        readonly copyCodeBtnText: "コードをコピー";
        readonly copyCodeSuccessText: "コピー済み";
        readonly clearHistoryBtnText: "履歴をクリア";
        readonly copyTextSuccess: "クリップボードにコピーしました";
        readonly copyTextFail: "クリップボードへのコピーに失敗しました";
        readonly confirmClearHistory: "すべてのメッセージをクリアしてもよろしいですか？";
        readonly loadingText: "考え中...";
        readonly loadingEndText: "深く考えました";
    };
};
export default _default;
