/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

import _defineProperty from '@babel/runtime/helpers/defineProperty';
import { defineComponent } from '@vue/composition-api';
import Panel from './components/Panel.js';
import props from './props.js';
import { useCascaderContext } from './hooks.js';
import './components/Item.js';
import '../_chunks/dep-653f218a.js';
import 'tdesign-icons-vue';
import './core/helper.js';
import '@babel/runtime/helpers/typeof';
import 'lodash-es';
import './core/className.js';
import '@babel/runtime/helpers/toConsumableArray';
import '../checkbox/index.js';
import '../checkbox/group.js';
import '@babel/runtime/helpers/slicedToArray';
import '../utils/helper.js';
import '@babel/runtime/helpers/objectWithoutProperties';
import '../checkbox/checkbox.js';
import '../checkbox/props.js';
import '../checkbox/constants.js';
import '../checkbox/store.js';
import '@babel/runtime/helpers/classCallCheck';
import '@babel/runtime/helpers/createClass';
import '../checkbox/hooks/useKeyboardEvent.js';
import '../_common/js/common.js';
import '../hooks/useConfig.js';
import '../config-provider/useConfig.js';
import '../config-provider/context.js';
import '../_common/js/global-config/default-config.js';
import '../_common/js/global-config/locale/zh_CN.js';
import '../_chunks/dep-84fc5ae7.js';
import '../_chunks/dep-eb45b5e0.js';
import 'dayjs';
import '../hooks/useVModel.js';
import '../hooks/useFormDisabled.js';
import '../hooks/useElementLazyRender.js';
import '../_common/js/utils/observe.js';
import '../utils/render-tnode.js';
import '@babel/runtime/helpers/readOnlyError';
import 'vue';
import '../checkbox/checkbox-group-props.js';
import '../hooks/slots.js';
import '../utils/withInstall.js';
import '../loading/index.js';
import '../loading/directive.js';
import '../loading/plugin.js';
import '../loading/loading.js';
import '../loading/icon/gradient.js';
import '../_common/js/loading/circle-adapter.js';
import '../_common/js/utils/setStyle.js';
import '../_common/js/utils/helper.js';
import '../config-provider/config-receiver.js';
import '../utils/mixins.js';
import '../utils/dom.js';
import 'raf';
import '../utils/easing.js';
import '../utils/transfer-dom.js';
import '../loading/props.js';
import '../config.js';
import '../hooks/useGlobalIcon.js';
import '../utils/ripple.js';
import '../hooks/tnode.js';
import '../hooks/render-tnode.js';
import './core/effect.js';
import '../_common/js/tree/tree-store.js';
import 'mitt';
import '../_common/js/tree/tree-node.js';
import '@babel/runtime/helpers/asyncToGenerator';
import '@babel/runtime/regenerator';
import '../_common/js/tree/tree-node-model.js';
import '../_common/js/log/log.js';
import '../hooks/useDefaultValue.js';

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var _CascaderPanel = defineComponent({
  name: "TCascaderPanel",
  props: _objectSpread({}, props),
  setup: function setup(props2, _ref) {
    var slots = _ref.slots,
      emit = _ref.emit;
    var _useCascaderContext = useCascaderContext(props2),
      cascaderContext = _useCascaderContext.cascaderContext;
    var onClick = function onClick(value, node) {
      emit("click", value, node);
    };
    return {
      cascaderContext: cascaderContext,
      slots: slots,
      onClick: onClick
    };
  },
  render: function render() {
    var h = arguments[0];
    return h(Panel, {
      "attrs": {
        "empty": this.empty,
        "trigger": this.trigger,
        "cascaderContext": this.cascaderContext
      },
      "scopedSlots": {
        empty: this.slots.empty,
        option: this.slots.option,
        loadingText: this.slots.loadingText
      },
      "on": {
        "click": this.onClick
      }
    });
  }
});

export { _CascaderPanel as default };
//# sourceMappingURL=cascader-panel.js.map
