/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

import { h as helper } from '../../_chunks/dep-653f218a.js';
import _defineProperty from '@babel/runtime/helpers/defineProperty';
import { defineComponent, computed } from '@vue/composition-api';
import { ChevronRightIcon } from 'tdesign-icons-vue';
import { getFullPathLabel } from '../core/helper.js';
import { getCascaderItemClass, getCascaderItemIconClass } from '../core/className.js';
import { Checkbox } from '../../checkbox/index.js';
import { Loading } from '../../loading/index.js';
import { getKeepAnimationMixins } from '../../config-provider/config-receiver.js';
import { usePrefixClass, useCommonClassName } from '../../hooks/useConfig.js';
import { useGlobalIcon } from '../../hooks/useGlobalIcon.js';
import Ripple from '../../utils/ripple.js';
import '@babel/runtime/helpers/typeof';
import 'lodash-es';
import '@babel/runtime/helpers/toConsumableArray';
import '../../checkbox/group.js';
import '@babel/runtime/helpers/slicedToArray';
import '../../utils/helper.js';
import '@babel/runtime/helpers/objectWithoutProperties';
import '../../checkbox/checkbox.js';
import '../../checkbox/props.js';
import '../../checkbox/constants.js';
import '../../checkbox/store.js';
import '@babel/runtime/helpers/classCallCheck';
import '@babel/runtime/helpers/createClass';
import '../../checkbox/hooks/useKeyboardEvent.js';
import '../../_common/js/common.js';
import '../../hooks/useVModel.js';
import '../../hooks/useFormDisabled.js';
import '../../hooks/useElementLazyRender.js';
import '../../_common/js/utils/observe.js';
import '../../utils/render-tnode.js';
import '@babel/runtime/helpers/readOnlyError';
import 'vue';
import '../../config-provider/useConfig.js';
import '../../config-provider/context.js';
import '../../_common/js/global-config/default-config.js';
import '../../_common/js/global-config/locale/zh_CN.js';
import '../../_chunks/dep-84fc5ae7.js';
import '../../_chunks/dep-eb45b5e0.js';
import 'dayjs';
import '../../checkbox/checkbox-group-props.js';
import '../../hooks/slots.js';
import '../../utils/withInstall.js';
import '../../loading/directive.js';
import '../../loading/plugin.js';
import '../../loading/loading.js';
import '../../loading/icon/gradient.js';
import '../../_common/js/loading/circle-adapter.js';
import '../../_common/js/utils/setStyle.js';
import '../../_common/js/utils/helper.js';
import '../../utils/mixins.js';
import '../../utils/dom.js';
import 'raf';
import '../../utils/easing.js';
import '../../utils/transfer-dom.js';
import '../../loading/props.js';
import '../../config.js';

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var keepAnimationMixins = getKeepAnimationMixins();
var props = {
  node: {
    type: Object,
    "default": function _default() {
      return {};
    }
  },
  optionChild: {
    type: [Object, Array]
  },
  cascaderContext: {
    type: Object
  },
  onChange: Function,
  onClick: Function,
  onMouseenter: Function
};
var Item = defineComponent({
  mixins: [keepAnimationMixins],
  directives: {
    Ripple: Ripple
  },
  props: _objectSpread({}, props),
  setup: function setup(props2) {
    var COMPONENT_NAME = usePrefixClass("cascader__item");
    var classPrefix = usePrefixClass();
    var _useCommonClassName = useCommonClassName(),
      STATUS = _useCommonClassName.STATUS,
      SIZE = _useCommonClassName.SIZE;
    var _useGlobalIcon = useGlobalIcon({
        ChevronRightIcon: ChevronRightIcon
      }),
      ChevronRightIcon$1 = _useGlobalIcon.ChevronRightIcon;
    var itemClass = computed(function () {
      return getCascaderItemClass(classPrefix.value, props2.node, SIZE.value, STATUS.value, props2.cascaderContext);
    });
    var iconClass = computed(function () {
      return getCascaderItemIconClass(classPrefix.value, props2.node, STATUS.value, props2.cascaderContext);
    });
    return {
      COMPONENT_NAME: COMPONENT_NAME,
      ChevronRightIcon: ChevronRightIcon$1,
      iconClass: iconClass,
      itemClass: itemClass
    };
  },
  render: function render() {
    var _this = this;
    var h = arguments[0];
    var iconClass = this.iconClass,
      cascaderContext = this.cascaderContext,
      itemClass = this.itemClass,
      node = this.node,
      optionChild = this.optionChild,
      COMPONENT_NAME = this.COMPONENT_NAME,
      onChange = this.onChange,
      ChevronRightIcon = this.ChevronRightIcon;
    function RenderLabelInner(node2, cascaderContext2) {
      var inputVal = cascaderContext2.inputVal;
      var labelText = inputVal ? getFullPathLabel(node2) : node2.label;
      if (inputVal) {
        var texts = labelText.split(inputVal);
        var doms = [];
        for (var index = 0; index < texts.length; index++) {
          doms.push(h("span", {
            "key": index
          }, [texts[index]]));
          if (index === texts.length - 1) break;
          doms.push(h("span", {
            "key": "".concat(index, "filter"),
            "class": "".concat(COMPONENT_NAME, "-label--filter")
          }, [inputVal]));
        }
        return doms;
      }
      return labelText;
    }
    function RenderLabelContent(node2, cascaderContext2) {
      var label = RenderLabelInner(node2, cascaderContext2);
      var labelCont = h("span", {
        "attrs": {
          "title": cascaderContext2.inputVal ? getFullPathLabel(node2) : node2.label,
          "role": "label"
        },
        "class": ["".concat(COMPONENT_NAME, "-label"), "".concat(COMPONENT_NAME, "-label--ellipsis")]
      }, [label]);
      return labelCont;
    }
    function RenderCheckBox(node2, cascaderContext2) {
      var checkProps = cascaderContext2.checkProps,
        value = cascaderContext2.value,
        max = cascaderContext2.max,
        inputVal = cascaderContext2.inputVal;
      var label = RenderLabelInner(node2, cascaderContext2);
      return h(Checkbox, helper([{
        "attrs": {
          "checked": node2.checked,
          "indeterminate": node2.indeterminate,
          "disabled": node2.isDisabled() || value.length >= max && max !== 0,
          "name": String(node2.value),
          "title": inputVal ? getFullPathLabel(node2) : node2.label,
          "stopLabelTrigger": !!node2.children
        },
        "on": {
          "change": function change(vale, _ref) {
            var e = _ref.e;
            e.stopPropagation();
            onChange();
          }
        }
      }, checkProps]), [label]);
    }
    return h("li", {
      "class": itemClass,
      "on": {
        "click": function click(e) {
          e.stopPropagation();
          _this.onClick();
        },
        "mouseenter": function mouseenter(e) {
          e.stopPropagation();
          _this.onMouseenter();
        }
      }
    }, [optionChild || (cascaderContext.multiple ? RenderCheckBox(node, cascaderContext) : RenderLabelContent(node, cascaderContext)), node.children && (node.loading ? h(Loading, {
      "class": iconClass,
      "attrs": {
        "size": "small"
      }
    }) : h(ChevronRightIcon, {
      "class": iconClass
    }))]);
  }
});

export { Item as default };
//# sourceMappingURL=Item.js.map
