import { TNode } from '../common';
export interface TdCheckboxProps {
    checkAll?: boolean;
    checked?: boolean;
    defaultChecked?: boolean;
    default?: string | TNode;
    disabled?: boolean;
    indeterminate?: boolean;
    label?: string | TNode;
    lazyLoad?: boolean;
    name?: string;
    readonly?: boolean;
    value?: string | number | boolean;
    onChange?: (checked: boolean, context: {
        e: Event;
    }) => void;
}
export interface TdCheckboxGroupProps<T = CheckboxGroupValue> {
    disabled?: boolean;
    lazyLoad?: boolean;
    max?: number;
    name?: string;
    options?: Array<CheckboxOption>;
    value?: T;
    defaultValue?: T;
    onChange?: (value: T, context: CheckboxGroupChangeContext) => void;
}
export declare type CheckboxOption = string | number | CheckboxOptionObj;
export interface CheckboxOptionObj extends TdCheckboxProps {
    text?: string;
}
export declare type CheckboxGroupValue = Array<string | number | boolean>;
export interface CheckboxGroupChangeContext {
    e: Event;
    current: string | number | boolean;
    option: CheckboxOption | TdCheckboxProps;
    type: 'check' | 'uncheck';
}
