/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

import _defineProperty from '@babel/runtime/helpers/defineProperty';
import { defineComponent, ref, watch } from '@vue/composition-api';
import { upperCase } from 'lodash-es';
import props from '../../props.js';
import { FORMATS } from '../../../_common/js/color-picker/constants.js';
import { Select, Option } from '../../../select/index.js';
import { Input } from '../../../input/index.js';
import FormatInputs from './inputs.js';
import { useBaseClassName } from '../../hooks.js';
import '../../../select/select.js';
import '@babel/runtime/helpers/objectWithoutProperties';
import '@babel/runtime/helpers/toConsumableArray';
import '@babel/runtime/helpers/typeof';
import '@babel/runtime/helpers/slicedToArray';
import '../../../hooks/useDefaultValue.js';
import '../../../hooks/useVModel.js';
import '../../../hooks/tnode.js';
import '../../../hooks/render-tnode.js';
import '../../../config-provider/useConfig.js';
import '../../../config-provider/context.js';
import '../../../_common/js/global-config/default-config.js';
import '../../../_common/js/global-config/locale/zh_CN.js';
import '../../../_chunks/dep-84fc5ae7.js';
import '../../../_chunks/dep-eb45b5e0.js';
import 'dayjs';
import '../../../select/props.js';
import '../../../loading/index.js';
import '../../../loading/directive.js';
import '../../../loading/plugin.js';
import 'vue';
import '../../../loading/loading.js';
import '../../../loading/icon/gradient.js';
import '../../../_common/js/loading/circle-adapter.js';
import '../../../_common/js/utils/setStyle.js';
import '../../../_common/js/utils/helper.js';
import '../../../config-provider/config-receiver.js';
import '../../../utils/mixins.js';
import '../../../utils/dom.js';
import 'raf';
import '../../../utils/easing.js';
import '../../../utils/render-tnode.js';
import '@babel/runtime/helpers/readOnlyError';
import '../../../utils/transfer-dom.js';
import '../../../loading/props.js';
import '../../../config.js';
import '../../../utils/withInstall.js';
import '../../../popup/index.js';
import '../../../popup/popup.js';
import '@popperjs/core';
import '../../../utils/helper.js';
import '../../../popup/props.js';
import '../../../popup/container.js';
import '../../../utils/event.js';
import '../../../popup/utils.js';
import '../../../utils/map-props.js';
import '../../../popup/plugin.js';
import '../../../_common/js/log/log.js';
import '../../../tag/index.js';
import '../../../tag/tag.js';
import 'tdesign-icons-vue';
import 'tinycolor2';
import '../../../tag/props.js';
import '../../../tag/check-tag.js';
import '../../../_chunks/dep-653f218a.js';
import '../../../tag/check-tag-props.js';
import '../../../hooks/useConfig.js';
import '../../../_common/js/common.js';
import '../../../tag/check-tag-group.js';
import '../../../tag/check-tag-group-props.js';
import '../../../select-input/index.js';
import '../../../select-input/select-input.js';
import '../../../select-input/props.js';
import '../../../select-input/useSingle.js';
import '../../../input/input.js';
import '../../../input/props.js';
import '../../../input/input-group.js';
import '../../../select-input/useMultiple.js';
import '../../../tag-input/index.js';
import '../../../tag-input/tag-input.js';
import '../../../tag-input/props.js';
import '../../../tag-input/hooks/useTagScroll.js';
import '../../../tag-input/useTagList.js';
import '../../../tag-input/hooks/useHover.js';
import '../../../tag-input/hooks/useDragSorter.js';
import '../../../hooks/useGlobalIcon.js';
import '../../../select-input/useOverlayInnerStyle.js';
import '../../../common-components/fake-arrow.js';
import '../../../select/option.js';
import '../../../utils/ripple.js';
import '../../../select/option-props.js';
import '../../../checkbox/index.js';
import '../../../checkbox/group.js';
import '../../../checkbox/checkbox.js';
import '../../../checkbox/props.js';
import '../../../checkbox/constants.js';
import '../../../checkbox/store.js';
import '@babel/runtime/helpers/classCallCheck';
import '@babel/runtime/helpers/createClass';
import '../../../checkbox/hooks/useKeyboardEvent.js';
import '../../../hooks/useFormDisabled.js';
import '../../../hooks/useElementLazyRender.js';
import '../../../_common/js/utils/observe.js';
import '../../../checkbox/checkbox-group-props.js';
import '../../../hooks/slots.js';
import '../../../hooks/useLazyLoad.js';
import '../../../select/util.js';
import '../../../hooks/useCommonClassName.js';
import '../../../select/select-panel.js';
import '../../../select/optionGroup.js';
import '../../../select/option-group-props.js';
import '../../../hooks/useVirtualScroll.js';
import '../../../select/hooks/useSelectOptions.js';
import '../../../input-number/index.js';
import '../../../input-number/input-number.js';
import '../../../button/index.js';
import '../../../button/button.js';
import '../../../button/props.js';
import '../../../input-number/props.js';
import '../../../input-number/useInputNumber.js';
import '../../../_common/js/input-number/number.js';
import '../../../_common/js/input-number/large-number.js';
import './config.js';
import '../../../_common/js/color-picker/color.js';
import '../../../_common/js/color-picker/cmyk.js';
import '../../../_common/js/color-picker/gradient.js';

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var FormatPanel = defineComponent({
  name: "FormatPanel",
  components: {
    TSelect: Select,
    TInput: Input,
    TOption: Option,
    FormatInputs: FormatInputs
  },
  inheritAttrs: false,
  props: _objectSpread(_objectSpread({}, props), {}, {
    color: {
      type: Object
    },
    handleFormatModeChange: {
      type: Function,
      "default": function _default() {
        return function () {};
      }
    },
    handleFormatInputChange: {
      type: Function,
      "default": function _default() {
        return function () {};
      }
    }
  }),
  setup: function setup(props2) {
    var baseClassName = useBaseClassName();
    var formatModel = ref(props2.format);
    watch(function () {
      return [props2.format];
    }, function () {
      return formatModel.value = props2.format;
    });
    var handleModeChange = function handleModeChange(v) {
      formatModel.value = v;
      props2.handleFormatModeChange(v);
    };
    return {
      formatModel: formatModel,
      baseClassName: baseClassName,
      handleModeChange: handleModeChange
    };
  },
  render: function render(h) {
    var _this = this;
    var baseClassName = this.baseClassName,
      handleModeChange = this.handleModeChange;
    var newProps = _objectSpread(_objectSpread({}, this.$props), {}, {
      format: this.formatModel
    });
    var selectInputProps = _objectSpread({}, this.selectInputProps || {});
    return h("div", {
      "class": "".concat(baseClassName, "__format")
    }, [h("div", {
      "class": "".concat(baseClassName, "__format--item")
    }, [h("t-select", {
      "attrs": {
        "size": "small",
        "selectInputProps": _objectSpread({}, selectInputProps),
        "popupProps": _objectSpread({
          overlayClassName: "".concat(baseClassName, "__select-options")
        }, selectInputProps.popupProps),
        "disabled": this.disabled
      },
      "class": "".concat(baseClassName, "__format-mode-select"),
      "on": {
        "change": handleModeChange
      },
      "model": {
        value: _this.formatModel,
        callback: function callback($$v) {
          _this.formatModel = $$v;
        }
      }
    }, [FORMATS.map(function (item) {
      return h("t-option", {
        "key": item,
        "attrs": {
          "value": item,
          "label": upperCase(item)
        },
        "style": {
          fontSize: "12px"
        }
      });
    })])]), h("div", {
      "class": "".concat(baseClassName, "__format--item")
    }, [h("format-inputs", {
      props: newProps
    })])]);
  }
});

export { FormatPanel as default };
//# sourceMappingURL=index.js.map
