/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

import Vue from 'vue';
import { cloneDeep } from 'lodash-es';
import { defaultGlobalConfig, mergeWith } from './context.js';
import props from './props.js';
import '../_common/js/global-config/default-config.js';
import '../_common/js/global-config/locale/zh_CN.js';
import '../_chunks/dep-84fc5ae7.js';
import '@babel/runtime/helpers/typeof';
import '../_chunks/dep-eb45b5e0.js';
import 'dayjs';

var globalConfigSymbol = "__TDESIGN__INSTANCE__GLOBAL__CONFIG__";
var ConfigProvider = Vue.extend({
  name: "TConfigProvider",
  props: props,
  data: function data() {
    return {
      defaultData: cloneDeep(defaultGlobalConfig)
    };
  },
  provide: function provide() {
    return {
      globalConfig: this.mergedGlobalConfig
    };
  },
  computed: {
    mergedGlobalConfig: function mergedGlobalConfig() {
      var mergedGlobalConfig = mergeWith(this.defaultData, this.globalConfig);
      Vue.prototype[globalConfigSymbol] = mergedGlobalConfig;
      return mergedGlobalConfig;
    }
  },
  render: function render() {
    var _this$$slots$default;
    var h = arguments[0];
    if (((_this$$slots$default = this.$slots["default"]) === null || _this$$slots$default === void 0 ? void 0 : _this$$slots$default.length) === 1) {
      return this.$slots["default"][0];
    }
    return h("div", [this.$slots["default"]]);
  }
});

export { ConfigProvider as default, globalConfigSymbol };
//# sourceMappingURL=config-provider.js.map
