/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

import { inject, computed, ref, h } from '@vue/composition-api';
import { defaultGlobalConfig } from './context.js';
import 'lodash-es';
import '../_common/js/global-config/default-config.js';
import '../_common/js/global-config/locale/zh_CN.js';
import '../_chunks/dep-84fc5ae7.js';
import '@babel/runtime/helpers/typeof';
import '../_chunks/dep-eb45b5e0.js';
import 'dayjs';

var t = function t(pattern) {
  for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }
  var data = args[0];
  if (typeof pattern === "string") {
    if (!data) return pattern;
    var regular = /\{\s*([\w-]+)\s*\}/g;
    var translated = pattern.replace(regular, function (match, key) {
      if (data) {
        return String(data[key]);
      }
      return "";
    });
    return translated;
  }
  if (typeof pattern === "function") {
    if (!args.length) return pattern(h);
    return pattern.apply(void 0, args);
  }
  return "";
};
function useConfig() {
  var componentName = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : void 0;
  var componentLocale = arguments.length > 1 ? arguments[1] : undefined;
  var injectGlobalConfig = inject("globalConfig", null);
  var mergedGlobalConfig = injectGlobalConfig || defaultGlobalConfig;
  var global = computed(function () {
    return Object.assign({}, mergedGlobalConfig[componentName], componentLocale);
  });
  var classPrefix = ref(mergedGlobalConfig.classPrefix);
  return {
    t: t,
    global: global,
    globalConfig: global,
    classPrefix: classPrefix
  };
}
function usePrefixClass(componentName) {
  var _useConfig = useConfig("classPrefix"),
    classPrefix = _useConfig.classPrefix;
  return ref(componentName ? "".concat(classPrefix.value, "-").concat(componentName) : classPrefix.value);
}

export { useConfig, usePrefixClass };
//# sourceMappingURL=useConfig.js.map
