import dayjs from 'dayjs';
import type { DateMultipleValue, DateValue } from './type';
import type { TagInputRemoveContext } from '../tag-input';
declare const _default: import("vue").ComponentOptions<import("vue").default, import("@vue/composition-api").ShallowUnwrapRef<{
    COMPONENT_NAME: import("@vue/composition-api").ComputedRef<string>;
    inputValue: import("@vue/composition-api").Ref<string | number | string[] | number[] | Date | Date[]>;
    datePickerPopupProps: import("@vue/composition-api").ComputedRef<{
        trigger: string;
        overlayInnerStyle: import("..").Styles | ((triggerElement: HTMLElement, popupElement: HTMLElement) => import("..").Styles);
        overlayClassName: import("..").ClassName[];
        onVisibleChange: (visible: boolean, context: any) => void;
        attach?: import("..").AttachNode;
        content?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
        default?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
        delay?: number | number[];
        destroyOnClose?: boolean;
        disabled?: boolean;
        hideEmptyPopup?: boolean;
        overlayInnerClassName?: import("..").ClassName;
        overlayStyle?: import("..").Styles | ((triggerElement: HTMLElement, popupElement: HTMLElement) => import("..").Styles);
        placement?: import("..").PopupPlacement;
        popperOptions?: object;
        showArrow?: boolean;
        triggerElement?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
        visible?: boolean;
        defaultVisible?: boolean;
        zIndex?: number;
        onScroll?: (context: {
            e: WheelEvent;
        }) => void;
        onScrollToBottom?: (context: {
            e: WheelEvent;
        }) => void;
        expandAnimation: boolean;
    }>;
    datePickerInputProps: import("@vue/composition-api").ComputedRef<import("..").TdInputProps<import("..").InputValue> | {
        ref: import("@vue/composition-api").Ref<any>;
        borderless: boolean;
        size: import("..").SizeEnum;
        prefixIcon: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
        class: {
            [x: string]: boolean;
        }[];
        onClear: (context: {
            e: InputEvent;
        }) => void;
        onBlur: (val: string, context: {
            e: FocusEvent;
        }) => void;
        onFocus: (_: string, { e }: {
            e: FocusEvent;
        }) => void;
        onChange: (val: string) => void;
        onEnter: (val: string) => void;
        align?: "center" | "left" | "right";
        allowInputOverMax?: boolean;
        autoWidth?: boolean;
        autocomplete?: string;
        autofocus?: boolean;
        clearable?: boolean;
        disabled?: boolean;
        format?: import("..").InputFormatType;
        inputClass?: import("..").ClassName;
        label?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
        maxcharacter?: number;
        maxlength?: string | number;
        name?: string;
        placeholder?: string;
        readonly?: boolean;
        showClearIconOnEmpty?: boolean;
        showLimitNumber?: boolean;
        spellCheck?: boolean;
        status?: "error" | "default" | "success" | "warning";
        suffix?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
        suffixIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
        tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
        type?: "number" | "search" | "password" | "url" | "hidden" | "text" | "submit" | "tel";
        value?: import("..").InputValue;
        defaultValue?: import("..").InputValue;
        onClick?: (context: {
            e: MouseEvent;
        }) => void;
        onCompositionend?: (value: string, context: {
            e: CompositionEvent;
        }) => void;
        onCompositionstart?: (value: string, context: {
            e: CompositionEvent;
        }) => void;
        onKeydown?: (value: import("..").InputValue, context: {
            e: KeyboardEvent;
        }) => void;
        onKeypress?: (value: import("..").InputValue, context: {
            e: KeyboardEvent;
        }) => void;
        onKeyup?: (value: import("..").InputValue, context: {
            e: KeyboardEvent;
        }) => void;
        onMouseenter?: (context: {
            e: MouseEvent;
        }) => void;
        onMouseleave?: (context: {
            e: MouseEvent;
        }) => void;
        onPaste?: (context: {
            e: ClipboardEvent;
            pasteValue: string;
        }) => void;
        onValidate?: (context: {
            error?: "exceed-maximum" | "below-minimum";
        }) => void;
        onWheel?: (context: {
            e: WheelEvent;
        }) => void;
    }>;
    popupVisible: import("@vue/composition-api").Ref<boolean>;
    panelProps: any;
    isDisabled: import("@vue/composition-api").ComputedRef<boolean>;
    onTagRemoveClick: (ctx: TagInputRemoveContext) => void;
    onTagClearClick: ({ e }: {
        e: MouseEvent;
    }) => void;
    CalendarIcon: import("tdesign-icons-vue").GlobalIconType;
    global: import("@vue/composition-api").ComputedRef<{} & (import("..").DatePickerConfig | ({
        readonly firstDayOfWeek: 1;
    } & {
        readonly dayjsLocale: "zh-cn";
        readonly placeholder: {
            readonly date: "请选择日期";
            readonly month: "请选择月份";
            readonly year: "请选择年份";
            readonly quarter: "请选择季度";
            readonly week: "请选择周";
        };
        readonly weekdays: readonly ["一", "二", "三", "四", "五", "六", "日"];
        readonly months: readonly ["1 月", "2 月", "3 月", "4 月", "5 月", "6 月", "7 月", "8 月", "9 月", "10 月", "11 月", "12 月"];
        readonly quarters: readonly ["一季度", "二季度", "三季度", "四季度"];
        readonly rangeSeparator: " - ";
        readonly direction: "ltr";
        readonly format: "YYYY-MM-DD";
        readonly dayAriaLabel: "日";
        readonly weekAbbreviation: "周";
        readonly yearAriaLabel: "年";
        readonly monthAriaLabel: "月";
        readonly confirm: "确定";
        readonly selectTime: "选择时间";
        readonly selectDate: "选择日期";
        readonly nextYear: "下一年";
        readonly preYear: "上一年";
        readonly nextMonth: "下个月";
        readonly preMonth: "上个月";
        readonly preDecade: "上个十年";
        readonly nextDecade: "下个十年";
        readonly now: "当前";
    })) & import("..").DatePickerConfig>;
}> & import("@vue/composition-api").Data, {}, {}, {
    allowInput: BooleanConstructor;
    borderless: BooleanConstructor;
    clearable: BooleanConstructor;
    defaultTime: {
        type: StringConstructor;
        default: string;
    };
    disableDate: {
        type: import("vue").PropType<import("./type").DisableDate>;
    };
    disableTime: {
        type: import("vue").PropType<(time: Date) => Partial<{
            hour: number[];
            minute: number[];
            second: number[];
            millisecond: number[];
        }>>;
    };
    disabled: BooleanConstructor;
    readonly: {
        type: BooleanConstructor;
        default: any;
    };
    enableTimePicker: BooleanConstructor;
    firstDayOfWeek: {
        type: NumberConstructor;
        validator(val: number): boolean;
    };
    format: {
        type: StringConstructor;
        default: any;
    };
    inputProps: {
        type: import("vue").PropType<import("..").InputProps<import("..").InputValue>>;
    };
    label: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    mode: {
        type: import("vue").PropType<"month" | "year" | "quarter" | "week" | "date">;
        default: "month" | "year" | "quarter" | "week" | "date";
        validator(val: "month" | "year" | "quarter" | "week" | "date"): boolean;
    };
    multiple: BooleanConstructor;
    placeholder: {
        type: import("vue").PropType<string>;
        default: any;
    };
    popupProps: {
        type: import("vue").PropType<import("..").TdPopupProps>;
    };
    prefixIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    presets: {
        type: import("vue").PropType<import("./type").PresetDate>;
    };
    presetsPlacement: {
        type: import("vue").PropType<"left" | "top" | "bottom" | "right">;
        default: "left" | "top" | "bottom" | "right";
        validator(val: "left" | "top" | "bottom" | "right"): boolean;
    };
    size: {
        type: import("vue").PropType<import("..").SizeEnum>;
        default: import("..").SizeEnum;
        validator(val: import("..").SizeEnum): boolean;
    };
    status: {
        type: import("vue").PropType<"error" | "default" | "success" | "warning">;
        default: "error" | "default" | "success" | "warning";
        validator(val: "error" | "default" | "success" | "warning"): boolean;
    };
    suffixIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    timePickerProps: {
        type: import("vue").PropType<import("..").TdTimePickerProps>;
    };
    tips: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    value: {
        type: import("vue").PropType<DateValue | DateMultipleValue>;
        default: string;
    };
    defaultValue: {
        type: import("vue").PropType<DateValue | DateMultipleValue>;
        default: string;
    };
    valueType: {
        type: import("vue").PropType<import("./type").DatePickerValueType>;
        default: string;
    };
    onBlur: import("vue").PropType<(context: {
        value: DateValue | DateMultipleValue;
        e: FocusEvent;
    }) => void>;
    onChange: import("vue").PropType<(value: DateValue | DateMultipleValue, context: {
        dayjsValue?: dayjs.Dayjs;
        trigger?: import("./type").DatePickerTriggerSource;
    }) => void>;
    onConfirm: import("vue").PropType<(context: {
        date: Date;
        e: MouseEvent;
    }) => void>;
    onFocus: import("vue").PropType<(context: {
        value: DateValue | DateMultipleValue;
        e: FocusEvent;
    }) => void>;
    onPick: import("vue").PropType<(value: DateValue) => void>;
    onPresetClick: import("vue").PropType<(context: {
        preset: import("./type").PresetDate;
        e: MouseEvent;
    }) => void>;
}, import("@vue/composition-api").ExtractPropTypes<{
    allowInput: BooleanConstructor;
    borderless: BooleanConstructor;
    clearable: BooleanConstructor;
    defaultTime: {
        type: StringConstructor;
        default: string;
    };
    disableDate: {
        type: import("vue").PropType<import("./type").DisableDate>;
    };
    disableTime: {
        type: import("vue").PropType<(time: Date) => Partial<{
            hour: number[];
            minute: number[];
            second: number[];
            millisecond: number[];
        }>>;
    };
    disabled: BooleanConstructor;
    readonly: {
        type: BooleanConstructor;
        default: any;
    };
    enableTimePicker: BooleanConstructor;
    firstDayOfWeek: {
        type: NumberConstructor;
        validator(val: number): boolean;
    };
    format: {
        type: StringConstructor;
        default: any;
    };
    inputProps: {
        type: import("vue").PropType<import("..").InputProps<import("..").InputValue>>;
    };
    label: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    mode: {
        type: import("vue").PropType<"month" | "year" | "quarter" | "week" | "date">;
        default: "month" | "year" | "quarter" | "week" | "date";
        validator(val: "month" | "year" | "quarter" | "week" | "date"): boolean;
    };
    multiple: BooleanConstructor;
    placeholder: {
        type: import("vue").PropType<string>;
        default: any;
    };
    popupProps: {
        type: import("vue").PropType<import("..").TdPopupProps>;
    };
    prefixIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    presets: {
        type: import("vue").PropType<import("./type").PresetDate>;
    };
    presetsPlacement: {
        type: import("vue").PropType<"left" | "top" | "bottom" | "right">;
        default: "left" | "top" | "bottom" | "right";
        validator(val: "left" | "top" | "bottom" | "right"): boolean;
    };
    size: {
        type: import("vue").PropType<import("..").SizeEnum>;
        default: import("..").SizeEnum;
        validator(val: import("..").SizeEnum): boolean;
    };
    status: {
        type: import("vue").PropType<"error" | "default" | "success" | "warning">;
        default: "error" | "default" | "success" | "warning";
        validator(val: "error" | "default" | "success" | "warning"): boolean;
    };
    suffixIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    timePickerProps: {
        type: import("vue").PropType<import("..").TdTimePickerProps>;
    };
    tips: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    value: {
        type: import("vue").PropType<DateValue | DateMultipleValue>;
        default: string;
    };
    defaultValue: {
        type: import("vue").PropType<DateValue | DateMultipleValue>;
        default: string;
    };
    valueType: {
        type: import("vue").PropType<import("./type").DatePickerValueType>;
        default: string;
    };
    onBlur: import("vue").PropType<(context: {
        value: DateValue | DateMultipleValue;
        e: FocusEvent;
    }) => void>;
    onChange: import("vue").PropType<(value: DateValue | DateMultipleValue, context: {
        dayjsValue?: dayjs.Dayjs;
        trigger?: import("./type").DatePickerTriggerSource;
    }) => void>;
    onConfirm: import("vue").PropType<(context: {
        date: Date;
        e: MouseEvent;
    }) => void>;
    onFocus: import("vue").PropType<(context: {
        value: DateValue | DateMultipleValue;
        e: FocusEvent;
    }) => void>;
    onPick: import("vue").PropType<(value: DateValue) => void>;
    onPresetClick: import("vue").PropType<(context: {
        preset: import("./type").PresetDate;
        e: MouseEvent;
    }) => void>;
}>> & Omit<import("vue").VueConstructor<import("vue").default>, never> & (new (...args: any[]) => import("@vue/composition-api").ComponentRenderProxy<{
    value: DateValue | DateMultipleValue;
    disabled: boolean;
    multiple: boolean;
    size: import("..").SizeEnum;
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    defaultValue: DateValue | DateMultipleValue;
    format: string;
    borderless: boolean;
    clearable: boolean;
    placeholder: string;
    allowInput: boolean;
    valueType: import("./type").DatePickerValueType;
    mode: "month" | "year" | "quarter" | "week" | "date";
    enableTimePicker: boolean;
    presetsPlacement: "left" | "top" | "bottom" | "right";
    defaultTime: string;
} & {
    label?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onChange?: (value: DateValue | DateMultipleValue, context: {
        dayjsValue?: dayjs.Dayjs;
        trigger?: import("./type").DatePickerTriggerSource;
    }) => void;
    prefixIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    suffixIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onBlur?: (context: {
        value: DateValue | DateMultipleValue;
        e: FocusEvent;
    }) => void;
    onFocus?: (context: {
        value: DateValue | DateMultipleValue;
        e: FocusEvent;
    }) => void;
    inputProps?: unknown;
    popupProps?: unknown;
    firstDayOfWeek?: number;
    disableTime?: (time: Date) => Partial<{
        hour: number[];
        minute: number[];
        second: number[];
        millisecond: number[];
    }>;
    presets?: import("./type").PresetDate;
    onPick?: (value: DateValue) => void;
    disableDate?: unknown;
    timePickerProps?: unknown;
    onConfirm?: (context: {
        date: Date;
        e: MouseEvent;
    }) => void;
    onPresetClick?: (context: {
        preset: import("./type").PresetDate;
        e: MouseEvent;
    }) => void;
}, import("@vue/composition-api").ShallowUnwrapRef<{
    COMPONENT_NAME: import("@vue/composition-api").ComputedRef<string>;
    inputValue: import("@vue/composition-api").Ref<string | number | string[] | number[] | Date | Date[]>;
    datePickerPopupProps: import("@vue/composition-api").ComputedRef<{
        trigger: string;
        overlayInnerStyle: import("..").Styles | ((triggerElement: HTMLElement, popupElement: HTMLElement) => import("..").Styles);
        overlayClassName: import("..").ClassName[];
        onVisibleChange: (visible: boolean, context: any) => void;
        attach?: import("..").AttachNode;
        content?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
        default?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
        delay?: number | number[];
        destroyOnClose?: boolean;
        disabled?: boolean;
        hideEmptyPopup?: boolean;
        overlayInnerClassName?: import("..").ClassName;
        overlayStyle?: import("..").Styles | ((triggerElement: HTMLElement, popupElement: HTMLElement) => import("..").Styles);
        placement?: import("..").PopupPlacement;
        popperOptions?: object;
        showArrow?: boolean;
        triggerElement?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
        visible?: boolean;
        defaultVisible?: boolean;
        zIndex?: number;
        onScroll?: (context: {
            e: WheelEvent;
        }) => void;
        onScrollToBottom?: (context: {
            e: WheelEvent;
        }) => void;
        expandAnimation: boolean;
    }>;
    datePickerInputProps: import("@vue/composition-api").ComputedRef<import("..").TdInputProps<import("..").InputValue> | {
        ref: import("@vue/composition-api").Ref<any>;
        borderless: boolean;
        size: import("..").SizeEnum;
        prefixIcon: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
        class: {
            [x: string]: boolean;
        }[];
        onClear: (context: {
            e: InputEvent;
        }) => void;
        onBlur: (val: string, context: {
            e: FocusEvent;
        }) => void;
        onFocus: (_: string, { e }: {
            e: FocusEvent;
        }) => void;
        onChange: (val: string) => void;
        onEnter: (val: string) => void;
        align?: "center" | "left" | "right";
        allowInputOverMax?: boolean;
        autoWidth?: boolean;
        autocomplete?: string;
        autofocus?: boolean;
        clearable?: boolean;
        disabled?: boolean;
        format?: import("..").InputFormatType;
        inputClass?: import("..").ClassName;
        label?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
        maxcharacter?: number;
        maxlength?: string | number;
        name?: string;
        placeholder?: string;
        readonly?: boolean;
        showClearIconOnEmpty?: boolean;
        showLimitNumber?: boolean;
        spellCheck?: boolean;
        status?: "error" | "default" | "success" | "warning";
        suffix?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
        suffixIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
        tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
        type?: "number" | "search" | "password" | "url" | "hidden" | "text" | "submit" | "tel";
        value?: import("..").InputValue;
        defaultValue?: import("..").InputValue;
        onClick?: (context: {
            e: MouseEvent;
        }) => void;
        onCompositionend?: (value: string, context: {
            e: CompositionEvent;
        }) => void;
        onCompositionstart?: (value: string, context: {
            e: CompositionEvent;
        }) => void;
        onKeydown?: (value: import("..").InputValue, context: {
            e: KeyboardEvent;
        }) => void;
        onKeypress?: (value: import("..").InputValue, context: {
            e: KeyboardEvent;
        }) => void;
        onKeyup?: (value: import("..").InputValue, context: {
            e: KeyboardEvent;
        }) => void;
        onMouseenter?: (context: {
            e: MouseEvent;
        }) => void;
        onMouseleave?: (context: {
            e: MouseEvent;
        }) => void;
        onPaste?: (context: {
            e: ClipboardEvent;
            pasteValue: string;
        }) => void;
        onValidate?: (context: {
            error?: "exceed-maximum" | "below-minimum";
        }) => void;
        onWheel?: (context: {
            e: WheelEvent;
        }) => void;
    }>;
    popupVisible: import("@vue/composition-api").Ref<boolean>;
    panelProps: any;
    isDisabled: import("@vue/composition-api").ComputedRef<boolean>;
    onTagRemoveClick: (ctx: TagInputRemoveContext) => void;
    onTagClearClick: ({ e }: {
        e: MouseEvent;
    }) => void;
    CalendarIcon: import("tdesign-icons-vue").GlobalIconType;
    global: import("@vue/composition-api").ComputedRef<{} & (import("..").DatePickerConfig | ({
        readonly firstDayOfWeek: 1;
    } & {
        readonly dayjsLocale: "zh-cn";
        readonly placeholder: {
            readonly date: "请选择日期";
            readonly month: "请选择月份";
            readonly year: "请选择年份";
            readonly quarter: "请选择季度";
            readonly week: "请选择周";
        };
        readonly weekdays: readonly ["一", "二", "三", "四", "五", "六", "日"];
        readonly months: readonly ["1 月", "2 月", "3 月", "4 月", "5 月", "6 月", "7 月", "8 月", "9 月", "10 月", "11 月", "12 月"];
        readonly quarters: readonly ["一季度", "二季度", "三季度", "四季度"];
        readonly rangeSeparator: " - ";
        readonly direction: "ltr";
        readonly format: "YYYY-MM-DD";
        readonly dayAriaLabel: "日";
        readonly weekAbbreviation: "周";
        readonly yearAriaLabel: "年";
        readonly monthAriaLabel: "月";
        readonly confirm: "确定";
        readonly selectTime: "选择时间";
        readonly selectDate: "选择日期";
        readonly nextYear: "下一年";
        readonly preYear: "上一年";
        readonly nextMonth: "下个月";
        readonly preMonth: "上个月";
        readonly preDecade: "上个十年";
        readonly nextDecade: "下个十年";
        readonly now: "当前";
    })) & import("..").DatePickerConfig>;
}>, import("@vue/composition-api").Data, {}, {}, {}, {}, {}, {
    value: DateValue | DateMultipleValue;
    disabled: boolean;
    multiple: boolean;
    size: import("..").SizeEnum;
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    defaultValue: DateValue | DateMultipleValue;
    format: string;
    borderless: boolean;
    clearable: boolean;
    placeholder: string;
    allowInput: boolean;
    valueType: import("./type").DatePickerValueType;
    mode: "month" | "year" | "quarter" | "week" | "date";
    enableTimePicker: boolean;
    presetsPlacement: "left" | "top" | "bottom" | "right";
    defaultTime: string;
} & {
    label?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onChange?: (value: DateValue | DateMultipleValue, context: {
        dayjsValue?: dayjs.Dayjs;
        trigger?: import("./type").DatePickerTriggerSource;
    }) => void;
    prefixIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    suffixIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onBlur?: (context: {
        value: DateValue | DateMultipleValue;
        e: FocusEvent;
    }) => void;
    onFocus?: (context: {
        value: DateValue | DateMultipleValue;
        e: FocusEvent;
    }) => void;
    inputProps?: unknown;
    popupProps?: unknown;
    firstDayOfWeek?: number;
    disableTime?: (time: Date) => Partial<{
        hour: number[];
        minute: number[];
        second: number[];
        millisecond: number[];
    }>;
    presets?: import("./type").PresetDate;
    onPick?: (value: DateValue) => void;
    disableDate?: unknown;
    timePickerProps?: unknown;
    onConfirm?: (context: {
        date: Date;
        e: MouseEvent;
    }) => void;
    onPresetClick?: (context: {
        preset: import("./type").PresetDate;
        e: MouseEvent;
    }) => void;
}, {
    value: DateValue | DateMultipleValue;
    disabled: boolean;
    multiple: boolean;
    size: import("..").SizeEnum;
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    defaultValue: DateValue | DateMultipleValue;
    format: string;
    borderless: boolean;
    clearable: boolean;
    placeholder: string;
    allowInput: boolean;
    valueType: import("./type").DatePickerValueType;
    mode: "month" | "year" | "quarter" | "week" | "date";
    enableTimePicker: boolean;
    presetsPlacement: "left" | "top" | "bottom" | "right";
    defaultTime: string;
}, true>);
export default _default;
