import dayjs from 'dayjs';
import { DateValue, DateRangePickerPartial } from './type';
declare const _default: import("vue").ComponentOptions<import("vue").default, import("@vue/composition-api").ShallowUnwrapRef<{
    COMPONENT_NAME: import("@vue/composition-api").ComputedRef<string>;
    inputValue: import("@vue/composition-api").Ref<string | number | string[] | number[] | Date | Date[]>;
    dateRangePickerPopupProps: import("@vue/composition-api").ComputedRef<{
        overlayInnerStyle: import("..").Styles | ((triggerElement: HTMLElement, popupElement: HTMLElement) => import("..").Styles);
        overlayClassName: import("..").ClassName[];
        onVisibleChange: (visible: boolean, context: any) => void;
        attach?: import("..").AttachNode;
        content?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
        default?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
        delay?: number | number[];
        destroyOnClose?: boolean;
        disabled?: boolean;
        hideEmptyPopup?: boolean;
        overlayInnerClassName?: import("..").ClassName;
        overlayStyle?: import("..").Styles | ((triggerElement: HTMLElement, popupElement: HTMLElement) => import("..").Styles);
        placement?: import("..").PopupPlacement;
        popperOptions?: object;
        showArrow?: boolean;
        trigger?: "click" | "focus" | "mousedown" | "hover" | "context-menu";
        triggerElement?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
        visible?: boolean;
        defaultVisible?: boolean;
        zIndex?: number;
        onScroll?: (context: {
            e: WheelEvent;
        }) => void;
        onScrollToBottom?: (context: {
            e: WheelEvent;
        }) => void;
        expandAnimation: boolean;
    }>;
    dateRangePickerRangeInputProps: import("@vue/composition-api").ComputedRef<{
        ref: import("@vue/composition-api").Ref<any>;
        borderless: boolean;
        size: import("..").SizeEnum;
        clearable: boolean;
        prefixIcon: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
        readonly: true | Boolean;
        separator: string;
        placeholder: any;
        activeIndex: number;
        class: {
            [x: string]: boolean;
        };
        onClick: ({ position }: any) => void;
        onClear: ({ e }: {
            e: MouseEvent;
        }) => void;
        onBlur: (newVal: string[], { e, position }: any) => void;
        onFocus: (newVal: string[], { e, position }: any) => void;
        onChange: (newVal: string[]) => void;
        onEnter: (newVal: string[]) => void;
        disabled?: boolean;
        format?: import("..").InputFormatType | import("..").InputFormatType[];
        inputProps?: import("..").InputProps<import("..").InputValue> | import("..").InputProps<import("..").InputValue>[];
        label?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
        showClearIconOnEmpty?: boolean;
        status?: "error" | "default" | "success" | "warning";
        suffix?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
        suffixIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
        tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
        value?: import("../range-input").RangeInputValue;
        defaultValue?: import("../range-input").RangeInputValue;
        onMouseenter?: (context: {
            e: MouseEvent;
        }) => void;
        onMouseleave?: (context: {
            e: MouseEvent;
        }) => void;
    }>;
    popupVisible: import("@vue/composition-api").Ref<boolean>;
    panelProps: any;
    CalendarIcon: import("tdesign-icons-vue").GlobalIconType;
    isDisabled: import("@vue/composition-api").ComputedRef<boolean>;
}> & import("@vue/composition-api").Data, {}, {}, {
    allowInput: BooleanConstructor;
    borderless: BooleanConstructor;
    clearable: BooleanConstructor;
    defaultTime: {
        type: import("vue").PropType<string[]>;
        default: () => string[];
    };
    disableDate: {
        type: import("vue").PropType<import("./type").DisableRangeDate>;
    };
    disableTime: {
        type: import("vue").PropType<(times: Date[], context: {
            partial: DateRangePickerPartial;
        }) => Partial<{
            hour: number[];
            minute: number[];
            second: number[];
        }>>;
    };
    disabled: BooleanConstructor;
    readonly: {
        type: BooleanConstructor;
        default: any;
    };
    enableTimePicker: BooleanConstructor;
    firstDayOfWeek: {
        type: NumberConstructor;
        validator(val: number): boolean;
    };
    format: {
        type: StringConstructor;
        default: string;
    };
    label: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    mode: {
        type: import("vue").PropType<"month" | "year" | "quarter" | "week" | "date">;
        default: "month" | "year" | "quarter" | "week" | "date";
        validator(val: "month" | "year" | "quarter" | "week" | "date"): boolean;
    };
    panelPreselection: {
        type: BooleanConstructor;
        default: boolean;
    };
    placeholder: {
        type: import("vue").PropType<string | string[]>;
    };
    popupProps: {
        type: import("vue").PropType<import("..").TdPopupProps>;
    };
    prefixIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    presets: {
        type: import("vue").PropType<import("./type").PresetRange>;
    };
    presetsPlacement: {
        type: import("vue").PropType<"left" | "top" | "bottom" | "right">;
        default: "left" | "top" | "bottom" | "right";
        validator(val: "left" | "top" | "bottom" | "right"): boolean;
    };
    rangeInputProps: {
        type: import("vue").PropType<import("../range-input").TdRangeInputProps>;
    };
    separator: {
        type: StringConstructor;
        default: string;
    };
    size: {
        type: import("vue").PropType<import("..").SizeEnum>;
        default: import("..").SizeEnum;
        validator(val: import("..").SizeEnum): boolean;
    };
    status: {
        type: import("vue").PropType<"error" | "default" | "success" | "warning">;
        default: "error" | "default" | "success" | "warning";
        validator(val: "error" | "default" | "success" | "warning"): boolean;
    };
    suffixIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    timePickerProps: {
        type: import("vue").PropType<import("..").TdTimePickerProps>;
    };
    tips: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    value: {
        type: import("vue").PropType<import("./type").DateRangeValue>;
        default: () => import("./type").DateRangeValue;
    };
    defaultValue: {
        type: import("vue").PropType<import("./type").DateRangeValue>;
        default: () => import("./type").DateRangeValue;
    };
    valueType: {
        type: import("vue").PropType<"YYYY-MM-DD" | "Date" | "time-stamp" | "YYYY" | "YYYY-MM" | "YYYY-MM-DD HH" | "YYYY-MM-DD HH:mm" | "YYYY-MM-DD HH:mm:ss" | "YYYY-MM-DD HH:mm:ss:SSS">;
        validator(val: "YYYY-MM-DD" | "Date" | "time-stamp" | "YYYY" | "YYYY-MM" | "YYYY-MM-DD HH" | "YYYY-MM-DD HH:mm" | "YYYY-MM-DD HH:mm:ss" | "YYYY-MM-DD HH:mm:ss:SSS"): boolean;
    };
    cancelRangeSelectLimit: {
        type: BooleanConstructor;
        default: boolean;
    };
    onBlur: import("vue").PropType<(context: {
        value: import("./type").DateRangeValue;
        partial: DateRangePickerPartial;
        e: FocusEvent;
    }) => void>;
    onChange: import("vue").PropType<(value: import("./type").DateRangeValue, context: {
        dayjsValue?: dayjs.Dayjs[];
        trigger?: import("./type").DatePickerTriggerSource;
    }) => void>;
    onConfirm: import("vue").PropType<(context: {
        date: Date[];
        e: MouseEvent;
        partial: DateRangePickerPartial;
    }) => void>;
    onFocus: import("vue").PropType<(context: {
        value: import("./type").DateRangeValue;
        partial: DateRangePickerPartial;
        e: FocusEvent;
    }) => void>;
    onInput: import("vue").PropType<(context: {
        input: string;
        value: import("./type").DateRangeValue;
        partial: DateRangePickerPartial;
        e: InputEvent;
    }) => void>;
    onPick: import("vue").PropType<(value: DateValue, context: import("./type").PickContext) => void>;
    onPresetClick: import("vue").PropType<(context: {
        preset: import("./type").PresetDate;
        e: MouseEvent;
    }) => void>;
}, import("@vue/composition-api").ExtractPropTypes<{
    allowInput: BooleanConstructor;
    borderless: BooleanConstructor;
    clearable: BooleanConstructor;
    defaultTime: {
        type: import("vue").PropType<string[]>;
        default: () => string[];
    };
    disableDate: {
        type: import("vue").PropType<import("./type").DisableRangeDate>;
    };
    disableTime: {
        type: import("vue").PropType<(times: Date[], context: {
            partial: DateRangePickerPartial;
        }) => Partial<{
            hour: number[];
            minute: number[];
            second: number[];
        }>>;
    };
    disabled: BooleanConstructor;
    readonly: {
        type: BooleanConstructor;
        default: any;
    };
    enableTimePicker: BooleanConstructor;
    firstDayOfWeek: {
        type: NumberConstructor;
        validator(val: number): boolean;
    };
    format: {
        type: StringConstructor;
        default: string;
    };
    label: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    mode: {
        type: import("vue").PropType<"month" | "year" | "quarter" | "week" | "date">;
        default: "month" | "year" | "quarter" | "week" | "date";
        validator(val: "month" | "year" | "quarter" | "week" | "date"): boolean;
    };
    panelPreselection: {
        type: BooleanConstructor;
        default: boolean;
    };
    placeholder: {
        type: import("vue").PropType<string | string[]>;
    };
    popupProps: {
        type: import("vue").PropType<import("..").TdPopupProps>;
    };
    prefixIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    presets: {
        type: import("vue").PropType<import("./type").PresetRange>;
    };
    presetsPlacement: {
        type: import("vue").PropType<"left" | "top" | "bottom" | "right">;
        default: "left" | "top" | "bottom" | "right";
        validator(val: "left" | "top" | "bottom" | "right"): boolean;
    };
    rangeInputProps: {
        type: import("vue").PropType<import("../range-input").TdRangeInputProps>;
    };
    separator: {
        type: StringConstructor;
        default: string;
    };
    size: {
        type: import("vue").PropType<import("..").SizeEnum>;
        default: import("..").SizeEnum;
        validator(val: import("..").SizeEnum): boolean;
    };
    status: {
        type: import("vue").PropType<"error" | "default" | "success" | "warning">;
        default: "error" | "default" | "success" | "warning";
        validator(val: "error" | "default" | "success" | "warning"): boolean;
    };
    suffixIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    timePickerProps: {
        type: import("vue").PropType<import("..").TdTimePickerProps>;
    };
    tips: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    value: {
        type: import("vue").PropType<import("./type").DateRangeValue>;
        default: () => import("./type").DateRangeValue;
    };
    defaultValue: {
        type: import("vue").PropType<import("./type").DateRangeValue>;
        default: () => import("./type").DateRangeValue;
    };
    valueType: {
        type: import("vue").PropType<"YYYY-MM-DD" | "Date" | "time-stamp" | "YYYY" | "YYYY-MM" | "YYYY-MM-DD HH" | "YYYY-MM-DD HH:mm" | "YYYY-MM-DD HH:mm:ss" | "YYYY-MM-DD HH:mm:ss:SSS">;
        validator(val: "YYYY-MM-DD" | "Date" | "time-stamp" | "YYYY" | "YYYY-MM" | "YYYY-MM-DD HH" | "YYYY-MM-DD HH:mm" | "YYYY-MM-DD HH:mm:ss" | "YYYY-MM-DD HH:mm:ss:SSS"): boolean;
    };
    cancelRangeSelectLimit: {
        type: BooleanConstructor;
        default: boolean;
    };
    onBlur: import("vue").PropType<(context: {
        value: import("./type").DateRangeValue;
        partial: DateRangePickerPartial;
        e: FocusEvent;
    }) => void>;
    onChange: import("vue").PropType<(value: import("./type").DateRangeValue, context: {
        dayjsValue?: dayjs.Dayjs[];
        trigger?: import("./type").DatePickerTriggerSource;
    }) => void>;
    onConfirm: import("vue").PropType<(context: {
        date: Date[];
        e: MouseEvent;
        partial: DateRangePickerPartial;
    }) => void>;
    onFocus: import("vue").PropType<(context: {
        value: import("./type").DateRangeValue;
        partial: DateRangePickerPartial;
        e: FocusEvent;
    }) => void>;
    onInput: import("vue").PropType<(context: {
        input: string;
        value: import("./type").DateRangeValue;
        partial: DateRangePickerPartial;
        e: InputEvent;
    }) => void>;
    onPick: import("vue").PropType<(value: DateValue, context: import("./type").PickContext) => void>;
    onPresetClick: import("vue").PropType<(context: {
        preset: import("./type").PresetDate;
        e: MouseEvent;
    }) => void>;
}>> & Omit<import("vue").VueConstructor<import("vue").default>, never> & (new (...args: any[]) => import("@vue/composition-api").ComponentRenderProxy<{
    value: import("./type").DateRangeValue;
    disabled: boolean;
    size: import("..").SizeEnum;
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    defaultValue: import("./type").DateRangeValue;
    format: string;
    borderless: boolean;
    clearable: boolean;
    allowInput: boolean;
    mode: "month" | "year" | "quarter" | "week" | "date";
    separator: string;
    enableTimePicker: boolean;
    presetsPlacement: "left" | "top" | "bottom" | "right";
    defaultTime: string[];
    cancelRangeSelectLimit: boolean;
    panelPreselection: boolean;
} & {
    label?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onChange?: (value: import("./type").DateRangeValue, context: {
        dayjsValue?: dayjs.Dayjs[];
        trigger?: import("./type").DatePickerTriggerSource;
    }) => void;
    prefixIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    suffixIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onBlur?: (context: {
        value: import("./type").DateRangeValue;
        partial: DateRangePickerPartial;
        e: FocusEvent;
    }) => void;
    onFocus?: (context: {
        value: import("./type").DateRangeValue;
        partial: DateRangePickerPartial;
        e: FocusEvent;
    }) => void;
    placeholder?: string | string[];
    popupProps?: unknown;
    valueType?: "YYYY-MM-DD" | "Date" | "time-stamp" | "YYYY" | "YYYY-MM" | "YYYY-MM-DD HH" | "YYYY-MM-DD HH:mm" | "YYYY-MM-DD HH:mm:ss" | "YYYY-MM-DD HH:mm:ss:SSS";
    firstDayOfWeek?: number;
    rangeInputProps?: unknown;
    disableTime?: (times: Date[], context: {
        partial: DateRangePickerPartial;
    }) => Partial<{
        hour: number[];
        minute: number[];
        second: number[];
    }>;
    presets?: import("./type").PresetRange;
    onInput?: (context: {
        input: string;
        value: import("./type").DateRangeValue;
        partial: DateRangePickerPartial;
        e: InputEvent;
    }) => void;
    onPick?: (value: DateValue, context: import("./type").PickContext) => void;
    disableDate?: unknown;
    timePickerProps?: unknown;
    onConfirm?: (context: {
        date: Date[];
        e: MouseEvent;
        partial: DateRangePickerPartial;
    }) => void;
    onPresetClick?: (context: {
        preset: import("./type").PresetDate;
        e: MouseEvent;
    }) => void;
}, import("@vue/composition-api").ShallowUnwrapRef<{
    COMPONENT_NAME: import("@vue/composition-api").ComputedRef<string>;
    inputValue: import("@vue/composition-api").Ref<string | number | string[] | number[] | Date | Date[]>;
    dateRangePickerPopupProps: import("@vue/composition-api").ComputedRef<{
        overlayInnerStyle: import("..").Styles | ((triggerElement: HTMLElement, popupElement: HTMLElement) => import("..").Styles);
        overlayClassName: import("..").ClassName[];
        onVisibleChange: (visible: boolean, context: any) => void;
        attach?: import("..").AttachNode;
        content?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
        default?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
        delay?: number | number[];
        destroyOnClose?: boolean;
        disabled?: boolean;
        hideEmptyPopup?: boolean;
        overlayInnerClassName?: import("..").ClassName;
        overlayStyle?: import("..").Styles | ((triggerElement: HTMLElement, popupElement: HTMLElement) => import("..").Styles);
        placement?: import("..").PopupPlacement;
        popperOptions?: object;
        showArrow?: boolean;
        trigger?: "click" | "focus" | "mousedown" | "hover" | "context-menu";
        triggerElement?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
        visible?: boolean;
        defaultVisible?: boolean;
        zIndex?: number;
        onScroll?: (context: {
            e: WheelEvent;
        }) => void;
        onScrollToBottom?: (context: {
            e: WheelEvent;
        }) => void;
        expandAnimation: boolean;
    }>;
    dateRangePickerRangeInputProps: import("@vue/composition-api").ComputedRef<{
        ref: import("@vue/composition-api").Ref<any>;
        borderless: boolean;
        size: import("..").SizeEnum;
        clearable: boolean;
        prefixIcon: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
        readonly: true | Boolean;
        separator: string;
        placeholder: any;
        activeIndex: number;
        class: {
            [x: string]: boolean;
        };
        onClick: ({ position }: any) => void;
        onClear: ({ e }: {
            e: MouseEvent;
        }) => void;
        onBlur: (newVal: string[], { e, position }: any) => void;
        onFocus: (newVal: string[], { e, position }: any) => void;
        onChange: (newVal: string[]) => void;
        onEnter: (newVal: string[]) => void;
        disabled?: boolean;
        format?: import("..").InputFormatType | import("..").InputFormatType[];
        inputProps?: import("..").InputProps<import("..").InputValue> | import("..").InputProps<import("..").InputValue>[];
        label?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
        showClearIconOnEmpty?: boolean;
        status?: "error" | "default" | "success" | "warning";
        suffix?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
        suffixIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
        tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
        value?: import("../range-input").RangeInputValue;
        defaultValue?: import("../range-input").RangeInputValue;
        onMouseenter?: (context: {
            e: MouseEvent;
        }) => void;
        onMouseleave?: (context: {
            e: MouseEvent;
        }) => void;
    }>;
    popupVisible: import("@vue/composition-api").Ref<boolean>;
    panelProps: any;
    CalendarIcon: import("tdesign-icons-vue").GlobalIconType;
    isDisabled: import("@vue/composition-api").ComputedRef<boolean>;
}>, import("@vue/composition-api").Data, {}, {}, {}, {}, {}, {
    value: import("./type").DateRangeValue;
    disabled: boolean;
    size: import("..").SizeEnum;
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    defaultValue: import("./type").DateRangeValue;
    format: string;
    borderless: boolean;
    clearable: boolean;
    allowInput: boolean;
    mode: "month" | "year" | "quarter" | "week" | "date";
    separator: string;
    enableTimePicker: boolean;
    presetsPlacement: "left" | "top" | "bottom" | "right";
    defaultTime: string[];
    cancelRangeSelectLimit: boolean;
    panelPreselection: boolean;
} & {
    label?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onChange?: (value: import("./type").DateRangeValue, context: {
        dayjsValue?: dayjs.Dayjs[];
        trigger?: import("./type").DatePickerTriggerSource;
    }) => void;
    prefixIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    suffixIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onBlur?: (context: {
        value: import("./type").DateRangeValue;
        partial: DateRangePickerPartial;
        e: FocusEvent;
    }) => void;
    onFocus?: (context: {
        value: import("./type").DateRangeValue;
        partial: DateRangePickerPartial;
        e: FocusEvent;
    }) => void;
    placeholder?: string | string[];
    popupProps?: unknown;
    valueType?: "YYYY-MM-DD" | "Date" | "time-stamp" | "YYYY" | "YYYY-MM" | "YYYY-MM-DD HH" | "YYYY-MM-DD HH:mm" | "YYYY-MM-DD HH:mm:ss" | "YYYY-MM-DD HH:mm:ss:SSS";
    firstDayOfWeek?: number;
    rangeInputProps?: unknown;
    disableTime?: (times: Date[], context: {
        partial: DateRangePickerPartial;
    }) => Partial<{
        hour: number[];
        minute: number[];
        second: number[];
    }>;
    presets?: import("./type").PresetRange;
    onInput?: (context: {
        input: string;
        value: import("./type").DateRangeValue;
        partial: DateRangePickerPartial;
        e: InputEvent;
    }) => void;
    onPick?: (value: DateValue, context: import("./type").PickContext) => void;
    disableDate?: unknown;
    timePickerProps?: unknown;
    onConfirm?: (context: {
        date: Date[];
        e: MouseEvent;
        partial: DateRangePickerPartial;
    }) => void;
    onPresetClick?: (context: {
        preset: import("./type").PresetDate;
        e: MouseEvent;
    }) => void;
}, {
    value: import("./type").DateRangeValue;
    disabled: boolean;
    size: import("..").SizeEnum;
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    defaultValue: import("./type").DateRangeValue;
    format: string;
    borderless: boolean;
    clearable: boolean;
    allowInput: boolean;
    mode: "month" | "year" | "quarter" | "week" | "date";
    separator: string;
    enableTimePicker: boolean;
    presetsPlacement: "left" | "top" | "bottom" | "right";
    defaultTime: string[];
    cancelRangeSelectLimit: boolean;
    panelPreselection: boolean;
}, true>);
export default _default;
