import { PropType } from '@vue/composition-api';
import { DateMultipleValue, DateValue } from '../type';
import { TdTimePickerProps } from '../../time-picker';
declare const _default: import("vue").ComponentOptions<import("vue").default, import("@vue/composition-api").ShallowUnwrapRef<{
    COMPONENT_NAME: import("@vue/composition-api").ComputedRef<string>;
    panelContentProps: import("@vue/composition-api").ComputedRef<{
        format: string;
        value: DateValue | DateMultipleValue | ((DateValue | DateMultipleValue) & object);
        mode: "month" | "year" | "quarter" | "week" | "date";
        year: number;
        month: number;
        firstDayOfWeek: number;
        tableData: any[];
        popupVisible: boolean;
        multiple: boolean;
        enableTimePicker: boolean;
        timePickerProps: {
            allowInput?: boolean;
            borderless?: boolean;
            clearable?: boolean;
            disableTime: (h: number, m: number, s: number, ms: number) => Partial<{
                hour: number[];
                minute: number[];
                second: number[];
                millisecond: number[];
            }>;
            disabled?: boolean;
            readonly?: boolean;
            format?: string;
            hideDisabledTime?: boolean;
            inputProps?: import("../..").InputProps<import("../..").InputValue>;
            placeholder?: string;
            popupProps?: import("../..").TdPopupProps;
            presets?: import("../../time-picker").PresetTime;
            size?: "small" | "medium" | "large";
            status?: "error" | "default" | "success" | "warning";
            steps?: (string | number)[];
            tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
            value?: string;
            defaultValue?: string;
            onBlur?: (context: {
                value: string;
                e: FocusEvent;
            }) => void;
            onChange?: (value: string) => void;
            onClose?: (context: {
                e: MouseEvent;
            }) => void;
            onFocus?: (context: {
                value: string;
                e: FocusEvent;
            }) => void;
            onInput?: (context: {
                value: string;
                e: InputEvent;
            }) => void;
            onOpen?: (context: {
                e: MouseEvent;
            }) => void;
            onPick?: (value: string, context: {
                e: MouseEvent;
            }) => void;
        };
        time: string;
        onMonthChange: Function;
        onYearChange: Function;
        onJumperClick: Function;
        onCellClick: Function;
        onCellMouseEnter: Function;
        onCellMouseLeave: Function;
        onTimePickerChange: Function;
    }>;
    extraProps: import("@vue/composition-api").ComputedRef<{
        presets: import("../type").PresetDate;
        enableTimePicker: boolean;
        presetsPlacement: "left" | "top" | "bottom" | "right";
        onPresetClick: Function;
        onConfirmClick: Function;
        selectedValue: DateValue | DateMultipleValue | ((DateValue | DateMultipleValue) & object);
    }>;
}> & import("@vue/composition-api").Data, {}, {}, {
    disableDate: PropType<import("../type").DisableDate>;
    disableTime: PropType<(time: Date) => Partial<{
        hour: number[];
        minute: number[];
        second: number[];
        millisecond: number[];
    }>>;
    mode: {
        type: PropType<"month" | "year" | "quarter" | "week" | "date">;
        default: string;
    };
    format: PropType<string>;
    presetsPlacement: {
        type: PropType<"left" | "top" | "bottom" | "right">;
        default: string;
    };
    value: PropType<DateValue | DateMultipleValue>;
    timePickerProps: PropType<TdTimePickerProps>;
    presets: PropType<import("../type").PresetDate>;
    enableTimePicker: BooleanConstructor;
    firstDayOfWeek: NumberConstructor;
    year: NumberConstructor;
    month: NumberConstructor;
    time: StringConstructor;
    popupVisible: BooleanConstructor;
    multiple: BooleanConstructor;
    onPanelClick: FunctionConstructor;
    onCellClick: FunctionConstructor;
    onCellMouseEnter: FunctionConstructor;
    onCellMouseLeave: FunctionConstructor;
    onJumperClick: FunctionConstructor;
    onConfirmClick: FunctionConstructor;
    onPresetClick: FunctionConstructor;
    onYearChange: FunctionConstructor;
    onMonthChange: FunctionConstructor;
    onTimePickerChange: FunctionConstructor;
}, import("@vue/composition-api").ExtractPropTypes<{
    disableDate: PropType<import("../type").DisableDate>;
    disableTime: PropType<(time: Date) => Partial<{
        hour: number[];
        minute: number[];
        second: number[];
        millisecond: number[];
    }>>;
    mode: {
        type: PropType<"month" | "year" | "quarter" | "week" | "date">;
        default: string;
    };
    format: PropType<string>;
    presetsPlacement: {
        type: PropType<"left" | "top" | "bottom" | "right">;
        default: string;
    };
    value: PropType<DateValue | DateMultipleValue>;
    timePickerProps: PropType<TdTimePickerProps>;
    presets: PropType<import("../type").PresetDate>;
    enableTimePicker: BooleanConstructor;
    firstDayOfWeek: NumberConstructor;
    year: NumberConstructor;
    month: NumberConstructor;
    time: StringConstructor;
    popupVisible: BooleanConstructor;
    multiple: BooleanConstructor;
    onPanelClick: FunctionConstructor;
    onCellClick: FunctionConstructor;
    onCellMouseEnter: FunctionConstructor;
    onCellMouseLeave: FunctionConstructor;
    onJumperClick: FunctionConstructor;
    onConfirmClick: FunctionConstructor;
    onPresetClick: FunctionConstructor;
    onYearChange: FunctionConstructor;
    onMonthChange: FunctionConstructor;
    onTimePickerChange: FunctionConstructor;
}>> & Omit<import("vue").VueConstructor<import("vue").default>, never> & (new (...args: any[]) => import("@vue/composition-api").ComponentRenderProxy<{
    multiple: boolean;
    popupVisible: boolean;
    mode: "month" | "year" | "quarter" | "week" | "date";
    enableTimePicker: boolean;
    presetsPlacement: "left" | "top" | "bottom" | "right";
} & {
    value?: DateValue | DateMultipleValue | ((DateValue | DateMultipleValue) & object);
    time?: string;
    month?: number;
    year?: number;
    format?: string;
    firstDayOfWeek?: number;
    onCellClick?: Function;
    onMonthChange?: Function;
    disableTime?: (time: Date) => Partial<{
        hour: number[];
        minute: number[];
        second: number[];
        millisecond: number[];
    }>;
    presets?: import("../type").PresetDate;
    disableDate?: unknown;
    timePickerProps?: unknown;
    onPanelClick?: Function;
    onPresetClick?: Function;
    onYearChange?: Function;
    onJumperClick?: Function;
    onCellMouseEnter?: Function;
    onCellMouseLeave?: Function;
    onTimePickerChange?: Function;
    onConfirmClick?: Function;
}, import("@vue/composition-api").ShallowUnwrapRef<{
    COMPONENT_NAME: import("@vue/composition-api").ComputedRef<string>;
    panelContentProps: import("@vue/composition-api").ComputedRef<{
        format: string;
        value: DateValue | DateMultipleValue | ((DateValue | DateMultipleValue) & object);
        mode: "month" | "year" | "quarter" | "week" | "date";
        year: number;
        month: number;
        firstDayOfWeek: number;
        tableData: any[];
        popupVisible: boolean;
        multiple: boolean;
        enableTimePicker: boolean;
        timePickerProps: {
            allowInput?: boolean;
            borderless?: boolean;
            clearable?: boolean;
            disableTime: (h: number, m: number, s: number, ms: number) => Partial<{
                hour: number[];
                minute: number[];
                second: number[];
                millisecond: number[];
            }>;
            disabled?: boolean;
            readonly?: boolean;
            format?: string;
            hideDisabledTime?: boolean;
            inputProps?: import("../..").InputProps<import("../..").InputValue>;
            placeholder?: string;
            popupProps?: import("../..").TdPopupProps;
            presets?: import("../../time-picker").PresetTime;
            size?: "small" | "medium" | "large";
            status?: "error" | "default" | "success" | "warning";
            steps?: (string | number)[];
            tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
            value?: string;
            defaultValue?: string;
            onBlur?: (context: {
                value: string;
                e: FocusEvent;
            }) => void;
            onChange?: (value: string) => void;
            onClose?: (context: {
                e: MouseEvent;
            }) => void;
            onFocus?: (context: {
                value: string;
                e: FocusEvent;
            }) => void;
            onInput?: (context: {
                value: string;
                e: InputEvent;
            }) => void;
            onOpen?: (context: {
                e: MouseEvent;
            }) => void;
            onPick?: (value: string, context: {
                e: MouseEvent;
            }) => void;
        };
        time: string;
        onMonthChange: Function;
        onYearChange: Function;
        onJumperClick: Function;
        onCellClick: Function;
        onCellMouseEnter: Function;
        onCellMouseLeave: Function;
        onTimePickerChange: Function;
    }>;
    extraProps: import("@vue/composition-api").ComputedRef<{
        presets: import("../type").PresetDate;
        enableTimePicker: boolean;
        presetsPlacement: "left" | "top" | "bottom" | "right";
        onPresetClick: Function;
        onConfirmClick: Function;
        selectedValue: DateValue | DateMultipleValue | ((DateValue | DateMultipleValue) & object);
    }>;
}>, import("@vue/composition-api").Data, {}, {}, {}, {}, {}, {
    multiple: boolean;
    popupVisible: boolean;
    mode: "month" | "year" | "quarter" | "week" | "date";
    enableTimePicker: boolean;
    presetsPlacement: "left" | "top" | "bottom" | "right";
} & {
    value?: DateValue | DateMultipleValue | ((DateValue | DateMultipleValue) & object);
    time?: string;
    month?: number;
    year?: number;
    format?: string;
    firstDayOfWeek?: number;
    onCellClick?: Function;
    onMonthChange?: Function;
    disableTime?: (time: Date) => Partial<{
        hour: number[];
        minute: number[];
        second: number[];
        millisecond: number[];
    }>;
    presets?: import("../type").PresetDate;
    disableDate?: unknown;
    timePickerProps?: unknown;
    onPanelClick?: Function;
    onPresetClick?: Function;
    onYearChange?: Function;
    onJumperClick?: Function;
    onCellMouseEnter?: Function;
    onCellMouseLeave?: Function;
    onTimePickerChange?: Function;
    onConfirmClick?: Function;
}, {
    multiple: boolean;
    popupVisible: boolean;
    mode: "month" | "year" | "quarter" | "week" | "date";
    enableTimePicker: boolean;
    presetsPlacement: "left" | "top" | "bottom" | "right";
}, true>);
export default _default;
