/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

import { computed, getCurrentInstance } from '@vue/composition-api';

function useFormDisabled() {
  var formDisabled = computed(function () {
    var currentInstance = getCurrentInstance();
    if (!currentInstance) return null;
    var parent = currentInstance.parent;
    while (parent) {
      if (parent.proxy.$options.name === "TForm") {
        return parent.props.disabled;
      }
      parent = parent.parent;
    }
    return false;
  });
  return {
    formDisabled: formDisabled
  };
}

export { useFormDisabled as default, useFormDisabled };
//# sourceMappingURL=useFormDisabled.js.map
