/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

import _ImageViewer from './image-viewer.js';
import { withInstall } from '../utils/withInstall.js';
import '@babel/runtime/helpers/slicedToArray';
import '@babel/runtime/helpers/defineProperty';
import '@vue/composition-api';
import 'tdesign-icons-vue';
import './props.js';
import './base/Container.js';
import 'vue';
import '../utils/dom.js';
import 'raf';
import 'lodash-es';
import '../utils/easing.js';
import './base/ImageModalIcon.js';
import '../hooks/useConfig.js';
import '../config-provider/useConfig.js';
import '../config-provider/context.js';
import '../_common/js/global-config/default-config.js';
import '../_common/js/global-config/locale/zh_CN.js';
import '../_chunks/dep-84fc5ae7.js';
import '@babel/runtime/helpers/typeof';
import '../_chunks/dep-eb45b5e0.js';
import 'dayjs';
import '../hooks/tnode.js';
import '../hooks/render-tnode.js';
import './base/ImageViewerUtils.js';
import '../tooltip/index.js';
import '../tooltip/tooltip.js';
import '../_chunks/dep-653f218a.js';
import '../tooltip/props.js';
import '../popup/props.js';
import '../popup/popup.js';
import '@popperjs/core';
import '../utils/render-tnode.js';
import '@babel/runtime/helpers/readOnlyError';
import '../utils/helper.js';
import '@babel/runtime/helpers/objectWithoutProperties';
import '../_common/js/utils/setStyle.js';
import '../popup/container.js';
import '../config-provider/config-receiver.js';
import '../utils/mixins.js';
import '../utils/event.js';
import '../popup/utils.js';
import '../utils/map-props.js';
import '../_common/js/input-number/large-number.js';
import '../_common/js/log/log.js';
import '../hooks/useImagePreviewUrl.js';
import '../_common/js/upload/utils.js';
import './base/ImageItem.js';
import './hooks.js';
import './const.js';
import './base/ImageViewerModal.js';
import '../dialog/index.js';
import '../dialog/dialog.js';
import '../button/index.js';
import '../button/button.js';
import '../loading/index.js';
import '../loading/directive.js';
import '../loading/plugin.js';
import '../loading/loading.js';
import '../loading/icon/gradient.js';
import '../_common/js/loading/circle-adapter.js';
import '../_common/js/utils/helper.js';
import '@babel/runtime/helpers/toConsumableArray';
import '../utils/transfer-dom.js';
import '../loading/props.js';
import '../config.js';
import '../button/props.js';
import '../utils/ripple.js';
import '../dialog/actions.js';
import '../dialog/props.js';
import '../hooks/useDestroyOnClose.js';
import '../dialog/stack.js';
import '../_common/js/utils/getScrollbarWidth.js';
import '../dialog/plugin.js';
import '../config-provider/config-provider.js';
import '../config-provider/props.js';
import '../hooks/useVModel.js';
import '../hooks/useDefaultValue.js';
import './utils.js';
import '../image/index.js';
import '../image/image.js';
import '../_common/js/utils/observe.js';
import '../image/props.js';
import '../space/index.js';
import '../space/space.js';
import '../space/props.js';

var ImageViewer = withInstall(_ImageViewer);

export { ImageViewer, ImageViewer as default };
//# sourceMappingURL=index.js.map
