/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

import VueCompositionAPI from '@vue/composition-api';
import _Menu from './menu.js';
import _HeadMenu from './head-menu.js';
import _Submenu from './submenu.js';
import _MenuItem from './menu-item.js';
import _MenuGroup from './menu-group.js';
import { withInstall } from '../utils/withInstall.js';
import mapProps from '../utils/map-props.js';
import '@babel/runtime/helpers/toConsumableArray';
import '@babel/runtime/helpers/defineProperty';
import './props.js';
import '../utils/render-tnode.js';
import '@babel/runtime/helpers/readOnlyError';
import '@babel/runtime/helpers/typeof';
import 'vue';
import 'lodash-es';
import './v-menu.js';
import '@babel/runtime/helpers/classCallCheck';
import '@babel/runtime/helpers/createClass';
import '../hooks/useConfig.js';
import '../config-provider/useConfig.js';
import '../config-provider/context.js';
import '../_common/js/global-config/default-config.js';
import '../_common/js/global-config/locale/zh_CN.js';
import '../_chunks/dep-84fc5ae7.js';
import '../_chunks/dep-eb45b5e0.js';
import 'dayjs';
import './head-menu-props.js';
import '../tabs/index.js';
import '../tabs/tabs.js';
import '../_chunks/dep-653f218a.js';
import '../utils/helper.js';
import '@babel/runtime/helpers/objectWithoutProperties';
import '@babel/runtime/helpers/slicedToArray';
import '../tabs/props.js';
import '../tabs/tab-panel.js';
import '../tabs/tab-panel-props.js';
import '../hooks/useDestroyOnClose.js';
import '../config-provider/config-receiver.js';
import '../utils/mixins.js';
import '../tabs/tab-nav.js';
import 'tdesign-icons-vue';
import '../tabs/tab-nav-item.js';
import '../utils/event.js';
import '../utils/ripple.js';
import '../_common/js/utils/setStyle.js';
import '../config.js';
import '../_common/js/tabs/base.js';
import './submenu-props.js';
import '../common-components/fake-arrow.js';
import '../popup/index.js';
import '../popup/popup.js';
import '@popperjs/core';
import '../utils/dom.js';
import 'raf';
import '../utils/easing.js';
import '../popup/props.js';
import '../popup/container.js';
import '../popup/utils.js';
import '../popup/plugin.js';
import '../_common/js/log/log.js';
import '../hooks/useCollapseAnimation.js';
import './menu-item-props.js';
import '../tooltip/index.js';
import '../tooltip/tooltip.js';
import '../tooltip/props.js';
import './menu-group-props.js';

var Menu = withInstall(mapProps([{
  name: "value",
  event: ["change", "update:value"]
}, {
  name: "expanded",
  event: ["expand", "update:expanded"]
}], {
  model: {
    prop: "value",
    event: "change"
  }
})(_Menu), VueCompositionAPI);
var HeadMenu = withInstall(mapProps([{
  name: "value",
  event: ["change", "update:value"]
}, {
  name: "expanded",
  event: ["expand", "update:expanded"]
}], {
  model: {
    prop: "value",
    event: "change"
  }
})(_HeadMenu), VueCompositionAPI);
var Submenu = withInstall(_Submenu, VueCompositionAPI);
var MenuItem = withInstall(_MenuItem, VueCompositionAPI);
var MenuGroup = withInstall(_MenuGroup, VueCompositionAPI);

export { HeadMenu, Menu, MenuGroup, MenuItem, Submenu };
//# sourceMappingURL=index.js.map
