/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

import { getClassPrefixMixins } from '../config-provider/config-receiver.js';
import mixins from '../utils/mixins.js';
import 'vue';
import 'lodash-es';
import '../config-provider/context.js';
import '../_common/js/global-config/default-config.js';
import '../_common/js/global-config/locale/zh_CN.js';
import '../_chunks/dep-84fc5ae7.js';
import '@babel/runtime/helpers/typeof';
import '../_chunks/dep-eb45b5e0.js';
import 'dayjs';

var classPrefixMixins = getClassPrefixMixins("slider");
var TSliderMark = mixins(classPrefixMixins).extend({
  name: "TSliderMark",
  props: {
    mark: {
      type: [Object, Array, String]
    },
    point: {
      type: Number
    }
  },
  methods: {
    changeValue: function changeValue(event) {
      event.stopPropagation();
      this.$emit("change-value", this.point);
    }
  },
  render: function render() {
    var h = arguments[0];
    var label = this.mark;
    return h("div", {
      "class": "".concat(this.componentName, "__mark-text"),
      "on": {
        "click": this.changeValue
      }
    }, [label]);
  }
});

export { TSliderMark as default };
//# sourceMappingURL=slider-mark.js.map
