/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

import { h as helper } from '../../_chunks/dep-653f218a.js';
import _toConsumableArray from '@babel/runtime/helpers/toConsumableArray';
import _slicedToArray from '@babel/runtime/helpers/slicedToArray';
import _defineProperty from '@babel/runtime/helpers/defineProperty';
import { toRefs, ref, computed, watch } from '@vue/composition-api';
import { useConfig } from '../../config-provider/useConfig.js';
import { Pagination } from '../../pagination/index.js';
import log from '../../_common/js/log/log.js';
import '../../config-provider/context.js';
import 'lodash-es';
import '../../_common/js/global-config/default-config.js';
import '../../_common/js/global-config/locale/zh_CN.js';
import '../../_chunks/dep-84fc5ae7.js';
import '@babel/runtime/helpers/typeof';
import '../../_chunks/dep-eb45b5e0.js';
import 'dayjs';
import '../../pagination/pagination.js';
import 'tdesign-icons-vue';
import '../../utils/mixins.js';
import 'vue';
import '../../config-provider/config-receiver.js';
import '../../input-number/index.js';
import '../../input-number/input-number.js';
import '../../button/index.js';
import '../../button/button.js';
import '../../loading/index.js';
import '../../loading/directive.js';
import '../../loading/plugin.js';
import '../../loading/loading.js';
import '../../loading/icon/gradient.js';
import '../../_common/js/loading/circle-adapter.js';
import '../../_common/js/utils/setStyle.js';
import '../../_common/js/utils/helper.js';
import '@babel/runtime/helpers/objectWithoutProperties';
import '../../utils/dom.js';
import 'raf';
import '../../utils/easing.js';
import '../../utils/render-tnode.js';
import '@babel/runtime/helpers/readOnlyError';
import '../../utils/transfer-dom.js';
import '../../loading/props.js';
import '../../config.js';
import '../../utils/withInstall.js';
import '../../button/props.js';
import '../../utils/ripple.js';
import '../../input/index.js';
import '../../input/input.js';
import '../../utils/helper.js';
import '../../utils/event.js';
import '../../input/props.js';
import '../../input/input-group.js';
import '../../utils/map-props.js';
import '../../input-number/props.js';
import '../../input-number/useInputNumber.js';
import '../../hooks/useCommonClassName.js';
import '../../hooks/useVModel.js';
import '../../_common/js/input-number/number.js';
import '../../_common/js/input-number/large-number.js';
import '../../hooks/useFormDisabled.js';
import '../../hooks/useGlobalIcon.js';
import '../../select/index.js';
import '../../select/select.js';
import '../../hooks/useDefaultValue.js';
import '../../hooks/tnode.js';
import '../../hooks/render-tnode.js';
import '../../select/props.js';
import '../../popup/index.js';
import '../../popup/popup.js';
import '@popperjs/core';
import '../../popup/props.js';
import '../../popup/container.js';
import '../../popup/utils.js';
import '../../popup/plugin.js';
import '../../tag/index.js';
import '../../tag/tag.js';
import 'tinycolor2';
import '../../tag/props.js';
import '../../tag/check-tag.js';
import '../../tag/check-tag-props.js';
import '../../hooks/useConfig.js';
import '../../_common/js/common.js';
import '../../tag/check-tag-group.js';
import '../../tag/check-tag-group-props.js';
import '../../select-input/index.js';
import '../../select-input/select-input.js';
import '../../select-input/props.js';
import '../../select-input/useSingle.js';
import '../../select-input/useMultiple.js';
import '../../tag-input/index.js';
import '../../tag-input/tag-input.js';
import '../../tag-input/props.js';
import '../../tag-input/hooks/useTagScroll.js';
import '../../tag-input/useTagList.js';
import '../../tag-input/hooks/useHover.js';
import '../../tag-input/hooks/useDragSorter.js';
import '../../select-input/useOverlayInnerStyle.js';
import '../../common-components/fake-arrow.js';
import '../../select/option.js';
import '../../select/option-props.js';
import '../../checkbox/index.js';
import '../../checkbox/group.js';
import '../../checkbox/checkbox.js';
import '../../checkbox/props.js';
import '../../checkbox/constants.js';
import '../../checkbox/store.js';
import '@babel/runtime/helpers/classCallCheck';
import '@babel/runtime/helpers/createClass';
import '../../checkbox/hooks/useKeyboardEvent.js';
import '../../hooks/useElementLazyRender.js';
import '../../_common/js/utils/observe.js';
import '../../checkbox/checkbox-group-props.js';
import '../../hooks/slots.js';
import '../../hooks/useLazyLoad.js';
import '../../select/util.js';
import '../../select/select-panel.js';
import '../../select/optionGroup.js';
import '../../select/option-group-props.js';
import '../../hooks/useVirtualScroll.js';
import '../../select/hooks/useSelectOptions.js';
import '../../input-adornment/index.js';
import '../../input-adornment/input-adornment.js';
import '../../input-adornment/props.js';
import '../../pagination/props.js';
import '../../pagination/pagination-mini.js';
import '../../pagination/pagination-mini-props.js';

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var DEFAULT_PAGE_SIZE = 10;
function usePaginationValue(pagination, onPageChange) {
  var _pagination$value, _pagination$value2, _pagination$value3;
  if ((_pagination$value = pagination.value) !== null && _pagination$value !== void 0 && _pagination$value.current && (_pagination$value2 = pagination.value) !== null && _pagination$value2 !== void 0 && _pagination$value2.defaultPageSize || (_pagination$value3 = pagination.value) !== null && _pagination$value3 !== void 0 && _pagination$value3.defaultCurrent && pagination !== null && pagination !== void 0 && pagination.value.pageSize) {
    log.error("Table", "cannot set both current and defaultPageSize, or defaultCurrent and pagesize. current/pageSize and defaultCurrent/defaultPageSize are allowed.");
  }
  var innerPagination = ref();
  var setInnerPagination = ref(onPageChange);
  watch(function () {
    return _objectSpread({}, pagination.value);
  }, function (pagination2) {
    if (!pagination2) return [innerPagination, setInnerPagination];
    var isControlled = Boolean(pagination2 === null || pagination2 === void 0 ? void 0 : pagination2.current);
    if (isControlled) {
      innerPagination.value = pagination2;
      return;
    }
    if (!innerPagination.value && pagination2.defaultCurrent) {
      innerPagination.value = _objectSpread(_objectSpread({}, pagination2), {}, {
        current: pagination2.defaultCurrent,
        pageSize: pagination2.defaultPageSize || DEFAULT_PAGE_SIZE
      });
    } else if (innerPagination.value && !pagination2.defaultCurrent) {
      innerPagination.value = void 0;
    }
    setInnerPagination.value = function (newPagination, newData) {
      innerPagination.value = _objectSpread(_objectSpread({}, innerPagination.value), newPagination);
      onPageChange === null || onPageChange === void 0 || onPageChange(newPagination, newData);
    };
  }, {
    immediate: true
  });
  return [innerPagination, setInnerPagination];
}
function usePagination(props, context) {
  var _toRefs = toRefs(props),
    pagination = _toRefs.pagination,
    disableDataPage = _toRefs.disableDataPage,
    data = _toRefs.data;
  var _useConfig = useConfig(),
    classPrefix = _useConfig.classPrefix;
  var dataSource = ref([]);
  var onPageChange = function onPageChange(pageInfo, newData) {
    var _props$onPageChange;
    context.emit("page-change", pageInfo, newData);
    (_props$onPageChange = props.onPageChange) === null || _props$onPageChange === void 0 || _props$onPageChange.call(props, pageInfo, newData);
  };
  var _usePaginationValue = usePaginationValue(pagination, onPageChange),
    _usePaginationValue2 = _slicedToArray(_usePaginationValue, 2),
    innerPagination = _usePaginationValue2[0],
    setInnerPagination = _usePaginationValue2[1];
  var isPaginateData = computed(function () {
    var _innerPagination$valu;
    var pageSize = (innerPagination === null || innerPagination === void 0 || (_innerPagination$valu = innerPagination.value) === null || _innerPagination$valu === void 0 ? void 0 : _innerPagination$valu.pageSize) || DEFAULT_PAGE_SIZE;
    return Boolean(!disableDataPage.value && props.data.length > pageSize);
  });
  var getDataSourceAndPaginate = function getDataSourceAndPaginate() {
    var current = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;
    var pageSize = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : DEFAULT_PAGE_SIZE;
    var data2 = props.data;
    var paginationData = [];
    if (isPaginateData.value) {
      var start = (current - 1) * pageSize;
      var end = current * pageSize;
      paginationData = data2.slice(start, end);
    } else {
      paginationData = data2;
    }
    return paginationData;
  };
  watch(function () {
    return [_objectSpread({}, innerPagination.value), _toConsumableArray(data.value)];
  }, function (_ref) {
    var _ref2 = _slicedToArray(_ref, 2),
      innerPagination2 = _ref2[0],
      data2 = _ref2[1];
    if (!(innerPagination2 !== null && innerPagination2 !== void 0 && innerPagination2.current)) {
      dataSource.value = data2;
      return;
    }
    var current = innerPagination2.current,
      pageSize = innerPagination2.pageSize;
    dataSource.value = getDataSourceAndPaginate(current, pageSize);
  }, {
    immediate: true
  });
  var renderPagination = function renderPagination(h) {
    if (!innerPagination.value) return null;
    return h("div", {
      "class": "".concat(classPrefix.value, "-table__pagination")
    }, [h(Pagination, helper([{}, {
      "props": _objectSpread(_objectSpread({}, props.pagination), innerPagination.value)
    }, {}, {
      "on": {
        change: function change(pageInfo) {
          var _setInnerPagination$v;
          var dataSource2 = getDataSourceAndPaginate(pageInfo.current, pageInfo.pageSize);
          setInnerPagination === null || setInnerPagination === void 0 || (_setInnerPagination$v = setInnerPagination.value) === null || _setInnerPagination$v === void 0 || _setInnerPagination$v.call(setInnerPagination, _objectSpread(_objectSpread({}, innerPagination.value), pageInfo), dataSource2);
        }
      }
    }, {
      "scopedSlots": {
        totalContent: context.slots.totalContent
      }
    }]))]);
  };
  return {
    isPaginateData: isPaginateData,
    dataSource: dataSource,
    innerPagination: innerPagination,
    renderPagination: renderPagination
  };
}

export { usePagination as default, usePaginationValue };
//# sourceMappingURL=usePagination.js.map
