/// <reference types="sortablejs" />
import { TdPrimaryTableProps } from '../table/type';
import { PropType } from 'vue';
declare const _default: {
    asyncLoading: {
        type: PropType<"loading" | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue) | "load-more">;
    };
    columnController: {
        type: PropType<import("../table/type").TableColumnController>;
    };
    columnControllerVisible: {
        type: BooleanConstructor;
        default: any;
    };
    defaultColumnControllerVisible: {
        type: BooleanConstructor;
        default: any;
    };
    columns: {
        type: PropType<import("../table/type").PrimaryTableCol<import("../table/type").TableRowData>[]>;
        default: () => TdPrimaryTableProps['columns'];
    };
    displayColumns: {
        type: PropType<import("..").CheckboxGroupValue>;
    };
    defaultDisplayColumns: {
        type: PropType<import("..").CheckboxGroupValue>;
    };
    dragSort: {
        type: PropType<"col" | "row" | "row-handler" | "row-handler-col" | "drag-col">;
        validator(val: TdPrimaryTableProps['dragSort']): boolean;
    };
    dragSortOptions: {
        type: PropType<import("sortablejs").SortableOptions>;
    };
    editableCellState: {
        type: PropType<import("../table/type").EditableCellType<import("../table/type").TableRowData>>;
    };
    editableRowKeys: {
        type: PropType<(string | number)[]>;
    };
    expandIcon: {
        type: PropType<boolean | ((h: import("vue").CreateElement, props: import("../table/type").ExpandArrowRenderParams<import("../table/type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: boolean;
    };
    expandOnRowClick: BooleanConstructor;
    expandedRow: {
        type: PropType<(h: import("vue").CreateElement, props: import("../table/type").TableExpandedRowParams<import("../table/type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    expandedRowKeys: {
        type: PropType<(string | number)[]>;
        default: () => TdPrimaryTableProps['expandedRowKeys'];
    };
    defaultExpandedRowKeys: {
        type: PropType<(string | number)[]>;
        default: () => TdPrimaryTableProps['defaultExpandedRowKeys'];
    };
    filterIcon: {
        type: PropType<(h: import("vue").CreateElement, props: {
            col: import("../table/type").PrimaryTableCol<import("../table/type").TableRowData>;
            colIndex: number;
        }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    filterRow: {
        type: PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    filterValue: {
        type: PropType<import("../table/type").FilterValue>;
    };
    defaultFilterValue: {
        type: PropType<import("../table/type").FilterValue>;
    };
    hideSortTips: BooleanConstructor;
    indeterminateSelectedRowKeys: {
        type: PropType<(string | number)[]>;
    };
    multipleSort: BooleanConstructor;
    reserveSelectedRowOnPaginate: {
        type: BooleanConstructor;
        default: boolean;
    };
    rowSelectionAllowUncheck: BooleanConstructor;
    rowSelectionType: {
        type: PropType<"multiple" | "single">;
        validator(val: TdPrimaryTableProps['rowSelectionType']): boolean;
    };
    selectOnRowClick: BooleanConstructor;
    selectedRowKeys: {
        type: PropType<(string | number)[]>;
        default: () => TdPrimaryTableProps['selectedRowKeys'];
    };
    defaultSelectedRowKeys: {
        type: PropType<(string | number)[]>;
        default: () => TdPrimaryTableProps['defaultSelectedRowKeys'];
    };
    showSortColumnBgColor: BooleanConstructor;
    sort: {
        type: PropType<import("../table/type").TableSort>;
    };
    defaultSort: {
        type: PropType<import("../table/type").TableSort>;
    };
    sortIcon: {
        type: PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    sortOnRowDraggable: BooleanConstructor;
    onAsyncLoadingClick: PropType<(context: {
        status: "loading" | "load-more";
    }) => void>;
    onCellClick: PropType<(context: import("../table/type").PrimaryTableCellEventContext<import("../table/type").TableRowData>) => void>;
    onChange: PropType<(data: import("../table/type").TableChangeData, context: import("../table/type").TableChangeContext<import("../table/type").TableRowData>) => void>;
    onColumnChange: PropType<(context: import("../table/type").PrimaryTableColumnChange<import("../table/type").TableRowData>) => void>;
    onColumnControllerVisibleChange: PropType<(visible: boolean, context: {
        trigger: "cancel" | "confirm";
    }) => void>;
    onDataChange: PropType<(data: import("../table/type").TableRowData[], context: import("../table/type").TableDataChangeContext) => void>;
    onDisplayColumnsChange: PropType<(value: import("..").CheckboxGroupValue) => void>;
    onDragSort: PropType<(context: import("../table/type").DragSortContext<import("../table/type").TableRowData>) => void>;
    onExpandChange: PropType<(expandedRowKeys: (string | number)[], options: import("../table/type").ExpandOptions<import("../table/type").TableRowData>) => void>;
    onFilterChange: PropType<(filterValue: import("../table/type").FilterValue, context: import("../table/type").TableFilterChangeContext<import("../table/type").TableRowData>) => void>;
    onRowEdit: PropType<(context: import("../table/type").PrimaryTableRowEditContext<import("../table/type").TableRowData>) => void>;
    onRowValidate: PropType<(context: import("../table/type").PrimaryTableRowValidateContext<import("../table/type").TableRowData>) => void>;
    onSelectChange: PropType<(selectedRowKeys: (string | number)[], options: import("../table/type").SelectOptions<import("../table/type").TableRowData>) => void>;
    onSortChange: PropType<(sort: import("../table/type").TableSort, options: import("../table/type").SortOptions<import("../table/type").TableRowData>) => void>;
    onValidate: PropType<(context: import("../table/type").PrimaryTableValidateContext) => void>;
};
export default _default;
