/// <reference types="sortablejs" />
import { TableListeners } from './base-table';
import { PrimaryTableCol, TableRowData } from './type';
import { PageInfo } from '../pagination';
import { ComponentScrollToElementParams } from '../common';
export { BASE_TABLE_ALL_EVENTS } from './base-table';
declare const _default: import("vue").ComponentOptions<import("vue").default, import("@vue/composition-api").ShallowUnwrapRef<{
    tColumns: import("@vue/composition-api").ComputedRef<PrimaryTableCol<TableRowData>[]>;
    showExpandedRow: import("@vue/composition-api").ComputedRef<boolean>;
    tRowClassNames: import("@vue/composition-api").ComputedRef<any[]>;
    hasEmptyCondition: import("@vue/composition-api").ComputedRef<boolean>;
    primaryTableRef: any;
    tRowAttributes: import("@vue/composition-api").ComputedRef<import("./type").TableRowAttributes<TableRowData>[]>;
    primaryTableClasses: import("@vue/composition-api").ComputedRef<{
        [x: string]: boolean | (string | number)[] | PrimaryTableCol<TableRowData>;
    }>;
    errorListMap: import("@vue/composition-api").Ref<{
        [x: string]: ({
            result: boolean;
            message: string;
            type?: "error" | "success" | "warning";
        } | {
            result: boolean;
            boolean?: boolean;
            date?: boolean | {
                format: string;
                strictMode: boolean;
                delimiters: string[];
            };
            email?: boolean | {
                allow_display_name?: boolean;
                require_display_name?: boolean;
                allow_utf8_local_part?: boolean;
                require_tld?: boolean;
                ignore_max_length?: boolean;
                allow_ip_domain?: boolean;
                domain_specific_validation?: boolean;
                allow_underscores?: boolean;
                host_blacklist?: string[];
                host_whitelist?: string[];
                blacklisted_chars?: string;
            };
            enum?: string[];
            idcard?: boolean;
            len?: number | boolean;
            max?: number | boolean;
            message?: string;
            min?: number | boolean;
            number?: boolean;
            pattern?: {
                exec: (string: string) => RegExpExecArray;
                test: (string: string) => boolean;
                readonly source: string;
                readonly global: boolean;
                readonly ignoreCase: boolean;
                readonly multiline: boolean;
                lastIndex: number;
                compile: (pattern: string, flags?: string) => RegExp;
                readonly flags: string;
                readonly sticky: boolean;
                readonly unicode: boolean;
                readonly dotAll: boolean;
                [Symbol.match]: (string: string) => RegExpMatchArray;
                [Symbol.replace]: {
                    (string: string, replaceValue: string): string;
                    (string: string, replacer: (substring: string, ...args: any[]) => string): string;
                };
                [Symbol.search]: (string: string) => number;
                [Symbol.split]: (string: string, limit?: number) => string[];
                [Symbol.matchAll]: (str: string) => IterableIterator<RegExpMatchArray>;
            };
            required?: boolean;
            telnumber?: boolean;
            trigger?: "blur" | "change" | "submit" | ("blur" | "change" | "submit")[];
            type?: "error" | "warning";
            url?: boolean | {
                protocols?: string[];
                require_tld?: boolean;
                require_protocol?: boolean;
                require_host?: boolean;
                require_port?: boolean;
                require_valid_protocol?: boolean;
                allow_underscores?: boolean;
                host_whitelist?: (string | {
                    exec: (string: string) => RegExpExecArray;
                    test: (string: string) => boolean;
                    readonly source: string;
                    readonly global: boolean;
                    readonly ignoreCase: boolean;
                    readonly multiline: boolean;
                    lastIndex: number;
                    compile: (pattern: string, flags?: string) => RegExp;
                    readonly flags: string;
                    readonly sticky: boolean;
                    readonly unicode: boolean;
                    readonly dotAll: boolean;
                    [Symbol.match]: (string: string) => RegExpMatchArray;
                    [Symbol.replace]: {
                        (string: string, replaceValue: string): string;
                        (string: string, replacer: (substring: string, ...args: any[]) => string): string;
                    };
                    [Symbol.search]: (string: string) => number;
                    [Symbol.split]: (string: string, limit?: number) => string[];
                    [Symbol.matchAll]: (str: string) => IterableIterator<RegExpMatchArray>;
                })[];
                host_blacklist?: (string | {
                    exec: (string: string) => RegExpExecArray;
                    test: (string: string) => boolean;
                    readonly source: string;
                    readonly global: boolean;
                    readonly ignoreCase: boolean;
                    readonly multiline: boolean;
                    lastIndex: number;
                    compile: (pattern: string, flags?: string) => RegExp;
                    readonly flags: string;
                    readonly sticky: boolean;
                    readonly unicode: boolean;
                    readonly dotAll: boolean;
                    [Symbol.match]: (string: string) => RegExpMatchArray;
                    [Symbol.replace]: {
                        (string: string, replaceValue: string): string;
                        (string: string, replacer: (substring: string, ...args: any[]) => string): string;
                    };
                    [Symbol.search]: (string: string) => number;
                    [Symbol.split]: (string: string, limit?: number) => string[];
                    [Symbol.matchAll]: (str: string) => IterableIterator<RegExpMatchArray>;
                })[];
                allow_trailing_dot?: boolean;
                allow_protocol_relative_urls?: boolean;
                disallow_auth?: boolean;
                allow_fragments?: boolean;
                allow_query_components?: boolean;
                validate_length?: boolean;
                max_allowed_length?: number | false;
            };
            validator?: import("..").CustomValidator;
            whitespace?: boolean;
        })[];
    }>;
    onShowElementChange: (val: boolean) => void;
    scrollToElement: (data: ComponentScrollToElementParams) => void;
    scrollColumnIntoView: (colKey: string) => void;
    refreshTable: () => void;
    validateRowData: (rowValue: any) => Promise<unknown>;
    validateTableData: () => Promise<unknown>;
    clearValidateData: () => void;
    renderTNode: (name: string, options?: import("../hooks/render-tnode").OptionsType) => any;
    renderColumnController: (h: import("vue").CreateElement) => JSX.Element;
    renderExpandedRow: (h: import("vue").CreateElement, p: import("./type").TableExpandedRowParams<TableRowData> & {
        tableWidth: number;
        isWidthOverflow: boolean;
    }) => JSX.Element;
    onInnerExpandRowClick: (p: import("./type").RowEventContext<TableRowData>) => void;
    onInnerRowClick: (context: import("./type").RowEventContext<TableRowData>) => void;
    renderFirstFilterRow: (h: import("vue").CreateElement) => JSX.Element;
    renderAsyncLoading: (h: import("vue").CreateElement) => JSX.Element;
    onInnerPageChange: (pageInfo: PageInfo, newData: Array<TableRowData>) => void;
    setDragSortColumns: (val: PrimaryTableCol<TableRowData>[]) => void;
    onInnerActiveRowAction: (context: import("./type").ActiveRowActionContext<TableRowData>) => void;
    innerKeyboardRowHover: import("@vue/composition-api").ComputedRef<boolean>;
    innerDisableSpaceInactiveRow: import("@vue/composition-api").ComputedRef<boolean>;
}> & import("@vue/composition-api").Data, {
    getListener(): TableListeners;
    formatNode(api: string, renderInnerNode: Function, condition: boolean, extra?: {
        reverse?: boolean;
    }): unknown;
}, {}, {
    asyncLoading: {
        type: import("vue").PropType<"loading" | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue) | "load-more">;
    };
    columnController: {
        type: import("vue").PropType<import("./type").TableColumnController>;
    };
    columnControllerVisible: {
        type: BooleanConstructor;
        default: any;
    };
    defaultColumnControllerVisible: {
        type: BooleanConstructor;
        default: any;
    };
    columns: {
        type: import("vue").PropType<PrimaryTableCol<TableRowData>[]>;
        default: () => PrimaryTableCol<TableRowData>[];
    };
    displayColumns: {
        type: import("vue").PropType<import("..").CheckboxGroupValue>;
    };
    defaultDisplayColumns: {
        type: import("vue").PropType<import("..").CheckboxGroupValue>;
    };
    dragSort: {
        type: import("vue").PropType<"col" | "row" | "row-handler" | "row-handler-col" | "drag-col">;
        validator(val: "col" | "row" | "row-handler" | "row-handler-col" | "drag-col"): boolean;
    };
    dragSortOptions: {
        type: import("vue").PropType<import("sortablejs").SortableOptions>;
    };
    editableCellState: {
        type: import("vue").PropType<import("./type").EditableCellType<TableRowData>>;
    };
    editableRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
    };
    expandIcon: {
        type: import("vue").PropType<boolean | ((h: import("vue").CreateElement, props: import("./type").ExpandArrowRenderParams<TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: boolean;
    };
    expandOnRowClick: BooleanConstructor;
    expandedRow: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: import("./type").TableExpandedRowParams<TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    expandedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultExpandedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    filterIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: {
            col: PrimaryTableCol<TableRowData>;
            colIndex: number;
        }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    filterRow: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    filterValue: {
        type: import("vue").PropType<import("./type").FilterValue>;
    };
    defaultFilterValue: {
        type: import("vue").PropType<import("./type").FilterValue>;
    };
    hideSortTips: BooleanConstructor;
    indeterminateSelectedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
    };
    multipleSort: BooleanConstructor;
    reserveSelectedRowOnPaginate: {
        type: BooleanConstructor;
        default: boolean;
    };
    rowSelectionAllowUncheck: BooleanConstructor;
    rowSelectionType: {
        type: import("vue").PropType<"multiple" | "single">;
        validator(val: "multiple" | "single"): boolean;
    };
    selectOnRowClick: BooleanConstructor;
    selectedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultSelectedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    showSortColumnBgColor: BooleanConstructor;
    sort: {
        type: import("vue").PropType<import("./type").TableSort>;
    };
    defaultSort: {
        type: import("vue").PropType<import("./type").TableSort>;
    };
    sortIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    sortOnRowDraggable: BooleanConstructor;
    onAsyncLoadingClick: import("vue").PropType<(context: {
        status: "loading" | "load-more";
    }) => void>;
    onCellClick: import("vue").PropType<(context: import("./type").PrimaryTableCellEventContext<TableRowData>) => void>;
    onChange: import("vue").PropType<(data: import("./type").TableChangeData, context: import("./type").TableChangeContext<TableRowData>) => void>;
    onColumnChange: import("vue").PropType<(context: import("./type").PrimaryTableColumnChange<TableRowData>) => void>;
    onColumnControllerVisibleChange: import("vue").PropType<(visible: boolean, context: {
        trigger: "cancel" | "confirm";
    }) => void>;
    onDataChange: import("vue").PropType<(data: TableRowData[], context: import("./type").TableDataChangeContext) => void>;
    onDisplayColumnsChange: import("vue").PropType<(value: import("..").CheckboxGroupValue) => void>;
    onDragSort: import("vue").PropType<(context: import("./type").DragSortContext<TableRowData>) => void>;
    onExpandChange: import("vue").PropType<(expandedRowKeys: (string | number)[], options: import("./type").ExpandOptions<TableRowData>) => void>;
    onFilterChange: import("vue").PropType<(filterValue: import("./type").FilterValue, context: import("./type").TableFilterChangeContext<TableRowData>) => void>;
    onRowEdit: import("vue").PropType<(context: import("./type").PrimaryTableRowEditContext<TableRowData>) => void>;
    onRowValidate: import("vue").PropType<(context: import("./type").PrimaryTableRowValidateContext<TableRowData>) => void>;
    onSelectChange: import("vue").PropType<(selectedRowKeys: (string | number)[], options: import("./type").SelectOptions<TableRowData>) => void>;
    onSortChange: import("vue").PropType<(sort: import("./type").TableSort, options: import("./type").SortOptions<TableRowData>) => void>;
    onValidate: import("vue").PropType<(context: import("./type").PrimaryTableValidateContext) => void>;
    activeRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultActiveRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    activeRowType: {
        type: import("vue").PropType<"multiple" | "single">;
        default: string;
    };
    allowResizeColumnWidth: {
        type: BooleanConstructor;
        default: any;
    };
    attach: {
        type: import("vue").PropType<import("../common").AttachNode>;
    };
    bordered: BooleanConstructor;
    bottomContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    cellEmptyContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement, props: import("./type").BaseTableCellParams<TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    data: {
        type: import("vue").PropType<TableRowData[]>;
        default: () => TableRowData[];
    };
    disableDataPage: BooleanConstructor;
    disableSpaceInactiveRow: {
        type: BooleanConstructor;
        default: any;
    };
    empty: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: string;
    };
    firstFullRow: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    fixedRows: {
        type: import("vue").PropType<number[]>;
    };
    footData: {
        type: import("vue").PropType<TableRowData[]>;
        default: () => TableRowData[];
    };
    footerAffixProps: {
        type: import("vue").PropType<Partial<import("..").TdAffixProps>>;
    };
    footerAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
        default: boolean;
    };
    footerSummary: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    headerAffixProps: {
        type: import("vue").PropType<Partial<import("..").TdAffixProps>>;
    };
    headerAffixedTop: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
        default: boolean;
    };
    height: {
        type: import("vue").PropType<string | number>;
    };
    horizontalScrollAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
    };
    hover: BooleanConstructor;
    keyboardRowHover: {
        type: BooleanConstructor;
        default: boolean;
    };
    lastFullRow: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    lazyLoad: BooleanConstructor;
    loading: {
        type: import("vue").PropType<boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: any;
    };
    loadingProps: {
        type: import("vue").PropType<Partial<import("..").TdLoadingProps>>;
    };
    locale: {
        type: import("vue").PropType<import("..").TableConfig>;
    };
    maxHeight: {
        type: import("vue").PropType<string | number>;
    };
    pagination: {
        type: import("vue").PropType<import("../pagination").TdPaginationProps>;
    };
    paginationAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
    };
    resizable: BooleanConstructor;
    rowAttributes: {
        type: import("vue").PropType<import("./type").TableRowAttributes<TableRowData>>;
    };
    rowClassName: {
        type: import("vue").PropType<import("../common").ClassName | ((params: import("./type").RowClassNameParams<TableRowData>) => import("../common").ClassName)>;
    };
    rowKey: {
        type: StringConstructor;
        default: string;
        required: boolean;
    };
    rowspanAndColspan: {
        type: import("vue").PropType<import("./type").TableRowspanAndColspanFunc<TableRowData>>;
    };
    rowspanAndColspanInFooter: {
        type: import("vue").PropType<import("./type").TableRowspanAndColspanFunc<TableRowData>>;
    };
    scroll: {
        type: import("vue").PropType<import("../common").TScroll>;
    };
    showHeader: {
        type: BooleanConstructor;
        default: boolean;
    };
    size: {
        type: import("vue").PropType<import("../common").SizeEnum>;
        validator(val: import("../common").SizeEnum): boolean;
    };
    stripe: BooleanConstructor;
    tableContentWidth: {
        type: StringConstructor;
        default: string;
    };
    tableLayout: {
        type: import("vue").PropType<"fixed" | "auto">;
        default: "fixed" | "auto";
        validator(val: "fixed" | "auto"): boolean;
    };
    topContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    verticalAlign: {
        type: import("vue").PropType<"top" | "bottom" | "middle">;
        default: "top" | "bottom" | "middle";
        validator(val: "top" | "bottom" | "middle"): boolean;
    };
    onActiveChange: import("vue").PropType<(activeRowKeys: (string | number)[], context: import("./type").ActiveChangeContext<TableRowData>) => void>;
    onActiveRowAction: import("vue").PropType<(context: import("./type").ActiveRowActionContext<TableRowData>) => void>;
    onColumnResizeChange: import("vue").PropType<(context: {
        columnsWidth: {
            [colKey: string]: number;
        };
    }) => void>;
    onPageChange: import("vue").PropType<(pageInfo: PageInfo, newDataSource: TableRowData[]) => void>;
    onRowClick: import("vue").PropType<(context: import("./type").RowEventContext<TableRowData>) => void>;
    onRowDblclick: import("vue").PropType<(context: import("./type").RowEventContext<TableRowData>) => void>;
    onRowMousedown: import("vue").PropType<(context: import("./type").RowEventContext<TableRowData>) => void>;
    onRowMouseenter: import("vue").PropType<(context: import("./type").RowEventContext<TableRowData>) => void>;
    onRowMouseleave: import("vue").PropType<(context: import("./type").RowEventContext<TableRowData>) => void>;
    onRowMouseover: import("vue").PropType<(context: import("./type").RowEventContext<TableRowData>) => void>;
    onRowMouseup: import("vue").PropType<(context: import("./type").RowEventContext<TableRowData>) => void>;
    onScroll: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
    onScrollX: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
    onScrollY: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
}, import("@vue/composition-api").ExtractPropTypes<{
    asyncLoading: {
        type: import("vue").PropType<"loading" | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue) | "load-more">;
    };
    columnController: {
        type: import("vue").PropType<import("./type").TableColumnController>;
    };
    columnControllerVisible: {
        type: BooleanConstructor;
        default: any;
    };
    defaultColumnControllerVisible: {
        type: BooleanConstructor;
        default: any;
    };
    columns: {
        type: import("vue").PropType<PrimaryTableCol<TableRowData>[]>;
        default: () => PrimaryTableCol<TableRowData>[];
    };
    displayColumns: {
        type: import("vue").PropType<import("..").CheckboxGroupValue>;
    };
    defaultDisplayColumns: {
        type: import("vue").PropType<import("..").CheckboxGroupValue>;
    };
    dragSort: {
        type: import("vue").PropType<"col" | "row" | "row-handler" | "row-handler-col" | "drag-col">;
        validator(val: "col" | "row" | "row-handler" | "row-handler-col" | "drag-col"): boolean;
    };
    dragSortOptions: {
        type: import("vue").PropType<import("sortablejs").SortableOptions>;
    };
    editableCellState: {
        type: import("vue").PropType<import("./type").EditableCellType<TableRowData>>;
    };
    editableRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
    };
    expandIcon: {
        type: import("vue").PropType<boolean | ((h: import("vue").CreateElement, props: import("./type").ExpandArrowRenderParams<TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: boolean;
    };
    expandOnRowClick: BooleanConstructor;
    expandedRow: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: import("./type").TableExpandedRowParams<TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    expandedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultExpandedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    filterIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: {
            col: PrimaryTableCol<TableRowData>;
            colIndex: number;
        }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    filterRow: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    filterValue: {
        type: import("vue").PropType<import("./type").FilterValue>;
    };
    defaultFilterValue: {
        type: import("vue").PropType<import("./type").FilterValue>;
    };
    hideSortTips: BooleanConstructor;
    indeterminateSelectedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
    };
    multipleSort: BooleanConstructor;
    reserveSelectedRowOnPaginate: {
        type: BooleanConstructor;
        default: boolean;
    };
    rowSelectionAllowUncheck: BooleanConstructor;
    rowSelectionType: {
        type: import("vue").PropType<"multiple" | "single">;
        validator(val: "multiple" | "single"): boolean;
    };
    selectOnRowClick: BooleanConstructor;
    selectedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultSelectedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    showSortColumnBgColor: BooleanConstructor;
    sort: {
        type: import("vue").PropType<import("./type").TableSort>;
    };
    defaultSort: {
        type: import("vue").PropType<import("./type").TableSort>;
    };
    sortIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    sortOnRowDraggable: BooleanConstructor;
    onAsyncLoadingClick: import("vue").PropType<(context: {
        status: "loading" | "load-more";
    }) => void>;
    onCellClick: import("vue").PropType<(context: import("./type").PrimaryTableCellEventContext<TableRowData>) => void>;
    onChange: import("vue").PropType<(data: import("./type").TableChangeData, context: import("./type").TableChangeContext<TableRowData>) => void>;
    onColumnChange: import("vue").PropType<(context: import("./type").PrimaryTableColumnChange<TableRowData>) => void>;
    onColumnControllerVisibleChange: import("vue").PropType<(visible: boolean, context: {
        trigger: "cancel" | "confirm";
    }) => void>;
    onDataChange: import("vue").PropType<(data: TableRowData[], context: import("./type").TableDataChangeContext) => void>;
    onDisplayColumnsChange: import("vue").PropType<(value: import("..").CheckboxGroupValue) => void>;
    onDragSort: import("vue").PropType<(context: import("./type").DragSortContext<TableRowData>) => void>;
    onExpandChange: import("vue").PropType<(expandedRowKeys: (string | number)[], options: import("./type").ExpandOptions<TableRowData>) => void>;
    onFilterChange: import("vue").PropType<(filterValue: import("./type").FilterValue, context: import("./type").TableFilterChangeContext<TableRowData>) => void>;
    onRowEdit: import("vue").PropType<(context: import("./type").PrimaryTableRowEditContext<TableRowData>) => void>;
    onRowValidate: import("vue").PropType<(context: import("./type").PrimaryTableRowValidateContext<TableRowData>) => void>;
    onSelectChange: import("vue").PropType<(selectedRowKeys: (string | number)[], options: import("./type").SelectOptions<TableRowData>) => void>;
    onSortChange: import("vue").PropType<(sort: import("./type").TableSort, options: import("./type").SortOptions<TableRowData>) => void>;
    onValidate: import("vue").PropType<(context: import("./type").PrimaryTableValidateContext) => void>;
    activeRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultActiveRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    activeRowType: {
        type: import("vue").PropType<"multiple" | "single">;
        default: string;
    };
    allowResizeColumnWidth: {
        type: BooleanConstructor;
        default: any;
    };
    attach: {
        type: import("vue").PropType<import("../common").AttachNode>;
    };
    bordered: BooleanConstructor;
    bottomContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    cellEmptyContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement, props: import("./type").BaseTableCellParams<TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    data: {
        type: import("vue").PropType<TableRowData[]>;
        default: () => TableRowData[];
    };
    disableDataPage: BooleanConstructor;
    disableSpaceInactiveRow: {
        type: BooleanConstructor;
        default: any;
    };
    empty: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: string;
    };
    firstFullRow: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    fixedRows: {
        type: import("vue").PropType<number[]>;
    };
    footData: {
        type: import("vue").PropType<TableRowData[]>;
        default: () => TableRowData[];
    };
    footerAffixProps: {
        type: import("vue").PropType<Partial<import("..").TdAffixProps>>;
    };
    footerAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
        default: boolean;
    };
    footerSummary: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    headerAffixProps: {
        type: import("vue").PropType<Partial<import("..").TdAffixProps>>;
    };
    headerAffixedTop: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
        default: boolean;
    };
    height: {
        type: import("vue").PropType<string | number>;
    };
    horizontalScrollAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
    };
    hover: BooleanConstructor;
    keyboardRowHover: {
        type: BooleanConstructor;
        default: boolean;
    };
    lastFullRow: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    lazyLoad: BooleanConstructor;
    loading: {
        type: import("vue").PropType<boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: any;
    };
    loadingProps: {
        type: import("vue").PropType<Partial<import("..").TdLoadingProps>>;
    };
    locale: {
        type: import("vue").PropType<import("..").TableConfig>;
    };
    maxHeight: {
        type: import("vue").PropType<string | number>;
    };
    pagination: {
        type: import("vue").PropType<import("../pagination").TdPaginationProps>;
    };
    paginationAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
    };
    resizable: BooleanConstructor;
    rowAttributes: {
        type: import("vue").PropType<import("./type").TableRowAttributes<TableRowData>>;
    };
    rowClassName: {
        type: import("vue").PropType<import("../common").ClassName | ((params: import("./type").RowClassNameParams<TableRowData>) => import("../common").ClassName)>;
    };
    rowKey: {
        type: StringConstructor;
        default: string;
        required: boolean;
    };
    rowspanAndColspan: {
        type: import("vue").PropType<import("./type").TableRowspanAndColspanFunc<TableRowData>>;
    };
    rowspanAndColspanInFooter: {
        type: import("vue").PropType<import("./type").TableRowspanAndColspanFunc<TableRowData>>;
    };
    scroll: {
        type: import("vue").PropType<import("../common").TScroll>;
    };
    showHeader: {
        type: BooleanConstructor;
        default: boolean;
    };
    size: {
        type: import("vue").PropType<import("../common").SizeEnum>;
        validator(val: import("../common").SizeEnum): boolean;
    };
    stripe: BooleanConstructor;
    tableContentWidth: {
        type: StringConstructor;
        default: string;
    };
    tableLayout: {
        type: import("vue").PropType<"fixed" | "auto">;
        default: "fixed" | "auto";
        validator(val: "fixed" | "auto"): boolean;
    };
    topContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    verticalAlign: {
        type: import("vue").PropType<"top" | "bottom" | "middle">;
        default: "top" | "bottom" | "middle";
        validator(val: "top" | "bottom" | "middle"): boolean;
    };
    onActiveChange: import("vue").PropType<(activeRowKeys: (string | number)[], context: import("./type").ActiveChangeContext<TableRowData>) => void>;
    onActiveRowAction: import("vue").PropType<(context: import("./type").ActiveRowActionContext<TableRowData>) => void>;
    onColumnResizeChange: import("vue").PropType<(context: {
        columnsWidth: {
            [colKey: string]: number;
        };
    }) => void>;
    onPageChange: import("vue").PropType<(pageInfo: PageInfo, newDataSource: TableRowData[]) => void>;
    onRowClick: import("vue").PropType<(context: import("./type").RowEventContext<TableRowData>) => void>;
    onRowDblclick: import("vue").PropType<(context: import("./type").RowEventContext<TableRowData>) => void>;
    onRowMousedown: import("vue").PropType<(context: import("./type").RowEventContext<TableRowData>) => void>;
    onRowMouseenter: import("vue").PropType<(context: import("./type").RowEventContext<TableRowData>) => void>;
    onRowMouseleave: import("vue").PropType<(context: import("./type").RowEventContext<TableRowData>) => void>;
    onRowMouseover: import("vue").PropType<(context: import("./type").RowEventContext<TableRowData>) => void>;
    onRowMouseup: import("vue").PropType<(context: import("./type").RowEventContext<TableRowData>) => void>;
    onScroll: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
    onScrollX: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
    onScrollY: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
}>> & Omit<import("vue").VueConstructor<import("vue").default>, never> & (new (...args: any[]) => import("@vue/composition-api").ComponentRenderProxy<{
    data: TableRowData[];
    columns: PrimaryTableCol<TableRowData>[];
    tableLayout: "fixed" | "auto";
    verticalAlign: "top" | "bottom" | "middle";
    loading: boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    empty: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    hover: boolean;
    lazyLoad: boolean;
    bordered: boolean;
    showHeader: boolean;
    stripe: boolean;
    activeRowKeys: (string | number)[];
    defaultActiveRowKeys: (string | number)[];
    activeRowType: "multiple" | "single";
    allowResizeColumnWidth: boolean;
    disableDataPage: boolean;
    disableSpaceInactiveRow: boolean;
    footData: TableRowData[];
    footerAffixedBottom: boolean;
    headerAffixedTop: boolean;
    keyboardRowHover: boolean;
    resizable: boolean;
    rowKey: string;
    tableContentWidth: string;
    columnControllerVisible: boolean;
    defaultColumnControllerVisible: boolean;
    expandIcon: boolean | ((h: import("vue").CreateElement, props: import("./type").ExpandArrowRenderParams<TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue);
    expandOnRowClick: boolean;
    expandedRowKeys: (string | number)[];
    defaultExpandedRowKeys: (string | number)[];
    hideSortTips: boolean;
    multipleSort: boolean;
    reserveSelectedRowOnPaginate: boolean;
    rowSelectionAllowUncheck: boolean;
    selectOnRowClick: boolean;
    selectedRowKeys: (string | number)[];
    defaultSelectedRowKeys: (string | number)[];
    showSortColumnBgColor: boolean;
    sortOnRowDraggable: boolean;
} & {
    sort?: import("./type").TableSort;
    height?: string | number;
    maxHeight?: string | number;
    scroll?: import("../common").TScroll;
    size?: import("../common").SizeEnum;
    onChange?: (data: import("./type").TableChangeData, context: import("./type").TableChangeContext<TableRowData>) => void;
    attach?: import("../common").AttachNode;
    pagination?: unknown;
    onValidate?: (context: import("./type").PrimaryTableValidateContext) => void;
    onScroll?: (params: {
        e: WheelEvent;
    }) => void;
    onDragSort?: (context: import("./type").DragSortContext<TableRowData>) => void;
    dragSort?: "col" | "row" | "row-handler" | "row-handler-col" | "drag-col";
    onCellClick?: (context: import("./type").PrimaryTableCellEventContext<TableRowData>) => void;
    onPageChange?: (pageInfo: PageInfo, newDataSource: TableRowData[]) => void;
    filterValue?: unknown;
    loadingProps?: unknown;
    asyncLoading?: "loading" | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue) | "load-more";
    bottomContent?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    cellEmptyContent?: string | ((h: import("vue").CreateElement, props: import("./type").BaseTableCellParams<TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue);
    firstFullRow?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    fixedRows?: number[];
    footerAffixProps?: unknown;
    footerSummary?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    headerAffixProps?: unknown;
    horizontalScrollAffixedBottom?: unknown;
    lastFullRow?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    locale?: unknown;
    paginationAffixedBottom?: unknown;
    rowAttributes?: import("./type").TableRowAttributes<TableRowData>;
    rowClassName?: unknown;
    rowspanAndColspan?: import("./type").TableRowspanAndColspanFunc<TableRowData>;
    rowspanAndColspanInFooter?: import("./type").TableRowspanAndColspanFunc<TableRowData>;
    topContent?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onActiveChange?: (activeRowKeys: (string | number)[], context: import("./type").ActiveChangeContext<TableRowData>) => void;
    onActiveRowAction?: (context: import("./type").ActiveRowActionContext<TableRowData>) => void;
    onColumnResizeChange?: (context: {
        columnsWidth: {
            [colKey: string]: number;
        };
    }) => void;
    onRowClick?: (context: import("./type").RowEventContext<TableRowData>) => void;
    onRowDblclick?: (context: import("./type").RowEventContext<TableRowData>) => void;
    onRowMousedown?: (context: import("./type").RowEventContext<TableRowData>) => void;
    onRowMouseenter?: (context: import("./type").RowEventContext<TableRowData>) => void;
    onRowMouseleave?: (context: import("./type").RowEventContext<TableRowData>) => void;
    onRowMouseover?: (context: import("./type").RowEventContext<TableRowData>) => void;
    onRowMouseup?: (context: import("./type").RowEventContext<TableRowData>) => void;
    onScrollX?: (params: {
        e: WheelEvent;
    }) => void;
    onScrollY?: (params: {
        e: WheelEvent;
    }) => void;
    sortIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    filterIcon?: (h: import("vue").CreateElement, props: {
        col: PrimaryTableCol<TableRowData>;
        colIndex: number;
    }) => import("vue/types/vnode").ScopedSlotReturnValue;
    columnController?: unknown;
    displayColumns?: import("..").CheckboxGroupValue;
    defaultDisplayColumns?: import("..").CheckboxGroupValue;
    dragSortOptions?: unknown;
    editableCellState?: import("./type").EditableCellType<TableRowData>;
    editableRowKeys?: (string | number)[];
    expandedRow?: (h: import("vue").CreateElement, props: import("./type").TableExpandedRowParams<TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue;
    filterRow?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    defaultFilterValue?: unknown;
    indeterminateSelectedRowKeys?: (string | number)[];
    rowSelectionType?: "multiple" | "single";
    defaultSort?: import("./type").TableSort;
    onAsyncLoadingClick?: (context: {
        status: "loading" | "load-more";
    }) => void;
    onColumnChange?: (context: import("./type").PrimaryTableColumnChange<TableRowData>) => void;
    onColumnControllerVisibleChange?: (visible: boolean, context: {
        trigger: "cancel" | "confirm";
    }) => void;
    onDataChange?: (data: TableRowData[], context: import("./type").TableDataChangeContext) => void;
    onDisplayColumnsChange?: (value: import("..").CheckboxGroupValue) => void;
    onExpandChange?: (expandedRowKeys: (string | number)[], options: import("./type").ExpandOptions<TableRowData>) => void;
    onFilterChange?: (filterValue: import("./type").FilterValue, context: import("./type").TableFilterChangeContext<TableRowData>) => void;
    onRowEdit?: (context: import("./type").PrimaryTableRowEditContext<TableRowData>) => void;
    onRowValidate?: (context: import("./type").PrimaryTableRowValidateContext<TableRowData>) => void;
    onSelectChange?: (selectedRowKeys: (string | number)[], options: import("./type").SelectOptions<TableRowData>) => void;
    onSortChange?: (sort: import("./type").TableSort, options: import("./type").SortOptions<TableRowData>) => void;
}, import("@vue/composition-api").ShallowUnwrapRef<{
    tColumns: import("@vue/composition-api").ComputedRef<PrimaryTableCol<TableRowData>[]>;
    showExpandedRow: import("@vue/composition-api").ComputedRef<boolean>;
    tRowClassNames: import("@vue/composition-api").ComputedRef<any[]>;
    hasEmptyCondition: import("@vue/composition-api").ComputedRef<boolean>;
    primaryTableRef: any;
    tRowAttributes: import("@vue/composition-api").ComputedRef<import("./type").TableRowAttributes<TableRowData>[]>;
    primaryTableClasses: import("@vue/composition-api").ComputedRef<{
        [x: string]: boolean | (string | number)[] | PrimaryTableCol<TableRowData>;
    }>;
    errorListMap: import("@vue/composition-api").Ref<{
        [x: string]: ({
            result: boolean;
            message: string;
            type?: "error" | "success" | "warning";
        } | {
            result: boolean;
            boolean?: boolean;
            date?: boolean | {
                format: string;
                strictMode: boolean;
                delimiters: string[];
            };
            email?: boolean | {
                allow_display_name?: boolean;
                require_display_name?: boolean;
                allow_utf8_local_part?: boolean;
                require_tld?: boolean;
                ignore_max_length?: boolean;
                allow_ip_domain?: boolean;
                domain_specific_validation?: boolean;
                allow_underscores?: boolean;
                host_blacklist?: string[];
                host_whitelist?: string[];
                blacklisted_chars?: string;
            };
            enum?: string[];
            idcard?: boolean;
            len?: number | boolean;
            max?: number | boolean;
            message?: string;
            min?: number | boolean;
            number?: boolean;
            pattern?: {
                exec: (string: string) => RegExpExecArray;
                test: (string: string) => boolean;
                readonly source: string;
                readonly global: boolean;
                readonly ignoreCase: boolean;
                readonly multiline: boolean;
                lastIndex: number;
                compile: (pattern: string, flags?: string) => RegExp;
                readonly flags: string;
                readonly sticky: boolean;
                readonly unicode: boolean;
                readonly dotAll: boolean;
                [Symbol.match]: (string: string) => RegExpMatchArray;
                [Symbol.replace]: {
                    (string: string, replaceValue: string): string;
                    (string: string, replacer: (substring: string, ...args: any[]) => string): string;
                };
                [Symbol.search]: (string: string) => number;
                [Symbol.split]: (string: string, limit?: number) => string[];
                [Symbol.matchAll]: (str: string) => IterableIterator<RegExpMatchArray>;
            };
            required?: boolean;
            telnumber?: boolean;
            trigger?: "blur" | "change" | "submit" | ("blur" | "change" | "submit")[];
            type?: "error" | "warning";
            url?: boolean | {
                protocols?: string[];
                require_tld?: boolean;
                require_protocol?: boolean;
                require_host?: boolean;
                require_port?: boolean;
                require_valid_protocol?: boolean;
                allow_underscores?: boolean;
                host_whitelist?: (string | {
                    exec: (string: string) => RegExpExecArray;
                    test: (string: string) => boolean;
                    readonly source: string;
                    readonly global: boolean;
                    readonly ignoreCase: boolean;
                    readonly multiline: boolean;
                    lastIndex: number;
                    compile: (pattern: string, flags?: string) => RegExp;
                    readonly flags: string;
                    readonly sticky: boolean;
                    readonly unicode: boolean;
                    readonly dotAll: boolean;
                    [Symbol.match]: (string: string) => RegExpMatchArray;
                    [Symbol.replace]: {
                        (string: string, replaceValue: string): string;
                        (string: string, replacer: (substring: string, ...args: any[]) => string): string;
                    };
                    [Symbol.search]: (string: string) => number;
                    [Symbol.split]: (string: string, limit?: number) => string[];
                    [Symbol.matchAll]: (str: string) => IterableIterator<RegExpMatchArray>;
                })[];
                host_blacklist?: (string | {
                    exec: (string: string) => RegExpExecArray;
                    test: (string: string) => boolean;
                    readonly source: string;
                    readonly global: boolean;
                    readonly ignoreCase: boolean;
                    readonly multiline: boolean;
                    lastIndex: number;
                    compile: (pattern: string, flags?: string) => RegExp;
                    readonly flags: string;
                    readonly sticky: boolean;
                    readonly unicode: boolean;
                    readonly dotAll: boolean;
                    [Symbol.match]: (string: string) => RegExpMatchArray;
                    [Symbol.replace]: {
                        (string: string, replaceValue: string): string;
                        (string: string, replacer: (substring: string, ...args: any[]) => string): string;
                    };
                    [Symbol.search]: (string: string) => number;
                    [Symbol.split]: (string: string, limit?: number) => string[];
                    [Symbol.matchAll]: (str: string) => IterableIterator<RegExpMatchArray>;
                })[];
                allow_trailing_dot?: boolean;
                allow_protocol_relative_urls?: boolean;
                disallow_auth?: boolean;
                allow_fragments?: boolean;
                allow_query_components?: boolean;
                validate_length?: boolean;
                max_allowed_length?: number | false;
            };
            validator?: import("..").CustomValidator;
            whitespace?: boolean;
        })[];
    }>;
    onShowElementChange: (val: boolean) => void;
    scrollToElement: (data: ComponentScrollToElementParams) => void;
    scrollColumnIntoView: (colKey: string) => void;
    refreshTable: () => void;
    validateRowData: (rowValue: any) => Promise<unknown>;
    validateTableData: () => Promise<unknown>;
    clearValidateData: () => void;
    renderTNode: (name: string, options?: import("../hooks/render-tnode").OptionsType) => any;
    renderColumnController: (h: import("vue").CreateElement) => JSX.Element;
    renderExpandedRow: (h: import("vue").CreateElement, p: import("./type").TableExpandedRowParams<TableRowData> & {
        tableWidth: number;
        isWidthOverflow: boolean;
    }) => JSX.Element;
    onInnerExpandRowClick: (p: import("./type").RowEventContext<TableRowData>) => void;
    onInnerRowClick: (context: import("./type").RowEventContext<TableRowData>) => void;
    renderFirstFilterRow: (h: import("vue").CreateElement) => JSX.Element;
    renderAsyncLoading: (h: import("vue").CreateElement) => JSX.Element;
    onInnerPageChange: (pageInfo: PageInfo, newData: Array<TableRowData>) => void;
    setDragSortColumns: (val: PrimaryTableCol<TableRowData>[]) => void;
    onInnerActiveRowAction: (context: import("./type").ActiveRowActionContext<TableRowData>) => void;
    innerKeyboardRowHover: import("@vue/composition-api").ComputedRef<boolean>;
    innerDisableSpaceInactiveRow: import("@vue/composition-api").ComputedRef<boolean>;
}>, import("@vue/composition-api").Data, {}, {
    getListener(): TableListeners;
    formatNode(api: string, renderInnerNode: Function, condition: boolean, extra?: {
        reverse?: boolean;
    }): unknown;
}, {}, {}, {}, {
    data: TableRowData[];
    columns: PrimaryTableCol<TableRowData>[];
    tableLayout: "fixed" | "auto";
    verticalAlign: "top" | "bottom" | "middle";
    loading: boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    empty: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    hover: boolean;
    lazyLoad: boolean;
    bordered: boolean;
    showHeader: boolean;
    stripe: boolean;
    activeRowKeys: (string | number)[];
    defaultActiveRowKeys: (string | number)[];
    activeRowType: "multiple" | "single";
    allowResizeColumnWidth: boolean;
    disableDataPage: boolean;
    disableSpaceInactiveRow: boolean;
    footData: TableRowData[];
    footerAffixedBottom: boolean;
    headerAffixedTop: boolean;
    keyboardRowHover: boolean;
    resizable: boolean;
    rowKey: string;
    tableContentWidth: string;
    columnControllerVisible: boolean;
    defaultColumnControllerVisible: boolean;
    expandIcon: boolean | ((h: import("vue").CreateElement, props: import("./type").ExpandArrowRenderParams<TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue);
    expandOnRowClick: boolean;
    expandedRowKeys: (string | number)[];
    defaultExpandedRowKeys: (string | number)[];
    hideSortTips: boolean;
    multipleSort: boolean;
    reserveSelectedRowOnPaginate: boolean;
    rowSelectionAllowUncheck: boolean;
    selectOnRowClick: boolean;
    selectedRowKeys: (string | number)[];
    defaultSelectedRowKeys: (string | number)[];
    showSortColumnBgColor: boolean;
    sortOnRowDraggable: boolean;
} & {
    sort?: import("./type").TableSort;
    height?: string | number;
    maxHeight?: string | number;
    scroll?: import("../common").TScroll;
    size?: import("../common").SizeEnum;
    onChange?: (data: import("./type").TableChangeData, context: import("./type").TableChangeContext<TableRowData>) => void;
    attach?: import("../common").AttachNode;
    pagination?: unknown;
    onValidate?: (context: import("./type").PrimaryTableValidateContext) => void;
    onScroll?: (params: {
        e: WheelEvent;
    }) => void;
    onDragSort?: (context: import("./type").DragSortContext<TableRowData>) => void;
    dragSort?: "col" | "row" | "row-handler" | "row-handler-col" | "drag-col";
    onCellClick?: (context: import("./type").PrimaryTableCellEventContext<TableRowData>) => void;
    onPageChange?: (pageInfo: PageInfo, newDataSource: TableRowData[]) => void;
    filterValue?: unknown;
    loadingProps?: unknown;
    asyncLoading?: "loading" | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue) | "load-more";
    bottomContent?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    cellEmptyContent?: string | ((h: import("vue").CreateElement, props: import("./type").BaseTableCellParams<TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue);
    firstFullRow?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    fixedRows?: number[];
    footerAffixProps?: unknown;
    footerSummary?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    headerAffixProps?: unknown;
    horizontalScrollAffixedBottom?: unknown;
    lastFullRow?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    locale?: unknown;
    paginationAffixedBottom?: unknown;
    rowAttributes?: import("./type").TableRowAttributes<TableRowData>;
    rowClassName?: unknown;
    rowspanAndColspan?: import("./type").TableRowspanAndColspanFunc<TableRowData>;
    rowspanAndColspanInFooter?: import("./type").TableRowspanAndColspanFunc<TableRowData>;
    topContent?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onActiveChange?: (activeRowKeys: (string | number)[], context: import("./type").ActiveChangeContext<TableRowData>) => void;
    onActiveRowAction?: (context: import("./type").ActiveRowActionContext<TableRowData>) => void;
    onColumnResizeChange?: (context: {
        columnsWidth: {
            [colKey: string]: number;
        };
    }) => void;
    onRowClick?: (context: import("./type").RowEventContext<TableRowData>) => void;
    onRowDblclick?: (context: import("./type").RowEventContext<TableRowData>) => void;
    onRowMousedown?: (context: import("./type").RowEventContext<TableRowData>) => void;
    onRowMouseenter?: (context: import("./type").RowEventContext<TableRowData>) => void;
    onRowMouseleave?: (context: import("./type").RowEventContext<TableRowData>) => void;
    onRowMouseover?: (context: import("./type").RowEventContext<TableRowData>) => void;
    onRowMouseup?: (context: import("./type").RowEventContext<TableRowData>) => void;
    onScrollX?: (params: {
        e: WheelEvent;
    }) => void;
    onScrollY?: (params: {
        e: WheelEvent;
    }) => void;
    sortIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    filterIcon?: (h: import("vue").CreateElement, props: {
        col: PrimaryTableCol<TableRowData>;
        colIndex: number;
    }) => import("vue/types/vnode").ScopedSlotReturnValue;
    columnController?: unknown;
    displayColumns?: import("..").CheckboxGroupValue;
    defaultDisplayColumns?: import("..").CheckboxGroupValue;
    dragSortOptions?: unknown;
    editableCellState?: import("./type").EditableCellType<TableRowData>;
    editableRowKeys?: (string | number)[];
    expandedRow?: (h: import("vue").CreateElement, props: import("./type").TableExpandedRowParams<TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue;
    filterRow?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    defaultFilterValue?: unknown;
    indeterminateSelectedRowKeys?: (string | number)[];
    rowSelectionType?: "multiple" | "single";
    defaultSort?: import("./type").TableSort;
    onAsyncLoadingClick?: (context: {
        status: "loading" | "load-more";
    }) => void;
    onColumnChange?: (context: import("./type").PrimaryTableColumnChange<TableRowData>) => void;
    onColumnControllerVisibleChange?: (visible: boolean, context: {
        trigger: "cancel" | "confirm";
    }) => void;
    onDataChange?: (data: TableRowData[], context: import("./type").TableDataChangeContext) => void;
    onDisplayColumnsChange?: (value: import("..").CheckboxGroupValue) => void;
    onExpandChange?: (expandedRowKeys: (string | number)[], options: import("./type").ExpandOptions<TableRowData>) => void;
    onFilterChange?: (filterValue: import("./type").FilterValue, context: import("./type").TableFilterChangeContext<TableRowData>) => void;
    onRowEdit?: (context: import("./type").PrimaryTableRowEditContext<TableRowData>) => void;
    onRowValidate?: (context: import("./type").PrimaryTableRowValidateContext<TableRowData>) => void;
    onSelectChange?: (selectedRowKeys: (string | number)[], options: import("./type").SelectOptions<TableRowData>) => void;
    onSortChange?: (sort: import("./type").TableSort, options: import("./type").SortOptions<TableRowData>) => void;
}, {
    data: TableRowData[];
    columns: PrimaryTableCol<TableRowData>[];
    tableLayout: "fixed" | "auto";
    verticalAlign: "top" | "bottom" | "middle";
    loading: boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    empty: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    hover: boolean;
    lazyLoad: boolean;
    bordered: boolean;
    showHeader: boolean;
    stripe: boolean;
    activeRowKeys: (string | number)[];
    defaultActiveRowKeys: (string | number)[];
    activeRowType: "multiple" | "single";
    allowResizeColumnWidth: boolean;
    disableDataPage: boolean;
    disableSpaceInactiveRow: boolean;
    footData: TableRowData[];
    footerAffixedBottom: boolean;
    headerAffixedTop: boolean;
    keyboardRowHover: boolean;
    resizable: boolean;
    rowKey: string;
    tableContentWidth: string;
    columnControllerVisible: boolean;
    defaultColumnControllerVisible: boolean;
    expandIcon: boolean | ((h: import("vue").CreateElement, props: import("./type").ExpandArrowRenderParams<TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue);
    expandOnRowClick: boolean;
    expandedRowKeys: (string | number)[];
    defaultExpandedRowKeys: (string | number)[];
    hideSortTips: boolean;
    multipleSort: boolean;
    reserveSelectedRowOnPaginate: boolean;
    rowSelectionAllowUncheck: boolean;
    selectOnRowClick: boolean;
    selectedRowKeys: (string | number)[];
    defaultSelectedRowKeys: (string | number)[];
    showSortColumnBgColor: boolean;
    sortOnRowDraggable: boolean;
}, true>);
export default _default;
