import { PropType } from '@vue/composition-api';
import { SortType } from './type';
import { TableConfig } from '../config-provider';
declare type SortTypeEnums = Array<'desc' | 'asc'>;
declare const _default: import("vue").ComponentOptions<import("vue").default, import("@vue/composition-api").ShallowUnwrapRef<{
    t: <T>(pattern: T, ...args: any[]) => any;
    global: import("@vue/composition-api").ComputedRef<{} & (TableConfig | ({
        readonly expandIcon: any;
        readonly sortIcon: any;
        readonly filterIcon: any;
        readonly treeExpandAndFoldIcon: any;
        readonly hideSortTips: false;
        readonly size: "medium";
    } & {
        readonly empty: "暂无数据";
        readonly loadingText: "正在加载中，请稍后";
        readonly loadingMoreText: "点击加载更多";
        readonly filterInputPlaceholder: "请输入内容（无默认值）";
        readonly sortAscendingOperationText: "点击升序";
        readonly sortCancelOperationText: "点击取消排序";
        readonly sortDescendingOperationText: "点击降序";
        readonly clearFilterResultButtonText: "清空筛选";
        readonly columnConfigButtonText: "列配置";
        readonly columnConfigTitleText: "表格列配置";
        readonly columnConfigDescriptionText: "请选择需要在表格中显示的数据列";
        readonly confirmText: "确认";
        readonly cancelText: "取消";
        readonly resetText: "重置";
        readonly selectAllText: "全选";
        readonly searchResultText: "搜索“{result}”，找到 {count} 条结果";
    })) & TableConfig>;
    ChevronDownIcon: import("tdesign-icons-vue").GlobalIconType;
    tableSortClasses: {
        sortable: string;
        sortColumn: string;
        title: string;
        trigger: string;
        doubleIcon: string;
        sortIcon: string;
        iconDirection: {
            asc: string;
            desc: string;
        };
        iconActive: string;
        iconDefault: string;
    };
    negativeRotate180: string;
    allowSortTypes: import("@vue/composition-api").ComputedRef<SortTypeEnums>;
    onSortIconClick: (e: MouseEvent, direction: string) => void;
    renderTNode: (name: string, options?: import("vue").VNode | import("../hooks/render-tnode").JSXRenderContext) => any;
}> & import("@vue/composition-api").Data, {
    getSortIcon(direction: string, activeClass: string): JSX.Element;
}, {}, {
    sortType: {
        type: PropType<SortType>;
        default: string;
    };
    sortOrder: {
        type: StringConstructor;
        default: () => string;
    };
    sortIcon: PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    tooltipProps: PropType<import("../tooltip").TdTooltipProps>;
    locale: PropType<TableConfig>;
    hideSortTips: BooleanConstructor;
}, import("@vue/composition-api").ExtractPropTypes<{
    sortType: {
        type: PropType<SortType>;
        default: string;
    };
    sortOrder: {
        type: StringConstructor;
        default: () => string;
    };
    sortIcon: PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    tooltipProps: PropType<import("../tooltip").TdTooltipProps>;
    locale: PropType<TableConfig>;
    hideSortTips: BooleanConstructor;
}>> & Omit<import("vue").VueConstructor<import("vue").default>, never> & (new (...args: any[]) => import("@vue/composition-api").ComponentRenderProxy<{
    hideSortTips: boolean;
    sortType: SortType;
    sortOrder: string;
} & {
    tooltipProps?: unknown;
    locale?: unknown;
    sortIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
}, import("@vue/composition-api").ShallowUnwrapRef<{
    t: <T>(pattern: T, ...args: any[]) => any;
    global: import("@vue/composition-api").ComputedRef<{} & (TableConfig | ({
        readonly expandIcon: any;
        readonly sortIcon: any;
        readonly filterIcon: any;
        readonly treeExpandAndFoldIcon: any;
        readonly hideSortTips: false;
        readonly size: "medium";
    } & {
        readonly empty: "暂无数据";
        readonly loadingText: "正在加载中，请稍后";
        readonly loadingMoreText: "点击加载更多";
        readonly filterInputPlaceholder: "请输入内容（无默认值）";
        readonly sortAscendingOperationText: "点击升序";
        readonly sortCancelOperationText: "点击取消排序";
        readonly sortDescendingOperationText: "点击降序";
        readonly clearFilterResultButtonText: "清空筛选";
        readonly columnConfigButtonText: "列配置";
        readonly columnConfigTitleText: "表格列配置";
        readonly columnConfigDescriptionText: "请选择需要在表格中显示的数据列";
        readonly confirmText: "确认";
        readonly cancelText: "取消";
        readonly resetText: "重置";
        readonly selectAllText: "全选";
        readonly searchResultText: "搜索“{result}”，找到 {count} 条结果";
    })) & TableConfig>;
    ChevronDownIcon: import("tdesign-icons-vue").GlobalIconType;
    tableSortClasses: {
        sortable: string;
        sortColumn: string;
        title: string;
        trigger: string;
        doubleIcon: string;
        sortIcon: string;
        iconDirection: {
            asc: string;
            desc: string;
        };
        iconActive: string;
        iconDefault: string;
    };
    negativeRotate180: string;
    allowSortTypes: import("@vue/composition-api").ComputedRef<SortTypeEnums>;
    onSortIconClick: (e: MouseEvent, direction: string) => void;
    renderTNode: (name: string, options?: import("vue").VNode | import("../hooks/render-tnode").JSXRenderContext) => any;
}>, import("@vue/composition-api").Data, {}, {
    getSortIcon(direction: string, activeClass: string): JSX.Element;
}, {}, {}, {}, {
    hideSortTips: boolean;
    sortType: SortType;
    sortOrder: string;
} & {
    tooltipProps?: unknown;
    locale?: unknown;
    sortIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
}, {
    hideSortTips: boolean;
    sortType: SortType;
    sortOrder: string;
}, true>);
export default _default;
