import { TNode } from '../common';
export interface TdTabsProps {
    addable?: boolean;
    disabled?: boolean;
    list?: Array<TdTabPanelProps>;
    placement?: 'left' | 'top' | 'bottom' | 'right';
    scrollPosition?: 'auto' | 'start' | 'center' | 'end';
    size?: 'medium' | 'large';
    theme?: 'normal' | 'card';
    value?: TabValue;
    defaultValue?: TabValue;
    onAdd?: (context: {
        e: MouseEvent;
    }) => void;
    onChange?: (value: TabValue) => void;
    onRemove?: (options: {
        value: TabValue;
        index: number;
        e: MouseEvent;
    }) => void;
}
export interface TdTabPanelProps {
    default?: TNode;
    destroyOnHide?: boolean;
    disabled?: boolean;
    label?: string | TNode;
    panel?: string | TNode;
    removable?: boolean;
    value?: TabValue;
    onRemove?: (options: {
        value: TabValue;
        e: MouseEvent;
    }) => void;
    lazy?: Boolean;
}
export declare type TabValue = string | number;
