import { TdTagInputProps } from './type';
import './style';
export * from './type';
export * from './interface';
export declare type TagInputProps = TdTagInputProps;
export declare const TagInput: import("vue").ComponentOptions<import("vue").default, import("@vue/composition-api").ShallowUnwrapRef<{
    tagValue: import("@vue/composition-api").Ref<import("./type").TagInputValue>;
    tInputValue: import("@vue/composition-api").Ref<string>;
    isHover: import("@vue/composition-api").Ref<boolean>;
    tagInputPlaceholder: import("@vue/composition-api").ComputedRef<string>;
    showClearIcon: import("@vue/composition-api").ComputedRef<boolean>;
    tagInputRef: import("@vue/composition-api").Ref<any>;
    classPrefix: import("@vue/composition-api").Ref<string>;
    classes: import("@vue/composition-api").ComputedRef<(string | {
        [x: string]: boolean;
    })[]>;
    componentName: import("@vue/composition-api").Ref<string>;
    setTInputValue: (value: string, context?: import("./type").InputValueChangeContext) => void;
    addHover: (context: {
        e: MouseEvent;
    }) => void;
    cancelHover: (context: {
        e: MouseEvent;
    }) => void;
    onInputEnter: (value: string, context: {
        e: KeyboardEvent;
    }) => void;
    onInnerEnter: (value: string, params: {
        e: KeyboardEvent;
    }) => void;
    onInputBackspaceKeyUp: (value: import("..").InputValue) => void;
    onInputBackspaceKeyDown: (value: import("..").InputValue, p: {
        e: KeyboardEvent;
    }) => void;
    renderLabel: ({ displayNode, label }: {
        displayNode: any;
        label: any;
    }, h: import("vue").CreateElement) => any[];
    onWheel: ({ e }: {
        e: WheelEvent;
    }) => void;
    scrollToRightOnEnter: () => void;
    scrollToLeftOnLeave: () => void;
    onClearClick: (ctx: {
        e: MouseEvent;
    }) => void;
    onInnerClick: (context: {
        e: MouseEvent;
    }) => void;
    onClose: (p: {
        e?: MouseEvent;
        index: number;
    }) => void;
    onInputCompositionstart: (value: string, context: {
        e: CompositionEvent;
    }) => void;
    onInputCompositionend: (value: string, context: {
        e: CompositionEvent;
    }) => void;
    CloseCircleFilledIcon: import("tdesign-icons-vue").GlobalIconType;
}> & import("@vue/composition-api").Data, {}, {}, {
    autoWidth: BooleanConstructor;
    borderless: BooleanConstructor;
    clearable: BooleanConstructor;
    collapsedItems: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: {
            value: import("./type").TagInputValue;
            collapsedSelectedItems: import("./type").TagInputValue;
            count: number;
            onClose: (context: {
                index: number;
                e?: MouseEvent;
            }) => void;
        }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    disabled: {
        type: BooleanConstructor;
        default: any;
    };
    dragSort: BooleanConstructor;
    excessTagsDisplayType: {
        type: import("vue").PropType<"scroll" | "break-line">;
        default: "scroll" | "break-line";
        validator(val: "scroll" | "break-line"): boolean;
    };
    inputProps: {
        type: import("vue").PropType<import("..").InputProps<import("..").InputValue>>;
    };
    inputValue: {
        type: import("vue").PropType<string>;
        default: any;
    };
    defaultInputValue: {
        type: import("vue").PropType<string>;
        default: string;
    };
    label: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    max: {
        type: NumberConstructor;
    };
    minCollapsedNum: {
        type: NumberConstructor;
        default: number;
    };
    placeholder: {
        type: StringConstructor;
        default: any;
    };
    prefixIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    readonly: BooleanConstructor;
    size: {
        type: import("vue").PropType<import("..").SizeEnum>;
        default: import("..").SizeEnum;
        validator(val: import("..").SizeEnum): boolean;
    };
    status: {
        type: import("vue").PropType<"error" | "default" | "success" | "warning">;
        validator(val: "error" | "default" | "success" | "warning"): boolean;
    };
    suffix: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    suffixIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    tag: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement, props: {
            value: string | number;
        }) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    tagProps: {
        type: import("vue").PropType<import("..").TdTagProps>;
    };
    tips: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    value: {
        type: import("vue").PropType<import("./type").TagInputValue>;
        default: any;
    };
    defaultValue: {
        type: import("vue").PropType<import("./type").TagInputValue>;
        default: () => import("./type").TagInputValue;
    };
    valueDisplay: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement, props: {
            value: import("./type").TagInputValue;
            onClose: (index: number, item?: any) => void;
        }) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    onBlur: import("vue").PropType<(value: import("./type").TagInputValue, context: {
        inputValue: string;
        e: FocusEvent;
    }) => void>;
    onChange: import("vue").PropType<(value: import("./type").TagInputValue, context: import("./type").TagInputChangeContext) => void>;
    onClear: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onClick: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onDragSort: import("vue").PropType<(context: import("./type").TagInputDragSortContext) => void>;
    onEnter: import("vue").PropType<(value: import("./type").TagInputValue, context: {
        e: KeyboardEvent;
        inputValue: string;
    }) => void>;
    onFocus: import("vue").PropType<(value: import("./type").TagInputValue, context: {
        inputValue: string;
        e: FocusEvent;
    }) => void>;
    onInputChange: import("vue").PropType<(value: string, context?: import("./type").InputValueChangeContext) => void>;
    onMouseenter: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onMouseleave: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onPaste: import("vue").PropType<(context: {
        e: ClipboardEvent;
        pasteValue: string;
    }) => void>;
    onRemove: import("vue").PropType<(context: import("./type").TagInputRemoveContext) => void>;
}, import("@vue/composition-api").ExtractPropTypes<{
    autoWidth: BooleanConstructor;
    borderless: BooleanConstructor;
    clearable: BooleanConstructor;
    collapsedItems: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: {
            value: import("./type").TagInputValue;
            collapsedSelectedItems: import("./type").TagInputValue;
            count: number;
            onClose: (context: {
                index: number;
                e?: MouseEvent;
            }) => void;
        }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    disabled: {
        type: BooleanConstructor;
        default: any;
    };
    dragSort: BooleanConstructor;
    excessTagsDisplayType: {
        type: import("vue").PropType<"scroll" | "break-line">;
        default: "scroll" | "break-line";
        validator(val: "scroll" | "break-line"): boolean;
    };
    inputProps: {
        type: import("vue").PropType<import("..").InputProps<import("..").InputValue>>;
    };
    inputValue: {
        type: import("vue").PropType<string>;
        default: any;
    };
    defaultInputValue: {
        type: import("vue").PropType<string>;
        default: string;
    };
    label: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    max: {
        type: NumberConstructor;
    };
    minCollapsedNum: {
        type: NumberConstructor;
        default: number;
    };
    placeholder: {
        type: StringConstructor;
        default: any;
    };
    prefixIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    readonly: BooleanConstructor;
    size: {
        type: import("vue").PropType<import("..").SizeEnum>;
        default: import("..").SizeEnum;
        validator(val: import("..").SizeEnum): boolean;
    };
    status: {
        type: import("vue").PropType<"error" | "default" | "success" | "warning">;
        validator(val: "error" | "default" | "success" | "warning"): boolean;
    };
    suffix: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    suffixIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    tag: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement, props: {
            value: string | number;
        }) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    tagProps: {
        type: import("vue").PropType<import("..").TdTagProps>;
    };
    tips: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    value: {
        type: import("vue").PropType<import("./type").TagInputValue>;
        default: any;
    };
    defaultValue: {
        type: import("vue").PropType<import("./type").TagInputValue>;
        default: () => import("./type").TagInputValue;
    };
    valueDisplay: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement, props: {
            value: import("./type").TagInputValue;
            onClose: (index: number, item?: any) => void;
        }) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    onBlur: import("vue").PropType<(value: import("./type").TagInputValue, context: {
        inputValue: string;
        e: FocusEvent;
    }) => void>;
    onChange: import("vue").PropType<(value: import("./type").TagInputValue, context: import("./type").TagInputChangeContext) => void>;
    onClear: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onClick: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onDragSort: import("vue").PropType<(context: import("./type").TagInputDragSortContext) => void>;
    onEnter: import("vue").PropType<(value: import("./type").TagInputValue, context: {
        e: KeyboardEvent;
        inputValue: string;
    }) => void>;
    onFocus: import("vue").PropType<(value: import("./type").TagInputValue, context: {
        inputValue: string;
        e: FocusEvent;
    }) => void>;
    onInputChange: import("vue").PropType<(value: string, context?: import("./type").InputValueChangeContext) => void>;
    onMouseenter: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onMouseleave: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onPaste: import("vue").PropType<(context: {
        e: ClipboardEvent;
        pasteValue: string;
    }) => void>;
    onRemove: import("vue").PropType<(context: import("./type").TagInputRemoveContext) => void>;
}>> & Omit<import("vue").VueConstructor<import("vue").default>, never> & (new (...args: any[]) => import("@vue/composition-api").ComponentRenderProxy<{
    value: import("./type").TagInputValue;
    disabled: boolean;
    size: import("..").SizeEnum;
    readonly: boolean;
    defaultValue: import("./type").TagInputValue;
    autoWidth: boolean;
    borderless: boolean;
    clearable: boolean;
    placeholder: string;
    inputValue: string;
    excessTagsDisplayType: "scroll" | "break-line";
    defaultInputValue: string;
    dragSort: boolean;
    minCollapsedNum: number;
} & {
    max?: number;
    label?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    status?: "error" | "default" | "success" | "warning";
    tag?: string | ((h: import("vue").CreateElement, props: {
        value: string | number;
    }) => import("vue/types/vnode").ScopedSlotReturnValue);
    onClick?: (context: {
        e: MouseEvent;
    }) => void;
    onChange?: (value: import("./type").TagInputValue, context: import("./type").TagInputChangeContext) => void;
    prefixIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    suffix?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    suffixIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onBlur?: (value: import("./type").TagInputValue, context: {
        inputValue: string;
        e: FocusEvent;
    }) => void;
    onClear?: (context: {
        e: MouseEvent;
    }) => void;
    onEnter?: (value: import("./type").TagInputValue, context: {
        e: KeyboardEvent;
        inputValue: string;
    }) => void;
    onFocus?: (value: import("./type").TagInputValue, context: {
        inputValue: string;
        e: FocusEvent;
    }) => void;
    onMouseenter?: (context: {
        e: MouseEvent;
    }) => void;
    onMouseleave?: (context: {
        e: MouseEvent;
    }) => void;
    onPaste?: (context: {
        e: ClipboardEvent;
        pasteValue: string;
    }) => void;
    collapsedItems?: (h: import("vue").CreateElement, props: {
        value: import("./type").TagInputValue;
        collapsedSelectedItems: import("./type").TagInputValue;
        count: number;
        onClose: (context: {
            index: number;
            e?: MouseEvent;
        }) => void;
    }) => import("vue/types/vnode").ScopedSlotReturnValue;
    inputProps?: unknown;
    tagProps?: unknown;
    valueDisplay?: string | ((h: import("vue").CreateElement, props: {
        value: import("./type").TagInputValue;
        onClose: (index: number, item?: any) => void;
    }) => import("vue/types/vnode").ScopedSlotReturnValue);
    onDragSort?: (context: import("./type").TagInputDragSortContext) => void;
    onInputChange?: (value: string, context?: import("./type").InputValueChangeContext) => void;
    onRemove?: (context: import("./type").TagInputRemoveContext) => void;
}, import("@vue/composition-api").ShallowUnwrapRef<{
    tagValue: import("@vue/composition-api").Ref<import("./type").TagInputValue>;
    tInputValue: import("@vue/composition-api").Ref<string>;
    isHover: import("@vue/composition-api").Ref<boolean>;
    tagInputPlaceholder: import("@vue/composition-api").ComputedRef<string>;
    showClearIcon: import("@vue/composition-api").ComputedRef<boolean>;
    tagInputRef: import("@vue/composition-api").Ref<any>;
    classPrefix: import("@vue/composition-api").Ref<string>;
    classes: import("@vue/composition-api").ComputedRef<(string | {
        [x: string]: boolean;
    })[]>;
    componentName: import("@vue/composition-api").Ref<string>;
    setTInputValue: (value: string, context?: import("./type").InputValueChangeContext) => void;
    addHover: (context: {
        e: MouseEvent;
    }) => void;
    cancelHover: (context: {
        e: MouseEvent;
    }) => void;
    onInputEnter: (value: string, context: {
        e: KeyboardEvent;
    }) => void;
    onInnerEnter: (value: string, params: {
        e: KeyboardEvent;
    }) => void;
    onInputBackspaceKeyUp: (value: import("..").InputValue) => void;
    onInputBackspaceKeyDown: (value: import("..").InputValue, p: {
        e: KeyboardEvent;
    }) => void;
    renderLabel: ({ displayNode, label }: {
        displayNode: any;
        label: any;
    }, h: import("vue").CreateElement) => any[];
    onWheel: ({ e }: {
        e: WheelEvent;
    }) => void;
    scrollToRightOnEnter: () => void;
    scrollToLeftOnLeave: () => void;
    onClearClick: (ctx: {
        e: MouseEvent;
    }) => void;
    onInnerClick: (context: {
        e: MouseEvent;
    }) => void;
    onClose: (p: {
        e?: MouseEvent;
        index: number;
    }) => void;
    onInputCompositionstart: (value: string, context: {
        e: CompositionEvent;
    }) => void;
    onInputCompositionend: (value: string, context: {
        e: CompositionEvent;
    }) => void;
    CloseCircleFilledIcon: import("tdesign-icons-vue").GlobalIconType;
}>, import("@vue/composition-api").Data, {}, {}, {}, {}, {}, {
    value: import("./type").TagInputValue;
    disabled: boolean;
    size: import("..").SizeEnum;
    readonly: boolean;
    defaultValue: import("./type").TagInputValue;
    autoWidth: boolean;
    borderless: boolean;
    clearable: boolean;
    placeholder: string;
    inputValue: string;
    excessTagsDisplayType: "scroll" | "break-line";
    defaultInputValue: string;
    dragSort: boolean;
    minCollapsedNum: number;
} & {
    max?: number;
    label?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    status?: "error" | "default" | "success" | "warning";
    tag?: string | ((h: import("vue").CreateElement, props: {
        value: string | number;
    }) => import("vue/types/vnode").ScopedSlotReturnValue);
    onClick?: (context: {
        e: MouseEvent;
    }) => void;
    onChange?: (value: import("./type").TagInputValue, context: import("./type").TagInputChangeContext) => void;
    prefixIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    suffix?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    suffixIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onBlur?: (value: import("./type").TagInputValue, context: {
        inputValue: string;
        e: FocusEvent;
    }) => void;
    onClear?: (context: {
        e: MouseEvent;
    }) => void;
    onEnter?: (value: import("./type").TagInputValue, context: {
        e: KeyboardEvent;
        inputValue: string;
    }) => void;
    onFocus?: (value: import("./type").TagInputValue, context: {
        inputValue: string;
        e: FocusEvent;
    }) => void;
    onMouseenter?: (context: {
        e: MouseEvent;
    }) => void;
    onMouseleave?: (context: {
        e: MouseEvent;
    }) => void;
    onPaste?: (context: {
        e: ClipboardEvent;
        pasteValue: string;
    }) => void;
    collapsedItems?: (h: import("vue").CreateElement, props: {
        value: import("./type").TagInputValue;
        collapsedSelectedItems: import("./type").TagInputValue;
        count: number;
        onClose: (context: {
            index: number;
            e?: MouseEvent;
        }) => void;
    }) => import("vue/types/vnode").ScopedSlotReturnValue;
    inputProps?: unknown;
    tagProps?: unknown;
    valueDisplay?: string | ((h: import("vue").CreateElement, props: {
        value: import("./type").TagInputValue;
        onClose: (index: number, item?: any) => void;
    }) => import("vue/types/vnode").ScopedSlotReturnValue);
    onDragSort?: (context: import("./type").TagInputDragSortContext) => void;
    onInputChange?: (value: string, context?: import("./type").InputValueChangeContext) => void;
    onRemove?: (context: import("./type").TagInputRemoveContext) => void;
}, {
    value: import("./type").TagInputValue;
    disabled: boolean;
    size: import("..").SizeEnum;
    readonly: boolean;
    defaultValue: import("./type").TagInputValue;
    autoWidth: boolean;
    borderless: boolean;
    clearable: boolean;
    placeholder: string;
    inputValue: string;
    excessTagsDisplayType: "scroll" | "break-line";
    defaultInputValue: string;
    dragSort: boolean;
    minCollapsedNum: number;
}, true>) & import("vue").PluginObject<import("vue").ComponentOptions<import("vue").default, import("@vue/composition-api").ShallowUnwrapRef<{
    tagValue: import("@vue/composition-api").Ref<import("./type").TagInputValue>;
    tInputValue: import("@vue/composition-api").Ref<string>;
    isHover: import("@vue/composition-api").Ref<boolean>;
    tagInputPlaceholder: import("@vue/composition-api").ComputedRef<string>;
    showClearIcon: import("@vue/composition-api").ComputedRef<boolean>;
    tagInputRef: import("@vue/composition-api").Ref<any>;
    classPrefix: import("@vue/composition-api").Ref<string>;
    classes: import("@vue/composition-api").ComputedRef<(string | {
        [x: string]: boolean;
    })[]>;
    componentName: import("@vue/composition-api").Ref<string>;
    setTInputValue: (value: string, context?: import("./type").InputValueChangeContext) => void;
    addHover: (context: {
        e: MouseEvent;
    }) => void;
    cancelHover: (context: {
        e: MouseEvent;
    }) => void;
    onInputEnter: (value: string, context: {
        e: KeyboardEvent;
    }) => void;
    onInnerEnter: (value: string, params: {
        e: KeyboardEvent;
    }) => void;
    onInputBackspaceKeyUp: (value: import("..").InputValue) => void;
    onInputBackspaceKeyDown: (value: import("..").InputValue, p: {
        e: KeyboardEvent;
    }) => void;
    renderLabel: ({ displayNode, label }: {
        displayNode: any;
        label: any;
    }, h: import("vue").CreateElement) => any[];
    onWheel: ({ e }: {
        e: WheelEvent;
    }) => void;
    scrollToRightOnEnter: () => void;
    scrollToLeftOnLeave: () => void;
    onClearClick: (ctx: {
        e: MouseEvent;
    }) => void;
    onInnerClick: (context: {
        e: MouseEvent;
    }) => void;
    onClose: (p: {
        e?: MouseEvent;
        index: number;
    }) => void;
    onInputCompositionstart: (value: string, context: {
        e: CompositionEvent;
    }) => void;
    onInputCompositionend: (value: string, context: {
        e: CompositionEvent;
    }) => void;
    CloseCircleFilledIcon: import("tdesign-icons-vue").GlobalIconType;
}> & import("@vue/composition-api").Data, {}, {}, {
    autoWidth: BooleanConstructor;
    borderless: BooleanConstructor;
    clearable: BooleanConstructor;
    collapsedItems: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: {
            value: import("./type").TagInputValue;
            collapsedSelectedItems: import("./type").TagInputValue;
            count: number;
            onClose: (context: {
                index: number;
                e?: MouseEvent;
            }) => void;
        }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    disabled: {
        type: BooleanConstructor;
        default: any;
    };
    dragSort: BooleanConstructor;
    excessTagsDisplayType: {
        type: import("vue").PropType<"scroll" | "break-line">;
        default: "scroll" | "break-line";
        validator(val: "scroll" | "break-line"): boolean;
    };
    inputProps: {
        type: import("vue").PropType<import("..").InputProps<import("..").InputValue>>;
    };
    inputValue: {
        type: import("vue").PropType<string>;
        default: any;
    };
    defaultInputValue: {
        type: import("vue").PropType<string>;
        default: string;
    };
    label: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    max: {
        type: NumberConstructor;
    };
    minCollapsedNum: {
        type: NumberConstructor;
        default: number;
    };
    placeholder: {
        type: StringConstructor;
        default: any;
    };
    prefixIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    readonly: BooleanConstructor;
    size: {
        type: import("vue").PropType<import("..").SizeEnum>;
        default: import("..").SizeEnum;
        validator(val: import("..").SizeEnum): boolean;
    };
    status: {
        type: import("vue").PropType<"error" | "default" | "success" | "warning">;
        validator(val: "error" | "default" | "success" | "warning"): boolean;
    };
    suffix: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    suffixIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    tag: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement, props: {
            value: string | number;
        }) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    tagProps: {
        type: import("vue").PropType<import("..").TdTagProps>;
    };
    tips: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    value: {
        type: import("vue").PropType<import("./type").TagInputValue>;
        default: any;
    };
    defaultValue: {
        type: import("vue").PropType<import("./type").TagInputValue>;
        default: () => import("./type").TagInputValue;
    };
    valueDisplay: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement, props: {
            value: import("./type").TagInputValue;
            onClose: (index: number, item?: any) => void;
        }) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    onBlur: import("vue").PropType<(value: import("./type").TagInputValue, context: {
        inputValue: string;
        e: FocusEvent;
    }) => void>;
    onChange: import("vue").PropType<(value: import("./type").TagInputValue, context: import("./type").TagInputChangeContext) => void>;
    onClear: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onClick: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onDragSort: import("vue").PropType<(context: import("./type").TagInputDragSortContext) => void>;
    onEnter: import("vue").PropType<(value: import("./type").TagInputValue, context: {
        e: KeyboardEvent;
        inputValue: string;
    }) => void>;
    onFocus: import("vue").PropType<(value: import("./type").TagInputValue, context: {
        inputValue: string;
        e: FocusEvent;
    }) => void>;
    onInputChange: import("vue").PropType<(value: string, context?: import("./type").InputValueChangeContext) => void>;
    onMouseenter: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onMouseleave: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onPaste: import("vue").PropType<(context: {
        e: ClipboardEvent;
        pasteValue: string;
    }) => void>;
    onRemove: import("vue").PropType<(context: import("./type").TagInputRemoveContext) => void>;
}, import("@vue/composition-api").ExtractPropTypes<{
    autoWidth: BooleanConstructor;
    borderless: BooleanConstructor;
    clearable: BooleanConstructor;
    collapsedItems: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: {
            value: import("./type").TagInputValue;
            collapsedSelectedItems: import("./type").TagInputValue;
            count: number;
            onClose: (context: {
                index: number;
                e?: MouseEvent;
            }) => void;
        }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    disabled: {
        type: BooleanConstructor;
        default: any;
    };
    dragSort: BooleanConstructor;
    excessTagsDisplayType: {
        type: import("vue").PropType<"scroll" | "break-line">;
        default: "scroll" | "break-line";
        validator(val: "scroll" | "break-line"): boolean;
    };
    inputProps: {
        type: import("vue").PropType<import("..").InputProps<import("..").InputValue>>;
    };
    inputValue: {
        type: import("vue").PropType<string>;
        default: any;
    };
    defaultInputValue: {
        type: import("vue").PropType<string>;
        default: string;
    };
    label: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    max: {
        type: NumberConstructor;
    };
    minCollapsedNum: {
        type: NumberConstructor;
        default: number;
    };
    placeholder: {
        type: StringConstructor;
        default: any;
    };
    prefixIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    readonly: BooleanConstructor;
    size: {
        type: import("vue").PropType<import("..").SizeEnum>;
        default: import("..").SizeEnum;
        validator(val: import("..").SizeEnum): boolean;
    };
    status: {
        type: import("vue").PropType<"error" | "default" | "success" | "warning">;
        validator(val: "error" | "default" | "success" | "warning"): boolean;
    };
    suffix: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    suffixIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    tag: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement, props: {
            value: string | number;
        }) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    tagProps: {
        type: import("vue").PropType<import("..").TdTagProps>;
    };
    tips: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    value: {
        type: import("vue").PropType<import("./type").TagInputValue>;
        default: any;
    };
    defaultValue: {
        type: import("vue").PropType<import("./type").TagInputValue>;
        default: () => import("./type").TagInputValue;
    };
    valueDisplay: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement, props: {
            value: import("./type").TagInputValue;
            onClose: (index: number, item?: any) => void;
        }) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    onBlur: import("vue").PropType<(value: import("./type").TagInputValue, context: {
        inputValue: string;
        e: FocusEvent;
    }) => void>;
    onChange: import("vue").PropType<(value: import("./type").TagInputValue, context: import("./type").TagInputChangeContext) => void>;
    onClear: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onClick: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onDragSort: import("vue").PropType<(context: import("./type").TagInputDragSortContext) => void>;
    onEnter: import("vue").PropType<(value: import("./type").TagInputValue, context: {
        e: KeyboardEvent;
        inputValue: string;
    }) => void>;
    onFocus: import("vue").PropType<(value: import("./type").TagInputValue, context: {
        inputValue: string;
        e: FocusEvent;
    }) => void>;
    onInputChange: import("vue").PropType<(value: string, context?: import("./type").InputValueChangeContext) => void>;
    onMouseenter: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onMouseleave: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onPaste: import("vue").PropType<(context: {
        e: ClipboardEvent;
        pasteValue: string;
    }) => void>;
    onRemove: import("vue").PropType<(context: import("./type").TagInputRemoveContext) => void>;
}>> & Omit<import("vue").VueConstructor<import("vue").default>, never> & (new (...args: any[]) => import("@vue/composition-api").ComponentRenderProxy<{
    value: import("./type").TagInputValue;
    disabled: boolean;
    size: import("..").SizeEnum;
    readonly: boolean;
    defaultValue: import("./type").TagInputValue;
    autoWidth: boolean;
    borderless: boolean;
    clearable: boolean;
    placeholder: string;
    inputValue: string;
    excessTagsDisplayType: "scroll" | "break-line";
    defaultInputValue: string;
    dragSort: boolean;
    minCollapsedNum: number;
} & {
    max?: number;
    label?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    status?: "error" | "default" | "success" | "warning";
    tag?: string | ((h: import("vue").CreateElement, props: {
        value: string | number;
    }) => import("vue/types/vnode").ScopedSlotReturnValue);
    onClick?: (context: {
        e: MouseEvent;
    }) => void;
    onChange?: (value: import("./type").TagInputValue, context: import("./type").TagInputChangeContext) => void;
    prefixIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    suffix?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    suffixIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onBlur?: (value: import("./type").TagInputValue, context: {
        inputValue: string;
        e: FocusEvent;
    }) => void;
    onClear?: (context: {
        e: MouseEvent;
    }) => void;
    onEnter?: (value: import("./type").TagInputValue, context: {
        e: KeyboardEvent;
        inputValue: string;
    }) => void;
    onFocus?: (value: import("./type").TagInputValue, context: {
        inputValue: string;
        e: FocusEvent;
    }) => void;
    onMouseenter?: (context: {
        e: MouseEvent;
    }) => void;
    onMouseleave?: (context: {
        e: MouseEvent;
    }) => void;
    onPaste?: (context: {
        e: ClipboardEvent;
        pasteValue: string;
    }) => void;
    collapsedItems?: (h: import("vue").CreateElement, props: {
        value: import("./type").TagInputValue;
        collapsedSelectedItems: import("./type").TagInputValue;
        count: number;
        onClose: (context: {
            index: number;
            e?: MouseEvent;
        }) => void;
    }) => import("vue/types/vnode").ScopedSlotReturnValue;
    inputProps?: unknown;
    tagProps?: unknown;
    valueDisplay?: string | ((h: import("vue").CreateElement, props: {
        value: import("./type").TagInputValue;
        onClose: (index: number, item?: any) => void;
    }) => import("vue/types/vnode").ScopedSlotReturnValue);
    onDragSort?: (context: import("./type").TagInputDragSortContext) => void;
    onInputChange?: (value: string, context?: import("./type").InputValueChangeContext) => void;
    onRemove?: (context: import("./type").TagInputRemoveContext) => void;
}, import("@vue/composition-api").ShallowUnwrapRef<{
    tagValue: import("@vue/composition-api").Ref<import("./type").TagInputValue>;
    tInputValue: import("@vue/composition-api").Ref<string>;
    isHover: import("@vue/composition-api").Ref<boolean>;
    tagInputPlaceholder: import("@vue/composition-api").ComputedRef<string>;
    showClearIcon: import("@vue/composition-api").ComputedRef<boolean>;
    tagInputRef: import("@vue/composition-api").Ref<any>;
    classPrefix: import("@vue/composition-api").Ref<string>;
    classes: import("@vue/composition-api").ComputedRef<(string | {
        [x: string]: boolean;
    })[]>;
    componentName: import("@vue/composition-api").Ref<string>;
    setTInputValue: (value: string, context?: import("./type").InputValueChangeContext) => void;
    addHover: (context: {
        e: MouseEvent;
    }) => void;
    cancelHover: (context: {
        e: MouseEvent;
    }) => void;
    onInputEnter: (value: string, context: {
        e: KeyboardEvent;
    }) => void;
    onInnerEnter: (value: string, params: {
        e: KeyboardEvent;
    }) => void;
    onInputBackspaceKeyUp: (value: import("..").InputValue) => void;
    onInputBackspaceKeyDown: (value: import("..").InputValue, p: {
        e: KeyboardEvent;
    }) => void;
    renderLabel: ({ displayNode, label }: {
        displayNode: any;
        label: any;
    }, h: import("vue").CreateElement) => any[];
    onWheel: ({ e }: {
        e: WheelEvent;
    }) => void;
    scrollToRightOnEnter: () => void;
    scrollToLeftOnLeave: () => void;
    onClearClick: (ctx: {
        e: MouseEvent;
    }) => void;
    onInnerClick: (context: {
        e: MouseEvent;
    }) => void;
    onClose: (p: {
        e?: MouseEvent;
        index: number;
    }) => void;
    onInputCompositionstart: (value: string, context: {
        e: CompositionEvent;
    }) => void;
    onInputCompositionend: (value: string, context: {
        e: CompositionEvent;
    }) => void;
    CloseCircleFilledIcon: import("tdesign-icons-vue").GlobalIconType;
}>, import("@vue/composition-api").Data, {}, {}, {}, {}, {}, {
    value: import("./type").TagInputValue;
    disabled: boolean;
    size: import("..").SizeEnum;
    readonly: boolean;
    defaultValue: import("./type").TagInputValue;
    autoWidth: boolean;
    borderless: boolean;
    clearable: boolean;
    placeholder: string;
    inputValue: string;
    excessTagsDisplayType: "scroll" | "break-line";
    defaultInputValue: string;
    dragSort: boolean;
    minCollapsedNum: number;
} & {
    max?: number;
    label?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    status?: "error" | "default" | "success" | "warning";
    tag?: string | ((h: import("vue").CreateElement, props: {
        value: string | number;
    }) => import("vue/types/vnode").ScopedSlotReturnValue);
    onClick?: (context: {
        e: MouseEvent;
    }) => void;
    onChange?: (value: import("./type").TagInputValue, context: import("./type").TagInputChangeContext) => void;
    prefixIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    suffix?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    suffixIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onBlur?: (value: import("./type").TagInputValue, context: {
        inputValue: string;
        e: FocusEvent;
    }) => void;
    onClear?: (context: {
        e: MouseEvent;
    }) => void;
    onEnter?: (value: import("./type").TagInputValue, context: {
        e: KeyboardEvent;
        inputValue: string;
    }) => void;
    onFocus?: (value: import("./type").TagInputValue, context: {
        inputValue: string;
        e: FocusEvent;
    }) => void;
    onMouseenter?: (context: {
        e: MouseEvent;
    }) => void;
    onMouseleave?: (context: {
        e: MouseEvent;
    }) => void;
    onPaste?: (context: {
        e: ClipboardEvent;
        pasteValue: string;
    }) => void;
    collapsedItems?: (h: import("vue").CreateElement, props: {
        value: import("./type").TagInputValue;
        collapsedSelectedItems: import("./type").TagInputValue;
        count: number;
        onClose: (context: {
            index: number;
            e?: MouseEvent;
        }) => void;
    }) => import("vue/types/vnode").ScopedSlotReturnValue;
    inputProps?: unknown;
    tagProps?: unknown;
    valueDisplay?: string | ((h: import("vue").CreateElement, props: {
        value: import("./type").TagInputValue;
        onClose: (index: number, item?: any) => void;
    }) => import("vue/types/vnode").ScopedSlotReturnValue);
    onDragSort?: (context: import("./type").TagInputDragSortContext) => void;
    onInputChange?: (value: string, context?: import("./type").InputValueChangeContext) => void;
    onRemove?: (context: import("./type").TagInputRemoveContext) => void;
}, {
    value: import("./type").TagInputValue;
    disabled: boolean;
    size: import("..").SizeEnum;
    readonly: boolean;
    defaultValue: import("./type").TagInputValue;
    autoWidth: boolean;
    borderless: boolean;
    clearable: boolean;
    placeholder: string;
    inputValue: string;
    excessTagsDisplayType: "scroll" | "break-line";
    defaultInputValue: string;
    dragSort: boolean;
    minCollapsedNum: number;
}, true>)>;
export default TagInput;
