import { RangeInputPosition } from '../range-input';
import { TimeRangeValue } from './interface';
import type { TimeRangePickerPartial } from './type';
declare const _default: import("vue").ComponentOptions<import("vue").default, import("@vue/composition-api").ShallowUnwrapRef<{
    global: import("@vue/composition-api").ComputedRef<{} & (import("..").TimePickerConfig | {
        readonly dayjsLocale: "zh-cn";
        readonly now: "此刻";
        readonly confirm: "确定";
        readonly anteMeridiem: "上午";
        readonly postMeridiem: "下午";
        readonly placeholder: "选择时间";
    }) & import("..").TimePickerConfig>;
    componentName: import("@vue/composition-api").ComputedRef<string>;
    currentValue: import("@vue/composition-api").Ref<string[]>;
    currentPanelIdx: any;
    inputClasses: import("@vue/composition-api").ComputedRef<(string | {
        [x: string]: boolean;
    })[]>;
    innerValue: import("@vue/composition-api").Ref<TimeRangeValue>;
    isShowPanel: import("@vue/composition-api").Ref<boolean>;
    handleInputChange: (inputVal: TimeRangeValue, { e, position }: {
        e: InputEvent;
        position: RangeInputPosition;
    }) => void;
    handleShowPopup: (visible: boolean, context: any) => void;
    handleClear: (context: {
        e: MouseEvent;
    }) => void;
    handleFocus: (value: TimeRangeValue, { e, position }: {
        e: FocusEvent;
        position: RangeInputPosition;
    }) => void;
    handleOnPick: (pickValue: string, e: MouseEvent) => void;
    handleClickConfirm: () => void;
    handleClick: ({ position }: {
        position: 'first' | 'second';
    }) => void;
    handleInputBlur: (value: TimeRangeValue, { e }: {
        e: FocusEvent;
    }) => void;
    handleTimeChange: (newValue: string) => void;
    TimeIcon: import("tdesign-icons-vue").GlobalIconType;
    isDisabled: import("@vue/composition-api").ComputedRef<boolean | boolean[]>;
}> & import("@vue/composition-api").Data, {}, {}, {
    rangeInputProps: ObjectConstructor;
    popupProps: ObjectConstructor;
    allowInput: BooleanConstructor;
    autoSwap: {
        type: BooleanConstructor;
        default: boolean;
    };
    borderless: BooleanConstructor;
    clearable: BooleanConstructor;
    disableTime: {
        type: import("vue").PropType<(h: number, m: number, s: number, context: {
            partial: TimeRangePickerPartial;
        }) => Partial<{
            hour: number[];
            minute: number[];
            second: number[];
        }>>;
    };
    disabled: {
        type: import("vue").PropType<boolean | boolean[]>;
        default: any;
    };
    readonly: {
        type: BooleanConstructor;
        default: any;
    };
    format: {
        type: StringConstructor;
        default: string;
    };
    hideDisabledTime: {
        type: BooleanConstructor;
        default: boolean;
    };
    placeholder: {
        type: import("vue").PropType<string | string[]>;
        default: any;
    };
    presets: {
        type: import("vue").PropType<import("./type").PresetTimeRange>;
    };
    size: {
        type: import("vue").PropType<"small" | "medium" | "large">;
        default: "small" | "medium" | "large";
        validator(val: "small" | "medium" | "large"): boolean;
    };
    status: {
        type: import("vue").PropType<"error" | "default" | "success" | "warning">;
        default: "error" | "default" | "success" | "warning";
        validator(val: "error" | "default" | "success" | "warning"): boolean;
    };
    steps: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    tips: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    value: {
        type: import("vue").PropType<TimeRangeValue>;
        default: any;
    };
    defaultValue: {
        type: import("vue").PropType<TimeRangeValue>;
    };
    onBlur: import("vue").PropType<(context: {
        value: TimeRangeValue;
        e?: FocusEvent;
        position?: TimeRangePickerPartial;
    }) => void>;
    onChange: import("vue").PropType<(value: TimeRangeValue) => void>;
    onFocus: import("vue").PropType<(context?: {
        value: TimeRangeValue;
        e?: FocusEvent;
        position?: TimeRangePickerPartial;
    }) => void>;
    onInput: import("vue").PropType<(context: {
        value: TimeRangeValue;
        e?: InputEvent;
        position?: TimeRangePickerPartial;
    }) => void>;
    onPick: import("vue").PropType<(value: TimeRangeValue, context: {
        e: MouseEvent;
        position?: TimeRangePickerPartial;
    }) => void>;
}, import("@vue/composition-api").ExtractPropTypes<{
    rangeInputProps: ObjectConstructor;
    popupProps: ObjectConstructor;
    allowInput: BooleanConstructor;
    autoSwap: {
        type: BooleanConstructor;
        default: boolean;
    };
    borderless: BooleanConstructor;
    clearable: BooleanConstructor;
    disableTime: {
        type: import("vue").PropType<(h: number, m: number, s: number, context: {
            partial: TimeRangePickerPartial;
        }) => Partial<{
            hour: number[];
            minute: number[];
            second: number[];
        }>>;
    };
    disabled: {
        type: import("vue").PropType<boolean | boolean[]>;
        default: any;
    };
    readonly: {
        type: BooleanConstructor;
        default: any;
    };
    format: {
        type: StringConstructor;
        default: string;
    };
    hideDisabledTime: {
        type: BooleanConstructor;
        default: boolean;
    };
    placeholder: {
        type: import("vue").PropType<string | string[]>;
        default: any;
    };
    presets: {
        type: import("vue").PropType<import("./type").PresetTimeRange>;
    };
    size: {
        type: import("vue").PropType<"small" | "medium" | "large">;
        default: "small" | "medium" | "large";
        validator(val: "small" | "medium" | "large"): boolean;
    };
    status: {
        type: import("vue").PropType<"error" | "default" | "success" | "warning">;
        default: "error" | "default" | "success" | "warning";
        validator(val: "error" | "default" | "success" | "warning"): boolean;
    };
    steps: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    tips: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    value: {
        type: import("vue").PropType<TimeRangeValue>;
        default: any;
    };
    defaultValue: {
        type: import("vue").PropType<TimeRangeValue>;
    };
    onBlur: import("vue").PropType<(context: {
        value: TimeRangeValue;
        e?: FocusEvent;
        position?: TimeRangePickerPartial;
    }) => void>;
    onChange: import("vue").PropType<(value: TimeRangeValue) => void>;
    onFocus: import("vue").PropType<(context?: {
        value: TimeRangeValue;
        e?: FocusEvent;
        position?: TimeRangePickerPartial;
    }) => void>;
    onInput: import("vue").PropType<(context: {
        value: TimeRangeValue;
        e?: InputEvent;
        position?: TimeRangePickerPartial;
    }) => void>;
    onPick: import("vue").PropType<(value: TimeRangeValue, context: {
        e: MouseEvent;
        position?: TimeRangePickerPartial;
    }) => void>;
}>> & Omit<import("vue").VueConstructor<import("vue").default>, never> & (new (...args: any[]) => import("@vue/composition-api").ComponentRenderProxy<{
    value: TimeRangeValue;
    disabled: boolean | boolean[];
    size: "small" | "medium" | "large";
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    steps: (string | number)[];
    format: string;
    borderless: boolean;
    clearable: boolean;
    placeholder: string | string[];
    allowInput: boolean;
    hideDisabledTime: boolean;
    autoSwap: boolean;
} & {
    onChange?: (value: TimeRangeValue) => void;
    defaultValue?: TimeRangeValue;
    tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onBlur?: (context: {
        value: TimeRangeValue;
        e?: FocusEvent;
        position?: TimeRangePickerPartial;
    }) => void;
    onFocus?: (context?: {
        value: TimeRangeValue;
        e?: FocusEvent;
        position?: TimeRangePickerPartial;
    }) => void;
    popupProps?: Record<string, any>;
    rangeInputProps?: Record<string, any>;
    disableTime?: (h: number, m: number, s: number, context: {
        partial: TimeRangePickerPartial;
    }) => Partial<{
        hour: number[];
        minute: number[];
        second: number[];
    }>;
    presets?: import("./type").PresetTimeRange;
    onInput?: (context: {
        value: TimeRangeValue;
        e?: InputEvent;
        position?: TimeRangePickerPartial;
    }) => void;
    onPick?: (value: TimeRangeValue, context: {
        e: MouseEvent;
        position?: TimeRangePickerPartial;
    }) => void;
}, import("@vue/composition-api").ShallowUnwrapRef<{
    global: import("@vue/composition-api").ComputedRef<{} & (import("..").TimePickerConfig | {
        readonly dayjsLocale: "zh-cn";
        readonly now: "此刻";
        readonly confirm: "确定";
        readonly anteMeridiem: "上午";
        readonly postMeridiem: "下午";
        readonly placeholder: "选择时间";
    }) & import("..").TimePickerConfig>;
    componentName: import("@vue/composition-api").ComputedRef<string>;
    currentValue: import("@vue/composition-api").Ref<string[]>;
    currentPanelIdx: any;
    inputClasses: import("@vue/composition-api").ComputedRef<(string | {
        [x: string]: boolean;
    })[]>;
    innerValue: import("@vue/composition-api").Ref<TimeRangeValue>;
    isShowPanel: import("@vue/composition-api").Ref<boolean>;
    handleInputChange: (inputVal: TimeRangeValue, { e, position }: {
        e: InputEvent;
        position: RangeInputPosition;
    }) => void;
    handleShowPopup: (visible: boolean, context: any) => void;
    handleClear: (context: {
        e: MouseEvent;
    }) => void;
    handleFocus: (value: TimeRangeValue, { e, position }: {
        e: FocusEvent;
        position: RangeInputPosition;
    }) => void;
    handleOnPick: (pickValue: string, e: MouseEvent) => void;
    handleClickConfirm: () => void;
    handleClick: ({ position }: {
        position: 'first' | 'second';
    }) => void;
    handleInputBlur: (value: TimeRangeValue, { e }: {
        e: FocusEvent;
    }) => void;
    handleTimeChange: (newValue: string) => void;
    TimeIcon: import("tdesign-icons-vue").GlobalIconType;
    isDisabled: import("@vue/composition-api").ComputedRef<boolean | boolean[]>;
}>, import("@vue/composition-api").Data, {}, {}, {}, {}, {}, {
    value: TimeRangeValue;
    disabled: boolean | boolean[];
    size: "small" | "medium" | "large";
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    steps: (string | number)[];
    format: string;
    borderless: boolean;
    clearable: boolean;
    placeholder: string | string[];
    allowInput: boolean;
    hideDisabledTime: boolean;
    autoSwap: boolean;
} & {
    onChange?: (value: TimeRangeValue) => void;
    defaultValue?: TimeRangeValue;
    tips?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onBlur?: (context: {
        value: TimeRangeValue;
        e?: FocusEvent;
        position?: TimeRangePickerPartial;
    }) => void;
    onFocus?: (context?: {
        value: TimeRangeValue;
        e?: FocusEvent;
        position?: TimeRangePickerPartial;
    }) => void;
    popupProps?: Record<string, any>;
    rangeInputProps?: Record<string, any>;
    disableTime?: (h: number, m: number, s: number, context: {
        partial: TimeRangePickerPartial;
    }) => Partial<{
        hour: number[];
        minute: number[];
        second: number[];
    }>;
    presets?: import("./type").PresetTimeRange;
    onInput?: (context: {
        value: TimeRangeValue;
        e?: InputEvent;
        position?: TimeRangePickerPartial;
    }) => void;
    onPick?: (value: TimeRangeValue, context: {
        e: MouseEvent;
        position?: TimeRangePickerPartial;
    }) => void;
}, {
    value: TimeRangeValue;
    disabled: boolean | boolean[];
    size: "small" | "medium" | "large";
    readonly: boolean;
    status: "error" | "default" | "success" | "warning";
    steps: (string | number)[];
    format: string;
    borderless: boolean;
    clearable: boolean;
    placeholder: string | string[];
    allowInput: boolean;
    hideDisabledTime: boolean;
    autoSwap: boolean;
}, true>);
export default _default;
