/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

var TimelineProps = {
  labelAlign: {
    type: String,
    "default": "left",
    validator: function validator(val) {
      if (!val) return true;
      return ["left", "right", "alternate", "top", "bottom"].includes(val);
    }
  },
  layout: {
    type: String,
    "default": "vertical",
    validator: function validator(val) {
      if (!val) return true;
      return ["horizontal", "vertical"].includes(val);
    }
  },
  mode: {
    type: String,
    "default": "alternate",
    validator: function validator(val) {
      if (!val) return true;
      return ["alternate", "same"].includes(val);
    }
  },
  reverse: Boolean,
  theme: {
    type: String,
    "default": "default",
    validator: function validator(val) {
      if (!val) return true;
      return ["default", "dot"].includes(val);
    }
  }
};

export { TimelineProps as default };
//# sourceMappingURL=props.js.map
