import { SetupContext } from '@vue/composition-api';
import { TdTreeSelectProps, TreeSelectValue } from './type';
import { TreeNodeValue } from '../tree';
import { TreeOptionData, TreeKeysType } from '../common';
export default function useTreeSelect(props: TdTreeSelectProps, context: SetupContext): {
    classPrefix: import("@vue/composition-api").ComputedRef<string>;
    global: import("@vue/composition-api").ComputedRef<{} & (import("..").TreeSelectConfig | {
        readonly empty: "暂无数据";
        readonly loadingText: "加载中";
        readonly placeholder: "请选择";
    }) & import("..").TreeSelectConfig>;
    tDisabled: import("@vue/composition-api").ComputedRef<boolean>;
    treeRef: import("@vue/composition-api").Ref<{
        appendTo: (value: TreeNodeValue, newData: TreeOptionData<string | number> | TreeOptionData<string | number>[]) => void;
        getIndex: (value: TreeNodeValue) => number;
        getItem: (value: TreeNodeValue) => import("../tree").TreeNodeModel<TreeOptionData<string | number>>;
        getItems: (value?: TreeNodeValue) => import("../tree").TreeNodeModel<TreeOptionData<string | number>>[];
        getParent: (value: TreeNodeValue) => import("../tree").TreeNodeModel<TreeOptionData<string | number>>;
        getParents: (value: TreeNodeValue) => import("../tree").TreeNodeModel<TreeOptionData<string | number>>[];
        getPath: (value: TreeNodeValue) => import("../tree").TreeNodeModel<TreeOptionData<string | number>>[];
        getTreeData: (value?: TreeNodeValue) => TreeOptionData<string | number>[];
        insertAfter: (value: TreeNodeValue, newData: TreeOptionData<string | number>) => void;
        insertBefore: (value: TreeNodeValue, newData: TreeOptionData<string | number>) => void;
        refresh: () => void;
        remove: (value: TreeNodeValue) => void;
        scrollTo?: (scrollToParams: import("../common").ScrollToElementParams) => void;
        setItem: (value: TreeNodeValue, options: import("../tree").TreeNodeState) => void;
    }>;
    tKeys: import("@vue/composition-api").ComputedRef<TreeKeysType>;
    treeKey: import("@vue/composition-api").Ref<number>;
    popupClass: import("@vue/composition-api").ComputedRef<string[]>;
    isObjectValue: import("@vue/composition-api").ComputedRef<boolean>;
    dropdownInnerSize: import("@vue/composition-api").ComputedRef<string>;
    inputPlaceholder: import("@vue/composition-api").ComputedRef<any>;
    innerVisible: import("@vue/composition-api").Ref<boolean>;
    nodeInfo: import("@vue/composition-api").ComputedRef<TreeOptionData<string | number> | TreeOptionData<string | number>[]>;
    treeSelectValue: import("@vue/composition-api").Ref<TreeSelectValue>;
    innerInputValue: import("@vue/composition-api").Ref<string>;
    multipleChecked: import("@vue/composition-api").ComputedRef<TreeNodeValue[]>;
    singleActivated: import("@vue/composition-api").ComputedRef<any[]>;
    clear: (context: {
        e: MouseEvent;
    }) => void;
    filterByText: import("@vue/composition-api").ComputedRef<(node: import("../tree").TreeNodeModel<import("../tree/adapt").TypeTreeOptionData>) => boolean>;
    setInnerVisible: (value: boolean, context: import("./type").TreeSelectPopupVisibleContext<TreeOptionData<string | number>>) => void;
    setTreeSelectValue: import("../hooks/useVModel").ChangeHandler<TreeSelectValue, [context: import("./type").TreeSelectChangeContext<TreeOptionData<string | number>>]>;
    setInnerInputValue: (value: string, context: import("../select-input").SelectInputValueChangeContext) => void;
    treeNodeChange: (value: TreeNodeValue[], context: {
        node: import("../tree").TreeNodeModel<import("../tree/adapt").TypeTreeOptionData>;
        e?: any;
        trigger: "setItem" | "node-click";
    }) => void;
    treeNodeActive: (value: TreeNodeValue[], context: {
        node: import("../tree").TreeNodeModel<import("../tree/adapt").TypeTreeOptionData>;
        e?: MouseEvent;
        trigger: "setItem" | "node-click";
    }) => void;
    inputChange: (value: string, context?: import("../select-input").SelectInputValueChangeContext) => void;
    tagChange: (value: import("..").TagInputValue, context: import("..").TagInputChangeContext) => void;
    onInnerPopupVisibleChange: (visible: boolean, context: import("..").PopupVisibleChangeContext) => void;
    onInnerFocus: (value: import("../select-input").SelectInputValue, context: import("../select-input").SelectInputFocusContext) => void;
    onInnerBlur: (value: import("../select-input").SelectInputValue, context: import("../select-input").SelectInputBlurContext) => void;
    onInnerEnter: (value: import("../select-input").SelectInputValue, context: {
        e: KeyboardEvent;
        inputValue: string;
        tagInputValue?: import("..").TagInputValue;
    }) => void;
};
