/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

import { set, isNil, get } from 'lodash-es';

function getNodeDataByValue(values, data, keys) {
  var _getTreeNodeData = function getTreeNodeData(values2, data2, keys2) {
    var results2 = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : /* @__PURE__ */new Map();
    var _loop = function _loop() {
        var _item$children;
        var item = data2[i];
        var index = values2.findIndex(function (val) {
          return get(item, keys2.value) === val;
        });
        if (index !== -1) {
          results2.set(values2[index], item);
        }
        if (Array.isArray(item.children) && (_item$children = item.children) !== null && _item$children !== void 0 && _item$children.length) {
          _getTreeNodeData(values2, item.children, keys2, results2);
        }
        if (results2.size >= values2.length) {
          return {
            v: results2
          };
        }
      },
      _ret;
    for (var i = 0, len = data2.length; i < len; i++) {
      _ret = _loop();
      if (_ret) return _ret.v;
    }
    return results2;
  };
  var results = _getTreeNodeData(values, data, keys);
  if (values.length && results.size < values.length) {
    values.forEach(function (value) {
      if (!results.get(value)) {
        var obj = {};
        set(obj, keys.label, value);
        set(obj, keys.value, value);
        results.set(value, obj);
      }
    });
  }
  return values.map(function (value) {
    return results.get(value);
  });
}
function normalizeArray(value) {
  if (isNil(value)) {
    return [];
  }
  return Array.isArray(value) ? value : [value];
}
var utils = {};

export { utils as default, getNodeDataByValue, normalizeArray };
//# sourceMappingURL=utils.js.map
