/**
 * tdesign v1.11.2
 * (c) 2025 tdesign
 * @license MIT
 */

import { toRefs, ref } from '@vue/composition-api';

function useItemState(props, context) {
  var refProps = toRefs(props);
  var treeItemRef = ref(null);
  var treeScope = props.treeScope;
  var store = treeScope.store;
  var node = store.privateMap.get(props.itemKey);
  var state = {
    stateId: props.stateId,
    props: props,
    context: context,
    treeScope: treeScope,
    refProps: refProps,
    node: node,
    treeItemRef: treeItemRef
  };
  return {
    state: state
  };
}

export { useItemState as default };
//# sourceMappingURL=useItemState.js.map
