import { CreateElement } from 'vue';
import { PropType } from '@vue/composition-api';
import { CommonDisplayFileProps } from '../interface';
import { TdUploadProps, UploadFile } from '../type';
export interface ImageCardUploadProps extends CommonDisplayFileProps {
    multiple: TdUploadProps['multiple'];
    max: TdUploadProps['max'];
    disabled?: TdUploadProps['disabled'];
    showUploadProgress: TdUploadProps['showUploadProgress'];
    triggerUpload?: (e: MouseEvent) => void;
    uploadFiles?: (toFiles?: UploadFile[]) => void;
    cancelUpload?: (context: {
        e: MouseEvent;
        file: UploadFile;
    }) => void;
}
declare const _default: import("vue").ComponentOptions<import("vue").default, import("@vue/composition-api").ShallowUnwrapRef<{
    icons: import("tdesign-icons-vue").GlobalIconConfig;
    showTrigger: import("@vue/composition-api").ComputedRef<boolean>;
}> & import("@vue/composition-api").Data, {
    renderMainContent(file: UploadFile, index: number): JSX.Element;
    renderProgressFile(file: UploadFile, loadCard: string): JSX.Element;
    renderFailFile(file: UploadFile, index: number, loadCard: string): JSX.Element;
}, {}, {
    multiple: BooleanConstructor;
    max: NumberConstructor;
    disabled: BooleanConstructor;
    showUploadProgress: BooleanConstructor;
    triggerUpload: PropType<(e: MouseEvent) => void>;
    uploadFiles: PropType<(toFiles?: UploadFile[]) => void>;
    cancelUpload: PropType<(context: {
        e: MouseEvent;
        file: UploadFile;
    }) => void>;
    showImageFileName: BooleanConstructor;
    accept: StringConstructor;
    files: import("vue").PropType<UploadFile[]>;
    toUploadFiles: import("vue").PropType<UploadFile[]>;
    displayFiles: import("vue").PropType<UploadFile[]>;
    theme: import("vue").PropType<"file" | "custom" | "image" | "file-input" | "file-flow" | "image-flow">;
    abridgeName: import("vue").PropType<number[]>;
    placeholder: StringConstructor;
    classPrefix: StringConstructor;
    tips: (FunctionConstructor | StringConstructor)[];
    status: import("vue").PropType<"error" | "default" | "success" | "warning">;
    locale: import("vue").PropType<import("../..").UploadConfig>;
    sizeOverLimitMessage: StringConstructor;
    autoUpload: BooleanConstructor;
    uploading: BooleanConstructor;
    tipsClasses: import("vue").PropType<string>;
    errorClasses: import("vue").PropType<string[]>;
    placeholderClass: import("vue").PropType<string>;
    default: import("vue").PropType<(h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    fileListDisplay: import("vue").PropType<(h: CreateElement, props: {
        files: UploadFile[];
        dragEvents?: import("../..").UploadDisplayDragEvents;
    }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    onRemove: import("vue").PropType<(p: import("../type").UploadRemoveContext) => void>;
    imageViewerProps: import("vue").PropType<import("../../image-viewer").TdImageViewerProps>;
}, import("@vue/composition-api").ExtractPropTypes<{
    multiple: BooleanConstructor;
    max: NumberConstructor;
    disabled: BooleanConstructor;
    showUploadProgress: BooleanConstructor;
    triggerUpload: PropType<(e: MouseEvent) => void>;
    uploadFiles: PropType<(toFiles?: UploadFile[]) => void>;
    cancelUpload: PropType<(context: {
        e: MouseEvent;
        file: UploadFile;
    }) => void>;
    showImageFileName: BooleanConstructor;
    accept: StringConstructor;
    files: import("vue").PropType<UploadFile[]>;
    toUploadFiles: import("vue").PropType<UploadFile[]>;
    displayFiles: import("vue").PropType<UploadFile[]>;
    theme: import("vue").PropType<"file" | "custom" | "image" | "file-input" | "file-flow" | "image-flow">;
    abridgeName: import("vue").PropType<number[]>;
    placeholder: StringConstructor;
    classPrefix: StringConstructor;
    tips: (FunctionConstructor | StringConstructor)[];
    status: import("vue").PropType<"error" | "default" | "success" | "warning">;
    locale: import("vue").PropType<import("../..").UploadConfig>;
    sizeOverLimitMessage: StringConstructor;
    autoUpload: BooleanConstructor;
    uploading: BooleanConstructor;
    tipsClasses: import("vue").PropType<string>;
    errorClasses: import("vue").PropType<string[]>;
    placeholderClass: import("vue").PropType<string>;
    default: import("vue").PropType<(h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    fileListDisplay: import("vue").PropType<(h: CreateElement, props: {
        files: UploadFile[];
        dragEvents?: import("../..").UploadDisplayDragEvents;
    }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    onRemove: import("vue").PropType<(p: import("../type").UploadRemoveContext) => void>;
    imageViewerProps: import("vue").PropType<import("../../image-viewer").TdImageViewerProps>;
}>> & Omit<import("vue").VueConstructor<import("vue").default>, never> & (new (...args: any[]) => import("@vue/composition-api").ComponentRenderProxy<{
    disabled: boolean;
    multiple: boolean;
    autoUpload: boolean;
    uploading: boolean;
    showUploadProgress: boolean;
    showImageFileName: boolean;
} & {
    max?: number;
    default?: (h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    status?: "error" | "default" | "success" | "warning";
    classPrefix?: string;
    theme?: "file" | "custom" | "image" | "file-input" | "file-flow" | "image-flow";
    tips?: string;
    errorClasses?: string[];
    placeholder?: string;
    onRemove?: (p: import("../type").UploadRemoveContext) => void;
    locale?: unknown;
    files?: UploadFile[];
    abridgeName?: number[];
    fileListDisplay?: (h: CreateElement, props: {
        files: UploadFile[];
        dragEvents?: import("../..").UploadDisplayDragEvents;
    }) => import("vue/types/vnode").ScopedSlotReturnValue;
    imageViewerProps?: unknown;
    toUploadFiles?: UploadFile[];
    displayFiles?: UploadFile[];
    tipsClasses?: string;
    placeholderClass?: string;
    accept?: string;
    sizeOverLimitMessage?: string;
    triggerUpload?: (e: MouseEvent) => void;
    uploadFiles?: (toFiles?: UploadFile[]) => void;
    cancelUpload?: (context: {
        e: MouseEvent;
        file: UploadFile;
    }) => void;
}, import("@vue/composition-api").ShallowUnwrapRef<{
    icons: import("tdesign-icons-vue").GlobalIconConfig;
    showTrigger: import("@vue/composition-api").ComputedRef<boolean>;
}>, import("@vue/composition-api").Data, {}, {
    renderMainContent(file: UploadFile, index: number): JSX.Element;
    renderProgressFile(file: UploadFile, loadCard: string): JSX.Element;
    renderFailFile(file: UploadFile, index: number, loadCard: string): JSX.Element;
}, {}, {}, {}, {
    disabled: boolean;
    multiple: boolean;
    autoUpload: boolean;
    uploading: boolean;
    showUploadProgress: boolean;
    showImageFileName: boolean;
} & {
    max?: number;
    default?: (h: CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    status?: "error" | "default" | "success" | "warning";
    classPrefix?: string;
    theme?: "file" | "custom" | "image" | "file-input" | "file-flow" | "image-flow";
    tips?: string;
    errorClasses?: string[];
    placeholder?: string;
    onRemove?: (p: import("../type").UploadRemoveContext) => void;
    locale?: unknown;
    files?: UploadFile[];
    abridgeName?: number[];
    fileListDisplay?: (h: CreateElement, props: {
        files: UploadFile[];
        dragEvents?: import("../..").UploadDisplayDragEvents;
    }) => import("vue/types/vnode").ScopedSlotReturnValue;
    imageViewerProps?: unknown;
    toUploadFiles?: UploadFile[];
    displayFiles?: UploadFile[];
    tipsClasses?: string;
    placeholderClass?: string;
    accept?: string;
    sizeOverLimitMessage?: string;
    triggerUpload?: (e: MouseEvent) => void;
    uploadFiles?: (toFiles?: UploadFile[]) => void;
    cancelUpload?: (context: {
        e: MouseEvent;
        file: UploadFile;
    }) => void;
}, {
    disabled: boolean;
    multiple: boolean;
    autoUpload: boolean;
    uploading: boolean;
    showUploadProgress: boolean;
    showImageFileName: boolean;
}, true>);
export default _default;
