/// <reference types="sortablejs" />
import './style';
export * from './type';
export * from './interface';
export declare const BaseTable: import("vue").ComponentOptions<import("vue").default, import("@vue/composition-api").ShallowUnwrapRef<{
    virtualConfig: {
        visibleData: import("@vue/composition-api").Ref<any[]>;
        translateY: import("@vue/composition-api").Ref<number>;
        scrollHeight: import("@vue/composition-api").Ref<number>;
        isVirtualScroll: import("@vue/composition-api").ComputedRef<boolean>;
        handleScroll: () => void;
        handleRowMounted: (rowData: any) => void;
        scrollToElement: (p: import("../hooks").ScrollToElementParams) => void;
    };
    scrollToElement: (params: import("..").ComponentScrollToElementParams) => void;
    columnResizable: import("@vue/composition-api").ComputedRef<boolean>;
    thList: import("@vue/composition-api").ComputedRef<import("./type").BaseTableCol<import("./type").TableRowData>[][]>;
    classPrefix: string;
    innerPagination: import("@vue/composition-api").Ref<import("..").TdPaginationProps>;
    global: import("@vue/composition-api").ComputedRef<{} & (import("..").TableConfig | ({
        readonly expandIcon: any;
        readonly sortIcon: any;
        readonly filterIcon: any;
        readonly treeExpandAndFoldIcon: any;
        readonly hideSortTips: false;
        readonly size: "medium";
    } & {
        readonly empty: "暂无数据";
        readonly loadingText: "正在加载中，请稍后";
        readonly loadingMoreText: "点击加载更多";
        readonly filterInputPlaceholder: "请输入内容（无默认值）";
        readonly sortAscendingOperationText: "点击升序";
        readonly sortCancelOperationText: "点击取消排序";
        readonly sortDescendingOperationText: "点击降序";
        readonly clearFilterResultButtonText: "清空筛选";
        readonly columnConfigButtonText: "列配置";
        readonly columnConfigTitleText: "表格列配置";
        readonly columnConfigDescriptionText: "请选择需要在表格中显示的数据列";
        readonly confirmText: "确认";
        readonly cancelText: "取消";
        readonly resetText: "重置";
        readonly selectAllText: "全选";
        readonly searchResultText: "搜索“{result}”，找到 {count} 条结果";
    })) & import("..").TableConfig>;
    tableSize: import("@vue/composition-api").ComputedRef<import("..").SizeEnum>;
    tableFootHeight: import("@vue/composition-api").Ref<number>;
    tableWidth: import("@vue/composition-api").Ref<number>;
    tableElmWidth: import("@vue/composition-api").Ref<number>;
    tableRef: import("@vue/composition-api").Ref<HTMLDivElement>;
    tableElmRef: import("@vue/composition-api").Ref<HTMLTableElement>;
    sizeClassNames: {
        small: string;
        medium: string;
        large: string;
        default: string;
        xs: string;
        xl: string;
        block: string;
    };
    tableBaseClass: {
        table: (string | {
            [x: string]: boolean;
        })[];
        columnResizableTable: string;
        overflowVisible: string;
        body: string;
        content: string;
        topContent: string;
        bottomContent: string;
        paginationWrap: string;
        tdLastRow: string;
        tdFirstCol: string;
        thCellInner: string;
        tableRowEdit: string;
        cellEditable: string;
        cellEditWrap: string;
        bordered: string;
        striped: string;
        hover: string;
        loading: string;
        rowspanAndColspan: string;
        empty: string;
        emptyRow: string;
        headerFixed: string;
        columnFixed: string;
        widthOverflow: string;
        multipleHeader: string;
        footerAffixed: string;
        horizontalBarAffixed: string;
        affixedHeader: string;
        affixedHeaderElm: string;
        affixedFooterElm: string;
        affixedFooterWrap: string;
        scrollbarDivider: string;
        fullHeight: string;
        resizeLine: string;
        obviousScrollbar: string;
        affixedHeaderWrap: string;
    };
    spansAndLeafNodes: import("@vue/composition-api").ComputedRef<{
        rowspanAndColspanMap: import("./interface").ThRowspanAndColspan;
        leafColumns: import("./type").BaseTableCol<import("./type").TableRowData>[];
    }>;
    dynamicBaseTableClasses: import("@vue/composition-api").ComputedRef<import("..").ClassName[]>;
    tableContentStyles: import("@vue/composition-api").ComputedRef<import("..").Styles>;
    tableElementStyles: import("@vue/composition-api").ComputedRef<import("..").Styles>;
    virtualScrollClasses: {
        cursor: string;
        header: string;
    };
    tableLayoutClasses: {
        auto: string;
        fixed: string;
    };
    tableElmClasses: import("@vue/composition-api").ComputedRef<string[][]>;
    dividerBottom: import("@vue/composition-api").ComputedRef<number>;
    tableContentRef: import("@vue/composition-api").Ref<HTMLDivElement>;
    isFixedHeader: import("@vue/composition-api").Ref<boolean>;
    isWidthOverflow: import("@vue/composition-api").Ref<boolean>;
    isFixedColumn: import("@vue/composition-api").Ref<boolean>;
    rowAndColFixedPosition: import("@vue/composition-api").Ref<import("./interface").RowAndColFixedPosition>;
    showColumnShadow: {
        left: boolean;
        right: boolean;
    };
    thWidthList: import("@vue/composition-api").Ref<{
        [x: string]: number;
    }>;
    isPaginateData: import("@vue/composition-api").ComputedRef<boolean>;
    dataSource: import("@vue/composition-api").Ref<{
        [x: string]: any;
        children?: any[];
    }[]>;
    affixHeaderRef: import("@vue/composition-api").Ref<HTMLDivElement>;
    affixFooterRef: import("@vue/composition-api").Ref<HTMLDivElement>;
    paginationRef: import("@vue/composition-api").Ref<HTMLDivElement>;
    bottomContentRef: import("@vue/composition-api").Ref<HTMLDivElement>;
    showAffixHeader: import("@vue/composition-api").Ref<boolean>;
    showAffixFooter: import("@vue/composition-api").Ref<boolean>;
    scrollbarWidth: import("@vue/composition-api").Ref<number>;
    isMultipleHeader: import("@vue/composition-api").ComputedRef<boolean>;
    showRightDivider: import("@vue/composition-api").ComputedRef<boolean>;
    resizeLineRef: import("@vue/composition-api").Ref<HTMLDivElement>;
    resizeLineStyle: {
        display: string;
        height: string;
        left: string;
        bottom: string;
    };
    columnResizeParams: {
        resizeLineRef: import("@vue/composition-api").Ref<HTMLDivElement>;
        resizeLineStyle: {
            display: string;
            height: string;
            left: string;
            bottom: string;
        };
        onColumnMouseover: (e: MouseEvent, col: import("./type").BaseTableCol<import("./type").TableRowData>) => void;
        onColumnMousedown: (e: MouseEvent, col: import("./type").BaseTableCol<import("./type").TableRowData>, index: number) => void;
        setEffectColMap: (nodes: import("./type").BaseTableCol<import("./type").TableRowData>[], parent: import("./type").BaseTableCol<import("./type").TableRowData>) => void;
    };
    horizontalScrollbarRef: import("@vue/composition-api").Ref<HTMLDivElement>;
    tableBodyRef: import("@vue/composition-api").Ref<HTMLTableElement>;
    showAffixPagination: import("@vue/composition-api").Ref<boolean>;
    tActiveRow: import("@vue/composition-api").Ref<(string | number)[]>;
    hoverRow: import("@vue/composition-api").Ref<string | number>;
    showElement: import("@vue/composition-api").Ref<boolean>;
    getListener: () => import("./base-table").TableListeners;
    renderPagination: (h: import("vue").CreateElement) => JSX.Element;
    onFixedChange: () => void;
    onHorizontalScroll: (scrollElement?: HTMLElement) => void;
    updateAffixHeaderOrFooter: () => void;
    refreshTable: () => void;
    onInnerVirtualScroll: (e: WheelEvent) => void;
    scrollColumnIntoView: (colKey: string) => void;
    onTableFocus: () => void;
    onTableBlur: () => void;
    onInnerRowClick: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    paginationAffixRef: import("@vue/composition-api").Ref<any>;
    horizontalScrollAffixRef: import("@vue/composition-api").Ref<any>;
    headerTopAffixRef: import("@vue/composition-api").Ref<any>;
    footerBottomAffixRef: import("@vue/composition-api").Ref<any>;
    isIE: import("@vue/composition-api").ComputedRef<boolean>;
    tableRefTabIndex: import("@vue/composition-api").Ref<number>;
}> & import("@vue/composition-api").Data, {
    renderColGroup(columns: import("./type").BaseTableCol<import("./type").TableRowData>[], isAffixHeader?: boolean): JSX.Element;
    getHeadProps(isAffixHeader?: boolean): {
        isFixedHeader: boolean;
        showColumnShadow: {
            left: boolean;
            right: boolean;
        };
        thDraggable: boolean;
        rowAndColFixedPosition: import("./interface").RowAndColFixedPosition;
        isMultipleHeader: boolean;
        bordered: boolean;
        maxHeight: string | number;
        height: string | number;
        spansAndLeafNodes: {
            rowspanAndColspanMap: import("./interface").ThRowspanAndColspan;
            leafColumns: import("./type").BaseTableCol<import("./type").TableRowData>[];
        };
        thList: import("./type").BaseTableCol<import("./type").TableRowData>[][];
        thWidthList: {
            [x: string]: number;
        };
        resizable: boolean;
        columnResizeParams: {
            resizeLineRef: import("@vue/composition-api").Ref<HTMLDivElement>;
            resizeLineStyle: {
                display: string;
                height: string;
                left: string;
                bottom: string;
            };
            onColumnMouseover: (e: MouseEvent, col: import("./type").BaseTableCol<import("./type").TableRowData>) => void;
            onColumnMousedown: (e: MouseEvent, col: import("./type").BaseTableCol<import("./type").TableRowData>, index: number) => void;
            setEffectColMap: (nodes: import("./type").BaseTableCol<import("./type").TableRowData>[], parent: import("./type").BaseTableCol<import("./type").TableRowData>) => void;
        };
        classPrefix: string;
        ellipsisOverlayClassName: string;
        attach: import("..").AttachNode;
    };
    renderFixedHeader(columns: import("./type").BaseTableCol<import("./type").TableRowData>[]): JSX.Element;
    renderAffixedFooter(columns: import("./type").BaseTableCol<import("./type").TableRowData>[]): JSX.Element;
    renderAffixedHeader(columns: import("./type").BaseTableCol<import("./type").TableRowData>[]): JSX.Element;
}, {}, {
    renderExpandedRow: import("@vue/composition-api").PropType<(h: import("vue").CreateElement, params: import("./type").TableExpandedRowParams<import("./type").TableRowData>) => JSX.Element>;
    onLeafColumnsChange: import("@vue/composition-api").PropType<(columns: import("./type").BaseTableCol<import("./type").TableRowData>[]) => void>;
    thDraggable: BooleanConstructor;
    activeRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultActiveRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    activeRowType: {
        type: import("vue").PropType<"multiple" | "single">;
        default: string;
    };
    allowResizeColumnWidth: {
        type: BooleanConstructor;
        default: any;
    };
    attach: {
        type: import("vue").PropType<import("..").AttachNode>;
    };
    bordered: BooleanConstructor;
    bottomContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    cellEmptyContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement, props: import("./type").BaseTableCellParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    columns: {
        type: import("vue").PropType<import("./type").BaseTableCol<import("./type").TableRowData>[]>;
        default: () => import("./type").BaseTableCol<import("./type").TableRowData>[];
    };
    data: {
        type: import("vue").PropType<import("./type").TableRowData[]>;
        default: () => import("./type").TableRowData[];
    };
    disableDataPage: BooleanConstructor;
    disableSpaceInactiveRow: {
        type: BooleanConstructor;
        default: any;
    };
    empty: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: string;
    };
    firstFullRow: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    fixedRows: {
        type: import("vue").PropType<number[]>;
    };
    footData: {
        type: import("vue").PropType<import("./type").TableRowData[]>;
        default: () => import("./type").TableRowData[];
    };
    footerAffixProps: {
        type: import("vue").PropType<Partial<import("..").TdAffixProps>>;
    };
    footerAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
        default: boolean;
    };
    footerSummary: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    headerAffixProps: {
        type: import("vue").PropType<Partial<import("..").TdAffixProps>>;
    };
    headerAffixedTop: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
        default: boolean;
    };
    height: {
        type: import("vue").PropType<string | number>;
    };
    horizontalScrollAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
    };
    hover: BooleanConstructor;
    keyboardRowHover: {
        type: BooleanConstructor;
        default: boolean;
    };
    lastFullRow: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    lazyLoad: BooleanConstructor;
    loading: {
        type: import("vue").PropType<boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: any;
    };
    loadingProps: {
        type: import("vue").PropType<Partial<import("..").TdLoadingProps>>;
    };
    locale: {
        type: import("vue").PropType<import("..").TableConfig>;
    };
    maxHeight: {
        type: import("vue").PropType<string | number>;
    };
    pagination: {
        type: import("vue").PropType<import("..").TdPaginationProps>;
    };
    paginationAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
    };
    resizable: BooleanConstructor;
    rowAttributes: {
        type: import("vue").PropType<import("./type").TableRowAttributes<import("./type").TableRowData>>;
    };
    rowClassName: {
        type: import("vue").PropType<import("..").ClassName | ((params: import("./type").RowClassNameParams<import("./type").TableRowData>) => import("..").ClassName)>;
    };
    rowKey: {
        type: StringConstructor;
        default: string;
        required: boolean;
    };
    rowspanAndColspan: {
        type: import("vue").PropType<import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>>;
    };
    rowspanAndColspanInFooter: {
        type: import("vue").PropType<import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>>;
    };
    scroll: {
        type: import("vue").PropType<import("..").TScroll>;
    };
    showHeader: {
        type: BooleanConstructor;
        default: boolean;
    };
    size: {
        type: import("vue").PropType<import("..").SizeEnum>;
        validator(val: import("..").SizeEnum): boolean;
    };
    stripe: BooleanConstructor;
    tableContentWidth: {
        type: StringConstructor;
        default: string;
    };
    tableLayout: {
        type: import("vue").PropType<"fixed" | "auto">;
        default: "fixed" | "auto";
        validator(val: "fixed" | "auto"): boolean;
    };
    topContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    verticalAlign: {
        type: import("vue").PropType<"top" | "bottom" | "middle">;
        default: "top" | "bottom" | "middle";
        validator(val: "top" | "bottom" | "middle"): boolean;
    };
    onActiveChange: import("vue").PropType<(activeRowKeys: (string | number)[], context: import("./type").ActiveChangeContext<import("./type").TableRowData>) => void>;
    onActiveRowAction: import("vue").PropType<(context: import("./type").ActiveRowActionContext<import("./type").TableRowData>) => void>;
    onCellClick: import("vue").PropType<(context: import("./type").BaseTableCellEventContext<import("./type").TableRowData>) => void>;
    onColumnResizeChange: import("vue").PropType<(context: {
        columnsWidth: {
            [colKey: string]: number;
        };
    }) => void>;
    onPageChange: import("vue").PropType<(pageInfo: import("..").PageInfo, newDataSource: import("./type").TableRowData[]) => void>;
    onRowClick: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowDblclick: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMousedown: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseenter: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseleave: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseover: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseup: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onScroll: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
    onScrollX: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
    onScrollY: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
}, import("@vue/composition-api").ExtractPropTypes<{
    renderExpandedRow: import("@vue/composition-api").PropType<(h: import("vue").CreateElement, params: import("./type").TableExpandedRowParams<import("./type").TableRowData>) => JSX.Element>;
    onLeafColumnsChange: import("@vue/composition-api").PropType<(columns: import("./type").BaseTableCol<import("./type").TableRowData>[]) => void>;
    thDraggable: BooleanConstructor;
    activeRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultActiveRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    activeRowType: {
        type: import("vue").PropType<"multiple" | "single">;
        default: string;
    };
    allowResizeColumnWidth: {
        type: BooleanConstructor;
        default: any;
    };
    attach: {
        type: import("vue").PropType<import("..").AttachNode>;
    };
    bordered: BooleanConstructor;
    bottomContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    cellEmptyContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement, props: import("./type").BaseTableCellParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    columns: {
        type: import("vue").PropType<import("./type").BaseTableCol<import("./type").TableRowData>[]>;
        default: () => import("./type").BaseTableCol<import("./type").TableRowData>[];
    };
    data: {
        type: import("vue").PropType<import("./type").TableRowData[]>;
        default: () => import("./type").TableRowData[];
    };
    disableDataPage: BooleanConstructor;
    disableSpaceInactiveRow: {
        type: BooleanConstructor;
        default: any;
    };
    empty: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: string;
    };
    firstFullRow: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    fixedRows: {
        type: import("vue").PropType<number[]>;
    };
    footData: {
        type: import("vue").PropType<import("./type").TableRowData[]>;
        default: () => import("./type").TableRowData[];
    };
    footerAffixProps: {
        type: import("vue").PropType<Partial<import("..").TdAffixProps>>;
    };
    footerAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
        default: boolean;
    };
    footerSummary: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    headerAffixProps: {
        type: import("vue").PropType<Partial<import("..").TdAffixProps>>;
    };
    headerAffixedTop: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
        default: boolean;
    };
    height: {
        type: import("vue").PropType<string | number>;
    };
    horizontalScrollAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
    };
    hover: BooleanConstructor;
    keyboardRowHover: {
        type: BooleanConstructor;
        default: boolean;
    };
    lastFullRow: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    lazyLoad: BooleanConstructor;
    loading: {
        type: import("vue").PropType<boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: any;
    };
    loadingProps: {
        type: import("vue").PropType<Partial<import("..").TdLoadingProps>>;
    };
    locale: {
        type: import("vue").PropType<import("..").TableConfig>;
    };
    maxHeight: {
        type: import("vue").PropType<string | number>;
    };
    pagination: {
        type: import("vue").PropType<import("..").TdPaginationProps>;
    };
    paginationAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
    };
    resizable: BooleanConstructor;
    rowAttributes: {
        type: import("vue").PropType<import("./type").TableRowAttributes<import("./type").TableRowData>>;
    };
    rowClassName: {
        type: import("vue").PropType<import("..").ClassName | ((params: import("./type").RowClassNameParams<import("./type").TableRowData>) => import("..").ClassName)>;
    };
    rowKey: {
        type: StringConstructor;
        default: string;
        required: boolean;
    };
    rowspanAndColspan: {
        type: import("vue").PropType<import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>>;
    };
    rowspanAndColspanInFooter: {
        type: import("vue").PropType<import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>>;
    };
    scroll: {
        type: import("vue").PropType<import("..").TScroll>;
    };
    showHeader: {
        type: BooleanConstructor;
        default: boolean;
    };
    size: {
        type: import("vue").PropType<import("..").SizeEnum>;
        validator(val: import("..").SizeEnum): boolean;
    };
    stripe: BooleanConstructor;
    tableContentWidth: {
        type: StringConstructor;
        default: string;
    };
    tableLayout: {
        type: import("vue").PropType<"fixed" | "auto">;
        default: "fixed" | "auto";
        validator(val: "fixed" | "auto"): boolean;
    };
    topContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    verticalAlign: {
        type: import("vue").PropType<"top" | "bottom" | "middle">;
        default: "top" | "bottom" | "middle";
        validator(val: "top" | "bottom" | "middle"): boolean;
    };
    onActiveChange: import("vue").PropType<(activeRowKeys: (string | number)[], context: import("./type").ActiveChangeContext<import("./type").TableRowData>) => void>;
    onActiveRowAction: import("vue").PropType<(context: import("./type").ActiveRowActionContext<import("./type").TableRowData>) => void>;
    onCellClick: import("vue").PropType<(context: import("./type").BaseTableCellEventContext<import("./type").TableRowData>) => void>;
    onColumnResizeChange: import("vue").PropType<(context: {
        columnsWidth: {
            [colKey: string]: number;
        };
    }) => void>;
    onPageChange: import("vue").PropType<(pageInfo: import("..").PageInfo, newDataSource: import("./type").TableRowData[]) => void>;
    onRowClick: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowDblclick: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMousedown: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseenter: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseleave: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseover: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseup: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onScroll: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
    onScrollX: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
    onScrollY: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
}>> & Omit<import("vue").VueConstructor<import("vue").default>, never> & (new (...args: any[]) => import("@vue/composition-api").ComponentRenderProxy<{
    data: import("./type").TableRowData[];
    columns: import("./type").BaseTableCol<import("./type").TableRowData>[];
    tableLayout: "fixed" | "auto";
    verticalAlign: "top" | "bottom" | "middle";
    loading: boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    empty: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    hover: boolean;
    lazyLoad: boolean;
    bordered: boolean;
    showHeader: boolean;
    stripe: boolean;
    activeRowKeys: (string | number)[];
    defaultActiveRowKeys: (string | number)[];
    activeRowType: "multiple" | "single";
    allowResizeColumnWidth: boolean;
    disableDataPage: boolean;
    disableSpaceInactiveRow: boolean;
    footData: import("./type").TableRowData[];
    footerAffixedBottom: boolean;
    headerAffixedTop: boolean;
    keyboardRowHover: boolean;
    resizable: boolean;
    rowKey: string;
    tableContentWidth: string;
    thDraggable: boolean;
} & {
    height?: string | number;
    maxHeight?: string | number;
    scroll?: import("..").TScroll;
    size?: import("..").SizeEnum;
    attach?: import("..").AttachNode;
    pagination?: unknown;
    onScroll?: (params: {
        e: WheelEvent;
    }) => void;
    onCellClick?: (context: import("./type").BaseTableCellEventContext<import("./type").TableRowData>) => void;
    onPageChange?: (pageInfo: import("..").PageInfo, newDataSource: import("./type").TableRowData[]) => void;
    loadingProps?: unknown;
    bottomContent?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    cellEmptyContent?: string | ((h: import("vue").CreateElement, props: import("./type").BaseTableCellParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue);
    firstFullRow?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    fixedRows?: number[];
    footerAffixProps?: unknown;
    footerSummary?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    headerAffixProps?: unknown;
    horizontalScrollAffixedBottom?: unknown;
    lastFullRow?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    locale?: unknown;
    paginationAffixedBottom?: unknown;
    rowAttributes?: import("./type").TableRowAttributes<import("./type").TableRowData>;
    rowClassName?: unknown;
    rowspanAndColspan?: import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>;
    rowspanAndColspanInFooter?: import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>;
    topContent?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onActiveChange?: (activeRowKeys: (string | number)[], context: import("./type").ActiveChangeContext<import("./type").TableRowData>) => void;
    onActiveRowAction?: (context: import("./type").ActiveRowActionContext<import("./type").TableRowData>) => void;
    onColumnResizeChange?: (context: {
        columnsWidth: {
            [colKey: string]: number;
        };
    }) => void;
    onRowClick?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowDblclick?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMousedown?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseenter?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseleave?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseover?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseup?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onScrollX?: (params: {
        e: WheelEvent;
    }) => void;
    onScrollY?: (params: {
        e: WheelEvent;
    }) => void;
    renderExpandedRow?: (h: import("vue").CreateElement, params: import("./type").TableExpandedRowParams<import("./type").TableRowData>) => JSX.Element;
    onLeafColumnsChange?: (columns: import("./type").BaseTableCol<import("./type").TableRowData>[]) => void;
}, import("@vue/composition-api").ShallowUnwrapRef<{
    virtualConfig: {
        visibleData: import("@vue/composition-api").Ref<any[]>;
        translateY: import("@vue/composition-api").Ref<number>;
        scrollHeight: import("@vue/composition-api").Ref<number>;
        isVirtualScroll: import("@vue/composition-api").ComputedRef<boolean>;
        handleScroll: () => void;
        handleRowMounted: (rowData: any) => void;
        scrollToElement: (p: import("../hooks").ScrollToElementParams) => void;
    };
    scrollToElement: (params: import("..").ComponentScrollToElementParams) => void;
    columnResizable: import("@vue/composition-api").ComputedRef<boolean>;
    thList: import("@vue/composition-api").ComputedRef<import("./type").BaseTableCol<import("./type").TableRowData>[][]>;
    classPrefix: string;
    innerPagination: import("@vue/composition-api").Ref<import("..").TdPaginationProps>;
    global: import("@vue/composition-api").ComputedRef<{} & (import("..").TableConfig | ({
        readonly expandIcon: any;
        readonly sortIcon: any;
        readonly filterIcon: any;
        readonly treeExpandAndFoldIcon: any;
        readonly hideSortTips: false;
        readonly size: "medium";
    } & {
        readonly empty: "暂无数据";
        readonly loadingText: "正在加载中，请稍后";
        readonly loadingMoreText: "点击加载更多";
        readonly filterInputPlaceholder: "请输入内容（无默认值）";
        readonly sortAscendingOperationText: "点击升序";
        readonly sortCancelOperationText: "点击取消排序";
        readonly sortDescendingOperationText: "点击降序";
        readonly clearFilterResultButtonText: "清空筛选";
        readonly columnConfigButtonText: "列配置";
        readonly columnConfigTitleText: "表格列配置";
        readonly columnConfigDescriptionText: "请选择需要在表格中显示的数据列";
        readonly confirmText: "确认";
        readonly cancelText: "取消";
        readonly resetText: "重置";
        readonly selectAllText: "全选";
        readonly searchResultText: "搜索“{result}”，找到 {count} 条结果";
    })) & import("..").TableConfig>;
    tableSize: import("@vue/composition-api").ComputedRef<import("..").SizeEnum>;
    tableFootHeight: import("@vue/composition-api").Ref<number>;
    tableWidth: import("@vue/composition-api").Ref<number>;
    tableElmWidth: import("@vue/composition-api").Ref<number>;
    tableRef: import("@vue/composition-api").Ref<HTMLDivElement>;
    tableElmRef: import("@vue/composition-api").Ref<HTMLTableElement>;
    sizeClassNames: {
        small: string;
        medium: string;
        large: string;
        default: string;
        xs: string;
        xl: string;
        block: string;
    };
    tableBaseClass: {
        table: (string | {
            [x: string]: boolean;
        })[];
        columnResizableTable: string;
        overflowVisible: string;
        body: string;
        content: string;
        topContent: string;
        bottomContent: string;
        paginationWrap: string;
        tdLastRow: string;
        tdFirstCol: string;
        thCellInner: string;
        tableRowEdit: string;
        cellEditable: string;
        cellEditWrap: string;
        bordered: string;
        striped: string;
        hover: string;
        loading: string;
        rowspanAndColspan: string;
        empty: string;
        emptyRow: string;
        headerFixed: string;
        columnFixed: string;
        widthOverflow: string;
        multipleHeader: string;
        footerAffixed: string;
        horizontalBarAffixed: string;
        affixedHeader: string;
        affixedHeaderElm: string;
        affixedFooterElm: string;
        affixedFooterWrap: string;
        scrollbarDivider: string;
        fullHeight: string;
        resizeLine: string;
        obviousScrollbar: string;
        affixedHeaderWrap: string;
    };
    spansAndLeafNodes: import("@vue/composition-api").ComputedRef<{
        rowspanAndColspanMap: import("./interface").ThRowspanAndColspan;
        leafColumns: import("./type").BaseTableCol<import("./type").TableRowData>[];
    }>;
    dynamicBaseTableClasses: import("@vue/composition-api").ComputedRef<import("..").ClassName[]>;
    tableContentStyles: import("@vue/composition-api").ComputedRef<import("..").Styles>;
    tableElementStyles: import("@vue/composition-api").ComputedRef<import("..").Styles>;
    virtualScrollClasses: {
        cursor: string;
        header: string;
    };
    tableLayoutClasses: {
        auto: string;
        fixed: string;
    };
    tableElmClasses: import("@vue/composition-api").ComputedRef<string[][]>;
    dividerBottom: import("@vue/composition-api").ComputedRef<number>;
    tableContentRef: import("@vue/composition-api").Ref<HTMLDivElement>;
    isFixedHeader: import("@vue/composition-api").Ref<boolean>;
    isWidthOverflow: import("@vue/composition-api").Ref<boolean>;
    isFixedColumn: import("@vue/composition-api").Ref<boolean>;
    rowAndColFixedPosition: import("@vue/composition-api").Ref<import("./interface").RowAndColFixedPosition>;
    showColumnShadow: {
        left: boolean;
        right: boolean;
    };
    thWidthList: import("@vue/composition-api").Ref<{
        [x: string]: number;
    }>;
    isPaginateData: import("@vue/composition-api").ComputedRef<boolean>;
    dataSource: import("@vue/composition-api").Ref<{
        [x: string]: any;
        children?: any[];
    }[]>;
    affixHeaderRef: import("@vue/composition-api").Ref<HTMLDivElement>;
    affixFooterRef: import("@vue/composition-api").Ref<HTMLDivElement>;
    paginationRef: import("@vue/composition-api").Ref<HTMLDivElement>;
    bottomContentRef: import("@vue/composition-api").Ref<HTMLDivElement>;
    showAffixHeader: import("@vue/composition-api").Ref<boolean>;
    showAffixFooter: import("@vue/composition-api").Ref<boolean>;
    scrollbarWidth: import("@vue/composition-api").Ref<number>;
    isMultipleHeader: import("@vue/composition-api").ComputedRef<boolean>;
    showRightDivider: import("@vue/composition-api").ComputedRef<boolean>;
    resizeLineRef: import("@vue/composition-api").Ref<HTMLDivElement>;
    resizeLineStyle: {
        display: string;
        height: string;
        left: string;
        bottom: string;
    };
    columnResizeParams: {
        resizeLineRef: import("@vue/composition-api").Ref<HTMLDivElement>;
        resizeLineStyle: {
            display: string;
            height: string;
            left: string;
            bottom: string;
        };
        onColumnMouseover: (e: MouseEvent, col: import("./type").BaseTableCol<import("./type").TableRowData>) => void;
        onColumnMousedown: (e: MouseEvent, col: import("./type").BaseTableCol<import("./type").TableRowData>, index: number) => void;
        setEffectColMap: (nodes: import("./type").BaseTableCol<import("./type").TableRowData>[], parent: import("./type").BaseTableCol<import("./type").TableRowData>) => void;
    };
    horizontalScrollbarRef: import("@vue/composition-api").Ref<HTMLDivElement>;
    tableBodyRef: import("@vue/composition-api").Ref<HTMLTableElement>;
    showAffixPagination: import("@vue/composition-api").Ref<boolean>;
    tActiveRow: import("@vue/composition-api").Ref<(string | number)[]>;
    hoverRow: import("@vue/composition-api").Ref<string | number>;
    showElement: import("@vue/composition-api").Ref<boolean>;
    getListener: () => import("./base-table").TableListeners;
    renderPagination: (h: import("vue").CreateElement) => JSX.Element;
    onFixedChange: () => void;
    onHorizontalScroll: (scrollElement?: HTMLElement) => void;
    updateAffixHeaderOrFooter: () => void;
    refreshTable: () => void;
    onInnerVirtualScroll: (e: WheelEvent) => void;
    scrollColumnIntoView: (colKey: string) => void;
    onTableFocus: () => void;
    onTableBlur: () => void;
    onInnerRowClick: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    paginationAffixRef: import("@vue/composition-api").Ref<any>;
    horizontalScrollAffixRef: import("@vue/composition-api").Ref<any>;
    headerTopAffixRef: import("@vue/composition-api").Ref<any>;
    footerBottomAffixRef: import("@vue/composition-api").Ref<any>;
    isIE: import("@vue/composition-api").ComputedRef<boolean>;
    tableRefTabIndex: import("@vue/composition-api").Ref<number>;
}>, import("@vue/composition-api").Data, {}, {
    renderColGroup(columns: import("./type").BaseTableCol<import("./type").TableRowData>[], isAffixHeader?: boolean): JSX.Element;
    getHeadProps(isAffixHeader?: boolean): {
        isFixedHeader: boolean;
        showColumnShadow: {
            left: boolean;
            right: boolean;
        };
        thDraggable: boolean;
        rowAndColFixedPosition: import("./interface").RowAndColFixedPosition;
        isMultipleHeader: boolean;
        bordered: boolean;
        maxHeight: string | number;
        height: string | number;
        spansAndLeafNodes: {
            rowspanAndColspanMap: import("./interface").ThRowspanAndColspan;
            leafColumns: import("./type").BaseTableCol<import("./type").TableRowData>[];
        };
        thList: import("./type").BaseTableCol<import("./type").TableRowData>[][];
        thWidthList: {
            [x: string]: number;
        };
        resizable: boolean;
        columnResizeParams: {
            resizeLineRef: import("@vue/composition-api").Ref<HTMLDivElement>;
            resizeLineStyle: {
                display: string;
                height: string;
                left: string;
                bottom: string;
            };
            onColumnMouseover: (e: MouseEvent, col: import("./type").BaseTableCol<import("./type").TableRowData>) => void;
            onColumnMousedown: (e: MouseEvent, col: import("./type").BaseTableCol<import("./type").TableRowData>, index: number) => void;
            setEffectColMap: (nodes: import("./type").BaseTableCol<import("./type").TableRowData>[], parent: import("./type").BaseTableCol<import("./type").TableRowData>) => void;
        };
        classPrefix: string;
        ellipsisOverlayClassName: string;
        attach: import("..").AttachNode;
    };
    renderFixedHeader(columns: import("./type").BaseTableCol<import("./type").TableRowData>[]): JSX.Element;
    renderAffixedFooter(columns: import("./type").BaseTableCol<import("./type").TableRowData>[]): JSX.Element;
    renderAffixedHeader(columns: import("./type").BaseTableCol<import("./type").TableRowData>[]): JSX.Element;
}, {}, {}, {}, {
    data: import("./type").TableRowData[];
    columns: import("./type").BaseTableCol<import("./type").TableRowData>[];
    tableLayout: "fixed" | "auto";
    verticalAlign: "top" | "bottom" | "middle";
    loading: boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    empty: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    hover: boolean;
    lazyLoad: boolean;
    bordered: boolean;
    showHeader: boolean;
    stripe: boolean;
    activeRowKeys: (string | number)[];
    defaultActiveRowKeys: (string | number)[];
    activeRowType: "multiple" | "single";
    allowResizeColumnWidth: boolean;
    disableDataPage: boolean;
    disableSpaceInactiveRow: boolean;
    footData: import("./type").TableRowData[];
    footerAffixedBottom: boolean;
    headerAffixedTop: boolean;
    keyboardRowHover: boolean;
    resizable: boolean;
    rowKey: string;
    tableContentWidth: string;
    thDraggable: boolean;
} & {
    height?: string | number;
    maxHeight?: string | number;
    scroll?: import("..").TScroll;
    size?: import("..").SizeEnum;
    attach?: import("..").AttachNode;
    pagination?: unknown;
    onScroll?: (params: {
        e: WheelEvent;
    }) => void;
    onCellClick?: (context: import("./type").BaseTableCellEventContext<import("./type").TableRowData>) => void;
    onPageChange?: (pageInfo: import("..").PageInfo, newDataSource: import("./type").TableRowData[]) => void;
    loadingProps?: unknown;
    bottomContent?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    cellEmptyContent?: string | ((h: import("vue").CreateElement, props: import("./type").BaseTableCellParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue);
    firstFullRow?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    fixedRows?: number[];
    footerAffixProps?: unknown;
    footerSummary?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    headerAffixProps?: unknown;
    horizontalScrollAffixedBottom?: unknown;
    lastFullRow?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    locale?: unknown;
    paginationAffixedBottom?: unknown;
    rowAttributes?: import("./type").TableRowAttributes<import("./type").TableRowData>;
    rowClassName?: unknown;
    rowspanAndColspan?: import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>;
    rowspanAndColspanInFooter?: import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>;
    topContent?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onActiveChange?: (activeRowKeys: (string | number)[], context: import("./type").ActiveChangeContext<import("./type").TableRowData>) => void;
    onActiveRowAction?: (context: import("./type").ActiveRowActionContext<import("./type").TableRowData>) => void;
    onColumnResizeChange?: (context: {
        columnsWidth: {
            [colKey: string]: number;
        };
    }) => void;
    onRowClick?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowDblclick?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMousedown?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseenter?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseleave?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseover?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseup?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onScrollX?: (params: {
        e: WheelEvent;
    }) => void;
    onScrollY?: (params: {
        e: WheelEvent;
    }) => void;
    renderExpandedRow?: (h: import("vue").CreateElement, params: import("./type").TableExpandedRowParams<import("./type").TableRowData>) => JSX.Element;
    onLeafColumnsChange?: (columns: import("./type").BaseTableCol<import("./type").TableRowData>[]) => void;
}, {
    data: import("./type").TableRowData[];
    columns: import("./type").BaseTableCol<import("./type").TableRowData>[];
    tableLayout: "fixed" | "auto";
    verticalAlign: "top" | "bottom" | "middle";
    loading: boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    empty: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    hover: boolean;
    lazyLoad: boolean;
    bordered: boolean;
    showHeader: boolean;
    stripe: boolean;
    activeRowKeys: (string | number)[];
    defaultActiveRowKeys: (string | number)[];
    activeRowType: "multiple" | "single";
    allowResizeColumnWidth: boolean;
    disableDataPage: boolean;
    disableSpaceInactiveRow: boolean;
    footData: import("./type").TableRowData[];
    footerAffixedBottom: boolean;
    headerAffixedTop: boolean;
    keyboardRowHover: boolean;
    resizable: boolean;
    rowKey: string;
    tableContentWidth: string;
    thDraggable: boolean;
}, true>) & import("vue").PluginObject<import("vue").ComponentOptions<import("vue").default, import("@vue/composition-api").ShallowUnwrapRef<{
    virtualConfig: {
        visibleData: import("@vue/composition-api").Ref<any[]>;
        translateY: import("@vue/composition-api").Ref<number>;
        scrollHeight: import("@vue/composition-api").Ref<number>;
        isVirtualScroll: import("@vue/composition-api").ComputedRef<boolean>;
        handleScroll: () => void;
        handleRowMounted: (rowData: any) => void;
        scrollToElement: (p: import("../hooks").ScrollToElementParams) => void;
    };
    scrollToElement: (params: import("..").ComponentScrollToElementParams) => void;
    columnResizable: import("@vue/composition-api").ComputedRef<boolean>;
    thList: import("@vue/composition-api").ComputedRef<import("./type").BaseTableCol<import("./type").TableRowData>[][]>;
    classPrefix: string;
    innerPagination: import("@vue/composition-api").Ref<import("..").TdPaginationProps>;
    global: import("@vue/composition-api").ComputedRef<{} & (import("..").TableConfig | ({
        readonly expandIcon: any;
        readonly sortIcon: any;
        readonly filterIcon: any;
        readonly treeExpandAndFoldIcon: any;
        readonly hideSortTips: false;
        readonly size: "medium";
    } & {
        readonly empty: "暂无数据";
        readonly loadingText: "正在加载中，请稍后";
        readonly loadingMoreText: "点击加载更多";
        readonly filterInputPlaceholder: "请输入内容（无默认值）";
        readonly sortAscendingOperationText: "点击升序";
        readonly sortCancelOperationText: "点击取消排序";
        readonly sortDescendingOperationText: "点击降序";
        readonly clearFilterResultButtonText: "清空筛选";
        readonly columnConfigButtonText: "列配置";
        readonly columnConfigTitleText: "表格列配置";
        readonly columnConfigDescriptionText: "请选择需要在表格中显示的数据列";
        readonly confirmText: "确认";
        readonly cancelText: "取消";
        readonly resetText: "重置";
        readonly selectAllText: "全选";
        readonly searchResultText: "搜索“{result}”，找到 {count} 条结果";
    })) & import("..").TableConfig>;
    tableSize: import("@vue/composition-api").ComputedRef<import("..").SizeEnum>;
    tableFootHeight: import("@vue/composition-api").Ref<number>;
    tableWidth: import("@vue/composition-api").Ref<number>;
    tableElmWidth: import("@vue/composition-api").Ref<number>;
    tableRef: import("@vue/composition-api").Ref<HTMLDivElement>;
    tableElmRef: import("@vue/composition-api").Ref<HTMLTableElement>;
    sizeClassNames: {
        small: string;
        medium: string;
        large: string;
        default: string;
        xs: string;
        xl: string;
        block: string;
    };
    tableBaseClass: {
        table: (string | {
            [x: string]: boolean;
        })[];
        columnResizableTable: string;
        overflowVisible: string;
        body: string;
        content: string;
        topContent: string;
        bottomContent: string;
        paginationWrap: string;
        tdLastRow: string;
        tdFirstCol: string;
        thCellInner: string;
        tableRowEdit: string;
        cellEditable: string;
        cellEditWrap: string;
        bordered: string;
        striped: string;
        hover: string;
        loading: string;
        rowspanAndColspan: string;
        empty: string;
        emptyRow: string;
        headerFixed: string;
        columnFixed: string;
        widthOverflow: string;
        multipleHeader: string;
        footerAffixed: string;
        horizontalBarAffixed: string;
        affixedHeader: string;
        affixedHeaderElm: string;
        affixedFooterElm: string;
        affixedFooterWrap: string;
        scrollbarDivider: string;
        fullHeight: string;
        resizeLine: string;
        obviousScrollbar: string;
        affixedHeaderWrap: string;
    };
    spansAndLeafNodes: import("@vue/composition-api").ComputedRef<{
        rowspanAndColspanMap: import("./interface").ThRowspanAndColspan;
        leafColumns: import("./type").BaseTableCol<import("./type").TableRowData>[];
    }>;
    dynamicBaseTableClasses: import("@vue/composition-api").ComputedRef<import("..").ClassName[]>;
    tableContentStyles: import("@vue/composition-api").ComputedRef<import("..").Styles>;
    tableElementStyles: import("@vue/composition-api").ComputedRef<import("..").Styles>;
    virtualScrollClasses: {
        cursor: string;
        header: string;
    };
    tableLayoutClasses: {
        auto: string;
        fixed: string;
    };
    tableElmClasses: import("@vue/composition-api").ComputedRef<string[][]>;
    dividerBottom: import("@vue/composition-api").ComputedRef<number>;
    tableContentRef: import("@vue/composition-api").Ref<HTMLDivElement>;
    isFixedHeader: import("@vue/composition-api").Ref<boolean>;
    isWidthOverflow: import("@vue/composition-api").Ref<boolean>;
    isFixedColumn: import("@vue/composition-api").Ref<boolean>;
    rowAndColFixedPosition: import("@vue/composition-api").Ref<import("./interface").RowAndColFixedPosition>;
    showColumnShadow: {
        left: boolean;
        right: boolean;
    };
    thWidthList: import("@vue/composition-api").Ref<{
        [x: string]: number;
    }>;
    isPaginateData: import("@vue/composition-api").ComputedRef<boolean>;
    dataSource: import("@vue/composition-api").Ref<{
        [x: string]: any;
        children?: any[];
    }[]>;
    affixHeaderRef: import("@vue/composition-api").Ref<HTMLDivElement>;
    affixFooterRef: import("@vue/composition-api").Ref<HTMLDivElement>;
    paginationRef: import("@vue/composition-api").Ref<HTMLDivElement>;
    bottomContentRef: import("@vue/composition-api").Ref<HTMLDivElement>;
    showAffixHeader: import("@vue/composition-api").Ref<boolean>;
    showAffixFooter: import("@vue/composition-api").Ref<boolean>;
    scrollbarWidth: import("@vue/composition-api").Ref<number>;
    isMultipleHeader: import("@vue/composition-api").ComputedRef<boolean>;
    showRightDivider: import("@vue/composition-api").ComputedRef<boolean>;
    resizeLineRef: import("@vue/composition-api").Ref<HTMLDivElement>;
    resizeLineStyle: {
        display: string;
        height: string;
        left: string;
        bottom: string;
    };
    columnResizeParams: {
        resizeLineRef: import("@vue/composition-api").Ref<HTMLDivElement>;
        resizeLineStyle: {
            display: string;
            height: string;
            left: string;
            bottom: string;
        };
        onColumnMouseover: (e: MouseEvent, col: import("./type").BaseTableCol<import("./type").TableRowData>) => void;
        onColumnMousedown: (e: MouseEvent, col: import("./type").BaseTableCol<import("./type").TableRowData>, index: number) => void;
        setEffectColMap: (nodes: import("./type").BaseTableCol<import("./type").TableRowData>[], parent: import("./type").BaseTableCol<import("./type").TableRowData>) => void;
    };
    horizontalScrollbarRef: import("@vue/composition-api").Ref<HTMLDivElement>;
    tableBodyRef: import("@vue/composition-api").Ref<HTMLTableElement>;
    showAffixPagination: import("@vue/composition-api").Ref<boolean>;
    tActiveRow: import("@vue/composition-api").Ref<(string | number)[]>;
    hoverRow: import("@vue/composition-api").Ref<string | number>;
    showElement: import("@vue/composition-api").Ref<boolean>;
    getListener: () => import("./base-table").TableListeners;
    renderPagination: (h: import("vue").CreateElement) => JSX.Element;
    onFixedChange: () => void;
    onHorizontalScroll: (scrollElement?: HTMLElement) => void;
    updateAffixHeaderOrFooter: () => void;
    refreshTable: () => void;
    onInnerVirtualScroll: (e: WheelEvent) => void;
    scrollColumnIntoView: (colKey: string) => void;
    onTableFocus: () => void;
    onTableBlur: () => void;
    onInnerRowClick: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    paginationAffixRef: import("@vue/composition-api").Ref<any>;
    horizontalScrollAffixRef: import("@vue/composition-api").Ref<any>;
    headerTopAffixRef: import("@vue/composition-api").Ref<any>;
    footerBottomAffixRef: import("@vue/composition-api").Ref<any>;
    isIE: import("@vue/composition-api").ComputedRef<boolean>;
    tableRefTabIndex: import("@vue/composition-api").Ref<number>;
}> & import("@vue/composition-api").Data, {
    renderColGroup(columns: import("./type").BaseTableCol<import("./type").TableRowData>[], isAffixHeader?: boolean): JSX.Element;
    getHeadProps(isAffixHeader?: boolean): {
        isFixedHeader: boolean;
        showColumnShadow: {
            left: boolean;
            right: boolean;
        };
        thDraggable: boolean;
        rowAndColFixedPosition: import("./interface").RowAndColFixedPosition;
        isMultipleHeader: boolean;
        bordered: boolean;
        maxHeight: string | number;
        height: string | number;
        spansAndLeafNodes: {
            rowspanAndColspanMap: import("./interface").ThRowspanAndColspan;
            leafColumns: import("./type").BaseTableCol<import("./type").TableRowData>[];
        };
        thList: import("./type").BaseTableCol<import("./type").TableRowData>[][];
        thWidthList: {
            [x: string]: number;
        };
        resizable: boolean;
        columnResizeParams: {
            resizeLineRef: import("@vue/composition-api").Ref<HTMLDivElement>;
            resizeLineStyle: {
                display: string;
                height: string;
                left: string;
                bottom: string;
            };
            onColumnMouseover: (e: MouseEvent, col: import("./type").BaseTableCol<import("./type").TableRowData>) => void;
            onColumnMousedown: (e: MouseEvent, col: import("./type").BaseTableCol<import("./type").TableRowData>, index: number) => void;
            setEffectColMap: (nodes: import("./type").BaseTableCol<import("./type").TableRowData>[], parent: import("./type").BaseTableCol<import("./type").TableRowData>) => void;
        };
        classPrefix: string;
        ellipsisOverlayClassName: string;
        attach: import("..").AttachNode;
    };
    renderFixedHeader(columns: import("./type").BaseTableCol<import("./type").TableRowData>[]): JSX.Element;
    renderAffixedFooter(columns: import("./type").BaseTableCol<import("./type").TableRowData>[]): JSX.Element;
    renderAffixedHeader(columns: import("./type").BaseTableCol<import("./type").TableRowData>[]): JSX.Element;
}, {}, {
    renderExpandedRow: import("@vue/composition-api").PropType<(h: import("vue").CreateElement, params: import("./type").TableExpandedRowParams<import("./type").TableRowData>) => JSX.Element>;
    onLeafColumnsChange: import("@vue/composition-api").PropType<(columns: import("./type").BaseTableCol<import("./type").TableRowData>[]) => void>;
    thDraggable: BooleanConstructor;
    activeRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultActiveRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    activeRowType: {
        type: import("vue").PropType<"multiple" | "single">;
        default: string;
    };
    allowResizeColumnWidth: {
        type: BooleanConstructor;
        default: any;
    };
    attach: {
        type: import("vue").PropType<import("..").AttachNode>;
    };
    bordered: BooleanConstructor;
    bottomContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    cellEmptyContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement, props: import("./type").BaseTableCellParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    columns: {
        type: import("vue").PropType<import("./type").BaseTableCol<import("./type").TableRowData>[]>;
        default: () => import("./type").BaseTableCol<import("./type").TableRowData>[];
    };
    data: {
        type: import("vue").PropType<import("./type").TableRowData[]>;
        default: () => import("./type").TableRowData[];
    };
    disableDataPage: BooleanConstructor;
    disableSpaceInactiveRow: {
        type: BooleanConstructor;
        default: any;
    };
    empty: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: string;
    };
    firstFullRow: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    fixedRows: {
        type: import("vue").PropType<number[]>;
    };
    footData: {
        type: import("vue").PropType<import("./type").TableRowData[]>;
        default: () => import("./type").TableRowData[];
    };
    footerAffixProps: {
        type: import("vue").PropType<Partial<import("..").TdAffixProps>>;
    };
    footerAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
        default: boolean;
    };
    footerSummary: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    headerAffixProps: {
        type: import("vue").PropType<Partial<import("..").TdAffixProps>>;
    };
    headerAffixedTop: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
        default: boolean;
    };
    height: {
        type: import("vue").PropType<string | number>;
    };
    horizontalScrollAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
    };
    hover: BooleanConstructor;
    keyboardRowHover: {
        type: BooleanConstructor;
        default: boolean;
    };
    lastFullRow: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    lazyLoad: BooleanConstructor;
    loading: {
        type: import("vue").PropType<boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: any;
    };
    loadingProps: {
        type: import("vue").PropType<Partial<import("..").TdLoadingProps>>;
    };
    locale: {
        type: import("vue").PropType<import("..").TableConfig>;
    };
    maxHeight: {
        type: import("vue").PropType<string | number>;
    };
    pagination: {
        type: import("vue").PropType<import("..").TdPaginationProps>;
    };
    paginationAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
    };
    resizable: BooleanConstructor;
    rowAttributes: {
        type: import("vue").PropType<import("./type").TableRowAttributes<import("./type").TableRowData>>;
    };
    rowClassName: {
        type: import("vue").PropType<import("..").ClassName | ((params: import("./type").RowClassNameParams<import("./type").TableRowData>) => import("..").ClassName)>;
    };
    rowKey: {
        type: StringConstructor;
        default: string;
        required: boolean;
    };
    rowspanAndColspan: {
        type: import("vue").PropType<import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>>;
    };
    rowspanAndColspanInFooter: {
        type: import("vue").PropType<import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>>;
    };
    scroll: {
        type: import("vue").PropType<import("..").TScroll>;
    };
    showHeader: {
        type: BooleanConstructor;
        default: boolean;
    };
    size: {
        type: import("vue").PropType<import("..").SizeEnum>;
        validator(val: import("..").SizeEnum): boolean;
    };
    stripe: BooleanConstructor;
    tableContentWidth: {
        type: StringConstructor;
        default: string;
    };
    tableLayout: {
        type: import("vue").PropType<"fixed" | "auto">;
        default: "fixed" | "auto";
        validator(val: "fixed" | "auto"): boolean;
    };
    topContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    verticalAlign: {
        type: import("vue").PropType<"top" | "bottom" | "middle">;
        default: "top" | "bottom" | "middle";
        validator(val: "top" | "bottom" | "middle"): boolean;
    };
    onActiveChange: import("vue").PropType<(activeRowKeys: (string | number)[], context: import("./type").ActiveChangeContext<import("./type").TableRowData>) => void>;
    onActiveRowAction: import("vue").PropType<(context: import("./type").ActiveRowActionContext<import("./type").TableRowData>) => void>;
    onCellClick: import("vue").PropType<(context: import("./type").BaseTableCellEventContext<import("./type").TableRowData>) => void>;
    onColumnResizeChange: import("vue").PropType<(context: {
        columnsWidth: {
            [colKey: string]: number;
        };
    }) => void>;
    onPageChange: import("vue").PropType<(pageInfo: import("..").PageInfo, newDataSource: import("./type").TableRowData[]) => void>;
    onRowClick: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowDblclick: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMousedown: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseenter: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseleave: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseover: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseup: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onScroll: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
    onScrollX: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
    onScrollY: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
}, import("@vue/composition-api").ExtractPropTypes<{
    renderExpandedRow: import("@vue/composition-api").PropType<(h: import("vue").CreateElement, params: import("./type").TableExpandedRowParams<import("./type").TableRowData>) => JSX.Element>;
    onLeafColumnsChange: import("@vue/composition-api").PropType<(columns: import("./type").BaseTableCol<import("./type").TableRowData>[]) => void>;
    thDraggable: BooleanConstructor;
    activeRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultActiveRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    activeRowType: {
        type: import("vue").PropType<"multiple" | "single">;
        default: string;
    };
    allowResizeColumnWidth: {
        type: BooleanConstructor;
        default: any;
    };
    attach: {
        type: import("vue").PropType<import("..").AttachNode>;
    };
    bordered: BooleanConstructor;
    bottomContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    cellEmptyContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement, props: import("./type").BaseTableCellParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    columns: {
        type: import("vue").PropType<import("./type").BaseTableCol<import("./type").TableRowData>[]>;
        default: () => import("./type").BaseTableCol<import("./type").TableRowData>[];
    };
    data: {
        type: import("vue").PropType<import("./type").TableRowData[]>;
        default: () => import("./type").TableRowData[];
    };
    disableDataPage: BooleanConstructor;
    disableSpaceInactiveRow: {
        type: BooleanConstructor;
        default: any;
    };
    empty: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: string;
    };
    firstFullRow: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    fixedRows: {
        type: import("vue").PropType<number[]>;
    };
    footData: {
        type: import("vue").PropType<import("./type").TableRowData[]>;
        default: () => import("./type").TableRowData[];
    };
    footerAffixProps: {
        type: import("vue").PropType<Partial<import("..").TdAffixProps>>;
    };
    footerAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
        default: boolean;
    };
    footerSummary: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    headerAffixProps: {
        type: import("vue").PropType<Partial<import("..").TdAffixProps>>;
    };
    headerAffixedTop: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
        default: boolean;
    };
    height: {
        type: import("vue").PropType<string | number>;
    };
    horizontalScrollAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
    };
    hover: BooleanConstructor;
    keyboardRowHover: {
        type: BooleanConstructor;
        default: boolean;
    };
    lastFullRow: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    lazyLoad: BooleanConstructor;
    loading: {
        type: import("vue").PropType<boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: any;
    };
    loadingProps: {
        type: import("vue").PropType<Partial<import("..").TdLoadingProps>>;
    };
    locale: {
        type: import("vue").PropType<import("..").TableConfig>;
    };
    maxHeight: {
        type: import("vue").PropType<string | number>;
    };
    pagination: {
        type: import("vue").PropType<import("..").TdPaginationProps>;
    };
    paginationAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
    };
    resizable: BooleanConstructor;
    rowAttributes: {
        type: import("vue").PropType<import("./type").TableRowAttributes<import("./type").TableRowData>>;
    };
    rowClassName: {
        type: import("vue").PropType<import("..").ClassName | ((params: import("./type").RowClassNameParams<import("./type").TableRowData>) => import("..").ClassName)>;
    };
    rowKey: {
        type: StringConstructor;
        default: string;
        required: boolean;
    };
    rowspanAndColspan: {
        type: import("vue").PropType<import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>>;
    };
    rowspanAndColspanInFooter: {
        type: import("vue").PropType<import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>>;
    };
    scroll: {
        type: import("vue").PropType<import("..").TScroll>;
    };
    showHeader: {
        type: BooleanConstructor;
        default: boolean;
    };
    size: {
        type: import("vue").PropType<import("..").SizeEnum>;
        validator(val: import("..").SizeEnum): boolean;
    };
    stripe: BooleanConstructor;
    tableContentWidth: {
        type: StringConstructor;
        default: string;
    };
    tableLayout: {
        type: import("vue").PropType<"fixed" | "auto">;
        default: "fixed" | "auto";
        validator(val: "fixed" | "auto"): boolean;
    };
    topContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    verticalAlign: {
        type: import("vue").PropType<"top" | "bottom" | "middle">;
        default: "top" | "bottom" | "middle";
        validator(val: "top" | "bottom" | "middle"): boolean;
    };
    onActiveChange: import("vue").PropType<(activeRowKeys: (string | number)[], context: import("./type").ActiveChangeContext<import("./type").TableRowData>) => void>;
    onActiveRowAction: import("vue").PropType<(context: import("./type").ActiveRowActionContext<import("./type").TableRowData>) => void>;
    onCellClick: import("vue").PropType<(context: import("./type").BaseTableCellEventContext<import("./type").TableRowData>) => void>;
    onColumnResizeChange: import("vue").PropType<(context: {
        columnsWidth: {
            [colKey: string]: number;
        };
    }) => void>;
    onPageChange: import("vue").PropType<(pageInfo: import("..").PageInfo, newDataSource: import("./type").TableRowData[]) => void>;
    onRowClick: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowDblclick: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMousedown: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseenter: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseleave: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseover: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseup: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onScroll: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
    onScrollX: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
    onScrollY: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
}>> & Omit<import("vue").VueConstructor<import("vue").default>, never> & (new (...args: any[]) => import("@vue/composition-api").ComponentRenderProxy<{
    data: import("./type").TableRowData[];
    columns: import("./type").BaseTableCol<import("./type").TableRowData>[];
    tableLayout: "fixed" | "auto";
    verticalAlign: "top" | "bottom" | "middle";
    loading: boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    empty: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    hover: boolean;
    lazyLoad: boolean;
    bordered: boolean;
    showHeader: boolean;
    stripe: boolean;
    activeRowKeys: (string | number)[];
    defaultActiveRowKeys: (string | number)[];
    activeRowType: "multiple" | "single";
    allowResizeColumnWidth: boolean;
    disableDataPage: boolean;
    disableSpaceInactiveRow: boolean;
    footData: import("./type").TableRowData[];
    footerAffixedBottom: boolean;
    headerAffixedTop: boolean;
    keyboardRowHover: boolean;
    resizable: boolean;
    rowKey: string;
    tableContentWidth: string;
    thDraggable: boolean;
} & {
    height?: string | number;
    maxHeight?: string | number;
    scroll?: import("..").TScroll;
    size?: import("..").SizeEnum;
    attach?: import("..").AttachNode;
    pagination?: unknown;
    onScroll?: (params: {
        e: WheelEvent;
    }) => void;
    onCellClick?: (context: import("./type").BaseTableCellEventContext<import("./type").TableRowData>) => void;
    onPageChange?: (pageInfo: import("..").PageInfo, newDataSource: import("./type").TableRowData[]) => void;
    loadingProps?: unknown;
    bottomContent?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    cellEmptyContent?: string | ((h: import("vue").CreateElement, props: import("./type").BaseTableCellParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue);
    firstFullRow?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    fixedRows?: number[];
    footerAffixProps?: unknown;
    footerSummary?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    headerAffixProps?: unknown;
    horizontalScrollAffixedBottom?: unknown;
    lastFullRow?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    locale?: unknown;
    paginationAffixedBottom?: unknown;
    rowAttributes?: import("./type").TableRowAttributes<import("./type").TableRowData>;
    rowClassName?: unknown;
    rowspanAndColspan?: import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>;
    rowspanAndColspanInFooter?: import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>;
    topContent?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onActiveChange?: (activeRowKeys: (string | number)[], context: import("./type").ActiveChangeContext<import("./type").TableRowData>) => void;
    onActiveRowAction?: (context: import("./type").ActiveRowActionContext<import("./type").TableRowData>) => void;
    onColumnResizeChange?: (context: {
        columnsWidth: {
            [colKey: string]: number;
        };
    }) => void;
    onRowClick?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowDblclick?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMousedown?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseenter?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseleave?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseover?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseup?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onScrollX?: (params: {
        e: WheelEvent;
    }) => void;
    onScrollY?: (params: {
        e: WheelEvent;
    }) => void;
    renderExpandedRow?: (h: import("vue").CreateElement, params: import("./type").TableExpandedRowParams<import("./type").TableRowData>) => JSX.Element;
    onLeafColumnsChange?: (columns: import("./type").BaseTableCol<import("./type").TableRowData>[]) => void;
}, import("@vue/composition-api").ShallowUnwrapRef<{
    virtualConfig: {
        visibleData: import("@vue/composition-api").Ref<any[]>;
        translateY: import("@vue/composition-api").Ref<number>;
        scrollHeight: import("@vue/composition-api").Ref<number>;
        isVirtualScroll: import("@vue/composition-api").ComputedRef<boolean>;
        handleScroll: () => void;
        handleRowMounted: (rowData: any) => void;
        scrollToElement: (p: import("../hooks").ScrollToElementParams) => void;
    };
    scrollToElement: (params: import("..").ComponentScrollToElementParams) => void;
    columnResizable: import("@vue/composition-api").ComputedRef<boolean>;
    thList: import("@vue/composition-api").ComputedRef<import("./type").BaseTableCol<import("./type").TableRowData>[][]>;
    classPrefix: string;
    innerPagination: import("@vue/composition-api").Ref<import("..").TdPaginationProps>;
    global: import("@vue/composition-api").ComputedRef<{} & (import("..").TableConfig | ({
        readonly expandIcon: any;
        readonly sortIcon: any;
        readonly filterIcon: any;
        readonly treeExpandAndFoldIcon: any;
        readonly hideSortTips: false;
        readonly size: "medium";
    } & {
        readonly empty: "暂无数据";
        readonly loadingText: "正在加载中，请稍后";
        readonly loadingMoreText: "点击加载更多";
        readonly filterInputPlaceholder: "请输入内容（无默认值）";
        readonly sortAscendingOperationText: "点击升序";
        readonly sortCancelOperationText: "点击取消排序";
        readonly sortDescendingOperationText: "点击降序";
        readonly clearFilterResultButtonText: "清空筛选";
        readonly columnConfigButtonText: "列配置";
        readonly columnConfigTitleText: "表格列配置";
        readonly columnConfigDescriptionText: "请选择需要在表格中显示的数据列";
        readonly confirmText: "确认";
        readonly cancelText: "取消";
        readonly resetText: "重置";
        readonly selectAllText: "全选";
        readonly searchResultText: "搜索“{result}”，找到 {count} 条结果";
    })) & import("..").TableConfig>;
    tableSize: import("@vue/composition-api").ComputedRef<import("..").SizeEnum>;
    tableFootHeight: import("@vue/composition-api").Ref<number>;
    tableWidth: import("@vue/composition-api").Ref<number>;
    tableElmWidth: import("@vue/composition-api").Ref<number>;
    tableRef: import("@vue/composition-api").Ref<HTMLDivElement>;
    tableElmRef: import("@vue/composition-api").Ref<HTMLTableElement>;
    sizeClassNames: {
        small: string;
        medium: string;
        large: string;
        default: string;
        xs: string;
        xl: string;
        block: string;
    };
    tableBaseClass: {
        table: (string | {
            [x: string]: boolean;
        })[];
        columnResizableTable: string;
        overflowVisible: string;
        body: string;
        content: string;
        topContent: string;
        bottomContent: string;
        paginationWrap: string;
        tdLastRow: string;
        tdFirstCol: string;
        thCellInner: string;
        tableRowEdit: string;
        cellEditable: string;
        cellEditWrap: string;
        bordered: string;
        striped: string;
        hover: string;
        loading: string;
        rowspanAndColspan: string;
        empty: string;
        emptyRow: string;
        headerFixed: string;
        columnFixed: string;
        widthOverflow: string;
        multipleHeader: string;
        footerAffixed: string;
        horizontalBarAffixed: string;
        affixedHeader: string;
        affixedHeaderElm: string;
        affixedFooterElm: string;
        affixedFooterWrap: string;
        scrollbarDivider: string;
        fullHeight: string;
        resizeLine: string;
        obviousScrollbar: string;
        affixedHeaderWrap: string;
    };
    spansAndLeafNodes: import("@vue/composition-api").ComputedRef<{
        rowspanAndColspanMap: import("./interface").ThRowspanAndColspan;
        leafColumns: import("./type").BaseTableCol<import("./type").TableRowData>[];
    }>;
    dynamicBaseTableClasses: import("@vue/composition-api").ComputedRef<import("..").ClassName[]>;
    tableContentStyles: import("@vue/composition-api").ComputedRef<import("..").Styles>;
    tableElementStyles: import("@vue/composition-api").ComputedRef<import("..").Styles>;
    virtualScrollClasses: {
        cursor: string;
        header: string;
    };
    tableLayoutClasses: {
        auto: string;
        fixed: string;
    };
    tableElmClasses: import("@vue/composition-api").ComputedRef<string[][]>;
    dividerBottom: import("@vue/composition-api").ComputedRef<number>;
    tableContentRef: import("@vue/composition-api").Ref<HTMLDivElement>;
    isFixedHeader: import("@vue/composition-api").Ref<boolean>;
    isWidthOverflow: import("@vue/composition-api").Ref<boolean>;
    isFixedColumn: import("@vue/composition-api").Ref<boolean>;
    rowAndColFixedPosition: import("@vue/composition-api").Ref<import("./interface").RowAndColFixedPosition>;
    showColumnShadow: {
        left: boolean;
        right: boolean;
    };
    thWidthList: import("@vue/composition-api").Ref<{
        [x: string]: number;
    }>;
    isPaginateData: import("@vue/composition-api").ComputedRef<boolean>;
    dataSource: import("@vue/composition-api").Ref<{
        [x: string]: any;
        children?: any[];
    }[]>;
    affixHeaderRef: import("@vue/composition-api").Ref<HTMLDivElement>;
    affixFooterRef: import("@vue/composition-api").Ref<HTMLDivElement>;
    paginationRef: import("@vue/composition-api").Ref<HTMLDivElement>;
    bottomContentRef: import("@vue/composition-api").Ref<HTMLDivElement>;
    showAffixHeader: import("@vue/composition-api").Ref<boolean>;
    showAffixFooter: import("@vue/composition-api").Ref<boolean>;
    scrollbarWidth: import("@vue/composition-api").Ref<number>;
    isMultipleHeader: import("@vue/composition-api").ComputedRef<boolean>;
    showRightDivider: import("@vue/composition-api").ComputedRef<boolean>;
    resizeLineRef: import("@vue/composition-api").Ref<HTMLDivElement>;
    resizeLineStyle: {
        display: string;
        height: string;
        left: string;
        bottom: string;
    };
    columnResizeParams: {
        resizeLineRef: import("@vue/composition-api").Ref<HTMLDivElement>;
        resizeLineStyle: {
            display: string;
            height: string;
            left: string;
            bottom: string;
        };
        onColumnMouseover: (e: MouseEvent, col: import("./type").BaseTableCol<import("./type").TableRowData>) => void;
        onColumnMousedown: (e: MouseEvent, col: import("./type").BaseTableCol<import("./type").TableRowData>, index: number) => void;
        setEffectColMap: (nodes: import("./type").BaseTableCol<import("./type").TableRowData>[], parent: import("./type").BaseTableCol<import("./type").TableRowData>) => void;
    };
    horizontalScrollbarRef: import("@vue/composition-api").Ref<HTMLDivElement>;
    tableBodyRef: import("@vue/composition-api").Ref<HTMLTableElement>;
    showAffixPagination: import("@vue/composition-api").Ref<boolean>;
    tActiveRow: import("@vue/composition-api").Ref<(string | number)[]>;
    hoverRow: import("@vue/composition-api").Ref<string | number>;
    showElement: import("@vue/composition-api").Ref<boolean>;
    getListener: () => import("./base-table").TableListeners;
    renderPagination: (h: import("vue").CreateElement) => JSX.Element;
    onFixedChange: () => void;
    onHorizontalScroll: (scrollElement?: HTMLElement) => void;
    updateAffixHeaderOrFooter: () => void;
    refreshTable: () => void;
    onInnerVirtualScroll: (e: WheelEvent) => void;
    scrollColumnIntoView: (colKey: string) => void;
    onTableFocus: () => void;
    onTableBlur: () => void;
    onInnerRowClick: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    paginationAffixRef: import("@vue/composition-api").Ref<any>;
    horizontalScrollAffixRef: import("@vue/composition-api").Ref<any>;
    headerTopAffixRef: import("@vue/composition-api").Ref<any>;
    footerBottomAffixRef: import("@vue/composition-api").Ref<any>;
    isIE: import("@vue/composition-api").ComputedRef<boolean>;
    tableRefTabIndex: import("@vue/composition-api").Ref<number>;
}>, import("@vue/composition-api").Data, {}, {
    renderColGroup(columns: import("./type").BaseTableCol<import("./type").TableRowData>[], isAffixHeader?: boolean): JSX.Element;
    getHeadProps(isAffixHeader?: boolean): {
        isFixedHeader: boolean;
        showColumnShadow: {
            left: boolean;
            right: boolean;
        };
        thDraggable: boolean;
        rowAndColFixedPosition: import("./interface").RowAndColFixedPosition;
        isMultipleHeader: boolean;
        bordered: boolean;
        maxHeight: string | number;
        height: string | number;
        spansAndLeafNodes: {
            rowspanAndColspanMap: import("./interface").ThRowspanAndColspan;
            leafColumns: import("./type").BaseTableCol<import("./type").TableRowData>[];
        };
        thList: import("./type").BaseTableCol<import("./type").TableRowData>[][];
        thWidthList: {
            [x: string]: number;
        };
        resizable: boolean;
        columnResizeParams: {
            resizeLineRef: import("@vue/composition-api").Ref<HTMLDivElement>;
            resizeLineStyle: {
                display: string;
                height: string;
                left: string;
                bottom: string;
            };
            onColumnMouseover: (e: MouseEvent, col: import("./type").BaseTableCol<import("./type").TableRowData>) => void;
            onColumnMousedown: (e: MouseEvent, col: import("./type").BaseTableCol<import("./type").TableRowData>, index: number) => void;
            setEffectColMap: (nodes: import("./type").BaseTableCol<import("./type").TableRowData>[], parent: import("./type").BaseTableCol<import("./type").TableRowData>) => void;
        };
        classPrefix: string;
        ellipsisOverlayClassName: string;
        attach: import("..").AttachNode;
    };
    renderFixedHeader(columns: import("./type").BaseTableCol<import("./type").TableRowData>[]): JSX.Element;
    renderAffixedFooter(columns: import("./type").BaseTableCol<import("./type").TableRowData>[]): JSX.Element;
    renderAffixedHeader(columns: import("./type").BaseTableCol<import("./type").TableRowData>[]): JSX.Element;
}, {}, {}, {}, {
    data: import("./type").TableRowData[];
    columns: import("./type").BaseTableCol<import("./type").TableRowData>[];
    tableLayout: "fixed" | "auto";
    verticalAlign: "top" | "bottom" | "middle";
    loading: boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    empty: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    hover: boolean;
    lazyLoad: boolean;
    bordered: boolean;
    showHeader: boolean;
    stripe: boolean;
    activeRowKeys: (string | number)[];
    defaultActiveRowKeys: (string | number)[];
    activeRowType: "multiple" | "single";
    allowResizeColumnWidth: boolean;
    disableDataPage: boolean;
    disableSpaceInactiveRow: boolean;
    footData: import("./type").TableRowData[];
    footerAffixedBottom: boolean;
    headerAffixedTop: boolean;
    keyboardRowHover: boolean;
    resizable: boolean;
    rowKey: string;
    tableContentWidth: string;
    thDraggable: boolean;
} & {
    height?: string | number;
    maxHeight?: string | number;
    scroll?: import("..").TScroll;
    size?: import("..").SizeEnum;
    attach?: import("..").AttachNode;
    pagination?: unknown;
    onScroll?: (params: {
        e: WheelEvent;
    }) => void;
    onCellClick?: (context: import("./type").BaseTableCellEventContext<import("./type").TableRowData>) => void;
    onPageChange?: (pageInfo: import("..").PageInfo, newDataSource: import("./type").TableRowData[]) => void;
    loadingProps?: unknown;
    bottomContent?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    cellEmptyContent?: string | ((h: import("vue").CreateElement, props: import("./type").BaseTableCellParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue);
    firstFullRow?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    fixedRows?: number[];
    footerAffixProps?: unknown;
    footerSummary?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    headerAffixProps?: unknown;
    horizontalScrollAffixedBottom?: unknown;
    lastFullRow?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    locale?: unknown;
    paginationAffixedBottom?: unknown;
    rowAttributes?: import("./type").TableRowAttributes<import("./type").TableRowData>;
    rowClassName?: unknown;
    rowspanAndColspan?: import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>;
    rowspanAndColspanInFooter?: import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>;
    topContent?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onActiveChange?: (activeRowKeys: (string | number)[], context: import("./type").ActiveChangeContext<import("./type").TableRowData>) => void;
    onActiveRowAction?: (context: import("./type").ActiveRowActionContext<import("./type").TableRowData>) => void;
    onColumnResizeChange?: (context: {
        columnsWidth: {
            [colKey: string]: number;
        };
    }) => void;
    onRowClick?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowDblclick?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMousedown?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseenter?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseleave?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseover?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseup?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onScrollX?: (params: {
        e: WheelEvent;
    }) => void;
    onScrollY?: (params: {
        e: WheelEvent;
    }) => void;
    renderExpandedRow?: (h: import("vue").CreateElement, params: import("./type").TableExpandedRowParams<import("./type").TableRowData>) => JSX.Element;
    onLeafColumnsChange?: (columns: import("./type").BaseTableCol<import("./type").TableRowData>[]) => void;
}, {
    data: import("./type").TableRowData[];
    columns: import("./type").BaseTableCol<import("./type").TableRowData>[];
    tableLayout: "fixed" | "auto";
    verticalAlign: "top" | "bottom" | "middle";
    loading: boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    empty: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    hover: boolean;
    lazyLoad: boolean;
    bordered: boolean;
    showHeader: boolean;
    stripe: boolean;
    activeRowKeys: (string | number)[];
    defaultActiveRowKeys: (string | number)[];
    activeRowType: "multiple" | "single";
    allowResizeColumnWidth: boolean;
    disableDataPage: boolean;
    disableSpaceInactiveRow: boolean;
    footData: import("./type").TableRowData[];
    footerAffixedBottom: boolean;
    headerAffixedTop: boolean;
    keyboardRowHover: boolean;
    resizable: boolean;
    rowKey: string;
    tableContentWidth: string;
    thDraggable: boolean;
}, true>)>;
export declare const PrimaryTable: import("vue").ComponentOptions<import("vue").default, import("@vue/composition-api").ShallowUnwrapRef<{
    tColumns: import("@vue/composition-api").ComputedRef<import("./type").PrimaryTableCol<import("./type").TableRowData>[]>;
    showExpandedRow: import("@vue/composition-api").ComputedRef<boolean>;
    tRowClassNames: import("@vue/composition-api").ComputedRef<any[]>;
    hasEmptyCondition: import("@vue/composition-api").ComputedRef<boolean>;
    primaryTableRef: any;
    tRowAttributes: import("@vue/composition-api").ComputedRef<import("./type").TableRowAttributes<import("./type").TableRowData>[]>;
    primaryTableClasses: import("@vue/composition-api").ComputedRef<{
        [x: string]: boolean | (string | number)[] | import("./type").PrimaryTableCol<import("./type").TableRowData>;
    }>;
    errorListMap: import("@vue/composition-api").Ref<{
        [x: string]: ({
            result: boolean;
            message: string;
            type?: "error" | "success" | "warning";
        } | {
            result: boolean;
            boolean?: boolean;
            date?: boolean | {
                format: string;
                strictMode: boolean;
                delimiters: string[];
            };
            email?: boolean | {
                allow_display_name?: boolean;
                require_display_name?: boolean;
                allow_utf8_local_part?: boolean;
                require_tld?: boolean;
                ignore_max_length?: boolean;
                allow_ip_domain?: boolean;
                domain_specific_validation?: boolean;
                allow_underscores?: boolean;
                host_blacklist?: string[];
                host_whitelist?: string[];
                blacklisted_chars?: string;
            };
            enum?: string[];
            idcard?: boolean;
            len?: number | boolean;
            max?: number | boolean;
            message?: string;
            min?: number | boolean;
            number?: boolean;
            pattern?: {
                exec: (string: string) => RegExpExecArray;
                test: (string: string) => boolean;
                readonly source: string;
                readonly global: boolean;
                readonly ignoreCase: boolean;
                readonly multiline: boolean;
                lastIndex: number;
                compile: (pattern: string, flags?: string) => RegExp;
                readonly flags: string;
                readonly sticky: boolean;
                readonly unicode: boolean;
                readonly dotAll: boolean;
                [Symbol.match]: (string: string) => RegExpMatchArray;
                [Symbol.replace]: {
                    (string: string, replaceValue: string): string;
                    (string: string, replacer: (substring: string, ...args: any[]) => string): string;
                };
                [Symbol.search]: (string: string) => number;
                [Symbol.split]: (string: string, limit?: number) => string[];
                [Symbol.matchAll]: (str: string) => IterableIterator<RegExpMatchArray>;
            };
            required?: boolean;
            telnumber?: boolean;
            trigger?: "blur" | "change" | "submit" | ("blur" | "change" | "submit")[];
            type?: "error" | "warning";
            url?: boolean | {
                protocols?: string[];
                require_tld?: boolean;
                require_protocol?: boolean;
                require_host?: boolean;
                require_port?: boolean;
                require_valid_protocol?: boolean;
                allow_underscores?: boolean;
                host_whitelist?: (string | {
                    exec: (string: string) => RegExpExecArray;
                    test: (string: string) => boolean;
                    readonly source: string;
                    readonly global: boolean;
                    readonly ignoreCase: boolean;
                    readonly multiline: boolean;
                    lastIndex: number;
                    compile: (pattern: string, flags?: string) => RegExp;
                    readonly flags: string;
                    readonly sticky: boolean;
                    readonly unicode: boolean;
                    readonly dotAll: boolean;
                    [Symbol.match]: (string: string) => RegExpMatchArray;
                    [Symbol.replace]: {
                        (string: string, replaceValue: string): string;
                        (string: string, replacer: (substring: string, ...args: any[]) => string): string;
                    };
                    [Symbol.search]: (string: string) => number;
                    [Symbol.split]: (string: string, limit?: number) => string[];
                    [Symbol.matchAll]: (str: string) => IterableIterator<RegExpMatchArray>;
                })[];
                host_blacklist?: (string | {
                    exec: (string: string) => RegExpExecArray;
                    test: (string: string) => boolean;
                    readonly source: string;
                    readonly global: boolean;
                    readonly ignoreCase: boolean;
                    readonly multiline: boolean;
                    lastIndex: number;
                    compile: (pattern: string, flags?: string) => RegExp;
                    readonly flags: string;
                    readonly sticky: boolean;
                    readonly unicode: boolean;
                    readonly dotAll: boolean;
                    [Symbol.match]: (string: string) => RegExpMatchArray;
                    [Symbol.replace]: {
                        (string: string, replaceValue: string): string;
                        (string: string, replacer: (substring: string, ...args: any[]) => string): string;
                    };
                    [Symbol.search]: (string: string) => number;
                    [Symbol.split]: (string: string, limit?: number) => string[];
                    [Symbol.matchAll]: (str: string) => IterableIterator<RegExpMatchArray>;
                })[];
                allow_trailing_dot?: boolean;
                allow_protocol_relative_urls?: boolean;
                disallow_auth?: boolean;
                allow_fragments?: boolean;
                allow_query_components?: boolean;
                validate_length?: boolean;
                max_allowed_length?: number | false;
            };
            validator?: import("..").CustomValidator;
            whitespace?: boolean;
        })[];
    }>;
    onShowElementChange: (val: boolean) => void;
    scrollToElement: (data: import("..").ComponentScrollToElementParams) => void;
    scrollColumnIntoView: (colKey: string) => void;
    refreshTable: () => void;
    validateRowData: (rowValue: any) => Promise<unknown>;
    validateTableData: () => Promise<unknown>;
    clearValidateData: () => void;
    renderTNode: (name: string, options?: import("../hooks/render-tnode").OptionsType) => any;
    renderColumnController: (h: import("vue").CreateElement) => JSX.Element;
    renderExpandedRow: (h: import("vue").CreateElement, p: import("./type").TableExpandedRowParams<import("./type").TableRowData> & {
        tableWidth: number;
        isWidthOverflow: boolean;
    }) => JSX.Element;
    onInnerExpandRowClick: (p: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onInnerRowClick: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    renderFirstFilterRow: (h: import("vue").CreateElement) => JSX.Element;
    renderAsyncLoading: (h: import("vue").CreateElement) => JSX.Element;
    onInnerPageChange: (pageInfo: import("..").PageInfo, newData: import("./type").TableRowData[]) => void;
    setDragSortColumns: (val: import("./type").PrimaryTableCol<import("./type").TableRowData>[]) => void;
    onInnerActiveRowAction: (context: import("./type").ActiveRowActionContext<import("./type").TableRowData>) => void;
    innerKeyboardRowHover: import("@vue/composition-api").ComputedRef<boolean>;
    innerDisableSpaceInactiveRow: import("@vue/composition-api").ComputedRef<boolean>;
}> & import("@vue/composition-api").Data, {
    getListener(): import("./base-table").TableListeners;
    formatNode(api: string, renderInnerNode: Function, condition: boolean, extra?: {
        reverse?: boolean;
    }): unknown;
}, {}, {
    asyncLoading: {
        type: import("vue").PropType<"loading" | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue) | "load-more">;
    };
    columnController: {
        type: import("vue").PropType<import("./type").TableColumnController>;
    };
    columnControllerVisible: {
        type: BooleanConstructor;
        default: any;
    };
    defaultColumnControllerVisible: {
        type: BooleanConstructor;
        default: any;
    };
    columns: {
        type: import("vue").PropType<import("./type").PrimaryTableCol<import("./type").TableRowData>[]>;
        default: () => import("./type").PrimaryTableCol<import("./type").TableRowData>[];
    };
    displayColumns: {
        type: import("vue").PropType<import("..").CheckboxGroupValue>;
    };
    defaultDisplayColumns: {
        type: import("vue").PropType<import("..").CheckboxGroupValue>;
    };
    dragSort: {
        type: import("vue").PropType<"col" | "row" | "row-handler" | "row-handler-col" | "drag-col">;
        validator(val: "col" | "row" | "row-handler" | "row-handler-col" | "drag-col"): boolean;
    };
    dragSortOptions: {
        type: import("vue").PropType<import("sortablejs").SortableOptions>;
    };
    editableCellState: {
        type: import("vue").PropType<import("./type").EditableCellType<import("./type").TableRowData>>;
    };
    editableRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
    };
    expandIcon: {
        type: import("vue").PropType<boolean | ((h: import("vue").CreateElement, props: import("./type").ExpandArrowRenderParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: boolean;
    };
    expandOnRowClick: BooleanConstructor;
    expandedRow: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: import("./type").TableExpandedRowParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    expandedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultExpandedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    filterIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: {
            col: import("./type").PrimaryTableCol<import("./type").TableRowData>;
            colIndex: number;
        }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    filterRow: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    filterValue: {
        type: import("vue").PropType<import("./type").FilterValue>;
    };
    defaultFilterValue: {
        type: import("vue").PropType<import("./type").FilterValue>;
    };
    hideSortTips: BooleanConstructor;
    indeterminateSelectedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
    };
    multipleSort: BooleanConstructor;
    reserveSelectedRowOnPaginate: {
        type: BooleanConstructor;
        default: boolean;
    };
    rowSelectionAllowUncheck: BooleanConstructor;
    rowSelectionType: {
        type: import("vue").PropType<"multiple" | "single">;
        validator(val: "multiple" | "single"): boolean;
    };
    selectOnRowClick: BooleanConstructor;
    selectedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultSelectedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    showSortColumnBgColor: BooleanConstructor;
    sort: {
        type: import("vue").PropType<import("./type").TableSort>;
    };
    defaultSort: {
        type: import("vue").PropType<import("./type").TableSort>;
    };
    sortIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    sortOnRowDraggable: BooleanConstructor;
    onAsyncLoadingClick: import("vue").PropType<(context: {
        status: "loading" | "load-more";
    }) => void>;
    onCellClick: import("vue").PropType<(context: import("./type").PrimaryTableCellEventContext<import("./type").TableRowData>) => void>;
    onChange: import("vue").PropType<(data: import("./type").TableChangeData, context: import("./type").TableChangeContext<import("./type").TableRowData>) => void>;
    onColumnChange: import("vue").PropType<(context: import("./type").PrimaryTableColumnChange<import("./type").TableRowData>) => void>;
    onColumnControllerVisibleChange: import("vue").PropType<(visible: boolean, context: {
        trigger: "cancel" | "confirm";
    }) => void>;
    onDataChange: import("vue").PropType<(data: import("./type").TableRowData[], context: import("./type").TableDataChangeContext) => void>;
    onDisplayColumnsChange: import("vue").PropType<(value: import("..").CheckboxGroupValue) => void>;
    onDragSort: import("vue").PropType<(context: import("./type").DragSortContext<import("./type").TableRowData>) => void>;
    onExpandChange: import("vue").PropType<(expandedRowKeys: (string | number)[], options: import("./type").ExpandOptions<import("./type").TableRowData>) => void>;
    onFilterChange: import("vue").PropType<(filterValue: import("./type").FilterValue, context: import("./type").TableFilterChangeContext<import("./type").TableRowData>) => void>;
    onRowEdit: import("vue").PropType<(context: import("./type").PrimaryTableRowEditContext<import("./type").TableRowData>) => void>;
    onRowValidate: import("vue").PropType<(context: import("./type").PrimaryTableRowValidateContext<import("./type").TableRowData>) => void>;
    onSelectChange: import("vue").PropType<(selectedRowKeys: (string | number)[], options: import("./type").SelectOptions<import("./type").TableRowData>) => void>;
    onSortChange: import("vue").PropType<(sort: import("./type").TableSort, options: import("./type").SortOptions<import("./type").TableRowData>) => void>;
    onValidate: import("vue").PropType<(context: import("./type").PrimaryTableValidateContext) => void>;
    activeRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultActiveRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    activeRowType: {
        type: import("vue").PropType<"multiple" | "single">;
        default: string;
    };
    allowResizeColumnWidth: {
        type: BooleanConstructor;
        default: any;
    };
    attach: {
        type: import("vue").PropType<import("..").AttachNode>;
    };
    bordered: BooleanConstructor;
    bottomContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    cellEmptyContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement, props: import("./type").BaseTableCellParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    data: {
        type: import("vue").PropType<import("./type").TableRowData[]>;
        default: () => import("./type").TableRowData[];
    };
    disableDataPage: BooleanConstructor;
    disableSpaceInactiveRow: {
        type: BooleanConstructor;
        default: any;
    };
    empty: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: string;
    };
    firstFullRow: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    fixedRows: {
        type: import("vue").PropType<number[]>;
    };
    footData: {
        type: import("vue").PropType<import("./type").TableRowData[]>;
        default: () => import("./type").TableRowData[];
    };
    footerAffixProps: {
        type: import("vue").PropType<Partial<import("..").TdAffixProps>>;
    };
    footerAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
        default: boolean;
    };
    footerSummary: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    headerAffixProps: {
        type: import("vue").PropType<Partial<import("..").TdAffixProps>>;
    };
    headerAffixedTop: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
        default: boolean;
    };
    height: {
        type: import("vue").PropType<string | number>;
    };
    horizontalScrollAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
    };
    hover: BooleanConstructor;
    keyboardRowHover: {
        type: BooleanConstructor;
        default: boolean;
    };
    lastFullRow: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    lazyLoad: BooleanConstructor;
    loading: {
        type: import("vue").PropType<boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: any;
    };
    loadingProps: {
        type: import("vue").PropType<Partial<import("..").TdLoadingProps>>;
    };
    locale: {
        type: import("vue").PropType<import("..").TableConfig>;
    };
    maxHeight: {
        type: import("vue").PropType<string | number>;
    };
    pagination: {
        type: import("vue").PropType<import("..").TdPaginationProps>;
    };
    paginationAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
    };
    resizable: BooleanConstructor;
    rowAttributes: {
        type: import("vue").PropType<import("./type").TableRowAttributes<import("./type").TableRowData>>;
    };
    rowClassName: {
        type: import("vue").PropType<import("..").ClassName | ((params: import("./type").RowClassNameParams<import("./type").TableRowData>) => import("..").ClassName)>;
    };
    rowKey: {
        type: StringConstructor;
        default: string;
        required: boolean;
    };
    rowspanAndColspan: {
        type: import("vue").PropType<import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>>;
    };
    rowspanAndColspanInFooter: {
        type: import("vue").PropType<import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>>;
    };
    scroll: {
        type: import("vue").PropType<import("..").TScroll>;
    };
    showHeader: {
        type: BooleanConstructor;
        default: boolean;
    };
    size: {
        type: import("vue").PropType<import("..").SizeEnum>;
        validator(val: import("..").SizeEnum): boolean;
    };
    stripe: BooleanConstructor;
    tableContentWidth: {
        type: StringConstructor;
        default: string;
    };
    tableLayout: {
        type: import("vue").PropType<"fixed" | "auto">;
        default: "fixed" | "auto";
        validator(val: "fixed" | "auto"): boolean;
    };
    topContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    verticalAlign: {
        type: import("vue").PropType<"top" | "bottom" | "middle">;
        default: "top" | "bottom" | "middle";
        validator(val: "top" | "bottom" | "middle"): boolean;
    };
    onActiveChange: import("vue").PropType<(activeRowKeys: (string | number)[], context: import("./type").ActiveChangeContext<import("./type").TableRowData>) => void>;
    onActiveRowAction: import("vue").PropType<(context: import("./type").ActiveRowActionContext<import("./type").TableRowData>) => void>;
    onColumnResizeChange: import("vue").PropType<(context: {
        columnsWidth: {
            [colKey: string]: number;
        };
    }) => void>;
    onPageChange: import("vue").PropType<(pageInfo: import("..").PageInfo, newDataSource: import("./type").TableRowData[]) => void>;
    onRowClick: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowDblclick: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMousedown: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseenter: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseleave: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseover: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseup: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onScroll: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
    onScrollX: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
    onScrollY: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
}, import("@vue/composition-api").ExtractPropTypes<{
    asyncLoading: {
        type: import("vue").PropType<"loading" | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue) | "load-more">;
    };
    columnController: {
        type: import("vue").PropType<import("./type").TableColumnController>;
    };
    columnControllerVisible: {
        type: BooleanConstructor;
        default: any;
    };
    defaultColumnControllerVisible: {
        type: BooleanConstructor;
        default: any;
    };
    columns: {
        type: import("vue").PropType<import("./type").PrimaryTableCol<import("./type").TableRowData>[]>;
        default: () => import("./type").PrimaryTableCol<import("./type").TableRowData>[];
    };
    displayColumns: {
        type: import("vue").PropType<import("..").CheckboxGroupValue>;
    };
    defaultDisplayColumns: {
        type: import("vue").PropType<import("..").CheckboxGroupValue>;
    };
    dragSort: {
        type: import("vue").PropType<"col" | "row" | "row-handler" | "row-handler-col" | "drag-col">;
        validator(val: "col" | "row" | "row-handler" | "row-handler-col" | "drag-col"): boolean;
    };
    dragSortOptions: {
        type: import("vue").PropType<import("sortablejs").SortableOptions>;
    };
    editableCellState: {
        type: import("vue").PropType<import("./type").EditableCellType<import("./type").TableRowData>>;
    };
    editableRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
    };
    expandIcon: {
        type: import("vue").PropType<boolean | ((h: import("vue").CreateElement, props: import("./type").ExpandArrowRenderParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: boolean;
    };
    expandOnRowClick: BooleanConstructor;
    expandedRow: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: import("./type").TableExpandedRowParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    expandedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultExpandedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    filterIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: {
            col: import("./type").PrimaryTableCol<import("./type").TableRowData>;
            colIndex: number;
        }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    filterRow: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    filterValue: {
        type: import("vue").PropType<import("./type").FilterValue>;
    };
    defaultFilterValue: {
        type: import("vue").PropType<import("./type").FilterValue>;
    };
    hideSortTips: BooleanConstructor;
    indeterminateSelectedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
    };
    multipleSort: BooleanConstructor;
    reserveSelectedRowOnPaginate: {
        type: BooleanConstructor;
        default: boolean;
    };
    rowSelectionAllowUncheck: BooleanConstructor;
    rowSelectionType: {
        type: import("vue").PropType<"multiple" | "single">;
        validator(val: "multiple" | "single"): boolean;
    };
    selectOnRowClick: BooleanConstructor;
    selectedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultSelectedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    showSortColumnBgColor: BooleanConstructor;
    sort: {
        type: import("vue").PropType<import("./type").TableSort>;
    };
    defaultSort: {
        type: import("vue").PropType<import("./type").TableSort>;
    };
    sortIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    sortOnRowDraggable: BooleanConstructor;
    onAsyncLoadingClick: import("vue").PropType<(context: {
        status: "loading" | "load-more";
    }) => void>;
    onCellClick: import("vue").PropType<(context: import("./type").PrimaryTableCellEventContext<import("./type").TableRowData>) => void>;
    onChange: import("vue").PropType<(data: import("./type").TableChangeData, context: import("./type").TableChangeContext<import("./type").TableRowData>) => void>;
    onColumnChange: import("vue").PropType<(context: import("./type").PrimaryTableColumnChange<import("./type").TableRowData>) => void>;
    onColumnControllerVisibleChange: import("vue").PropType<(visible: boolean, context: {
        trigger: "cancel" | "confirm";
    }) => void>;
    onDataChange: import("vue").PropType<(data: import("./type").TableRowData[], context: import("./type").TableDataChangeContext) => void>;
    onDisplayColumnsChange: import("vue").PropType<(value: import("..").CheckboxGroupValue) => void>;
    onDragSort: import("vue").PropType<(context: import("./type").DragSortContext<import("./type").TableRowData>) => void>;
    onExpandChange: import("vue").PropType<(expandedRowKeys: (string | number)[], options: import("./type").ExpandOptions<import("./type").TableRowData>) => void>;
    onFilterChange: import("vue").PropType<(filterValue: import("./type").FilterValue, context: import("./type").TableFilterChangeContext<import("./type").TableRowData>) => void>;
    onRowEdit: import("vue").PropType<(context: import("./type").PrimaryTableRowEditContext<import("./type").TableRowData>) => void>;
    onRowValidate: import("vue").PropType<(context: import("./type").PrimaryTableRowValidateContext<import("./type").TableRowData>) => void>;
    onSelectChange: import("vue").PropType<(selectedRowKeys: (string | number)[], options: import("./type").SelectOptions<import("./type").TableRowData>) => void>;
    onSortChange: import("vue").PropType<(sort: import("./type").TableSort, options: import("./type").SortOptions<import("./type").TableRowData>) => void>;
    onValidate: import("vue").PropType<(context: import("./type").PrimaryTableValidateContext) => void>;
    activeRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultActiveRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    activeRowType: {
        type: import("vue").PropType<"multiple" | "single">;
        default: string;
    };
    allowResizeColumnWidth: {
        type: BooleanConstructor;
        default: any;
    };
    attach: {
        type: import("vue").PropType<import("..").AttachNode>;
    };
    bordered: BooleanConstructor;
    bottomContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    cellEmptyContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement, props: import("./type").BaseTableCellParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    data: {
        type: import("vue").PropType<import("./type").TableRowData[]>;
        default: () => import("./type").TableRowData[];
    };
    disableDataPage: BooleanConstructor;
    disableSpaceInactiveRow: {
        type: BooleanConstructor;
        default: any;
    };
    empty: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: string;
    };
    firstFullRow: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    fixedRows: {
        type: import("vue").PropType<number[]>;
    };
    footData: {
        type: import("vue").PropType<import("./type").TableRowData[]>;
        default: () => import("./type").TableRowData[];
    };
    footerAffixProps: {
        type: import("vue").PropType<Partial<import("..").TdAffixProps>>;
    };
    footerAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
        default: boolean;
    };
    footerSummary: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    headerAffixProps: {
        type: import("vue").PropType<Partial<import("..").TdAffixProps>>;
    };
    headerAffixedTop: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
        default: boolean;
    };
    height: {
        type: import("vue").PropType<string | number>;
    };
    horizontalScrollAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
    };
    hover: BooleanConstructor;
    keyboardRowHover: {
        type: BooleanConstructor;
        default: boolean;
    };
    lastFullRow: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    lazyLoad: BooleanConstructor;
    loading: {
        type: import("vue").PropType<boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: any;
    };
    loadingProps: {
        type: import("vue").PropType<Partial<import("..").TdLoadingProps>>;
    };
    locale: {
        type: import("vue").PropType<import("..").TableConfig>;
    };
    maxHeight: {
        type: import("vue").PropType<string | number>;
    };
    pagination: {
        type: import("vue").PropType<import("..").TdPaginationProps>;
    };
    paginationAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
    };
    resizable: BooleanConstructor;
    rowAttributes: {
        type: import("vue").PropType<import("./type").TableRowAttributes<import("./type").TableRowData>>;
    };
    rowClassName: {
        type: import("vue").PropType<import("..").ClassName | ((params: import("./type").RowClassNameParams<import("./type").TableRowData>) => import("..").ClassName)>;
    };
    rowKey: {
        type: StringConstructor;
        default: string;
        required: boolean;
    };
    rowspanAndColspan: {
        type: import("vue").PropType<import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>>;
    };
    rowspanAndColspanInFooter: {
        type: import("vue").PropType<import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>>;
    };
    scroll: {
        type: import("vue").PropType<import("..").TScroll>;
    };
    showHeader: {
        type: BooleanConstructor;
        default: boolean;
    };
    size: {
        type: import("vue").PropType<import("..").SizeEnum>;
        validator(val: import("..").SizeEnum): boolean;
    };
    stripe: BooleanConstructor;
    tableContentWidth: {
        type: StringConstructor;
        default: string;
    };
    tableLayout: {
        type: import("vue").PropType<"fixed" | "auto">;
        default: "fixed" | "auto";
        validator(val: "fixed" | "auto"): boolean;
    };
    topContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    verticalAlign: {
        type: import("vue").PropType<"top" | "bottom" | "middle">;
        default: "top" | "bottom" | "middle";
        validator(val: "top" | "bottom" | "middle"): boolean;
    };
    onActiveChange: import("vue").PropType<(activeRowKeys: (string | number)[], context: import("./type").ActiveChangeContext<import("./type").TableRowData>) => void>;
    onActiveRowAction: import("vue").PropType<(context: import("./type").ActiveRowActionContext<import("./type").TableRowData>) => void>;
    onColumnResizeChange: import("vue").PropType<(context: {
        columnsWidth: {
            [colKey: string]: number;
        };
    }) => void>;
    onPageChange: import("vue").PropType<(pageInfo: import("..").PageInfo, newDataSource: import("./type").TableRowData[]) => void>;
    onRowClick: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowDblclick: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMousedown: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseenter: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseleave: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseover: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseup: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onScroll: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
    onScrollX: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
    onScrollY: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
}>> & Omit<import("vue").VueConstructor<import("vue").default>, never> & (new (...args: any[]) => import("@vue/composition-api").ComponentRenderProxy<{
    data: import("./type").TableRowData[];
    columns: import("./type").PrimaryTableCol<import("./type").TableRowData>[];
    tableLayout: "fixed" | "auto";
    verticalAlign: "top" | "bottom" | "middle";
    loading: boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    empty: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    hover: boolean;
    lazyLoad: boolean;
    bordered: boolean;
    showHeader: boolean;
    stripe: boolean;
    activeRowKeys: (string | number)[];
    defaultActiveRowKeys: (string | number)[];
    activeRowType: "multiple" | "single";
    allowResizeColumnWidth: boolean;
    disableDataPage: boolean;
    disableSpaceInactiveRow: boolean;
    footData: import("./type").TableRowData[];
    footerAffixedBottom: boolean;
    headerAffixedTop: boolean;
    keyboardRowHover: boolean;
    resizable: boolean;
    rowKey: string;
    tableContentWidth: string;
    columnControllerVisible: boolean;
    defaultColumnControllerVisible: boolean;
    expandIcon: boolean | ((h: import("vue").CreateElement, props: import("./type").ExpandArrowRenderParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue);
    expandOnRowClick: boolean;
    expandedRowKeys: (string | number)[];
    defaultExpandedRowKeys: (string | number)[];
    hideSortTips: boolean;
    multipleSort: boolean;
    reserveSelectedRowOnPaginate: boolean;
    rowSelectionAllowUncheck: boolean;
    selectOnRowClick: boolean;
    selectedRowKeys: (string | number)[];
    defaultSelectedRowKeys: (string | number)[];
    showSortColumnBgColor: boolean;
    sortOnRowDraggable: boolean;
} & {
    sort?: import("./type").TableSort;
    height?: string | number;
    maxHeight?: string | number;
    scroll?: import("..").TScroll;
    size?: import("..").SizeEnum;
    onChange?: (data: import("./type").TableChangeData, context: import("./type").TableChangeContext<import("./type").TableRowData>) => void;
    attach?: import("..").AttachNode;
    pagination?: unknown;
    onValidate?: (context: import("./type").PrimaryTableValidateContext) => void;
    onScroll?: (params: {
        e: WheelEvent;
    }) => void;
    onDragSort?: (context: import("./type").DragSortContext<import("./type").TableRowData>) => void;
    dragSort?: "col" | "row" | "row-handler" | "row-handler-col" | "drag-col";
    onCellClick?: (context: import("./type").PrimaryTableCellEventContext<import("./type").TableRowData>) => void;
    onPageChange?: (pageInfo: import("..").PageInfo, newDataSource: import("./type").TableRowData[]) => void;
    filterValue?: unknown;
    loadingProps?: unknown;
    asyncLoading?: "loading" | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue) | "load-more";
    bottomContent?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    cellEmptyContent?: string | ((h: import("vue").CreateElement, props: import("./type").BaseTableCellParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue);
    firstFullRow?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    fixedRows?: number[];
    footerAffixProps?: unknown;
    footerSummary?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    headerAffixProps?: unknown;
    horizontalScrollAffixedBottom?: unknown;
    lastFullRow?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    locale?: unknown;
    paginationAffixedBottom?: unknown;
    rowAttributes?: import("./type").TableRowAttributes<import("./type").TableRowData>;
    rowClassName?: unknown;
    rowspanAndColspan?: import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>;
    rowspanAndColspanInFooter?: import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>;
    topContent?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onActiveChange?: (activeRowKeys: (string | number)[], context: import("./type").ActiveChangeContext<import("./type").TableRowData>) => void;
    onActiveRowAction?: (context: import("./type").ActiveRowActionContext<import("./type").TableRowData>) => void;
    onColumnResizeChange?: (context: {
        columnsWidth: {
            [colKey: string]: number;
        };
    }) => void;
    onRowClick?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowDblclick?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMousedown?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseenter?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseleave?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseover?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseup?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onScrollX?: (params: {
        e: WheelEvent;
    }) => void;
    onScrollY?: (params: {
        e: WheelEvent;
    }) => void;
    sortIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    filterIcon?: (h: import("vue").CreateElement, props: {
        col: import("./type").PrimaryTableCol<import("./type").TableRowData>;
        colIndex: number;
    }) => import("vue/types/vnode").ScopedSlotReturnValue;
    columnController?: unknown;
    displayColumns?: import("..").CheckboxGroupValue;
    defaultDisplayColumns?: import("..").CheckboxGroupValue;
    dragSortOptions?: unknown;
    editableCellState?: import("./type").EditableCellType<import("./type").TableRowData>;
    editableRowKeys?: (string | number)[];
    expandedRow?: (h: import("vue").CreateElement, props: import("./type").TableExpandedRowParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue;
    filterRow?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    defaultFilterValue?: unknown;
    indeterminateSelectedRowKeys?: (string | number)[];
    rowSelectionType?: "multiple" | "single";
    defaultSort?: import("./type").TableSort;
    onAsyncLoadingClick?: (context: {
        status: "loading" | "load-more";
    }) => void;
    onColumnChange?: (context: import("./type").PrimaryTableColumnChange<import("./type").TableRowData>) => void;
    onColumnControllerVisibleChange?: (visible: boolean, context: {
        trigger: "cancel" | "confirm";
    }) => void;
    onDataChange?: (data: import("./type").TableRowData[], context: import("./type").TableDataChangeContext) => void;
    onDisplayColumnsChange?: (value: import("..").CheckboxGroupValue) => void;
    onExpandChange?: (expandedRowKeys: (string | number)[], options: import("./type").ExpandOptions<import("./type").TableRowData>) => void;
    onFilterChange?: (filterValue: import("./type").FilterValue, context: import("./type").TableFilterChangeContext<import("./type").TableRowData>) => void;
    onRowEdit?: (context: import("./type").PrimaryTableRowEditContext<import("./type").TableRowData>) => void;
    onRowValidate?: (context: import("./type").PrimaryTableRowValidateContext<import("./type").TableRowData>) => void;
    onSelectChange?: (selectedRowKeys: (string | number)[], options: import("./type").SelectOptions<import("./type").TableRowData>) => void;
    onSortChange?: (sort: import("./type").TableSort, options: import("./type").SortOptions<import("./type").TableRowData>) => void;
}, import("@vue/composition-api").ShallowUnwrapRef<{
    tColumns: import("@vue/composition-api").ComputedRef<import("./type").PrimaryTableCol<import("./type").TableRowData>[]>;
    showExpandedRow: import("@vue/composition-api").ComputedRef<boolean>;
    tRowClassNames: import("@vue/composition-api").ComputedRef<any[]>;
    hasEmptyCondition: import("@vue/composition-api").ComputedRef<boolean>;
    primaryTableRef: any;
    tRowAttributes: import("@vue/composition-api").ComputedRef<import("./type").TableRowAttributes<import("./type").TableRowData>[]>;
    primaryTableClasses: import("@vue/composition-api").ComputedRef<{
        [x: string]: boolean | (string | number)[] | import("./type").PrimaryTableCol<import("./type").TableRowData>;
    }>;
    errorListMap: import("@vue/composition-api").Ref<{
        [x: string]: ({
            result: boolean;
            message: string;
            type?: "error" | "success" | "warning";
        } | {
            result: boolean;
            boolean?: boolean;
            date?: boolean | {
                format: string;
                strictMode: boolean;
                delimiters: string[];
            };
            email?: boolean | {
                allow_display_name?: boolean;
                require_display_name?: boolean;
                allow_utf8_local_part?: boolean;
                require_tld?: boolean;
                ignore_max_length?: boolean;
                allow_ip_domain?: boolean;
                domain_specific_validation?: boolean;
                allow_underscores?: boolean;
                host_blacklist?: string[];
                host_whitelist?: string[];
                blacklisted_chars?: string;
            };
            enum?: string[];
            idcard?: boolean;
            len?: number | boolean;
            max?: number | boolean;
            message?: string;
            min?: number | boolean;
            number?: boolean;
            pattern?: {
                exec: (string: string) => RegExpExecArray;
                test: (string: string) => boolean;
                readonly source: string;
                readonly global: boolean;
                readonly ignoreCase: boolean;
                readonly multiline: boolean;
                lastIndex: number;
                compile: (pattern: string, flags?: string) => RegExp;
                readonly flags: string;
                readonly sticky: boolean;
                readonly unicode: boolean;
                readonly dotAll: boolean;
                [Symbol.match]: (string: string) => RegExpMatchArray;
                [Symbol.replace]: {
                    (string: string, replaceValue: string): string;
                    (string: string, replacer: (substring: string, ...args: any[]) => string): string;
                };
                [Symbol.search]: (string: string) => number;
                [Symbol.split]: (string: string, limit?: number) => string[];
                [Symbol.matchAll]: (str: string) => IterableIterator<RegExpMatchArray>;
            };
            required?: boolean;
            telnumber?: boolean;
            trigger?: "blur" | "change" | "submit" | ("blur" | "change" | "submit")[];
            type?: "error" | "warning";
            url?: boolean | {
                protocols?: string[];
                require_tld?: boolean;
                require_protocol?: boolean;
                require_host?: boolean;
                require_port?: boolean;
                require_valid_protocol?: boolean;
                allow_underscores?: boolean;
                host_whitelist?: (string | {
                    exec: (string: string) => RegExpExecArray;
                    test: (string: string) => boolean;
                    readonly source: string;
                    readonly global: boolean;
                    readonly ignoreCase: boolean;
                    readonly multiline: boolean;
                    lastIndex: number;
                    compile: (pattern: string, flags?: string) => RegExp;
                    readonly flags: string;
                    readonly sticky: boolean;
                    readonly unicode: boolean;
                    readonly dotAll: boolean;
                    [Symbol.match]: (string: string) => RegExpMatchArray;
                    [Symbol.replace]: {
                        (string: string, replaceValue: string): string;
                        (string: string, replacer: (substring: string, ...args: any[]) => string): string;
                    };
                    [Symbol.search]: (string: string) => number;
                    [Symbol.split]: (string: string, limit?: number) => string[];
                    [Symbol.matchAll]: (str: string) => IterableIterator<RegExpMatchArray>;
                })[];
                host_blacklist?: (string | {
                    exec: (string: string) => RegExpExecArray;
                    test: (string: string) => boolean;
                    readonly source: string;
                    readonly global: boolean;
                    readonly ignoreCase: boolean;
                    readonly multiline: boolean;
                    lastIndex: number;
                    compile: (pattern: string, flags?: string) => RegExp;
                    readonly flags: string;
                    readonly sticky: boolean;
                    readonly unicode: boolean;
                    readonly dotAll: boolean;
                    [Symbol.match]: (string: string) => RegExpMatchArray;
                    [Symbol.replace]: {
                        (string: string, replaceValue: string): string;
                        (string: string, replacer: (substring: string, ...args: any[]) => string): string;
                    };
                    [Symbol.search]: (string: string) => number;
                    [Symbol.split]: (string: string, limit?: number) => string[];
                    [Symbol.matchAll]: (str: string) => IterableIterator<RegExpMatchArray>;
                })[];
                allow_trailing_dot?: boolean;
                allow_protocol_relative_urls?: boolean;
                disallow_auth?: boolean;
                allow_fragments?: boolean;
                allow_query_components?: boolean;
                validate_length?: boolean;
                max_allowed_length?: number | false;
            };
            validator?: import("..").CustomValidator;
            whitespace?: boolean;
        })[];
    }>;
    onShowElementChange: (val: boolean) => void;
    scrollToElement: (data: import("..").ComponentScrollToElementParams) => void;
    scrollColumnIntoView: (colKey: string) => void;
    refreshTable: () => void;
    validateRowData: (rowValue: any) => Promise<unknown>;
    validateTableData: () => Promise<unknown>;
    clearValidateData: () => void;
    renderTNode: (name: string, options?: import("../hooks/render-tnode").OptionsType) => any;
    renderColumnController: (h: import("vue").CreateElement) => JSX.Element;
    renderExpandedRow: (h: import("vue").CreateElement, p: import("./type").TableExpandedRowParams<import("./type").TableRowData> & {
        tableWidth: number;
        isWidthOverflow: boolean;
    }) => JSX.Element;
    onInnerExpandRowClick: (p: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onInnerRowClick: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    renderFirstFilterRow: (h: import("vue").CreateElement) => JSX.Element;
    renderAsyncLoading: (h: import("vue").CreateElement) => JSX.Element;
    onInnerPageChange: (pageInfo: import("..").PageInfo, newData: import("./type").TableRowData[]) => void;
    setDragSortColumns: (val: import("./type").PrimaryTableCol<import("./type").TableRowData>[]) => void;
    onInnerActiveRowAction: (context: import("./type").ActiveRowActionContext<import("./type").TableRowData>) => void;
    innerKeyboardRowHover: import("@vue/composition-api").ComputedRef<boolean>;
    innerDisableSpaceInactiveRow: import("@vue/composition-api").ComputedRef<boolean>;
}>, import("@vue/composition-api").Data, {}, {
    getListener(): import("./base-table").TableListeners;
    formatNode(api: string, renderInnerNode: Function, condition: boolean, extra?: {
        reverse?: boolean;
    }): unknown;
}, {}, {}, {}, {
    data: import("./type").TableRowData[];
    columns: import("./type").PrimaryTableCol<import("./type").TableRowData>[];
    tableLayout: "fixed" | "auto";
    verticalAlign: "top" | "bottom" | "middle";
    loading: boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    empty: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    hover: boolean;
    lazyLoad: boolean;
    bordered: boolean;
    showHeader: boolean;
    stripe: boolean;
    activeRowKeys: (string | number)[];
    defaultActiveRowKeys: (string | number)[];
    activeRowType: "multiple" | "single";
    allowResizeColumnWidth: boolean;
    disableDataPage: boolean;
    disableSpaceInactiveRow: boolean;
    footData: import("./type").TableRowData[];
    footerAffixedBottom: boolean;
    headerAffixedTop: boolean;
    keyboardRowHover: boolean;
    resizable: boolean;
    rowKey: string;
    tableContentWidth: string;
    columnControllerVisible: boolean;
    defaultColumnControllerVisible: boolean;
    expandIcon: boolean | ((h: import("vue").CreateElement, props: import("./type").ExpandArrowRenderParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue);
    expandOnRowClick: boolean;
    expandedRowKeys: (string | number)[];
    defaultExpandedRowKeys: (string | number)[];
    hideSortTips: boolean;
    multipleSort: boolean;
    reserveSelectedRowOnPaginate: boolean;
    rowSelectionAllowUncheck: boolean;
    selectOnRowClick: boolean;
    selectedRowKeys: (string | number)[];
    defaultSelectedRowKeys: (string | number)[];
    showSortColumnBgColor: boolean;
    sortOnRowDraggable: boolean;
} & {
    sort?: import("./type").TableSort;
    height?: string | number;
    maxHeight?: string | number;
    scroll?: import("..").TScroll;
    size?: import("..").SizeEnum;
    onChange?: (data: import("./type").TableChangeData, context: import("./type").TableChangeContext<import("./type").TableRowData>) => void;
    attach?: import("..").AttachNode;
    pagination?: unknown;
    onValidate?: (context: import("./type").PrimaryTableValidateContext) => void;
    onScroll?: (params: {
        e: WheelEvent;
    }) => void;
    onDragSort?: (context: import("./type").DragSortContext<import("./type").TableRowData>) => void;
    dragSort?: "col" | "row" | "row-handler" | "row-handler-col" | "drag-col";
    onCellClick?: (context: import("./type").PrimaryTableCellEventContext<import("./type").TableRowData>) => void;
    onPageChange?: (pageInfo: import("..").PageInfo, newDataSource: import("./type").TableRowData[]) => void;
    filterValue?: unknown;
    loadingProps?: unknown;
    asyncLoading?: "loading" | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue) | "load-more";
    bottomContent?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    cellEmptyContent?: string | ((h: import("vue").CreateElement, props: import("./type").BaseTableCellParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue);
    firstFullRow?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    fixedRows?: number[];
    footerAffixProps?: unknown;
    footerSummary?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    headerAffixProps?: unknown;
    horizontalScrollAffixedBottom?: unknown;
    lastFullRow?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    locale?: unknown;
    paginationAffixedBottom?: unknown;
    rowAttributes?: import("./type").TableRowAttributes<import("./type").TableRowData>;
    rowClassName?: unknown;
    rowspanAndColspan?: import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>;
    rowspanAndColspanInFooter?: import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>;
    topContent?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onActiveChange?: (activeRowKeys: (string | number)[], context: import("./type").ActiveChangeContext<import("./type").TableRowData>) => void;
    onActiveRowAction?: (context: import("./type").ActiveRowActionContext<import("./type").TableRowData>) => void;
    onColumnResizeChange?: (context: {
        columnsWidth: {
            [colKey: string]: number;
        };
    }) => void;
    onRowClick?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowDblclick?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMousedown?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseenter?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseleave?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseover?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseup?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onScrollX?: (params: {
        e: WheelEvent;
    }) => void;
    onScrollY?: (params: {
        e: WheelEvent;
    }) => void;
    sortIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    filterIcon?: (h: import("vue").CreateElement, props: {
        col: import("./type").PrimaryTableCol<import("./type").TableRowData>;
        colIndex: number;
    }) => import("vue/types/vnode").ScopedSlotReturnValue;
    columnController?: unknown;
    displayColumns?: import("..").CheckboxGroupValue;
    defaultDisplayColumns?: import("..").CheckboxGroupValue;
    dragSortOptions?: unknown;
    editableCellState?: import("./type").EditableCellType<import("./type").TableRowData>;
    editableRowKeys?: (string | number)[];
    expandedRow?: (h: import("vue").CreateElement, props: import("./type").TableExpandedRowParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue;
    filterRow?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    defaultFilterValue?: unknown;
    indeterminateSelectedRowKeys?: (string | number)[];
    rowSelectionType?: "multiple" | "single";
    defaultSort?: import("./type").TableSort;
    onAsyncLoadingClick?: (context: {
        status: "loading" | "load-more";
    }) => void;
    onColumnChange?: (context: import("./type").PrimaryTableColumnChange<import("./type").TableRowData>) => void;
    onColumnControllerVisibleChange?: (visible: boolean, context: {
        trigger: "cancel" | "confirm";
    }) => void;
    onDataChange?: (data: import("./type").TableRowData[], context: import("./type").TableDataChangeContext) => void;
    onDisplayColumnsChange?: (value: import("..").CheckboxGroupValue) => void;
    onExpandChange?: (expandedRowKeys: (string | number)[], options: import("./type").ExpandOptions<import("./type").TableRowData>) => void;
    onFilterChange?: (filterValue: import("./type").FilterValue, context: import("./type").TableFilterChangeContext<import("./type").TableRowData>) => void;
    onRowEdit?: (context: import("./type").PrimaryTableRowEditContext<import("./type").TableRowData>) => void;
    onRowValidate?: (context: import("./type").PrimaryTableRowValidateContext<import("./type").TableRowData>) => void;
    onSelectChange?: (selectedRowKeys: (string | number)[], options: import("./type").SelectOptions<import("./type").TableRowData>) => void;
    onSortChange?: (sort: import("./type").TableSort, options: import("./type").SortOptions<import("./type").TableRowData>) => void;
}, {
    data: import("./type").TableRowData[];
    columns: import("./type").PrimaryTableCol<import("./type").TableRowData>[];
    tableLayout: "fixed" | "auto";
    verticalAlign: "top" | "bottom" | "middle";
    loading: boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    empty: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    hover: boolean;
    lazyLoad: boolean;
    bordered: boolean;
    showHeader: boolean;
    stripe: boolean;
    activeRowKeys: (string | number)[];
    defaultActiveRowKeys: (string | number)[];
    activeRowType: "multiple" | "single";
    allowResizeColumnWidth: boolean;
    disableDataPage: boolean;
    disableSpaceInactiveRow: boolean;
    footData: import("./type").TableRowData[];
    footerAffixedBottom: boolean;
    headerAffixedTop: boolean;
    keyboardRowHover: boolean;
    resizable: boolean;
    rowKey: string;
    tableContentWidth: string;
    columnControllerVisible: boolean;
    defaultColumnControllerVisible: boolean;
    expandIcon: boolean | ((h: import("vue").CreateElement, props: import("./type").ExpandArrowRenderParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue);
    expandOnRowClick: boolean;
    expandedRowKeys: (string | number)[];
    defaultExpandedRowKeys: (string | number)[];
    hideSortTips: boolean;
    multipleSort: boolean;
    reserveSelectedRowOnPaginate: boolean;
    rowSelectionAllowUncheck: boolean;
    selectOnRowClick: boolean;
    selectedRowKeys: (string | number)[];
    defaultSelectedRowKeys: (string | number)[];
    showSortColumnBgColor: boolean;
    sortOnRowDraggable: boolean;
}, true>) & import("vue").PluginObject<import("vue").ComponentOptions<import("vue").default, import("@vue/composition-api").ShallowUnwrapRef<{
    tColumns: import("@vue/composition-api").ComputedRef<import("./type").PrimaryTableCol<import("./type").TableRowData>[]>;
    showExpandedRow: import("@vue/composition-api").ComputedRef<boolean>;
    tRowClassNames: import("@vue/composition-api").ComputedRef<any[]>;
    hasEmptyCondition: import("@vue/composition-api").ComputedRef<boolean>;
    primaryTableRef: any;
    tRowAttributes: import("@vue/composition-api").ComputedRef<import("./type").TableRowAttributes<import("./type").TableRowData>[]>;
    primaryTableClasses: import("@vue/composition-api").ComputedRef<{
        [x: string]: boolean | (string | number)[] | import("./type").PrimaryTableCol<import("./type").TableRowData>;
    }>;
    errorListMap: import("@vue/composition-api").Ref<{
        [x: string]: ({
            result: boolean;
            message: string;
            type?: "error" | "success" | "warning";
        } | {
            result: boolean;
            boolean?: boolean;
            date?: boolean | {
                format: string;
                strictMode: boolean;
                delimiters: string[];
            };
            email?: boolean | {
                allow_display_name?: boolean;
                require_display_name?: boolean;
                allow_utf8_local_part?: boolean;
                require_tld?: boolean;
                ignore_max_length?: boolean;
                allow_ip_domain?: boolean;
                domain_specific_validation?: boolean;
                allow_underscores?: boolean;
                host_blacklist?: string[];
                host_whitelist?: string[];
                blacklisted_chars?: string;
            };
            enum?: string[];
            idcard?: boolean;
            len?: number | boolean;
            max?: number | boolean;
            message?: string;
            min?: number | boolean;
            number?: boolean;
            pattern?: {
                exec: (string: string) => RegExpExecArray;
                test: (string: string) => boolean;
                readonly source: string;
                readonly global: boolean;
                readonly ignoreCase: boolean;
                readonly multiline: boolean;
                lastIndex: number;
                compile: (pattern: string, flags?: string) => RegExp;
                readonly flags: string;
                readonly sticky: boolean;
                readonly unicode: boolean;
                readonly dotAll: boolean;
                [Symbol.match]: (string: string) => RegExpMatchArray;
                [Symbol.replace]: {
                    (string: string, replaceValue: string): string;
                    (string: string, replacer: (substring: string, ...args: any[]) => string): string;
                };
                [Symbol.search]: (string: string) => number;
                [Symbol.split]: (string: string, limit?: number) => string[];
                [Symbol.matchAll]: (str: string) => IterableIterator<RegExpMatchArray>;
            };
            required?: boolean;
            telnumber?: boolean;
            trigger?: "blur" | "change" | "submit" | ("blur" | "change" | "submit")[];
            type?: "error" | "warning";
            url?: boolean | {
                protocols?: string[];
                require_tld?: boolean;
                require_protocol?: boolean;
                require_host?: boolean;
                require_port?: boolean;
                require_valid_protocol?: boolean;
                allow_underscores?: boolean;
                host_whitelist?: (string | {
                    exec: (string: string) => RegExpExecArray;
                    test: (string: string) => boolean;
                    readonly source: string;
                    readonly global: boolean;
                    readonly ignoreCase: boolean;
                    readonly multiline: boolean;
                    lastIndex: number;
                    compile: (pattern: string, flags?: string) => RegExp;
                    readonly flags: string;
                    readonly sticky: boolean;
                    readonly unicode: boolean;
                    readonly dotAll: boolean;
                    [Symbol.match]: (string: string) => RegExpMatchArray;
                    [Symbol.replace]: {
                        (string: string, replaceValue: string): string;
                        (string: string, replacer: (substring: string, ...args: any[]) => string): string;
                    };
                    [Symbol.search]: (string: string) => number;
                    [Symbol.split]: (string: string, limit?: number) => string[];
                    [Symbol.matchAll]: (str: string) => IterableIterator<RegExpMatchArray>;
                })[];
                host_blacklist?: (string | {
                    exec: (string: string) => RegExpExecArray;
                    test: (string: string) => boolean;
                    readonly source: string;
                    readonly global: boolean;
                    readonly ignoreCase: boolean;
                    readonly multiline: boolean;
                    lastIndex: number;
                    compile: (pattern: string, flags?: string) => RegExp;
                    readonly flags: string;
                    readonly sticky: boolean;
                    readonly unicode: boolean;
                    readonly dotAll: boolean;
                    [Symbol.match]: (string: string) => RegExpMatchArray;
                    [Symbol.replace]: {
                        (string: string, replaceValue: string): string;
                        (string: string, replacer: (substring: string, ...args: any[]) => string): string;
                    };
                    [Symbol.search]: (string: string) => number;
                    [Symbol.split]: (string: string, limit?: number) => string[];
                    [Symbol.matchAll]: (str: string) => IterableIterator<RegExpMatchArray>;
                })[];
                allow_trailing_dot?: boolean;
                allow_protocol_relative_urls?: boolean;
                disallow_auth?: boolean;
                allow_fragments?: boolean;
                allow_query_components?: boolean;
                validate_length?: boolean;
                max_allowed_length?: number | false;
            };
            validator?: import("..").CustomValidator;
            whitespace?: boolean;
        })[];
    }>;
    onShowElementChange: (val: boolean) => void;
    scrollToElement: (data: import("..").ComponentScrollToElementParams) => void;
    scrollColumnIntoView: (colKey: string) => void;
    refreshTable: () => void;
    validateRowData: (rowValue: any) => Promise<unknown>;
    validateTableData: () => Promise<unknown>;
    clearValidateData: () => void;
    renderTNode: (name: string, options?: import("../hooks/render-tnode").OptionsType) => any;
    renderColumnController: (h: import("vue").CreateElement) => JSX.Element;
    renderExpandedRow: (h: import("vue").CreateElement, p: import("./type").TableExpandedRowParams<import("./type").TableRowData> & {
        tableWidth: number;
        isWidthOverflow: boolean;
    }) => JSX.Element;
    onInnerExpandRowClick: (p: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onInnerRowClick: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    renderFirstFilterRow: (h: import("vue").CreateElement) => JSX.Element;
    renderAsyncLoading: (h: import("vue").CreateElement) => JSX.Element;
    onInnerPageChange: (pageInfo: import("..").PageInfo, newData: import("./type").TableRowData[]) => void;
    setDragSortColumns: (val: import("./type").PrimaryTableCol<import("./type").TableRowData>[]) => void;
    onInnerActiveRowAction: (context: import("./type").ActiveRowActionContext<import("./type").TableRowData>) => void;
    innerKeyboardRowHover: import("@vue/composition-api").ComputedRef<boolean>;
    innerDisableSpaceInactiveRow: import("@vue/composition-api").ComputedRef<boolean>;
}> & import("@vue/composition-api").Data, {
    getListener(): import("./base-table").TableListeners;
    formatNode(api: string, renderInnerNode: Function, condition: boolean, extra?: {
        reverse?: boolean;
    }): unknown;
}, {}, {
    asyncLoading: {
        type: import("vue").PropType<"loading" | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue) | "load-more">;
    };
    columnController: {
        type: import("vue").PropType<import("./type").TableColumnController>;
    };
    columnControllerVisible: {
        type: BooleanConstructor;
        default: any;
    };
    defaultColumnControllerVisible: {
        type: BooleanConstructor;
        default: any;
    };
    columns: {
        type: import("vue").PropType<import("./type").PrimaryTableCol<import("./type").TableRowData>[]>;
        default: () => import("./type").PrimaryTableCol<import("./type").TableRowData>[];
    };
    displayColumns: {
        type: import("vue").PropType<import("..").CheckboxGroupValue>;
    };
    defaultDisplayColumns: {
        type: import("vue").PropType<import("..").CheckboxGroupValue>;
    };
    dragSort: {
        type: import("vue").PropType<"col" | "row" | "row-handler" | "row-handler-col" | "drag-col">;
        validator(val: "col" | "row" | "row-handler" | "row-handler-col" | "drag-col"): boolean;
    };
    dragSortOptions: {
        type: import("vue").PropType<import("sortablejs").SortableOptions>;
    };
    editableCellState: {
        type: import("vue").PropType<import("./type").EditableCellType<import("./type").TableRowData>>;
    };
    editableRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
    };
    expandIcon: {
        type: import("vue").PropType<boolean | ((h: import("vue").CreateElement, props: import("./type").ExpandArrowRenderParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: boolean;
    };
    expandOnRowClick: BooleanConstructor;
    expandedRow: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: import("./type").TableExpandedRowParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    expandedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultExpandedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    filterIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: {
            col: import("./type").PrimaryTableCol<import("./type").TableRowData>;
            colIndex: number;
        }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    filterRow: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    filterValue: {
        type: import("vue").PropType<import("./type").FilterValue>;
    };
    defaultFilterValue: {
        type: import("vue").PropType<import("./type").FilterValue>;
    };
    hideSortTips: BooleanConstructor;
    indeterminateSelectedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
    };
    multipleSort: BooleanConstructor;
    reserveSelectedRowOnPaginate: {
        type: BooleanConstructor;
        default: boolean;
    };
    rowSelectionAllowUncheck: BooleanConstructor;
    rowSelectionType: {
        type: import("vue").PropType<"multiple" | "single">;
        validator(val: "multiple" | "single"): boolean;
    };
    selectOnRowClick: BooleanConstructor;
    selectedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultSelectedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    showSortColumnBgColor: BooleanConstructor;
    sort: {
        type: import("vue").PropType<import("./type").TableSort>;
    };
    defaultSort: {
        type: import("vue").PropType<import("./type").TableSort>;
    };
    sortIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    sortOnRowDraggable: BooleanConstructor;
    onAsyncLoadingClick: import("vue").PropType<(context: {
        status: "loading" | "load-more";
    }) => void>;
    onCellClick: import("vue").PropType<(context: import("./type").PrimaryTableCellEventContext<import("./type").TableRowData>) => void>;
    onChange: import("vue").PropType<(data: import("./type").TableChangeData, context: import("./type").TableChangeContext<import("./type").TableRowData>) => void>;
    onColumnChange: import("vue").PropType<(context: import("./type").PrimaryTableColumnChange<import("./type").TableRowData>) => void>;
    onColumnControllerVisibleChange: import("vue").PropType<(visible: boolean, context: {
        trigger: "cancel" | "confirm";
    }) => void>;
    onDataChange: import("vue").PropType<(data: import("./type").TableRowData[], context: import("./type").TableDataChangeContext) => void>;
    onDisplayColumnsChange: import("vue").PropType<(value: import("..").CheckboxGroupValue) => void>;
    onDragSort: import("vue").PropType<(context: import("./type").DragSortContext<import("./type").TableRowData>) => void>;
    onExpandChange: import("vue").PropType<(expandedRowKeys: (string | number)[], options: import("./type").ExpandOptions<import("./type").TableRowData>) => void>;
    onFilterChange: import("vue").PropType<(filterValue: import("./type").FilterValue, context: import("./type").TableFilterChangeContext<import("./type").TableRowData>) => void>;
    onRowEdit: import("vue").PropType<(context: import("./type").PrimaryTableRowEditContext<import("./type").TableRowData>) => void>;
    onRowValidate: import("vue").PropType<(context: import("./type").PrimaryTableRowValidateContext<import("./type").TableRowData>) => void>;
    onSelectChange: import("vue").PropType<(selectedRowKeys: (string | number)[], options: import("./type").SelectOptions<import("./type").TableRowData>) => void>;
    onSortChange: import("vue").PropType<(sort: import("./type").TableSort, options: import("./type").SortOptions<import("./type").TableRowData>) => void>;
    onValidate: import("vue").PropType<(context: import("./type").PrimaryTableValidateContext) => void>;
    activeRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultActiveRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    activeRowType: {
        type: import("vue").PropType<"multiple" | "single">;
        default: string;
    };
    allowResizeColumnWidth: {
        type: BooleanConstructor;
        default: any;
    };
    attach: {
        type: import("vue").PropType<import("..").AttachNode>;
    };
    bordered: BooleanConstructor;
    bottomContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    cellEmptyContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement, props: import("./type").BaseTableCellParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    data: {
        type: import("vue").PropType<import("./type").TableRowData[]>;
        default: () => import("./type").TableRowData[];
    };
    disableDataPage: BooleanConstructor;
    disableSpaceInactiveRow: {
        type: BooleanConstructor;
        default: any;
    };
    empty: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: string;
    };
    firstFullRow: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    fixedRows: {
        type: import("vue").PropType<number[]>;
    };
    footData: {
        type: import("vue").PropType<import("./type").TableRowData[]>;
        default: () => import("./type").TableRowData[];
    };
    footerAffixProps: {
        type: import("vue").PropType<Partial<import("..").TdAffixProps>>;
    };
    footerAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
        default: boolean;
    };
    footerSummary: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    headerAffixProps: {
        type: import("vue").PropType<Partial<import("..").TdAffixProps>>;
    };
    headerAffixedTop: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
        default: boolean;
    };
    height: {
        type: import("vue").PropType<string | number>;
    };
    horizontalScrollAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
    };
    hover: BooleanConstructor;
    keyboardRowHover: {
        type: BooleanConstructor;
        default: boolean;
    };
    lastFullRow: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    lazyLoad: BooleanConstructor;
    loading: {
        type: import("vue").PropType<boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: any;
    };
    loadingProps: {
        type: import("vue").PropType<Partial<import("..").TdLoadingProps>>;
    };
    locale: {
        type: import("vue").PropType<import("..").TableConfig>;
    };
    maxHeight: {
        type: import("vue").PropType<string | number>;
    };
    pagination: {
        type: import("vue").PropType<import("..").TdPaginationProps>;
    };
    paginationAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
    };
    resizable: BooleanConstructor;
    rowAttributes: {
        type: import("vue").PropType<import("./type").TableRowAttributes<import("./type").TableRowData>>;
    };
    rowClassName: {
        type: import("vue").PropType<import("..").ClassName | ((params: import("./type").RowClassNameParams<import("./type").TableRowData>) => import("..").ClassName)>;
    };
    rowKey: {
        type: StringConstructor;
        default: string;
        required: boolean;
    };
    rowspanAndColspan: {
        type: import("vue").PropType<import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>>;
    };
    rowspanAndColspanInFooter: {
        type: import("vue").PropType<import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>>;
    };
    scroll: {
        type: import("vue").PropType<import("..").TScroll>;
    };
    showHeader: {
        type: BooleanConstructor;
        default: boolean;
    };
    size: {
        type: import("vue").PropType<import("..").SizeEnum>;
        validator(val: import("..").SizeEnum): boolean;
    };
    stripe: BooleanConstructor;
    tableContentWidth: {
        type: StringConstructor;
        default: string;
    };
    tableLayout: {
        type: import("vue").PropType<"fixed" | "auto">;
        default: "fixed" | "auto";
        validator(val: "fixed" | "auto"): boolean;
    };
    topContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    verticalAlign: {
        type: import("vue").PropType<"top" | "bottom" | "middle">;
        default: "top" | "bottom" | "middle";
        validator(val: "top" | "bottom" | "middle"): boolean;
    };
    onActiveChange: import("vue").PropType<(activeRowKeys: (string | number)[], context: import("./type").ActiveChangeContext<import("./type").TableRowData>) => void>;
    onActiveRowAction: import("vue").PropType<(context: import("./type").ActiveRowActionContext<import("./type").TableRowData>) => void>;
    onColumnResizeChange: import("vue").PropType<(context: {
        columnsWidth: {
            [colKey: string]: number;
        };
    }) => void>;
    onPageChange: import("vue").PropType<(pageInfo: import("..").PageInfo, newDataSource: import("./type").TableRowData[]) => void>;
    onRowClick: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowDblclick: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMousedown: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseenter: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseleave: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseover: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseup: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onScroll: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
    onScrollX: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
    onScrollY: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
}, import("@vue/composition-api").ExtractPropTypes<{
    asyncLoading: {
        type: import("vue").PropType<"loading" | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue) | "load-more">;
    };
    columnController: {
        type: import("vue").PropType<import("./type").TableColumnController>;
    };
    columnControllerVisible: {
        type: BooleanConstructor;
        default: any;
    };
    defaultColumnControllerVisible: {
        type: BooleanConstructor;
        default: any;
    };
    columns: {
        type: import("vue").PropType<import("./type").PrimaryTableCol<import("./type").TableRowData>[]>;
        default: () => import("./type").PrimaryTableCol<import("./type").TableRowData>[];
    };
    displayColumns: {
        type: import("vue").PropType<import("..").CheckboxGroupValue>;
    };
    defaultDisplayColumns: {
        type: import("vue").PropType<import("..").CheckboxGroupValue>;
    };
    dragSort: {
        type: import("vue").PropType<"col" | "row" | "row-handler" | "row-handler-col" | "drag-col">;
        validator(val: "col" | "row" | "row-handler" | "row-handler-col" | "drag-col"): boolean;
    };
    dragSortOptions: {
        type: import("vue").PropType<import("sortablejs").SortableOptions>;
    };
    editableCellState: {
        type: import("vue").PropType<import("./type").EditableCellType<import("./type").TableRowData>>;
    };
    editableRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
    };
    expandIcon: {
        type: import("vue").PropType<boolean | ((h: import("vue").CreateElement, props: import("./type").ExpandArrowRenderParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: boolean;
    };
    expandOnRowClick: BooleanConstructor;
    expandedRow: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: import("./type").TableExpandedRowParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    expandedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultExpandedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    filterIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: {
            col: import("./type").PrimaryTableCol<import("./type").TableRowData>;
            colIndex: number;
        }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    filterRow: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    filterValue: {
        type: import("vue").PropType<import("./type").FilterValue>;
    };
    defaultFilterValue: {
        type: import("vue").PropType<import("./type").FilterValue>;
    };
    hideSortTips: BooleanConstructor;
    indeterminateSelectedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
    };
    multipleSort: BooleanConstructor;
    reserveSelectedRowOnPaginate: {
        type: BooleanConstructor;
        default: boolean;
    };
    rowSelectionAllowUncheck: BooleanConstructor;
    rowSelectionType: {
        type: import("vue").PropType<"multiple" | "single">;
        validator(val: "multiple" | "single"): boolean;
    };
    selectOnRowClick: BooleanConstructor;
    selectedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultSelectedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    showSortColumnBgColor: BooleanConstructor;
    sort: {
        type: import("vue").PropType<import("./type").TableSort>;
    };
    defaultSort: {
        type: import("vue").PropType<import("./type").TableSort>;
    };
    sortIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    sortOnRowDraggable: BooleanConstructor;
    onAsyncLoadingClick: import("vue").PropType<(context: {
        status: "loading" | "load-more";
    }) => void>;
    onCellClick: import("vue").PropType<(context: import("./type").PrimaryTableCellEventContext<import("./type").TableRowData>) => void>;
    onChange: import("vue").PropType<(data: import("./type").TableChangeData, context: import("./type").TableChangeContext<import("./type").TableRowData>) => void>;
    onColumnChange: import("vue").PropType<(context: import("./type").PrimaryTableColumnChange<import("./type").TableRowData>) => void>;
    onColumnControllerVisibleChange: import("vue").PropType<(visible: boolean, context: {
        trigger: "cancel" | "confirm";
    }) => void>;
    onDataChange: import("vue").PropType<(data: import("./type").TableRowData[], context: import("./type").TableDataChangeContext) => void>;
    onDisplayColumnsChange: import("vue").PropType<(value: import("..").CheckboxGroupValue) => void>;
    onDragSort: import("vue").PropType<(context: import("./type").DragSortContext<import("./type").TableRowData>) => void>;
    onExpandChange: import("vue").PropType<(expandedRowKeys: (string | number)[], options: import("./type").ExpandOptions<import("./type").TableRowData>) => void>;
    onFilterChange: import("vue").PropType<(filterValue: import("./type").FilterValue, context: import("./type").TableFilterChangeContext<import("./type").TableRowData>) => void>;
    onRowEdit: import("vue").PropType<(context: import("./type").PrimaryTableRowEditContext<import("./type").TableRowData>) => void>;
    onRowValidate: import("vue").PropType<(context: import("./type").PrimaryTableRowValidateContext<import("./type").TableRowData>) => void>;
    onSelectChange: import("vue").PropType<(selectedRowKeys: (string | number)[], options: import("./type").SelectOptions<import("./type").TableRowData>) => void>;
    onSortChange: import("vue").PropType<(sort: import("./type").TableSort, options: import("./type").SortOptions<import("./type").TableRowData>) => void>;
    onValidate: import("vue").PropType<(context: import("./type").PrimaryTableValidateContext) => void>;
    activeRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultActiveRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    activeRowType: {
        type: import("vue").PropType<"multiple" | "single">;
        default: string;
    };
    allowResizeColumnWidth: {
        type: BooleanConstructor;
        default: any;
    };
    attach: {
        type: import("vue").PropType<import("..").AttachNode>;
    };
    bordered: BooleanConstructor;
    bottomContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    cellEmptyContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement, props: import("./type").BaseTableCellParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    data: {
        type: import("vue").PropType<import("./type").TableRowData[]>;
        default: () => import("./type").TableRowData[];
    };
    disableDataPage: BooleanConstructor;
    disableSpaceInactiveRow: {
        type: BooleanConstructor;
        default: any;
    };
    empty: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: string;
    };
    firstFullRow: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    fixedRows: {
        type: import("vue").PropType<number[]>;
    };
    footData: {
        type: import("vue").PropType<import("./type").TableRowData[]>;
        default: () => import("./type").TableRowData[];
    };
    footerAffixProps: {
        type: import("vue").PropType<Partial<import("..").TdAffixProps>>;
    };
    footerAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
        default: boolean;
    };
    footerSummary: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    headerAffixProps: {
        type: import("vue").PropType<Partial<import("..").TdAffixProps>>;
    };
    headerAffixedTop: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
        default: boolean;
    };
    height: {
        type: import("vue").PropType<string | number>;
    };
    horizontalScrollAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
    };
    hover: BooleanConstructor;
    keyboardRowHover: {
        type: BooleanConstructor;
        default: boolean;
    };
    lastFullRow: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    lazyLoad: BooleanConstructor;
    loading: {
        type: import("vue").PropType<boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: any;
    };
    loadingProps: {
        type: import("vue").PropType<Partial<import("..").TdLoadingProps>>;
    };
    locale: {
        type: import("vue").PropType<import("..").TableConfig>;
    };
    maxHeight: {
        type: import("vue").PropType<string | number>;
    };
    pagination: {
        type: import("vue").PropType<import("..").TdPaginationProps>;
    };
    paginationAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
    };
    resizable: BooleanConstructor;
    rowAttributes: {
        type: import("vue").PropType<import("./type").TableRowAttributes<import("./type").TableRowData>>;
    };
    rowClassName: {
        type: import("vue").PropType<import("..").ClassName | ((params: import("./type").RowClassNameParams<import("./type").TableRowData>) => import("..").ClassName)>;
    };
    rowKey: {
        type: StringConstructor;
        default: string;
        required: boolean;
    };
    rowspanAndColspan: {
        type: import("vue").PropType<import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>>;
    };
    rowspanAndColspanInFooter: {
        type: import("vue").PropType<import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>>;
    };
    scroll: {
        type: import("vue").PropType<import("..").TScroll>;
    };
    showHeader: {
        type: BooleanConstructor;
        default: boolean;
    };
    size: {
        type: import("vue").PropType<import("..").SizeEnum>;
        validator(val: import("..").SizeEnum): boolean;
    };
    stripe: BooleanConstructor;
    tableContentWidth: {
        type: StringConstructor;
        default: string;
    };
    tableLayout: {
        type: import("vue").PropType<"fixed" | "auto">;
        default: "fixed" | "auto";
        validator(val: "fixed" | "auto"): boolean;
    };
    topContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    verticalAlign: {
        type: import("vue").PropType<"top" | "bottom" | "middle">;
        default: "top" | "bottom" | "middle";
        validator(val: "top" | "bottom" | "middle"): boolean;
    };
    onActiveChange: import("vue").PropType<(activeRowKeys: (string | number)[], context: import("./type").ActiveChangeContext<import("./type").TableRowData>) => void>;
    onActiveRowAction: import("vue").PropType<(context: import("./type").ActiveRowActionContext<import("./type").TableRowData>) => void>;
    onColumnResizeChange: import("vue").PropType<(context: {
        columnsWidth: {
            [colKey: string]: number;
        };
    }) => void>;
    onPageChange: import("vue").PropType<(pageInfo: import("..").PageInfo, newDataSource: import("./type").TableRowData[]) => void>;
    onRowClick: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowDblclick: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMousedown: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseenter: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseleave: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseover: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseup: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onScroll: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
    onScrollX: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
    onScrollY: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
}>> & Omit<import("vue").VueConstructor<import("vue").default>, never> & (new (...args: any[]) => import("@vue/composition-api").ComponentRenderProxy<{
    data: import("./type").TableRowData[];
    columns: import("./type").PrimaryTableCol<import("./type").TableRowData>[];
    tableLayout: "fixed" | "auto";
    verticalAlign: "top" | "bottom" | "middle";
    loading: boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    empty: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    hover: boolean;
    lazyLoad: boolean;
    bordered: boolean;
    showHeader: boolean;
    stripe: boolean;
    activeRowKeys: (string | number)[];
    defaultActiveRowKeys: (string | number)[];
    activeRowType: "multiple" | "single";
    allowResizeColumnWidth: boolean;
    disableDataPage: boolean;
    disableSpaceInactiveRow: boolean;
    footData: import("./type").TableRowData[];
    footerAffixedBottom: boolean;
    headerAffixedTop: boolean;
    keyboardRowHover: boolean;
    resizable: boolean;
    rowKey: string;
    tableContentWidth: string;
    columnControllerVisible: boolean;
    defaultColumnControllerVisible: boolean;
    expandIcon: boolean | ((h: import("vue").CreateElement, props: import("./type").ExpandArrowRenderParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue);
    expandOnRowClick: boolean;
    expandedRowKeys: (string | number)[];
    defaultExpandedRowKeys: (string | number)[];
    hideSortTips: boolean;
    multipleSort: boolean;
    reserveSelectedRowOnPaginate: boolean;
    rowSelectionAllowUncheck: boolean;
    selectOnRowClick: boolean;
    selectedRowKeys: (string | number)[];
    defaultSelectedRowKeys: (string | number)[];
    showSortColumnBgColor: boolean;
    sortOnRowDraggable: boolean;
} & {
    sort?: import("./type").TableSort;
    height?: string | number;
    maxHeight?: string | number;
    scroll?: import("..").TScroll;
    size?: import("..").SizeEnum;
    onChange?: (data: import("./type").TableChangeData, context: import("./type").TableChangeContext<import("./type").TableRowData>) => void;
    attach?: import("..").AttachNode;
    pagination?: unknown;
    onValidate?: (context: import("./type").PrimaryTableValidateContext) => void;
    onScroll?: (params: {
        e: WheelEvent;
    }) => void;
    onDragSort?: (context: import("./type").DragSortContext<import("./type").TableRowData>) => void;
    dragSort?: "col" | "row" | "row-handler" | "row-handler-col" | "drag-col";
    onCellClick?: (context: import("./type").PrimaryTableCellEventContext<import("./type").TableRowData>) => void;
    onPageChange?: (pageInfo: import("..").PageInfo, newDataSource: import("./type").TableRowData[]) => void;
    filterValue?: unknown;
    loadingProps?: unknown;
    asyncLoading?: "loading" | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue) | "load-more";
    bottomContent?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    cellEmptyContent?: string | ((h: import("vue").CreateElement, props: import("./type").BaseTableCellParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue);
    firstFullRow?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    fixedRows?: number[];
    footerAffixProps?: unknown;
    footerSummary?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    headerAffixProps?: unknown;
    horizontalScrollAffixedBottom?: unknown;
    lastFullRow?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    locale?: unknown;
    paginationAffixedBottom?: unknown;
    rowAttributes?: import("./type").TableRowAttributes<import("./type").TableRowData>;
    rowClassName?: unknown;
    rowspanAndColspan?: import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>;
    rowspanAndColspanInFooter?: import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>;
    topContent?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onActiveChange?: (activeRowKeys: (string | number)[], context: import("./type").ActiveChangeContext<import("./type").TableRowData>) => void;
    onActiveRowAction?: (context: import("./type").ActiveRowActionContext<import("./type").TableRowData>) => void;
    onColumnResizeChange?: (context: {
        columnsWidth: {
            [colKey: string]: number;
        };
    }) => void;
    onRowClick?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowDblclick?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMousedown?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseenter?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseleave?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseover?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseup?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onScrollX?: (params: {
        e: WheelEvent;
    }) => void;
    onScrollY?: (params: {
        e: WheelEvent;
    }) => void;
    sortIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    filterIcon?: (h: import("vue").CreateElement, props: {
        col: import("./type").PrimaryTableCol<import("./type").TableRowData>;
        colIndex: number;
    }) => import("vue/types/vnode").ScopedSlotReturnValue;
    columnController?: unknown;
    displayColumns?: import("..").CheckboxGroupValue;
    defaultDisplayColumns?: import("..").CheckboxGroupValue;
    dragSortOptions?: unknown;
    editableCellState?: import("./type").EditableCellType<import("./type").TableRowData>;
    editableRowKeys?: (string | number)[];
    expandedRow?: (h: import("vue").CreateElement, props: import("./type").TableExpandedRowParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue;
    filterRow?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    defaultFilterValue?: unknown;
    indeterminateSelectedRowKeys?: (string | number)[];
    rowSelectionType?: "multiple" | "single";
    defaultSort?: import("./type").TableSort;
    onAsyncLoadingClick?: (context: {
        status: "loading" | "load-more";
    }) => void;
    onColumnChange?: (context: import("./type").PrimaryTableColumnChange<import("./type").TableRowData>) => void;
    onColumnControllerVisibleChange?: (visible: boolean, context: {
        trigger: "cancel" | "confirm";
    }) => void;
    onDataChange?: (data: import("./type").TableRowData[], context: import("./type").TableDataChangeContext) => void;
    onDisplayColumnsChange?: (value: import("..").CheckboxGroupValue) => void;
    onExpandChange?: (expandedRowKeys: (string | number)[], options: import("./type").ExpandOptions<import("./type").TableRowData>) => void;
    onFilterChange?: (filterValue: import("./type").FilterValue, context: import("./type").TableFilterChangeContext<import("./type").TableRowData>) => void;
    onRowEdit?: (context: import("./type").PrimaryTableRowEditContext<import("./type").TableRowData>) => void;
    onRowValidate?: (context: import("./type").PrimaryTableRowValidateContext<import("./type").TableRowData>) => void;
    onSelectChange?: (selectedRowKeys: (string | number)[], options: import("./type").SelectOptions<import("./type").TableRowData>) => void;
    onSortChange?: (sort: import("./type").TableSort, options: import("./type").SortOptions<import("./type").TableRowData>) => void;
}, import("@vue/composition-api").ShallowUnwrapRef<{
    tColumns: import("@vue/composition-api").ComputedRef<import("./type").PrimaryTableCol<import("./type").TableRowData>[]>;
    showExpandedRow: import("@vue/composition-api").ComputedRef<boolean>;
    tRowClassNames: import("@vue/composition-api").ComputedRef<any[]>;
    hasEmptyCondition: import("@vue/composition-api").ComputedRef<boolean>;
    primaryTableRef: any;
    tRowAttributes: import("@vue/composition-api").ComputedRef<import("./type").TableRowAttributes<import("./type").TableRowData>[]>;
    primaryTableClasses: import("@vue/composition-api").ComputedRef<{
        [x: string]: boolean | (string | number)[] | import("./type").PrimaryTableCol<import("./type").TableRowData>;
    }>;
    errorListMap: import("@vue/composition-api").Ref<{
        [x: string]: ({
            result: boolean;
            message: string;
            type?: "error" | "success" | "warning";
        } | {
            result: boolean;
            boolean?: boolean;
            date?: boolean | {
                format: string;
                strictMode: boolean;
                delimiters: string[];
            };
            email?: boolean | {
                allow_display_name?: boolean;
                require_display_name?: boolean;
                allow_utf8_local_part?: boolean;
                require_tld?: boolean;
                ignore_max_length?: boolean;
                allow_ip_domain?: boolean;
                domain_specific_validation?: boolean;
                allow_underscores?: boolean;
                host_blacklist?: string[];
                host_whitelist?: string[];
                blacklisted_chars?: string;
            };
            enum?: string[];
            idcard?: boolean;
            len?: number | boolean;
            max?: number | boolean;
            message?: string;
            min?: number | boolean;
            number?: boolean;
            pattern?: {
                exec: (string: string) => RegExpExecArray;
                test: (string: string) => boolean;
                readonly source: string;
                readonly global: boolean;
                readonly ignoreCase: boolean;
                readonly multiline: boolean;
                lastIndex: number;
                compile: (pattern: string, flags?: string) => RegExp;
                readonly flags: string;
                readonly sticky: boolean;
                readonly unicode: boolean;
                readonly dotAll: boolean;
                [Symbol.match]: (string: string) => RegExpMatchArray;
                [Symbol.replace]: {
                    (string: string, replaceValue: string): string;
                    (string: string, replacer: (substring: string, ...args: any[]) => string): string;
                };
                [Symbol.search]: (string: string) => number;
                [Symbol.split]: (string: string, limit?: number) => string[];
                [Symbol.matchAll]: (str: string) => IterableIterator<RegExpMatchArray>;
            };
            required?: boolean;
            telnumber?: boolean;
            trigger?: "blur" | "change" | "submit" | ("blur" | "change" | "submit")[];
            type?: "error" | "warning";
            url?: boolean | {
                protocols?: string[];
                require_tld?: boolean;
                require_protocol?: boolean;
                require_host?: boolean;
                require_port?: boolean;
                require_valid_protocol?: boolean;
                allow_underscores?: boolean;
                host_whitelist?: (string | {
                    exec: (string: string) => RegExpExecArray;
                    test: (string: string) => boolean;
                    readonly source: string;
                    readonly global: boolean;
                    readonly ignoreCase: boolean;
                    readonly multiline: boolean;
                    lastIndex: number;
                    compile: (pattern: string, flags?: string) => RegExp;
                    readonly flags: string;
                    readonly sticky: boolean;
                    readonly unicode: boolean;
                    readonly dotAll: boolean;
                    [Symbol.match]: (string: string) => RegExpMatchArray;
                    [Symbol.replace]: {
                        (string: string, replaceValue: string): string;
                        (string: string, replacer: (substring: string, ...args: any[]) => string): string;
                    };
                    [Symbol.search]: (string: string) => number;
                    [Symbol.split]: (string: string, limit?: number) => string[];
                    [Symbol.matchAll]: (str: string) => IterableIterator<RegExpMatchArray>;
                })[];
                host_blacklist?: (string | {
                    exec: (string: string) => RegExpExecArray;
                    test: (string: string) => boolean;
                    readonly source: string;
                    readonly global: boolean;
                    readonly ignoreCase: boolean;
                    readonly multiline: boolean;
                    lastIndex: number;
                    compile: (pattern: string, flags?: string) => RegExp;
                    readonly flags: string;
                    readonly sticky: boolean;
                    readonly unicode: boolean;
                    readonly dotAll: boolean;
                    [Symbol.match]: (string: string) => RegExpMatchArray;
                    [Symbol.replace]: {
                        (string: string, replaceValue: string): string;
                        (string: string, replacer: (substring: string, ...args: any[]) => string): string;
                    };
                    [Symbol.search]: (string: string) => number;
                    [Symbol.split]: (string: string, limit?: number) => string[];
                    [Symbol.matchAll]: (str: string) => IterableIterator<RegExpMatchArray>;
                })[];
                allow_trailing_dot?: boolean;
                allow_protocol_relative_urls?: boolean;
                disallow_auth?: boolean;
                allow_fragments?: boolean;
                allow_query_components?: boolean;
                validate_length?: boolean;
                max_allowed_length?: number | false;
            };
            validator?: import("..").CustomValidator;
            whitespace?: boolean;
        })[];
    }>;
    onShowElementChange: (val: boolean) => void;
    scrollToElement: (data: import("..").ComponentScrollToElementParams) => void;
    scrollColumnIntoView: (colKey: string) => void;
    refreshTable: () => void;
    validateRowData: (rowValue: any) => Promise<unknown>;
    validateTableData: () => Promise<unknown>;
    clearValidateData: () => void;
    renderTNode: (name: string, options?: import("../hooks/render-tnode").OptionsType) => any;
    renderColumnController: (h: import("vue").CreateElement) => JSX.Element;
    renderExpandedRow: (h: import("vue").CreateElement, p: import("./type").TableExpandedRowParams<import("./type").TableRowData> & {
        tableWidth: number;
        isWidthOverflow: boolean;
    }) => JSX.Element;
    onInnerExpandRowClick: (p: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onInnerRowClick: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    renderFirstFilterRow: (h: import("vue").CreateElement) => JSX.Element;
    renderAsyncLoading: (h: import("vue").CreateElement) => JSX.Element;
    onInnerPageChange: (pageInfo: import("..").PageInfo, newData: import("./type").TableRowData[]) => void;
    setDragSortColumns: (val: import("./type").PrimaryTableCol<import("./type").TableRowData>[]) => void;
    onInnerActiveRowAction: (context: import("./type").ActiveRowActionContext<import("./type").TableRowData>) => void;
    innerKeyboardRowHover: import("@vue/composition-api").ComputedRef<boolean>;
    innerDisableSpaceInactiveRow: import("@vue/composition-api").ComputedRef<boolean>;
}>, import("@vue/composition-api").Data, {}, {
    getListener(): import("./base-table").TableListeners;
    formatNode(api: string, renderInnerNode: Function, condition: boolean, extra?: {
        reverse?: boolean;
    }): unknown;
}, {}, {}, {}, {
    data: import("./type").TableRowData[];
    columns: import("./type").PrimaryTableCol<import("./type").TableRowData>[];
    tableLayout: "fixed" | "auto";
    verticalAlign: "top" | "bottom" | "middle";
    loading: boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    empty: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    hover: boolean;
    lazyLoad: boolean;
    bordered: boolean;
    showHeader: boolean;
    stripe: boolean;
    activeRowKeys: (string | number)[];
    defaultActiveRowKeys: (string | number)[];
    activeRowType: "multiple" | "single";
    allowResizeColumnWidth: boolean;
    disableDataPage: boolean;
    disableSpaceInactiveRow: boolean;
    footData: import("./type").TableRowData[];
    footerAffixedBottom: boolean;
    headerAffixedTop: boolean;
    keyboardRowHover: boolean;
    resizable: boolean;
    rowKey: string;
    tableContentWidth: string;
    columnControllerVisible: boolean;
    defaultColumnControllerVisible: boolean;
    expandIcon: boolean | ((h: import("vue").CreateElement, props: import("./type").ExpandArrowRenderParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue);
    expandOnRowClick: boolean;
    expandedRowKeys: (string | number)[];
    defaultExpandedRowKeys: (string | number)[];
    hideSortTips: boolean;
    multipleSort: boolean;
    reserveSelectedRowOnPaginate: boolean;
    rowSelectionAllowUncheck: boolean;
    selectOnRowClick: boolean;
    selectedRowKeys: (string | number)[];
    defaultSelectedRowKeys: (string | number)[];
    showSortColumnBgColor: boolean;
    sortOnRowDraggable: boolean;
} & {
    sort?: import("./type").TableSort;
    height?: string | number;
    maxHeight?: string | number;
    scroll?: import("..").TScroll;
    size?: import("..").SizeEnum;
    onChange?: (data: import("./type").TableChangeData, context: import("./type").TableChangeContext<import("./type").TableRowData>) => void;
    attach?: import("..").AttachNode;
    pagination?: unknown;
    onValidate?: (context: import("./type").PrimaryTableValidateContext) => void;
    onScroll?: (params: {
        e: WheelEvent;
    }) => void;
    onDragSort?: (context: import("./type").DragSortContext<import("./type").TableRowData>) => void;
    dragSort?: "col" | "row" | "row-handler" | "row-handler-col" | "drag-col";
    onCellClick?: (context: import("./type").PrimaryTableCellEventContext<import("./type").TableRowData>) => void;
    onPageChange?: (pageInfo: import("..").PageInfo, newDataSource: import("./type").TableRowData[]) => void;
    filterValue?: unknown;
    loadingProps?: unknown;
    asyncLoading?: "loading" | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue) | "load-more";
    bottomContent?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    cellEmptyContent?: string | ((h: import("vue").CreateElement, props: import("./type").BaseTableCellParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue);
    firstFullRow?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    fixedRows?: number[];
    footerAffixProps?: unknown;
    footerSummary?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    headerAffixProps?: unknown;
    horizontalScrollAffixedBottom?: unknown;
    lastFullRow?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    locale?: unknown;
    paginationAffixedBottom?: unknown;
    rowAttributes?: import("./type").TableRowAttributes<import("./type").TableRowData>;
    rowClassName?: unknown;
    rowspanAndColspan?: import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>;
    rowspanAndColspanInFooter?: import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>;
    topContent?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onActiveChange?: (activeRowKeys: (string | number)[], context: import("./type").ActiveChangeContext<import("./type").TableRowData>) => void;
    onActiveRowAction?: (context: import("./type").ActiveRowActionContext<import("./type").TableRowData>) => void;
    onColumnResizeChange?: (context: {
        columnsWidth: {
            [colKey: string]: number;
        };
    }) => void;
    onRowClick?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowDblclick?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMousedown?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseenter?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseleave?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseover?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseup?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onScrollX?: (params: {
        e: WheelEvent;
    }) => void;
    onScrollY?: (params: {
        e: WheelEvent;
    }) => void;
    sortIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    filterIcon?: (h: import("vue").CreateElement, props: {
        col: import("./type").PrimaryTableCol<import("./type").TableRowData>;
        colIndex: number;
    }) => import("vue/types/vnode").ScopedSlotReturnValue;
    columnController?: unknown;
    displayColumns?: import("..").CheckboxGroupValue;
    defaultDisplayColumns?: import("..").CheckboxGroupValue;
    dragSortOptions?: unknown;
    editableCellState?: import("./type").EditableCellType<import("./type").TableRowData>;
    editableRowKeys?: (string | number)[];
    expandedRow?: (h: import("vue").CreateElement, props: import("./type").TableExpandedRowParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue;
    filterRow?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    defaultFilterValue?: unknown;
    indeterminateSelectedRowKeys?: (string | number)[];
    rowSelectionType?: "multiple" | "single";
    defaultSort?: import("./type").TableSort;
    onAsyncLoadingClick?: (context: {
        status: "loading" | "load-more";
    }) => void;
    onColumnChange?: (context: import("./type").PrimaryTableColumnChange<import("./type").TableRowData>) => void;
    onColumnControllerVisibleChange?: (visible: boolean, context: {
        trigger: "cancel" | "confirm";
    }) => void;
    onDataChange?: (data: import("./type").TableRowData[], context: import("./type").TableDataChangeContext) => void;
    onDisplayColumnsChange?: (value: import("..").CheckboxGroupValue) => void;
    onExpandChange?: (expandedRowKeys: (string | number)[], options: import("./type").ExpandOptions<import("./type").TableRowData>) => void;
    onFilterChange?: (filterValue: import("./type").FilterValue, context: import("./type").TableFilterChangeContext<import("./type").TableRowData>) => void;
    onRowEdit?: (context: import("./type").PrimaryTableRowEditContext<import("./type").TableRowData>) => void;
    onRowValidate?: (context: import("./type").PrimaryTableRowValidateContext<import("./type").TableRowData>) => void;
    onSelectChange?: (selectedRowKeys: (string | number)[], options: import("./type").SelectOptions<import("./type").TableRowData>) => void;
    onSortChange?: (sort: import("./type").TableSort, options: import("./type").SortOptions<import("./type").TableRowData>) => void;
}, {
    data: import("./type").TableRowData[];
    columns: import("./type").PrimaryTableCol<import("./type").TableRowData>[];
    tableLayout: "fixed" | "auto";
    verticalAlign: "top" | "bottom" | "middle";
    loading: boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    empty: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    hover: boolean;
    lazyLoad: boolean;
    bordered: boolean;
    showHeader: boolean;
    stripe: boolean;
    activeRowKeys: (string | number)[];
    defaultActiveRowKeys: (string | number)[];
    activeRowType: "multiple" | "single";
    allowResizeColumnWidth: boolean;
    disableDataPage: boolean;
    disableSpaceInactiveRow: boolean;
    footData: import("./type").TableRowData[];
    footerAffixedBottom: boolean;
    headerAffixedTop: boolean;
    keyboardRowHover: boolean;
    resizable: boolean;
    rowKey: string;
    tableContentWidth: string;
    columnControllerVisible: boolean;
    defaultColumnControllerVisible: boolean;
    expandIcon: boolean | ((h: import("vue").CreateElement, props: import("./type").ExpandArrowRenderParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue);
    expandOnRowClick: boolean;
    expandedRowKeys: (string | number)[];
    defaultExpandedRowKeys: (string | number)[];
    hideSortTips: boolean;
    multipleSort: boolean;
    reserveSelectedRowOnPaginate: boolean;
    rowSelectionAllowUncheck: boolean;
    selectOnRowClick: boolean;
    selectedRowKeys: (string | number)[];
    defaultSelectedRowKeys: (string | number)[];
    showSortColumnBgColor: boolean;
    sortOnRowDraggable: boolean;
}, true>)>;
export declare const EnhancedTable: import("vue").ComponentOptions<import("vue").default, import("@vue/composition-api").ShallowUnwrapRef<{
    scrollToElement: (params: import("..").ComponentScrollToElementParams) => void;
    rowDataKeys: import("@vue/composition-api").ComputedRef<{
        rowKey: string;
        childrenKey: string;
    }>;
    setData: <T>(key: import("./type").TableRowValue, newRowData: T) => void;
    getData: (key: import("./type").TableRowValue) => import("./type").TableRowState<import("./type").TableRowData>;
    remove: (key: import("./type").TableRowValue) => void;
    removeChildren: (key: import("./type").TableRowValue) => void;
    appendTo: <T_1>(key: import("./type").TableRowValue, newData: T_1 | T_1[]) => void;
    insertAfter: <T_2>(rowValue: import("./type").TableRowValue, newData: T_2) => void;
    insertBefore: <T_3>(rowValue: import("./type").TableRowValue, newData: T_3) => void;
    toggleExpandData: (p: {
        row: import("./type").TableRowData;
        rowIndex: number;
    }, trigger?: "expand-fold-icon" | "row-click") => void;
    expandAll: (type?: "default-expand-all" | "expand-all", list?: import("./type").TableRowData[]) => void;
    foldAll: () => void;
    getTreeNode: () => import("../_common/js/table/types").TableRowData[];
    resetData: (data: import("./type").TableRowData[]) => void;
    getTreeExpandedRow: (type?: "all" | "data" | "unique") => any[];
    store: import("@vue/composition-api").Ref<{
        treeDataMap: import("../_common/js/table/tree-store").TableTreeDataMap;
        expandAllRowIndex: 0;
        initialTreeStore: (dataSource: import("../_common/js/table/types").TableRowData[], columns: import("../_common/js/table/types").PlainObject[], keys: import("../_common/js/table/tree-store").KeysType) => void;
        getAllUniqueKeys: (data: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType, arr?: import("../_common/js/table/types").TableRowData[]) => import("../_common/js/table/types").TableRowData[];
        getExpandedChildrenKeys: (data: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType, arr?: (string | number)[]) => (string | number)[];
        expandTreeNode: (rowList: (string | number)[], dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        foldTreeNode: (rowList: (string | number)[], dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        toggleExpandData: (p: {
            rowIndex: number;
            row: import("../_common/js/table/types").TableRowData;
        }, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType, type?: "expand" | "fold") => import("../_common/js/table/types").TableRowData[];
        updateExpandRow: (changeRow: import("../_common/js/table/types").TableRowState<import("../_common/js/table/types").TableRowData>, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        getData: (key: import("../_common/js/table/types").TableRowValue) => import("../_common/js/table/types").TableRowState<import("../_common/js/table/types").TableRowData>;
        updateData: (rowValue: import("../_common/js/table/types").TableRowValue, newRowData: import("../_common/js/table/types").TableRowData, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => number;
        remove: (key: import("../_common/js/table/types").TableRowValue, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        removeChildren: (key: import("../_common/js/table/types").TableRowValue, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        appendTo: (rowValue: string | number, newData: import("../_common/js/table/types").TableRowData | import("../_common/js/table/types").TableRowData[], dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        appendToRoot: (newData: import("../_common/js/table/types").TableRowData | import("../_common/js/table/types").TableRowData[], dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        insertAfter: (rowValue: string | number, newData: import("../_common/js/table/types").TableRowData, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        insertBefore: (rowValue: string | number, newData: import("../_common/js/table/types").TableRowData, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        insert: (rowValue: string | number, newData: import("../_common/js/table/types").TableRowData, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType, type: "after" | "before") => import("../_common/js/table/types").TableRowData[];
        swapData: (dataSource: import("../_common/js/table/types").TableRowData[], params: import("../_common/js/table/tree-store").SwapParams<import("../_common/js/table/types").TableRowData>, keys: import("../_common/js/table/tree-store").KeysType) => {
            dataSource: import("../_common/js/table/types").TableRowData[];
            result: boolean;
            code?: number;
            reason?: string;
        };
        expandAll: (dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        foldAll: (dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        getTreeNode: (dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        getTreeExpandedRow: (dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType, type?: "all" | "data" | "unique") => any[];
        initialTreeDataMap: (treeDataMap: import("../_common/js/table/tree-store").TableTreeDataMap, dataSource: import("../_common/js/table/types").TableRowData[], column: import("../_common/js/table/types").PlainObject, keys: import("../_common/js/table/tree-store").KeysType, level?: number, parent?: import("../_common/js/table/types").TableRowState<import("../_common/js/table/types").TableRowData>) => void;
        updateDisabledState: (dataSource: import("../_common/js/table/types").TableRowData[], column: import("../_common/js/table/types").PlainObject, keys: import("../_common/js/table/tree-store").KeysType) => void;
        validateDataExist: (state: import("../_common/js/table/types").TableRowState<import("../_common/js/table/types").TableRowData>, rowValue: string | number) => boolean;
        validateDataDoubleExist: (state: import("../_common/js/table/types").TableRowState<import("../_common/js/table/types").TableRowData>, rowValue: string | number) => boolean;
    }>;
    classPrefix: import("@vue/composition-api").ComputedRef<string>;
    dataSource: import("@vue/composition-api").Ref<{
        [x: string]: any;
        children?: any[];
    }[]>;
    tColumns: import("@vue/composition-api").ComputedRef<import("./type").PrimaryTableCol<import("./type").TableRowData>[]>;
    treeDataMap: import("@vue/composition-api").Ref<import("../_common/js/table/tree-store").TableTreeDataMap>;
    tIndeterminateSelectedRowKeys: import("@vue/composition-api").Ref<(string | number)[]>;
    enhancedTableRef: import("@vue/composition-api").Ref<any>;
    primaryTableRef: import("@vue/composition-api").Ref<any>;
    onDragSortChange: (params: import("./type").DragSortContext<import("./type").TableRowData>) => void;
    onInnerSelectChange: (rowKeys: (string | number)[], extraData: import("./type").SelectOptions<import("./type").TableRowData>) => void;
    onEnhancedTableRowClick: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
}> & import("@vue/composition-api").Data, {
    getListener(): import("./base-table").TableListeners;
    getRowClassName({ row }: {
        row: import("./type").TableRowData;
    }): import("..").ClassName[];
}, {}, {
    beforeDragSort: {
        type: import("vue").PropType<(context: import("./type").DragSortContext<import("./type").TableRowData>) => boolean>;
    };
    expandedTreeNodes: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultExpandedTreeNodes: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    tree: {
        type: import("vue").PropType<import("./type").TableTreeConfig>;
    };
    treeExpandAndFoldIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: {
            type: "expand" | "fold";
            row: import("./type").TableRowData;
        }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    onAbnormalDragSort: import("vue").PropType<(context: import("./type").TableAbnormalDragSortContext<import("./type").TableRowData>) => void>;
    onExpandedTreeNodesChange: import("vue").PropType<(expandedTreeNodes: (string | number)[], options: import("./type").TableTreeNodeExpandOptions<import("./type").TableRowData>) => void>;
    onTreeExpandChange: import("vue").PropType<(context: import("./type").TableTreeExpandChangeContext<import("./type").TableRowData>) => void>;
    asyncLoading: {
        type: import("vue").PropType<"loading" | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue) | "load-more">;
    };
    columnController: {
        type: import("vue").PropType<import("./type").TableColumnController>;
    };
    columnControllerVisible: {
        type: BooleanConstructor;
        default: any;
    };
    defaultColumnControllerVisible: {
        type: BooleanConstructor;
        default: any;
    };
    columns: {
        type: import("vue").PropType<import("./type").PrimaryTableCol<import("./type").TableRowData>[]>;
        default: () => import("./type").PrimaryTableCol<import("./type").TableRowData>[];
    };
    displayColumns: {
        type: import("vue").PropType<import("..").CheckboxGroupValue>;
    };
    defaultDisplayColumns: {
        type: import("vue").PropType<import("..").CheckboxGroupValue>;
    };
    dragSort: {
        type: import("vue").PropType<"col" | "row" | "row-handler" | "row-handler-col" | "drag-col">;
        validator(val: "col" | "row" | "row-handler" | "row-handler-col" | "drag-col"): boolean;
    };
    dragSortOptions: {
        type: import("vue").PropType<import("sortablejs").SortableOptions>;
    };
    editableCellState: {
        type: import("vue").PropType<import("./type").EditableCellType<import("./type").TableRowData>>;
    };
    editableRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
    };
    expandIcon: {
        type: import("vue").PropType<boolean | ((h: import("vue").CreateElement, props: import("./type").ExpandArrowRenderParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: boolean;
    };
    expandOnRowClick: BooleanConstructor;
    expandedRow: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: import("./type").TableExpandedRowParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    expandedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultExpandedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    filterIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: {
            col: import("./type").PrimaryTableCol<import("./type").TableRowData>;
            colIndex: number;
        }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    filterRow: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    filterValue: {
        type: import("vue").PropType<import("./type").FilterValue>;
    };
    defaultFilterValue: {
        type: import("vue").PropType<import("./type").FilterValue>;
    };
    hideSortTips: BooleanConstructor;
    indeterminateSelectedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
    };
    multipleSort: BooleanConstructor;
    reserveSelectedRowOnPaginate: {
        type: BooleanConstructor;
        default: boolean;
    };
    rowSelectionAllowUncheck: BooleanConstructor;
    rowSelectionType: {
        type: import("vue").PropType<"multiple" | "single">;
        validator(val: "multiple" | "single"): boolean;
    };
    selectOnRowClick: BooleanConstructor;
    selectedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultSelectedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    showSortColumnBgColor: BooleanConstructor;
    sort: {
        type: import("vue").PropType<import("./type").TableSort>;
    };
    defaultSort: {
        type: import("vue").PropType<import("./type").TableSort>;
    };
    sortIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    sortOnRowDraggable: BooleanConstructor;
    onAsyncLoadingClick: import("vue").PropType<(context: {
        status: "loading" | "load-more";
    }) => void>;
    onCellClick: import("vue").PropType<(context: import("./type").PrimaryTableCellEventContext<import("./type").TableRowData>) => void>;
    onChange: import("vue").PropType<(data: import("./type").TableChangeData, context: import("./type").TableChangeContext<import("./type").TableRowData>) => void>;
    onColumnChange: import("vue").PropType<(context: import("./type").PrimaryTableColumnChange<import("./type").TableRowData>) => void>;
    onColumnControllerVisibleChange: import("vue").PropType<(visible: boolean, context: {
        trigger: "cancel" | "confirm";
    }) => void>;
    onDataChange: import("vue").PropType<(data: import("./type").TableRowData[], context: import("./type").TableDataChangeContext) => void>;
    onDisplayColumnsChange: import("vue").PropType<(value: import("..").CheckboxGroupValue) => void>;
    onDragSort: import("vue").PropType<(context: import("./type").DragSortContext<import("./type").TableRowData>) => void>;
    onExpandChange: import("vue").PropType<(expandedRowKeys: (string | number)[], options: import("./type").ExpandOptions<import("./type").TableRowData>) => void>;
    onFilterChange: import("vue").PropType<(filterValue: import("./type").FilterValue, context: import("./type").TableFilterChangeContext<import("./type").TableRowData>) => void>;
    onRowEdit: import("vue").PropType<(context: import("./type").PrimaryTableRowEditContext<import("./type").TableRowData>) => void>;
    onRowValidate: import("vue").PropType<(context: import("./type").PrimaryTableRowValidateContext<import("./type").TableRowData>) => void>;
    onSelectChange: import("vue").PropType<(selectedRowKeys: (string | number)[], options: import("./type").SelectOptions<import("./type").TableRowData>) => void>;
    onSortChange: import("vue").PropType<(sort: import("./type").TableSort, options: import("./type").SortOptions<import("./type").TableRowData>) => void>;
    onValidate: import("vue").PropType<(context: import("./type").PrimaryTableValidateContext) => void>;
    activeRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultActiveRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    activeRowType: {
        type: import("vue").PropType<"multiple" | "single">;
        default: string;
    };
    allowResizeColumnWidth: {
        type: BooleanConstructor;
        default: any;
    };
    attach: {
        type: import("vue").PropType<import("..").AttachNode>;
    };
    bordered: BooleanConstructor;
    bottomContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    cellEmptyContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement, props: import("./type").BaseTableCellParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    data: {
        type: import("vue").PropType<import("./type").TableRowData[]>;
        default: () => import("./type").TableRowData[];
    };
    disableDataPage: BooleanConstructor;
    disableSpaceInactiveRow: {
        type: BooleanConstructor;
        default: any;
    };
    empty: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: string;
    };
    firstFullRow: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    fixedRows: {
        type: import("vue").PropType<number[]>;
    };
    footData: {
        type: import("vue").PropType<import("./type").TableRowData[]>;
        default: () => import("./type").TableRowData[];
    };
    footerAffixProps: {
        type: import("vue").PropType<Partial<import("..").TdAffixProps>>;
    };
    footerAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
        default: boolean;
    };
    footerSummary: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    headerAffixProps: {
        type: import("vue").PropType<Partial<import("..").TdAffixProps>>;
    };
    headerAffixedTop: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
        default: boolean;
    };
    height: {
        type: import("vue").PropType<string | number>;
    };
    horizontalScrollAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
    };
    hover: BooleanConstructor;
    keyboardRowHover: {
        type: BooleanConstructor;
        default: boolean;
    };
    lastFullRow: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    lazyLoad: BooleanConstructor;
    loading: {
        type: import("vue").PropType<boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: any;
    };
    loadingProps: {
        type: import("vue").PropType<Partial<import("..").TdLoadingProps>>;
    };
    locale: {
        type: import("vue").PropType<import("..").TableConfig>;
    };
    maxHeight: {
        type: import("vue").PropType<string | number>;
    };
    pagination: {
        type: import("vue").PropType<import("..").TdPaginationProps>;
    };
    paginationAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
    };
    resizable: BooleanConstructor;
    rowAttributes: {
        type: import("vue").PropType<import("./type").TableRowAttributes<import("./type").TableRowData>>;
    };
    rowClassName: {
        type: import("vue").PropType<import("..").ClassName | ((params: import("./type").RowClassNameParams<import("./type").TableRowData>) => import("..").ClassName)>;
    };
    rowKey: {
        type: StringConstructor;
        default: string;
        required: boolean;
    };
    rowspanAndColspan: {
        type: import("vue").PropType<import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>>;
    };
    rowspanAndColspanInFooter: {
        type: import("vue").PropType<import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>>;
    };
    scroll: {
        type: import("vue").PropType<import("..").TScroll>;
    };
    showHeader: {
        type: BooleanConstructor;
        default: boolean;
    };
    size: {
        type: import("vue").PropType<import("..").SizeEnum>;
        validator(val: import("..").SizeEnum): boolean;
    };
    stripe: BooleanConstructor;
    tableContentWidth: {
        type: StringConstructor;
        default: string;
    };
    tableLayout: {
        type: import("vue").PropType<"fixed" | "auto">;
        default: "fixed" | "auto";
        validator(val: "fixed" | "auto"): boolean;
    };
    topContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    verticalAlign: {
        type: import("vue").PropType<"top" | "bottom" | "middle">;
        default: "top" | "bottom" | "middle";
        validator(val: "top" | "bottom" | "middle"): boolean;
    };
    onActiveChange: import("vue").PropType<(activeRowKeys: (string | number)[], context: import("./type").ActiveChangeContext<import("./type").TableRowData>) => void>;
    onActiveRowAction: import("vue").PropType<(context: import("./type").ActiveRowActionContext<import("./type").TableRowData>) => void>;
    onColumnResizeChange: import("vue").PropType<(context: {
        columnsWidth: {
            [colKey: string]: number;
        };
    }) => void>;
    onPageChange: import("vue").PropType<(pageInfo: import("..").PageInfo, newDataSource: import("./type").TableRowData[]) => void>;
    onRowClick: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowDblclick: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMousedown: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseenter: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseleave: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseover: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseup: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onScroll: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
    onScrollX: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
    onScrollY: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
}, import("@vue/composition-api").ExtractPropTypes<{
    beforeDragSort: {
        type: import("vue").PropType<(context: import("./type").DragSortContext<import("./type").TableRowData>) => boolean>;
    };
    expandedTreeNodes: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultExpandedTreeNodes: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    tree: {
        type: import("vue").PropType<import("./type").TableTreeConfig>;
    };
    treeExpandAndFoldIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: {
            type: "expand" | "fold";
            row: import("./type").TableRowData;
        }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    onAbnormalDragSort: import("vue").PropType<(context: import("./type").TableAbnormalDragSortContext<import("./type").TableRowData>) => void>;
    onExpandedTreeNodesChange: import("vue").PropType<(expandedTreeNodes: (string | number)[], options: import("./type").TableTreeNodeExpandOptions<import("./type").TableRowData>) => void>;
    onTreeExpandChange: import("vue").PropType<(context: import("./type").TableTreeExpandChangeContext<import("./type").TableRowData>) => void>;
    asyncLoading: {
        type: import("vue").PropType<"loading" | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue) | "load-more">;
    };
    columnController: {
        type: import("vue").PropType<import("./type").TableColumnController>;
    };
    columnControllerVisible: {
        type: BooleanConstructor;
        default: any;
    };
    defaultColumnControllerVisible: {
        type: BooleanConstructor;
        default: any;
    };
    columns: {
        type: import("vue").PropType<import("./type").PrimaryTableCol<import("./type").TableRowData>[]>;
        default: () => import("./type").PrimaryTableCol<import("./type").TableRowData>[];
    };
    displayColumns: {
        type: import("vue").PropType<import("..").CheckboxGroupValue>;
    };
    defaultDisplayColumns: {
        type: import("vue").PropType<import("..").CheckboxGroupValue>;
    };
    dragSort: {
        type: import("vue").PropType<"col" | "row" | "row-handler" | "row-handler-col" | "drag-col">;
        validator(val: "col" | "row" | "row-handler" | "row-handler-col" | "drag-col"): boolean;
    };
    dragSortOptions: {
        type: import("vue").PropType<import("sortablejs").SortableOptions>;
    };
    editableCellState: {
        type: import("vue").PropType<import("./type").EditableCellType<import("./type").TableRowData>>;
    };
    editableRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
    };
    expandIcon: {
        type: import("vue").PropType<boolean | ((h: import("vue").CreateElement, props: import("./type").ExpandArrowRenderParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: boolean;
    };
    expandOnRowClick: BooleanConstructor;
    expandedRow: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: import("./type").TableExpandedRowParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    expandedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultExpandedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    filterIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: {
            col: import("./type").PrimaryTableCol<import("./type").TableRowData>;
            colIndex: number;
        }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    filterRow: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    filterValue: {
        type: import("vue").PropType<import("./type").FilterValue>;
    };
    defaultFilterValue: {
        type: import("vue").PropType<import("./type").FilterValue>;
    };
    hideSortTips: BooleanConstructor;
    indeterminateSelectedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
    };
    multipleSort: BooleanConstructor;
    reserveSelectedRowOnPaginate: {
        type: BooleanConstructor;
        default: boolean;
    };
    rowSelectionAllowUncheck: BooleanConstructor;
    rowSelectionType: {
        type: import("vue").PropType<"multiple" | "single">;
        validator(val: "multiple" | "single"): boolean;
    };
    selectOnRowClick: BooleanConstructor;
    selectedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultSelectedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    showSortColumnBgColor: BooleanConstructor;
    sort: {
        type: import("vue").PropType<import("./type").TableSort>;
    };
    defaultSort: {
        type: import("vue").PropType<import("./type").TableSort>;
    };
    sortIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    sortOnRowDraggable: BooleanConstructor;
    onAsyncLoadingClick: import("vue").PropType<(context: {
        status: "loading" | "load-more";
    }) => void>;
    onCellClick: import("vue").PropType<(context: import("./type").PrimaryTableCellEventContext<import("./type").TableRowData>) => void>;
    onChange: import("vue").PropType<(data: import("./type").TableChangeData, context: import("./type").TableChangeContext<import("./type").TableRowData>) => void>;
    onColumnChange: import("vue").PropType<(context: import("./type").PrimaryTableColumnChange<import("./type").TableRowData>) => void>;
    onColumnControllerVisibleChange: import("vue").PropType<(visible: boolean, context: {
        trigger: "cancel" | "confirm";
    }) => void>;
    onDataChange: import("vue").PropType<(data: import("./type").TableRowData[], context: import("./type").TableDataChangeContext) => void>;
    onDisplayColumnsChange: import("vue").PropType<(value: import("..").CheckboxGroupValue) => void>;
    onDragSort: import("vue").PropType<(context: import("./type").DragSortContext<import("./type").TableRowData>) => void>;
    onExpandChange: import("vue").PropType<(expandedRowKeys: (string | number)[], options: import("./type").ExpandOptions<import("./type").TableRowData>) => void>;
    onFilterChange: import("vue").PropType<(filterValue: import("./type").FilterValue, context: import("./type").TableFilterChangeContext<import("./type").TableRowData>) => void>;
    onRowEdit: import("vue").PropType<(context: import("./type").PrimaryTableRowEditContext<import("./type").TableRowData>) => void>;
    onRowValidate: import("vue").PropType<(context: import("./type").PrimaryTableRowValidateContext<import("./type").TableRowData>) => void>;
    onSelectChange: import("vue").PropType<(selectedRowKeys: (string | number)[], options: import("./type").SelectOptions<import("./type").TableRowData>) => void>;
    onSortChange: import("vue").PropType<(sort: import("./type").TableSort, options: import("./type").SortOptions<import("./type").TableRowData>) => void>;
    onValidate: import("vue").PropType<(context: import("./type").PrimaryTableValidateContext) => void>;
    activeRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultActiveRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    activeRowType: {
        type: import("vue").PropType<"multiple" | "single">;
        default: string;
    };
    allowResizeColumnWidth: {
        type: BooleanConstructor;
        default: any;
    };
    attach: {
        type: import("vue").PropType<import("..").AttachNode>;
    };
    bordered: BooleanConstructor;
    bottomContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    cellEmptyContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement, props: import("./type").BaseTableCellParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    data: {
        type: import("vue").PropType<import("./type").TableRowData[]>;
        default: () => import("./type").TableRowData[];
    };
    disableDataPage: BooleanConstructor;
    disableSpaceInactiveRow: {
        type: BooleanConstructor;
        default: any;
    };
    empty: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: string;
    };
    firstFullRow: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    fixedRows: {
        type: import("vue").PropType<number[]>;
    };
    footData: {
        type: import("vue").PropType<import("./type").TableRowData[]>;
        default: () => import("./type").TableRowData[];
    };
    footerAffixProps: {
        type: import("vue").PropType<Partial<import("..").TdAffixProps>>;
    };
    footerAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
        default: boolean;
    };
    footerSummary: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    headerAffixProps: {
        type: import("vue").PropType<Partial<import("..").TdAffixProps>>;
    };
    headerAffixedTop: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
        default: boolean;
    };
    height: {
        type: import("vue").PropType<string | number>;
    };
    horizontalScrollAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
    };
    hover: BooleanConstructor;
    keyboardRowHover: {
        type: BooleanConstructor;
        default: boolean;
    };
    lastFullRow: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    lazyLoad: BooleanConstructor;
    loading: {
        type: import("vue").PropType<boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: any;
    };
    loadingProps: {
        type: import("vue").PropType<Partial<import("..").TdLoadingProps>>;
    };
    locale: {
        type: import("vue").PropType<import("..").TableConfig>;
    };
    maxHeight: {
        type: import("vue").PropType<string | number>;
    };
    pagination: {
        type: import("vue").PropType<import("..").TdPaginationProps>;
    };
    paginationAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
    };
    resizable: BooleanConstructor;
    rowAttributes: {
        type: import("vue").PropType<import("./type").TableRowAttributes<import("./type").TableRowData>>;
    };
    rowClassName: {
        type: import("vue").PropType<import("..").ClassName | ((params: import("./type").RowClassNameParams<import("./type").TableRowData>) => import("..").ClassName)>;
    };
    rowKey: {
        type: StringConstructor;
        default: string;
        required: boolean;
    };
    rowspanAndColspan: {
        type: import("vue").PropType<import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>>;
    };
    rowspanAndColspanInFooter: {
        type: import("vue").PropType<import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>>;
    };
    scroll: {
        type: import("vue").PropType<import("..").TScroll>;
    };
    showHeader: {
        type: BooleanConstructor;
        default: boolean;
    };
    size: {
        type: import("vue").PropType<import("..").SizeEnum>;
        validator(val: import("..").SizeEnum): boolean;
    };
    stripe: BooleanConstructor;
    tableContentWidth: {
        type: StringConstructor;
        default: string;
    };
    tableLayout: {
        type: import("vue").PropType<"fixed" | "auto">;
        default: "fixed" | "auto";
        validator(val: "fixed" | "auto"): boolean;
    };
    topContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    verticalAlign: {
        type: import("vue").PropType<"top" | "bottom" | "middle">;
        default: "top" | "bottom" | "middle";
        validator(val: "top" | "bottom" | "middle"): boolean;
    };
    onActiveChange: import("vue").PropType<(activeRowKeys: (string | number)[], context: import("./type").ActiveChangeContext<import("./type").TableRowData>) => void>;
    onActiveRowAction: import("vue").PropType<(context: import("./type").ActiveRowActionContext<import("./type").TableRowData>) => void>;
    onColumnResizeChange: import("vue").PropType<(context: {
        columnsWidth: {
            [colKey: string]: number;
        };
    }) => void>;
    onPageChange: import("vue").PropType<(pageInfo: import("..").PageInfo, newDataSource: import("./type").TableRowData[]) => void>;
    onRowClick: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowDblclick: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMousedown: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseenter: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseleave: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseover: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseup: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onScroll: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
    onScrollX: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
    onScrollY: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
}>> & Omit<import("vue").VueConstructor<import("vue").default>, never> & (new (...args: any[]) => import("@vue/composition-api").ComponentRenderProxy<{
    data: import("./type").TableRowData[];
    columns: import("./type").PrimaryTableCol<import("./type").TableRowData>[];
    tableLayout: "fixed" | "auto";
    verticalAlign: "top" | "bottom" | "middle";
    loading: boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    empty: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    hover: boolean;
    lazyLoad: boolean;
    bordered: boolean;
    showHeader: boolean;
    stripe: boolean;
    activeRowKeys: (string | number)[];
    defaultActiveRowKeys: (string | number)[];
    activeRowType: "multiple" | "single";
    allowResizeColumnWidth: boolean;
    disableDataPage: boolean;
    disableSpaceInactiveRow: boolean;
    footData: import("./type").TableRowData[];
    footerAffixedBottom: boolean;
    headerAffixedTop: boolean;
    keyboardRowHover: boolean;
    resizable: boolean;
    rowKey: string;
    tableContentWidth: string;
    columnControllerVisible: boolean;
    defaultColumnControllerVisible: boolean;
    expandIcon: boolean | ((h: import("vue").CreateElement, props: import("./type").ExpandArrowRenderParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue);
    expandOnRowClick: boolean;
    expandedRowKeys: (string | number)[];
    defaultExpandedRowKeys: (string | number)[];
    hideSortTips: boolean;
    multipleSort: boolean;
    reserveSelectedRowOnPaginate: boolean;
    rowSelectionAllowUncheck: boolean;
    selectOnRowClick: boolean;
    selectedRowKeys: (string | number)[];
    defaultSelectedRowKeys: (string | number)[];
    showSortColumnBgColor: boolean;
    sortOnRowDraggable: boolean;
    expandedTreeNodes: (string | number)[];
    defaultExpandedTreeNodes: (string | number)[];
} & {
    sort?: import("./type").TableSort;
    height?: string | number;
    maxHeight?: string | number;
    scroll?: import("..").TScroll;
    size?: import("..").SizeEnum;
    onChange?: (data: import("./type").TableChangeData, context: import("./type").TableChangeContext<import("./type").TableRowData>) => void;
    attach?: import("..").AttachNode;
    pagination?: unknown;
    tree?: unknown;
    onValidate?: (context: import("./type").PrimaryTableValidateContext) => void;
    onScroll?: (params: {
        e: WheelEvent;
    }) => void;
    onDragSort?: (context: import("./type").DragSortContext<import("./type").TableRowData>) => void;
    dragSort?: "col" | "row" | "row-handler" | "row-handler-col" | "drag-col";
    onCellClick?: (context: import("./type").PrimaryTableCellEventContext<import("./type").TableRowData>) => void;
    onPageChange?: (pageInfo: import("..").PageInfo, newDataSource: import("./type").TableRowData[]) => void;
    filterValue?: unknown;
    loadingProps?: unknown;
    asyncLoading?: "loading" | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue) | "load-more";
    bottomContent?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    cellEmptyContent?: string | ((h: import("vue").CreateElement, props: import("./type").BaseTableCellParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue);
    firstFullRow?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    fixedRows?: number[];
    footerAffixProps?: unknown;
    footerSummary?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    headerAffixProps?: unknown;
    horizontalScrollAffixedBottom?: unknown;
    lastFullRow?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    locale?: unknown;
    paginationAffixedBottom?: unknown;
    rowAttributes?: import("./type").TableRowAttributes<import("./type").TableRowData>;
    rowClassName?: unknown;
    rowspanAndColspan?: import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>;
    rowspanAndColspanInFooter?: import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>;
    topContent?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onActiveChange?: (activeRowKeys: (string | number)[], context: import("./type").ActiveChangeContext<import("./type").TableRowData>) => void;
    onActiveRowAction?: (context: import("./type").ActiveRowActionContext<import("./type").TableRowData>) => void;
    onColumnResizeChange?: (context: {
        columnsWidth: {
            [colKey: string]: number;
        };
    }) => void;
    onRowClick?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowDblclick?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMousedown?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseenter?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseleave?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseover?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseup?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onScrollX?: (params: {
        e: WheelEvent;
    }) => void;
    onScrollY?: (params: {
        e: WheelEvent;
    }) => void;
    sortIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    filterIcon?: (h: import("vue").CreateElement, props: {
        col: import("./type").PrimaryTableCol<import("./type").TableRowData>;
        colIndex: number;
    }) => import("vue/types/vnode").ScopedSlotReturnValue;
    columnController?: unknown;
    displayColumns?: import("..").CheckboxGroupValue;
    defaultDisplayColumns?: import("..").CheckboxGroupValue;
    dragSortOptions?: unknown;
    editableCellState?: import("./type").EditableCellType<import("./type").TableRowData>;
    editableRowKeys?: (string | number)[];
    expandedRow?: (h: import("vue").CreateElement, props: import("./type").TableExpandedRowParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue;
    filterRow?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    defaultFilterValue?: unknown;
    indeterminateSelectedRowKeys?: (string | number)[];
    rowSelectionType?: "multiple" | "single";
    defaultSort?: import("./type").TableSort;
    onAsyncLoadingClick?: (context: {
        status: "loading" | "load-more";
    }) => void;
    onColumnChange?: (context: import("./type").PrimaryTableColumnChange<import("./type").TableRowData>) => void;
    onColumnControllerVisibleChange?: (visible: boolean, context: {
        trigger: "cancel" | "confirm";
    }) => void;
    onDataChange?: (data: import("./type").TableRowData[], context: import("./type").TableDataChangeContext) => void;
    onDisplayColumnsChange?: (value: import("..").CheckboxGroupValue) => void;
    onExpandChange?: (expandedRowKeys: (string | number)[], options: import("./type").ExpandOptions<import("./type").TableRowData>) => void;
    onFilterChange?: (filterValue: import("./type").FilterValue, context: import("./type").TableFilterChangeContext<import("./type").TableRowData>) => void;
    onRowEdit?: (context: import("./type").PrimaryTableRowEditContext<import("./type").TableRowData>) => void;
    onRowValidate?: (context: import("./type").PrimaryTableRowValidateContext<import("./type").TableRowData>) => void;
    onSelectChange?: (selectedRowKeys: (string | number)[], options: import("./type").SelectOptions<import("./type").TableRowData>) => void;
    onSortChange?: (sort: import("./type").TableSort, options: import("./type").SortOptions<import("./type").TableRowData>) => void;
    beforeDragSort?: (context: import("./type").DragSortContext<import("./type").TableRowData>) => boolean;
    treeExpandAndFoldIcon?: (h: import("vue").CreateElement, props: {
        type: "expand" | "fold";
        row: import("./type").TableRowData;
    }) => import("vue/types/vnode").ScopedSlotReturnValue;
    onAbnormalDragSort?: (context: import("./type").TableAbnormalDragSortContext<import("./type").TableRowData>) => void;
    onExpandedTreeNodesChange?: (expandedTreeNodes: (string | number)[], options: import("./type").TableTreeNodeExpandOptions<import("./type").TableRowData>) => void;
    onTreeExpandChange?: (context: import("./type").TableTreeExpandChangeContext<import("./type").TableRowData>) => void;
}, import("@vue/composition-api").ShallowUnwrapRef<{
    scrollToElement: (params: import("..").ComponentScrollToElementParams) => void;
    rowDataKeys: import("@vue/composition-api").ComputedRef<{
        rowKey: string;
        childrenKey: string;
    }>;
    setData: <T>(key: import("./type").TableRowValue, newRowData: T) => void;
    getData: (key: import("./type").TableRowValue) => import("./type").TableRowState<import("./type").TableRowData>;
    remove: (key: import("./type").TableRowValue) => void;
    removeChildren: (key: import("./type").TableRowValue) => void;
    appendTo: <T_1>(key: import("./type").TableRowValue, newData: T_1 | T_1[]) => void;
    insertAfter: <T_2>(rowValue: import("./type").TableRowValue, newData: T_2) => void;
    insertBefore: <T_3>(rowValue: import("./type").TableRowValue, newData: T_3) => void;
    toggleExpandData: (p: {
        row: import("./type").TableRowData;
        rowIndex: number;
    }, trigger?: "expand-fold-icon" | "row-click") => void;
    expandAll: (type?: "default-expand-all" | "expand-all", list?: import("./type").TableRowData[]) => void;
    foldAll: () => void;
    getTreeNode: () => import("../_common/js/table/types").TableRowData[];
    resetData: (data: import("./type").TableRowData[]) => void;
    getTreeExpandedRow: (type?: "all" | "data" | "unique") => any[];
    store: import("@vue/composition-api").Ref<{
        treeDataMap: import("../_common/js/table/tree-store").TableTreeDataMap;
        expandAllRowIndex: 0;
        initialTreeStore: (dataSource: import("../_common/js/table/types").TableRowData[], columns: import("../_common/js/table/types").PlainObject[], keys: import("../_common/js/table/tree-store").KeysType) => void;
        getAllUniqueKeys: (data: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType, arr?: import("../_common/js/table/types").TableRowData[]) => import("../_common/js/table/types").TableRowData[];
        getExpandedChildrenKeys: (data: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType, arr?: (string | number)[]) => (string | number)[];
        expandTreeNode: (rowList: (string | number)[], dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        foldTreeNode: (rowList: (string | number)[], dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        toggleExpandData: (p: {
            rowIndex: number;
            row: import("../_common/js/table/types").TableRowData;
        }, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType, type?: "expand" | "fold") => import("../_common/js/table/types").TableRowData[];
        updateExpandRow: (changeRow: import("../_common/js/table/types").TableRowState<import("../_common/js/table/types").TableRowData>, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        getData: (key: import("../_common/js/table/types").TableRowValue) => import("../_common/js/table/types").TableRowState<import("../_common/js/table/types").TableRowData>;
        updateData: (rowValue: import("../_common/js/table/types").TableRowValue, newRowData: import("../_common/js/table/types").TableRowData, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => number;
        remove: (key: import("../_common/js/table/types").TableRowValue, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        removeChildren: (key: import("../_common/js/table/types").TableRowValue, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        appendTo: (rowValue: string | number, newData: import("../_common/js/table/types").TableRowData | import("../_common/js/table/types").TableRowData[], dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        appendToRoot: (newData: import("../_common/js/table/types").TableRowData | import("../_common/js/table/types").TableRowData[], dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        insertAfter: (rowValue: string | number, newData: import("../_common/js/table/types").TableRowData, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        insertBefore: (rowValue: string | number, newData: import("../_common/js/table/types").TableRowData, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        insert: (rowValue: string | number, newData: import("../_common/js/table/types").TableRowData, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType, type: "after" | "before") => import("../_common/js/table/types").TableRowData[];
        swapData: (dataSource: import("../_common/js/table/types").TableRowData[], params: import("../_common/js/table/tree-store").SwapParams<import("../_common/js/table/types").TableRowData>, keys: import("../_common/js/table/tree-store").KeysType) => {
            dataSource: import("../_common/js/table/types").TableRowData[];
            result: boolean;
            code?: number;
            reason?: string;
        };
        expandAll: (dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        foldAll: (dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        getTreeNode: (dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        getTreeExpandedRow: (dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType, type?: "all" | "data" | "unique") => any[];
        initialTreeDataMap: (treeDataMap: import("../_common/js/table/tree-store").TableTreeDataMap, dataSource: import("../_common/js/table/types").TableRowData[], column: import("../_common/js/table/types").PlainObject, keys: import("../_common/js/table/tree-store").KeysType, level?: number, parent?: import("../_common/js/table/types").TableRowState<import("../_common/js/table/types").TableRowData>) => void;
        updateDisabledState: (dataSource: import("../_common/js/table/types").TableRowData[], column: import("../_common/js/table/types").PlainObject, keys: import("../_common/js/table/tree-store").KeysType) => void;
        validateDataExist: (state: import("../_common/js/table/types").TableRowState<import("../_common/js/table/types").TableRowData>, rowValue: string | number) => boolean;
        validateDataDoubleExist: (state: import("../_common/js/table/types").TableRowState<import("../_common/js/table/types").TableRowData>, rowValue: string | number) => boolean;
    }>;
    classPrefix: import("@vue/composition-api").ComputedRef<string>;
    dataSource: import("@vue/composition-api").Ref<{
        [x: string]: any;
        children?: any[];
    }[]>;
    tColumns: import("@vue/composition-api").ComputedRef<import("./type").PrimaryTableCol<import("./type").TableRowData>[]>;
    treeDataMap: import("@vue/composition-api").Ref<import("../_common/js/table/tree-store").TableTreeDataMap>;
    tIndeterminateSelectedRowKeys: import("@vue/composition-api").Ref<(string | number)[]>;
    enhancedTableRef: import("@vue/composition-api").Ref<any>;
    primaryTableRef: import("@vue/composition-api").Ref<any>;
    onDragSortChange: (params: import("./type").DragSortContext<import("./type").TableRowData>) => void;
    onInnerSelectChange: (rowKeys: (string | number)[], extraData: import("./type").SelectOptions<import("./type").TableRowData>) => void;
    onEnhancedTableRowClick: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
}>, import("@vue/composition-api").Data, {}, {
    getListener(): import("./base-table").TableListeners;
    getRowClassName({ row }: {
        row: import("./type").TableRowData;
    }): import("..").ClassName[];
}, {}, {}, {}, {
    data: import("./type").TableRowData[];
    columns: import("./type").PrimaryTableCol<import("./type").TableRowData>[];
    tableLayout: "fixed" | "auto";
    verticalAlign: "top" | "bottom" | "middle";
    loading: boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    empty: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    hover: boolean;
    lazyLoad: boolean;
    bordered: boolean;
    showHeader: boolean;
    stripe: boolean;
    activeRowKeys: (string | number)[];
    defaultActiveRowKeys: (string | number)[];
    activeRowType: "multiple" | "single";
    allowResizeColumnWidth: boolean;
    disableDataPage: boolean;
    disableSpaceInactiveRow: boolean;
    footData: import("./type").TableRowData[];
    footerAffixedBottom: boolean;
    headerAffixedTop: boolean;
    keyboardRowHover: boolean;
    resizable: boolean;
    rowKey: string;
    tableContentWidth: string;
    columnControllerVisible: boolean;
    defaultColumnControllerVisible: boolean;
    expandIcon: boolean | ((h: import("vue").CreateElement, props: import("./type").ExpandArrowRenderParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue);
    expandOnRowClick: boolean;
    expandedRowKeys: (string | number)[];
    defaultExpandedRowKeys: (string | number)[];
    hideSortTips: boolean;
    multipleSort: boolean;
    reserveSelectedRowOnPaginate: boolean;
    rowSelectionAllowUncheck: boolean;
    selectOnRowClick: boolean;
    selectedRowKeys: (string | number)[];
    defaultSelectedRowKeys: (string | number)[];
    showSortColumnBgColor: boolean;
    sortOnRowDraggable: boolean;
    expandedTreeNodes: (string | number)[];
    defaultExpandedTreeNodes: (string | number)[];
} & {
    sort?: import("./type").TableSort;
    height?: string | number;
    maxHeight?: string | number;
    scroll?: import("..").TScroll;
    size?: import("..").SizeEnum;
    onChange?: (data: import("./type").TableChangeData, context: import("./type").TableChangeContext<import("./type").TableRowData>) => void;
    attach?: import("..").AttachNode;
    pagination?: unknown;
    tree?: unknown;
    onValidate?: (context: import("./type").PrimaryTableValidateContext) => void;
    onScroll?: (params: {
        e: WheelEvent;
    }) => void;
    onDragSort?: (context: import("./type").DragSortContext<import("./type").TableRowData>) => void;
    dragSort?: "col" | "row" | "row-handler" | "row-handler-col" | "drag-col";
    onCellClick?: (context: import("./type").PrimaryTableCellEventContext<import("./type").TableRowData>) => void;
    onPageChange?: (pageInfo: import("..").PageInfo, newDataSource: import("./type").TableRowData[]) => void;
    filterValue?: unknown;
    loadingProps?: unknown;
    asyncLoading?: "loading" | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue) | "load-more";
    bottomContent?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    cellEmptyContent?: string | ((h: import("vue").CreateElement, props: import("./type").BaseTableCellParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue);
    firstFullRow?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    fixedRows?: number[];
    footerAffixProps?: unknown;
    footerSummary?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    headerAffixProps?: unknown;
    horizontalScrollAffixedBottom?: unknown;
    lastFullRow?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    locale?: unknown;
    paginationAffixedBottom?: unknown;
    rowAttributes?: import("./type").TableRowAttributes<import("./type").TableRowData>;
    rowClassName?: unknown;
    rowspanAndColspan?: import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>;
    rowspanAndColspanInFooter?: import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>;
    topContent?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onActiveChange?: (activeRowKeys: (string | number)[], context: import("./type").ActiveChangeContext<import("./type").TableRowData>) => void;
    onActiveRowAction?: (context: import("./type").ActiveRowActionContext<import("./type").TableRowData>) => void;
    onColumnResizeChange?: (context: {
        columnsWidth: {
            [colKey: string]: number;
        };
    }) => void;
    onRowClick?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowDblclick?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMousedown?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseenter?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseleave?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseover?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseup?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onScrollX?: (params: {
        e: WheelEvent;
    }) => void;
    onScrollY?: (params: {
        e: WheelEvent;
    }) => void;
    sortIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    filterIcon?: (h: import("vue").CreateElement, props: {
        col: import("./type").PrimaryTableCol<import("./type").TableRowData>;
        colIndex: number;
    }) => import("vue/types/vnode").ScopedSlotReturnValue;
    columnController?: unknown;
    displayColumns?: import("..").CheckboxGroupValue;
    defaultDisplayColumns?: import("..").CheckboxGroupValue;
    dragSortOptions?: unknown;
    editableCellState?: import("./type").EditableCellType<import("./type").TableRowData>;
    editableRowKeys?: (string | number)[];
    expandedRow?: (h: import("vue").CreateElement, props: import("./type").TableExpandedRowParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue;
    filterRow?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    defaultFilterValue?: unknown;
    indeterminateSelectedRowKeys?: (string | number)[];
    rowSelectionType?: "multiple" | "single";
    defaultSort?: import("./type").TableSort;
    onAsyncLoadingClick?: (context: {
        status: "loading" | "load-more";
    }) => void;
    onColumnChange?: (context: import("./type").PrimaryTableColumnChange<import("./type").TableRowData>) => void;
    onColumnControllerVisibleChange?: (visible: boolean, context: {
        trigger: "cancel" | "confirm";
    }) => void;
    onDataChange?: (data: import("./type").TableRowData[], context: import("./type").TableDataChangeContext) => void;
    onDisplayColumnsChange?: (value: import("..").CheckboxGroupValue) => void;
    onExpandChange?: (expandedRowKeys: (string | number)[], options: import("./type").ExpandOptions<import("./type").TableRowData>) => void;
    onFilterChange?: (filterValue: import("./type").FilterValue, context: import("./type").TableFilterChangeContext<import("./type").TableRowData>) => void;
    onRowEdit?: (context: import("./type").PrimaryTableRowEditContext<import("./type").TableRowData>) => void;
    onRowValidate?: (context: import("./type").PrimaryTableRowValidateContext<import("./type").TableRowData>) => void;
    onSelectChange?: (selectedRowKeys: (string | number)[], options: import("./type").SelectOptions<import("./type").TableRowData>) => void;
    onSortChange?: (sort: import("./type").TableSort, options: import("./type").SortOptions<import("./type").TableRowData>) => void;
    beforeDragSort?: (context: import("./type").DragSortContext<import("./type").TableRowData>) => boolean;
    treeExpandAndFoldIcon?: (h: import("vue").CreateElement, props: {
        type: "expand" | "fold";
        row: import("./type").TableRowData;
    }) => import("vue/types/vnode").ScopedSlotReturnValue;
    onAbnormalDragSort?: (context: import("./type").TableAbnormalDragSortContext<import("./type").TableRowData>) => void;
    onExpandedTreeNodesChange?: (expandedTreeNodes: (string | number)[], options: import("./type").TableTreeNodeExpandOptions<import("./type").TableRowData>) => void;
    onTreeExpandChange?: (context: import("./type").TableTreeExpandChangeContext<import("./type").TableRowData>) => void;
}, {
    data: import("./type").TableRowData[];
    columns: import("./type").PrimaryTableCol<import("./type").TableRowData>[];
    tableLayout: "fixed" | "auto";
    verticalAlign: "top" | "bottom" | "middle";
    loading: boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    empty: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    hover: boolean;
    lazyLoad: boolean;
    bordered: boolean;
    showHeader: boolean;
    stripe: boolean;
    activeRowKeys: (string | number)[];
    defaultActiveRowKeys: (string | number)[];
    activeRowType: "multiple" | "single";
    allowResizeColumnWidth: boolean;
    disableDataPage: boolean;
    disableSpaceInactiveRow: boolean;
    footData: import("./type").TableRowData[];
    footerAffixedBottom: boolean;
    headerAffixedTop: boolean;
    keyboardRowHover: boolean;
    resizable: boolean;
    rowKey: string;
    tableContentWidth: string;
    columnControllerVisible: boolean;
    defaultColumnControllerVisible: boolean;
    expandIcon: boolean | ((h: import("vue").CreateElement, props: import("./type").ExpandArrowRenderParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue);
    expandOnRowClick: boolean;
    expandedRowKeys: (string | number)[];
    defaultExpandedRowKeys: (string | number)[];
    hideSortTips: boolean;
    multipleSort: boolean;
    reserveSelectedRowOnPaginate: boolean;
    rowSelectionAllowUncheck: boolean;
    selectOnRowClick: boolean;
    selectedRowKeys: (string | number)[];
    defaultSelectedRowKeys: (string | number)[];
    showSortColumnBgColor: boolean;
    sortOnRowDraggable: boolean;
    expandedTreeNodes: (string | number)[];
    defaultExpandedTreeNodes: (string | number)[];
}, true>) & import("vue").PluginObject<import("vue").ComponentOptions<import("vue").default, import("@vue/composition-api").ShallowUnwrapRef<{
    scrollToElement: (params: import("..").ComponentScrollToElementParams) => void;
    rowDataKeys: import("@vue/composition-api").ComputedRef<{
        rowKey: string;
        childrenKey: string;
    }>;
    setData: <T>(key: import("./type").TableRowValue, newRowData: T) => void;
    getData: (key: import("./type").TableRowValue) => import("./type").TableRowState<import("./type").TableRowData>;
    remove: (key: import("./type").TableRowValue) => void;
    removeChildren: (key: import("./type").TableRowValue) => void;
    appendTo: <T_1>(key: import("./type").TableRowValue, newData: T_1 | T_1[]) => void;
    insertAfter: <T_2>(rowValue: import("./type").TableRowValue, newData: T_2) => void;
    insertBefore: <T_3>(rowValue: import("./type").TableRowValue, newData: T_3) => void;
    toggleExpandData: (p: {
        row: import("./type").TableRowData;
        rowIndex: number;
    }, trigger?: "expand-fold-icon" | "row-click") => void;
    expandAll: (type?: "default-expand-all" | "expand-all", list?: import("./type").TableRowData[]) => void;
    foldAll: () => void;
    getTreeNode: () => import("../_common/js/table/types").TableRowData[];
    resetData: (data: import("./type").TableRowData[]) => void;
    getTreeExpandedRow: (type?: "all" | "data" | "unique") => any[];
    store: import("@vue/composition-api").Ref<{
        treeDataMap: import("../_common/js/table/tree-store").TableTreeDataMap;
        expandAllRowIndex: 0;
        initialTreeStore: (dataSource: import("../_common/js/table/types").TableRowData[], columns: import("../_common/js/table/types").PlainObject[], keys: import("../_common/js/table/tree-store").KeysType) => void;
        getAllUniqueKeys: (data: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType, arr?: import("../_common/js/table/types").TableRowData[]) => import("../_common/js/table/types").TableRowData[];
        getExpandedChildrenKeys: (data: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType, arr?: (string | number)[]) => (string | number)[];
        expandTreeNode: (rowList: (string | number)[], dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        foldTreeNode: (rowList: (string | number)[], dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        toggleExpandData: (p: {
            rowIndex: number;
            row: import("../_common/js/table/types").TableRowData;
        }, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType, type?: "expand" | "fold") => import("../_common/js/table/types").TableRowData[];
        updateExpandRow: (changeRow: import("../_common/js/table/types").TableRowState<import("../_common/js/table/types").TableRowData>, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        getData: (key: import("../_common/js/table/types").TableRowValue) => import("../_common/js/table/types").TableRowState<import("../_common/js/table/types").TableRowData>;
        updateData: (rowValue: import("../_common/js/table/types").TableRowValue, newRowData: import("../_common/js/table/types").TableRowData, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => number;
        remove: (key: import("../_common/js/table/types").TableRowValue, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        removeChildren: (key: import("../_common/js/table/types").TableRowValue, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        appendTo: (rowValue: string | number, newData: import("../_common/js/table/types").TableRowData | import("../_common/js/table/types").TableRowData[], dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        appendToRoot: (newData: import("../_common/js/table/types").TableRowData | import("../_common/js/table/types").TableRowData[], dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        insertAfter: (rowValue: string | number, newData: import("../_common/js/table/types").TableRowData, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        insertBefore: (rowValue: string | number, newData: import("../_common/js/table/types").TableRowData, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        insert: (rowValue: string | number, newData: import("../_common/js/table/types").TableRowData, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType, type: "after" | "before") => import("../_common/js/table/types").TableRowData[];
        swapData: (dataSource: import("../_common/js/table/types").TableRowData[], params: import("../_common/js/table/tree-store").SwapParams<import("../_common/js/table/types").TableRowData>, keys: import("../_common/js/table/tree-store").KeysType) => {
            dataSource: import("../_common/js/table/types").TableRowData[];
            result: boolean;
            code?: number;
            reason?: string;
        };
        expandAll: (dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        foldAll: (dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        getTreeNode: (dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        getTreeExpandedRow: (dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType, type?: "all" | "data" | "unique") => any[];
        initialTreeDataMap: (treeDataMap: import("../_common/js/table/tree-store").TableTreeDataMap, dataSource: import("../_common/js/table/types").TableRowData[], column: import("../_common/js/table/types").PlainObject, keys: import("../_common/js/table/tree-store").KeysType, level?: number, parent?: import("../_common/js/table/types").TableRowState<import("../_common/js/table/types").TableRowData>) => void;
        updateDisabledState: (dataSource: import("../_common/js/table/types").TableRowData[], column: import("../_common/js/table/types").PlainObject, keys: import("../_common/js/table/tree-store").KeysType) => void;
        validateDataExist: (state: import("../_common/js/table/types").TableRowState<import("../_common/js/table/types").TableRowData>, rowValue: string | number) => boolean;
        validateDataDoubleExist: (state: import("../_common/js/table/types").TableRowState<import("../_common/js/table/types").TableRowData>, rowValue: string | number) => boolean;
    }>;
    classPrefix: import("@vue/composition-api").ComputedRef<string>;
    dataSource: import("@vue/composition-api").Ref<{
        [x: string]: any;
        children?: any[];
    }[]>;
    tColumns: import("@vue/composition-api").ComputedRef<import("./type").PrimaryTableCol<import("./type").TableRowData>[]>;
    treeDataMap: import("@vue/composition-api").Ref<import("../_common/js/table/tree-store").TableTreeDataMap>;
    tIndeterminateSelectedRowKeys: import("@vue/composition-api").Ref<(string | number)[]>;
    enhancedTableRef: import("@vue/composition-api").Ref<any>;
    primaryTableRef: import("@vue/composition-api").Ref<any>;
    onDragSortChange: (params: import("./type").DragSortContext<import("./type").TableRowData>) => void;
    onInnerSelectChange: (rowKeys: (string | number)[], extraData: import("./type").SelectOptions<import("./type").TableRowData>) => void;
    onEnhancedTableRowClick: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
}> & import("@vue/composition-api").Data, {
    getListener(): import("./base-table").TableListeners;
    getRowClassName({ row }: {
        row: import("./type").TableRowData;
    }): import("..").ClassName[];
}, {}, {
    beforeDragSort: {
        type: import("vue").PropType<(context: import("./type").DragSortContext<import("./type").TableRowData>) => boolean>;
    };
    expandedTreeNodes: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultExpandedTreeNodes: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    tree: {
        type: import("vue").PropType<import("./type").TableTreeConfig>;
    };
    treeExpandAndFoldIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: {
            type: "expand" | "fold";
            row: import("./type").TableRowData;
        }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    onAbnormalDragSort: import("vue").PropType<(context: import("./type").TableAbnormalDragSortContext<import("./type").TableRowData>) => void>;
    onExpandedTreeNodesChange: import("vue").PropType<(expandedTreeNodes: (string | number)[], options: import("./type").TableTreeNodeExpandOptions<import("./type").TableRowData>) => void>;
    onTreeExpandChange: import("vue").PropType<(context: import("./type").TableTreeExpandChangeContext<import("./type").TableRowData>) => void>;
    asyncLoading: {
        type: import("vue").PropType<"loading" | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue) | "load-more">;
    };
    columnController: {
        type: import("vue").PropType<import("./type").TableColumnController>;
    };
    columnControllerVisible: {
        type: BooleanConstructor;
        default: any;
    };
    defaultColumnControllerVisible: {
        type: BooleanConstructor;
        default: any;
    };
    columns: {
        type: import("vue").PropType<import("./type").PrimaryTableCol<import("./type").TableRowData>[]>;
        default: () => import("./type").PrimaryTableCol<import("./type").TableRowData>[];
    };
    displayColumns: {
        type: import("vue").PropType<import("..").CheckboxGroupValue>;
    };
    defaultDisplayColumns: {
        type: import("vue").PropType<import("..").CheckboxGroupValue>;
    };
    dragSort: {
        type: import("vue").PropType<"col" | "row" | "row-handler" | "row-handler-col" | "drag-col">;
        validator(val: "col" | "row" | "row-handler" | "row-handler-col" | "drag-col"): boolean;
    };
    dragSortOptions: {
        type: import("vue").PropType<import("sortablejs").SortableOptions>;
    };
    editableCellState: {
        type: import("vue").PropType<import("./type").EditableCellType<import("./type").TableRowData>>;
    };
    editableRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
    };
    expandIcon: {
        type: import("vue").PropType<boolean | ((h: import("vue").CreateElement, props: import("./type").ExpandArrowRenderParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: boolean;
    };
    expandOnRowClick: BooleanConstructor;
    expandedRow: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: import("./type").TableExpandedRowParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    expandedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultExpandedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    filterIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: {
            col: import("./type").PrimaryTableCol<import("./type").TableRowData>;
            colIndex: number;
        }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    filterRow: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    filterValue: {
        type: import("vue").PropType<import("./type").FilterValue>;
    };
    defaultFilterValue: {
        type: import("vue").PropType<import("./type").FilterValue>;
    };
    hideSortTips: BooleanConstructor;
    indeterminateSelectedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
    };
    multipleSort: BooleanConstructor;
    reserveSelectedRowOnPaginate: {
        type: BooleanConstructor;
        default: boolean;
    };
    rowSelectionAllowUncheck: BooleanConstructor;
    rowSelectionType: {
        type: import("vue").PropType<"multiple" | "single">;
        validator(val: "multiple" | "single"): boolean;
    };
    selectOnRowClick: BooleanConstructor;
    selectedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultSelectedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    showSortColumnBgColor: BooleanConstructor;
    sort: {
        type: import("vue").PropType<import("./type").TableSort>;
    };
    defaultSort: {
        type: import("vue").PropType<import("./type").TableSort>;
    };
    sortIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    sortOnRowDraggable: BooleanConstructor;
    onAsyncLoadingClick: import("vue").PropType<(context: {
        status: "loading" | "load-more";
    }) => void>;
    onCellClick: import("vue").PropType<(context: import("./type").PrimaryTableCellEventContext<import("./type").TableRowData>) => void>;
    onChange: import("vue").PropType<(data: import("./type").TableChangeData, context: import("./type").TableChangeContext<import("./type").TableRowData>) => void>;
    onColumnChange: import("vue").PropType<(context: import("./type").PrimaryTableColumnChange<import("./type").TableRowData>) => void>;
    onColumnControllerVisibleChange: import("vue").PropType<(visible: boolean, context: {
        trigger: "cancel" | "confirm";
    }) => void>;
    onDataChange: import("vue").PropType<(data: import("./type").TableRowData[], context: import("./type").TableDataChangeContext) => void>;
    onDisplayColumnsChange: import("vue").PropType<(value: import("..").CheckboxGroupValue) => void>;
    onDragSort: import("vue").PropType<(context: import("./type").DragSortContext<import("./type").TableRowData>) => void>;
    onExpandChange: import("vue").PropType<(expandedRowKeys: (string | number)[], options: import("./type").ExpandOptions<import("./type").TableRowData>) => void>;
    onFilterChange: import("vue").PropType<(filterValue: import("./type").FilterValue, context: import("./type").TableFilterChangeContext<import("./type").TableRowData>) => void>;
    onRowEdit: import("vue").PropType<(context: import("./type").PrimaryTableRowEditContext<import("./type").TableRowData>) => void>;
    onRowValidate: import("vue").PropType<(context: import("./type").PrimaryTableRowValidateContext<import("./type").TableRowData>) => void>;
    onSelectChange: import("vue").PropType<(selectedRowKeys: (string | number)[], options: import("./type").SelectOptions<import("./type").TableRowData>) => void>;
    onSortChange: import("vue").PropType<(sort: import("./type").TableSort, options: import("./type").SortOptions<import("./type").TableRowData>) => void>;
    onValidate: import("vue").PropType<(context: import("./type").PrimaryTableValidateContext) => void>;
    activeRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultActiveRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    activeRowType: {
        type: import("vue").PropType<"multiple" | "single">;
        default: string;
    };
    allowResizeColumnWidth: {
        type: BooleanConstructor;
        default: any;
    };
    attach: {
        type: import("vue").PropType<import("..").AttachNode>;
    };
    bordered: BooleanConstructor;
    bottomContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    cellEmptyContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement, props: import("./type").BaseTableCellParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    data: {
        type: import("vue").PropType<import("./type").TableRowData[]>;
        default: () => import("./type").TableRowData[];
    };
    disableDataPage: BooleanConstructor;
    disableSpaceInactiveRow: {
        type: BooleanConstructor;
        default: any;
    };
    empty: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: string;
    };
    firstFullRow: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    fixedRows: {
        type: import("vue").PropType<number[]>;
    };
    footData: {
        type: import("vue").PropType<import("./type").TableRowData[]>;
        default: () => import("./type").TableRowData[];
    };
    footerAffixProps: {
        type: import("vue").PropType<Partial<import("..").TdAffixProps>>;
    };
    footerAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
        default: boolean;
    };
    footerSummary: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    headerAffixProps: {
        type: import("vue").PropType<Partial<import("..").TdAffixProps>>;
    };
    headerAffixedTop: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
        default: boolean;
    };
    height: {
        type: import("vue").PropType<string | number>;
    };
    horizontalScrollAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
    };
    hover: BooleanConstructor;
    keyboardRowHover: {
        type: BooleanConstructor;
        default: boolean;
    };
    lastFullRow: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    lazyLoad: BooleanConstructor;
    loading: {
        type: import("vue").PropType<boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: any;
    };
    loadingProps: {
        type: import("vue").PropType<Partial<import("..").TdLoadingProps>>;
    };
    locale: {
        type: import("vue").PropType<import("..").TableConfig>;
    };
    maxHeight: {
        type: import("vue").PropType<string | number>;
    };
    pagination: {
        type: import("vue").PropType<import("..").TdPaginationProps>;
    };
    paginationAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
    };
    resizable: BooleanConstructor;
    rowAttributes: {
        type: import("vue").PropType<import("./type").TableRowAttributes<import("./type").TableRowData>>;
    };
    rowClassName: {
        type: import("vue").PropType<import("..").ClassName | ((params: import("./type").RowClassNameParams<import("./type").TableRowData>) => import("..").ClassName)>;
    };
    rowKey: {
        type: StringConstructor;
        default: string;
        required: boolean;
    };
    rowspanAndColspan: {
        type: import("vue").PropType<import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>>;
    };
    rowspanAndColspanInFooter: {
        type: import("vue").PropType<import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>>;
    };
    scroll: {
        type: import("vue").PropType<import("..").TScroll>;
    };
    showHeader: {
        type: BooleanConstructor;
        default: boolean;
    };
    size: {
        type: import("vue").PropType<import("..").SizeEnum>;
        validator(val: import("..").SizeEnum): boolean;
    };
    stripe: BooleanConstructor;
    tableContentWidth: {
        type: StringConstructor;
        default: string;
    };
    tableLayout: {
        type: import("vue").PropType<"fixed" | "auto">;
        default: "fixed" | "auto";
        validator(val: "fixed" | "auto"): boolean;
    };
    topContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    verticalAlign: {
        type: import("vue").PropType<"top" | "bottom" | "middle">;
        default: "top" | "bottom" | "middle";
        validator(val: "top" | "bottom" | "middle"): boolean;
    };
    onActiveChange: import("vue").PropType<(activeRowKeys: (string | number)[], context: import("./type").ActiveChangeContext<import("./type").TableRowData>) => void>;
    onActiveRowAction: import("vue").PropType<(context: import("./type").ActiveRowActionContext<import("./type").TableRowData>) => void>;
    onColumnResizeChange: import("vue").PropType<(context: {
        columnsWidth: {
            [colKey: string]: number;
        };
    }) => void>;
    onPageChange: import("vue").PropType<(pageInfo: import("..").PageInfo, newDataSource: import("./type").TableRowData[]) => void>;
    onRowClick: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowDblclick: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMousedown: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseenter: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseleave: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseover: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseup: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onScroll: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
    onScrollX: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
    onScrollY: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
}, import("@vue/composition-api").ExtractPropTypes<{
    beforeDragSort: {
        type: import("vue").PropType<(context: import("./type").DragSortContext<import("./type").TableRowData>) => boolean>;
    };
    expandedTreeNodes: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultExpandedTreeNodes: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    tree: {
        type: import("vue").PropType<import("./type").TableTreeConfig>;
    };
    treeExpandAndFoldIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: {
            type: "expand" | "fold";
            row: import("./type").TableRowData;
        }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    onAbnormalDragSort: import("vue").PropType<(context: import("./type").TableAbnormalDragSortContext<import("./type").TableRowData>) => void>;
    onExpandedTreeNodesChange: import("vue").PropType<(expandedTreeNodes: (string | number)[], options: import("./type").TableTreeNodeExpandOptions<import("./type").TableRowData>) => void>;
    onTreeExpandChange: import("vue").PropType<(context: import("./type").TableTreeExpandChangeContext<import("./type").TableRowData>) => void>;
    asyncLoading: {
        type: import("vue").PropType<"loading" | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue) | "load-more">;
    };
    columnController: {
        type: import("vue").PropType<import("./type").TableColumnController>;
    };
    columnControllerVisible: {
        type: BooleanConstructor;
        default: any;
    };
    defaultColumnControllerVisible: {
        type: BooleanConstructor;
        default: any;
    };
    columns: {
        type: import("vue").PropType<import("./type").PrimaryTableCol<import("./type").TableRowData>[]>;
        default: () => import("./type").PrimaryTableCol<import("./type").TableRowData>[];
    };
    displayColumns: {
        type: import("vue").PropType<import("..").CheckboxGroupValue>;
    };
    defaultDisplayColumns: {
        type: import("vue").PropType<import("..").CheckboxGroupValue>;
    };
    dragSort: {
        type: import("vue").PropType<"col" | "row" | "row-handler" | "row-handler-col" | "drag-col">;
        validator(val: "col" | "row" | "row-handler" | "row-handler-col" | "drag-col"): boolean;
    };
    dragSortOptions: {
        type: import("vue").PropType<import("sortablejs").SortableOptions>;
    };
    editableCellState: {
        type: import("vue").PropType<import("./type").EditableCellType<import("./type").TableRowData>>;
    };
    editableRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
    };
    expandIcon: {
        type: import("vue").PropType<boolean | ((h: import("vue").CreateElement, props: import("./type").ExpandArrowRenderParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: boolean;
    };
    expandOnRowClick: BooleanConstructor;
    expandedRow: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: import("./type").TableExpandedRowParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    expandedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultExpandedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    filterIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement, props: {
            col: import("./type").PrimaryTableCol<import("./type").TableRowData>;
            colIndex: number;
        }) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    filterRow: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    filterValue: {
        type: import("vue").PropType<import("./type").FilterValue>;
    };
    defaultFilterValue: {
        type: import("vue").PropType<import("./type").FilterValue>;
    };
    hideSortTips: BooleanConstructor;
    indeterminateSelectedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
    };
    multipleSort: BooleanConstructor;
    reserveSelectedRowOnPaginate: {
        type: BooleanConstructor;
        default: boolean;
    };
    rowSelectionAllowUncheck: BooleanConstructor;
    rowSelectionType: {
        type: import("vue").PropType<"multiple" | "single">;
        validator(val: "multiple" | "single"): boolean;
    };
    selectOnRowClick: BooleanConstructor;
    selectedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultSelectedRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    showSortColumnBgColor: BooleanConstructor;
    sort: {
        type: import("vue").PropType<import("./type").TableSort>;
    };
    defaultSort: {
        type: import("vue").PropType<import("./type").TableSort>;
    };
    sortIcon: {
        type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
    };
    sortOnRowDraggable: BooleanConstructor;
    onAsyncLoadingClick: import("vue").PropType<(context: {
        status: "loading" | "load-more";
    }) => void>;
    onCellClick: import("vue").PropType<(context: import("./type").PrimaryTableCellEventContext<import("./type").TableRowData>) => void>;
    onChange: import("vue").PropType<(data: import("./type").TableChangeData, context: import("./type").TableChangeContext<import("./type").TableRowData>) => void>;
    onColumnChange: import("vue").PropType<(context: import("./type").PrimaryTableColumnChange<import("./type").TableRowData>) => void>;
    onColumnControllerVisibleChange: import("vue").PropType<(visible: boolean, context: {
        trigger: "cancel" | "confirm";
    }) => void>;
    onDataChange: import("vue").PropType<(data: import("./type").TableRowData[], context: import("./type").TableDataChangeContext) => void>;
    onDisplayColumnsChange: import("vue").PropType<(value: import("..").CheckboxGroupValue) => void>;
    onDragSort: import("vue").PropType<(context: import("./type").DragSortContext<import("./type").TableRowData>) => void>;
    onExpandChange: import("vue").PropType<(expandedRowKeys: (string | number)[], options: import("./type").ExpandOptions<import("./type").TableRowData>) => void>;
    onFilterChange: import("vue").PropType<(filterValue: import("./type").FilterValue, context: import("./type").TableFilterChangeContext<import("./type").TableRowData>) => void>;
    onRowEdit: import("vue").PropType<(context: import("./type").PrimaryTableRowEditContext<import("./type").TableRowData>) => void>;
    onRowValidate: import("vue").PropType<(context: import("./type").PrimaryTableRowValidateContext<import("./type").TableRowData>) => void>;
    onSelectChange: import("vue").PropType<(selectedRowKeys: (string | number)[], options: import("./type").SelectOptions<import("./type").TableRowData>) => void>;
    onSortChange: import("vue").PropType<(sort: import("./type").TableSort, options: import("./type").SortOptions<import("./type").TableRowData>) => void>;
    onValidate: import("vue").PropType<(context: import("./type").PrimaryTableValidateContext) => void>;
    activeRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    defaultActiveRowKeys: {
        type: import("vue").PropType<(string | number)[]>;
        default: () => (string | number)[];
    };
    activeRowType: {
        type: import("vue").PropType<"multiple" | "single">;
        default: string;
    };
    allowResizeColumnWidth: {
        type: BooleanConstructor;
        default: any;
    };
    attach: {
        type: import("vue").PropType<import("..").AttachNode>;
    };
    bordered: BooleanConstructor;
    bottomContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    cellEmptyContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement, props: import("./type").BaseTableCellParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    data: {
        type: import("vue").PropType<import("./type").TableRowData[]>;
        default: () => import("./type").TableRowData[];
    };
    disableDataPage: BooleanConstructor;
    disableSpaceInactiveRow: {
        type: BooleanConstructor;
        default: any;
    };
    empty: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: string;
    };
    firstFullRow: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    fixedRows: {
        type: import("vue").PropType<number[]>;
    };
    footData: {
        type: import("vue").PropType<import("./type").TableRowData[]>;
        default: () => import("./type").TableRowData[];
    };
    footerAffixProps: {
        type: import("vue").PropType<Partial<import("..").TdAffixProps>>;
    };
    footerAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
        default: boolean;
    };
    footerSummary: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    headerAffixProps: {
        type: import("vue").PropType<Partial<import("..").TdAffixProps>>;
    };
    headerAffixedTop: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
        default: boolean;
    };
    height: {
        type: import("vue").PropType<string | number>;
    };
    horizontalScrollAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
    };
    hover: BooleanConstructor;
    keyboardRowHover: {
        type: BooleanConstructor;
        default: boolean;
    };
    lastFullRow: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    lazyLoad: BooleanConstructor;
    loading: {
        type: import("vue").PropType<boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        default: any;
    };
    loadingProps: {
        type: import("vue").PropType<Partial<import("..").TdLoadingProps>>;
    };
    locale: {
        type: import("vue").PropType<import("..").TableConfig>;
    };
    maxHeight: {
        type: import("vue").PropType<string | number>;
    };
    pagination: {
        type: import("vue").PropType<import("..").TdPaginationProps>;
    };
    paginationAffixedBottom: {
        type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
    };
    resizable: BooleanConstructor;
    rowAttributes: {
        type: import("vue").PropType<import("./type").TableRowAttributes<import("./type").TableRowData>>;
    };
    rowClassName: {
        type: import("vue").PropType<import("..").ClassName | ((params: import("./type").RowClassNameParams<import("./type").TableRowData>) => import("..").ClassName)>;
    };
    rowKey: {
        type: StringConstructor;
        default: string;
        required: boolean;
    };
    rowspanAndColspan: {
        type: import("vue").PropType<import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>>;
    };
    rowspanAndColspanInFooter: {
        type: import("vue").PropType<import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>>;
    };
    scroll: {
        type: import("vue").PropType<import("..").TScroll>;
    };
    showHeader: {
        type: BooleanConstructor;
        default: boolean;
    };
    size: {
        type: import("vue").PropType<import("..").SizeEnum>;
        validator(val: import("..").SizeEnum): boolean;
    };
    stripe: BooleanConstructor;
    tableContentWidth: {
        type: StringConstructor;
        default: string;
    };
    tableLayout: {
        type: import("vue").PropType<"fixed" | "auto">;
        default: "fixed" | "auto";
        validator(val: "fixed" | "auto"): boolean;
    };
    topContent: {
        type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
    };
    verticalAlign: {
        type: import("vue").PropType<"top" | "bottom" | "middle">;
        default: "top" | "bottom" | "middle";
        validator(val: "top" | "bottom" | "middle"): boolean;
    };
    onActiveChange: import("vue").PropType<(activeRowKeys: (string | number)[], context: import("./type").ActiveChangeContext<import("./type").TableRowData>) => void>;
    onActiveRowAction: import("vue").PropType<(context: import("./type").ActiveRowActionContext<import("./type").TableRowData>) => void>;
    onColumnResizeChange: import("vue").PropType<(context: {
        columnsWidth: {
            [colKey: string]: number;
        };
    }) => void>;
    onPageChange: import("vue").PropType<(pageInfo: import("..").PageInfo, newDataSource: import("./type").TableRowData[]) => void>;
    onRowClick: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowDblclick: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMousedown: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseenter: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseleave: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseover: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onRowMouseup: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
    onScroll: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
    onScrollX: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
    onScrollY: import("vue").PropType<(params: {
        e: WheelEvent;
    }) => void>;
}>> & Omit<import("vue").VueConstructor<import("vue").default>, never> & (new (...args: any[]) => import("@vue/composition-api").ComponentRenderProxy<{
    data: import("./type").TableRowData[];
    columns: import("./type").PrimaryTableCol<import("./type").TableRowData>[];
    tableLayout: "fixed" | "auto";
    verticalAlign: "top" | "bottom" | "middle";
    loading: boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    empty: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    hover: boolean;
    lazyLoad: boolean;
    bordered: boolean;
    showHeader: boolean;
    stripe: boolean;
    activeRowKeys: (string | number)[];
    defaultActiveRowKeys: (string | number)[];
    activeRowType: "multiple" | "single";
    allowResizeColumnWidth: boolean;
    disableDataPage: boolean;
    disableSpaceInactiveRow: boolean;
    footData: import("./type").TableRowData[];
    footerAffixedBottom: boolean;
    headerAffixedTop: boolean;
    keyboardRowHover: boolean;
    resizable: boolean;
    rowKey: string;
    tableContentWidth: string;
    columnControllerVisible: boolean;
    defaultColumnControllerVisible: boolean;
    expandIcon: boolean | ((h: import("vue").CreateElement, props: import("./type").ExpandArrowRenderParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue);
    expandOnRowClick: boolean;
    expandedRowKeys: (string | number)[];
    defaultExpandedRowKeys: (string | number)[];
    hideSortTips: boolean;
    multipleSort: boolean;
    reserveSelectedRowOnPaginate: boolean;
    rowSelectionAllowUncheck: boolean;
    selectOnRowClick: boolean;
    selectedRowKeys: (string | number)[];
    defaultSelectedRowKeys: (string | number)[];
    showSortColumnBgColor: boolean;
    sortOnRowDraggable: boolean;
    expandedTreeNodes: (string | number)[];
    defaultExpandedTreeNodes: (string | number)[];
} & {
    sort?: import("./type").TableSort;
    height?: string | number;
    maxHeight?: string | number;
    scroll?: import("..").TScroll;
    size?: import("..").SizeEnum;
    onChange?: (data: import("./type").TableChangeData, context: import("./type").TableChangeContext<import("./type").TableRowData>) => void;
    attach?: import("..").AttachNode;
    pagination?: unknown;
    tree?: unknown;
    onValidate?: (context: import("./type").PrimaryTableValidateContext) => void;
    onScroll?: (params: {
        e: WheelEvent;
    }) => void;
    onDragSort?: (context: import("./type").DragSortContext<import("./type").TableRowData>) => void;
    dragSort?: "col" | "row" | "row-handler" | "row-handler-col" | "drag-col";
    onCellClick?: (context: import("./type").PrimaryTableCellEventContext<import("./type").TableRowData>) => void;
    onPageChange?: (pageInfo: import("..").PageInfo, newDataSource: import("./type").TableRowData[]) => void;
    filterValue?: unknown;
    loadingProps?: unknown;
    asyncLoading?: "loading" | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue) | "load-more";
    bottomContent?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    cellEmptyContent?: string | ((h: import("vue").CreateElement, props: import("./type").BaseTableCellParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue);
    firstFullRow?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    fixedRows?: number[];
    footerAffixProps?: unknown;
    footerSummary?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    headerAffixProps?: unknown;
    horizontalScrollAffixedBottom?: unknown;
    lastFullRow?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    locale?: unknown;
    paginationAffixedBottom?: unknown;
    rowAttributes?: import("./type").TableRowAttributes<import("./type").TableRowData>;
    rowClassName?: unknown;
    rowspanAndColspan?: import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>;
    rowspanAndColspanInFooter?: import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>;
    topContent?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onActiveChange?: (activeRowKeys: (string | number)[], context: import("./type").ActiveChangeContext<import("./type").TableRowData>) => void;
    onActiveRowAction?: (context: import("./type").ActiveRowActionContext<import("./type").TableRowData>) => void;
    onColumnResizeChange?: (context: {
        columnsWidth: {
            [colKey: string]: number;
        };
    }) => void;
    onRowClick?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowDblclick?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMousedown?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseenter?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseleave?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseover?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseup?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onScrollX?: (params: {
        e: WheelEvent;
    }) => void;
    onScrollY?: (params: {
        e: WheelEvent;
    }) => void;
    sortIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    filterIcon?: (h: import("vue").CreateElement, props: {
        col: import("./type").PrimaryTableCol<import("./type").TableRowData>;
        colIndex: number;
    }) => import("vue/types/vnode").ScopedSlotReturnValue;
    columnController?: unknown;
    displayColumns?: import("..").CheckboxGroupValue;
    defaultDisplayColumns?: import("..").CheckboxGroupValue;
    dragSortOptions?: unknown;
    editableCellState?: import("./type").EditableCellType<import("./type").TableRowData>;
    editableRowKeys?: (string | number)[];
    expandedRow?: (h: import("vue").CreateElement, props: import("./type").TableExpandedRowParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue;
    filterRow?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    defaultFilterValue?: unknown;
    indeterminateSelectedRowKeys?: (string | number)[];
    rowSelectionType?: "multiple" | "single";
    defaultSort?: import("./type").TableSort;
    onAsyncLoadingClick?: (context: {
        status: "loading" | "load-more";
    }) => void;
    onColumnChange?: (context: import("./type").PrimaryTableColumnChange<import("./type").TableRowData>) => void;
    onColumnControllerVisibleChange?: (visible: boolean, context: {
        trigger: "cancel" | "confirm";
    }) => void;
    onDataChange?: (data: import("./type").TableRowData[], context: import("./type").TableDataChangeContext) => void;
    onDisplayColumnsChange?: (value: import("..").CheckboxGroupValue) => void;
    onExpandChange?: (expandedRowKeys: (string | number)[], options: import("./type").ExpandOptions<import("./type").TableRowData>) => void;
    onFilterChange?: (filterValue: import("./type").FilterValue, context: import("./type").TableFilterChangeContext<import("./type").TableRowData>) => void;
    onRowEdit?: (context: import("./type").PrimaryTableRowEditContext<import("./type").TableRowData>) => void;
    onRowValidate?: (context: import("./type").PrimaryTableRowValidateContext<import("./type").TableRowData>) => void;
    onSelectChange?: (selectedRowKeys: (string | number)[], options: import("./type").SelectOptions<import("./type").TableRowData>) => void;
    onSortChange?: (sort: import("./type").TableSort, options: import("./type").SortOptions<import("./type").TableRowData>) => void;
    beforeDragSort?: (context: import("./type").DragSortContext<import("./type").TableRowData>) => boolean;
    treeExpandAndFoldIcon?: (h: import("vue").CreateElement, props: {
        type: "expand" | "fold";
        row: import("./type").TableRowData;
    }) => import("vue/types/vnode").ScopedSlotReturnValue;
    onAbnormalDragSort?: (context: import("./type").TableAbnormalDragSortContext<import("./type").TableRowData>) => void;
    onExpandedTreeNodesChange?: (expandedTreeNodes: (string | number)[], options: import("./type").TableTreeNodeExpandOptions<import("./type").TableRowData>) => void;
    onTreeExpandChange?: (context: import("./type").TableTreeExpandChangeContext<import("./type").TableRowData>) => void;
}, import("@vue/composition-api").ShallowUnwrapRef<{
    scrollToElement: (params: import("..").ComponentScrollToElementParams) => void;
    rowDataKeys: import("@vue/composition-api").ComputedRef<{
        rowKey: string;
        childrenKey: string;
    }>;
    setData: <T>(key: import("./type").TableRowValue, newRowData: T) => void;
    getData: (key: import("./type").TableRowValue) => import("./type").TableRowState<import("./type").TableRowData>;
    remove: (key: import("./type").TableRowValue) => void;
    removeChildren: (key: import("./type").TableRowValue) => void;
    appendTo: <T_1>(key: import("./type").TableRowValue, newData: T_1 | T_1[]) => void;
    insertAfter: <T_2>(rowValue: import("./type").TableRowValue, newData: T_2) => void;
    insertBefore: <T_3>(rowValue: import("./type").TableRowValue, newData: T_3) => void;
    toggleExpandData: (p: {
        row: import("./type").TableRowData;
        rowIndex: number;
    }, trigger?: "expand-fold-icon" | "row-click") => void;
    expandAll: (type?: "default-expand-all" | "expand-all", list?: import("./type").TableRowData[]) => void;
    foldAll: () => void;
    getTreeNode: () => import("../_common/js/table/types").TableRowData[];
    resetData: (data: import("./type").TableRowData[]) => void;
    getTreeExpandedRow: (type?: "all" | "data" | "unique") => any[];
    store: import("@vue/composition-api").Ref<{
        treeDataMap: import("../_common/js/table/tree-store").TableTreeDataMap;
        expandAllRowIndex: 0;
        initialTreeStore: (dataSource: import("../_common/js/table/types").TableRowData[], columns: import("../_common/js/table/types").PlainObject[], keys: import("../_common/js/table/tree-store").KeysType) => void;
        getAllUniqueKeys: (data: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType, arr?: import("../_common/js/table/types").TableRowData[]) => import("../_common/js/table/types").TableRowData[];
        getExpandedChildrenKeys: (data: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType, arr?: (string | number)[]) => (string | number)[];
        expandTreeNode: (rowList: (string | number)[], dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        foldTreeNode: (rowList: (string | number)[], dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        toggleExpandData: (p: {
            rowIndex: number;
            row: import("../_common/js/table/types").TableRowData;
        }, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType, type?: "expand" | "fold") => import("../_common/js/table/types").TableRowData[];
        updateExpandRow: (changeRow: import("../_common/js/table/types").TableRowState<import("../_common/js/table/types").TableRowData>, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        getData: (key: import("../_common/js/table/types").TableRowValue) => import("../_common/js/table/types").TableRowState<import("../_common/js/table/types").TableRowData>;
        updateData: (rowValue: import("../_common/js/table/types").TableRowValue, newRowData: import("../_common/js/table/types").TableRowData, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => number;
        remove: (key: import("../_common/js/table/types").TableRowValue, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        removeChildren: (key: import("../_common/js/table/types").TableRowValue, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        appendTo: (rowValue: string | number, newData: import("../_common/js/table/types").TableRowData | import("../_common/js/table/types").TableRowData[], dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        appendToRoot: (newData: import("../_common/js/table/types").TableRowData | import("../_common/js/table/types").TableRowData[], dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        insertAfter: (rowValue: string | number, newData: import("../_common/js/table/types").TableRowData, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        insertBefore: (rowValue: string | number, newData: import("../_common/js/table/types").TableRowData, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        insert: (rowValue: string | number, newData: import("../_common/js/table/types").TableRowData, dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType, type: "after" | "before") => import("../_common/js/table/types").TableRowData[];
        swapData: (dataSource: import("../_common/js/table/types").TableRowData[], params: import("../_common/js/table/tree-store").SwapParams<import("../_common/js/table/types").TableRowData>, keys: import("../_common/js/table/tree-store").KeysType) => {
            dataSource: import("../_common/js/table/types").TableRowData[];
            result: boolean;
            code?: number;
            reason?: string;
        };
        expandAll: (dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        foldAll: (dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        getTreeNode: (dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType) => import("../_common/js/table/types").TableRowData[];
        getTreeExpandedRow: (dataSource: import("../_common/js/table/types").TableRowData[], keys: import("../_common/js/table/tree-store").KeysType, type?: "all" | "data" | "unique") => any[];
        initialTreeDataMap: (treeDataMap: import("../_common/js/table/tree-store").TableTreeDataMap, dataSource: import("../_common/js/table/types").TableRowData[], column: import("../_common/js/table/types").PlainObject, keys: import("../_common/js/table/tree-store").KeysType, level?: number, parent?: import("../_common/js/table/types").TableRowState<import("../_common/js/table/types").TableRowData>) => void;
        updateDisabledState: (dataSource: import("../_common/js/table/types").TableRowData[], column: import("../_common/js/table/types").PlainObject, keys: import("../_common/js/table/tree-store").KeysType) => void;
        validateDataExist: (state: import("../_common/js/table/types").TableRowState<import("../_common/js/table/types").TableRowData>, rowValue: string | number) => boolean;
        validateDataDoubleExist: (state: import("../_common/js/table/types").TableRowState<import("../_common/js/table/types").TableRowData>, rowValue: string | number) => boolean;
    }>;
    classPrefix: import("@vue/composition-api").ComputedRef<string>;
    dataSource: import("@vue/composition-api").Ref<{
        [x: string]: any;
        children?: any[];
    }[]>;
    tColumns: import("@vue/composition-api").ComputedRef<import("./type").PrimaryTableCol<import("./type").TableRowData>[]>;
    treeDataMap: import("@vue/composition-api").Ref<import("../_common/js/table/tree-store").TableTreeDataMap>;
    tIndeterminateSelectedRowKeys: import("@vue/composition-api").Ref<(string | number)[]>;
    enhancedTableRef: import("@vue/composition-api").Ref<any>;
    primaryTableRef: import("@vue/composition-api").Ref<any>;
    onDragSortChange: (params: import("./type").DragSortContext<import("./type").TableRowData>) => void;
    onInnerSelectChange: (rowKeys: (string | number)[], extraData: import("./type").SelectOptions<import("./type").TableRowData>) => void;
    onEnhancedTableRowClick: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
}>, import("@vue/composition-api").Data, {}, {
    getListener(): import("./base-table").TableListeners;
    getRowClassName({ row }: {
        row: import("./type").TableRowData;
    }): import("..").ClassName[];
}, {}, {}, {}, {
    data: import("./type").TableRowData[];
    columns: import("./type").PrimaryTableCol<import("./type").TableRowData>[];
    tableLayout: "fixed" | "auto";
    verticalAlign: "top" | "bottom" | "middle";
    loading: boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    empty: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    hover: boolean;
    lazyLoad: boolean;
    bordered: boolean;
    showHeader: boolean;
    stripe: boolean;
    activeRowKeys: (string | number)[];
    defaultActiveRowKeys: (string | number)[];
    activeRowType: "multiple" | "single";
    allowResizeColumnWidth: boolean;
    disableDataPage: boolean;
    disableSpaceInactiveRow: boolean;
    footData: import("./type").TableRowData[];
    footerAffixedBottom: boolean;
    headerAffixedTop: boolean;
    keyboardRowHover: boolean;
    resizable: boolean;
    rowKey: string;
    tableContentWidth: string;
    columnControllerVisible: boolean;
    defaultColumnControllerVisible: boolean;
    expandIcon: boolean | ((h: import("vue").CreateElement, props: import("./type").ExpandArrowRenderParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue);
    expandOnRowClick: boolean;
    expandedRowKeys: (string | number)[];
    defaultExpandedRowKeys: (string | number)[];
    hideSortTips: boolean;
    multipleSort: boolean;
    reserveSelectedRowOnPaginate: boolean;
    rowSelectionAllowUncheck: boolean;
    selectOnRowClick: boolean;
    selectedRowKeys: (string | number)[];
    defaultSelectedRowKeys: (string | number)[];
    showSortColumnBgColor: boolean;
    sortOnRowDraggable: boolean;
    expandedTreeNodes: (string | number)[];
    defaultExpandedTreeNodes: (string | number)[];
} & {
    sort?: import("./type").TableSort;
    height?: string | number;
    maxHeight?: string | number;
    scroll?: import("..").TScroll;
    size?: import("..").SizeEnum;
    onChange?: (data: import("./type").TableChangeData, context: import("./type").TableChangeContext<import("./type").TableRowData>) => void;
    attach?: import("..").AttachNode;
    pagination?: unknown;
    tree?: unknown;
    onValidate?: (context: import("./type").PrimaryTableValidateContext) => void;
    onScroll?: (params: {
        e: WheelEvent;
    }) => void;
    onDragSort?: (context: import("./type").DragSortContext<import("./type").TableRowData>) => void;
    dragSort?: "col" | "row" | "row-handler" | "row-handler-col" | "drag-col";
    onCellClick?: (context: import("./type").PrimaryTableCellEventContext<import("./type").TableRowData>) => void;
    onPageChange?: (pageInfo: import("..").PageInfo, newDataSource: import("./type").TableRowData[]) => void;
    filterValue?: unknown;
    loadingProps?: unknown;
    asyncLoading?: "loading" | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue) | "load-more";
    bottomContent?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    cellEmptyContent?: string | ((h: import("vue").CreateElement, props: import("./type").BaseTableCellParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue);
    firstFullRow?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    fixedRows?: number[];
    footerAffixProps?: unknown;
    footerSummary?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    headerAffixProps?: unknown;
    horizontalScrollAffixedBottom?: unknown;
    lastFullRow?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    locale?: unknown;
    paginationAffixedBottom?: unknown;
    rowAttributes?: import("./type").TableRowAttributes<import("./type").TableRowData>;
    rowClassName?: unknown;
    rowspanAndColspan?: import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>;
    rowspanAndColspanInFooter?: import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>;
    topContent?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    onActiveChange?: (activeRowKeys: (string | number)[], context: import("./type").ActiveChangeContext<import("./type").TableRowData>) => void;
    onActiveRowAction?: (context: import("./type").ActiveRowActionContext<import("./type").TableRowData>) => void;
    onColumnResizeChange?: (context: {
        columnsWidth: {
            [colKey: string]: number;
        };
    }) => void;
    onRowClick?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowDblclick?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMousedown?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseenter?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseleave?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseover?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onRowMouseup?: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
    onScrollX?: (params: {
        e: WheelEvent;
    }) => void;
    onScrollY?: (params: {
        e: WheelEvent;
    }) => void;
    sortIcon?: (h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue;
    filterIcon?: (h: import("vue").CreateElement, props: {
        col: import("./type").PrimaryTableCol<import("./type").TableRowData>;
        colIndex: number;
    }) => import("vue/types/vnode").ScopedSlotReturnValue;
    columnController?: unknown;
    displayColumns?: import("..").CheckboxGroupValue;
    defaultDisplayColumns?: import("..").CheckboxGroupValue;
    dragSortOptions?: unknown;
    editableCellState?: import("./type").EditableCellType<import("./type").TableRowData>;
    editableRowKeys?: (string | number)[];
    expandedRow?: (h: import("vue").CreateElement, props: import("./type").TableExpandedRowParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue;
    filterRow?: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    defaultFilterValue?: unknown;
    indeterminateSelectedRowKeys?: (string | number)[];
    rowSelectionType?: "multiple" | "single";
    defaultSort?: import("./type").TableSort;
    onAsyncLoadingClick?: (context: {
        status: "loading" | "load-more";
    }) => void;
    onColumnChange?: (context: import("./type").PrimaryTableColumnChange<import("./type").TableRowData>) => void;
    onColumnControllerVisibleChange?: (visible: boolean, context: {
        trigger: "cancel" | "confirm";
    }) => void;
    onDataChange?: (data: import("./type").TableRowData[], context: import("./type").TableDataChangeContext) => void;
    onDisplayColumnsChange?: (value: import("..").CheckboxGroupValue) => void;
    onExpandChange?: (expandedRowKeys: (string | number)[], options: import("./type").ExpandOptions<import("./type").TableRowData>) => void;
    onFilterChange?: (filterValue: import("./type").FilterValue, context: import("./type").TableFilterChangeContext<import("./type").TableRowData>) => void;
    onRowEdit?: (context: import("./type").PrimaryTableRowEditContext<import("./type").TableRowData>) => void;
    onRowValidate?: (context: import("./type").PrimaryTableRowValidateContext<import("./type").TableRowData>) => void;
    onSelectChange?: (selectedRowKeys: (string | number)[], options: import("./type").SelectOptions<import("./type").TableRowData>) => void;
    onSortChange?: (sort: import("./type").TableSort, options: import("./type").SortOptions<import("./type").TableRowData>) => void;
    beforeDragSort?: (context: import("./type").DragSortContext<import("./type").TableRowData>) => boolean;
    treeExpandAndFoldIcon?: (h: import("vue").CreateElement, props: {
        type: "expand" | "fold";
        row: import("./type").TableRowData;
    }) => import("vue/types/vnode").ScopedSlotReturnValue;
    onAbnormalDragSort?: (context: import("./type").TableAbnormalDragSortContext<import("./type").TableRowData>) => void;
    onExpandedTreeNodesChange?: (expandedTreeNodes: (string | number)[], options: import("./type").TableTreeNodeExpandOptions<import("./type").TableRowData>) => void;
    onTreeExpandChange?: (context: import("./type").TableTreeExpandChangeContext<import("./type").TableRowData>) => void;
}, {
    data: import("./type").TableRowData[];
    columns: import("./type").PrimaryTableCol<import("./type").TableRowData>[];
    tableLayout: "fixed" | "auto";
    verticalAlign: "top" | "bottom" | "middle";
    loading: boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    empty: string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue);
    hover: boolean;
    lazyLoad: boolean;
    bordered: boolean;
    showHeader: boolean;
    stripe: boolean;
    activeRowKeys: (string | number)[];
    defaultActiveRowKeys: (string | number)[];
    activeRowType: "multiple" | "single";
    allowResizeColumnWidth: boolean;
    disableDataPage: boolean;
    disableSpaceInactiveRow: boolean;
    footData: import("./type").TableRowData[];
    footerAffixedBottom: boolean;
    headerAffixedTop: boolean;
    keyboardRowHover: boolean;
    resizable: boolean;
    rowKey: string;
    tableContentWidth: string;
    columnControllerVisible: boolean;
    defaultColumnControllerVisible: boolean;
    expandIcon: boolean | ((h: import("vue").CreateElement, props: import("./type").ExpandArrowRenderParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue);
    expandOnRowClick: boolean;
    expandedRowKeys: (string | number)[];
    defaultExpandedRowKeys: (string | number)[];
    hideSortTips: boolean;
    multipleSort: boolean;
    reserveSelectedRowOnPaginate: boolean;
    rowSelectionAllowUncheck: boolean;
    selectOnRowClick: boolean;
    selectedRowKeys: (string | number)[];
    defaultSelectedRowKeys: (string | number)[];
    showSortColumnBgColor: boolean;
    sortOnRowDraggable: boolean;
    expandedTreeNodes: (string | number)[];
    defaultExpandedTreeNodes: (string | number)[];
}, true>)>;
export declare const Table: {
    name: string;
    data?: import("@vue/composition-api").ShallowUnwrapRef<{
        tColumns: import("@vue/composition-api").ComputedRef<import("./type").PrimaryTableCol<import("./type").TableRowData>[]>;
        showExpandedRow: import("@vue/composition-api").ComputedRef<boolean>;
        tRowClassNames: import("@vue/composition-api").ComputedRef<any[]>;
        hasEmptyCondition: import("@vue/composition-api").ComputedRef<boolean>;
        primaryTableRef: any;
        tRowAttributes: import("@vue/composition-api").ComputedRef<import("./type").TableRowAttributes<import("./type").TableRowData>[]>;
        primaryTableClasses: import("@vue/composition-api").ComputedRef<{
            [x: string]: boolean | (string | number)[] | import("./type").PrimaryTableCol<import("./type").TableRowData>;
        }>;
        errorListMap: import("@vue/composition-api").Ref<{
            [x: string]: ({
                result: boolean;
                message: string;
                type?: "error" | "success" | "warning";
            } | {
                result: boolean;
                boolean?: boolean;
                date?: boolean | {
                    format: string;
                    strictMode: boolean;
                    delimiters: string[];
                };
                email?: boolean | {
                    allow_display_name?: boolean;
                    require_display_name?: boolean;
                    allow_utf8_local_part?: boolean;
                    require_tld?: boolean;
                    ignore_max_length?: boolean;
                    allow_ip_domain?: boolean;
                    domain_specific_validation?: boolean;
                    allow_underscores?: boolean;
                    host_blacklist?: string[];
                    host_whitelist?: string[];
                    blacklisted_chars?: string;
                };
                enum?: string[];
                idcard?: boolean;
                len?: number | boolean;
                max?: number | boolean;
                message?: string;
                min?: number | boolean;
                number?: boolean;
                pattern?: {
                    exec: (string: string) => RegExpExecArray;
                    test: (string: string) => boolean;
                    readonly source: string;
                    readonly global: boolean;
                    readonly ignoreCase: boolean;
                    readonly multiline: boolean;
                    lastIndex: number;
                    compile: (pattern: string, flags?: string) => RegExp;
                    readonly flags: string;
                    readonly sticky: boolean;
                    readonly unicode: boolean;
                    readonly dotAll: boolean;
                    [Symbol.match]: (string: string) => RegExpMatchArray;
                    [Symbol.replace]: {
                        (string: string, replaceValue: string): string;
                        (string: string, replacer: (substring: string, ...args: any[]) => string): string;
                    };
                    [Symbol.search]: (string: string) => number;
                    [Symbol.split]: (string: string, limit?: number) => string[];
                    [Symbol.matchAll]: (str: string) => IterableIterator<RegExpMatchArray>;
                };
                required?: boolean;
                telnumber?: boolean;
                trigger?: "blur" | "change" | "submit" | ("blur" | "change" | "submit")[];
                type?: "error" | "warning";
                url?: boolean | {
                    protocols?: string[];
                    require_tld?: boolean;
                    require_protocol?: boolean;
                    require_host?: boolean;
                    require_port?: boolean;
                    require_valid_protocol?: boolean;
                    allow_underscores?: boolean;
                    host_whitelist?: (string | {
                        exec: (string: string) => RegExpExecArray;
                        test: (string: string) => boolean;
                        readonly source: string;
                        readonly global: boolean;
                        readonly ignoreCase: boolean;
                        readonly multiline: boolean;
                        lastIndex: number;
                        compile: (pattern: string, flags?: string) => RegExp;
                        readonly flags: string;
                        readonly sticky: boolean;
                        readonly unicode: boolean;
                        readonly dotAll: boolean;
                        [Symbol.match]: (string: string) => RegExpMatchArray;
                        [Symbol.replace]: {
                            (string: string, replaceValue: string): string;
                            (string: string, replacer: (substring: string, ...args: any[]) => string): string;
                        };
                        [Symbol.search]: (string: string) => number;
                        [Symbol.split]: (string: string, limit?: number) => string[];
                        [Symbol.matchAll]: (str: string) => IterableIterator<RegExpMatchArray>;
                    })[];
                    host_blacklist?: (string | {
                        exec: (string: string) => RegExpExecArray;
                        test: (string: string) => boolean;
                        readonly source: string;
                        readonly global: boolean;
                        readonly ignoreCase: boolean;
                        readonly multiline: boolean;
                        lastIndex: number;
                        compile: (pattern: string, flags?: string) => RegExp;
                        readonly flags: string;
                        readonly sticky: boolean;
                        readonly unicode: boolean;
                        readonly dotAll: boolean;
                        [Symbol.match]: (string: string) => RegExpMatchArray;
                        [Symbol.replace]: {
                            (string: string, replaceValue: string): string;
                            (string: string, replacer: (substring: string, ...args: any[]) => string): string;
                        };
                        [Symbol.search]: (string: string) => number;
                        [Symbol.split]: (string: string, limit?: number) => string[];
                        [Symbol.matchAll]: (str: string) => IterableIterator<RegExpMatchArray>;
                    })[];
                    allow_trailing_dot?: boolean;
                    allow_protocol_relative_urls?: boolean;
                    disallow_auth?: boolean;
                    allow_fragments?: boolean;
                    allow_query_components?: boolean;
                    validate_length?: boolean;
                    max_allowed_length?: number | false;
                };
                validator?: import("..").CustomValidator;
                whitespace?: boolean;
            })[];
        }>;
        onShowElementChange: (val: boolean) => void;
        scrollToElement: (data: import("..").ComponentScrollToElementParams) => void;
        scrollColumnIntoView: (colKey: string) => void;
        refreshTable: () => void;
        validateRowData: (rowValue: any) => Promise<unknown>;
        validateTableData: () => Promise<unknown>;
        clearValidateData: () => void;
        renderTNode: (name: string, options?: import("../hooks/render-tnode").OptionsType) => any;
        renderColumnController: (h: import("vue").CreateElement) => JSX.Element;
        renderExpandedRow: (h: import("vue").CreateElement, p: import("./type").TableExpandedRowParams<import("./type").TableRowData> & {
            tableWidth: number;
            isWidthOverflow: boolean;
        }) => JSX.Element;
        onInnerExpandRowClick: (p: import("./type").RowEventContext<import("./type").TableRowData>) => void;
        onInnerRowClick: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
        renderFirstFilterRow: (h: import("vue").CreateElement) => JSX.Element;
        renderAsyncLoading: (h: import("vue").CreateElement) => JSX.Element;
        onInnerPageChange: (pageInfo: import("..").PageInfo, newData: import("./type").TableRowData[]) => void;
        setDragSortColumns: (val: import("./type").PrimaryTableCol<import("./type").TableRowData>[]) => void;
        onInnerActiveRowAction: (context: import("./type").ActiveRowActionContext<import("./type").TableRowData>) => void;
        innerKeyboardRowHover: import("@vue/composition-api").ComputedRef<boolean>;
        innerDisableSpaceInactiveRow: import("@vue/composition-api").ComputedRef<boolean>;
    }> & import("@vue/composition-api").Data;
    props?: {
        asyncLoading: {
            type: import("vue").PropType<"loading" | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue) | "load-more">;
        };
        columnController: {
            type: import("vue").PropType<import("./type").TableColumnController>;
        };
        columnControllerVisible: {
            type: BooleanConstructor;
            default: any;
        };
        defaultColumnControllerVisible: {
            type: BooleanConstructor;
            default: any;
        };
        columns: {
            type: import("vue").PropType<import("./type").PrimaryTableCol<import("./type").TableRowData>[]>;
            default: () => import("./type").PrimaryTableCol<import("./type").TableRowData>[];
        };
        displayColumns: {
            type: import("vue").PropType<import("..").CheckboxGroupValue>;
        };
        defaultDisplayColumns: {
            type: import("vue").PropType<import("..").CheckboxGroupValue>;
        };
        dragSort: {
            type: import("vue").PropType<"col" | "row" | "row-handler" | "row-handler-col" | "drag-col">;
            validator(val: "col" | "row" | "row-handler" | "row-handler-col" | "drag-col"): boolean;
        };
        dragSortOptions: {
            type: import("vue").PropType<import("sortablejs").SortableOptions>;
        };
        editableCellState: {
            type: import("vue").PropType<import("./type").EditableCellType<import("./type").TableRowData>>;
        };
        editableRowKeys: {
            type: import("vue").PropType<(string | number)[]>;
        };
        expandIcon: {
            type: import("vue").PropType<boolean | ((h: import("vue").CreateElement, props: import("./type").ExpandArrowRenderParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue)>;
            default: boolean;
        };
        expandOnRowClick: BooleanConstructor;
        expandedRow: {
            type: import("vue").PropType<(h: import("vue").CreateElement, props: import("./type").TableExpandedRowParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue>;
        };
        expandedRowKeys: {
            type: import("vue").PropType<(string | number)[]>;
            default: () => (string | number)[];
        };
        defaultExpandedRowKeys: {
            type: import("vue").PropType<(string | number)[]>;
            default: () => (string | number)[];
        };
        filterIcon: {
            type: import("vue").PropType<(h: import("vue").CreateElement, props: {
                col: import("./type").PrimaryTableCol<import("./type").TableRowData>;
                colIndex: number;
            }) => import("vue/types/vnode").ScopedSlotReturnValue>;
        };
        filterRow: {
            type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        };
        filterValue: {
            type: import("vue").PropType<import("./type").FilterValue>;
        };
        defaultFilterValue: {
            type: import("vue").PropType<import("./type").FilterValue>;
        };
        hideSortTips: BooleanConstructor;
        indeterminateSelectedRowKeys: {
            type: import("vue").PropType<(string | number)[]>;
        };
        multipleSort: BooleanConstructor;
        reserveSelectedRowOnPaginate: {
            type: BooleanConstructor;
            default: boolean;
        };
        rowSelectionAllowUncheck: BooleanConstructor;
        rowSelectionType: {
            type: import("vue").PropType<"multiple" | "single">;
            validator(val: "multiple" | "single"): boolean;
        };
        selectOnRowClick: BooleanConstructor;
        selectedRowKeys: {
            type: import("vue").PropType<(string | number)[]>;
            default: () => (string | number)[];
        };
        defaultSelectedRowKeys: {
            type: import("vue").PropType<(string | number)[]>;
            default: () => (string | number)[];
        };
        showSortColumnBgColor: BooleanConstructor;
        sort: {
            type: import("vue").PropType<import("./type").TableSort>;
        };
        defaultSort: {
            type: import("vue").PropType<import("./type").TableSort>;
        };
        sortIcon: {
            type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
        };
        sortOnRowDraggable: BooleanConstructor;
        onAsyncLoadingClick: import("vue").PropType<(context: {
            status: "loading" | "load-more";
        }) => void>;
        onCellClick: import("vue").PropType<(context: import("./type").PrimaryTableCellEventContext<import("./type").TableRowData>) => void>;
        onChange: import("vue").PropType<(data: import("./type").TableChangeData, context: import("./type").TableChangeContext<import("./type").TableRowData>) => void>;
        onColumnChange: import("vue").PropType<(context: import("./type").PrimaryTableColumnChange<import("./type").TableRowData>) => void>;
        onColumnControllerVisibleChange: import("vue").PropType<(visible: boolean, context: {
            trigger: "cancel" | "confirm";
        }) => void>;
        onDataChange: import("vue").PropType<(data: import("./type").TableRowData[], context: import("./type").TableDataChangeContext) => void>;
        onDisplayColumnsChange: import("vue").PropType<(value: import("..").CheckboxGroupValue) => void>;
        onDragSort: import("vue").PropType<(context: import("./type").DragSortContext<import("./type").TableRowData>) => void>;
        onExpandChange: import("vue").PropType<(expandedRowKeys: (string | number)[], options: import("./type").ExpandOptions<import("./type").TableRowData>) => void>;
        onFilterChange: import("vue").PropType<(filterValue: import("./type").FilterValue, context: import("./type").TableFilterChangeContext<import("./type").TableRowData>) => void>;
        onRowEdit: import("vue").PropType<(context: import("./type").PrimaryTableRowEditContext<import("./type").TableRowData>) => void>;
        onRowValidate: import("vue").PropType<(context: import("./type").PrimaryTableRowValidateContext<import("./type").TableRowData>) => void>;
        onSelectChange: import("vue").PropType<(selectedRowKeys: (string | number)[], options: import("./type").SelectOptions<import("./type").TableRowData>) => void>;
        onSortChange: import("vue").PropType<(sort: import("./type").TableSort, options: import("./type").SortOptions<import("./type").TableRowData>) => void>;
        onValidate: import("vue").PropType<(context: import("./type").PrimaryTableValidateContext) => void>;
        activeRowKeys: {
            type: import("vue").PropType<(string | number)[]>;
            default: () => (string | number)[];
        };
        defaultActiveRowKeys: {
            type: import("vue").PropType<(string | number)[]>;
            default: () => (string | number)[];
        };
        activeRowType: {
            type: import("vue").PropType<"multiple" | "single">;
            default: string;
        };
        allowResizeColumnWidth: {
            type: BooleanConstructor;
            default: any;
        };
        attach: {
            type: import("vue").PropType<import("..").AttachNode>;
        };
        bordered: BooleanConstructor;
        bottomContent: {
            type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        };
        cellEmptyContent: {
            type: import("vue").PropType<string | ((h: import("vue").CreateElement, props: import("./type").BaseTableCellParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        };
        data: {
            type: import("vue").PropType<import("./type").TableRowData[]>;
            default: () => import("./type").TableRowData[];
        };
        disableDataPage: BooleanConstructor;
        disableSpaceInactiveRow: {
            type: BooleanConstructor;
            default: any;
        };
        empty: {
            type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
            default: string;
        };
        firstFullRow: {
            type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        };
        fixedRows: {
            type: import("vue").PropType<number[]>;
        };
        footData: {
            type: import("vue").PropType<import("./type").TableRowData[]>;
            default: () => import("./type").TableRowData[];
        };
        footerAffixProps: {
            type: import("vue").PropType<Partial<import("..").TdAffixProps>>;
        };
        footerAffixedBottom: {
            type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
            default: boolean;
        };
        footerSummary: {
            type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        };
        headerAffixProps: {
            type: import("vue").PropType<Partial<import("..").TdAffixProps>>;
        };
        headerAffixedTop: {
            type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
            default: boolean;
        };
        height: {
            type: import("vue").PropType<string | number>;
        };
        horizontalScrollAffixedBottom: {
            type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
        };
        hover: BooleanConstructor;
        keyboardRowHover: {
            type: BooleanConstructor;
            default: boolean;
        };
        lastFullRow: {
            type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        };
        lazyLoad: BooleanConstructor;
        loading: {
            type: import("vue").PropType<boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
            default: any;
        };
        loadingProps: {
            type: import("vue").PropType<Partial<import("..").TdLoadingProps>>;
        };
        locale: {
            type: import("vue").PropType<import("..").TableConfig>;
        };
        maxHeight: {
            type: import("vue").PropType<string | number>;
        };
        pagination: {
            type: import("vue").PropType<import("..").TdPaginationProps>;
        };
        paginationAffixedBottom: {
            type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
        };
        resizable: BooleanConstructor;
        rowAttributes: {
            type: import("vue").PropType<import("./type").TableRowAttributes<import("./type").TableRowData>>;
        };
        rowClassName: {
            type: import("vue").PropType<import("..").ClassName | ((params: import("./type").RowClassNameParams<import("./type").TableRowData>) => import("..").ClassName)>;
        };
        rowKey: {
            type: StringConstructor;
            default: string;
            required: boolean;
        };
        rowspanAndColspan: {
            type: import("vue").PropType<import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>>;
        };
        rowspanAndColspanInFooter: {
            type: import("vue").PropType<import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>>;
        };
        scroll: {
            type: import("vue").PropType<import("..").TScroll>;
        };
        showHeader: {
            type: BooleanConstructor;
            default: boolean;
        };
        size: {
            type: import("vue").PropType<import("..").SizeEnum>;
            validator(val: import("..").SizeEnum): boolean;
        };
        stripe: BooleanConstructor;
        tableContentWidth: {
            type: StringConstructor;
            default: string;
        };
        tableLayout: {
            type: import("vue").PropType<"fixed" | "auto">;
            default: "fixed" | "auto";
            validator(val: "fixed" | "auto"): boolean;
        };
        topContent: {
            type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        };
        verticalAlign: {
            type: import("vue").PropType<"top" | "bottom" | "middle">;
            default: "top" | "bottom" | "middle";
            validator(val: "top" | "bottom" | "middle"): boolean;
        };
        onActiveChange: import("vue").PropType<(activeRowKeys: (string | number)[], context: import("./type").ActiveChangeContext<import("./type").TableRowData>) => void>;
        onActiveRowAction: import("vue").PropType<(context: import("./type").ActiveRowActionContext<import("./type").TableRowData>) => void>;
        onColumnResizeChange: import("vue").PropType<(context: {
            columnsWidth: {
                [colKey: string]: number;
            };
        }) => void>;
        onPageChange: import("vue").PropType<(pageInfo: import("..").PageInfo, newDataSource: import("./type").TableRowData[]) => void>;
        onRowClick: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
        onRowDblclick: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
        onRowMousedown: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
        onRowMouseenter: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
        onRowMouseleave: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
        onRowMouseover: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
        onRowMouseup: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
        onScroll: import("vue").PropType<(params: {
            e: WheelEvent;
        }) => void>;
        onScrollX: import("vue").PropType<(params: {
            e: WheelEvent;
        }) => void>;
        onScrollY: import("vue").PropType<(params: {
            e: WheelEvent;
        }) => void>;
    };
    propsData?: object;
    computed?: import("vue/types/options").Accessors<{}>;
    methods?: {
        getListener(): import("./base-table").TableListeners;
        formatNode(api: string, renderInnerNode: Function, condition: boolean, extra?: {
            reverse?: boolean;
        }): unknown;
    };
    watch?: Record<string, import("vue").WatchOptionsWithHandler<any> | import("vue").WatchHandler<any>>;
    el?: string | Element;
    template?: string;
    render?(createElement: import("vue").CreateElement, hack: import("vue").RenderContext<import("@vue/composition-api").ExtractPropTypes<{
        asyncLoading: {
            type: import("vue").PropType<"loading" | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue) | "load-more">;
        };
        columnController: {
            type: import("vue").PropType<import("./type").TableColumnController>;
        };
        columnControllerVisible: {
            type: BooleanConstructor;
            default: any;
        };
        defaultColumnControllerVisible: {
            type: BooleanConstructor;
            default: any;
        };
        columns: {
            type: import("vue").PropType<import("./type").PrimaryTableCol<import("./type").TableRowData>[]>;
            default: () => import("./type").PrimaryTableCol<import("./type").TableRowData>[];
        };
        displayColumns: {
            type: import("vue").PropType<import("..").CheckboxGroupValue>;
        };
        defaultDisplayColumns: {
            type: import("vue").PropType<import("..").CheckboxGroupValue>;
        };
        dragSort: {
            type: import("vue").PropType<"col" | "row" | "row-handler" | "row-handler-col" | "drag-col">;
            validator(val: "col" | "row" | "row-handler" | "row-handler-col" | "drag-col"): boolean;
        };
        dragSortOptions: {
            type: import("vue").PropType<import("sortablejs").SortableOptions>;
        };
        editableCellState: {
            type: import("vue").PropType<import("./type").EditableCellType<import("./type").TableRowData>>;
        };
        editableRowKeys: {
            type: import("vue").PropType<(string | number)[]>;
        };
        expandIcon: {
            type: import("vue").PropType<boolean | ((h: import("vue").CreateElement, props: import("./type").ExpandArrowRenderParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue)>;
            default: boolean;
        };
        expandOnRowClick: BooleanConstructor;
        expandedRow: {
            type: import("vue").PropType<(h: import("vue").CreateElement, props: import("./type").TableExpandedRowParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue>;
        };
        expandedRowKeys: {
            type: import("vue").PropType<(string | number)[]>;
            default: () => (string | number)[];
        };
        defaultExpandedRowKeys: {
            type: import("vue").PropType<(string | number)[]>;
            default: () => (string | number)[];
        };
        filterIcon: {
            type: import("vue").PropType<(h: import("vue").CreateElement, props: {
                col: import("./type").PrimaryTableCol<import("./type").TableRowData>;
                colIndex: number;
            }) => import("vue/types/vnode").ScopedSlotReturnValue>;
        };
        filterRow: {
            type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        };
        filterValue: {
            type: import("vue").PropType<import("./type").FilterValue>;
        };
        defaultFilterValue: {
            type: import("vue").PropType<import("./type").FilterValue>;
        };
        hideSortTips: BooleanConstructor;
        indeterminateSelectedRowKeys: {
            type: import("vue").PropType<(string | number)[]>;
        };
        multipleSort: BooleanConstructor;
        reserveSelectedRowOnPaginate: {
            type: BooleanConstructor;
            default: boolean;
        };
        rowSelectionAllowUncheck: BooleanConstructor;
        rowSelectionType: {
            type: import("vue").PropType<"multiple" | "single">;
            validator(val: "multiple" | "single"): boolean;
        };
        selectOnRowClick: BooleanConstructor;
        selectedRowKeys: {
            type: import("vue").PropType<(string | number)[]>;
            default: () => (string | number)[];
        };
        defaultSelectedRowKeys: {
            type: import("vue").PropType<(string | number)[]>;
            default: () => (string | number)[];
        };
        showSortColumnBgColor: BooleanConstructor;
        sort: {
            type: import("vue").PropType<import("./type").TableSort>;
        };
        defaultSort: {
            type: import("vue").PropType<import("./type").TableSort>;
        };
        sortIcon: {
            type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
        };
        sortOnRowDraggable: BooleanConstructor;
        onAsyncLoadingClick: import("vue").PropType<(context: {
            status: "loading" | "load-more";
        }) => void>;
        onCellClick: import("vue").PropType<(context: import("./type").PrimaryTableCellEventContext<import("./type").TableRowData>) => void>;
        onChange: import("vue").PropType<(data: import("./type").TableChangeData, context: import("./type").TableChangeContext<import("./type").TableRowData>) => void>;
        onColumnChange: import("vue").PropType<(context: import("./type").PrimaryTableColumnChange<import("./type").TableRowData>) => void>;
        onColumnControllerVisibleChange: import("vue").PropType<(visible: boolean, context: {
            trigger: "cancel" | "confirm";
        }) => void>;
        onDataChange: import("vue").PropType<(data: import("./type").TableRowData[], context: import("./type").TableDataChangeContext) => void>;
        onDisplayColumnsChange: import("vue").PropType<(value: import("..").CheckboxGroupValue) => void>;
        onDragSort: import("vue").PropType<(context: import("./type").DragSortContext<import("./type").TableRowData>) => void>;
        onExpandChange: import("vue").PropType<(expandedRowKeys: (string | number)[], options: import("./type").ExpandOptions<import("./type").TableRowData>) => void>;
        onFilterChange: import("vue").PropType<(filterValue: import("./type").FilterValue, context: import("./type").TableFilterChangeContext<import("./type").TableRowData>) => void>;
        onRowEdit: import("vue").PropType<(context: import("./type").PrimaryTableRowEditContext<import("./type").TableRowData>) => void>;
        onRowValidate: import("vue").PropType<(context: import("./type").PrimaryTableRowValidateContext<import("./type").TableRowData>) => void>;
        onSelectChange: import("vue").PropType<(selectedRowKeys: (string | number)[], options: import("./type").SelectOptions<import("./type").TableRowData>) => void>;
        onSortChange: import("vue").PropType<(sort: import("./type").TableSort, options: import("./type").SortOptions<import("./type").TableRowData>) => void>;
        onValidate: import("vue").PropType<(context: import("./type").PrimaryTableValidateContext) => void>;
        activeRowKeys: {
            type: import("vue").PropType<(string | number)[]>;
            default: () => (string | number)[];
        };
        defaultActiveRowKeys: {
            type: import("vue").PropType<(string | number)[]>;
            default: () => (string | number)[];
        };
        activeRowType: {
            type: import("vue").PropType<"multiple" | "single">;
            default: string;
        };
        allowResizeColumnWidth: {
            type: BooleanConstructor;
            default: any;
        };
        attach: {
            type: import("vue").PropType<import("..").AttachNode>;
        };
        bordered: BooleanConstructor;
        bottomContent: {
            type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        };
        cellEmptyContent: {
            type: import("vue").PropType<string | ((h: import("vue").CreateElement, props: import("./type").BaseTableCellParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        };
        data: {
            type: import("vue").PropType<import("./type").TableRowData[]>;
            default: () => import("./type").TableRowData[];
        };
        disableDataPage: BooleanConstructor;
        disableSpaceInactiveRow: {
            type: BooleanConstructor;
            default: any;
        };
        empty: {
            type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
            default: string;
        };
        firstFullRow: {
            type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        };
        fixedRows: {
            type: import("vue").PropType<number[]>;
        };
        footData: {
            type: import("vue").PropType<import("./type").TableRowData[]>;
            default: () => import("./type").TableRowData[];
        };
        footerAffixProps: {
            type: import("vue").PropType<Partial<import("..").TdAffixProps>>;
        };
        footerAffixedBottom: {
            type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
            default: boolean;
        };
        footerSummary: {
            type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        };
        headerAffixProps: {
            type: import("vue").PropType<Partial<import("..").TdAffixProps>>;
        };
        headerAffixedTop: {
            type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
            default: boolean;
        };
        height: {
            type: import("vue").PropType<string | number>;
        };
        horizontalScrollAffixedBottom: {
            type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
        };
        hover: BooleanConstructor;
        keyboardRowHover: {
            type: BooleanConstructor;
            default: boolean;
        };
        lastFullRow: {
            type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        };
        lazyLoad: BooleanConstructor;
        loading: {
            type: import("vue").PropType<boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
            default: any;
        };
        loadingProps: {
            type: import("vue").PropType<Partial<import("..").TdLoadingProps>>;
        };
        locale: {
            type: import("vue").PropType<import("..").TableConfig>;
        };
        maxHeight: {
            type: import("vue").PropType<string | number>;
        };
        pagination: {
            type: import("vue").PropType<import("..").TdPaginationProps>;
        };
        paginationAffixedBottom: {
            type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
        };
        resizable: BooleanConstructor;
        rowAttributes: {
            type: import("vue").PropType<import("./type").TableRowAttributes<import("./type").TableRowData>>;
        };
        rowClassName: {
            type: import("vue").PropType<import("..").ClassName | ((params: import("./type").RowClassNameParams<import("./type").TableRowData>) => import("..").ClassName)>;
        };
        rowKey: {
            type: StringConstructor;
            default: string;
            required: boolean;
        };
        rowspanAndColspan: {
            type: import("vue").PropType<import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>>;
        };
        rowspanAndColspanInFooter: {
            type: import("vue").PropType<import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>>;
        };
        scroll: {
            type: import("vue").PropType<import("..").TScroll>;
        };
        showHeader: {
            type: BooleanConstructor;
            default: boolean;
        };
        size: {
            type: import("vue").PropType<import("..").SizeEnum>;
            validator(val: import("..").SizeEnum): boolean;
        };
        stripe: BooleanConstructor;
        tableContentWidth: {
            type: StringConstructor;
            default: string;
        };
        tableLayout: {
            type: import("vue").PropType<"fixed" | "auto">;
            default: "fixed" | "auto";
            validator(val: "fixed" | "auto"): boolean;
        };
        topContent: {
            type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        };
        verticalAlign: {
            type: import("vue").PropType<"top" | "bottom" | "middle">;
            default: "top" | "bottom" | "middle";
            validator(val: "top" | "bottom" | "middle"): boolean;
        };
        onActiveChange: import("vue").PropType<(activeRowKeys: (string | number)[], context: import("./type").ActiveChangeContext<import("./type").TableRowData>) => void>;
        onActiveRowAction: import("vue").PropType<(context: import("./type").ActiveRowActionContext<import("./type").TableRowData>) => void>;
        onColumnResizeChange: import("vue").PropType<(context: {
            columnsWidth: {
                [colKey: string]: number;
            };
        }) => void>;
        onPageChange: import("vue").PropType<(pageInfo: import("..").PageInfo, newDataSource: import("./type").TableRowData[]) => void>;
        onRowClick: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
        onRowDblclick: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
        onRowMousedown: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
        onRowMouseenter: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
        onRowMouseleave: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
        onRowMouseover: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
        onRowMouseup: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
        onScroll: import("vue").PropType<(params: {
            e: WheelEvent;
        }) => void>;
        onScrollX: import("vue").PropType<(params: {
            e: WheelEvent;
        }) => void>;
        onScrollY: import("vue").PropType<(params: {
            e: WheelEvent;
        }) => void>;
    }>>): import("vue").VNode;
    renderError?(createElement: import("vue").CreateElement, err: Error): import("vue").VNode;
    staticRenderFns?: ((createElement: import("vue").CreateElement) => import("vue").VNode)[];
    beforeCreate?(this: import("vue").default): void;
    created?(): void;
    beforeDestroy?(): void;
    destroyed?(): void;
    beforeMount?(): void;
    mounted?(): void;
    beforeUpdate?(): void;
    updated?(): void;
    activated?(): void;
    deactivated?(): void;
    errorCaptured?(err: Error, vm: import("vue").default, info: string): boolean | void;
    serverPrefetch?(this: import("vue").default): Promise<void>;
    directives?: {
        [key: string]: import("vue").DirectiveFunction | import("vue").DirectiveOptions;
    };
    components?: {
        [key: string]: import("vue").Component<any, any, any, any> | import("vue").AsyncComponent<any, any, any, any>;
    };
    transitions?: {
        [key: string]: object;
    };
    filters?: {
        [key: string]: Function;
    };
    provide?: object | (() => object);
    inject?: import("vue/types/options").InjectOptions;
    model?: {
        prop?: string;
        event?: string;
    };
    parent?: import("vue").default;
    mixins?: (import("vue").VueConstructor<import("vue").default> | import("vue").ComponentOptions<import("vue").default, import("vue/types/options").DefaultData<import("vue").default>, import("vue/types/options").DefaultMethods<import("vue").default>, import("vue/types/options").DefaultComputed, import("vue/types/options").PropsDefinition<import("vue/types/options").DefaultProps>, import("vue/types/options").DefaultProps>)[];
    extends?: import("vue").VueConstructor<import("vue").default> | import("vue").ComponentOptions<import("vue").default, import("vue/types/options").DefaultData<import("vue").default>, import("vue/types/options").DefaultMethods<import("vue").default>, import("vue/types/options").DefaultComputed, import("vue/types/options").PropsDefinition<import("vue/types/options").DefaultProps>, import("vue/types/options").DefaultProps>;
    delimiters?: [string, string];
    comments?: boolean;
    inheritAttrs?: boolean;
    setup?: import("@vue/composition-api").SetupFunction<import("@vue/composition-api").Data, import("@vue/composition-api").Data, {}>;
    filter: (id: string, definition?: Function) => Function;
    set: {
        <T>(object: object, key: string | number, value: T): T;
        <T_1>(array: T_1[], key: number, value: T_1): T_1;
    };
    use: {
        <T_2>(plugin: import("vue").PluginObject<T_2> | import("vue").PluginFunction<T_2>, options?: T_2): import("vue").VueConstructor<import("vue").default>;
        (plugin: import("vue").PluginObject<any> | import("vue").PluginFunction<any>, ...options: any[]): import("vue").VueConstructor<import("vue").default>;
    };
    extend: {
        <Data, Methods, Computed, PropNames extends string = never>(options?: import("vue/types/options").ThisTypedComponentOptionsWithArrayProps<import("vue").default, Data, Methods, Computed, PropNames>): import("vue/types/vue").ExtendedVue<import("vue").default, Data, Methods, Computed, Record<PropNames, any>>;
        <Data_1, Methods_1, Computed_1, Props>(options?: import("vue/types/options").ThisTypedComponentOptionsWithRecordProps<import("vue").default, Data_1, Methods_1, Computed_1, Props>): import("vue/types/vue").ExtendedVue<import("vue").default, Data_1, Methods_1, Computed_1, Props>;
        <PropNames_1 extends string = never>(definition: import("vue").FunctionalComponentOptions<Record<PropNames_1, any>, PropNames_1[]>): import("vue/types/vue").ExtendedVue<import("vue").default, {}, {}, {}, Record<PropNames_1, any>>;
        <Props_1>(definition: import("vue").FunctionalComponentOptions<Props_1, import("vue/types/options").RecordPropsDefinition<Props_1>>): import("vue/types/vue").ExtendedVue<import("vue").default, {}, {}, {}, Props_1>;
        (options?: import("vue").ComponentOptions<import("vue").default, import("vue/types/options").DefaultData<import("vue").default>, import("vue/types/options").DefaultMethods<import("vue").default>, import("vue/types/options").DefaultComputed, import("vue/types/options").PropsDefinition<import("vue/types/options").DefaultProps>, import("vue/types/options").DefaultProps>): import("vue/types/vue").ExtendedVue<import("vue").default, {}, {}, {}, {}>;
    };
    nextTick: {
        <T_3>(callback: (this: T_3) => void, context?: T_3): void;
        (): Promise<void>;
    };
    delete: {
        (object: object, key: string | number): void;
        <T_4>(array: T_4[], key: number): void;
    };
    directive: (id: string, definition?: import("vue").DirectiveFunction | import("vue").DirectiveOptions) => import("vue").DirectiveOptions;
    component: {
        (id: string): import("vue").VueConstructor<import("vue").default>;
        <VC extends import("vue").VueConstructor<import("vue").default>>(id: string, constructor: VC): VC;
        <Data_2, Methods_2, Computed_2, Props_2>(id: string, definition: import("vue").AsyncComponent<Data_2, Methods_2, Computed_2, Props_2>): import("vue/types/vue").ExtendedVue<import("vue").default, Data_2, Methods_2, Computed_2, Props_2>;
        <Data_3, Methods_3, Computed_3, PropNames_2 extends string = never>(id: string, definition?: import("vue/types/options").ThisTypedComponentOptionsWithArrayProps<import("vue").default, Data_3, Methods_3, Computed_3, PropNames_2>): import("vue/types/vue").ExtendedVue<import("vue").default, Data_3, Methods_3, Computed_3, Record<PropNames_2, any>>;
        <Data_4, Methods_4, Computed_4, Props_3>(id: string, definition?: import("vue/types/options").ThisTypedComponentOptionsWithRecordProps<import("vue").default, Data_4, Methods_4, Computed_4, Props_3>): import("vue/types/vue").ExtendedVue<import("vue").default, Data_4, Methods_4, Computed_4, Props_3>;
        <PropNames_3 extends string>(id: string, definition: import("vue").FunctionalComponentOptions<Record<PropNames_3, any>, PropNames_3[]>): import("vue/types/vue").ExtendedVue<import("vue").default, {}, {}, {}, Record<PropNames_3, any>>;
        <Props_4>(id: string, definition: import("vue").FunctionalComponentOptions<Props_4, import("vue/types/options").RecordPropsDefinition<Props_4>>): import("vue/types/vue").ExtendedVue<import("vue").default, {}, {}, {}, Props_4>;
        (id: string, definition?: import("vue").ComponentOptions<import("vue").default, import("vue/types/options").DefaultData<import("vue").default>, import("vue/types/options").DefaultMethods<import("vue").default>, import("vue/types/options").DefaultComputed, import("vue/types/options").PropsDefinition<import("vue/types/options").DefaultProps>, import("vue/types/options").DefaultProps>): import("vue/types/vue").ExtendedVue<import("vue").default, {}, {}, {}, {}>;
    };
    mixin: (mixin: import("vue").VueConstructor<import("vue").default> | import("vue").ComponentOptions<import("vue").default, import("vue/types/options").DefaultData<import("vue").default>, import("vue/types/options").DefaultMethods<import("vue").default>, import("vue/types/options").DefaultComputed, import("vue/types/options").PropsDefinition<import("vue/types/options").DefaultProps>, import("vue/types/options").DefaultProps>) => import("vue").VueConstructor<import("vue").default>;
    compile: (template: string) => {
        render(createElement: any): import("vue").VNode;
        staticRenderFns: (() => import("vue").VNode)[];
    };
    observable: <T_5>(obj: T_5) => T_5;
    util: {
        warn(msg: string, vm?: import("vue/types/vue").CombinedVueInstance<import("vue").default, object, object, object, Record<never, any>>): void;
    };
    config: import("vue/types/vue").VueConfiguration;
    version: string;
    _installedPlugins: import("vue").PluginObject<any>[];
} & import("vue").PluginObject<{
    name: string;
    data?: import("@vue/composition-api").ShallowUnwrapRef<{
        tColumns: import("@vue/composition-api").ComputedRef<import("./type").PrimaryTableCol<import("./type").TableRowData>[]>;
        showExpandedRow: import("@vue/composition-api").ComputedRef<boolean>;
        tRowClassNames: import("@vue/composition-api").ComputedRef<any[]>;
        hasEmptyCondition: import("@vue/composition-api").ComputedRef<boolean>;
        primaryTableRef: any;
        tRowAttributes: import("@vue/composition-api").ComputedRef<import("./type").TableRowAttributes<import("./type").TableRowData>[]>;
        primaryTableClasses: import("@vue/composition-api").ComputedRef<{
            [x: string]: boolean | (string | number)[] | import("./type").PrimaryTableCol<import("./type").TableRowData>;
        }>;
        errorListMap: import("@vue/composition-api").Ref<{
            [x: string]: ({
                result: boolean;
                message: string;
                type?: "error" | "success" | "warning";
            } | {
                result: boolean;
                boolean?: boolean;
                date?: boolean | {
                    format: string;
                    strictMode: boolean;
                    delimiters: string[];
                };
                email?: boolean | {
                    allow_display_name?: boolean;
                    require_display_name?: boolean;
                    allow_utf8_local_part?: boolean;
                    require_tld?: boolean;
                    ignore_max_length?: boolean;
                    allow_ip_domain?: boolean;
                    domain_specific_validation?: boolean;
                    allow_underscores?: boolean;
                    host_blacklist?: string[];
                    host_whitelist?: string[];
                    blacklisted_chars?: string;
                };
                enum?: string[];
                idcard?: boolean;
                len?: number | boolean;
                max?: number | boolean;
                message?: string;
                min?: number | boolean;
                number?: boolean;
                pattern?: {
                    exec: (string: string) => RegExpExecArray;
                    test: (string: string) => boolean;
                    readonly source: string;
                    readonly global: boolean;
                    readonly ignoreCase: boolean;
                    readonly multiline: boolean;
                    lastIndex: number;
                    compile: (pattern: string, flags?: string) => RegExp;
                    readonly flags: string;
                    readonly sticky: boolean;
                    readonly unicode: boolean;
                    readonly dotAll: boolean;
                    [Symbol.match]: (string: string) => RegExpMatchArray;
                    [Symbol.replace]: {
                        (string: string, replaceValue: string): string;
                        (string: string, replacer: (substring: string, ...args: any[]) => string): string;
                    };
                    [Symbol.search]: (string: string) => number;
                    [Symbol.split]: (string: string, limit?: number) => string[];
                    [Symbol.matchAll]: (str: string) => IterableIterator<RegExpMatchArray>;
                };
                required?: boolean;
                telnumber?: boolean;
                trigger?: "blur" | "change" | "submit" | ("blur" | "change" | "submit")[];
                type?: "error" | "warning";
                url?: boolean | {
                    protocols?: string[];
                    require_tld?: boolean;
                    require_protocol?: boolean;
                    require_host?: boolean;
                    require_port?: boolean;
                    require_valid_protocol?: boolean;
                    allow_underscores?: boolean;
                    host_whitelist?: (string | {
                        exec: (string: string) => RegExpExecArray;
                        test: (string: string) => boolean;
                        readonly source: string;
                        readonly global: boolean;
                        readonly ignoreCase: boolean;
                        readonly multiline: boolean;
                        lastIndex: number;
                        compile: (pattern: string, flags?: string) => RegExp;
                        readonly flags: string;
                        readonly sticky: boolean;
                        readonly unicode: boolean;
                        readonly dotAll: boolean;
                        [Symbol.match]: (string: string) => RegExpMatchArray;
                        [Symbol.replace]: {
                            (string: string, replaceValue: string): string;
                            (string: string, replacer: (substring: string, ...args: any[]) => string): string;
                        };
                        [Symbol.search]: (string: string) => number;
                        [Symbol.split]: (string: string, limit?: number) => string[];
                        [Symbol.matchAll]: (str: string) => IterableIterator<RegExpMatchArray>;
                    })[];
                    host_blacklist?: (string | {
                        exec: (string: string) => RegExpExecArray;
                        test: (string: string) => boolean;
                        readonly source: string;
                        readonly global: boolean;
                        readonly ignoreCase: boolean;
                        readonly multiline: boolean;
                        lastIndex: number;
                        compile: (pattern: string, flags?: string) => RegExp;
                        readonly flags: string;
                        readonly sticky: boolean;
                        readonly unicode: boolean;
                        readonly dotAll: boolean;
                        [Symbol.match]: (string: string) => RegExpMatchArray;
                        [Symbol.replace]: {
                            (string: string, replaceValue: string): string;
                            (string: string, replacer: (substring: string, ...args: any[]) => string): string;
                        };
                        [Symbol.search]: (string: string) => number;
                        [Symbol.split]: (string: string, limit?: number) => string[];
                        [Symbol.matchAll]: (str: string) => IterableIterator<RegExpMatchArray>;
                    })[];
                    allow_trailing_dot?: boolean;
                    allow_protocol_relative_urls?: boolean;
                    disallow_auth?: boolean;
                    allow_fragments?: boolean;
                    allow_query_components?: boolean;
                    validate_length?: boolean;
                    max_allowed_length?: number | false;
                };
                validator?: import("..").CustomValidator;
                whitespace?: boolean;
            })[];
        }>;
        onShowElementChange: (val: boolean) => void;
        scrollToElement: (data: import("..").ComponentScrollToElementParams) => void;
        scrollColumnIntoView: (colKey: string) => void;
        refreshTable: () => void;
        validateRowData: (rowValue: any) => Promise<unknown>;
        validateTableData: () => Promise<unknown>;
        clearValidateData: () => void;
        renderTNode: (name: string, options?: import("../hooks/render-tnode").OptionsType) => any;
        renderColumnController: (h: import("vue").CreateElement) => JSX.Element;
        renderExpandedRow: (h: import("vue").CreateElement, p: import("./type").TableExpandedRowParams<import("./type").TableRowData> & {
            tableWidth: number;
            isWidthOverflow: boolean;
        }) => JSX.Element;
        onInnerExpandRowClick: (p: import("./type").RowEventContext<import("./type").TableRowData>) => void;
        onInnerRowClick: (context: import("./type").RowEventContext<import("./type").TableRowData>) => void;
        renderFirstFilterRow: (h: import("vue").CreateElement) => JSX.Element;
        renderAsyncLoading: (h: import("vue").CreateElement) => JSX.Element;
        onInnerPageChange: (pageInfo: import("..").PageInfo, newData: import("./type").TableRowData[]) => void;
        setDragSortColumns: (val: import("./type").PrimaryTableCol<import("./type").TableRowData>[]) => void;
        onInnerActiveRowAction: (context: import("./type").ActiveRowActionContext<import("./type").TableRowData>) => void;
        innerKeyboardRowHover: import("@vue/composition-api").ComputedRef<boolean>;
        innerDisableSpaceInactiveRow: import("@vue/composition-api").ComputedRef<boolean>;
    }> & import("@vue/composition-api").Data;
    props?: {
        asyncLoading: {
            type: import("vue").PropType<"loading" | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue) | "load-more">;
        };
        columnController: {
            type: import("vue").PropType<import("./type").TableColumnController>;
        };
        columnControllerVisible: {
            type: BooleanConstructor;
            default: any;
        };
        defaultColumnControllerVisible: {
            type: BooleanConstructor;
            default: any;
        };
        columns: {
            type: import("vue").PropType<import("./type").PrimaryTableCol<import("./type").TableRowData>[]>;
            default: () => import("./type").PrimaryTableCol<import("./type").TableRowData>[];
        };
        displayColumns: {
            type: import("vue").PropType<import("..").CheckboxGroupValue>;
        };
        defaultDisplayColumns: {
            type: import("vue").PropType<import("..").CheckboxGroupValue>;
        };
        dragSort: {
            type: import("vue").PropType<"col" | "row" | "row-handler" | "row-handler-col" | "drag-col">;
            validator(val: "col" | "row" | "row-handler" | "row-handler-col" | "drag-col"): boolean;
        };
        dragSortOptions: {
            type: import("vue").PropType<import("sortablejs").SortableOptions>;
        };
        editableCellState: {
            type: import("vue").PropType<import("./type").EditableCellType<import("./type").TableRowData>>;
        };
        editableRowKeys: {
            type: import("vue").PropType<(string | number)[]>;
        };
        expandIcon: {
            type: import("vue").PropType<boolean | ((h: import("vue").CreateElement, props: import("./type").ExpandArrowRenderParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue)>;
            default: boolean;
        };
        expandOnRowClick: BooleanConstructor;
        expandedRow: {
            type: import("vue").PropType<(h: import("vue").CreateElement, props: import("./type").TableExpandedRowParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue>;
        };
        expandedRowKeys: {
            type: import("vue").PropType<(string | number)[]>;
            default: () => (string | number)[];
        };
        defaultExpandedRowKeys: {
            type: import("vue").PropType<(string | number)[]>;
            default: () => (string | number)[];
        };
        filterIcon: {
            type: import("vue").PropType<(h: import("vue").CreateElement, props: {
                col: import("./type").PrimaryTableCol<import("./type").TableRowData>;
                colIndex: number;
            }) => import("vue/types/vnode").ScopedSlotReturnValue>;
        };
        filterRow: {
            type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        };
        filterValue: {
            type: import("vue").PropType<import("./type").FilterValue>;
        };
        defaultFilterValue: {
            type: import("vue").PropType<import("./type").FilterValue>;
        };
        hideSortTips: BooleanConstructor;
        indeterminateSelectedRowKeys: {
            type: import("vue").PropType<(string | number)[]>;
        };
        multipleSort: BooleanConstructor;
        reserveSelectedRowOnPaginate: {
            type: BooleanConstructor;
            default: boolean;
        };
        rowSelectionAllowUncheck: BooleanConstructor;
        rowSelectionType: {
            type: import("vue").PropType<"multiple" | "single">;
            validator(val: "multiple" | "single"): boolean;
        };
        selectOnRowClick: BooleanConstructor;
        selectedRowKeys: {
            type: import("vue").PropType<(string | number)[]>;
            default: () => (string | number)[];
        };
        defaultSelectedRowKeys: {
            type: import("vue").PropType<(string | number)[]>;
            default: () => (string | number)[];
        };
        showSortColumnBgColor: BooleanConstructor;
        sort: {
            type: import("vue").PropType<import("./type").TableSort>;
        };
        defaultSort: {
            type: import("vue").PropType<import("./type").TableSort>;
        };
        sortIcon: {
            type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
        };
        sortOnRowDraggable: BooleanConstructor;
        onAsyncLoadingClick: import("vue").PropType<(context: {
            status: "loading" | "load-more";
        }) => void>;
        onCellClick: import("vue").PropType<(context: import("./type").PrimaryTableCellEventContext<import("./type").TableRowData>) => void>;
        onChange: import("vue").PropType<(data: import("./type").TableChangeData, context: import("./type").TableChangeContext<import("./type").TableRowData>) => void>;
        onColumnChange: import("vue").PropType<(context: import("./type").PrimaryTableColumnChange<import("./type").TableRowData>) => void>;
        onColumnControllerVisibleChange: import("vue").PropType<(visible: boolean, context: {
            trigger: "cancel" | "confirm";
        }) => void>;
        onDataChange: import("vue").PropType<(data: import("./type").TableRowData[], context: import("./type").TableDataChangeContext) => void>;
        onDisplayColumnsChange: import("vue").PropType<(value: import("..").CheckboxGroupValue) => void>;
        onDragSort: import("vue").PropType<(context: import("./type").DragSortContext<import("./type").TableRowData>) => void>;
        onExpandChange: import("vue").PropType<(expandedRowKeys: (string | number)[], options: import("./type").ExpandOptions<import("./type").TableRowData>) => void>;
        onFilterChange: import("vue").PropType<(filterValue: import("./type").FilterValue, context: import("./type").TableFilterChangeContext<import("./type").TableRowData>) => void>;
        onRowEdit: import("vue").PropType<(context: import("./type").PrimaryTableRowEditContext<import("./type").TableRowData>) => void>;
        onRowValidate: import("vue").PropType<(context: import("./type").PrimaryTableRowValidateContext<import("./type").TableRowData>) => void>;
        onSelectChange: import("vue").PropType<(selectedRowKeys: (string | number)[], options: import("./type").SelectOptions<import("./type").TableRowData>) => void>;
        onSortChange: import("vue").PropType<(sort: import("./type").TableSort, options: import("./type").SortOptions<import("./type").TableRowData>) => void>;
        onValidate: import("vue").PropType<(context: import("./type").PrimaryTableValidateContext) => void>;
        activeRowKeys: {
            type: import("vue").PropType<(string | number)[]>;
            default: () => (string | number)[];
        };
        defaultActiveRowKeys: {
            type: import("vue").PropType<(string | number)[]>;
            default: () => (string | number)[];
        };
        activeRowType: {
            type: import("vue").PropType<"multiple" | "single">;
            default: string;
        };
        allowResizeColumnWidth: {
            type: BooleanConstructor;
            default: any;
        };
        attach: {
            type: import("vue").PropType<import("..").AttachNode>;
        };
        bordered: BooleanConstructor;
        bottomContent: {
            type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        };
        cellEmptyContent: {
            type: import("vue").PropType<string | ((h: import("vue").CreateElement, props: import("./type").BaseTableCellParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        };
        data: {
            type: import("vue").PropType<import("./type").TableRowData[]>;
            default: () => import("./type").TableRowData[];
        };
        disableDataPage: BooleanConstructor;
        disableSpaceInactiveRow: {
            type: BooleanConstructor;
            default: any;
        };
        empty: {
            type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
            default: string;
        };
        firstFullRow: {
            type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        };
        fixedRows: {
            type: import("vue").PropType<number[]>;
        };
        footData: {
            type: import("vue").PropType<import("./type").TableRowData[]>;
            default: () => import("./type").TableRowData[];
        };
        footerAffixProps: {
            type: import("vue").PropType<Partial<import("..").TdAffixProps>>;
        };
        footerAffixedBottom: {
            type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
            default: boolean;
        };
        footerSummary: {
            type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        };
        headerAffixProps: {
            type: import("vue").PropType<Partial<import("..").TdAffixProps>>;
        };
        headerAffixedTop: {
            type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
            default: boolean;
        };
        height: {
            type: import("vue").PropType<string | number>;
        };
        horizontalScrollAffixedBottom: {
            type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
        };
        hover: BooleanConstructor;
        keyboardRowHover: {
            type: BooleanConstructor;
            default: boolean;
        };
        lastFullRow: {
            type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        };
        lazyLoad: BooleanConstructor;
        loading: {
            type: import("vue").PropType<boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
            default: any;
        };
        loadingProps: {
            type: import("vue").PropType<Partial<import("..").TdLoadingProps>>;
        };
        locale: {
            type: import("vue").PropType<import("..").TableConfig>;
        };
        maxHeight: {
            type: import("vue").PropType<string | number>;
        };
        pagination: {
            type: import("vue").PropType<import("..").TdPaginationProps>;
        };
        paginationAffixedBottom: {
            type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
        };
        resizable: BooleanConstructor;
        rowAttributes: {
            type: import("vue").PropType<import("./type").TableRowAttributes<import("./type").TableRowData>>;
        };
        rowClassName: {
            type: import("vue").PropType<import("..").ClassName | ((params: import("./type").RowClassNameParams<import("./type").TableRowData>) => import("..").ClassName)>;
        };
        rowKey: {
            type: StringConstructor;
            default: string;
            required: boolean;
        };
        rowspanAndColspan: {
            type: import("vue").PropType<import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>>;
        };
        rowspanAndColspanInFooter: {
            type: import("vue").PropType<import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>>;
        };
        scroll: {
            type: import("vue").PropType<import("..").TScroll>;
        };
        showHeader: {
            type: BooleanConstructor;
            default: boolean;
        };
        size: {
            type: import("vue").PropType<import("..").SizeEnum>;
            validator(val: import("..").SizeEnum): boolean;
        };
        stripe: BooleanConstructor;
        tableContentWidth: {
            type: StringConstructor;
            default: string;
        };
        tableLayout: {
            type: import("vue").PropType<"fixed" | "auto">;
            default: "fixed" | "auto";
            validator(val: "fixed" | "auto"): boolean;
        };
        topContent: {
            type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        };
        verticalAlign: {
            type: import("vue").PropType<"top" | "bottom" | "middle">;
            default: "top" | "bottom" | "middle";
            validator(val: "top" | "bottom" | "middle"): boolean;
        };
        onActiveChange: import("vue").PropType<(activeRowKeys: (string | number)[], context: import("./type").ActiveChangeContext<import("./type").TableRowData>) => void>;
        onActiveRowAction: import("vue").PropType<(context: import("./type").ActiveRowActionContext<import("./type").TableRowData>) => void>;
        onColumnResizeChange: import("vue").PropType<(context: {
            columnsWidth: {
                [colKey: string]: number;
            };
        }) => void>;
        onPageChange: import("vue").PropType<(pageInfo: import("..").PageInfo, newDataSource: import("./type").TableRowData[]) => void>;
        onRowClick: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
        onRowDblclick: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
        onRowMousedown: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
        onRowMouseenter: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
        onRowMouseleave: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
        onRowMouseover: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
        onRowMouseup: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
        onScroll: import("vue").PropType<(params: {
            e: WheelEvent;
        }) => void>;
        onScrollX: import("vue").PropType<(params: {
            e: WheelEvent;
        }) => void>;
        onScrollY: import("vue").PropType<(params: {
            e: WheelEvent;
        }) => void>;
    };
    propsData?: object;
    computed?: import("vue/types/options").Accessors<{}>;
    methods?: {
        getListener(): import("./base-table").TableListeners;
        formatNode(api: string, renderInnerNode: Function, condition: boolean, extra?: {
            reverse?: boolean;
        }): unknown;
    };
    watch?: Record<string, import("vue").WatchOptionsWithHandler<any> | import("vue").WatchHandler<any>>;
    el?: string | Element;
    template?: string;
    render?(createElement: import("vue").CreateElement, hack: import("vue").RenderContext<import("@vue/composition-api").ExtractPropTypes<{
        asyncLoading: {
            type: import("vue").PropType<"loading" | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue) | "load-more">;
        };
        columnController: {
            type: import("vue").PropType<import("./type").TableColumnController>;
        };
        columnControllerVisible: {
            type: BooleanConstructor;
            default: any;
        };
        defaultColumnControllerVisible: {
            type: BooleanConstructor;
            default: any;
        };
        columns: {
            type: import("vue").PropType<import("./type").PrimaryTableCol<import("./type").TableRowData>[]>;
            default: () => import("./type").PrimaryTableCol<import("./type").TableRowData>[];
        };
        displayColumns: {
            type: import("vue").PropType<import("..").CheckboxGroupValue>;
        };
        defaultDisplayColumns: {
            type: import("vue").PropType<import("..").CheckboxGroupValue>;
        };
        dragSort: {
            type: import("vue").PropType<"col" | "row" | "row-handler" | "row-handler-col" | "drag-col">;
            validator(val: "col" | "row" | "row-handler" | "row-handler-col" | "drag-col"): boolean;
        };
        dragSortOptions: {
            type: import("vue").PropType<import("sortablejs").SortableOptions>;
        };
        editableCellState: {
            type: import("vue").PropType<import("./type").EditableCellType<import("./type").TableRowData>>;
        };
        editableRowKeys: {
            type: import("vue").PropType<(string | number)[]>;
        };
        expandIcon: {
            type: import("vue").PropType<boolean | ((h: import("vue").CreateElement, props: import("./type").ExpandArrowRenderParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue)>;
            default: boolean;
        };
        expandOnRowClick: BooleanConstructor;
        expandedRow: {
            type: import("vue").PropType<(h: import("vue").CreateElement, props: import("./type").TableExpandedRowParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue>;
        };
        expandedRowKeys: {
            type: import("vue").PropType<(string | number)[]>;
            default: () => (string | number)[];
        };
        defaultExpandedRowKeys: {
            type: import("vue").PropType<(string | number)[]>;
            default: () => (string | number)[];
        };
        filterIcon: {
            type: import("vue").PropType<(h: import("vue").CreateElement, props: {
                col: import("./type").PrimaryTableCol<import("./type").TableRowData>;
                colIndex: number;
            }) => import("vue/types/vnode").ScopedSlotReturnValue>;
        };
        filterRow: {
            type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        };
        filterValue: {
            type: import("vue").PropType<import("./type").FilterValue>;
        };
        defaultFilterValue: {
            type: import("vue").PropType<import("./type").FilterValue>;
        };
        hideSortTips: BooleanConstructor;
        indeterminateSelectedRowKeys: {
            type: import("vue").PropType<(string | number)[]>;
        };
        multipleSort: BooleanConstructor;
        reserveSelectedRowOnPaginate: {
            type: BooleanConstructor;
            default: boolean;
        };
        rowSelectionAllowUncheck: BooleanConstructor;
        rowSelectionType: {
            type: import("vue").PropType<"multiple" | "single">;
            validator(val: "multiple" | "single"): boolean;
        };
        selectOnRowClick: BooleanConstructor;
        selectedRowKeys: {
            type: import("vue").PropType<(string | number)[]>;
            default: () => (string | number)[];
        };
        defaultSelectedRowKeys: {
            type: import("vue").PropType<(string | number)[]>;
            default: () => (string | number)[];
        };
        showSortColumnBgColor: BooleanConstructor;
        sort: {
            type: import("vue").PropType<import("./type").TableSort>;
        };
        defaultSort: {
            type: import("vue").PropType<import("./type").TableSort>;
        };
        sortIcon: {
            type: import("vue").PropType<(h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue>;
        };
        sortOnRowDraggable: BooleanConstructor;
        onAsyncLoadingClick: import("vue").PropType<(context: {
            status: "loading" | "load-more";
        }) => void>;
        onCellClick: import("vue").PropType<(context: import("./type").PrimaryTableCellEventContext<import("./type").TableRowData>) => void>;
        onChange: import("vue").PropType<(data: import("./type").TableChangeData, context: import("./type").TableChangeContext<import("./type").TableRowData>) => void>;
        onColumnChange: import("vue").PropType<(context: import("./type").PrimaryTableColumnChange<import("./type").TableRowData>) => void>;
        onColumnControllerVisibleChange: import("vue").PropType<(visible: boolean, context: {
            trigger: "cancel" | "confirm";
        }) => void>;
        onDataChange: import("vue").PropType<(data: import("./type").TableRowData[], context: import("./type").TableDataChangeContext) => void>;
        onDisplayColumnsChange: import("vue").PropType<(value: import("..").CheckboxGroupValue) => void>;
        onDragSort: import("vue").PropType<(context: import("./type").DragSortContext<import("./type").TableRowData>) => void>;
        onExpandChange: import("vue").PropType<(expandedRowKeys: (string | number)[], options: import("./type").ExpandOptions<import("./type").TableRowData>) => void>;
        onFilterChange: import("vue").PropType<(filterValue: import("./type").FilterValue, context: import("./type").TableFilterChangeContext<import("./type").TableRowData>) => void>;
        onRowEdit: import("vue").PropType<(context: import("./type").PrimaryTableRowEditContext<import("./type").TableRowData>) => void>;
        onRowValidate: import("vue").PropType<(context: import("./type").PrimaryTableRowValidateContext<import("./type").TableRowData>) => void>;
        onSelectChange: import("vue").PropType<(selectedRowKeys: (string | number)[], options: import("./type").SelectOptions<import("./type").TableRowData>) => void>;
        onSortChange: import("vue").PropType<(sort: import("./type").TableSort, options: import("./type").SortOptions<import("./type").TableRowData>) => void>;
        onValidate: import("vue").PropType<(context: import("./type").PrimaryTableValidateContext) => void>;
        activeRowKeys: {
            type: import("vue").PropType<(string | number)[]>;
            default: () => (string | number)[];
        };
        defaultActiveRowKeys: {
            type: import("vue").PropType<(string | number)[]>;
            default: () => (string | number)[];
        };
        activeRowType: {
            type: import("vue").PropType<"multiple" | "single">;
            default: string;
        };
        allowResizeColumnWidth: {
            type: BooleanConstructor;
            default: any;
        };
        attach: {
            type: import("vue").PropType<import("..").AttachNode>;
        };
        bordered: BooleanConstructor;
        bottomContent: {
            type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        };
        cellEmptyContent: {
            type: import("vue").PropType<string | ((h: import("vue").CreateElement, props: import("./type").BaseTableCellParams<import("./type").TableRowData>) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        };
        data: {
            type: import("vue").PropType<import("./type").TableRowData[]>;
            default: () => import("./type").TableRowData[];
        };
        disableDataPage: BooleanConstructor;
        disableSpaceInactiveRow: {
            type: BooleanConstructor;
            default: any;
        };
        empty: {
            type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
            default: string;
        };
        firstFullRow: {
            type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        };
        fixedRows: {
            type: import("vue").PropType<number[]>;
        };
        footData: {
            type: import("vue").PropType<import("./type").TableRowData[]>;
            default: () => import("./type").TableRowData[];
        };
        footerAffixProps: {
            type: import("vue").PropType<Partial<import("..").TdAffixProps>>;
        };
        footerAffixedBottom: {
            type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
            default: boolean;
        };
        footerSummary: {
            type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        };
        headerAffixProps: {
            type: import("vue").PropType<Partial<import("..").TdAffixProps>>;
        };
        headerAffixedTop: {
            type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
            default: boolean;
        };
        height: {
            type: import("vue").PropType<string | number>;
        };
        horizontalScrollAffixedBottom: {
            type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
        };
        hover: BooleanConstructor;
        keyboardRowHover: {
            type: BooleanConstructor;
            default: boolean;
        };
        lastFullRow: {
            type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        };
        lazyLoad: BooleanConstructor;
        loading: {
            type: import("vue").PropType<boolean | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
            default: any;
        };
        loadingProps: {
            type: import("vue").PropType<Partial<import("..").TdLoadingProps>>;
        };
        locale: {
            type: import("vue").PropType<import("..").TableConfig>;
        };
        maxHeight: {
            type: import("vue").PropType<string | number>;
        };
        pagination: {
            type: import("vue").PropType<import("..").TdPaginationProps>;
        };
        paginationAffixedBottom: {
            type: import("vue").PropType<boolean | Partial<import("..").TdAffixProps>>;
        };
        resizable: BooleanConstructor;
        rowAttributes: {
            type: import("vue").PropType<import("./type").TableRowAttributes<import("./type").TableRowData>>;
        };
        rowClassName: {
            type: import("vue").PropType<import("..").ClassName | ((params: import("./type").RowClassNameParams<import("./type").TableRowData>) => import("..").ClassName)>;
        };
        rowKey: {
            type: StringConstructor;
            default: string;
            required: boolean;
        };
        rowspanAndColspan: {
            type: import("vue").PropType<import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>>;
        };
        rowspanAndColspanInFooter: {
            type: import("vue").PropType<import("./type").TableRowspanAndColspanFunc<import("./type").TableRowData>>;
        };
        scroll: {
            type: import("vue").PropType<import("..").TScroll>;
        };
        showHeader: {
            type: BooleanConstructor;
            default: boolean;
        };
        size: {
            type: import("vue").PropType<import("..").SizeEnum>;
            validator(val: import("..").SizeEnum): boolean;
        };
        stripe: BooleanConstructor;
        tableContentWidth: {
            type: StringConstructor;
            default: string;
        };
        tableLayout: {
            type: import("vue").PropType<"fixed" | "auto">;
            default: "fixed" | "auto";
            validator(val: "fixed" | "auto"): boolean;
        };
        topContent: {
            type: import("vue").PropType<string | ((h: import("vue").CreateElement) => import("vue/types/vnode").ScopedSlotReturnValue)>;
        };
        verticalAlign: {
            type: import("vue").PropType<"top" | "bottom" | "middle">;
            default: "top" | "bottom" | "middle";
            validator(val: "top" | "bottom" | "middle"): boolean;
        };
        onActiveChange: import("vue").PropType<(activeRowKeys: (string | number)[], context: import("./type").ActiveChangeContext<import("./type").TableRowData>) => void>;
        onActiveRowAction: import("vue").PropType<(context: import("./type").ActiveRowActionContext<import("./type").TableRowData>) => void>;
        onColumnResizeChange: import("vue").PropType<(context: {
            columnsWidth: {
                [colKey: string]: number;
            };
        }) => void>;
        onPageChange: import("vue").PropType<(pageInfo: import("..").PageInfo, newDataSource: import("./type").TableRowData[]) => void>;
        onRowClick: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
        onRowDblclick: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
        onRowMousedown: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
        onRowMouseenter: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
        onRowMouseleave: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
        onRowMouseover: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
        onRowMouseup: import("vue").PropType<(context: import("./type").RowEventContext<import("./type").TableRowData>) => void>;
        onScroll: import("vue").PropType<(params: {
            e: WheelEvent;
        }) => void>;
        onScrollX: import("vue").PropType<(params: {
            e: WheelEvent;
        }) => void>;
        onScrollY: import("vue").PropType<(params: {
            e: WheelEvent;
        }) => void>;
    }>>): import("vue").VNode;
    renderError?(createElement: import("vue").CreateElement, err: Error): import("vue").VNode;
    staticRenderFns?: ((createElement: import("vue").CreateElement) => import("vue").VNode)[];
    beforeCreate?(this: import("vue").default): void;
    created?(): void;
    beforeDestroy?(): void;
    destroyed?(): void;
    beforeMount?(): void;
    mounted?(): void;
    beforeUpdate?(): void;
    updated?(): void;
    activated?(): void;
    deactivated?(): void;
    errorCaptured?(err: Error, vm: import("vue").default, info: string): boolean | void;
    serverPrefetch?(this: import("vue").default): Promise<void>;
    directives?: {
        [key: string]: import("vue").DirectiveFunction | import("vue").DirectiveOptions;
    };
    components?: {
        [key: string]: import("vue").Component<any, any, any, any> | import("vue").AsyncComponent<any, any, any, any>;
    };
    transitions?: {
        [key: string]: object;
    };
    filters?: {
        [key: string]: Function;
    };
    provide?: object | (() => object);
    inject?: import("vue/types/options").InjectOptions;
    model?: {
        prop?: string;
        event?: string;
    };
    parent?: import("vue").default;
    mixins?: (import("vue").VueConstructor<import("vue").default> | import("vue").ComponentOptions<import("vue").default, import("vue/types/options").DefaultData<import("vue").default>, import("vue/types/options").DefaultMethods<import("vue").default>, import("vue/types/options").DefaultComputed, import("vue/types/options").PropsDefinition<import("vue/types/options").DefaultProps>, import("vue/types/options").DefaultProps>)[];
    extends?: import("vue").VueConstructor<import("vue").default> | import("vue").ComponentOptions<import("vue").default, import("vue/types/options").DefaultData<import("vue").default>, import("vue/types/options").DefaultMethods<import("vue").default>, import("vue/types/options").DefaultComputed, import("vue/types/options").PropsDefinition<import("vue/types/options").DefaultProps>, import("vue/types/options").DefaultProps>;
    delimiters?: [string, string];
    comments?: boolean;
    inheritAttrs?: boolean;
    setup?: import("@vue/composition-api").SetupFunction<import("@vue/composition-api").Data, import("@vue/composition-api").Data, {}>;
    filter: (id: string, definition?: Function) => Function;
    set: {
        <T>(object: object, key: string | number, value: T): T;
        <T_1>(array: T_1[], key: number, value: T_1): T_1;
    };
    use: {
        <T_2>(plugin: import("vue").PluginObject<T_2> | import("vue").PluginFunction<T_2>, options?: T_2): import("vue").VueConstructor<import("vue").default>;
        (plugin: import("vue").PluginObject<any> | import("vue").PluginFunction<any>, ...options: any[]): import("vue").VueConstructor<import("vue").default>;
    };
    extend: {
        <Data, Methods, Computed, PropNames extends string = never>(options?: import("vue/types/options").ThisTypedComponentOptionsWithArrayProps<import("vue").default, Data, Methods, Computed, PropNames>): import("vue/types/vue").ExtendedVue<import("vue").default, Data, Methods, Computed, Record<PropNames, any>>;
        <Data_1, Methods_1, Computed_1, Props>(options?: import("vue/types/options").ThisTypedComponentOptionsWithRecordProps<import("vue").default, Data_1, Methods_1, Computed_1, Props>): import("vue/types/vue").ExtendedVue<import("vue").default, Data_1, Methods_1, Computed_1, Props>;
        <PropNames_1 extends string = never>(definition: import("vue").FunctionalComponentOptions<Record<PropNames_1, any>, PropNames_1[]>): import("vue/types/vue").ExtendedVue<import("vue").default, {}, {}, {}, Record<PropNames_1, any>>;
        <Props_1>(definition: import("vue").FunctionalComponentOptions<Props_1, import("vue/types/options").RecordPropsDefinition<Props_1>>): import("vue/types/vue").ExtendedVue<import("vue").default, {}, {}, {}, Props_1>;
        (options?: import("vue").ComponentOptions<import("vue").default, import("vue/types/options").DefaultData<import("vue").default>, import("vue/types/options").DefaultMethods<import("vue").default>, import("vue/types/options").DefaultComputed, import("vue/types/options").PropsDefinition<import("vue/types/options").DefaultProps>, import("vue/types/options").DefaultProps>): import("vue/types/vue").ExtendedVue<import("vue").default, {}, {}, {}, {}>;
    };
    nextTick: {
        <T_3>(callback: (this: T_3) => void, context?: T_3): void;
        (): Promise<void>;
    };
    delete: {
        (object: object, key: string | number): void;
        <T_4>(array: T_4[], key: number): void;
    };
    directive: (id: string, definition?: import("vue").DirectiveFunction | import("vue").DirectiveOptions) => import("vue").DirectiveOptions;
    component: {
        (id: string): import("vue").VueConstructor<import("vue").default>;
        <VC extends import("vue").VueConstructor<import("vue").default>>(id: string, constructor: VC): VC;
        <Data_2, Methods_2, Computed_2, Props_2>(id: string, definition: import("vue").AsyncComponent<Data_2, Methods_2, Computed_2, Props_2>): import("vue/types/vue").ExtendedVue<import("vue").default, Data_2, Methods_2, Computed_2, Props_2>;
        <Data_3, Methods_3, Computed_3, PropNames_2 extends string = never>(id: string, definition?: import("vue/types/options").ThisTypedComponentOptionsWithArrayProps<import("vue").default, Data_3, Methods_3, Computed_3, PropNames_2>): import("vue/types/vue").ExtendedVue<import("vue").default, Data_3, Methods_3, Computed_3, Record<PropNames_2, any>>;
        <Data_4, Methods_4, Computed_4, Props_3>(id: string, definition?: import("vue/types/options").ThisTypedComponentOptionsWithRecordProps<import("vue").default, Data_4, Methods_4, Computed_4, Props_3>): import("vue/types/vue").ExtendedVue<import("vue").default, Data_4, Methods_4, Computed_4, Props_3>;
        <PropNames_3 extends string>(id: string, definition: import("vue").FunctionalComponentOptions<Record<PropNames_3, any>, PropNames_3[]>): import("vue/types/vue").ExtendedVue<import("vue").default, {}, {}, {}, Record<PropNames_3, any>>;
        <Props_4>(id: string, definition: import("vue").FunctionalComponentOptions<Props_4, import("vue/types/options").RecordPropsDefinition<Props_4>>): import("vue/types/vue").ExtendedVue<import("vue").default, {}, {}, {}, Props_4>;
        (id: string, definition?: import("vue").ComponentOptions<import("vue").default, import("vue/types/options").DefaultData<import("vue").default>, import("vue/types/options").DefaultMethods<import("vue").default>, import("vue/types/options").DefaultComputed, import("vue/types/options").PropsDefinition<import("vue/types/options").DefaultProps>, import("vue/types/options").DefaultProps>): import("vue/types/vue").ExtendedVue<import("vue").default, {}, {}, {}, {}>;
    };
    mixin: (mixin: import("vue").VueConstructor<import("vue").default> | import("vue").ComponentOptions<import("vue").default, import("vue/types/options").DefaultData<import("vue").default>, import("vue/types/options").DefaultMethods<import("vue").default>, import("vue/types/options").DefaultComputed, import("vue/types/options").PropsDefinition<import("vue/types/options").DefaultProps>, import("vue/types/options").DefaultProps>) => import("vue").VueConstructor<import("vue").default>;
    compile: (template: string) => {
        render(createElement: any): import("vue").VNode;
        staticRenderFns: (() => import("vue").VNode)[];
    };
    observable: <T_5>(obj: T_5) => T_5;
    util: {
        warn(msg: string, vm?: import("vue/types/vue").CombinedVueInstance<import("vue").default, object, object, object, Record<never, any>>): void;
    };
    config: import("vue/types/vue").VueConfiguration;
    version: string;
    _installedPlugins: import("vue").PluginObject<any>[];
}>;
export default Table;
